

sub webfix {
    use LWP::Simple;
    use URI::URL;

    if ($winMain::search_string eq "") {
	&mkPrintErreur("ERREUR : Aucune slection de chane de recherche donne dans la zone \"Search string\"\n");
	return;
    }
    
    if (!open(FIC,">MKCtmp_resultwebfix.txt")) {
	&mkPrintErreur("ERREUR : Impossible d\'ouvrir MKCtmp_resultwebfix.txt\n");
	return;
	}
    
    my $MAJU = 1;
    my $ACCENTS = 0;
    
    my $LANG="fr" unless $LANG;
    
    $suffixe=$ARGV[0];
    $suffixesansaccents=$suffixe;

    print FIC "Pas de prise en compte des accents\n" if $ACCENTS;
    print FIC "Prise en compte des accents\n" unless $ACCENTS;
    print FIC "Filtrage des mots en \"$suffixe\" du dictionnaire $DICOFILE\n";
    
    my $DICOFILE = "Dico/dico-fr.txt";
    
    open(IN, "<$DICOFILE") or die "Fichier introuvable : $DICOFILE ($!)\n";
    while(<IN>){
	unless ($_ =~/ /){
	chomp;
	$sansaccents =$_;
	$sansaccents =~tr//aaaeeeeiioouuuc/;
	if (m/$suffixe$/oi || ($ACCENTS && $sansaccents =~m/$suffixesansaccents$/oi )){
	    $pref=substr($_, 0, 3);
	    $_=~tr//aaaeeeeiioouuuc/ if $ACCENTS;
	    $frequent{$pref}.=" -$_" unless $frequent{$pref}=~/\-$_\b/;
	}
    }
    }
    
    foreach (sort keys %frequent){
	print FIC $_,"\t",$frequent{$_},"\n";}
    
    print FIC "Chargement de la liste des prfixes\n";

    
    my $PREFIXFILE = "Dico/prefixe.txt";
    
    open (IN, "<$PREFIXFILE") or die "Fichier introuvable : $PREFIXFILE ($!)\n";
    while(<IN>){
	chomp;
	push @MotsCles, $_ unless ($_ =~/^[\#\>]/);}

    close IN;
    
    print FIC "Dbut de la recherche\n";
    print FIC "Pas de recherche des mots en majuscules\n" unless $MAJU;
    print FIC "Le recherche prend en compte les mots en majuscules\n" if $MAJU;
    
    foreach $MotCle(@MotsCles){ 
	print FIC "$MotCle\n";
    &LanceWEBFIX($MotCle);
    }
    
}

sub LanceWEBFIX {
    if (!open(FIC,">>MKCtmp_resultwebfix.txt")) {
	&mkPrintErreur("ERREUR : Impossible d\'ouvrir MKCtmp_resultwebfix.txt\n");
	return;
	}
    my $MotCle = $_[0];
    my $url = url('http://www.altavista.com/cgi-bin/query');
    my $result="";
    $url->query_form(
		     q=>"$MotCle*****$suffixe ".$frequent{$MotCle},
		     kl=>$LANG,
		     pg=>'q',
		     wt=>'y',
		     Translate=>'on',
		     );

    if (defined (my $contenu = get $url)) {
#	print $contenu;
	if ($contenu =~/We found (about )?(.*?) results?/i){
	    $result=$2;
	    $result=~s/[,\. ]//g;
	}
	elsif ($contenu =~/AltaVista found no document matching your query/i)
	{$result=0;}
	else {warn "Problme de la part d'AltaVista !\n";}
	if ($result>0) {
	    print FIC "PREFIXE : $MotCle  ($result)\n";
	    print FIC "ATTESTATIONS : ",$frequent{$MotCle},"\n" if $frequent{$MotCle};
	   	    
	    if ($contenu =~/<a href=\"(.*?)\" target=\"_self\">\[Next \&gt\;\&gt\;\]\<\/a\>/){
		$secondpage = "http://www.altavista.com$1";
	    }
	    else {$secondpage="";}
	    
	    while ($contenu =~/r=(http:\/\/.*?)\"/){
		$contenu=$';
		$site=$1;
		if (defined (my $page = get $1)){
		    if ($MAJU){
		    while ($page =~/\b($MotCle(\w|\-)*$suffixe)/ig){
			print FIC "$1\t$site\n" unless $frequent{$MotCle}=~/\-$1/i;}
		}
		else {
		    while ($page =~/\b($MotCle(\w|\-)*$suffixe)/g){
			print FIC "$1\t$site\n" unless $frequent{$MotCle}=~/\-$1/i;}
		}
		
	    }
	    }	    
	    if ($secondpage){
		if (defined (my $contenu = get $secondpage)) {
		    
		    while ($contenu =~/r=(http:\/\/.*?)\"/){
			$contenu=$';
			$site=$1;
			if (defined (my $page = get $1)){
			    if ($MAJU){
				while ($page =~/\b($MotCle(\w|\-)*$suffixe)/ig){
				    print FIC "$1\t$site\n" unless $frequent{$MotCle}=~/\-$1/i;}
			    }
			    else {
				while ($page =~/\b($MotCle(\w|\-)*$suffixe)/g){
				    print FIC "$1\t$site\n" unless $frequent{$MotCle}=~/\-$1/i;}
			    }
			}
		    }
		}		
	    }
	}
    }
    close(FIC);
}
