#!/usr/bin/perl -w
#
# A example which represents some XML as a tree

use strict;
use lib '../lib';
use GraphViz::XML;

my $xml = '<?xml version="1.0" encoding="ISO-8859-1" standalone="yes"?>
<dico>
<word>
<item>le</item>
<cat>DET</cat>
<features>
<featmorph nb="2">
<feat number="1"><type>tete gnre</type><value>masc</value></feat>
<feat number="2"><type>tete nbre</type><value>sing</value></feat>
</featmorph>
<featsem nb="1">
<feat number="1"><type>...</type><value>...</value></feat>
</featsem>
</features>
</word>
<word>
<item>les</item>
<cat>DET</cat>
<features>
<featmorph nb="2">
<feat number="1"><type>tete gnre</type><value>masc</value></feat>
<feat number="2"><type>tete nbre</type><value>plur</value></feat>
</featmorph>
<featsem nb="1">
<feat number="1"><type>...</type><value>...</value></feat>
</featsem>
</features>
</word>
<word>
<item>les</item>
<cat>DET</cat>
<features>
<featmorph nb="2">
<feat number="1"><type>tete genre</type><value>fem</value></feat>
<feat number="2"><type>tete nbre</type><value>plur</value></feat>
</featmorph>
<featsem nb="1">
<feat number="1"><type>...</type><value>...</value></feat>
</featsem>
</features>
</word>
<word>
<item>la</item>
<cat>DET</cat>
<features>
<featmorph nb="2">
<feat number="1"><type>tete gnre</type><value>fem</value></feat>
<feat number="2"><type>tete nbre</type><value>sing</value></feat>
</featmorph>
<featsem nb="1">
<feat number="1"><type>...</type><value>...</value></feat>
</featsem>
</features>
</word>
<word>
<item>la</item>
<cat>CLIT</cat>
<features>
<featmorph nb="2">
<feat number="1"><type>tete gnre</type><value>fem</value></feat>
<feat number="2"><type>tete nbre</type><value>sing</value></feat>
</featmorph>
<featsem nb="1">
<feat number="1"><type>...</type><value>...</value></feat>
</featsem>
</features>
</word>
<word>
<item>le</item>
<cat>CLIT</cat>
<features>
<featmorph nb="2">
<feat number="1"><type>tete gnre</type><value>masc</value></feat>
<feat number="2"><type>tete nbre</type><value>sing</value></feat>
</featmorph>
<featsem nb="1">
<feat number="1"><type>...</type><value>...</value></feat>
</featsem>
</features>
</word>
<word>
<item>petite</item>
<cat>ADJ</cat>
<features>
<featmorph nb="2">
<feat number="1"><type>tete gnre</type><value>fem</value></feat>
<feat number="2"><type>tete nbre</type><value>sing</value></feat>
</featmorph>
<featsem nb="1">
<feat number="1"><type>...</type><value>...</value></feat>
</featsem>
</features>
</word>
<word>
<item>belle</item>
<cat>ADJ</cat>
<features>
<featmorph nb="2">
<feat number="1"><type>tete gnre</type><value>fem</value></feat>
<feat number="2"><type>tete nbre</type><value>sing</value></feat>
</featmorph>
<featsem nb="1">
<feat number="1"><type>...</type><value>...</value></feat>
</featsem>
</features>
</word>
<word>
<item>jolie</item>
<cat>ADJ</cat>
<features>
<featmorph nb="2">
<feat number="1"><type>tete gnre</type><value>fem</value></feat>
<feat number="2"><type>tete nbre</type><value>sing</value></feat>
</featmorph>
<featsem nb="1">
<feat number="1"><type>...</type><value>...</value></feat>
</featsem>
</features>
</word>
<word>
<item>petit</item>
<cat>ADJ</cat>
<features>
<featmorph nb="2">
<feat number="1"><type>tete gnre</type><value>masc</value></feat>
<feat number="2"><type>tete nbre</type><value>sing</value></feat>
</featmorph>
<featsem nb="1">
<feat number="1"><type>...</type><value>...</value></feat>
</featsem>
</features>
</word>
<word>
<item>grand</item>
<cat>ADJ</cat>
<features>
<featmorph nb="2">
<feat number="1"><type>tete gnre</type><value>masc</value></feat>
<feat number="2"><type>tete nbre</type><value>sing</value></feat>
</featmorph>
<featsem nb="1">
<feat number="1"><type>...</type><value>...</value></feat>
</featsem>
</features>
</word>
<word>
<item>blanc</item>
<cat>ADJ</cat>
<features>
<featmorph nb="2">
<feat number="1"><type>tete gnre</type><value>masc</value></feat>
<feat number="2"><type>tete nbre</type><value>sing</value></feat>
</featmorph>
<featsem nb="1">
<feat number="1"><type>...</type><value>...</value></feat>
</featsem>
</features>
</word>
<word>
<item>blanche</item>
<cat>ADJ</cat>
<features>
<featmorph nb="2">
<feat number="1"><type>tete gnre</type><value>fem</value></feat>
<feat number="2"><type>tete nbre</type><value>sing</value></feat>
</featmorph>
<featsem nb="1">
<feat number="1"><type>...</type><value>...</value></feat>
</featsem>
</features>
</word>
<word>
<item>noir</item>
<cat>ADJ</cat>
<features>
<featmorph nb="2">
<feat number="1"><type>tete gnre</type><value>masc</value></feat>
<feat number="2"><type>tete nbre</type><value>sing</value></feat>
</featmorph>
<featsem nb="1">
<feat number="1"><type>...</type><value>...</value></feat>
</featsem>
</features>
</word>
<word>
<item>noire</item>
<cat>ADJ</cat>
<features>
<featmorph nb="2">
<feat number="1"><type>tete gnre</type><value>fem</value></feat>
<feat number="2"><type>tete nbre</type><value>sing</value></feat>
</featmorph>
<featsem nb="1">
<feat number="1"><type>...</type><value>...</value></feat>
</featsem>
</features>
</word>
<word>
<item>marron</item>
<cat>ADJ</cat>
<features>
<featmorph nb="2">
<feat number="1"><type>tete gnre</type><value>fem</value></feat>
<feat number="2"><type>tete nbre</type><value>sing</value></feat>
</featmorph>
<featsem nb="1">
<feat number="1"><type>...</type><value>...</value></feat>
</featsem>
</features>
</word>
<word>
<item>marron</item>
<cat>ADJ</cat>
<features>
<featmorph nb="2">
<feat number="1"><type>tete gnre</type><value>masc</value></feat>
<feat number="2"><type>tete nbre</type><value>sing</value></feat>
</featmorph>
<featsem nb="1">
<feat number="1"><type>...</type><value>...</value></feat>
</featsem>
</features>
</word>
<word>
<item>orange</item>
<cat>ADJ</cat>
<features>
<featmorph nb="2">
<feat number="1"><type>tete gnre</type><value>masc</value></feat>
<feat number="2"><type>tete nbre</type><value>sing</value></feat>
</featmorph>
<featsem nb="1">
<feat number="1"><type>...</type><value>...</value></feat>
</featsem>
</features>
</word>
<word>
<item>orange</item>
<cat>ADJ</cat>
<features>
<featmorph nb="2">
<feat number="1"><type>tete gnre</type><value>fem</value></feat>
<feat number="2"><type>tete nbre</type><value>sing</value></feat>
</featmorph>
<featsem nb="1">
<feat number="1"><type>...</type><value>...</value></feat>
</featsem>
</features>
</word>
<word>
<item>bleu</item>
<cat>ADJ</cat>
<features>
<featmorph nb="2">
<feat number="1"><type>tete gnre</type><value>masc</value></feat>
<feat number="2"><type>tete nbre</type><value>sing</value></feat>
</featmorph>
<featsem nb="1">
<feat number="1"><type>...</type><value>...</value></feat>
</featsem>
</features>
</word>
<word>
<item>bleue</item>
<cat>ADJ</cat>
<features>
<featmorph nb="2">
<feat number="1"><type>tete gnre</type><value>fem</value></feat>
<feat number="2"><type>tete nbre</type><value>sing</value></feat>
</featmorph>
<featsem nb="1">
<feat number="1"><type>...</type><value>...</value></feat>
</featsem>
</features>
</word>
<word>
<item>verte</item>
<cat>ADJ</cat>
<features>
<featmorph nb="2">
<feat number="1"><type>tete gnre</type><value>fem</value></feat>
<feat number="2"><type>tete nbre</type><value>sing</value></feat>
</featmorph>
<featsem nb="1">
<feat number="1"><type>...</type><value>...</value></feat>
</featsem>
</features>
</word>
<word>
<item>vert</item>
<cat>ADJ</cat>
<features>
<featmorph nb="2">
<feat number="1"><type>tete gnre</type><value>masc</value></feat>
<feat number="2"><type>tete nbre</type><value>sing</value></feat>
</featmorph>
<featsem nb="1">
<feat number="1"><type>...</type><value>...</value></feat>
</featsem>
</features>
</word>
<word>
<item>verts</item>
<cat>ADJ</cat>
<features>
<featmorph nb="2">
<feat number="1"><type>tete gnre</type><value>masc</value></feat>
<feat number="2"><type>tete nbre</type><value>plur</value></feat>
</featmorph>
<featsem nb="1">
<feat number="1"><type>...</type><value>...</value></feat>
</featsem>
</features>
</word>
<word>
<item>vertes</item>
<cat>ADJ</cat>
<features>
<featmorph nb="2">
<feat number="1"><type>tete gnre</type><value>fem</value></feat>
<feat number="2"><type>tete nbre</type><value>plur</value></feat>
</featmorph>
<featsem nb="1">
<feat number="1"><type>...</type><value>...</value></feat>
</featsem>
</features>
</word>
<word>
<item>citron</item>
<cat>ADJ</cat>
<features>
<featmorph nb="3">
<feat number="1"><type>tete gnre</type><value>fem</value></feat>
<feat number="2"><type>tete nbre</type><value>sing</value></feat>
<feat number="3"><type>tete pers</type><value>trois</value></feat>
</featmorph>
<featsem nb="1">
<feat number="1"><type>...</type><value>...</value></feat>
</featsem>
</features>
</word>
<word>
<item>citron</item>
<cat>ADJ</cat>
<features>
<featmorph nb="3">
<feat number="1"><type>tete gnre</type><value>masc</value></feat>
<feat number="2"><type>tete nbre</type><value>sing</value></feat>
<feat number="3"><type>tete pers</type><value>trois</value></feat>
</featmorph>
<featsem nb="1">
<feat number="1"><type>...</type><value>...</value></feat>
</featsem>
</features>
</word>
<word>
<item>jolies</item>
<cat>ADJ</cat>
<features>
<featmorph nb="2">
<feat number="1"><type>tete gnre</type><value>fem</value></feat>
<feat number="2"><type>tete nbre</type><value>plur</value></feat>
</featmorph>
<featsem nb="1">
<feat number="1"><type>...</type><value>...</value></feat>
</featsem>
</features>
</word>
<word>
<item>mauvais</item>
<cat>ADJ</cat>
<features>
<featmorph nb="2">
<feat number="1"><type>tete gnre</type><value>masc</value></feat>
<feat number="2"><type>tete nbre</type><value>plur</value></feat>
</featmorph>
<featsem nb="1">
<feat number="1"><type>...</type><value>...</value></feat>
</featsem>
</features>
</word>
<word>
<item>mauvais</item>
<cat>ADJ</cat>
<features>
<featmorph nb="2">
<feat number="1"><type>tete gnre</type><value>masc</value></feat>
<feat number="2"><type>tete nbre</type><value>sing</value></feat>
</featmorph>
<featsem nb="1">
<feat number="1"><type>...</type><value>...</value></feat>
</featsem>
</features>
</word>
<word>
<item>petite</item>
<cat>N</cat>
<features>
<featmorph nb="3">
<feat number="1"><type>tete gnre</type><value>fem</value></feat>
<feat number="2"><type>tete nbre</type><value>sing</value></feat>
<feat number="3"><type>tete pers</type><value>trois</value></feat>
</featmorph>
<featsem nb="1">
<feat number="1"><type>...</type><value>...</value></feat>
</featsem>
</features>
</word>
<word>
<item>fille</item>
<cat>N</cat>
<features>
<featmorph nb="3">
<feat number="1"><type>tete gnre</type><value>fem</value></feat>
<feat number="2"><type>tete nbre</type><value>sing</value></feat>
<feat number="3"><type>tete pers</type><value>trois</value></feat>
</featmorph>
<featsem nb="1">
<feat number="1"><type>...</type><value>...</value></feat>
</featsem>
</features>
</word>
<word>
<item>mere</item>
<cat>N</cat>
<features>
<featmorph nb="3">
<feat number="1"><type>tete gnre</type><value>fem</value></feat>
<feat number="2"><type>tete nbre</type><value>sing</value></feat>
<feat number="3"><type>tete pers</type><value>trois</value></feat>
</featmorph>
<featsem nb="1">
<feat number="1"><type>...</type><value>...</value></feat>
</featsem>
</features>
</word>
<word>
<item>soeur</item>
<cat>N</cat>
<features>
<featmorph nb="3">
<feat number="1"><type>tete gnre</type><value>fem</value></feat>
<feat number="2"><type>tete nbre</type><value>sing</value></feat>
<feat number="3"><type>tete pers</type><value>trois</value></feat>
</featmorph>
<featsem nb="1">
<feat number="1"><type>...</type><value>...</value></feat>
</featsem>
</features>
</word>
<word>
<item>belle</item>
<cat>N</cat>
<features>
<featmorph nb="3">
<feat number="1"><type>tete gnre</type><value>fem</value></feat>
<feat number="2"><type>tete nbre</type><value>sing</value></feat>
<feat number="3"><type>tete pers</type><value>trois</value></feat>
</featmorph>
<featsem nb="1">
<feat number="1"><type>...</type><value>...</value></feat>
</featsem>
</features>
</word>
<word>
<item>porte</item>
<cat>N</cat>
<features>
<featmorph nb="3">
<feat number="1"><type>tete gnre</type><value>fem</value></feat>
<feat number="2"><type>tete nbre</type><value>sing</value></feat>
<feat number="3"><type>tete pers</type><value>trois</value></feat>
</featmorph>
<featsem nb="1">
<feat number="1"><type>...</type><value>...</value></feat>
</featsem>
</features>
</word>
<word>
<item>fenetre</item>
<cat>N</cat>
<features>
<featmorph nb="3">
<feat number="1"><type>tete gnre</type><value>fem</value></feat>
<feat number="2"><type>tete nbre</type><value>sing</value></feat>
<feat number="3"><type>tete pers</type><value>trois</value></feat>
</featmorph>
<featsem nb="1">
<feat number="1"><type>...</type><value>...</value></feat>
</featsem>
</features>
</word>
<word>
<item>cousine</item>
<cat>N</cat>
<features>
<featmorph nb="3">
<feat number="1"><type>tete gnre</type><value>fem</value></feat>
<feat number="2"><type>tete nbre</type><value>sing</value></feat>
<feat number="3"><type>tete pers</type><value>trois</value></feat>
</featmorph>
<featsem nb="1">
<feat number="1"><type>...</type><value>...</value></feat>
</featsem>
</features>
</word>
<word>
<item>brise</item>
<cat>N</cat>
<features>
<featmorph nb="3">
<feat number="1"><type>tete gnre</type><value>fem</value></feat>
<feat number="2"><type>tete nbre</type><value>sing</value></feat>
<feat number="3"><type>tete pers</type><value>trois</value></feat>
</featmorph>
<featsem nb="1">
<feat number="1"><type>...</type><value>...</value></feat>
</featsem>
</features>
</word>
<word>
<item>voisine</item>
<cat>N</cat>
<features>
<featmorph nb="3">
<feat number="1"><type>tete gnre</type><value>fem</value></feat>
<feat number="2"><type>tete nbre</type><value>sing</value></feat>
<feat number="3"><type>tete pers</type><value>trois</value></feat>
</featmorph>
<featsem nb="1">
<feat number="1"><type>...</type><value>...</value></feat>
</featsem>
</features>
</word>
<word>
<item>belette</item>
<cat>N</cat>
<features>
<featmorph nb="3">
<feat number="1"><type>tete gnre</type><value>fem</value></feat>
<feat number="2"><type>tete nbre</type><value>sing</value></feat>
<feat number="3"><type>tete pers</type><value>trois</value></feat>
</featmorph>
<featsem nb="1">
<feat number="1"><type>...</type><value>...</value></feat>
</featsem>
</features>
</word>
<word>
<item>voile</item>
<cat>N</cat>
<features>
<featmorph nb="3">
<feat number="1"><type>tete gnre</type><value>masc</value></feat>
<feat number="2"><type>tete nbre</type><value>sing</value></feat>
<feat number="3"><type>tete pers</type><value>trois</value></feat>
</featmorph>
<featsem nb="1">
<feat number="1"><type>...</type><value>...</value></feat>
</featsem>
</features>
</word>
<word>
<item>fils</item>
<cat>N</cat>
<features>
<featmorph nb="3">
<feat number="1"><type>tete gnre</type><value>masc</value></feat>
<feat number="2"><type>tete nbre</type><value>sing</value></feat>
<feat number="3"><type>tete pers</type><value>trois</value></feat>
</featmorph>
<featsem nb="1">
<feat number="1"><type>...</type><value>...</value></feat>
</featsem>
</features>
</word>
<word>
<item>fils</item>
<cat>N</cat>
<features>
<featmorph nb="3">
<feat number="1"><type>tete gnre</type><value>masc</value></feat>
<feat number="2"><type>tete nbre</type><value>plur</value></feat>
<feat number="3"><type>tete pers</type><value>trois</value></feat>
</featmorph>
<featsem nb="1">
<feat number="1"><type>...</type><value>...</value></feat>
</featsem>
</features>
</word>
<word>
<item>frere</item>
<cat>N</cat>
<features>
<featmorph nb="3">
<feat number="1"><type>tete gnre</type><value>masc</value></feat>
<feat number="2"><type>tete nbre</type><value>sing</value></feat>
<feat number="3"><type>tete pers</type><value>trois</value></feat>
</featmorph>
<featsem nb="1">
<feat number="1"><type>...</type><value>...</value></feat>
</featsem>
</features>
</word>
<word>
<item>pere</item>
<cat>N</cat>
<features>
<featmorph nb="3">
<feat number="1"><type>tete gnre</type><value>masc</value></feat>
<feat number="2"><type>tete nbre</type><value>sing</value></feat>
<feat number="3"><type>tete pers</type><value>trois</value></feat>
</featmorph>
<featsem nb="1">
<feat number="1"><type>...</type><value>...</value></feat>
</featsem>
</features>
</word>
<word>
<item>oncle</item>
<cat>N</cat>
<features>
<featmorph nb="3">
<feat number="1"><type>tete gnre</type><value>masc</value></feat>
<feat number="2"><type>tete nbre</type><value>sing</value></feat>
<feat number="3"><type>tete pers</type><value>trois</value></feat>
</featmorph>
<featsem nb="1">
<feat number="1"><type>...</type><value>...</value></feat>
</featsem>
</features>
</word>
<word>
<item>bras</item>
<cat>N</cat>
<features>
<featmorph nb="3">
<feat number="1"><type>tete gnre</type><value>masc</value></feat>
<feat number="2"><type>tete nbre</type><value>sing</value></feat>
<feat number="3"><type>tete pers</type><value>trois</value></feat>
</featmorph>
<featsem nb="1">
<feat number="1"><type>...</type><value>...</value></feat>
</featsem>
</features>
</word>
<word>
<item>couvent</item>
<cat>N</cat>
<features>
<featmorph nb="3">
<feat number="1"><type>tete gnre</type><value>masc</value></feat>
<feat number="2"><type>tete nbre</type><value>sing</value></feat>
<feat number="3"><type>tete pers</type><value>trois</value></feat>
</featmorph>
<featsem nb="1">
<feat number="1"><type>...</type><value>...</value></feat>
</featsem>
</features>
</word>
<word>
<item>glace</item>
<cat>N</cat>
<features>
<featmorph nb="3">
<feat number="1"><type>tete gnre</type><value>fem</value></feat>
<feat number="2"><type>tete nbre</type><value>sing</value></feat>
<feat number="3"><type>tete pers</type><value>trois</value></feat>
</featmorph>
<featsem nb="1">
<feat number="1"><type>...</type><value>...</value></feat>
</featsem>
</features>
</word>
<word>
<item>histoire</item>
<cat>N</cat>
<features>
<featmorph nb="3">
<feat number="1"><type>tete gnre</type><value>fem</value></feat>
<feat number="2"><type>tete nbre</type><value>sing</value></feat>
<feat number="3"><type>tete pers</type><value>trois</value></feat>
</featmorph>
<featsem nb="1">
<feat number="1"><type>...</type><value>...</value></feat>
</featsem>
</features>
</word>
<word>
<item>chat</item>
<cat>N</cat>
<features>
<featmorph nb="3">
<feat number="1"><type>tete gnre</type><value>masc</value></feat>
<feat number="2"><type>tete nbre</type><value>sing</value></feat>
<feat number="3"><type>tete pers</type><value>trois</value></feat>
</featmorph>
<featsem nb="1">
<feat number="1"><type>...</type><value>...</value></feat>
</featsem>
</features>
</word>
<word>
<item>chien</item>
<cat>N</cat>
<features>
<featmorph nb="3">
<feat number="1"><type>tete gnre</type><value>masc</value></feat>
<feat number="2"><type>tete nbre</type><value>sing</value></feat>
<feat number="3"><type>tete pers</type><value>trois</value></feat>
</featmorph>
<featsem nb="1">
<feat number="1"><type>...</type><value>...</value></feat>
</featsem>
</features>
</word>
<word>
<item>loup</item>
<cat>N</cat>
<features>
<featmorph nb="3">
<feat number="1"><type>tete gnre</type><value>masc</value></feat>
<feat number="2"><type>tete nbre</type><value>sing</value></feat>
<feat number="3"><type>tete pers</type><value>trois</value></feat>
</featmorph>
<featsem nb="1">
<feat number="1"><type>...</type><value>...</value></feat>
</featsem>
</features>
</word>
<word>
<item>garcon</item>
<cat>N</cat>
<features>
<featmorph nb="3">
<feat number="1"><type>tete gnre</type><value>masc</value></feat>
<feat number="2"><type>tete nbre</type><value>sing</value></feat>
<feat number="3"><type>tete pers</type><value>trois</value></feat>
</featmorph>
<featsem nb="1">
<feat number="1"><type>...</type><value>...</value></feat>
</featsem>
</features>
</word>
<word>
<item>fumer</item>
<cat>N</cat>
<features>
<featmorph nb="3">
<feat number="1"><type>tete gnre</type><value>masc</value></feat>
<feat number="2"><type>tete nbre</type><value>sing</value></feat>
<feat number="3"><type>tete pers</type><value>trois</value></feat>
</featmorph>
<featsem nb="1">
<feat number="1"><type>...</type><value>...</value></feat>
</featsem>
</features>
</word>
<word>
<item>manger</item>
<cat>N</cat>
<features>
<featmorph nb="3">
<feat number="1"><type>tete gnre</type><value>masc</value></feat>
<feat number="2"><type>tete nbre</type><value>sing</value></feat>
<feat number="3"><type>tete pers</type><value>trois</value></feat>
</featmorph>
<featsem nb="1">
<feat number="1"><type>...</type><value>...</value></feat>
</featsem>
</features>
</word>
<word>
<item>mordre</item>
<cat>N</cat>
<features>
<featmorph nb="3">
<feat number="1"><type>tete gnre</type><value>masc</value></feat>
<feat number="2"><type>tete nbre</type><value>sing</value></feat>
<feat number="3"><type>tete pers</type><value>trois</value></feat>
</featmorph>
<featsem nb="1">
<feat number="1"><type>...</type><value>...</value></feat>
</featsem>
</features>
</word>
<word>
<item>cinema</item>
<cat>N</cat>
<features>
<featmorph nb="3">
<feat number="1"><type>tete gnre</type><value>masc</value></feat>
<feat number="2"><type>tete nbre</type><value>sing</value></feat>
<feat number="3"><type>tete pers</type><value>trois</value></feat>
</featmorph>
<featsem nb="1">
<feat number="1"><type>...</type><value>...</value></feat>
</featsem>
</features>
</word>
<word>
<item>jardin</item>
<cat>N</cat>
<features>
<featmorph nb="3">
<feat number="1"><type>tete gnre</type><value>masc</value></feat>
<feat number="2"><type>tete nbre</type><value>sing</value></feat>
<feat number="3"><type>tete pers</type><value>trois</value></feat>
</featmorph>
<featsem nb="1">
<feat number="1"><type>...</type><value>...</value></feat>
</featsem>
</features>
</word>
<word>
<item>parc</item>
<cat>N</cat>
<features>
<featmorph nb="3">
<feat number="1"><type>tete gnre</type><value>masc</value></feat>
<feat number="2"><type>tete nbre</type><value>sing</value></feat>
<feat number="3"><type>tete pers</type><value>trois</value></feat>
</featmorph>
<featsem nb="1">
<feat number="1"><type>...</type><value>...</value></feat>
</featsem>
</features>
</word>
<word>
<item>souris</item>
<cat>N</cat>
<features>
<featmorph nb="3">
<feat number="1"><type>tete gnre</type><value>fem</value></feat>
<feat number="2"><type>tete nbre</type><value>sing</value></feat>
<feat number="3"><type>tete pers</type><value>trois</value></feat>
</featmorph>
<featsem nb="1">
<feat number="1"><type>...</type><value>...</value></feat>
</featsem>
</features>
</word>
<word>
<item>sante</item>
<cat>N</cat>
<features>
<featmorph nb="3">
<feat number="1"><type>tete gnre</type><value>fem</value></feat>
<feat number="2"><type>tete nbre</type><value>sing</value></feat>
<feat number="3"><type>tete pers</type><value>trois</value></feat>
</featmorph>
<featsem nb="1">
<feat number="1"><type>...</type><value>...</value></feat>
</featsem>
</features>
</word>
<word>
<item>fille</item>
<cat>N</cat>
<features>
<featmorph nb="3">
<feat number="1"><type>tete gnre</type><value>fem</value></feat>
<feat number="2"><type>tete nbre</type><value>sing</value></feat>
<feat number="3"><type>tete pers</type><value>trois</value></feat>
</featmorph>
<featsem nb="1">
<feat number="1"><type>...</type><value>...</value></feat>
</featsem>
</features>
</word>
<word>
<item>cour</item>
<cat>N</cat>
<features>
<featmorph nb="3">
<feat number="1"><type>tete gnre</type><value>fem</value></feat>
<feat number="2"><type>tete nbre</type><value>sing</value></feat>
<feat number="3"><type>tete pers</type><value>trois</value></feat>
</featmorph>
<featsem nb="1">
<feat number="1"><type>...</type><value>...</value></feat>
</featsem>
</features>
</word>
<word>
<item>souris</item>
<cat>N</cat>
<features>
<featmorph nb="3">
<feat number="1"><type>tete gnre</type><value>fem</value></feat>
<feat number="2"><type>tete nbre</type><value>plur</value></feat>
<feat number="3"><type>tete pers</type><value>trois</value></feat>
</featmorph>
<featsem nb="1">
<feat number="1"><type>...</type><value>...</value></feat>
</featsem>
</features>
</word>
<word>
<item>histoires</item>
<cat>N</cat>
<features>
<featmorph nb="3">
<feat number="1"><type>tete gnre</type><value>fem</value></feat>
<feat number="2"><type>tete nbre</type><value>plur</value></feat>
<feat number="3"><type>tete pers</type><value>trois</value></feat>
</featmorph>
<featsem nb="1">
<feat number="1"><type>...</type><value>...</value></feat>
</featsem>
</features>
</word>
<word>
<item>animaux</item>
<cat>N</cat>
<features>
<featmorph nb="3">
<feat number="1"><type>tete gnre</type><value>masc</value></feat>
<feat number="2"><type>tete nbre</type><value>plur</value></feat>
<feat number="3"><type>tete pers</type><value>trois</value></feat>
</featmorph>
<featsem nb="1">
<feat number="1"><type>...</type><value>...</value></feat>
</featsem>
</features>
</word>
<word>
<item>bras</item>
<cat>N</cat>
<features>
<featmorph nb="3">
<feat number="1"><type>tete gnre</type><value>masc</value></feat>
<feat number="2"><type>tete nbre</type><value>plur</value></feat>
<feat number="3"><type>tete pers</type><value>trois</value></feat>
</featmorph>
<featsem nb="1">
<feat number="1"><type>...</type><value>...</value></feat>
</featsem>
</features>
</word>
<word>
<item>jardins</item>
<cat>N</cat>
<features>
<featmorph nb="3">
<feat number="1"><type>tete gnre</type><value>masc</value></feat>
<feat number="2"><type>tete nbre</type><value>plur</value></feat>
<feat number="3"><type>tete pers</type><value>trois</value></feat>
</featmorph>
<featsem nb="1">
<feat number="1"><type>...</type><value>...</value></feat>
</featsem>
</features>
</word>
<word>
<item>parcs</item>
<cat>N</cat>
<features>
<featmorph nb="3">
<feat number="1"><type>tete gnre</type><value>masc</value></feat>
<feat number="2"><type>tete nbre</type><value>plur</value></feat>
<feat number="3"><type>tete pers</type><value>trois</value></feat>
</featmorph>
<featsem nb="1">
<feat number="1"><type>...</type><value>...</value></feat>
</featsem>
</features>
</word>
<word>
<item>loups</item>
<cat>N</cat>
<features>
<featmorph nb="3">
<feat number="1"><type>tete gnre</type><value>masc</value></feat>
<feat number="2"><type>tete nbre</type><value>plur</value></feat>
<feat number="3"><type>tete pers</type><value>trois</value></feat>
</featmorph>
<featsem nb="1">
<feat number="1"><type>...</type><value>...</value></feat>
</featsem>
</features>
</word>
<word>
<item>chats</item>
<cat>N</cat>
<features>
<featmorph nb="3">
<feat number="1"><type>tete gnre</type><value>masc</value></feat>
<feat number="2"><type>tete nbre</type><value>plur</value></feat>
<feat number="3"><type>tete pers</type><value>trois</value></feat>
</featmorph>
<featsem nb="1">
<feat number="1"><type>...</type><value>...</value></feat>
</featsem>
</features>
</word>
<word>
<item>enfants</item>
<cat>N</cat>
<features>
<featmorph nb="3">
<feat number="1"><type>tete gnre</type><value>masc</value></feat>
<feat number="2"><type>tete nbre</type><value>plur</value></feat>
<feat number="3"><type>tete pers</type><value>trois</value></feat>
</featmorph>
<featsem nb="1">
<feat number="1"><type>...</type><value>...</value></feat>
</featsem>
</features>
</word>
<word>
<item>chiens</item>
<cat>N</cat>
<features>
<featmorph nb="3">
<feat number="1"><type>tete gnre</type><value>masc</value></feat>
<feat number="2"><type>tete nbre</type><value>plur</value></feat>
<feat number="3"><type>tete pers</type><value>trois</value></feat>
</featmorph>
<featsem nb="1">
<feat number="1"><type>...</type><value>...</value></feat>
</featsem>
</features>
</word>
<word>
<item>poules</item>
<cat>N</cat>
<features>
<featmorph nb="3">
<feat number="1"><type>tete gnre</type><value>fem</value></feat>
<feat number="2"><type>tete nbre</type><value>plur</value></feat>
<feat number="3"><type>tete pers</type><value>trois</value></feat>
</featmorph>
<featsem nb="1">
<feat number="1"><type>...</type><value>...</value></feat>
</featsem>
</features>
</word>
<word>
<item>brise</item>
<cat>V</cat>
<features>
<featmorph nb="4">
<feat number="1"><type>arg0 cat</type><value>GN</value></feat>
<feat number="2"><type>arg0 tete pers</type><value>trois</value></feat>
<feat number="3"><type>arg0 tete nbre</type><value>sing</value></feat>
<feat number="4"><type>arg1 cat</type><value>GN</value></feat>
</featmorph>
<featsem nb="1">
<feat number="1"><type>...</type><value>...</value></feat>
</featsem>
</features>
</word>
<word>
<item>va</item>
<cat>V</cat>
<features>
<featmorph nb="5">
<feat number="1"><type>arg0 cat</type><value>GN</value></feat>
<feat number="2"><type>arg0 tete pers</type><value>trois</value></feat>
<feat number="3"><type>arg0 tete nbre</type><value>sing</value></feat>
<feat number="4"><type>arg1 cat</type><value>GNP prep</value></feat>
<feat number="5"><type>prep</type><value>A</value></feat>
</featmorph>
<featsem nb="1">
<feat number="1"><type>...</type><value>...</value></feat>
</featsem>
</features>
</word>
<word>
<item>reve</item>
<cat>V</cat>
<features>
<featmorph nb="5">
<feat number="1"><type>arg0 cat</type><value>GN</value></feat>
<feat number="2"><type>arg0 tete pers</type><value>trois</value></feat>
<feat number="3"><type>arg0 tete nbre</type><value>sing</value></feat>
<feat number="4"><type>arg1 cat</type><value>GNP prep</value></feat>
<feat number="5"><type>prep</type><value>DE</value></feat>
</featmorph>
<featsem nb="1">
<feat number="1"><type>...</type><value>...</value></feat>
</featsem>
</features>
</word>
<word>
<item>reve</item>
<cat>V</cat>
<features>
<featmorph nb="3">
<feat number="1"><type>arg0 cat</type><value>VOID</value></feat>
<feat number="2"><type>arg1 cat</type><value>INF prep</value></feat>
<feat number="3"><type>prep</type><value>DE</value></feat>
</featmorph>
<featsem nb="1">
<feat number="1"><type>...</type><value>...</value></feat>
</featsem>
</features>
</word>
<word>
<item>parle</item>
<cat>V</cat>
<features>
<featmorph nb="5">
<feat number="1"><type>arg0 cat</type><value>GN</value></feat>
<feat number="2"><type>arg0 tete pers</type><value>trois</value></feat>
<feat number="3"><type>arg0 tete nbre</type><value>sing</value></feat>
<feat number="4"><type>arg1 cat</type><value>GNP prep</value></feat>
<feat number="5"><type>prep</type><value>DE/A</value></feat>
</featmorph>
<featsem nb="1">
<feat number="1"><type>...</type><value>...</value></feat>
</featsem>
</features>
</word>
<word>
<item>donne</item>
<cat>V</cat>
<features>
<featmorph nb="6">
<feat number="1"><type>arg0 cat</type><value>GN</value></feat>
<feat number="2"><type>arg0 tete pers</type><value>trois</value></feat>
<feat number="3"><type>arg0 tete nbre</type><value>sing</value></feat>
<feat number="4"><type>arg1 cat</type><value>GN</value></feat>
<feat number="5"><type>arg2</type><value>GNP prep</value></feat>
<feat number="6"><type>prep</type><value>A</value></feat>
</featmorph>
<featsem nb="1">
<feat number="1"><type>...</type><value>...</value></feat>
</featsem>
</features>
</word>
<word>
<item>offre</item>
<cat>V</cat>
<features>
<featmorph nb="6">
<feat number="1"><type>arg0 cat</type><value>GN</value></feat>
<feat number="2"><type>arg0 tete pers</type><value>trois</value></feat>
<feat number="3"><type>arg0 tete nbre</type><value>sing</value></feat>
<feat number="4"><type>arg1 cat</type><value>GN</value></feat>
<feat number="5"><type>arg2</type><value>GNP prep</value></feat>
<feat number="6"><type>prep</type><value>A</value></feat>
</featmorph>
<featsem nb="1">
<feat number="1"><type>...</type><value>...</value></feat>
</featsem>
</features>
</word>
<word>
<item>prete</item>
<cat>V</cat>
<features>
<featmorph nb="6">
<feat number="1"><type>arg0 cat</type><value>GN</value></feat>
<feat number="2"><type>arg0 tete pers</type><value>trois</value></feat>
<feat number="3"><type>arg0 tete nbre</type><value>sing</value></feat>
<feat number="4"><type>arg1 cat</type><value>GN</value></feat>
<feat number="5"><type>arg2</type><value>GNP prep</value></feat>
<feat number="6"><type>prep</type><value>A</value></feat>
</featmorph>
<featsem nb="1">
<feat number="1"><type>...</type><value>...</value></feat>
</featsem>
</features>
</word>
<word>
<item>demande</item>
<cat>V</cat>
<features>
<featmorph nb="6">
<feat number="1"><type>arg0 cat</type><value>GN</value></feat>
<feat number="2"><type>arg0 tete pers</type><value>trois</value></feat>
<feat number="3"><type>arg0 tete nbre</type><value>sing</value></feat>
<feat number="4"><type>arg1 cat</type><value>GN</value></feat>
<feat number="5"><type>arg2</type><value>GNP prep</value></feat>
<feat number="6"><type>prep</type><value>A</value></feat>
</featmorph>
<featsem nb="1">
<feat number="1"><type>...</type><value>...</value></feat>
</featsem>
</features>
</word>
<word>
<item>mord</item>
<cat>V</cat>
<features>
<featmorph nb="4">
<feat number="1"><type>arg0 cat</type><value>GN</value></feat>
<feat number="2"><type>arg0 tete pers</type><value>trois</value></feat>
<feat number="3"><type>arg0 tete nbre</type><value>sing</value></feat>
<feat number="4"><type>arg1 cat</type><value>GN</value></feat>
</featmorph>
<featsem nb="1">
<feat number="1"><type>...</type><value>...</value></feat>
</featsem>
</features>
</word>
<word>
<item>est</item>
<cat>V</cat>
<features>
<featmorph nb="4">
<feat number="1"><type>arg0 cat</type><value>GN</value></feat>
<feat number="2"><type>arg0 tete pers</type><value>trois</value></feat>
<feat number="3"><type>arg0 tete nbre</type><value>sing</value></feat>
<feat number="4"><type>arg1 cat</type><value>GN</value></feat>
</featmorph>
<featsem nb="1">
<feat number="1"><type>...</type><value>...</value></feat>
</featsem>
</features>
</word>
<word>
<item>nuit</item>
<cat>V</cat>
<features>
<featmorph nb="5">
<feat number="1"><type>arg0 cat</type><value>GN</value></feat>
<feat number="2"><type>arg0 tete pers</type><value>trois</value></feat>
<feat number="3"><type>arg0 tete nbre</type><value>sing</value></feat>
<feat number="4"><type>arg1 cat</type><value>GNP prep</value></feat>
<feat number="5"><type>prep</type><value>A</value></feat>
</featmorph>
<featsem nb="1">
<feat number="1"><type>...</type><value>...</value></feat>
</featsem>
</features>
</word>
<word>
<item>couvent</item>
<cat>V</cat>
<features>
<featmorph nb="4">
<feat number="1"><type>arg0 cat</type><value>GN</value></feat>
<feat number="2"><type>arg0 tete pers</type><value>trois</value></feat>
<feat number="3"><type>arg0 tete nbre</type><value>plur</value></feat>
<feat number="4"><type>arg1 cat</type><value>GN</value></feat>
</featmorph>
<featsem nb="1">
<feat number="1"><type>...</type><value>...</value></feat>
</featsem>
</features>
</word>
<word>
<item>jouent</item>
<cat>V</cat>
<features>
<featmorph nb="5">
<feat number="1"><type>arg0 cat</type><value>GN</value></feat>
<feat number="2"><type>arg0 tete pers</type><value>trois</value></feat>
<feat number="3"><type>arg0 tete nbre</type><value>plur</value></feat>
<feat number="4"><type>arg1 cat</type><value>GNP prep</value></feat>
<feat number="5"><type>prep</type><value>A</value></feat>
</featmorph>
<featsem nb="1">
<feat number="1"><type>...</type><value>...</value></feat>
</featsem>
</features>
</word>
<word>
<item>porte</item>
<cat>V</cat>
<features>
<featmorph nb="4">
<feat number="1"><type>arg0 cat</type><value>GN</value></feat>
<feat number="2"><type>arg0 tete pers</type><value>trois</value></feat>
<feat number="3"><type>arg0 tete nbre</type><value>sing</value></feat>
<feat number="4"><type>arg1 cat</type><value>GN</value></feat>
</featmorph>
<featsem nb="1">
<feat number="1"><type>...</type><value>...</value></feat>
</featsem>
</features>
</word>
<word>
<item>voile</item>
<cat>V</cat>
<features>
<featmorph nb="4">
<feat number="1"><type>arg0 cat</type><value>GN</value></feat>
<feat number="2"><type>arg0 tete pers</type><value>trois</value></feat>
<feat number="3"><type>arg0 tete nbre</type><value>sing</value></feat>
<feat number="4"><type>arg1 cat</type><value>GN</value></feat>
</featmorph>
<featsem nb="1">
<feat number="1"><type>...</type><value>...</value></feat>
</featsem>
</features>
</word>
<word>
<item>glace</item>
<cat>V</cat>
<features>
<featmorph nb="4">
<feat number="1"><type>arg0 cat</type><value>GN</value></feat>
<feat number="2"><type>arg0 tete pers</type><value>trois</value></feat>
<feat number="3"><type>arg0 tete nbre</type><value>sing</value></feat>
<feat number="4"><type>arg1 cat</type><value>GN</value></feat>
</featmorph>
<featsem nb="1">
<feat number="1"><type>...</type><value>...</value></feat>
</featsem>
</features>
</word>
<word>
<item>dort</item>
<cat>V</cat>
<features>
<featmorph nb="4">
<feat number="1"><type>arg0 cat</type><value>GN</value></feat>
<feat number="2"><type>arg0 tete pers</type><value>trois</value></feat>
<feat number="3"><type>arg0 tete nbre</type><value>sing</value></feat>
<feat number="4"><type>arg1 cat</type><value>VOID</value></feat>
</featmorph>
<featsem nb="1">
<feat number="1"><type>...</type><value>...</value></feat>
</featsem>
</features>
</word>
<word>
<item>dorment</item>
<cat>V</cat>
<features>
<featmorph nb="4">
<feat number="1"><type>arg0 cat</type><value>GN</value></feat>
<feat number="2"><type>arg0 tete pers</type><value>trois</value></feat>
<feat number="3"><type>arg0 tete nbre</type><value>plur</value></feat>
<feat number="4"><type>arg1 cat</type><value>VOID</value></feat>
</featmorph>
<featsem nb="1">
<feat number="1"><type>...</type><value>...</value></feat>
</featsem>
</features>
</word>
<word>
<item>mordent</item>
<cat>V</cat>
<features>
<featmorph nb="4">
<feat number="1"><type>arg0 cat</type><value>GN</value></feat>
<feat number="2"><type>arg0 tete pers</type><value>trois</value></feat>
<feat number="3"><type>arg0 tete nbre</type><value>plur</value></feat>
<feat number="4"><type>arg1 cat</type><value>GN</value></feat>
</featmorph>
<featsem nb="1">
<feat number="1"><type>...</type><value>...</value></feat>
</featsem>
</features>
</word>
<word>
<item>sont</item>
<cat>V</cat>
<features>
<featmorph nb="4">
<feat number="1"><type>arg0 cat</type><value>GN</value></feat>
<feat number="2"><type>arg0 tete pers</type><value>trois</value></feat>
<feat number="3"><type>arg0 tete nbre</type><value>plur</value></feat>
<feat number="4"><type>arg1 cat</type><value>GN</value></feat>
</featmorph>
<featsem nb="1">
<feat number="1"><type>...</type><value>...</value></feat>
</featsem>
</features>
</word>
<word>
<item>boivent</item>
<cat>V</cat>
<features>
<featmorph nb="4">
<feat number="1"><type>arg0 cat</type><value>GN</value></feat>
<feat number="2"><type>arg0 tete pers</type><value>trois</value></feat>
<feat number="3"><type>arg0 tete nbre</type><value>plur</value></feat>
<feat number="4"><type>arg1 cat</type><value>GN</value></feat>
</featmorph>
<featsem nb="1">
<feat number="1"><type>...</type><value>...</value></feat>
</featsem>
</features>
</word>
<word>
<item>vont</item>
<cat>V</cat>
<features>
<featmorph nb="5">
<feat number="1"><type>arg0 cat</type><value>GN</value></feat>
<feat number="2"><type>arg0 tete pers</type><value>trois</value></feat>
<feat number="3"><type>arg0 tete nbre</type><value>plur</value></feat>
<feat number="4"><type>arg1 cat</type><value>GNP prep</value></feat>
<feat number="5"><type>prep</type><value>A</value></feat>
</featmorph>
<featsem nb="1">
<feat number="1"><type>...</type><value>...</value></feat>
</featsem>
</features>
</word>
<word>
<item>mange</item>
<cat>V</cat>
<features>
<featmorph nb="3">
<feat number="1"><type>arg0 cat</type><value>GN</value></feat>
<feat number="2"><type>arg0 tete pers</type><value>trois</value></feat>
<feat number="3"><type>arg0 tete nbre</type><value>sing</value></feat>
<feat number="4"><type>arg1 cat</type><value>GN</value></feat>
</featmorph>
<featsem nb="1">
<feat number="1"><type>...</type><value>...</value></feat>
</featsem>
</features>
</word>
<word>
<item>dort</item>
<cat>V</cat>
<features>
<featmorph nb="4">
<feat number="1"><type>arg0 cat</type><value>GN</value></feat>
<feat number="2"><type>arg0 tete pers</type><value>trois</value></feat>
<feat number="3"><type>arg0 tete nbre</type><value>sing</value></feat>
<feat number="4"><type>arg1 cat</type><value>VOID</value></feat>
</featmorph>
<featsem nb="1">
<feat number="1"><type>...</type><value>...</value></feat>
</featsem>
</features>
</word>
<word>
<item>miaule</item>
<cat>V</cat>
<features>
<featmorph nb="4">
<feat number="1"><type>arg0 cat</type><value>GN</value></feat>
<feat number="2"><type>arg0 tete pers</type><value>trois</value></feat>
<feat number="3"><type>arg0 tete nbre</type><value>sing</value></feat>
<feat number="4"><type>arg1 cat</type><value>VOID</value></feat>
</featmorph>
<featsem nb="1">
<feat number="1"><type>...</type><value>...</value></feat>
</featsem>
</features>
</word>
<word>
<item>aboit</item>
<cat>V</cat>
<features>
<featmorph nb="4">
<feat number="1"><type>arg0 cat</type><value>GN</value></feat>
<feat number="2"><type>arg0 tete pers</type><value>trois</value></feat>
<feat number="3"><type>arg0 tete nbre</type><value>sing</value></feat>
<feat number="4"><type>arg1 cat</type><value>VOID</value></feat>
</featmorph>
<featsem nb="1">
<feat number="1"><type>...</type><value>...</value></feat>
</featsem>
</features>
</word>
<word>
<item>mangent</item>
<cat>V</cat>
<features>
<featmorph nb="4">
<feat number="1"><type>arg0 cat</type><value>GN</value></feat>
<feat number="2"><type>arg0 tete pers</type><value>trois</value></feat>
<feat number="3"><type>arg0 tete nbre</type><value>plur</value></feat>
<feat number="4"><type>arg1 cat</type><value>GN</value></feat>
</featmorph>
<featsem nb="1">
<feat number="1"><type>...</type><value>...</value></feat>
</featsem>
</features>
</word>
<word>
<item>manger</item>
<cat>V</cat>
<features>
<featmorph nb="2">
<feat number="1"><type>arg0 cat</type><value>VOID</value></feat>
<feat number="2"><type>arg1 cat</type><value>GN</value></feat>
</featmorph>
<featsem nb="1">
<feat number="1"><type>...</type><value>...</value></feat>
</featsem>
</features>
</word>
<word>
<item>attrape</item>
<cat>V</cat>
<features>
<featmorph nb="4">
<feat number="1"><type>arg0 cat</type><value>GN</value></feat>
<feat number="2"><type>arg0 tete pers</type><value>trois</value></feat>
<feat number="3"><type>arg0 tete nbre</type><value>sing</value></feat>
<feat number="4"><type>arg1 cat</type><value>GN</value></feat>
</featmorph>
<featsem nb="1">
<feat number="1"><type>...</type><value>...</value></feat>
</featsem>
</features>
</word>
<word>
<item>craint</item>
<cat>V</cat>
<features>
<featmorph nb="4">
<feat number="1"><type>arg0 cat</type><value>GN</value></feat>
<feat number="2"><type>arg0 tete pers</type><value>trois</value></feat>
<feat number="3"><type>arg0 tete nbre</type><value>sing</value></feat>
<feat number="4"><type>arg1 cat</type><value>GN</value></feat>
</featmorph>
<featsem nb="1">
<feat number="1"><type>...</type><value>...</value></feat>
</featsem>
</features>
</word>
<word>
<item>au</item>
<cat>PREP</cat>
<features>
<featmorph nb="4">
<feat number="1"><type>select cat</type><value>GN1</value></feat>
<feat number="2"><type>select tete gnre</type><value>masc</value></feat>
<feat number="3"><type>select tete nbre</type><value>sing</value></feat>
<feat number="4"><type>prep</type><value>A</value></feat>
</featmorph>
<featsem nb="1">
<feat number="1"><type>...</type><value>...</value></feat>
</featsem>
</features>
</word>
<word>
<item>du</item>
<cat>PREP</cat>
<features>
<featmorph nb="4">
<feat number="1"><type>select cat</type><value>GN1</value></feat>
<feat number="2"><type>select tete gnre</type><value>masc</value></feat>
<feat number="3"><type>select tete nbre</type><value>sing</value></feat>
<feat number="4"><type>prep</type><value>DE</value></feat>
</featmorph>
<featsem nb="1">
<feat number="1"><type>...</type><value>...</value></feat>
</featsem>
</features>
</word>
<word>
<item>aux</item>
<cat>PREP</cat>
<features>
<featmorph nb="4">
<feat number="1"><type>select cat</type><value>GN1</value></feat>
<feat number="2"><type>select tete gnre</type><value>masc</value></feat>
<feat number="3"><type>select tete nbre</type><value>plur</value></feat>
<feat number="4"><type>prep</type><value>A</value></feat>
</featmorph>
<featsem nb="1">
<feat number="1"><type>...</type><value>...</value></feat>
</featsem>
</features>
</word>
</dico>
';

my $graph = GraphViz::XML->new($xml);

$graph->as_png("xml.png");
#print $g->as_text;
#print $g->_as_debug;

