use winFunc;
##############################################################################
#AUTHORS: 	Fleury Serge
#VERSION: 	1.0.2
#email:		serge.fleury@univ-paris3.fr
#url:		http://www.cavi.univ-paris3.fr/ilpga/ilpga/sfleury/mkcorpusProject.htm
#date:		June/2002
#FILE:
#    This file is part of MKCorpus.
##############################################################################
#
# collocations in XPATH module
#
##############################################################################
# Markus Dreyer
# 28.08.2000
# Kollokationen finden
    if (!open(F,"$ARGV[0]")) {
	&mkPrintErreur("ERREUR : Impossible d\'ouvrir MKC-tmp_collocInXPath.txt\n");
	return;
    }
    if (!open(FIC2,">MKC-tmp_collocations.txt")) {
    &mkPrintErreur("ERREUR : Impossible d\'ouvrir MKC-tmp_collocations.txt\n");
    return;
	}
    my $debug = 0; 
    my @offsets;
# Debug-Meldungen ein- oder ausschalten
    my $leftRight = 4; 
# immer je $leftRight Wrter nach links und nach rechts. Fenstergre ist somit $leftRight * 2 + 1
    my $begin = time();
    my $typeCnt  = 0;  
# hier werden die Types des Korpus gezhlt
### File Zeile fr Zeile einlesen ###

    my $lineCnt = 0;
    while(my $line = <F> ){
	next if(substr($line, 0, 2) eq "%%");
	print FIC2 "Processing line $lineCnt... (elapsed: ", (time() - $begin), "sec)\n" if( $lineCnt % 1000 == 0);
	$line =~ s/^\s+[0-9]+:\s+//;
	my @tokens = split( /\s+/, $line );
	### Schleife ber jeden Token im Satz ###
	for(my $i = 0; $i <= $#tokens; $i++){
	    dbg("$tokens[$i]\n");
	    ### Fenster, das rechten und linken Kontext eines jeden Tokens betrachtet ###
	    for(my $j = ($i - $leftRight); $j <= ($i + $leftRight); $j++ ){
		$j = 0 if( $j < 0 );
		last if( $j > $#tokens );
		dbg("\t" . $tokens[$j] . " (" . ($j - $i) . ")\n");
		registerType( $tokens[$j] );
		push(
		     @{		# als Array interpretierter ...
			 ${ $offsets[ $typesCollocations{ $tokens[$i] }]  }{$typesCollocations{ $tokens[$j] }} # ... Wert des doppelten Hashs
		 }
		,
		$j - $i 
		    )
		if($j - $i != 0);
	}
	dbg("\n");
    }
    $lineCnt++;	
    last if($lineCnt == 2000);
}
close F;

print FIC2 "Beginne Berechnung...";
print FIC2 "Abgelaufen bisher: ", ( time() - $begin ), " sec.\n";

### Errechnen und ausgeben: mean offset und standard deviation ###
my $token1Nr = 0;
foreach my $hashRef ( @offsets ){
    foreach my $token2Nr ( keys %{$hashRef} ){
	print FIC2 "$numbersCollocations[$token1Nr]\t$numbersCollocations[$token2Nr]\t\t";	
	my @offsetsForToken1AndToken2 = @{ ${ $offsets[$token1Nr] }{ $token2Nr } };
    dbg("( ");
    foreach(@offsetsForToken1AndToken2){
	dbg("$_ ");
    }
    dbg(") ");
    my $meanTmp = mean( @offsetsForToken1AndToken2 );
    $meanTmp = sprintf("%.3f", $meanTmp); # auf 3 Stellen runden
    my $devTmp = stdDev( \@offsetsForToken1AndToken2, $meanTmp );
    $devTmp = sprintf("%.3f", $devTmp) if(defined $devTmp);
    
    # Die Ergebnisse knnte man wieder speichern:
    #${$means{$token1Nr}}{$token2Nr} = $meanTmp;
    #${$stdDev{$token1Nr}}{$token2Nr} = $devTmp;
    
    my $cntTmp = $#offsetsForToken1AndToken2 + 1;
    print FIC2 "CNT = $cntTmp\t";
    print FIC2 "MEAN = $meanTmp";
    print FIC2 "\tDEV = $devTmp", (($cntTmp > 2 && $devTmp <= 1)?(" !!!"):(""))
	if( defined $devTmp );
    print FIC2 "\n";
}
$token1Nr++;
}
print FIC2 "Gesamtzeit: ", ( time() - $begin ), " sec.\n";
close(F);
close(FIC2);


#########################################################################
### mean offset (Mittlerer Abstand) ausrechnen
### Parameter: Einen Array, der alle Abweichungen enthlt, (-1, 3, 2, -2)
#########################################################################
sub mean{
	my @offsets = @_;
	my $sum = 0;
	foreach (@offsets){
		$sum += $_;		
	}
	return ($sum / (($#offsets > 0)?($#offsets + 1):(1)));
}

######################################################################
### standard deviation ausrechnen
### Parameter: Einen Array, der alle Abweichungen enthlt und die mean-offset-Zahl
######################################################################
sub stdDev{
	my ($offsetsRef, $meanOffset) = @_;
	my @offsets = @$offsetsRef;
	return undef if( $#offsets == 0 ); # nur ein Element
	my $stdDev = 0;
	foreach $offset (@offsets){
		$stdDev += (($offset - $meanOffset) * ($offset - $meanOffset));
	}
	return sqrt( $stdDev / $#offsets );
}

######################################################################
# Type neu in den Hash eintragen: Jeder Type bekommt 'ne eigene Nummer 
######################################################################
sub registerType{
	my $w = shift;
	unless(defined $typesCollocations{$w} ){
		$typesCollocations{$w} = $typeCnt++;
		push (@numbersCollocations, $w);
	}
}

###################################################################
### dbg() - Einfache Info-Messages ber den Programmablauf ausgeben
###################################################################
sub dbg{
    $debug && print shift; # Ausgabe nur, wenn $debug wahr.
}


