package winFunc6;
##############################################################################
#AUTHORS: 	Fleury Serge
#VERSION: 	1.0.4
#email:		serge.fleury@univ-paris3.fr
#url:		http://www.cavi.univ-paris3.fr/ilpga/ilpga/sfleury/mkcorpusProject.htm
#date:		mars/2003
#FILE:
#    This file is part of MKCorpus.
##############################################################################
#
# winFunc6.pm
#
# [mkcorpus] Callback-functions for all windows
#

#-------
# Export

use strict;
use Exporter;
use vars qw(@ISA @EXPORT 
);
@ISA = qw(Exporter);
@EXPORT = qw( 
	      &xml2png &displayDotFile &parcoursXMLandDisplayWithDot &parcoursXMLandDisplayAsPNG
	     );


#-------
# Packages

use Tk 800.022;
use Tk::TextUndo;
use Tk::TextEdit;
use Tk::TextTools;
use Tk::MarkupTools;

use Tk::Menu;
use Tk::Optionmenu;
use Tk::Photo;
use Tk::Balloon;
use Tk::CheckButton;
use Tk::RadioButton;

use Tk::Balloon;
use Tk::ObjScanner;
use Tk::DirTree;
use Tk::WaitBox;
use Tk::ProgressBar;
use Tk::Date;
use Tk::XMLViewer;
use Tk::Animation;
use Tk::Dialog;
use Tk::DialogBox;
use Tk::Toplevel;
use Tk::FileSelect;

use English;
use File::Basename;
use Data::Dumper;
use winMain;

use IO::Handle;
use IO::Seekable;
use IO::File;
use IO::Pipe;
use IO::Socket;
use IO::Dir;

use GraphViz;
use GraphViz::XML;


use FindBin qw( $Bin );

#-----------------
# Global variables

#------------------
# Private Variables

my $top1;
my $top2;
my $top3;
my $top4;
my $top5;


#---------------------------------------------------------------------------------------
#Procdures et premiers Niveaux
#---------------------------------------------------------------------------------------

sub xml2png {

    use GraphViz;
    use XML::Twig;
    use GraphViz::XML;
    my $xml = "";

    if (!open(TMPFILE,("$winMain::nom_fic"))) {
	&winFunc1::mkPrintErreur("ERREUR : Impossible d\'ouvrir le fichier '$winMain::nom_fic'\n");
	return;
    }

    while (<TMPFILE>) {
	$xml .= $_;
    }

    close(TMPFILE);

    my $graph = GraphViz::XML->new($xml);
    my $tmp_graph= Win32::GetCwd() . "MKC-tmp_xml.png";
    $graph->as_png($tmp_graph);

    eval {my $msie = Win32::OLE->GetActiveObject('InternetExplorer.Application')};
    if ($@) {
	&winFunc1::mkPrintErreur("InternetExplorer unavailable" );
    }
    my $msie;
    unless (defined $msie) {
	print "Dmarrage de IE \n";
	$msie = Win32::OLE->new('InternetExplorer.Application');
	if ($@) {
	    &winFunc1::mkPrintErreur("ERREUR : Oops, cannot start IE" );
	}
	$msie->{'Visible'}=1;
	$msie->Navigate($tmp_graph);
    }  

}

#---------------------------------------------
sub displayDotFile {

    use Tk::GraphViz;

    my $mw = $winMain::mw ->Toplevel(-title => "MKC-Graphic");

    my $mw1=$mw->Frame->pack(-side => 'top',
				  -expand => '1', -fill => 'both' ); 

    my $msg;
    my $label=$mw->Label( -textvariable => \$msg , -relief => 'raised' )->pack(-side => 'bottom');

    my $gv = $mw1->Scrolled ( 'GraphViz',
                             -background => 'white',
                             -scrollbars => 'sw' )
      ->pack ( -expand => '1', -fill => 'both' );

    $gv->bind ( 'node', '<Button-1>', sub {
                my @tags = $gv->gettags('current');
                push @tags, undef unless (@tags % 2) == 0;
                my %tags = @tags;
		printf ( "Clicked node: '%s' => %s\n",
                         $tags{node}, $tags{label} );
		$msg="Clicked node: $tags{node} => $tags{label}";
                } );

    $gv->show ( $winMain::nom_fic );

}

#---------------------------------------------
sub displayDotFile2 {


    my $file = shift;
    use Tk::GraphViz;

    my $mw = $winMain::mw ->Toplevel(-title => "MKC-Graphic");
    my $gv = $mw->Scrolled ( 'GraphViz',
                             -background => 'white',
                             -scrollbars => 'sw' )
      ->pack ( -expand => '1', -fill => 'both' );

    $gv->bind ( 'node', '<Button-1>', sub {
                my @tags = $gv->gettags('current');
                push @tags, undef unless (@tags % 2) == 0;
                my %tags = @tags;
                printf ( "Clicked node: '%s' => %s\n",
                         $tags{node}, $tags{label} );
                } );

    $gv->show ( $file );
    my $tmp_graph= Win32::GetCwd() . "MKC-tmp_xml.png";
    $gv->as_png($tmp_graph);

    eval {my $msie = Win32::OLE->GetActiveObject('InternetExplorer.Application')};
    if ($@) {
	&winFunc1::mkPrintErreur("InternetExplorer unavailable" );
    }
    my $msie;
    unless (defined $msie) {
	print "Dmarrage de IE \n";
	$msie = Win32::OLE->new('InternetExplorer.Application');
	if ($@) {
	    &winFunc1::mkPrintErreur("ERREUR : Oops, cannot start IE" );
	}
	$msie->{'Visible'}=1;
	$msie->Navigate($tmp_graph);
    }
}
#---------------------------------------------
sub parcoursXMLandDisplayWithDot {

    use XML::DOM;
    my $xp=new XML::DOM::Parser;
    my $doc=$xp->parsefile($winMain::nom_fic);

    if (!open(TMPDOMFILE,(">MKC-tmp_domfile.txt"))) {
	&winFunc1::mkPrintErreur("ERREUR : Impossible d\'ouvrir le fichier MKC-tmp_domfile.txt en criture\n");
	return;
    }

    if (!open(TMPDOPFILE,(">MKC-tmp_dopfile.dot"))) {
	&winFunc1::mkPrintErreur("ERREUR : Impossible d\'ouvrir le fichier MKC-tmp_domfile.txt en criture\n");
	return;
    }



    print TMPDOPFILE "digraph L0 {";
    print TMPDOPFILE "	size = \"8,8\";";
    print TMPDOPFILE "	ordering=out;";
    print TMPDOPFILE "	node [shape = box];";


    my $cpt=0;
#    my $cpt1=$cpt;
    &parcourir ($doc,0, $cpt);

    print TMPDOPFILE "}";

    print TMPDOMFILE "\n";
    print TMPDOPFILE "\n";
    close(TMPDOMFILE);
    close(TMPDOPFILE);
    my $tmpfile="MKC-tmp_dopfile.dot";
    my $msg="MKC-tmp_dopfile.dot";
    &winFunc1::IncludedFileInWindow($tmpfile,$msg);
    

    use Tk::GraphViz;
    my $mw = $winMain::mw ->Toplevel(-title => "MKC-Graphic");

    my $gv = $mw->Scrolled ( 'GraphViz',
                             -background => 'white',
                             -scrollbars => 'sw' )
      ->pack ( -expand => '1', -fill => 'both' );

    $gv->bind ( 'node', '<Button-1>', sub {
                my @tags = $gv->gettags('current');
                push @tags, undef unless (@tags % 2) == 0;
                my %tags = @tags;
                printf ( "Clicked node: '%s' => %s\n",
                         $tags{node}, $tags{label} );
                } );

    $gv->show ( $tmpfile );


    sub parcourir(){ 
	my ($node,$cpt1)=@_;
	my $retVal='';
	my $numChilds=0;

	    foreach my $child ($node->getChildNodes) {
		if ($child->getNodeType==ELEMENT_NODE) {
		    $numChilds++;
		    my $name=$child->getNodeName;
		    print TMPDOMFILE "\nNODE: $name";
		    print TMPDOPFILE "\nn".$cpt." [label=\"".$name."\"];";

		    if ($numChilds >= 2) {
			print "$numChilds\n";
			my $rootstr="n".($cpt1-1);
			print TMPDOPFILE "\n".$rootstr." -> n".$cpt.";";
		    }
		    
		    $cpt++;

		    my $attrs=$child->getAttributes;
		    foreach my $i (0..$attrs->getLength-1) {
			my $attr=$attrs->item($i);
			my $strAttr=$attr->getName."=".$attr->getValue;
			print TMPDOMFILE " $strAttr";
		    }

		    my $tmpcpt=$cpt;
		   
		    my $val= &parcourir($child,$tmpcpt);
		   
		    my $rootstr="n".($tmpcpt -1);
		    print TMPDOPFILE "\n".$rootstr." -> n".$tmpcpt.";";

		    if (!($val eq '')) {
			print TMPDOMFILE " VALUE=$val";
		    }
		} elsif ($child->getNodeType==TEXT_NODE) {
		    $retVal=$child->getData();
		    if ($retVal !~/^\s*$/) {
			$numChilds++;
			print TMPDOPFILE "\nn".$cpt." [label=\"".$retVal."\"];";
			$cpt++;
		    }
		}

	    }


    }
    
}

#---------------------------------------------
sub parcoursXMLandDisplayAsPNG {

    use XML::DOM;
    my $xp=new XML::DOM::Parser;
    my $doc=$xp->parsefile($winMain::nom_fic);

    if (!open(TMPDOMFILE,(">MKC-tmp_domfile.txt"))) {
	&winFunc1::mkPrintErreur("ERREUR : Impossible d\'ouvrir le fichier MKC-tmp_domfile.txt en criture\n");
	return;
    }

    if (!open(TMPDOPFILE,(">MKC-tmp_dopfile.dot"))) {
	&winFunc1::mkPrintErreur("ERREUR : Impossible d\'ouvrir le fichier MKC-tmp_domfile.txt en criture\n");
	return;
    }



    print TMPDOPFILE "digraph L0 {";
    print TMPDOPFILE "	size = \"8,8\";";
    print TMPDOPFILE "	ordering=out;";
    print TMPDOPFILE "	node [shape = box];";


    my $cpt=0;
    &parcourir ($doc,0, $cpt);

    print TMPDOPFILE "}";
    print TMPDOMFILE "\n";
    print TMPDOPFILE "\n";
    close(TMPDOMFILE);
    close(TMPDOPFILE);
    my $tmpfile="MKC-tmp_dopfile.dot";
    my $msg="MKC-tmp_dopfile.dot";
    &winFunc1::IncludedFileInWindow($tmpfile,$msg);


    &displayDotFile2 ( $tmpfile );
    


    sub parcourir(){ 
	my ($node,$cpt1)=@_;
	my $retVal='';
	my $numChilds=0;

	    foreach my $child ($node->getChildNodes) {
		if ($child->getNodeType==ELEMENT_NODE) {
		    $numChilds++;
		    my $name=$child->getNodeName;
		    print TMPDOMFILE "\nNODE: $name";
		    print TMPDOPFILE "\nn".$cpt." [label=\"".$name."\"];";

		    if ($numChilds >= 2) {
			print "$numChilds\n";
			my $rootstr="n".($cpt1-1);
			print TMPDOPFILE "\n".$rootstr." -> n".$cpt.";";
		    }
		    
		    $cpt++;

		    my $attrs=$child->getAttributes;
		    foreach my $i (0..$attrs->getLength-1) {
			my $attr=$attrs->item($i);
			my $strAttr=$attr->getName."=".$attr->getValue;
			print TMPDOMFILE " $strAttr";
		    }

		    my $tmpcpt=$cpt;
		   
		    my $val= &parcourir($child,$tmpcpt);
		   
		    my $rootstr="n".($tmpcpt -1);
		    print TMPDOPFILE "\n".$rootstr." -> n".$tmpcpt.";";

		    if (!($val eq '')) {
			print TMPDOMFILE " VALUE=$val";
		    }
		} elsif ($child->getNodeType==TEXT_NODE) {
		    $retVal=$child->getData();
		    if ($retVal !~/^\s*$/) {
			$numChilds++;
			print TMPDOPFILE "\nn".$cpt." [label=\"".$retVal."\"];";
			$cpt++;
		    }
		}

	    }


    }
    
}

#---------------------------------------------

#------------------------------------------------------------------------
1;

