package winMain;
##############################################################################
#AUTHORS: 	Fleury Serge
#VERSION: 	1.0.4
#email:		serge.fleury@univ-paris3.fr
#url:		http://www.cavi.univ-paris3.fr/ilpga/ilpga/sfleury/mkcorpusProject.htm
#date:		mars/2003
#FILE:
#    This file is part of MKCorpus.
##############################################################################
#
# winMain.pm
#
# [mkcorpus] The main-window
#
##############################################################################
#-------
# Export

use Exporter;
use vars qw(@ISA @EXPORT  $mw  $start_dir $file
	    $label $menu $toolsmenu
	    $frame1 $frame2 $frame3 $frame4 $frame5 $frame6 
	    @group1 @group2 @group3 @group4 @group5 @group6 
	    $new_num_doc $b_menu $nom_fic 
	    $max_num_doc $num_doc $winNb  $saisie $saisie2 $saisie3 
	    $search_string $replace_string $cpt_file_balises $texte $mkTextXpath 
	    $levelxmlConverter1  $indxmlConverter1  $headxmlConverter1 
	    $levelxmlConverter2 $indxmlConverter2  $headxmlConverter2 
	    $levelxmlConverter3 $indxmlConverter3  $headxmlConverter3  
	    $mainXmlviewer2  $listePn2SelectionMarkup  $listePn2SelectionMarkup2  
	    $search_string_map $listePn2  $listePn2Map $position_search $waitBoxWidget 
	    @courant %Courant @liste_xmlBalise %Liste_xmlBalise @liste_xmlLexicoBalise 
	    %Liste_xmlLexicoBalise @liste_xmlLexicoBalise2 %Liste_xmlLexicoBalise2 
	    %listeBaliseXmlLexico %compteurBaliseXmlLexico %compteurBaliseXml 
	    %listeBaliseXml %mapTextFull @mapText $imageSelectFile $imageSearch 
	    $imageLoad $imageExit $imageHelp $imageSave $imageScan $imageSelect $imageKub $imageedxml
	    $imageText $imageReplace $imageDelete $imageClearSearch $imageNoHighlight 
	    $logoMKC $winBalloon $pctComplete $progress $progressText $splash 
	    $statusbar $balloon
	    );

@ISA = qw(Exporter);
@EXPORT = qw(&CreateWinMain &UpdateIndicators 
	     $mw
	     $label 
	     $frame1 $frame2 $frame3 $frame4 $frame5 $frame6 
	     @group1 @group2 @group3 @group4 @group5 @group6 
	     $start_dir $new_num_doc $nom_fic $max_num_doc 
	     $num_doc $b_menu  $winNb  $saisie $saisie2 
	     $saisie3 $search_string $replace_string $cpt_file_balises 
	     $texte  $mkTextXpath $levelxmlConverter1  $indxmlConverter1  
	     $headxmlConverter1 $levelxmlConverter2 $indxmlConverter2  
	     $headxmlConverter2 $levelxmlConverter3 $indxmlConverter3  
	     $headxmlConverter3  $mainXmlviewer2  $listePn2SelectionMarkup  
	     $listePn2SelectionMarkup2  $search_string_map $listePn2  
	     $listePn2Map $position_search $waitBoxWidget @courant 
	     %Courant @liste_xmlBalise %Liste_xmlBalise @liste_xmlLexicoBalise 
	     %Liste_xmlLexicoBalise @liste_xmlLexicoBalise2 %Liste_xmlLexicoBalise2 
	     %listeBaliseXmlLexico %compteurBaliseXmlLexico %compteurBaliseXml 
	     %listeBaliseXml %mapTextFull @mapText $imageSelectFile $imageSearch $imageKub $imageedxml
	     $imageLoad $imageExit $imageHelp $imageSave $imageScan $imageSelect 
	     $imageText $imageReplace $imageDelete $imageClearSearch 
	     $imageNoHighlight $logoMKC $winBalloon $progress
	     );

#-------
# packages

use Getopt::Long;
use English;
use File::Basename;
use File::Find;
use Cwd;
use Getopt::Std;
use Text::Wrap; 

use Tk 800.022;
#use Tk::ErrorDialog;
use FindBin qw( $Bin );

##############################################################################
#-- Utilisation des modules developpes par Calin Mosut pour edXML
# TextTools - perl extensions library for "edxml"
# This module provides routines for text manipulation,
# such as search and replacement tools, and G.U.I. configuration.
# It overrides the module "TextEdit.pm" coming with perl_Tk.
#--
# MarkupTools - perl extensions library for "edxml"
# This library provides an interface to the standard perl
# routines that manipulate XML objects from XML::Parser.pm.
#--
# AUTHOR
# Calin MOSUT, "Babes-Bolyai" University
# Faculty of Letters, A.M.L. Departement
# Bulevard Horea, 31, 3400 Cluj-Napoca
# Romania
##############################################################################
#--

use Tk::TextUndo;
use Tk::TextEdit;
use Tk::TextTools;
use Tk::MarkupTools;

use Tk::Menu;
use Tk::Optionmenu;
use Tk::Photo;
use Tk::Balloon;
use Tk::CheckButton;
use Tk::RadioButton;

use Tk::XMLViewer;

use Tk::ObjScanner;
use Tk::DirTree;
use Tk::WaitBox;
use Tk::ProgressBar;

use Tk::Date;
use Tk::Animation;
use Tk::Dialog;
use Tk::DialogBox;
use Tk::Toplevel;
use Tk::FileSelect;

use XML::Parser;
use XML::Parser::Grove;
use XML::Grove;
use XML::Grove::Visitor;
use XML::Grove::Iter;
use XML::XPath;
use XML::DOM;
use XML::EasyOBJ;

#use Net::FTP;

use LWP::UserAgent;
use HTML::Parser;
use HTML::FormatText;
use HTML::FormatPS;
use LWP::Simple;
use HTML::LinkExtor;
use URI::URL;

use winFunc1;
#-------------------
# KUB
use winFunc2;
#-------------------
#  Appli EDXML (cf CALIN PROCs)
# use winFunc3;
#-------------------
# Dico suedois -> cf Project
# use winFunc4;
#-------------------
# Dico Phonetique  -> cf Project
# use winFunc5;
#-------------------
# Graphic Tools (GraphViz en particulier)
use winFunc6;
# autres winfunc a venir  -> cf Project

#-------------------
use mkCorpusModules::SubHandlers;
use mkCorpusModules::EliInfo;
use mkCorpusModules::MyVisitor;
use mkCorpusModules::DirSelect;

use strict; 

#-----------------
# Global variables
# Accessable from outside

$mw;
$label;
$menu;
$toolsmenu;
$frame1;
$frame2;
$frame3;
$frame4;
$frame5;
$frame6;
@group1;
@group2;
@group3;
@group4;
@group5;
@group6 ;
$start_dir;
$new_num_doc;
$nom_fic;
$file;
$max_num_doc;
$num_doc;
$winNb;
$b_menu;
$saisie; 
$saisie2; 
$saisie3;
$search_string;
$replace_string; 
$cpt_file_balises;
$texte ;
$mkTextXpath;
$levelxmlConverter1 ;
$indxmlConverter1 ;
$headxmlConverter1;
$levelxmlConverter2; 
$indxmlConverter2 ;
$headxmlConverter2;
$levelxmlConverter3; 
$indxmlConverter3 ;
$headxmlConverter3;
$mainXmlviewer2 ;
$listePn2SelectionMarkup ;
$listePn2SelectionMarkup2 ;
$search_string_map;
$listePn2 ;
$listePn2Map;
$position_search;
$waitBoxWidget;

#------------------
#Tableaux

@courant;
%Courant;
@liste_xmlBalise;
%Liste_xmlBalise;
@liste_xmlLexicoBalise;
%Liste_xmlLexicoBalise;
@liste_xmlLexicoBalise2;
%Liste_xmlLexicoBalise2;
%listeBaliseXmlLexico;
%compteurBaliseXmlLexico;
%compteurBaliseXml;
%listeBaliseXml;
%mapTextFull;
@mapText;

$imageKub;
$imageedxml;
$imageSelectFile;
$imageSearch;
$imageLoad;
$imageExit;
$imageHelp;
$imageSave;
$imageScan;
$imageSelect;
$imageText;
$imageReplace;
$imageDelete;
$imageClearSearch;
$imageNoHighlight;
$logoMKC;
$pctComplete;
$progress;
$progressText;
$splash;

$winBalloon;

#------------------
# Private Variables

my $menuButtonProc;
my $img;
#my $progress;
my $toolsTypweb;
my $sensnetXref;
my $helpTypweb;
my $typweb036;
my $typweb038;
my $alceste;
my $cordial;
my $lexico;
my $mirroringSite;
my $typwebParseRegExp;
my $typwebParseXML;
my $prepHtml;
my $statCorpus;
my $xmlCorpus;
my $xmlCorpus1;
my $fileCorpus;
my $fileWordCorpus;
my $menuxslttools;
my $menusearchingxmldocs;
my $menuxmlconverters;
my $menuhtmlconverters;
my $menuhtmltidy;
my $menuxmlTidy;
my $menuxmladdtag;
my $menuxmlViewer;
my $menuxmlParser;
my $menuxmlXpath;
my $menuxmlGrove;
my $menuxmlParseDTD;
my $menuxmlExtractor;
my $menuxmlElement;
my $menuxmlInProgress;
my $nlpregexp;
my $nlpsuffix;
my $nlpconcordance;
my $nlpbigram1;
my $nlpbigram2;
my $nlpothers;
my $time;

my $a_menu;
my $c_menu;
my $c0_menu;
my $d_menu;
my $d0_menu;
my $d1_menu;
my $d2_menu;
my $d3_menu;
my $d4_menu;
my $e_menu;
my $f_menu;
my $g_menu;
my $h_menu;
my $help_menu;
my $browser_menu;

my $corpusview;
my $checkchar;

my $buttonKub;
my $buttonEDXML;
my $buttonOpen;
my $buttonNoHighLight;
my $buttonLoad;
my $buttonSelect;
my $buttonExit;
my $buttonHelp;
my $buttonSave;
my $buttonText;
my $buttonScan;
my $cadreTop0;
my $cadreTop1;
my $cadreTop2;
my $cadreTop21;
my $cadreTop22;
my $cadreTop3;
my $cadreTop4;
my $top2;
my $w_string;
my $w_string_label;
my $w_string_label1;
my $w_string_label2;
my $w_string_label3;
my $w_string_entry;
my $w_string_entry1;
my $w_string_entry3;
my $w_string_entry2;
my $w_string_button;
my $w_string_button1;
my $w_string_button2;
my $w_string_button3;
my $w_string2;
my $w_string2_label;
my $w_string2_button;
my $w_string2_entry;
my $Filename;

##############################################################################
#--------------------
# CreateWinMain()
#
# Creates the main-window
##############################################################################

sub CreateWinMain() {
    $mw= MainWindow->new;
    $mw->title("MkCorpus \@(Tal Paris 3 - CLA2T) v.1.03");
    $mw->withdraw;
    $label = $mw->Label( -background => 'black',
			 -foreground =>  'white', -anchor => 'w' );
    
    
#------------------
    $splash = $mw->Toplevel(-title => "mkCorpus is coming soon..." , -visual => 'truecolor');
##############################################################################
## Make the application exit if the splash window is closed...
##############################################################################
    $splash->protocol( 'WM_DELETE_WINDOW' => sub {exit} ) ;
    my $img = $splash->Photo(-file=> 'pics/logo-mkc.gif');
    $splash->Label( -image => $img)->pack;
##############################################################################
#    my $camelSplash=$splash->Animation('-format' => 'gif',
#				       -file => Tk->findINC('anim.gif'));
#    my $l = $splash->Label(-image => $camelSplash)->pack(-side => 'top');
#    $splash->Animation->start_animation(80);
## Progress bar on splash screen...
##############################################################################
    $pctComplete = 0;
    $progress = $splash->ProgressBar(-variable => \$pctComplete,
				     -borderwidth => 7, -relief => 'flat', -width => 20, -length => 300,
				     -padx => 0, -pady => 0,-gap => 0,
				     -from => 0, -to => 100,
				     -colors => [0 => 'blue', 40 => 'black' , 80 => 'red'],
				     -troughcolor => 'white',
				     )->pack;
    
    $progressText = "";
    $splash->Label( -textvariable => \$progressText )->pack;
    sleep 2;
    &splashProgress( "Wake Up Boo...", 90 );
    sleep 2;
##############################################################################
#------------------
    $new_num_doc=0;
#$nom_fic="Nouveau".$new_num_doc.".txt";
#$nom_fic=$texte->FileName();
    $max_num_doc=10;
    $num_doc=0;
    @courant=();
    %Courant=();
    $start_dir = &GetCWD;
    $winNb=0;
#---------------------------------------------------------------------------------------
#Image Boutons
    $imageKub = $mw->Photo(-file => "pics/cube.gif");
    $imageedxml = $mw->Photo(-file => "pics/plan.gif");
    $imageSelectFile = $mw->Photo(-file => "icons/file_open.xpm");
    $logoMKC = $mw->Photo(-file => "pics/logo.xpm");
    $imageSearch = $mw->Photo(-file => "icons/search.xpm");
    $imageLoad = $mw->Photo(-file => "icons/open.xpm");
    $imageExit = $mw->Photo(-file => "icons/small.exit.xpm");
    $imageHelp = $mw->Photo(-file => "icons/small.help_3d.xpm");
    $imageSave = $mw->Photo(-file => "icons/filesave.xpm");
    $imageScan = $mw->Photo(-file => "icons/scan.xpm");
    $imageSelect=$mw->Photo(-file => "icons/small.select_3d.xpm");
    $imageText=$mw->Photo(-file => "icons/filenew.xpm");
    $imageReplace=$mw->Photo(-file => "icons/small.icon_copy_3d.xpm");
    $imageDelete=$mw->Photo(-file => "icons/cut.xpm");
    $imageClearSearch=$mw->Photo(-file => "icons/small.no_entry_3d.xpm");
    $imageNoHighlight=$mw->Photo(-file => "icons/refresh.xpm");
##############################################################################
#Variable pas utilise correctement
    $cpt_file_balises=0;
##############################################################################
    $winBalloon = $mw->Balloon(
			       -initwait => 400,
			       -state    => 'balloon'
			       );
#---------------------------------------------------------------------------------------
    splashProgress( "Initialising first bit... Main Window Definition", 5 );
    sleep 1;
#---------------------------------------------------------------------------------------
    $cadreTop0 = $mw->Frame->pack(-side => 'top',
				  -fill => 'x');    
    my $date = $cadreTop0->Date(-editable => 0,
				-variable => \$time,
				-value => 'now',
				)->pack(-side => 'left');
    $date->repeat(999, sub { $time = time(); });
    my $running;
    my $camel=$mw->Animation('-format' => 'gif',
			     -file => Tk->findINC('anim.gif'));
    my $l = $cadreTop0->Label(-image => $camel)->pack(-side => 'right');
    $cadreTop0->Button(-text => 'Start/Stop',
		       -command => sub {
			   if (!$running) {
			       $camel->start_animation(80);
			   } else {
			       $camel->stop_animation();
		 }
			   $running = !$running;
		       })->pack(-side => 'right');
#---------------------------------------------------------------------------------------
    $cadreTop1 = $mw->Frame->pack(-side => 'top',
				  -fill => 'x');
    $cadreTop2 = $mw->Frame->pack(-side => 'top',
			  -fill => 'x');
    $cadreTop21 = $mw->Frame->pack(-side => 'top',
			  -fill => 'x');;
    $cadreTop22 = $mw->Frame->pack(-side => 'top',
				   -fill => 'x');
    $cadreTop3 = $mw->Frame->pack(-side => 'top',
				  -fill => 'x');
    $cadreTop4 = $mw->Frame->pack(-side => 'top',
				  -fill => 'x');
#---------------------------------------------------------------------------------------
    splashProgress( "Initialising first bit... First Definition", 5 );
    sleep 1;
#---------------------------------------------------------------------------------------
##############################################################################
#$texte= $mw->Scrolled("TextUndo")->pack(-side => 'bottom',
#			      -fill => 'both',
#	    		      -expand => 1);
#
#-- modif CM
##############################################################################
    $frame1 = $cadreTop1->Frame( -relief => 'raised', -borderwidth => 1 );
    $frame2 = $cadreTop1->Frame( -relief => 'raised', -borderwidth => 1 );
    $frame3 = $cadreTop1->Frame( -relief => 'raised', -borderwidth => 1 );
    $frame4 = $cadreTop1->Frame( -relief => 'raised', -borderwidth => 1 );
    $frame5 = $cadreTop1->Frame( -relief => 'raised', -borderwidth => 1 );
    $frame6 = $cadreTop1->Frame( -relief => 'raised', -borderwidth => 1 );
    $texte= $cadreTop4->Scrolled( 'MarkupTools', 
				  -scrollbars => 'ose',
				  -exportselection => 'true',
				  -selectforeground => 'white',
				  -selectbackground => "#000070669645",
				  -insertwidth => 3, 
				  -setgrid => 'true',
				  -wrap => 'word'  );
    $file = $texte->FileName();
    $menu      = $texte->menu( -type => 'menubar' );
    $toolsmenu = $menu->entrycget( 4, '-menu' );
    $mw->setPalette( "#bfbdbfbdbfbd" );
    $mw->configure( -menu => $menu );
    $frame1->Button( -image   => $mw->Photo( -file =>"$Bin/ledxml/new.gif"),
		     -command => [$texte,'ConfirmEmptyDocument'], -relief=>'flat',
		     -height=>17, -width=>17 )->pack( -side=>'left' );
    $frame1->Button( -image => $mw->Photo(-file =>"$Bin/ledxml/open.gif"),
		     -command => [$texte,'FileLoadPopup'], -relief=>'flat',
		     -height=>17, -width=>17 )->pack( -side => 'left' );
    $frame1->Button( -image => $mw->Photo(-file =>"$Bin/ledxml/include.gif"),
		     -command => [$texte,'IncludeFilePopup'], -relief=>'flat',
		     -height=>17, -width=>17 )->pack( -side => 'left' );
    $frame1->Button( -image => $mw->Photo(-file =>"$Bin/ledxml/save.gif"),
		     -command => [$texte,'FileSave'], -relief=>'flat',
		     -height=>17, -width=>17 )->pack( -side => 'left' );
    $frame1->Button( -image => $mw->Photo(-file =>"$Bin/ledxml/export.gif"),
		     -command => [$texte,'FileExportPopup'], -relief=>'flat',
		     -height=>17, -width=>17 )->pack( -side => 'left' );
    
    $frame2->Button( -image => $mw->Photo(-file =>"$Bin/ledxml/undo.gif"),
		     -command => [$texte,'undo'], -relief=>'flat',
		     -height=>17, -width=>17 )->pack( -side => 'left' );
    $frame2->Button( -image => $mw->Photo(-file =>"$Bin/ledxml/redo.gif"),
		     -command => [$texte,'redo'], -relief=>'flat',
		     -height=>17, -width=>17 )->pack( -side => 'left' );    
    $frame3->Button( -image => $mw->Photo(-file =>"$Bin/ledxml/cut.gif" ),
		     -command => [$texte,'clipboardCut'], -relief=>'flat',
		     -height=>17, -width=>17 )->pack( -side => 'left' );
    $frame3->Button( -image => $mw->Photo(-file=>"$Bin/ledxml/copy.gif"),
		     -command => [$texte,'clipboardCopy'], -relief=>'flat',
		     -height=>17, -width=>17 )->pack( -side => 'left' );
    $frame3->Button( -image => $mw->Photo(-file=>"$Bin/ledxml/paste.gif"),
		     -command => [$texte,'clipboardPaste'], -relief=>'flat',
		     -height=>17, -width=>17 )->pack( -side => 'left' );
    $frame3->Button( -image => $mw->Photo(-file=>"$Bin/ledxml/clear.gif"),
		     -command => [$texte,'deleteSelected'], -relief=>'flat',
		     -height=>17, -width=>17 )->pack( -side => 'left' );
    $frame4->Button( -image => $mw->Photo(-file=>"$Bin/ledxml/find.gif"),
		     -command => [$texte,'FindPopUp'], -relief=>'flat',
		     -height=>17, -width=>17 )->pack( -side => 'left' );
    $frame4->Button( -image => $mw->Photo(-file=>"$Bin/ledxml/next.gif"),
		     -command => [$texte, 'FindSelectionNext'], -relief=>'flat',
		     -height=>17, -width=>17 )->pack( -side => 'left' );
    $frame4->Button( -image => $mw->Photo(-file=>"$Bin/ledxml/replace.gif"),
		     -command => [$texte,'FindAndReplacePopUp'], -relief=>'flat',
		     -height=>17, -width=>17 )->pack( -side => 'left' );
    $frame5->Button( -image => $mw->Photo(-file=>"$Bin/ledxml/display.gif"),
		     -command => [$texte,'displayArea'], -relief=>'flat',
		     -height=>17, -width=>17 )->pack( -side => 'left' );
    $frame5->Button( -image => $mw->Photo(-file=>"$Bin/ledxml/delete.gif"),
		     -command => [$texte,'deleteArea'], -relief=>'flat',
		     -height=>17, -width=>17 )->pack( -side => 'left' );
    $frame5->Button( -image => $mw->Photo(-file=>"$Bin/ledxml/remove.gif"),
		     -command => [$texte,'removeMarkups'], -relief=>'flat',
		     -height=>17, -width=>17 )->pack( -side => 'left' );
    $frame5->Button( -image => $mw->Photo(-file=>"$Bin/ledxml/write.gif"),
		     -command => [$texte,'WriteTagPopUp'], -relief=>'flat',
		     -height=>17, -width=>17 )->pack( -side => 'left' );
    $frame5->Button( -image => $mw->Photo(-file=>"$Bin/ledxml/markup.gif"),
		     -command => [$texte,'MarkupPopUp'], -relief=>'flat',
		     -height=>17, -width=>17 )->pack( -side => 'left' );
    $frame6->Button( -image => $mw->Photo(-file=>"$Bin/ledxml/cde.gif"),
		     -command => [$texte,'FormalProximity'], -relief=>'flat',
		     -height=>17, -width=>17 )->pack( -side => 'left' );
    $frame6->Button( -image => $mw->Photo(-file=>"$Bin/ledxml/index.gif"),
		     -command => [$texte,'showIndex'], -relief=>'flat',
		     -height=>17, -width=>17 )->pack( -side => 'left' );
    $frame6->Button( -image => $mw->Photo(-file=>"$Bin/ledxml/parse.gif"),
		     -command => \&showParser, -relief=>'flat',
		     -height=>17, -width=>17 )->pack( -side => 'left' );
    $frame6->Button( -image => $mw->Photo(-file=>"$Bin/ledxml/help.gif"),
		     -command => \&HelpPopup, -relief=>'flat',
		     -height=>17, -width=>17 )->pack( -side => 'left' );
    @group1 = $frame1->children();
    @group2 = $frame2->children();
    @group3 = $frame3->children();
    @group4 = $frame4->children();
    @group5 = $frame5->children();
    @group6 = $frame6->children();
    $statusbar  = $mw->Label( -relief => 'raised' );
    $balloon    = $mw->Balloon( -statusbar => $statusbar );
    $texte->setHomeEnvironement( $ENV{HOME}? $ENV{HOME}: 0 );
    $texte->getEditPreferences();
    $texte->loadEditPreferences();
    $texte->loadStatusbar( $statusbar );
    $texte->Subwidget( 'yscrollbar' )->configure( -jump => 1 );
    $texte->SetGUICallbacks([sub {&UpdateIndicators();}, sub {$texte->HighlightAllPairsBracketingCursor;}, sub {&UpdateMenu();}]);
    $balloon->attach( $group1[0], -balloonmsg => "New",
		      -statusmsg => "'New' button activated" );
    $balloon->attach( $group1[1], -balloonmsg => "Open",
		      -statusmsg => "'Open' button activated" );
    $balloon->attach( $group1[2], -balloonmsg => "Include",
		      -statusmsg => "'Include' button activated" );
    $balloon->attach( $group1[3], -balloonmsg => "Save",
		      -statusmsg => "'Save' button activated" );
    $balloon->attach( $group1[4], -balloonmsg => "Export clipboard",
		      -statusmsg => "'Export' button activated" );
    $balloon->attach( $group2[0], -balloonmsg => "Undo",
		      -statusmsg => "'Undo' button activated" );
    $balloon->attach( $group2[1], -balloonmsg => "Redo",
		      -statusmsg => "'Redo' button activated" );
    $balloon->attach( $group3[0], -balloonmsg => "Cut",
		      -statusmsg => "'Cut' button activated" );
    $balloon->attach( $group3[1], -balloonmsg => "Copy",
		      -statusmsg => "'Copy' button activated" );
    $balloon->attach( $group3[2], -balloonmsg => "Paste",
		      -statusmsg => "'Paste' button activated" );
    $balloon->attach( $group3[3], -balloonmsg => "Clear",
		      -statusmsg => "'Clear' button activated" );
    $balloon->attach( $group4[0], -balloonmsg => "Find",
		      -statusmsg => "'Find' button activated" );
    $balloon->attach( $group4[1], -balloonmsg => "Find next",
		      -statusmsg => "'Find next' button activated" );
    $balloon->attach( $group4[2], -balloonmsg => "Replace",
		      -statusmsg => "'Replace' button activated" );
    $balloon->attach( $group5[0], -balloonmsg => "Display tag area",
		      -statusmsg => "'Display' button activated" );
    $balloon->attach( $group5[1], -balloonmsg => "Delete tag area",
		      -statusmsg => "'Delete' button activated" );
    $balloon->attach( $group5[2], -balloonmsg => "Remove markups",
		      -statusmsg => "'Clear' button activated" );
    $balloon->attach( $group5[3], -balloonmsg => "Write tag",
		      -statusmsg => "'Write' button activated" );
    $balloon->attach( $group5[4], -balloonmsg => "Markup selections",
		      -statusmsg => "'Markup' button activated" );
    $balloon->attach( $group6[0], -balloonmsg => "Formal proximity",
		      -statusmsg => "'Proximity' button activated" );
    $balloon->attach( $group6[1], -balloonmsg => "Index",
		      -statusmsg => "'Index' button activated" );
    $balloon->attach( $group6[2], -balloonmsg => "Parser",
		      -statusmsg => "'Parser' button activated" );
    $balloon->attach( $group6[3], -balloonmsg => "Help",
		      -statusmsg => "'Help' button activated" );
##############################################################################
#-- modif CM
##############################################################################
    $frame1->pack( -side => 'left' );
    $frame2->pack( -side => 'left' );
    $frame3->pack( -side => 'left' );
    $frame4->pack( -side => 'left' );
    $frame5->pack( -side => 'left' );
    $frame6->pack( -side => 'left' );
    $texte->pack( -side => 'top', -fill => 'both', -expand => 1 );
    $statusbar->pack( -side => 'bottom', -fill => 'x' );
    $label->pack( -side => 'bottom', -fill => 'x' );
##############################################################################
#-- Modif CM
#$texte->Text(-setgrid => 'true');
#$mw->protocol('WM_DELETE_WINDOW'=>  sub{ConfirmExit2($texte);});
##############################################################################
    $mw->protocol( 'WM_DELETE_WINDOW' => sub { $texte->ConfirmExit; });
    $SIG{INT} = sub {  $texte->ConfirmExit; };
##############################################################################
# my $scanner = $mw->ObjScanner( caller => $texte, title=>"windows") -> pack ;
##############################################################################
    $b_menu=$cadreTop3->Menubutton(-text => "File (2)",
				   -tearoff => 0,
				   -relief => 'ridge',
				   -menuitems => [['command' => "~View dir",
						   -command => \&open_dir],
						  ['command' => "~View AND Select dir",
						   -command => \&viewAndSelectDir],
						  ['command' => "~Select File & open",
						   -command => \&query_file_dialog],
						  ['command' => "~Select File & not open",
						   -command => \&query_file_dialog3],
						  ['command' => "Open this file",
						   -command => \&lire_fic],
						  ['command' => "~Save this file",
						   -command => \&sauve_fic],
						  ['command' => "~Save this file as",
						   -command => \&query_file_dialog2],
						  ['command' =>"~Clear", 
						   -command => sub{ConfirmEmptyDocument2($texte);}],
						  ['command' => "Exit",
						   -command =>    sub{ConfirmExit2($texte);}
						   ]])->pack(-side => 'left');
#---------------------------------------------------------------------------------------
    splashProgress( "Initialising first bit... Menu Edit Definition", 10 );
    sleep 1;
#---------------------------------------------------------------------------------------
    $c0_menu=$cadreTop3->Menubutton(-text => "Edit (2)",
				    -tearoff => 0,
				    -relief => 'ridge',
				    -menuitems => [["command"=>'Undo', 
						    -command => [$texte => 'undo']],
						   ["command"=>'Redo', 
						    -command => [$texte => 'redo']],
						   "-",@{$texte->EditMenuItems} 
						   ])->pack(-side => 'left');
#---------------------------------------------------------------------------------------
    splashProgress( "Initialising first bit... Menu Search Definition", 10 );
    sleep 1;
#---------------------------------------------------------------------------------------
    $c_menu=$cadreTop3->Menubutton(-text => "Search (2)",
				   -tearoff => 0,
				   -relief => 'ridge',
				   -menuitems => [['command' => "I-Search",
						   -command => \&i_search],
						  ['command' => "Repeat I-Search",
						   -command => \&i_search2],
						  ['command' => "Global Search",
						   -command => \&search_in_fic],
						  ['command' => "I-Replace",
						   -command => \&i_replace],
						  ['command' => "Repeat I-Replace",
						   -command => \&i_replace2],
						  ['command' => "Global Replace",
						   -command => \&replace],
						  ['command' => "Search-Replace in Multiple Files",
						   -command => \&tksm]
						  ])->pack(-side => 'left');    
##############################################################################
#-- Modif CM
#$mw->bind("<Button-3>",sub{ $c_menu->Popup(-popover => 'cursor',
#						    _popanchor => "nw")});
##############################################################################
#---------------------------------------------------------------------------------------
    splashProgress( "Initialising first bit... Menu Markup Definition", 10 );
    sleep 1;
#---------------------------------------------------------------------------------------    
    $d0_menu=$cadreTop3->Menubutton(-text => "Markup <[^>]+>",
				    -tearoff => 0,
				    -relief => 'ridge',
				    -menuitems => [['command' => "View all",
						    -command => \&list_balise],
						   ['command' => "Delete all",
						    -command => \&del_balise],
						   ['command' => "Search all",
						    -command => \&search_balise],
						   ['command' => "I-Search",
						    -command => \&i_search],
						   ['command' => "Repeat I-Search",
						    -command => \&i_search2],
						   ['command' => "Extract Text in Markups",
						    -command => \&query_search_text_in_balise]
						   ])->pack(-side => 'left');
#---------------------------------------------------------------------------------------
    splashProgress( "Initialising first bit... Menu HTML Definition", 15 );
    sleep 1;
#---------------------------------------------------------------------------------------
    $d1_menu=$cadreTop3->Menubutton(-text => "Tools HTML",
				    -tearoff => 0,
				    -relief => 'ridge',
				    -menuitems => [
						   ["cascade" => "HTML-Converter"],
						   ["cascade" => "HTML-TIDY"]
						   ])->pack(-side => 'left');
    $menuhtmlconverters =$d1_menu->menu->Menu(-menuitems => [
							     ['command' => "Html2Text (special)",
							      -command => \&html0],
							     ['command' => "Html2Text",
							      -command => \&html1],
							     ['command' => "Html2PostScript",
							      -command => \&html2],
							     ['command' => "rtf2html",
							      -command => \&rtf2html],
							     ['command' => "ps2html",
							      -command => \&ps2html],
							     ['command' => "txt2html",
							      -command => \&txt2html],
							     ['command' => "perl2html",
							      -command => \&perl2html]
							     ]);
    $menuhtmltidy =$d1_menu->menu->Menu(-menuitems => [
						       ['command' => "Clean HTML with Tidy (Win32)",
							-command => \&query_dir_tidyClean1],
						       ['command' => "Clean HTML with Tidy HELP",
							-command => \&help_tidyClean1]
						       ]);
    
    $d1_menu->entryconfigure("HTML-Converter",-menu =>$menuhtmlconverters);
    $d1_menu->entryconfigure("HTML-TIDY",-menu =>$menuhtmltidy);    
#---------------------------------------------------------------------------------------
    splashProgress( "Initialising first bit... Menu XML Definition", 15 );
    sleep 1;
#---------------------------------------------------------------------------------------     
    $d2_menu=$cadreTop3->Menubutton(-text => "Tools XML",
				    -tearoff => 0,
				    -relief => 'ridge',
				    -menuitems => [
						   ["cascade" => "XML-Viewer"],
						   ["cascade" => "XML-Parser"],
						   ["cascade" => "XML XPath"],
						   ["cascade" => "XML-Grove"],
						   ["cascade" => "XML-ParseDTD"],
						   ["cascade" => "XML-Extractor"],
						   ["cascade" => "XML-Element"],
						   ["cascade" => "XML-AddTagInTextNode"],
						   ["cascade" => "XML-TIDY"],
						   ["cascade" => "XML-Converters"],
						   ["cascade" => "XSLT-Tools"],
						   ["cascade" => "XML-Searching-In-Docs"],
						   ["cascade" => "XML-Tools-Corpus"],
						   ["cascade" => "XML-In-Progress"]
						   ])->pack(-side => 'left');
    
    $menuxmlViewer =$d2_menu->menu->Menu(-menuitems => [
							['command' => "XML as Tree",
							 -command => \&eventXML],
							['command' => "XML Viewver (1)",
							 -command => \&xmlViewver],
							['command' => "XML Viewver (2)",
							 -command => \&xmlViewver_2]
							]);
    $menuxmlParser = $d2_menu->menu->Menu(-menuitems => [
							 ['command' => "Parse File",
							  -command => \&parseXML],
							 ['command' => "XML Parser",
							  -command => \&showParser]
							 ]);
    $menuxmlExtractor = $d2_menu->menu->Menu(-menuitems => [
							    ['command' => "Select Markup (Handlers)",
							     -command => \&xmlMkListBalise],
							    ['command' => "Select Markup (1) (DOM)",
							     -command => \&xmlDomExtractTag],
							    ['command' => "Select Markup (2) (DOM)",
							     -command => \&xmlDomExtractTag1],
							    ['command' => "Extract Markup with Search_string (DOM)",
							     -command => \&xmlDomExtractTagWithSearchString],
							    ]);
    $menuxmlElement = $d2_menu->menu->Menu(-menuitems => [
							  ['command' => "XML Comment",
							   -command => \&xmlComment],
							  ['command' => "XML Stat",
							   -command => \&xmlStat],
							  ['command' => "Print Elt As Text (with DOM)",
							   -command => \&printEltAsTextWithDOM],
							  ['command' => "Print Text Elt (with DOM)",
							   -command => \&printTextEltWithDOM],
							  ['command' => "Rename TAG",
							   -command => \&renameTAGXML],
							  ['command' => "Add ID on TAG",
							   -command => \&addIDOnTAG]
							  ]);
    $menuxmladdtag = $d2_menu->menu->Menu(-menuitems => [
							 ['command' => "Add TAG in Text NODE",
							  -command => \&addTagInTextNode],
							 ['command' => "I-Add TAG in Text NODE",
							  -command => \&iaddTagInTextNode],
							 ['command' => "Help Add TAG in Text NODE",
							  -command => \&helpaddTagInTextNode]
							 ]);
    $menuxmlParseDTD = $d2_menu->menu->Menu(-menuitems => [
							   ['command' => "Parse DTD",
							    -command => \&parseDTD]]);
    $menuxmlInProgress = $d2_menu->menu->Menu(-menuitems => [
							     ['command' => "Nothing",
							      -command => \&nothing]]);
    $menuxmlGrove = $d2_menu->menu->Menu(-menuitems => [
							['command' => "xmlGrove 1",
							 -command => \&xmlGroveTool1]]);
    $menuxmlXpath = $d2_menu->menu->Menu(-menuitems => [
							['command' => "Extract node via Xpath (1)",
							 -command => \&xmlXpath],
							['command' => "Extract node via Xpath (2)",
							 -command => \&xmlXpath1],
							['command' => "Extract all nodes with text via Xpath",
							 -command => \&xmlXpath2],
							['command' => "Extract all selected nodes (by name)",
							 -command => \&xmlXpath3],
							['command' => "Interface Xpath (Win32)",
							 -command => \&xmlXpath4],
							['command' => "Help Xpath",
							 -command => \&help_xmlXpath]
							]);   
    $menuxmlTidy = $d2_menu->menu->Menu(-menuitems => [
						       ['command' => "HTML2XML with Tidy (Win32)",
							-command => \&query_dir_tidyClean],
						       ['command' => "HTML2XML with Tidy HELP",
							-command => \&help_tidyClean]
						       ]);    
    $menuxmlconverters = $d2_menu->menu->Menu(-menuitems => [
							     ['command' => "XML2html",
							      -command => \&xmlConverter1],
							     ['command' => "XML2pod",
							      -command => \&xmlConverter2],
							     ['command' => "XML2txt",
							      -command => \&xmlConverter3],
							     ['command' => "RTF2XML",
							      -command => \&xmlConverter4]
							     ]);
    $menuxslttools = $d2_menu->menu->Menu(-menuitems => [
							 ['command' => "Sablotron(XML->HTML)",
							  -command => \&processSablotron],
							 ['command' => "XMLXSLT(XML->HTML)",
							  -command => \&processXMLXSLT],
							 ['command' => "XT-Win32(XML->HTML)",
							  -command => \&processXT],
                                                         ['command' => "XT(XML->HTML)",
							  -command => \&processXT2],
							 ['command' => "LIBXSLT(XML->HTML)",
							  -command => \&processLibXSLT]
							 ]);
    $menusearchingxmldocs = $d2_menu->menu->Menu(-menuitems => [
								['command' => " Tag Text Search ",
								 -command => \&tagtextsearch],
								['command' => " Text In Tag ",
								 -command => \&textintag]
								]);
    $xmlCorpus1=$d2_menu->menu->Menu(-menuitems => [
						   ['command' => "Collocation/XPath",
						    -command => \&collocInXPath],
						   ['command' => "Stat XML node",
						    -command => \&statxmlnode]
						   ]);

    $d2_menu->entryconfigure("XML-Viewer",-menu =>$menuxmlViewer);
    $d2_menu->entryconfigure("XML-Parser",-menu =>$menuxmlParser);
    $d2_menu->entryconfigure("XML XPath",-menu =>$menuxmlXpath);
    $d2_menu->entryconfigure("XML-Grove",-menu =>$menuxmlGrove);
    $d2_menu->entryconfigure("XML-ParseDTD",-menu =>$menuxmlParseDTD);
    $d2_menu->entryconfigure("XML-Searching-In-Docs",-menu =>$menusearchingxmldocs);
    $d2_menu->entryconfigure("XML-Extractor",-menu =>$menuxmlExtractor);
    $d2_menu->entryconfigure("XML-Element",-menu =>$menuxmlElement);
    $d2_menu->entryconfigure("XML-AddTagInTextNode",-menu =>$menuxmladdtag);
    $d2_menu->entryconfigure("XML-TIDY",-menu =>$menuxmlTidy);
    $d2_menu->entryconfigure("XML-Converters",-menu =>$menuxmlconverters);
    $d2_menu->entryconfigure("XSLT-Tools",-menu =>$menuxslttools);
    $d2_menu->entryconfigure("XML-Tools-Corpus",-menu =>$xmlCorpus1);
    $d2_menu->entryconfigure("XML-In-Progress",-menu =>$menuxmlInProgress);
#---------------------------------------------------------------------------------------
    splashProgress( "Initialising first bit... Menu Graphic Definition", 20 );
    sleep 1;
#---------------------------------------------------------------------------------------    
    $d4_menu=$cadreTop3->Menubutton(-text => "Graph",
				    -tearoff => 0,
				    -relief => 'ridge',
				    -menuitems => [['command' => "xml to png",
						    -command => \&xml2png],
						   ['command' => "display Dot File",
						    -command => \&displayDotFile],
						   ['command' => "xml 2 dot",
						    -command => \&parcoursXMLandDisplayWithDot],
						   ['command' => "xml 2 png (dom)",
						    -command => \&parcoursXMLandDisplayAsPNG]

						   ])->pack(-side => 'left');
#---------------------------------------------------------------------------------------
    splashProgress( "Initialising first bit... Menu Converters Definition", 22 );
    sleep 1;
#---------------------------------------------------------------------------------------    
    $d3_menu=$cadreTop3->Menubutton(-text => "Converters",
				    -tearoff => 0,
				    -relief => 'ridge',
				    -menuitems => [['command' => "pdf2xml",
						    -command => \&pdf2xml],
						   ['command' => "pdf2html",
						    -command => \&pdf2html],
						   ['command' => "rtf2html",
						    -command => \&rtf2html],
						   ['command' => "txt2html",
						    -command => \&txt2html],
						   ['command' => "perl2html",
						    -command => \&perl2html],
						   ['command' => "ps2html",
						    -command => \&ps2html]
						   ])->pack(-side => 'left');
#---------------------------------------------------------------------------------------
    splashProgress( "Initialising second bit , Menu Map definition...", 25 );
    sleep 1;
#---------------------------------------------------------------------------------------
    $h_menu=$cadreTop3->Menubutton(-text => "Map-Corpus",
				   -tearoff => 0,
				   -relief => 'ridge',
				   -menuitems => [
						  ['command' => "Make TAG-Map (RegExp)",
						   -command => \&makeTextToMap],
						  ['command' => "Make TAG-Map (DOM)",
						   -command => \&maketagmap],
						  ['command' => "Make TREE-TAG-Map (DOM)",
						   -command => \&maketreetagmap],
						  ['command' => "Make TREE-TAG-Map (LIBXML-DOM)",
						   -command => \&maketreetagmap_libxml]
						  ])->pack(-side => 'left')  ;    
#---------------------------------------------------------------------------------------
    splashProgress( "Initialising second bit, Menu Corpus Definition...", 25 );
    sleep 1;
#---------------------------------------------------------------------------------------
    $e_menu=$cadreTop3->Menubutton(-text => "Corpus Tools",
				   -tearoff => 0,
				   -relief => 'ridge',
				   -menuitems => [
					  ["cascade" => "StatTools"],
						  ["cascade" => "FileTools"],
						  ["cascade" => "MSWord-Tools"],
						  ["cascade" => "CheckChar"],
						  ["cascade" => "PrepHTML2Txt"],
						  ["cascade" => "Lexico"],
						  ["cascade" => "Alceste"],
						  ["cascade" => "Cordial"],
						  ["cascade" => "XML-Corpus"]
						  ]
				   )->pack(-side => 'left');
    $statCorpus=$e_menu->menu->Menu(-menuitems => [
						   ['command' => "Stat File",
						    -command => \&statFile]
						   ]);
    $xmlCorpus=$e_menu->menu->Menu(-menuitems => [
						   ['command' => "Collocation/XPath",
						    -command => \&collocInXPath],
						   ['command' => "Stat XML node",
						    -command => \&statxmlnode]
						   ]);
    $fileCorpus=$e_menu->menu->Menu(-menuitems => [
						   ['command' => "Concat File (for Lexico)",
						    -command => \&concatFile2lexico],
						   ['command' => "Concat File (-> XML)",
						    -command => \&concatFile2xml],
						   ['command' => "HELP Concat File",
						    -command => \&help_concatFile],
						   ['command' => "Directory2XML",
						    -command => \&directory2xml],
						   ['command' => "Select File (rand)",
						    -command => \&randSelectFile],
						   ['command' => "HELP Select File",
						    -command => \&help_randSelectFile],
						   ['command' => "Directory2XML",
						    -command => \&concat2xmlrandSelectFile]
						   ]);
    $fileWordCorpus=$e_menu->menu->Menu(-menuitems => [
						       ['command' => "MSWord 2 Lexico",
							-command => \&word2lexico],
						       ['command' => "MSWord 2 XML",
							-command => \&word2xml],
						       ['command' => "HELP  MSWord 2 Lexico",
							-command => \&help_word2lexico],
						       ['command' => "HELP  MSWord 2 XML",
							-command => \&help_word2xml]
						       ]);
    $checkchar=$e_menu->menu->Menu(-menuitems => [
						  ['command' => "Read Char",
						   -command => \&readCharInText],
						  ['command' => "Change Char",
						   -command => \&changeCharInText],
						  ['command' => "Change Ascii",
						   -command => \&changeAsciiInText],
						  ['command' => "Change UnrocognizedChar",
						   -command => \&changeUnrocognizedCharInText],
						  ['command' => "Apply Change in TableCharacter (No Log)",
						   -command => \&applyChangeInTableCharacter1],
						  ['command' => "Apply Change in TableCharacter (Log)",
						   -command => \&applyChangeInTableCharacter2],
						  ['command' => "Check Char v.2 (in-progress)",
						   -command => \&transcodeurTk]
						  ]);
    $prepHtml=$e_menu->menu->Menu(-menuitems => [['command' => "Read One Dir",
						  -command => \&query_dir_prepOneDir],
						 ['command' => "Read One File",
						  -command => \&mkPrepHtml2txtOneFile]
						 ]);    
    $lexico=$e_menu->menu->Menu(-menuitems => [['command' => "Extract Selected Markup For Lexico-Corpus (Handlers-1)",
						-command => \&lexico1],
					       ['command' => "Extract Selected Markup For Lexico-Corpus (Handlers-2)",
						-command => \&lexico2],
					       ['command' => "Extract Selected Markup For Lexico-Corpus (DOM)",
						-command => \&lexico3],
					       ['command' => "HELP Maj->Min",
						-command => \&help_lexico4],
					       ['command' => "Change Maj->Min",
						-command => \&lexico4],
					       ['command' => "HELP Specif-Sort",
						-command => \&help_lexico5],
					       ['command' => "Specif-Sort",
						-command => \&lexico5],
					       ['command' => "HELP DSR-Sort",
						-command => \&help_lexico6],
					       ['command' => "DSR-Sort",
						-command => \&lexico6]
					       ]);
    $alceste=$e_menu->menu->Menu(-menuitems => [['command' => "Make Corpus",
						 -command => \&alceste1],
						['command' => "Verify Corpus",
						 -command => \&alceste2]]);
    $cordial=$e_menu->menu->Menu(-menuitems => [['command' => "help Make Corpus",
						 -command => \&help_cordial],
						['command' => "Make Corpus-Tag",
						 -command => \&cordial],
						['command' => "Cordial 2 Lexico v.1",
						 -command => \&cordial2Lexico],
						['command' => "Cordial 2 Lexico v.2",
						 -command => \&cordial2Lexico2],
						['command' => "Cordial 2 XML ",
						 -command => \&cordial2xml],
						['command' => "Help Cordial 2 XML ",
						 -command => \&help_cordial2xml]
						]);
    $e_menu->entryconfigure("StatTools",-menu =>$statCorpus);
    $e_menu->entryconfigure("FileTools",-menu =>$fileCorpus);
    $e_menu->entryconfigure("XML-Corpus",-menu =>$xmlCorpus);
    $e_menu->entryconfigure("MSWord-Tools",-menu =>$fileWordCorpus);
    $e_menu->entryconfigure("CheckChar",-menu =>$checkchar);
    $e_menu->entryconfigure("PrepHTML2Txt",-menu =>$prepHtml);
    $e_menu->entryconfigure("Lexico",-menu =>$lexico);
    $e_menu->entryconfigure("Alceste",-menu =>$alceste);
    $e_menu->entryconfigure("Cordial",-menu =>$cordial);
#---------------------------------------------------------------------------------------
    splashProgress( "Initialising second bit, Menu NLP definition...", 30 );
    sleep 1;
#---------------------------------------------------------------------------------------
    $g_menu=$cadreTop3->Menubutton(-text => "NLP Tools",
				   -tearoff => 0,
				   -relief => 'ridge',
				   -menuitems => [
						  ["cascade" => "Count-regExp"],
						  ["cascade" => "Suffix-Prefix"],
						  ["cascade" => "Concordance"],
						  ["cascade" => "Bigram-word"],
						  ["cascade" => "Bigram-char"],
						  ["cascade" => "Others"]
						  ]
				   )->pack(-side => 'left');
#---------------------------------------------------------------------------------------
    splashProgress( "Initialising second bit (NLPa)...", 35 );
    sleep 1;
#---------------------------------------------------------------------------------------
    $nlpregexp=$g_menu->menu->Menu(-menuitems => [
						  ['command' => "FindTypes",
						   -command => \&findTypes],
						  ['command' => "Extract Region",
						   -command => \&extractRegion],
						  ['command' => "WordCount",
						   -command => \&mkWordCount]
						  ]);

    $nlpsuffix=$g_menu->menu->Menu(-menuitems => [
						  ['command' => "WebFix",
						   -command => \&webfix],
						  ['command' => "Help Webfix",
						   -command => \&helpwebfix]
						  ]);
#---------------------------------------------------------------------------------------
    splashProgress( "Initialising second bit (NLPb)...", 40 );
    sleep 1;
#---------------------------------------------------------------------------------------
    $nlpothers=$g_menu->menu->Menu(-menuitems => [
						  ['command' => "xWords (Dict)",
						   -command => \&mkXWord]
						  ]);
#---------------------------------------------------------------------------------------
    splashProgress( "Initialising second bit (NLPc)...", 45 );
    sleep 1;
#---------------------------------------------------------------------------------------
    $nlpconcordance=$g_menu->menu->Menu(-menuitems => [
						       ['command' => "Concordance (one word) 1",
							-command => \&mkConcordanceOneWord],
						       ['command' => "Concordance (one word) 2",
							-command => \&mkConcordanceOneWord2],
						       ['command' => "Concordance (all word) 1",
							-command => \&mkConcordance],
						       ['command' => "Concordance (all word) 2",
							-command => \&concordanceFormat],
						       ['command' => "Collocate",
							-command => \&mkCollocate],
						       ['command' => "Collocations",
							-command => \&mkCollocations]
						       ]);
#---------------------------------------------------------------------------------------
    splashProgress( "Initialising second bit (NLPd)...", 50 );
    sleep 1;
#---------------------------------------------------------------------------------------
    $nlpbigram1=$g_menu->menu->Menu(-menuitems => [
						   ['command' => "Bigram (Word)",
						    -command => \&mkBigramWord],
						   ['command' => "Trigram (Word)",
						    -command => \&mkTrigramWord],
						   ['command' => "FourGram (Word)",
						    -command => \&mkFourgramWord]
						   ]);
#---------------------------------------------------------------------------------------
    splashProgress( "Initialising second bit (NLPe)...", 55 );
    sleep 1;
#---------------------------------------------------------------------------------------
    $nlpbigram2=$g_menu->menu->Menu(-menuitems => [
						   ['command' => "help Bigram Char",
						    -command => \&help_bigramChar],
						   ['command' => "1-Make-index",
						    -command => \&makeIndex],
						   ['command' => "2-Mots2BigramUniques",
						    -command => \&mots2BigramUniques],
						   ['command' => "3-BigrammesUniques2Distance",
						    -command => \&bigrammesUniques2Distance],
						   ['command' => "4-mots2Distance_unix",
						    -command => \&mots2Distance]
						   ]
				    );
#---------------------------------------------------------------------------------------
    splashProgress( "Initialising second bit (NLPf)...", 55 );
    sleep 1;
#---------------------------------------------------------------------------------------
    $g_menu->entryconfigure("Count-regExp",-menu =>$nlpregexp);
    $g_menu->entryconfigure("Suffix-Prefix",-menu =>$nlpsuffix);
    $g_menu->entryconfigure("Concordance",-menu =>$nlpconcordance);
    $g_menu->entryconfigure("Bigram-word",-menu =>$nlpbigram1);
    $g_menu->entryconfigure("Bigram-char",-menu =>$nlpbigram2);
    $g_menu->entryconfigure("Others",-menu =>$nlpothers);
    
#---------------------------------------------------------------------------------------
    splashProgress( "Initialising second bit, Menu Typweb Definition...", 60 );
    sleep 1;
#---------------------------------------------------------------------------------------
    $f_menu=$cadreTop3->Menubutton(-text => "Typweb",
				   -tearoff => 0,
				   -relief => 'ridge',
				   -menuitems => [
						  ["cascade" => "DownloadSite"],
						  ["cascade" => "Typweb036"],
						  ["cascade" => "Typweb038"],
						  ["cascade" => "SensnetXref"],
						  ["cascade" => "Tools"],
						  ["cascade" => "HELPs"]
						  ])->pack(-side => 'left');    
    $mirroringSite=$f_menu->menu->Menu(-menuitems => [
						      ['command' => "Page Mirror",
						       -command => \&query_loadPageMirroring],
						      ['command' => "Site Mirror",
						       -command => \&query_loadMirroring],
						      ['command' => "Wget",
						       -command => \&query_wget],
						      ['command' => "Site UpLoad",
						       -command => \&query_uploading]
						      ]);
    $typweb036=$f_menu->menu->Menu(-menuitems => [['command' => "webxref-Read One Local Web Dir (036)",
						   -command => \&webxref1],
						  ['command' => "webxref-Read Index File (036)",
						   -command => \&webxref2],
						  ['command' => "mktipo-Read WebXref Results Site (036)",
						   -command => \&mktipo1],
						  ['command' => "extandstat-Make stat (036)",
						   -command => \&makestat1],
						  ['command' => "Tag HTML (036)",
						   -command => \&typwebExtractTagHTML],
						  ['command' => "Select Markup (036)",
						   -command => \&mkSelectionMarkup]
						  ]);
    $typweb038=$f_menu->menu->Menu(-menuitems => [
						  ['command' => "webxref-Read One Local Web Dir (038)",
						   -command => \&webxref11],
						  ['command' => "webxref-Read One Dir of Local Web Dir (038)",
						   -command => \&webxrefOneDir],				          
						  ['command' => "webxref-Read Index File (038)",
						   -command => \&webxref22],
						  ['command' => "webxref-Read One Local Web Dir (038 Unix Lynx)",
						   -command => \&webxref11Lynx],
						  ['command' => "webxref-Read One Dir of Local Web Dir (038 Unix Lynx)",
						   -command => \&webxrefOneDirLynx],			          
						  ['command' => "webxref-Read Index File (038 Unix Lynx)",
						   -command => \&webxref22Lynx],
						  ['command' => "webxref-Read Local Web Dir (038-homolWin32)",
						   -command => \&webxref111],
						  ['command' => "webxref-Read Index File (038-homolWin32)",
						   -command => \&webxref222],
						  ['command' => "webxref-Read Local Web Dir (038-homolUnix Lynx)",
						   -command => \&webxref1111],
						  ['command' => "webxref-Read Index File (038-homolUnix Lynx)",
						   -command => \&webxref2222],
						  ['command' => "Make StatWordByFile-Matrice (038 Unix-Lynx)",
						   -command => \&makeMatrice],
						  ['command' => "Make \"Text Only\" (038 Unix-Lynx)",
						   -command => \&makeMatrice2],
						  ['command' => "Make LINKS Matrice (038)",
						   -command => \&makeMatriceLinks],
						  ['command' => "Make TAG Corpus For Lexico (038)",
						   -command => \&makeCorpusTAG]
						  ]);    
    $sensnetXref=$f_menu->menu->Menu(-menuitems => [
						  ['command' => "webxref-Read One Local Web Dir (sensnetXref1)",
						   -command => \&sensnetXref1],
						  ['command' => "webxref-Read One Dir of Local Web Dir (sensnetXref2)",
						   -command => \&sensnetXref2],				          
						  ['command' => "webxref-Read Index File (sensnetXref3)",
						   -command => \&sensnetXref3],
						  ['command' => "webxref-Read One Local Web Dir (lynxW32) (sensnetXref4)",
						   -command => \&sensnetXref4],
						  ['command' => "webxref-Read One Dir of Local Web Dir (lynxW32) (sensnetXref5)",
						   -command => \&sensnetXref5],			          
						  ['command' => "webxref-Read Index File (lynxW32) (sensnetXref6)",
						   -command => \&sensnetXref6],
						  ]);    
    $toolsTypweb=$f_menu->menu->Menu(-menuitems => [['command' => "Extract TxtBrut",
						     -command => \&typwebExtractTxtBrut],
						    ['command' => "Select Markup",
						     -command => \&typwebMkListBalise],
						    ['command' => "DECANTEUR (\@2001 Grouin)",
						     -command => \&decanteur],
						    ['command' => "MAKE XML CORPUS TYPWEB",
						     -command => \&makeXMLCorpusTypweb]
						    ]);
    $helpTypweb=$f_menu->menu->Menu(-menuitems => [
						   ['command' => "HELP WEBXREF",
						    -command => \&helpwebxref],
						   ['command' => "HELP Make TAG-WORD Matrice",
						    -command => \&helpmakeMatrice],
						   ['command' => "HELP Make Matrice Links",
						    -command => \&helpmakeMatriceLinks],
						   ['command' => "HELP Make TAG Corpus",
						    -command => \&helpmakeCorpusTAG],
						   ['command' => "HELP TOOLS TYPWEB",
						    -command => \&helptypweb]
						   ]);
    $f_menu->entryconfigure("DownloadSite",-menu =>$mirroringSite);
    $f_menu->entryconfigure("Typweb036",-menu =>$typweb036);
    $f_menu->entryconfigure("Typweb038",-menu =>$typweb038);
    $f_menu->entryconfigure("SensnetXref",-menu =>$sensnetXref);
    $f_menu->entryconfigure("Tools",-menu =>$toolsTypweb);
    $f_menu->entryconfigure("HELPs",-menu =>$helpTypweb);
#---------------------------------------------------------------------------------------
    splashProgress( "Initialising second bit, Menu HELP...", 60 );
    sleep 1;
#---------------------------------------------------------------------------------------
    $help_menu=$cadreTop3->Menubutton(-text => "Help",
				      -tearoff => 0,
				      -relief => 'ridge',
				      -menuitems => [
##############################################################################
#					  ['command' => "Package Help",
#					-command => \&helpPackage],
##############################################################################
						     ['command' => "Package Help with Pod",
						      -command => \&helpPod2txt],
						     ['command' => "MkCorpus Help",
						      -command => \&command_help]
						     ])->pack(-side => 'left');
    
#---------------------------------------------------------------------------------------
    $browser_menu=$cadreTop3->Menubutton(-text => "Browser",
					 -tearoff => 0,
					 -relief => 'ridge',
					 -menuitems => [
							['command' => "Browser Help MKC",
							 -command => \&browser1],
							['command' => "Browser",
							 -command => \&browser2],
							['command' => "Help in IE",
							 -command => \&browser_ie]
							])->pack(-side => 'left');    
#---------------------------------------------------------------------------------------
    splashProgress( "Initialising third bit (dum-de-dum)...", 80 );
    sleep 1;
#---------------------------------------------------------------------------------------
##############################################################################
    $search_string = '';
    $w_string = $cadreTop2->Frame()->pack(-side => 'top', -fill => 'x');
    $w_string_label = $w_string->Label(-text => 'Search string (XPath):', -width => 20, -anchor => 'w');
    $saisie2= $w_string_entry = $w_string->Entry(-textvariable => \$search_string);
    $w_string_label2 = $w_string->Label(-text => 'Delete string:', -width => 13, -anchor => 'w');
    $w_string_entry2 = $w_string->Entry( -textvariable => \$search_string);
    $w_string_button = $w_string->Button(-text => 'Highlight', -image => $imageSearch);
    $winBalloon->attach($w_string_button,
			-balloonmsg => "Search and Highlight"
			);
    $w_string_button1 = $w_string->Button(-text => 'No Highlight', -image => $imageNoHighlight);
    $winBalloon->attach($w_string_button1,
			-balloonmsg => "Stop HighLight"
			);
    $w_string_button2 = $w_string->Button(-text => 'Delete', -image => $imageDelete);
    $winBalloon->attach($w_string_button2,
			-balloonmsg => "Delete"
			);
    $w_string_button3 = $w_string->Button(-text => 'ClearSearch', -image => $imageClearSearch);
    $winBalloon->attach($w_string_button3,
			-balloonmsg => "Clear Search"
			);
    $w_string_label->pack(-side => 'left');
    $w_string_entry->pack(-side => 'left');
    $w_string_label2->pack(-side => 'left');
    $w_string_entry2->pack(-side => 'left');
    $w_string_button->pack(-side => 'left', -pady => 5, -padx => 10);
    $w_string_button2->pack(-side => 'left', -pady => 5, -padx => 10);
    $w_string_button3->pack(-side => 'left', -pady => 5, -padx => 10);
    $w_string->pack(-side => 'top', -fill => 'x');
    $w_string_button->configure(-command => [sub {&text_search($texte, $search_string, 'search')}, $texte]);
    $w_string_button1->configure(-command => [sub {&remove_mark_search}]);
    $w_string_button2->configure(-command => [sub {&text_delete($texte, $search_string, 'search')}, $texte]);
    $w_string_button3->configure(-command => [sub {&remove_search}]);
    $w_string_entry->bind('<Return>' => [sub {shift; &text_search($texte, $search_string, 'search')}, $texte]);
    $w_string_entry2->bind('<Return>' => [sub {shift; &text_delete($texte, $search_string, 'search')}, $texte]);
    $w_string->pack(-side => 'top', -fill => 'x');
    if ($mw->depth > 1) {
	text_toggle($texte, ['configure', 'search', -background => 'SeaGreen4', -foreground => 'white'], 800,
		    ['configure', 'search', -background => undef,       -foreground => undef],   200);
    } else {
	text_toggle($texte, ['configure', 'search', -background => 'black',     -foreground => 'white'], 800,
		    ['configure', 'search', -background => undef,       -foreground => undef],   200);
    }
    
    $saisie2->delete(0,'end');
#---------------------------------------------------------------------------------------
    splashProgress( "Oops, more to do than expected...One more bit maybe!", 75 );
    sleep 1;
#---------------------------------------------------------------------------------------
#Boutons fonctions
#---------------------------------------------------------------------------------------
    $menuButtonProc = $cadreTop21->Frame()->pack(-side => 'top', -fill => 'x');

    $buttonOpen=$menuButtonProc->Button(-text => "Select File",
				  -image => $imageSelectFile,
				  -command => sub {&query_file_dialog})->pack(-side => 'left',
									      -anchor => 'e');
    $winBalloon->attach($buttonOpen,
			-balloonmsg => "Select File"
			);

    $buttonNoHighLight = $menuButtonProc->Button(-text => 'No Highlight', 
						 -image => $imageNoHighlight,
						 -command => sub {&remove_mark_search})->pack(-side => 'left',
									      -anchor => 'e');
    $winBalloon->attach($buttonNoHighLight ,
			-balloonmsg => "Stop HighLight"
			);

    $buttonKub=$menuButtonProc->Button(-text => "Load Kub",
				  -image => $imageKub,
				  -command => sub {&loadCube})->pack(-side => 'left',
									      -anchor => 'e');
    $winBalloon->attach($buttonKub,
			-balloonmsg => "Load Kub"
			);
#    $buttonEDXML=$menuButtonProc->Button(-text => "Load EDXML",
#				  -image => $imageedxml,
#				  -command => sub {&loadEDXML})->pack(-side => 'left',
#									      -anchor => 'e');
#    $winBalloon->attach($buttonEDXML,
#			-balloonmsg => "Load EDXML"
#			);

#------------------------------------------------------------
    $w_string2 = $cadreTop2->Frame()->pack(-side => 'top', -fill => 'x');
    $w_string2_label = $w_string2->Label(-text => 'Replace with string:', -width => 20, -anchor => 'w');
    $saisie3= $w_string2_entry = $w_string2->Entry(-textvariable => \$replace_string);
    $w_string2_button = $w_string2->Button(-text => 'Replace', -image => $imageReplace);
    $winBalloon->attach($w_string2_button,
			-balloonmsg => "Replace String"
			);
    $w_string2_label->pack(-side => 'left');
    $w_string2_entry->pack(-side => 'left');
    $w_string2_button->pack(-side => 'left', -pady => 5, -padx => 10);
#$w_string2->pack(-side => 'top', -fill => 'x');
    $w_string2_button->configure(-command => [sub {&text_replace($texte, $search_string, $replace_string, 'search')}, $texte]);
    $w_string2_entry->bind('<Return>' => [sub {shift; &text_replace($texte, $search_string, $replace_string, 'search')}, $texte]);
    $w_string2->pack(-side => 'top', -fill => 'x');
    $saisie3->delete(0,'end');
#---------------------------------------------------------------------------------------
##############################################################################
    $cadreTop22->Label(-text => "File : ",
		       -relief => 'raised')->pack(-side => 'left',
						  -anchor => 'w');
##############################################################################
#$saisie=$cadreTop22->Entry(-textvariable => \$texte->FileName())->pack(-side => 'left',
##############################################################################
    $saisie=$cadreTop22->Entry(-textvariable => \$file)->pack(-side => 'left',
							      -anchor => 'w',
							      -fill => 'x',
							      -expand => 1);
##############################################################################
#$saisie->delete(0,'end');
#$saisie->insert('end',"Nouveau");
##############################################################################
    $Filename=$texte->FileName($nom_fic);
##############################################################################
#$filename = $texte->FileName;
#print "$Filename\n";
##############################################################################
    $buttonLoad=$cadreTop22->Button(-text => "Load",
				    -image => $imageLoad,
				    -command => sub {&lire_fic})->pack(-side => 'left',
								       -anchor => 'e');
    $winBalloon->attach($buttonLoad,
			-balloonmsg => "Load File"
			);
    $buttonSelect=$cadreTop22->Button(-text => "Select Markup",
				      -image => $imageSelect,
				      -command => sub {&mkSelectionMarkup})->pack(-side => 'left',
										  -anchor => 'e');
    $winBalloon->attach($buttonSelect,
			-balloonmsg => "Select Markup"
			);
    $buttonExit=$cadreTop22->Button(-text => "Exit",
				    -image => $imageExit,
				    -command => sub{ConfirmExit2($texte)})->pack(-side => 'right');
    $winBalloon->attach($buttonExit,
			-balloonmsg => "Exit"
			);
    $buttonHelp=$cadreTop22->Button(-text => "Help",
				    -image => $imageHelp,
				    -command => sub {&command_help})->pack(-side => 'right',
						   -anchor => 'e');
    $winBalloon->attach($buttonHelp,
			-balloonmsg => "Help"
			);
##############################################################################
#	$Mbut_help = $mbar->Menubutton(relief => 'raised', 
#		text => "help",
#		underline => 0);
#	$Mbut_help->pack(-side => 'right');
#	$Mbut_help->command(-label => 'help', -command => \&command_help);
##############################################################################
#---------------------------------------------------------------------------------------
    splashProgress( "Initialising last bit. Nearly there...", 90 );
    sleep 1;
#---------------------------------------------------------------------------------------
    $buttonSave=$cadreTop22->Button(-text => "Save",
				    -image => $imageSave,
				    -command => sub {&sauve_fic})->pack(-side => 'right',
									-anchor => 'e');
    $winBalloon->attach($buttonSave,
			-balloonmsg => "Save This file"
			);
    $buttonText=$cadreTop22->Button(-text => "New",
				    -image => $imageText,
				    -command => sub{ConfirmEmptyDocument2($texte);})->pack(-side => 'right',
											   -anchor => 'e');
    $winBalloon->attach($buttonText,
			-balloonmsg => "New file"
			);
    $buttonScan=$cadreTop22->Button(-text => "Scan",
				    -image => $imageScan,
				    -command => sub{&scanner;})->pack(-side => 'right',
								      -anchor => 'e');
    $winBalloon->attach($buttonScan,
			-balloonmsg => "Scan Objets"
			);
##############################################################################
# Nettoyage fichiers temporaires
##############################################################################
#---------------------------------------------------------------------------------------
    splashProgress( "Cleaning...", 99 );
    sleep 1;
#---------------------------------------------------------------------------------------
    if (!opendir(DIR, $start_dir)) {
	&mkPrintErreur("ERREUR : can't open $start_dir for deleting TMP FILES : $!\n");
	return;
    }  
    my @files = readdir(DIR);
    closedir(DIR);
    foreach my $file (@files) {
	next if $file =~ /^\.\.?$/;
	if (-f $file) {
	    if (($file=~/^MKC-tmp.*\.txt$/)) {
		print $file," deleted\n";
		unlink($file) || &mkPrintErreur("ERREUR : having trouble deleting $file: $! \n");
	    }
	    if (($file=~/^MKC-tmp.*\.xml$/)) {
		print $file," deleted\n";
		unlink($file) || &mkPrintErreur("ERREUR : having trouble deleting $file: $! \n");
	    }
	}
    }
##############################################################################
## Remove splash and pop main window to top...
    $splash->destroy;
    $mw->deiconify;
    $mw->raise;
#---------------------------------------------------------------------------------------
##############################################################################

    MainLoop;

}
##############################################################################
##############################################################################
#---------------------------------------------------------------------------------------
#-- modif CM
# procedures supplementaires
#---------------------------------------------------------------------------------------
##############################################################################
##############################################################################

sub UpdateIndicators {
#    my ($texte) = @_;
    my (  $mode,
	  $line, $colon1,
	  $end, $colon2,
	  $top_visible, $bottom_visible, $percent );
    $file = $texte->FileName();
    $nom_fic = $file;
    if ( defined( $file )) {
	if ( $file =~ /([^\/\\]+)$/ ) {
	    $file = $1;
	}
    }
    else { $file = "Unregistered"; }
    $mode = "(Insert Mode)";
    if ( $texte->OverstrikeMode ) { $mode = "(Overstrike Mode)"; }
    ( $line, $colon1 ) = split( /\./, $texte->index( 'insert' ));
    ( $end, $colon2 ) = split( /\./, $texte->index( 'end' ));
    ( $top_visible, $bottom_visible ) = $texte->yview();
    $bottom_visible = int( $bottom_visible * $end );
    $percent = int( $bottom_visible*100/$end );
    return( $label->configure( -text => "--:** ".$file."\t\t".$mode."--L".
	    $line."--C".$colon1."--TL".$end."--(".$percent."%)"));
}
##############################################################################
#---------------------------------------------------------------------------------------
sub UpdateMenu {
    my ( $filemenu, $editmenu, $searchmenu, $markupmenu, $selection );
    $filemenu    = $menu->entrycget( 0, '-menu' );
    $editmenu    = $menu->entrycget( 1, '-menu' );
    $searchmenu  = $menu->entrycget( 2, '-menu' );
    $markupmenu  = $menu->entrycget( 3, '-menu' );
    if ( $texte->numberChanges ) {
	$filemenu->entryconfigure( 4, -state => 'normal' );
	$editmenu->entryconfigure( 0, -state => 'normal' );
	$group1[3]->configure( -state => 'normal' );
	$group2[0]->configure( -state => 'normal' );
    }
    else {
	$filemenu->entryconfigure( 4, -state => 'disabled' );
	$editmenu->entryconfigure( 0, -state => 'disabled' );
	$group1[3]->configure( -state => 'disabled' );
	$group2[0]->configure( -state => 'disabled' );
    }
    if ( $texte->SizeRedo ) {
	$editmenu->entryconfigure( 1, -state => 'normal' );
	$group2[1]->configure( -state => 'normal' );
    }
    else {
	$editmenu->entryconfigure( 1, -state => 'disabled' );
	$group2[1]->configure( -state => 'disabled' );
    }
    eval { $selection = $texte->SelectionGet( -selection=>"CLIPBOARD" );};
    unless ( $@ ) {
	$filemenu->entryconfigure( 6, -state => 'normal' );
	$editmenu->entryconfigure( 5, -state => 'normal' );
	$group1[4]->configure( -state => 'normal' );
	$group3[2]->configure( -state => 'normal' );
    }
    else {
	$filemenu->entryconfigure( 6, -state => 'disabled' );
	$editmenu->entryconfigure( 5, -state => 'disabled' );
	$group1[4]->configure( -state => 'disabled' );
	$group3[2]->configure( -state => 'disabled' );
    }
    if ( $texte->tagRanges( 'sel' )) {
	$editmenu->entryconfigure( 3, -state => 'normal' );
	$editmenu->entryconfigure( 4, -state => 'normal' );
	$editmenu->entryconfigure( 6, -state => 'normal' );
	$editmenu->entryconfigure( 9, -state => 'normal' );
	$searchmenu->entryconfigure( 1, -state => 'normal' );
	$searchmenu->entryconfigure( 2, -state => 'normal' );
	$group3[0]->configure( -state => 'normal' );
	$group3[1]->configure( -state => 'normal' );
	$group3[3]->configure( -state => 'normal' );
	$group4[1]->configure( -state => 'normal' );
    }
    else {
	$editmenu->entryconfigure( 3, -state => 'disabled' );
	$editmenu->entryconfigure( 4, -state => 'disabled' );
	$editmenu->entryconfigure( 6, -state => 'disabled' );
	$editmenu->entryconfigure( 9, -state => 'disabled' );
	$searchmenu->entryconfigure( 1, -state => 'disabled' );
	$searchmenu->entryconfigure( 2, -state => 'disabled' );
	$group3[0]->configure( -state => 'disabled' );
	$group3[1]->configure( -state => 'disabled' );
	$group3[3]->configure( -state => 'disabled' );
	$group4[1]->configure( -state => 'disabled' );
    }
    if ( $texte->getSafeMode ) {
	$markupmenu->entryconfigure( 11, -state => 'disabled' );
	$group5[4]->configure( -state => 'disabled' );
	if ($texte->index( 'insert' ) != $texte->getLastIndex ) {
	    $markupmenu->entryconfigure( 4, -state => 'disabled' );
	    $markupmenu->entryconfigure( 5, -state => 'disabled' );
	    $markupmenu->entryconfigure( 6, -state => 'disabled' );
	    $markupmenu->entryconfigure( 8, -state => 'disabled' );
	    $markupmenu->entryconfigure( 9, -state => 'disabled' );
	    $group5[3]->configure( -state => 'disabled' );
	}
	else {
	    if (! $texte->getXMLDecl ) {
		$markupmenu->entryconfigure( 4, -state => 'normal' );
	    }
	    if (! $texte->getDoctype ) {
		$markupmenu->entryconfigure( 5, -state => 'normal' );
	    }
	    $markupmenu->entryconfigure( 6, -state => 'normal' );
	    $markupmenu->entryconfigure( 8, -state => 'normal' );
	    $markupmenu->entryconfigure( 9, -state => 'normal' );
	    $group5[3]->configure( -state => 'normal' );
	}
	if ( $texte->FileName && $texte->FileName !~ /\.xml$/ ) {
	    $toolsmenu->entryconfigure( 3, -state => 'disabled' );
	    $group6[2]->configure( -state => 'disabled' );
	}
	else {
	    $toolsmenu->entryconfigure( 3, -state => 'normal' );
	    $group6[2]->configure( -state => 'normal' );
	}
    }

    else {
	$markupmenu->entryconfigure( 0, -state => 'normal' );
	$markupmenu->entryconfigure( 1, -state => 'normal' );
	$markupmenu->entryconfigure( 2, -state => 'normal' );
	$markupmenu->entryconfigure( 4, -state => 'normal' );
	$markupmenu->entryconfigure( 5, -state => 'normal' );
	$markupmenu->entryconfigure( 6, -state => 'normal' );
	$markupmenu->entryconfigure( 8, -state => 'normal' );
	$markupmenu->entryconfigure( 9, -state => 'normal' );
	$markupmenu->entryconfigure( 11,-state => 'normal' );
	$toolsmenu->entryconfigure( 3, -state => 'normal' );
	$group5[3]->configure( -state => 'normal' );
	$group5[4]->configure( -state => 'normal' );
	$group6[2]->configure( -state => 'normal' );
    }
}
##############################################################################
#---------------------------------------------------------------------------------------
sub HelpPopup {
    if (! Exists( $top2 )) {	
	$texte->tellStatusbar( "Showing the help window..." );
	$top2 = $mw->Toplevel( -title => 'Help' );
	my ( $window ) = $top2->Scrolled( 'ROText', -scrollbars => 'osoe',
					  -background => "#ffefffffe0c3",
					  -selectforeground => 'white',
					  -selectbackground => "#000070669645",
					  -height => 22, -width=> 70,
					  -wrap=> 'word' );
	my ( $menu ) = $top2->Menu();
	$window->tagConfigure( 'title', -justify=>'center',
			       -foreground=>'red' );
	$window->tagConfigure( 'blue', -foreground => 'blue' );
	$menu->Menubutton( -label => 'File',
			   -tearoff  => 0, -underline => 0,
			   -menuitems => [
			    ['command'  => '~General',
			     -command => sub { &GeneralHelp( $window );}],     
			    ['command' => '~Bindings',
			     -command => sub { &BindingsHelp( $window );}],
			    '-',
			    ['command' => '~Exit',
			     -command => sub {$top2->destroy();}]]);
	$menu->Menubutton( -label => 'View', -tearoff => 0, -underline=>0,
			   -menuitems =>[@{$window->ViewMenuItems}] );
	$top2->resizable( 0, 0 );
	$top2->configure( -menu => $menu );
	$window->bind( 'Tk::ROText', '<Button-3>', '' );
	$window->pack();
	&GeneralHelp ( $window );
	return( $texte->tellStatusbar( "'Help' window displayed." ));
    }
    return( 0 );
}
##############################################################################
#---------------------------------------------------------------------------------------
sub GeneralHelp {
    my ( $window ) = @_;
    $window->delete('1.0', 'end' );
    $window->insert( 'end', "DESCRIPTION EDXML Modules\n\n", 'title' );
    $window->insert( 'end', "\tModules TextTools and MarkupTools for edxml ", 'blue' );
    $window->insert( 'end', "edxml is a small editor providing routines for text manipulation, such as search and replacement tools and XML tags edition. Part of an E.N.S. Lyon project, " );
    $window->insert( 'end', "edxml ", 'blue' );
    $window->insert( 'end', "is intended to perform specific tasks upon linguistic corpora, consisting in the exploration of the formal proximity between enouncements, assisted tag placement, extraction, deletion and export of markup strings. The user can propose definitions for textual phenomena via the Perl regular expressions and then isolate and mark them with standard XML flags.\n\n\tFeatures of " );
    $window->insert( 'end', "edxml ", 'blue' );
    $window->insert( 'end', "include special characters matching. The module looks at the current cursor position and then tries to find the character pair that brackets the cursor. Characters that are searched for are: " );
    $window->insert( 'end', "<> () {} [] \"\"", 'blue' );
    $window->insert( 'end', ". It also checks the position of these pairs and try to highlight bad positions. If the character couples are not on the same line or not in the same column, then there might be a missing parenthesis somewhere. Characters that appear to not align are highlighted in red.\n\n\t" );
    $window->insert( 'end', "edxml ", 'blue' );
    $window->insert( 'end', "is free software. Please see the license terms for information on its use and redistribution, and for a DISCLAIMER OF ALL WARRANTIES.\n\n" );
    $window->insert( 'end', "MODULES AND USE\n\n", 'title' );
    $window->insert( 'end', "\tedxml ", 'blue' );
    $window->insert( 'end', "has the structure of a traditional text editor: a main window, a buffer for edits, menus and buttons. The tasks to perform upon the loaded file are activated through the menus or the buttons which are shortcuts for some of the routines already listed in the menus.\n\n\t" );
    $window->insert( 'end', "The File menu\n\n\tNew ", 'blue' );
    $window->insert( 'end', ": loads a new file. This file may be registered with the " );
    $window->insert( 'end', "Save", 'blue' );
    $window->insert( 'end', ", " );
    $window->insert( 'end', "Save As ", 'blue' );
    $window->insert( 'end', "commands.\n\t" );
    $window->insert( 'end', "Open ", 'blue' );
    $window->insert( 'end', ": calls a dialog box for the selection of an existing file.\n\t");
    $window->insert( 'end', "Include ", 'blue' );
    $window->insert( 'end', ": inserts the contents of an external file
 at the cursor point, without deleting the \"undo\" information of the current file.\n\t" );
    $window->insert( 'end', "Save ", 'blue' );
    $window->insert( 'end', ": saves edits by calling a dialog box if the document was not registered.\n\t" );
    $window->insert( 'end', "Save As ", 'blue' );
    $window->insert( 'end', ": saves the loaded file by calling a dialog box providing the possibility of changing the file name.\n\t" );
    $window->insert( 'end', "Export ", 'blue' );
    $window->insert( 'end', ": exports the clipboard selection to a file, selected with a dialog box. Before using this option, you have to copy the primary selection of the buffer to the clipboard. You may export several selections to a file ( the ancient exports will not be deleted ).\n\t" );
    $window->insert( 'end', "Exit ", 'blue' );
    $window->insert( 'end', ": closes the application.\n\n\t" );
    $window->insert( 'end', "The Edit menu\n\n\t", 'blue' );
    $window->insert( 'end', "Undo ", 'blue' );
    $window->insert( 'end', ": undoes the last action.\n\t" );
    $window->insert( 'end', "Redo ", 'blue' );
    $window->insert( 'end', ": re-makes edits step by step.\n\t" );
    $window->insert( 'end', "Cut ", 'blue' );
    $window->insert( 'end', ": deletes the primary selection of the buffer and pushes its contents in the clipboard.\n\t" );
    $window->insert( 'end', "Copy ", 'blue' );
    $window->insert( 'end', ": copies the primary selection of the buffer to the clipboard.\n\t" );
    $window->insert( 'end', "Paste ", 'blue' );
    $window->insert( 'end', ": inserts the clipboard selection into the buffer, at the cursor point.\n\t" );
    $window->insert( 'end', "Clear ", 'blue' );
    $window->insert( 'end', ": deletes the primary selection of the buffer.\n\t" );
    $window->insert( 'end', "Select All ", 'blue' );
    $window->insert( 'end', ": marks all the lines of the buffer as a primary selection.\n\t" );
    $window->insert( 'end', "Unselect All ", 'blue' );
    $window->insert( 'end', ": clears all the selected regions of the buffer.\n\n\t" );
    $window->insert( 'end', "The Search menu\n\n\t", 'blue' );
    $window->insert( 'end', "Find ", 'blue' );
    $window->insert( 'end', ": searches for a given string in the buffer. Arguments such as \"direction\", \"case\" and \"mode\" may be controlled. The '-regexp' mode is the most important argument for this program. It offers all the power of the Perl regular expressions, including the backup references. The search may be global.\n\t" );
    $window->insert( 'end', "Find Next ", 'blue' );
    $window->insert( 'end', ": searches '-forward' for the selected string in the application and stops after the first occurrence of the motif found.\n\t" );
    $window->insert( 'end', "Find Previous ", 'blue' );
    $window->insert( 'end', ": searches '-backward' for the selected string in the application and stops after the first occurrence of the motif found.\n\t" );
    $window->insert( 'end', "Replace ", 'blue' );
    $window->insert( 'end', ": searches for a given string in the buffer and replace its instances with another string. The search has the same controllable arguments as described for the Find option and may be global.\n\n\t" );
    $window->insert( 'end', "The Markup menu\n\n\t", 'blue' );
    $window->insert( 'end', "This menu refers to the manipulation of the standard XML tags. The formal representation for these tags is \"<[^>]+>\". There are two edit modes for the XML documents: an assisted mode, through the interface provided by this menu, and a manual mode. During the non-assisted manipulation of the buffer, the syntax corrector and other facilities will be desactivated. If you want to return to the assisted mode while working in safe mode, you should just press the " );
    $window->insert( 'end', "<F5> ", 'blue' );
    $window->insert( 'end', "key which will reset the XML indicators and indent the selected line.\n\n\t" );
    $window->insert( 'end', "Display Tag Area ", 'blue' );
    $window->insert( 'end', ": searches for text areas marked with the given tag in the buffer. The search may be global.\n\t" );
    $window->insert( 'end', "Delete Tag Area ", 'blue' );
    $window->insert( 'end', ": searches for text areas marked with the given tag in the buffer and deletes them. The deletion may be global for one tag.\n\t" );
    $window->insert( 'end', "Remove Markups ", 'blue' );
    $window->insert( 'end', ": removes all the tags from the buffer.\n\t" );
    $window->insert( 'end', "XML Declaration ", 'blue' );
    $window->insert( 'end', ": checks the edits for XML syntax and inserts an XML declaration at the cursor point.\n\t" );
    $window->insert( 'end', "Document Type ", 'blue' );
    $window->insert( 'end', ": checks the edits for XML syntax and inserts a Document type declaration at the cursor point.\n\t" );
    $window->insert( 'end', "Insert Comment ", 'blue' );
    $window->insert( 'end', ": inserts an XML comment at the cursor point.\n\t" );
    $window->insert( 'end', "Write Tag ", 'blue' );
    $window->insert( 'end', ": pops up a tag write dialog, then inserts the collected informations, if checked OK, as a start tag, an empty tag or an end tag, at the cursor position .\n\t" );
    $window->insert( 'end', "Insert Text ", 'blue' );
    $window->insert( 'end', ": inserts a text string at the cursor point.\n\t" );
    $window->insert( 'end', "Markup Selections ", 'blue' );
    $window->insert( 'end', ": takes a motif and search for its instances in the buffer. There are three controllable arguments : \"direction\", \"mode\" and \"case\". Then, if a tag name is provided, the routine will mark the selections with the given tag. This menu entry can be used only if the \"Unsafe Mode\" is checked in the options.\n\n\t" );
    $window->insert( 'end', "The Tools menu\n\n\t", 'blue' );
    $window->insert( 'end', "Show Index ", 'blue' );
    $window->insert( 'end', ": pops up a top level with a list widget and a menu. The menu provides entries commanding the extraction of all the lexical forms from the loaded file or the listing of the tag names, attributes, values and  comments from an XML document.\n\t" );
    $window->insert( 'end', "Proximity ", 'blue' );
    $window->insert( 'end', ": pops up a control top level for routines that calculate the formal distances between enouncements. The delimiters are \".!?\". A score is made with the common atoms ( forms, bigrams ) of two enouncements and and the specific atoms of each enouncement. You can structure the corpus by placing in the buffer a special tag \"key\", of the type " );
    $window->insert( 'end', "<key string=\"value\"> ", 'blue' );
    $window->insert( 'end', "and then specify \"string\" as an argument, in order to avoid too many iterations.\n\t" );
    $window->insert( 'end', "XML Parser ", 'blue' );
    $window->insert( 'end', ": pops up a top level with a read-only text widget which can display parsed contents. It provides a menu with entries controlling the text wrap and the closure of the XML objects according to the requested depth.\n\n\t" );
    $window->insert( 'end', "The View menu\n\n\t", 'blue' );  
    $window->insert( 'end', "Goto Line ", 'blue' );
    $window->insert( 'end', ": moves the cursor to the line number.\n\t" );
    $window->insert( 'end', "Wrap ", 'blue' );
    $window->insert( 'end', ": controls the line wrap.\n\t" );
    $window->insert( 'end', "Preferences ", 'blue' );
    $window->insert( 'end', ": shows the controls for the edit modes and the general configuration of the application.\n\n\t" );
    $window->insert( 'end', "The Help menu\n\n\t", 'blue' );
    $window->insert( 'end', "Help ", 'blue' );
    $window->insert( 'end', ": pops up a help window which can display these contents.\n\t" );
    $window->insert( 'end', "License ", 'blue' );
    $window->insert( 'end', ": pops up a read-only text widget displaying the license of " );
    $window->insert( 'end', "edxml", 'blue' );
    $window->insert( 'end', ".\n\t" );
    $window->insert( 'end', "About edxml ", 'blue' );
    $window->insert( 'end', ": pops up the front page of " );
    $window->insert( 'end', "edxml", 'blue' );
    $window->insert( 'end', ".\n\n" );
}
##############################################################################
#---------------------------------------------------------------------------------------
sub BindingsHelp {
    my ( $window ) = @_;
    $window->delete( '1.0', 'end' );
    $window->insert( 'end', "MOUSE BINDINGS\n\n", 'title' );
    $window->insert( 'end', "\tClicking mouse button 1 positions the insertion cursor just before the character underneath the mouse cursor, sets the input focus to this widget, and clears any selection in the widget. Dragging with mouse button 1 strokes out a selection between the insertion cursor and the character under the mouse.

\tDouble-clicking with mouse button 1 selects the word under the mouse and positions the insertion cursor at the beginning of the word. Dragging after a double click will stroke out a selection consisting of whole words.

\tTriple-clicking with mouse button 1 selects the line under the mouse and positions the insertion cursor at the beginning of the line. Dragging after a triple click will stroke out a selection consisting of whole lines.

\tThe ends of the selection can be adjusted by dragging with mouse button 1 while the " );
    $window->insert( 'end', "<Shift> ", 'blue' );
    $window->insert( 'end', "key is down;  this will adjust the end of the selection that was nearest to the mouse cursor when button 1 was pressed. If the button is double-clicked before dragging then the selection will be adjusted in units of whole words;  if it is triple-clicked then the selection will be adjusted in units of whole lines.

\tClicking mouse button 1 with the " );
    $window->insert( 'end', "<Control> ", 'blue' );
    $window->insert( 'end', "key down will reposition the insertion cursor without affecting the selection.

\tIf any normal printing characters are typed, they are inserted at the point of the insertion cursor.

\tThe view in the widget can be adjusted by dragging with mouse button 2. If mouse button 2 is clicked without moving the mouse, the selection is copied into the text at the position of the mouse cursor. The " );
    $window->insert( 'end', "<Insert> ", 'blue' );
    $window->insert( 'end', "key also inserts the selection, but at the position of the insertion cursor.

\tIf the mouse is dragged out of the widget while button 1 is pressed, the entry will automatically scroll to make more text visible ( if there is more text off-screen on the side where the mouse left the window ).\n\n" );
    
    $window->insert( 'end', "KEYBOARD BINDINGS\n\n", 'title' );
    $window->insert( 'end', "\tThe " );
    $window->insert( 'end', "<Left> ", 'blue' );
    $window->insert( 'end', "and " );
    $window->insert( 'end', "<Right> ", 'blue' );
    $window->insert( 'end', "keys move the insertion cursor one character to the left or right;  they also clear any selection in the text. If " );
    $window->insert( 'end', "<Left> ", 'blue' );
    $window->insert( 'end', "or " );
    $window->insert( 'end', "<Right> ", 'blue' );
    $window->insert( 'end', "is typed with the " );
    $window->insert( 'end', "<Shift> ", 'blue' );
    $window->insert( 'end', "key down, then the insertion cursor moves and the selection is extended to include the new character. " );
    $window->insert( 'end', "<Control-Left> ", 'blue' );
    $window->insert( 'end', "and " );
    $window->insert( 'end', "<Control-Right> ", 'blue' );
    $window->insert( 'end', "move the insertion cursor by words, and " );
    $window->insert( 'end', "<Control-Shift-Left> ", 'blue' );
    $window->insert( 'end', "and " );
    $window->insert( 'end', "<Control-Shift-Right> ", 'blue' );
    $window->insert( 'end', "move the insertion cursor by words and also extend the selection. " );
    $window->insert( 'end', "<Meta-b> ", 'blue' );
    $window->insert( 'end', "and " );
    $window->insert( 'end', "<Meta-f> ", 'blue' );
    $window->insert( 'end', "behave the same as " );
    $window->insert( 'end', "<Control-Left> ", 'blue' );
    $window->insert( 'end', "and " );
    $window->insert( 'end', "<Control-Right>", 'blue' );
    $window->insert( 'end', ", respectively.\n\n" );
    $window->insert( 'end', "\tThe " );
    $window->insert( 'end', "<Up> ", 'blue' );
    $window->insert( 'end', "and " );
    $window->insert( 'end', "<Down> ", 'blue' );
    $window->insert( 'end', "keys move the insertion cursor one line up or down and clear any selection in the text. If " );
    $window->insert( 'end', "<Up> ", 'blue' );
    $window->insert( 'end', "or " );
    $window->insert( 'end', "<Right> ", 'blue' );
    $window->insert( 'end', "is typed with the " );
    $window->insert( 'end', "<Shift> ", 'blue' );
    $window->insert( 'end', "key down, then the insertion cursor moves and the selection is extended to include the new character. " );
    $window->insert( 'end', "<Control-Up> ", 'blue' );
    $window->insert( 'end', "and " );
    $window->insert( 'end', "<Control-Down> ", 'blue' );
    $window->insert( 'end', "move the insertion cursor by paragraphs (lines separated by blank lines), and " );
    $window->insert( 'end', "<Control-Shift-Up> ", 'blue' );
    $window->insert( 'end', "and " );
    $window->insert( 'end', "<Control-Shift-Down> ", 'blue' );
    $window->insert( 'end', "move the insertion cursor by paragraphs and also extend the selection.\n\n\tThe " );
    $window->insert( 'end', "<Next> ", 'blue' );
    $window->insert( 'end', "and " );
    $window->insert( 'end', "<Prior> ", 'blue' );
    $window->insert( 'end', "keys move the insertion cursor forward or backwards by one screenful and clear any selection in the text. If the " );
    $window->insert( 'end', "<Shift> ", 'blue' );
    $window->insert( 'end', "key is held down while Next or Prior is typed, then the selection is extended to include the new character. " );
    $window->insert( 'end', "<Control-v> ", 'blue' );
    $window->insert( 'end', "moves the view down one screenful without moving the insertion cursor or adjusting the selection.\n\n\t" );
    $window->insert( 'end', "<Control-Next> ", 'blue' );
    $window->insert( 'end', "and " );
    $window->insert( 'end', "<Control-Prior> ", 'blue' );
    $window->insert( 'end', "scroll the view right or left by one page without moving the insertion cursor or affecting the selection.\n\n\t" );
    $window->insert( 'end', "<Home> ", 'blue' );
    $window->insert( 'end', "moves the insertion cursor to the beginning of its line and clear any selection in the widget. " );
    $window->insert( 'end', "<Shift-Home> ", 'blue' );
    $window->insert( 'end', "moves the insertion cursor to the beginning of the line and also extends the selection to that point.\n\n\t" );
    $window->insert( 'end', "<End> ", 'blue' );
    $window->insert( 'end', "moves the insertion cursor to the end of the line and clear any selection in the widget. " );
    $window->insert( 'end', "<Shift-End> ", 'blue' );
    $window->insert( 'end', "moves the cursor to the end of the line and extends the selection to that point.\n" );
    
    $window->insert( 'end', "<Control-Home> ", 'blue' );
    $window->insert( 'end', "and " );
    $window->insert( 'end', "<Meta-<> ", 'blue' );
    $window->insert( 'end', "move the insertion cursor to the beginning of the text and clear any selection in the widget. " );
    $window->insert( 'end', "<Control-Shift-Home> ", 'blue' );
    $window->insert( 'end', "moves the insertion cursor to the beginning of the text and also extends the selection to that point.\n\n\t" );
    $window->insert( 'end', "<Control-End> ", 'blue' );
    $window->insert( 'end', "and " );
    $window->insert( 'end', "<Meta->> ", 'blue' );
    $window->insert( 'end', "move the insertion cursor to the end of the text and clear any selection in the widget. " );
    $window->insert( 'end', "<Control-Shift-End> ", 'blue' );
    $window->insert( 'end', "moves the cursor to the end of the text and extends the selection to that point.\n\n\tThe " );
    $window->insert( 'end', "<Select> ", 'blue' );
    $window->insert( 'end', "key and " );
    $window->insert( 'end', "<Control-Space> ", 'blue' );
    $window->insert( 'end', "set the selection anchor to the position of the insertion cursor. They don't affect the current selection. " );
    $window->insert( 'end', "<Shift-Select> " );
    $window->insert( 'end', "and " );
    $window->insert( 'end', "<Control-Shift-Space> ", 'blue' );
    $window->insert( 'end', "adjust the selection to the current position of the insertion cursor, selecting from the anchor to the insertion cursor if there was not any selection previously.\n\n\t" );
    $window->insert( 'end', "<Control-n> ", 'blue' );
    $window->insert( 'end', "opens a new file.\n\t" );
    $window->insert( 'end', "<Control-s> ", 'blue' );
    $window->insert( 'end', "saves the loaded file.\n\t" );
    $window->insert( 'end', "<Control-e> ", 'blue' );
    $window->insert( 'end', "exports the clipboard to the selected file (preserving its contents, if any).\n\t" );
    $window->insert( 'end', "<Control-/> ", 'blue' );
    $window->insert( 'end', "selects the entire contents of the widget.\n\n\t" );
    $window->insert( 'end', "<Control-\\> ", 'blue' );
    $window->insert( 'end', " clears any selection in the widget.\n\n\t" );  
    $window->insert( 'end', "<F5> ", 'blue' );
    $window->insert( 'end', "updates the XML indicators and indents the selected line.\n\t" );
    $window->insert( 'end', "<F6> ", 'blue' );
    $window->insert( 'end', "calls the control top level for the routines that calculate the formal proximity between enouncements.\n\t" );
    $window->insert( 'end', "<F7> ", 'blue' );
    $window->insert( 'end', "pops up the XML index.\n\t" );
    $window->insert( 'end', "The " );
    $window->insert( 'end', "<F8> ", 'blue' );
    $window->insert( 'end', "key calls the XML parser.\n\t" );
    $window->insert( 'end', "The " );
    $window->insert( 'end', "<F16> ", 'blue' );
    $window->insert( 'end', "key (labeled Copy on many Sun workstations) or " );
    $window->insert( 'end', "<F1>", 'blue' );
    $window->insert( 'end', ", or " );
    $window->insert( 'end', "<Meta-w> ", 'blue' );
    $window->insert( 'end', "copies the selection in the widget to the clipboard, if there is a selection.\n\n\t" );
    $window->insert( 'end', "The " );
    $window->insert( 'end', "<F20> ", 'blue' );
    $window->insert( 'end', "key (labeled Cut on many Sun workstations) or " );
    $window->insert( 'end', "<F2>", 'blue' );
    $window->insert( 'end', ", or " );
    $window->insert( 'end', "<Control-w> ", 'blue' );
    $window->insert( 'end', "copies the selection in the widget to the clipboard and deletes the selection. If there is no selection in the widget then these keys have no effect.\n\n\t" );
    $window->insert( 'end', "The " );
    $window->insert( 'end', "<F18> ", 'blue' );
    $window->insert( 'end', "key (labeled Paste on many Sun workstations) or " );
    $window->insert( 'end', "<F3>", 'blue' );
    $window->insert( 'end', ", or " );
    $window->insert( 'end', "<Control-y> ", 'blue' );
    $window->insert( 'end', "inserts the contents of the clipboard at the position of the insertion cursor.\n\n\t" );
    $window->insert( 'end', "<Control-f> ", 'blue' );
    $window->insert( 'end', "calls the search dialog.\n\t" );
    $window->insert( 'end', "<Control-r> ", 'blue' );
    $window->insert( 'end', "calls the replacement dialog.\n\t" );
    $window->insert( 'end', "<Control-m> ", 'blue' );
    $window->insert( 'end', "calls the markup dialog.\n\t" );
    $window->insert( 'end', "<Control-t> ", 'blue' );
    $window->insert( 'end', "calls the tag write dialog.\n\t" );
    $window->insert( 'end', "<Control-h> ", 'blue' );
    $window->insert( 'end', "pops up the help top level.\n\n\t" );
    $window->insert( 'end', "The " );
    $window->insert( 'end', "<Delete> ", 'blue' );
    $window->insert( 'end', "key deletes the selection, if there is one in the widget. If there is no selection, it deletes the character to the right of the insertion cursor.\n\n\t" );
    $window->insert( 'end', "<Backspace> ", 'blue' );
    $window->insert( 'end', "deletes the selection, if there is one in the widget. If there is no selection, then deletes the character to the left of the insertion cursor.\n\t" );
    $window->insert( 'end', "<Control-d> ", 'blue' );
    $window->insert( 'end', "deletes the character to the right of the insertion cursor.\n\t" );
    $window->insert( 'end', "<Meta-d> ", 'blue' );
    $window->insert( 'end', "deletes the word to the right of the insertion cursor.\n\t" );
    $window->insert( 'end', "<Control-k> ", 'blue' );
    $window->insert( 'end', "deletes everything from the insertion cursor to the end of the line; if the insertion cursor is already at the end of a line, then " );
    $window->insert( 'end', "<Control-k> ", 'blue' );
    $window->insert( 'end', "deletes the newline character.\n\t" );
    $window->insert( 'end', "<Control-o> ", 'blue' );
    $window->insert( 'end', "opens a new line by inserting a newline character in front of the insertion cursor without moving the insertion cursor.\n\t" );
    $window->insert( 'end', "<Meta-backspace> ", 'blue' );
    $window->insert( 'end', "and " );
    $window->insert( 'end', "<Meta-Delete> ", 'blue' );
    $window->insert( 'end', "delete the word to the left of the insertion cursor.\n\n\t" );
    $window->insert( 'end', "<Control-x> ", 'blue' );
    $window->insert( 'end', "deletes whatever is selected in the text widget.\n\t" );
    $window->insert( 'end', "Pressing " );    
    $window->insert( 'end', "<L4> ", 'blue' );
    $window->insert( 'end', "several times undoes step by step the changes made to the text widget.\n\n\t" );
}
##############################################################################
#---------------------------------------------------------------------------------------
sub splashProgress {
   my ($text, $pct) = @_;
   $progressText = $text;
   $pctComplete = $pct;
#   $splash->Animation->start_animation(80);
   ## Hourglass cursor...
   $splash->Busy(-recurse => 1);
   ## Pop to top (if not! can be annoying tho')...
   $splash->raise;
   $splash->update;
}
#---------------------------------------------------------------------------------------
##############################################################################
##############################################################################

1;
