package SHTML;

use strict;
use vars qw/@ISA @EXPORT/;
require Exporter;
@ISA = 'Exporter';
@EXPORT = qw (striptohtml
              decipher_url
              expand_path);

sub striptohtml
{
    ($_) = @_;
    s/\n//g;
    s/\t//g;
    s/\s\s+/ /g;
    s/\</\n\</sg;
    s/\>/\>\n/sg;
    return($_);
}

sub decipher_url
{
    my ($url) = @_;
    my ($matched, $protocol, $host, $path);
    my ($user, $password, $machine, $port);

    $matched = $url =~ m#(\S+)://([^/ ]+)(.*)#;

    return unless($matched);
    
    $protocol = $1;
    $host = $2;
    $path = $3;
    
    $user = 'anonymous';
    $password = 'me@foo.bar';
    
    $_ = $host;
    
    if (m#(\S+):(\d+)#)
    {
	$_ = $1;
	$port = $2;
    }
    if (m#(\S+):(\S+)@(\S+)#)
    {
	$user = $1;
	$password = $2;
	$machine = $3;
    }
    elsif (m#(\S+)@(\S+)#)
    {
	$user = $1;
	$machine = $2;
    }
    else
    {
	$machine = $host;
    }
    return($protocol, $user, $password, $machine, $port, $path);
}

sub expand_path 
{
    my ($old) = @_;
    local (*_, *dir);
    $old =~ s#^#/# unless $old =~ m#^/#;
    my @dir = split(/\//, $old);
    shift(@dir);
    $_ = '';
    foreach my $dir (@dir) 
    {
        next if $dir eq '.';
        if ($dir eq '..') 
        {
            s#/[^/]+$##;
            next;
        }
        $_ .= '/' . $dir;
        while (my $r = readlink) 
        {
            if ($r =~ m#^/#) 
            {
                $_ = &expand_path($r);
                s#^/tmp_mnt## && next dir;
            } 
            else 
            { 
                s#[^/]+$#$r#;
                $_ = &expand_path($_);
            }
        }
    }
    ($_ eq '') ? '/' : $_;
}

1;
