#!/usr/local/bin/perl5

use LWP::UserAgent;
use HTML::LinkExtor;
use URI::URL;
use Getopt::Std;

my (%fullurl,$opt_d);

getopts('d');

unless (@ARGV)
{
    die "Usage: chkrhtml.pl [-d] url\n\n";
}

my $url = $ARGV[0];
print "Checking Website $url\n" if $opt_d;

my $ua = new LWP::UserAgent;
my @urlstack = ();
my @urls = ($url);
my $p = HTML::LinkExtor->new(\&callback);

my $res = $ua->request(HTTP::Request->new(GET => $url),
                    sub {$p->parse($_[0])});

die "Couldn't open $url\n" unless ($res->status_line eq '200 OK');

my $base = $res->base;
$fullurl{$base} = 1;
@urls = map { $_ = url($_, $base)->abs; } @urls;

addtostack($base,@urls);

while ($url = pop(@urlstack))
{
    print "Checking URL $url\n" if $opt_d;
    $res = $ua->request(HTTP::Request->new(GET => $url),
			sub {$p->parse($_[0])});

    unless ($res->status_line eq '200 OK')
    {
         print("Couldn't open $url (", 
               $res->status_line,
               ")\n   from: $fullurl{$url}\n");
         next;
    }
    @urls = map { $_ = url($_, $base)->abs; } @urls;
    addtostack($url,@urls);
}

sub addtostack
{
    my ($refurl, @urllist) = @_;

    for my $url (@urllist)
    {
	next unless($url =~ /^$base/);
	push(@urlstack,$url) unless(defined($fullurl{$url}));
	$fullurl{$url} = $refurl;
    }
}

sub callback 
{
   my($tag, %attr) = @_;
   push(@urls, values %attr);
}


