package winFunc1;
##############################################################################
#AUTHORS: 	Fleury Serge
#VERSION: 	1.0.4
#email:		serge.fleury@univ-paris3.fr
#url:		http://www.cavi.univ-paris3.fr/ilpga/ilpga/sfleury/mkcorpusProject.htm
#date:		mars/2003
#FILE:
#    This file is part of MKCorpus.
##############################################################################
#
# winFunc1.pm
#
# [mkcorpus] Callback-functions for all windows
#

#-------
# Export

use strict;
use Exporter;
use vars qw(@ISA @EXPORT $Conjonctions $Verbes $Pronoms $Adverbes
	    $Prepositions $Determinants $MotsProblemes $NomsPropres
	    $Ponctuations $MotsAEnlever $texteMp
	    $infile $file $tmplinepreptxt $sent @files 
	    %listeBaliseXmlLexico %listeBaliseXml 
	    %compteurBaliseXmlLexico %compteurBaliseXml
);
@ISA = qw(Exporter);
@EXPORT = qw(&UpdateIndicators2 &updateMarkupWindow &showParser &tagtextsearch &textintag &transcodeurTk &browser_ie 
	     &help_word2lexico &help_word2xml &word2lexico &word2xml &processSablotron &processXT  &processXT2 &processXMLXSLT
	     &tksm &query_dir_tidyClean &query_dir_tidyClean1  &help_tidyClean1 &help_tidyClean  
	     &addTagInTextNode &iaddTagInTextNode &helpaddTagInTextNode &extractRegion &findTypes 
	     &webfix &helpwebfix &parcourirWithDOM  &mots2BigramUniques 
	     &bigrammesUniques2Distance &DistanceEntreBigrammes &help_bigramChar 
	     &help_lexico4 &help_lexico5 &help_lexico6  &makeIndex &mots2Distance 
	     &ConfirmDiscard2 &ConfirmEmptyDocument2 &ConfirmExit2 &ConfirmNewDocument 
	     &FileLoadPopup &GetCWD &IncludedFileInWindow  &addtostack &alceste1 
	     &alceste2 &aname1  &aname2  &aname3  &applyChangeInTableCharacter1 
	     &applyChangeInTableCharacter2 &attach_selected_fic&author1  &author2  
	     &author3  &bystruct&callback &changeAsciiInText &changeCharInText 
	     &changeUnrocognizedCharInText &char_handler &char_handler1 &char_handler2 
	     &char_handler3 &char_handlerEventXML &code1  &code2  &code3  &collocate 
	     &command_help &helpPackage &helpPod2txt &browser1 &browser2 &comments 
	     &concordanceFormat &concordance_Asciichar &concordance_Unrochognizedchar 
	     &concordance_char &cordial &cordial2 &cordial2Lexico &cordial2Lexico2 
	     &cordial2xml &help_cordial2xml &create_ui &del_balise &delete_selected_Unrochognizedchar 
	     &delete_selected_ascii &delete_selected_balise &delete_selected_baliseXML 
	     &delete_selected_baliseXMLwithDOM &delete_selected_baliseXMLwithDOM1 
	     &delete_selected_baliseXMLLexico &delete_selected_baliseXMLLexico2 
	     &delete_selected_char &description1  &description2  &description3  
	     &displayTagSquare &drawText &dump_grove &email1  &email2  &email3  
	     &end_handler &end_handlerEventXML &eventXML &extracElementXML &extract_balise 
	     &extract_balise_oneline &extract_balise_oneline2 &extract_tagbalise 
	     &extract_tagtext_in_balise  &extract_text_in_balise &extract_text_in_balisewithDOM 
	     &extract_text_in_balisewithDOM1 &extract_text_in_baliseXML &extract_text_in_baliseXMLLexico 
	     &extract_text_in_baliseXMLLexico2 &fileDialog &fileDialog2 &fill_list &find_more &get_name 
	     &getfile &head1  &head2  &head3  &help_cordial &html0 &html1 &html2 &i_replace &i_replace2 
	     &i_search &i_search2 &i_search2_2 &i_search_2 &lexico1 &lexico2 &lexico3 &lexico4 &lexico5 
	     &lexico6 &lineid &lire_fic &list1  &list2  &list3  &list_balise &loadMirroring 
	     &loadMirroringPage &loadMkStatXML &loadMktipo &loadUploading &loadWget &load_selected_fic 
	     &loadwebxref &loadwebxref2 &loadwebxref22 &loadwebxref222 &loadwebxrefOneDir 
	     &sensnetXref1 &sensnetXref2 &sensnetXref3 &sensnetXref4 &sensnetXref5 &sensnetXref6
	     &makeTextToMap &make_text2map &make_text2map2 &makestat1 &maketagmap &maketreetagmap &maketreetagmap_libxml
	     &mkBigramWord &mkTrigramWord  &mkCollocate &mkConcordance &mkConcordanceOneWord 
	     &mkConcordanceOneWord2 &mkFourgramWord &mkPrepHtml2txtOneDir &mkPrepHtml2txtOneFile 
	     &mkSelectionXMLMarkupWithDOM &mkSelectionXMLMarkupWithDOM1 &mkSelectionMarkup 
	     &mkSelectionXMLLexicoMarkup &mkSelectionXMLLexicoMarkup2 &mkSelectionXMLMarkup 
	     &mkWaitBox &mkWordCount &mkXWord &mkdirhier &mktipo1 &mkIndisponible &mkPrintErreur 
	     &mkPrintMsgInfo &modify_selected_Unrochognizedchar &modify_selected_ascii 
	     &modify_selected_balise &modify_selected_baliseXML &modify_selected_baliseXMLwithDOM 
	     &modify_selected_baliseXMLwithDOM &modify_selected_baliseXMLLexico &modify_selected_baliseXMLLexico2 
	     &modify_selected_char &name1  &name2  &name3  &new_fic &numerically  &open_dir &parseDTD 
	     &parseXML &perl2html &preptxt &preptxt2 &printEltAsTextWithDOM &printTextEltWithDOM 
	     &renameTAGXML &addIDOnTAG  &xmlDomExtractTag &xmlDomExtractTag1 &xmlDomExtractTagWithSearchString 
	     &process_nodexmlDomExtractTag &process_nodeEltAsTextWithDOM &process_nodeTextEltWithDOM  
	     &print_list_balise  &process_node1  &process_node1b  &process_node2  &process_node2b  
	     &process_node3  &process_node3b  &ps2html &query_file_dialog &query_file_dialog2 
	     &query_file_dialog3 &query_dir_makestat1 &query_dir_mktipo &query_dir_prepOneDir 
	     &query_dir_webxref &query_dir_webxref2 &query_dir_webxref22 &query_dir_webxref222 
	     &query_loadMirroring &query_loadPageMirroring &query_replace &query_search_replace 
	     &query_search_text_in_balise &query_uploading &query_wget &readCharInText &read_text_forStat  
	     &removeWaitBox &remove_mark_search_map &remove_search &remove_search_map &replace 
	     &rtf2html  &sauve_fic &scanner &scanner1 &searchInTagMap &search_balise &search_in_fic 
	     &search_in_fic_2 &search_replace &search_tag_in_map &search_tag_in_map2 &see_also1  
	     &see_also2  &see_also3  &select_document &sendfile &set_minlev &sgml1 &sgml2 
	     &showtab &start_handler &start_handler1 &start_handler2 &start_handler3 
	     &start_handlerEventXML &start_handlerLexico &start_move &statFile 
	     &concatFile2lexico &concatFile2xml &help_concatFile &end_move &get_corners 
	     &liste_alltag_map &move_items &remove_mark_search &xmlComment &synopsis1  
	     &synopsis2  &synopsis3  &text1  &text2  &text3  &text_balise &text_delete 
	     &text_replace &text_search &text_toggle &translate &trim  &trt_en_cours 
	     &trt_fini &txt2html &typwebExtractTagHTML &typwebExtractTxtBrut 
	     &typwebMkListBalise &usageUploading &viewAndSelectDir &webxref1 &webxref11 &webxref11Lynx  
	     &webxref111 &webxref1111 &webxref2 &webxref22 &webxref22Lynx &webxref222 &webxref2222 
	     &xml1 &xml2 &xml3 &xmlConverter1 &xmlConverter2 &xmlConverter3 &xmlConverter4 &xmlGroveTool1  
	     &xmlMkListBalise  &xmlStat &xmlViewver &xmlViewver_2 &xmlXpath &xmlXpath1 &xmlXpath2 &xmlXpath3 
	     &xmlXpath4 &help_xmlXpath  &startaddIDOnTAG &endaddIDOnTAG &charaddIDOnTAG &escapeaddIDOnTAG  
	     &startrenameTAGXML &endrenameTAGXML &charrenameTAGXML &escaperenameTAGXML &makeXMLCorpusTypweb 
	     &makeMatrice &makeMatrice2 &makeMatriceLinks &makeCorpusTAG &helpmakeMatrice &helpmakeCorpusTAG 
	     &helpmakeMatriceLinks &helpwebxref &helptypweb &webxrefOneDir &webxrefOneDirLynx 
	     &query_dir_makeMatriceLinks &loadmakeMatriceLinks &query_dir_makeCorpusTAG 
	     &loadmakeCorpusTAG &query_dir_makeXMLCorpusTypweb &loadmakeXMLCorpusTypweb  
	     &query_dir_makeMatrice &loadmakeMatrice &query_dir_makeMatrice2 &loadmakeMatrice2 &decanteur
	     &mkCollocations &directory2xml &pdf2xml &pdf2html &collocInXPath
	     &randSelectFile &help_randSelectFile &concat2xmlrandSelectFile &statxmlnode
	     &processLibXSLT 
	     );


#-------
# Packages

use Tk 800.022;
#use Tk::ErrorDialog;
#use Tk;
#use Tk::Text;
use Tk::TextUndo;
use Tk::TextEdit;
use Tk::TextTools;
use Tk::MarkupTools;

use Tk::Menu;
use Tk::Optionmenu;
use Tk::Photo;
use Tk::Balloon;
use Tk::CheckButton;
use Tk::RadioButton;

use Tk::Balloon;
use Tk::ObjScanner;
use Tk::DirTree;
use Tk::WaitBox;
use Tk::ProgressBar;
use Tk::Date;
use Tk::XMLViewer;
use Tk::Animation;
use Tk::Dialog;
use Tk::DialogBox;
use Tk::Toplevel;
use Tk::FileSelect;

use English;
use File::Basename;
use Data::Dumper;
use winMain;

use IO::Handle;
use IO::Seekable;
use IO::File;
use IO::Pipe;
use IO::Socket;
use IO::Dir;


#-----------------
# Global variables

#------------------
# Private Variables

my %typesCollocations;
my @numbersCollocations;
my $top1;
my $transcodeurTkReplaceChar;
my $windowTranscodeurTk;
my $directory2xmlrecursewriter;
my $mainstatxmlnode;
my $mainrandSelectFile;
my $mainconcat2xmlrandSelectFile;
my $maindirectory2xml;
my $maincollocInXPath;
my $mainconcatFile;
my $mainword2lexico;
my $mainword2xml;
my $montantE;
my $montantF;
my $montantG;
my %liste_tagInput_addTagInTextNode;
my @ListeBigrammesMot1;
my @ListeBigrammesMot2;
my $AttValSE;
my $CDATA_CE;
my $CaractereLu;
my $CaractereNonPrevu;
my $CommentCE;
my $DT_IdentSE;
my $DT_ItemSE;
my $DeclCE;
my $DocTypeCE;
my $ElemTagCE;
my $EndTagCE;
my $FichierAscii;
my $FichierCaracteres;
my $FichierCaracteresNonPrevus;
my $Frequence;
my $Ligne1;
my $Ligne;
my $MarkupDeclCE;
my $MarkupSPE;
my $Mot;
my $Name;
my $NameChar;
my $NameStrt;
my $PI_CE;
my $PI_Tail;
my $QuoteCE;
my $QuoteSE;
my $S1;
my $S;
my $Segment;
my $SegmentOuForme;
my $TextSE;
my $Traits;
my $Until2Hyphens;
my $UntilHyphen;
my $UntilQMs;
my $UntilRSBs;
my $XML_SPE;
my $balise_name;
my $base;
my $bigram;
my $canvas;
my $catalog;
my $ch;
my $char2entity;
my $char;
my $concordance_TOP;
my $concordance_subform;
my $context;
my $currentdir;
my $curxfermode;
my $debug;
my $depth;
my $dir0;
my $element;
my $entity;
my $f;
my $file1;
my $file2;
my $file3;
my $file4;
my $file;
my $finalxx;
my $finalyy;
my $formatter;
my $ftp;
my $headxmlConverter1;
my $headxmlConverter2;
my $headxmlConverter3;
my $host;
my $html;
my $i;
my $id;
my $idaddIDOnTAG;
my $imageSave;
my $inchost;
my $ind;
my $indxmlConverter1;
my $indxmlConverter2;
my $indxmlConverter3;
my $infile;
my $key;
my $lenleft;
my $level;
my $leveleventXML;
my $levelxmlConverter1;
my $levelxmlConverter2;
my $levelxmlConverter3;
my $levelprintEltAsText;
my $ligne;
my $line;
my $listXmlviewer2;
my $listePn2;
my $listePn2Map;
my $listePn2SelectionMarkup2;
my $listePn2SelectionMarkup;
my $listePnChangeAscii;
my $listePnChangeChar;
my $listePnChangeUnrocognizedChar;
my $listePnXMLBalise;
my $listePnXMLBaliseWithDOM;
my $listePnXMLBaliseWithDOM1;
my $listePnXMLLexico2Balise;
my $listePnXMLLexicoBalise;
my $listePntag;
my $mainXmlviewer2;
my $mainXmlviewer;
my $markname;
my $mkExtractTextInMarkup;
my $mkTextConcordance;
my $mkTextMarkup;
my $mkTextXpath;
my $mkWindowForIncludingFile;
my $mkXML2TxtBrut;
my $modification;
my $newline;
my $nom_fic2;
my $offset;
my $openstring;
my $outfile;
my $pn0;
my $pn0_1;
my $pn10;
my $pn11;
my $pn1;
my $pn2;
my $pn2Map;
my $pn3;
my $pn4;
my $pn5;
my $pn6;
my $pn7;
my $pn8;
my $pn8a;
my $pn8b;
my $pn8c;
my $pn8d;
my $pn8db;
my $pn8de;
my $pn8e;
my $pn9;
my $pnChangeAscii;
my $pnChangeChar;
my $pnChangeUnrocognizedChar;
my $pnCordial;
my $pnDraw;
my $pnDrawSelectionMarkup2;
my $pnDrawSelectionMarkup;
my $pnXMLBalise;
my $pnXMLLexico2Balise;
my $pnXMLLexicoBalise;
my $pntag;
my $position_search;
my $quiet;
my $remainder;
my $resultat;
my $resulteventXML;
my $root;
my $search_string_map;
my $seen;
my @selectionParcourirDOM;
my %selectionParcourirDOM;
my $selx;
my $sent;
my $silent;
my $spacer;
my $spaces;
#my $start_dir;
my $startxx;
my $startyy;
my $statusXmlviewer2;
my $statusXmlviewer2Value;
my $statusXmlviewer;
my $tagtmp;
my $tmpTexte;
my $tmplinepreptxt;
my $txtnum;
my $unrestrict;
my $urlAddress;
my $value;
my $var;
my $waitBoxWidget;
my $wd;
my $word1;
my $word2;
my $word;
my $x;
my $xml_comments;
my $xml_countComments;
my $xml_string1;
my $xml_subform;
my $xpath;
my %Liste_xmlBalise;
my %Liste_xmlLexicoBalise2;
my %Liste_xmlLexicoBalise;
my %MapTextFull;
my %MapTextFull2;
my %char2entity;
my %compteurBaliseXml;
my %compteurBaliseXmlLexico;
my %count;
my %entity2char;
my %fullurl;
my %listeBaliseXml;
my %listeNodes2Map;
my %listeNodes2Map1;
my %listeBaliseXmlLexico;
my %mapTextFull;
my %mapTextFull2;
my %tag_countXmlviewer2;
my %xmlStatElements;
my @Lignes;
my @color;
my @contexts3;
my @files;
my @liste_xmlBalise;
my @liste_xmlLexicoBalise2;
my @liste_xmlLexicoBalise;
my @mapText;
my @tagsXmlviewer2;
my @token;
my @types;
my @urls;
my @urlstack;
my @words;
my @xmllistEventXML;
my @xmllistXmlviewer2;
my @listxmlDomExtractTag;
my %listxmlDomExtractTag;

#Lexical item
my $Conjonctions  = "&|autant|comme|donc|dont|et|jusqu|lorsque|mais|ni|ou|o|par|parce|puis|puisque|qu|qu\'|quand|quant|que|qui|si|soit|tandis" ;
my $Pronoms       = "c\'|ce|ceci|cela|celles|celui|ceux|elle|elles|il|ils|j|j\'|je|l\'|leur|lui|me|nous|on|s|s\'|se|te|tu|vous|y" ;
my $Verbes        = "a|accompagnant|accompagn|adress|agit|ai|aller|apparait|apparue|appartiennent|applique|apportant|apporte|apporter|apprcier|associant|atteignant|atteindre|atteint|aura|aurait|avais|avait|avez|avoir|avons|avre|ayant|bnfici|comporte|comportent|concernant|confirme|conservent|considr|contrler|correspond|correspondant|correspondre|cdant|demande|devait|devrait|distinguer|dilater|dit|doit|doivent|donne|donn|dbordant|dbute|dcide|dclar|dclenche|dcrit|dpendant|dpister|d|envisager|es|espre|est|estime|eu|existe|explique|faire|fait|fut|inscrit|jouer|juger|justifiant|justifient|limiter|maintenir|mettait|mettre|mis|modifier|montre|montr|motivant|motivera|naissant|obtenir|ont|parait|permet|permettant|permettent|persiste|perturb|peut|peuvent|pourrait|poursuivre|prenant|prend|procder|proposer|provoque|prciser|prdisposant|prdispos|prsentant|prsente|prsent|prvoir|pu|quitte|quitter|quitt|rappelons|refaire|regagne|regagner|rendre|renvoient|repose|ressent|retrouve|raliser|rsultant|rvl|semble|sera|sert|servant|servent|servir|soit|sont|suis|supposer|survenant|survenue|surviennent|traite|transfr|va|vaut|venir|veut|veux|vient|voir|vu|taient|tait|tant|t|tre" ;
# Verbes problmatiques : fait|
my $Adverbes      = "actuellement|ainsi|alors|angiographiquement|assez|aujourd\'|aussi|autrement|avant|beaucoup|bien|brivement|ci|cliniquement|comment|contrairement|discrtement|dj|encore|environ|extrmement|facilement|franchement|globalement|hautement|heureusement|hui|ici|imparfaitement|infra|lors|l|maintenant|mieux|modrment|moins|moyennement|n|n\'|ne|nettement|non|ores|parfaitement|partiellement|pas|peu|plus|plutt|pratiquement|probablement|prcocement|prcocment|rapidement|relativement|rellement|souvent|strictement|supra|tard|toujours|trop|trs|vraisemblablement|a|galement|lectriquement" ;
my $Prepositions  = "aprs|au|auprs|autour|aux|avant|avec|chez|contre|d|d\'|dans|de|depuis|des|devant|du|ds|en|entre|hors|jusqu\'|malgr|par|parmi|pendant|pour|prs|sans|selon|sous|sur|vers||" ;
my $Determinants  = "aucun|aucune|auquel|autre|autres|ce|celle|celles|cent|cents|certain|certaine|certaines|certains|ces|cet|cette|chaque|cinq|cinquante|de|des|deux|dix|douze|du|huit|l|la|laquelle|le|les|leurs|ma|mille|mon|mme|mmes|neuf|nos|notre|onze|plusieurs|quarante|quatorze|quatre|quelque|quelques|quinze|sa|seize|sept|ses|six|soixante|son|tel|telle|telles|tels|ton|tous|tout|toute|toutes|treize|trente|trois|un|une|vingt|vos|votre" ;
my $MotsProblemes = "er|[0-9]|[+*=]|chapitre|lundi|mardi|mercredi|jeudi|vendredi|samedi|dimanche|janvier|fvrier|mars|avril|mai|juin|juillet|aot|septembre|octobre|novembre|dcembre|%|M\.|MM\.|[0-9]{1,3}" ;

my $NomsPropres   = "Marie|Luc" ;
my $Ponctuations   = "[?,.;:!\"()_\\-]" ;

my $MotsAEnlever = "(" . $Conjonctions . "|" . $Pronoms . "|" . $Verbes  . "|" . $Adverbes . "|" . $Prepositions . "|" . $Determinants . "|" . $MotsProblemes . "|" . $NomsPropres . ")" ;

#---------------------------------------------------------------------------------------
#Procdures et premiers Niveaux
#---------------------------------------------------------------------------------------

sub scanner {
    &UpdateIndicators2;
my $scanner = $winMain::mw->ObjScanner( caller => $winMain::texte, 
                                 title=>"windows") -> pack ;
}
#---------------------------------------------
sub scanner1 {
&UpdateIndicators2;
  my $scan = $winMain::mw ->Toplevel();
  $scan -> ObjScanner
  (
   caller 		    => $winMain::texte,
   title 		    => 'demo setting the scanner options',
   background 	    => 'white',
   selectbackground => 'beige',
   foldImage 		=> $scan->Photo(-file => Tk->findINC('folder.xpm')),
   openImage 		=> $scan->Photo(-file => Tk->findINC('openfolder.xpm')),
   itemImage 		=> $scan->Photo(-file => Tk->findINC('textfile.xpm')),
  )
  -> pack(expand => 1, fill => 'both') ;
}
#----------------------------------------------------------------
sub GetCWD {
&UpdateIndicators2;
  # -- GetCWD
  # Get the current working directory, make sure it ends with a slash
  # No parameters
  # Returns cwd
  # Modified by Calin MOSUT (the command `pwd` in the original code could not
  # reach the mount point on a Windows machine)
  use Cwd;
  my $dir;

  $dir = getcwd;
  # method from Cwd.pm
  $dir =~ s/\n//g;
  if ($dir !~ m#/$#) {
    $dir = "$dir/";
  }
  return $dir;
}  # GetCWD
#---------------------------------------------------------------------------------------
sub ConfirmDiscard2 {
&UpdateIndicators2;
 my ($w)=@_;
 if ($w->numberChanges)
  {
   my $ans = $w->messageBox(-icon    => 'warning',
                            -type => 'YesNoCancel',
                            -message =>
"The text has been modified without being saved.
Save edits?");

   return 0 if ($ans=~/Cancel/i);
   return 1 if (($ans!~/Yes/i) && ($ans!~/Cancel/i));
#   return 0 if (($ans=~/Yes/i) && (!$w->FileSaveAsPopup));
   if ($ans=~/Yes/i) {
       eval {$w->FileSaveAsPopup};
       if ($@) {
	   &mkPrintErreur("Caught Error : $@\n");
	   return 0;
       }
       else {
	    return 1
       }
   }
}
 else {
 return 1;
 }
}
#---------------------------------------------------------------------------------------
sub ConfirmExit2 {
&UpdateIndicators2;
 my ($w) = @_;
 $winMain::texte->toplevel->destroy if ConfirmDiscard2($winMain::texte);
}
#---------------------------------------------------------------------------------------
sub ConfirmEmptyDocument2 {
&UpdateIndicators2;
 my ($w)=@_;
# $w->EmptyDocument if ConfirmDiscard2($winMain::texte);
# $winMain::saisie->delete(0,'end');
# $winMain::new_num_doc++;
# my $newDoc = "Nouveau".$winMain::new_num_doc.".txt";
# $winMain::saisie->insert('end',$newDoc);
# $winMain::texte->FileName($winMain::nom_fic);

 if (ConfirmDiscard2($winMain::texte)) {
     $w->EmptyDocument;
     $winMain::saisie->delete(0,'end');
     $winMain::new_num_doc++;
     my $newDoc = "Nouveau".$winMain::new_num_doc.".txt";
     $winMain::saisie->insert('end',$newDoc);
     $winMain::texte->FileName($winMain::nom_fic);
 }

}

#---------------------------------------------------------------------------------------
sub ConfirmNewDocument {
&UpdateIndicators2;
 my ($w)=@_;
 if (ConfirmDiscard2($w)) {
     return 1;
     }
 else {
     return 0;
 }
}
#-------------------------- Module FILE ------------------------------------------------
sub IncludedFileInWindow {
&UpdateIndicators2;
    my ($tmpfile,$msg) = @_;
    my $mkWindowForIncludingFile->destroy if Exists($mkWindowForIncludingFile);
    $mkWindowForIncludingFile = $winMain::mw->Toplevel();
    my $w = $mkWindowForIncludingFile;
    $w->title("$msg");
    $w->iconname("$msg");
    my $w_t = $w->TextUndo(-setgrid => 'true', -width => '60', -height => '28');
    my $w_ok = $w->Button(-text => 'OK', -width => 8, -command => ['destroy', $w]);
    my $w_save = $w->Button(-text => "Save",
			    -image => $winMain::imageSave,
			    -command => sub {$w_t->FileSaveAsPopup()})->pack(-side => 'top', -pady => 5, -padx => 10);

    $winMain::winBalloon->attach($w_save,
                  -balloonmsg => "Save"
               );
    my $w_s = $w->Scrollbar(-command => ['yview', $w_t]);
    $w_t->configure(-yscrollcommand => ['set', $w_s]);
    $w_ok->pack(-side => 'top', -pady => 5, -padx => 10);
    $w_s->pack(-side => 'right', -fill => 'y');
    $w_t->pack(-expand => 'yes', -fill => 'both');
    # Set up display styles
    my(@bold, @normal, $tags);
    if ($mkWindowForIncludingFile->depth > 1) {
	@bold = (-foreground => 'red');
	@normal = (-foreground => undef);
    } else {
	@bold = (-foreground => 'white', -background => 'black');
	@normal = (-foreground => undef, -background => undef);
    }
    $w_t->insert('0.0', '');
    $w_t->IncludeFile($tmpfile);
}
#---------------------------------------------
sub lire_fic {
&UpdateIndicators2;
    if (&ConfirmNewDocument($winMain::texte)) {
		
	eval {$winMain::texte->Load($winMain::nom_fic)};
		if ($@) {
		    &mkPrintErreur("Caught Error : $@\n");
		    return;
		}
		else {
		    &winMain::UpdateIndicators;
		}
	my $nom = "$winMain::nom_fic";
	if (!exists ($winMain::Courant{$nom})){
	    $winMain::Courant{$nom}++;
	    $winMain::num_doc++;
	    push (@winMain::courant, $nom);
	    $winMain::b_menu->command(-label => "$nom",
				      -command => [ \&load_selected_fic,"$nom"]);
	}

    }
}
#---------------------------------------------------------------------------------------
sub sauve_fic {
&UpdateIndicators2;
    $winMain::texte->Save;
}
#---------------------------------------------
sub FileLoadPopup {
&UpdateIndicators2;
 my ($w)=@_;
 my $name = $w->CreateFileSelect('getOpenFile',-title => 'File Load');
 $winMain::nom_fic=$name;
 return $w->Load($name) if defined($name) and length($name);
 return 0;
}
#---------------------------------------------------------------------------------------
sub new_fic {
&UpdateIndicators2;
    my $nom = "$winMain::nom_fic";
	if (!exists ($winMain::Courant{$nom})){
	    $winMain::Courant{$nom}++;
	    $winMain::num_doc++;
	    push (@winMain::courant, $nom);
	    $winMain::b_menu->command(-label => "$nom",
			     -command => [ \&load_selected_fic, "$nom"]);
	}
    &select_document("Nouveau");
}
#---------------------------------------------------------------------------------------
sub select_document {
&UpdateIndicators2;
    $winMain::texte->delete("1.0","end");
    my ($selection) = @_;
    $winMain::saisie->delete(0,'end');
    $winMain::saisie->insert('end',"$selection");
}
#---------------------------------------------
sub load_selected_fic {
&UpdateIndicators2;
    ($winMain::nom_fic) = @_;
    if (&ConfirmNewDocument($winMain::texte)) {

	eval {$winMain::texte->Load($winMain::nom_fic)};
	if ($@) {
	    &mkPrintErreur("Caught Error : $@\n");
	    return;
	}
	else {
	    &winMain::UpdateIndicators;
	}
	my $nom = "$winMain::nom_fic";
	if (!exists ($winMain::Courant{$nom})){
	    $winMain::Courant{$nom}++;
	    $winMain::num_doc++;
	    push (@winMain::courant, $nom);
	    $winMain::b_menu->command(-label => "$nom",
				      -command => [ \&load_selected_fic, "$nom"]);
	}
	
    }
}

#---------------------------------------------
sub attach_selected_fic {
&UpdateIndicators2;
    ($winMain::nom_fic) = @_;
    if (&ConfirmNewDocument($winMain::texte)) {
		my $nom = "$winMain::nom_fic";
		my $tmp_file = "attachedFile.txt";
		$winMain::texte->Load($tmp_file);
	}
}

#------------------------------------ MODULE SEARCH ---------------------------------------

sub tksm {
&UpdateIndicators2;
    $winMain::mw->withdraw;
    if ($Tk::platform eq 'unix') {
	system("perl tksm.pl");
    }
    else {
	system("perl win32TKsm.pl");
    }
    $winMain::mw->deiconify;
    $winMain::mw->raise;
}

sub remove_mark_search {
&UpdateIndicators2;
    $winMain::texte->tagDelete('search','1.0','end');
}

sub remove_mark_search_map {
&UpdateIndicators2;
    my ($texteMp) = @_;
    $texteMp->tagDelete('search','1.0','end');
}

sub remove_search {
&UpdateIndicators2;
    $winMain::texte->tagDelete('search','1.0','end');
    $winMain::search_string="";
    $winMain::replace_string="";
}

sub remove_search_map {
&UpdateIndicators2;
    my ($texteMp) = @_;
    $texteMp->tagDelete('search','1.0','end');
    $search_string_map="";
}
#---------------------------------------------
sub search_replace {
&UpdateIndicators2;
    my ($search,$replace) = @_;
    &text_replace($winMain::texte, $search, $replace, 'search');
    if ($winMain::texte->depth > 1) {
	&text_toggle($winMain::texte, ['configure', 'search', -background => 'SeaGreen4', -foreground => 'white'], 800,
		          ['configure', 'search', -background => undef,       -foreground => undef],   200);
      } else {
	&text_toggle($winMain::texte, ['configure', 'search', -background => 'black',     -foreground => 'white'], 800,
		          ['configure', 'search', -background => undef,       -foreground => undef],   200);
      }

    $winMain::saisie2->delete(0,'end');
    $winMain::saisie3->delete(0,'end');
#    $pn4->destroy() if Tk::Exists($pn4);

}



#---------------------------------------------
sub i_search {
&UpdateIndicators2;

    if ($winMain::search_string eq "") {
	    &mkPrintErreur("ERREUR : Aucune slection de chane de recherche donne\n");
	    return;
	}
    $winMain::texte->tag('remove',  'search', '0.0', 'end');
    my $resultat=$winMain::texte->search(-regexp, "$winMain::search_string",'1.0','end');
    if ($resultat eq "") {
	&mkPrintMsgInfo("Aucune chane correspondante pour le motif de recherche donn\n");
	return;
    }
    my $lenght = length $winMain::search_string;
    $resultat=~/([0-9]+)\.([0-9]+)/;
    $i=$1;
    $offset=$2;
    $winMain::texte->tag('add', 'search', sprintf("%d.%d", $i, $offset), sprintf("%d.%d", $i, $offset+$lenght));
    $winMain::texte->see($resultat);
    if ($winMain::mw->depth > 1) {
	&text_toggle($winMain::texte, ['configure', 'search', -background => 'SeaGreen4', -foreground => 'white'], 800,
		          ['configure', 'search', -background => undef,       -foreground => undef],   200);
      } else {
	&text_toggle($winMain::texte, ['configure', 'search', -background => 'black',     -foreground => 'white'], 800,
		          ['configure', 'search', -background => undef,       -foreground => undef],   200);
      }


    $position_search= sprintf("%d.%d", $i, $offset+$lenght);
    

}

#---------------------------------------------
sub i_search_2 {
&UpdateIndicators2;

    if ($search_string_map eq "") {
	    &mkPrintErreur("ERREUR : Aucune slection de chane de recherche donne\n");
	    return;
	}
    $texteMp->tag('remove',  'search', '0.0', 'end');
    my $resultat=$texteMp->search(-regexp, "$search_string_map",'1.0','end');
    if ($resultat eq "") {
	&mkPrintMsgInfo("Aucune chane correspondante pour le motif de recherche donn\n");
	return;
    }
    my $lenght = length $search_string_map;
    $resultat=~/([0-9]+)\.([0-9]+)/;
    $i=$1;
    $offset=$2;
    $texteMp->tag('add', 'search', sprintf("%d.%d", $i, $offset), sprintf("%d.%d", $i, $offset+$lenght));
    $texteMp->see($resultat);
    if ($pnDraw->depth > 1) {
	&text_toggle($texteMp, ['configure', 'search', -background => 'SeaGreen4', -foreground => 'white'], 800,
		          ['configure', 'search', -background => undef,       -foreground => undef],   200);
      } else {
	&text_toggle($texteMp, ['configure', 'search', -background => 'black',     -foreground => 'white'], 800,
		          ['configure', 'search', -background => undef,       -foreground => undef],   200);
      }


    $position_search= sprintf("%d.%d", $i, $offset+$lenght);
    
    print "ps1 : $position_search\n";
}

#---------------------------------------------
sub i_replace {
&UpdateIndicators2;

    if ($winMain::search_string eq "") {
	    &mkPrintErreur("ERREUR : Aucune slection de chane de recherche donne\n");
	    return;
	}
    $winMain::texte->tag('remove',  'search', '0.0', 'end');
    $resultat=$winMain::texte->search(-regexp, "$winMain::search_string",'1.0','end');
    if ($resultat eq "") {
	&mkPrintMsgInfo("Aucune chane correspondante pour le motif de recherche donn\n");
	return;
    }
    my $lenght = length $winMain::search_string;
    $resultat=~/([0-9]+)\.([0-9]+)/;
    $i=$1;
    $offset=$2;
    $winMain::texte->tag('add', 'search', sprintf("%d.%d", $i, $offset), sprintf("%d.%d", $i, $offset+$lenght));
    $winMain::texte->delete(sprintf("%d.%d",$i,$offset),sprintf("%d.%d",$i,$offset + $lenght));    
    $winMain::texte->insert(sprintf("%d.%d", $i, $offset),$winMain::replace_string);
    $lenght = length $winMain::replace_string;
    $winMain::texte->tag('add', 'search', sprintf("%d.%d", $i, $offset), sprintf("%d.%d", $i, $offset+$lenght));
    $winMain::texte->see($resultat);
    if ($winMain::mw->depth > 1) {
	&text_toggle($winMain::texte, ['configure', 'search', -background => 'SeaGreen4', -foreground => 'white'], 800,
		          ['configure', 'search', -background => undef,       -foreground => undef],   200);
      } else {
	&text_toggle($winMain::texte, ['configure', 'search', -background => 'black',     -foreground => 'white'], 800,
		          ['configure', 'search', -background => undef,       -foreground => undef],   200);
      }

    $position_search= sprintf("%d.%d", $i, $offset+$lenght);
    

}


#---------------------------------------------
sub i_search2 {
&UpdateIndicators2;

    if ($winMain::search_string eq "") {
	    &mkPrintErreur("ERREUR : Aucune slection de chane de recherche donne\n");
	    return;
	}
    $winMain::texte->tag('remove',  'search', '0.0', 'end');

    if ($position_search  !~/[0-9]+\.[0-9]+/) {
	&mkPrintMsgInfo("On vous a dj dit qu'il n\'existe aucune chane correspondante pour le motif de recherche donn\n...");
	return;
    }
    $resultat=$winMain::texte->search(-regexp, "$winMain::search_string",$position_search,'end');
    print $resultat,"<<<<<<<\n";
    if ($resultat eq "") {
	&mkPrintMsgInfo("Aucune chane correspondante pour le motif de recherche donn\n");
	return;
    }
    my $lenght = length $winMain::search_string;
    $resultat=~/([0-9]+)\.([0-9]+)/;
    $i=$1;
    $offset=$2;
    $winMain::texte->tag('add', 'search', sprintf("%d.%d", $i, $offset), sprintf("%d.%d", $i, $offset+$lenght));
    $winMain::texte->see($resultat);
    if ($winMain::texte->depth > 1) {
	&text_toggle($winMain::texte, ['configure', 'search', -background => 'SeaGreen4', -foreground => 'white'], 800,
		          ['configure', 'search', -background => undef,       -foreground => undef],   200);
      } else {
	&text_toggle($winMain::texte, ['configure', 'search', -background => 'black',     -foreground => 'white'], 800,
		          ['configure', 'search', -background => undef,       -foreground => undef],   200);
      }

    $position_search= sprintf("%d.%d", $i, $offset+$lenght);

}

#---------------------------------------------
sub i_search2_2 {
&UpdateIndicators2;

    if ($search_string_map eq "") {
	    &mkPrintErreur("ERREUR : Aucune slection de chane de recherche donne\n");
	    return;
	}
    $texteMp->tag('remove',  'search', '0.0', 'end');

#    print "ps2 : $position_search\n";

    if ($position_search  !~/[0-9]+\.[0-9]+/) {
	&mkPrintMsgInfo("On vous a dj dit qu'il n\'existe aucune chane correspondante pour le motif de recherche donn\n...");
	return;
    }

    $resultat=$texteMp->search(-regexp, "$search_string_map",$position_search,'end');
    print $resultat,"<<<<<<<\n";
    if ($resultat eq "") {
	&mkPrintMsgInfo("Aucune chane correspondante pour le motif de recherche donn\n");
	return;
    }
    my $lenght = length $search_string_map;
    $resultat=~/([0-9]+)\.([0-9]+)/;
    $i=$1;
    $offset=$2;
    $texteMp->tag('add', 'search', sprintf("%d.%d", $i, $offset), sprintf("%d.%d", $i, $offset+$lenght));
    $texteMp->see($resultat);
    if ($pnDraw->depth > 1) {
	&text_toggle($texteMp, ['configure', 'search', -background => 'SeaGreen4', -foreground => 'white'], 800,
		          ['configure', 'search', -background => undef,       -foreground => undef],   200);
      } else {
	&text_toggle($texteMp, ['configure', 'search', -background => 'black',     -foreground => 'white'], 800,
		          ['configure', 'search', -background => undef,       -foreground => undef],   200);
      }

    $position_search= sprintf("%d.%d", $i, $offset+$lenght);

}

#---------------------------------------------
sub i_replace2 {
&UpdateIndicators2;

    if ($winMain::search_string eq "") {
	    &mkPrintErreur("ERREUR : Aucune slection de chane de recherche donne\n");
	    return;
	}
    if ($position_search  !~/[0-9]+\.[0-9]+/) {
	&mkPrintMsgInfo("On vous a dj dit qu'il n\'existe aucune chane correspondante pour le motif de recherche donn\n...");
	return;
    }

    $winMain::texte->tag('remove',  'search', '0.0', 'end');
    $resultat=$winMain::texte->search(-regexp, "$winMain::search_string",$position_search,'end');
    if ($resultat eq "") {
	&mkPrintMsgInfo("Aucune chane correspondante pour le motif de recherche donn\n");
	return;
    }
    my $lenght = length $winMain::search_string;
    $resultat=~/([0-9]+)\.([0-9]+)/;
    $i=$1;
    $offset=$2;
    $winMain::texte->tag('add', 'search', sprintf("%d.%d", $i, $offset), sprintf("%d.%d", $i, $offset+$lenght));
    $winMain::texte->delete(sprintf("%d.%d",$i,$offset),sprintf("%d.%d",$i,$offset + $lenght));    
    $winMain::texte->insert(sprintf("%d.%d", $i, $offset),$winMain::replace_string);
    $lenght = length $winMain::replace_string;
    $winMain::texte->tag('add', 'search', sprintf("%d.%d", $i, $offset), sprintf("%d.%d", $i, $offset+$lenght));
    $winMain::texte->see($resultat);
    if ($winMain::mw->depth > 1) {
	&text_toggle($winMain::texte, ['configure', 'search', -background => 'SeaGreen4', -foreground => 'white'], 800,
		          ['configure', 'search', -background => undef,       -foreground => undef],   200);
      } else {
	&text_toggle($winMain::texte, ['configure', 'search', -background => 'black',     -foreground => 'white'], 800,
		          ['configure', 'search', -background => undef,       -foreground => undef],   200);
      }

    $position_search= sprintf("%d.%d", $i, $offset+$lenght);
    

}

#---------------------------------------------
sub search_in_fic {
&UpdateIndicators2;
    
    &text_search($winMain::texte, $winMain::search_string, 'search');
    if ($winMain::mw->depth > 1) {
	&text_toggle($winMain::texte, ['configure', 'search', -background => 'SeaGreen4', -foreground => 'white'], 800,
		          ['configure', 'search', -background => undef,       -foreground => undef],   200);
      } else {
	&text_toggle($winMain::texte, ['configure', 'search', -background => 'black',     -foreground => 'white'], 800,
		          ['configure', 'search', -background => undef,       -foreground => undef],   200);
      }

    $winMain::saisie2->delete(0,'end');
}

#---------------------------------------------
sub search_in_fic_2 {
&UpdateIndicators2;
    
    &text_search($texteMp, $search_string_map, 'search');
    if ($pnDraw->depth > 1) {
	&text_toggle($texteMp, ['configure', 'search', -background => 'SeaGreen4', -foreground => 'white'], 800,
		          ['configure', 'search', -background => undef,       -foreground => undef],   200);
      } else {
	&text_toggle($texteMp, ['configure', 'search', -background => 'black',     -foreground => 'white'], 800,
		          ['configure', 'search', -background => undef,       -foreground => undef],   200);
      }

#    $winMain::saisie2->delete(0,'end');
}
#---------------------------------------------------------------------------------------
sub replace {
&UpdateIndicators2;
    
    &text_replace($winMain::texte, $winMain::search_string, $winMain::replace_string, 'search');
    if ($winMain::mw->depth > 1) {
	&text_toggle($winMain::texte, ['configure', 'search', -background => 'SeaGreen4', -foreground => 'white'], 800,
		          ['configure', 'search', -background => undef,       -foreground => undef],   200);
      } else {
	&text_toggle($winMain::texte, ['configure', 'search', -background => 'black',     -foreground => 'white'], 800,
		          ['configure', 'search', -background => undef,       -foreground => undef],   200);
      }

    $winMain::saisie2->delete(0,'end');
    $winMain::saisie3->delete(0,'end');
}

#--------------------------------------------------------------------------------------
sub text_delete {
&UpdateIndicators2;

    # The utility procedure below searches and destroy for all instances of a given string in a text widget and applies a given tag
    # to each instance found.
    # Arguments:
    #
    # w -	The window in which to search.  Must be a text widget.
    # string -	The string to search for. 
    # tag -	Tag to apply to each instance of a matching string.

    my($w, $string, $tag) = @_;
    my @seenElt=();

    if ($string eq "") {
	&mkPrintErreur("ERREUR : Aucune slection de chane de recherche donne\n");
	return;
	}
    my $resultat=$w->search(-regexp, "$string",'1.0','end');
    if ($resultat eq "") {
	&mkPrintMsgInfo("Aucune chane correspondante pour le motif de recherche donn\n");
	return;
    }
    $w->tag('remove',  $tag, '0.0', 'end');
    (my $num_lines) = $w->index('end') =~ /(\d*)\.\d*/;
    my $id = 0;
    for($i = 1; $i <=$num_lines; $i++) {
	my $line = $w->get("${i}.0", "${i}.1000");
	next if not defined $line or $line !~ /($string)/;
        my $l = length $1;
	my $stringRegexp=$1;
	my $offset = 0;
	while (1) {
	    my $tmpoffset=0;
	    my $index = index $line, $stringRegexp, $tmpoffset;
	    last if $index == -1;
	    $offset += $index;
	    $w->tag('add', $tag, sprintf("%d.%d", $i, $offset), sprintf("%d.%d", $i, $offset+$l));
	    $seenElt[$id] =[$i, $offset, $i, $offset+$l];
	    $id++;
	    $offset += $l;
	    $line = substr $line, $index+$l;
	    if ($line=~/($string)/) { $stringRegexp=$1;
				      $l = length $1;}

	} # whilend
    } # forend


	for ($i = $#seenElt; $i >= 0; $i--) {
	    $w->delete(sprintf("%d.%d",$seenElt[$i][0],$seenElt[$i][1]),sprintf("%d.%d",$seenElt[$i][2],$seenElt[$i][3]));
	    }
    
    @seenElt=();
}

#---------------------------------------------------------------------------------------
sub text_search {
    &UpdateIndicators2;

    # The utility procedure below searches for all instances of a given string in a text widget and applies a given tag
    # to each instance found.
    # Arguments:
    #
    # w -	The window in which to search.  Must be a text widget.
    # string -	The string to search for. (regexp and so on...)
    # tag -	Tag to apply to each instance of a matching string.

    my($w, $string, $tag) = @_;

    print "$string / $tag \n";
    if ($string eq "") {
	&mkPrintErreur("ERREUR : Aucune slection de chane de recherche donne\n");
	return;

    }

    my $resultat=$w->search(-regexp, "$string",'1.0','end');
    if ($resultat eq "") {
	&mkPrintMsgInfo("Aucune chane correspondante pour le motif de recherche donn\n");
	return;
    }

    $w->tag('remove',  $tag, '0.0', 'end');
    (my $num_lines) = $w->index('end') =~ /(\d*)\.\d*/;
    for($i = 1; $i <=$num_lines; $i++) {
	my $line = $w->get("${i}.0", "${i}.1000");
	next if not defined $line or $line !~ /($string)/;
        my $l = length $1;
	my $stringRegexp=$1;
	my $offset = 0;
	while (1) {
	    my $tmpoffset=0;
	    my $index = index $line, $stringRegexp, $tmpoffset;
	    last if $index == -1;
	    $offset += $index;
	    $w->tag('add', $tag, sprintf("%d.%d", $i, $offset), sprintf("%d.%d", $i, $offset+$l));
	    $offset += $l;
	    $line = substr $line, $index+$l;
	    if ($line=~/($string)/) { $stringRegexp=$1;
				      $l = length $1;}

	} # whilend
    } # forend

} # end text_search

#---------------------------------------------------------------------------------------
sub text_replace {
&UpdateIndicators2;

    # The utility procedure below searches for all instances of a given string in a text widget and applies a given tag
    # to each instance found.
    # Arguments:
    #
    # w -	The window in which to search.  Must be a text widget.
    # string -	The string to search for. (regexp and so on...)
    # tag -	Tag to apply to each instance of a matching string.

    my($w, $string, $replace, $tag) = @_;
    my @seenElt=();

    if ($string eq "") {
	&mkPrintErreur("ERREUR : Aucune slection de chane de recherche donne\n");
	return;

    }

    my $resultat=$w->search(-regexp, "$string",'1.0','end');
    if ($resultat eq "") {
	&mkPrintMsgInfo("Aucune chane correspondante pour le motif de recherche donn\n");
	return;
    }

    $w->tag('remove',  $tag, '0.0', 'end');
    (my $num_lines) = $w->index('end') =~ /(\d*)\.\d*/;
    my $id = 0;
    for($i = 1; $i <=$num_lines; $i++) {
	my $line = $w->get("${i}.0", "${i}.1000");
	next if not defined $line or $line !~ /($string)/;
        my $l = length $1;
	my $stringRegexp=$1;
	my $offset = 0;
	while (1) {
	    my $tmpoffset=0;
	    my $index = index $line, $stringRegexp, $tmpoffset;
	    last if $index == -1;
	    $offset += $index;
	    $w->tag('add', $tag, sprintf("%d.%d", $i, $offset), sprintf("%d.%d", $i, $offset+$l));
	    $seenElt[$id] =[$i, $offset, $i, $offset+$l,$l];
	    $id++;
	    $offset += $l;
	    $line = substr $line, $index+$l;
	    if ($line=~/($string)/) { $stringRegexp=$1;
				      $l = length $1;}

	} # whilend
    } # forend


	for ($i = $#seenElt; $i >= 0; $i--) {
	    $w->delete(sprintf("%d.%d",$seenElt[$i][0],$seenElt[$i][1]),sprintf("%d.%d",$seenElt[$i][2],$seenElt[$i][3]));
	    $w->insert(sprintf("%d.%d",$seenElt[$i][0],$seenElt[$i][1]),$replace);
	    my $lenght = length $replace;
	    $w->tag('add', 'search', sprintf("%d.%d", $seenElt[$i][0],$seenElt[$i][1]), sprintf("%d.%d", $seenElt[$i][2],$seenElt[$i][3] + $lenght - $seenElt[$i][4]));

	    }

} # end text_replace


#---------------------------------------------------------------------------------------
sub text_toggle {
&UpdateIndicators2;

    # The procedure below is invoked repeatedly to invoke two commands at periodic intervals.  It normally reschedules itself
    # after each execution but if an error occurs (e.g. because the window was deleted) then it doesn't reschedule itself.
    # Arguments:
    #
    # w -       Text widget reference.
    # cmd1 -	Reference to a list of tag options.
    # sleep1 -	Ms to sleep after executing cmd1 before executing cmd2.
    # cmd2 -	Reference to a list of tag options.
    # sleep2 -	Ms to sleep after executing cmd2 before executing cmd1 again.

    my($w, $cmd1, $sleep1, $cmd2, $sleep2) = @_;
    $w->tag(@{$cmd1});
    $w->after($sleep1, [sub {&text_toggle(@_)}, $w, $cmd2, $sleep2, $cmd1, $sleep1]);


} # end text_toggle


#---------------------------- MODULE MARKUP -------------------------------------------

sub extract_text_in_balise {
&UpdateIndicators2;
    my @selection = $listePn2->curselection();
    my $tmp_nomfic=$winMain::nom_fic;
    open(TMPCATFILE,">MKC-tmp_catExtractTextInMarkup.txt");

    foreach $ind (@selection) {
	my $element=$listePn2->get($ind);
	$element=~/<([^>]+)>/;
	my $tmp=$1;
	if ($element=~/<([^ ]+) [^>]*>/) {$tmp=$1}
	my $balise_name = $tmp;
	my $nom_fic2="MKC-tmp_ExtractText_".$balise_name.".txt";
#	print "$nom_fic2\n";
	&extract_balise($element);
	open(TMPFILEEXTRACT,$nom_fic2);
	while(<TMPFILEEXTRACT>){
	    print TMPCATFILE $_;
	}
	close(TMPFILEEXTRACT);
	}	
    close(TMPCATFILE);

    my $tmpfile="MKC-tmp_catExtractTextInMarkup.txt";
    $mkExtractTextInMarkup->destroy if Exists($mkExtractTextInMarkup);
    $mkExtractTextInMarkup = $winMain::mw->Toplevel();
    my $w = $mkExtractTextInMarkup;
    $w->title('Extract Text');
    $w->iconname('Extract');
    my $w_ok = $w->Button(-text => 'OK', -width => 8, -command => ['destroy', $w]);
    my $w_t = $w->TextUndo(-setgrid => 'true', -width => '60', -height => '28',
			-font => '-Adobe-Helvetica-Bold-R-Normal--*-120-*-*-*-*-*-*');
    my $w_save = $w->Button(-text => "Save",
			    -image => $winMain::imageSave,
			    -command => sub {$w_t->FileSaveAsPopup()})->pack(-side => 'top', -pady => 5, -padx => 10);

    $winMain::winBalloon->attach($w_save,
                  -balloonmsg => "Save"
               );


    my $w_s = $w->Scrollbar(-command => ['yview', $w_t]);
    $w_t->configure(-yscrollcommand => ['set', $w_s]);
    $w_ok->pack(-side => 'top', -pady => 5, -padx => 10);
    $w_s->pack(-side => 'right', -fill => 'y');
    $w_t->pack(-expand => 'yes', -fill => 'both');

    # Set up display styles

    my(@bold, @normal, $tags);
    if ($mkExtractTextInMarkup->depth > 1) {
	@bold = (-foreground => 'red');
	@normal = (-foreground => undef);
    } else {
	@bold = (-foreground => 'white', -background => 'black');
	@normal = (-foreground => undef, -background => undef);
    }

    $w_t->insert('0.0', 'Extract Results...');
    $w_t->insert("end","\n\n");
    $w_t->IncludeFile($tmpfile);
    
}

#---------------------------------------------------------------------------------------
sub make_text2mapWithDOM {
&UpdateIndicators2;

    my @selection = $listePn2Map->curselection();
    %listeNodes2Map=();
    foreach $ind (@selection) {
	my $tag=$listePn2Map->get($ind);
	my $p = new XML::Parser ('Style' => 'Dom' );
#	my $p = XML::DOM::Parser->new; 
	my $oldIgnore = XML::DOM::ignoreReadOnly (1);
	my $doc;
	eval { $doc=$p->parsefile($winMain::nom_fic)};
	if ($@) {
	    &mkPrintErreur("Caught Error : $@\n");
	    return;
	}
	XML::DOM::ignoreReadOnly ($oldIgnore);
	my $elements=$doc->getElementsByTagName($tag);
	for my $i (0..$elements->getLength-1) {
	    my $evElement=$elements->item($i);
	    my $children=$evElement->getChildNodes;
	    $listeNodes2Map{$evElement}=$children;
	    }
    }
    &drawTextWithDOM(%listeNodes2Map);

}

#---------------------------------------------------------------------------------------
sub make_text2mapWithDOM3 {
&UpdateIndicators2;
    my ($tag) = @_;
    %listeNodes2Map=();
    %listeNodes2Map1=();
    my $p = XML::DOM::Parser->new; 
    my $doc;
    my $oldIgnore = XML::DOM::ignoreReadOnly(1);
    eval { $doc=$p->parsefile($winMain::nom_fic)};
    if ($@) {
	&mkPrintErreur("Caught Error : $@\n");
	&removeSplashWindow;
	return;
    }
    XML::DOM::ignoreReadOnly($oldIgnore);  
    #-------SPLASH REFRESH
	&splashProgress( "Work In Progress...", 25 );
    #-------SPLASH REFRESH

    my $elements=$doc->getElementsByTagName($tag);
    for my $i (0..$elements->getLength-1) {
	print $i,"\n";
	my @tmp=();
	my $evElement=$elements->item($i);
	my $firstchildren=$evElement->getFirstChild;
	my $children=$evElement->getChildNodes;
	push(@tmp,$firstchildren);
	push(@tmp,$children);
	$listeNodes2Map{$evElement}=\@tmp;
    }
    #-------SPLASH REFRESH
	&splashProgress( "Work In Progress...", 35 );
    #-------SPLASH REFRESH

    &drawTextWithDOM2($tag,%listeNodes2Map);
}

#---------------------------------------------------------------------------------------
sub make_text2mapWithDOM2 {
&UpdateIndicators2;

    my @selection = $listePn2SelectionMarkup2->curselection();
    %listeNodes2Map=();
    foreach $ind (@selection) {
	my $tag=$listePn2SelectionMarkup2->get($ind);
	my $p = XML::DOM::Parser->new; 
	my $doc;
	eval { $doc=$p->parsefile($winMain::nom_fic)};
	if ($@) {
	    &mkPrintErreur("Caught Error : $@\n");
	    return;
	}
	my $elements=$doc->getElementsByTagName($tag);
	for my $i (0..$elements->getLength-1) {
	    my $evElement=$elements->item($i);
	    my $children=$evElement->getChildNodes;
	    $listeNodes2Map{$evElement}=$children;
	    }
    }
    &drawTextWithDOM(%listeNodes2Map);

}

#---------------------------------------------------------------------------------------
sub make_text2map {
&UpdateIndicators2;
    my @selection = $listePn2Map->curselection();
    my $tmp_nomfic=$winMain::nom_fic;
    if (!open(TMPCATFILE,(">MKC-tmp_catExtractTextInMarkup.txt"))) {
	&mkPrintErreur("ERREUR : Impossible d\'ouvrir le fichier MKC-tmp_catExtractTextInMarkup.txt en criture\n");
	return;
    }
    my %mapSelTag=();
    foreach $ind (@selection) {
	my $element=$listePn2Map->get($ind);
	$element=~/<([^>]+)>/;
	my $tmp=$1;
	if ($element=~/<([^ ]+) [^>]*>/) {$tmp=$1}
	my $balise_name = $tmp;

	$mapSelTag{$tmp}=$tmp;

	my $nom_fic2="MKC-tmp_ExtractText_".$balise_name.".txt";
#	print "$nom_fic2\n";
	&extract_balise_oneline($element);

	if (!open(TMPFILEEXTRACT,$nom_fic2)) {
	    &mkPrintErreur("ERREUR : Impossible d\'ouvrir le fichier $nom_fic2\n");
	    return;
	}
	while(<TMPFILEEXTRACT>){
	    print TMPCATFILE $_;
	}
	close(TMPFILEEXTRACT);
	}	
    close(TMPCATFILE);

    if (!open(TMPCATFILE,("MKC-tmp_catExtractTextInMarkup.txt"))) {
	&mkPrintErreur("ERREUR : Impossible d\'ouvrir le fichier MKC-tmp_catExtractTextInMarkup.txt en lecture\n");
	return;
    }


    @mapText = ();
    while(<TMPCATFILE>){
	if (/^(<[^>]+>)\#(.+)$/) {
	    my %indMapText=();
	    $indMapText{$1}=$2;
	    push(@mapText,\%indMapText);
#	    print "tag: $1 content: $2\n";
	}
    }	
    close(TMPCATFILE);

#    print %mapSelTag,"\n";
    push(@mapText,\%mapSelTag)
    &drawText(@mapText);
}

#---------------------------------------------------------------------------------------
sub make_text2map2 {
&UpdateIndicators2;

    my ($tab) = @_;
    my @newtab = @$tab;
    my $tmp=$newtab[0];
    $tmp=~s/(>)/$1\n/gi;
    my $file="MKC-tmp_MAPFile2.txt";
    if (!open(TMPMAPFILE,(">$file"))) {
	&mkPrintErreur("ERREUR : Impossible d\'ouvrir le fichier $file en criture\n");
	return;
    }
    print TMPMAPFILE $tmp,"\n";
    close(TMPMAPFILE);
    
    my @selection = $listePn2SelectionMarkup2->curselection();
    my $tmp_nomfic=$file;
    if (!open(TMPCATFILE,(">MKC-tmp_catExtractTextInMarkup.txt"))) {
	&mkPrintErreur("ERREUR : Impossible d\'ouvrir le fichier MKC-tmp_catExtractTextInMarkup.txt en criture\n");
	return;
	}
    my %mapSelTag=();
    foreach $ind (@selection) {
	my $element=$listePn2SelectionMarkup2->get($ind);
	next if ($element=~/<\//);
	$element=~/<([^>]+)>/;
	my $tmp=$1;
	if ($element=~/<([^ ]+) [^>]*>/) {$tmp=$1}
	my $balise_name = $tmp;
	$mapSelTag{$tmp}=$tmp;
	my $nom_fic2="MKC-tmp_ExtractText_".$balise_name.".txt";
	&extract_balise_oneline2($element,$file);
	if (!open(TMPFILEEXTRACT,$nom_fic2)) {
	    &mkPrintErreur("ERREUR : Impossible d\'ouvrir le fichier $nom_fic2\n");
	    return;
	}
	while(<TMPFILEEXTRACT>){
	    print TMPCATFILE $_;
	}
	close(TMPFILEEXTRACT);
    }	
    close(TMPCATFILE);
    
    if (!open(TMPCATFILE,("MKC-tmp_catExtractTextInMarkup.txt"))) {
	&mkPrintErreur("ERREUR : Impossible d\'ouvrir le fichier MKC-tmp_catExtractTextInMarkup.txt en lecture\n");
	return;
    }
    
    
    @mapText = ();
    while(<TMPCATFILE>){
	    if (/^(<[^>]+>)\#(.+)$/) {
		my %indMapText=();
		$indMapText{$1}=$2;
		push(@mapText,\%indMapText);
#	    print "tag: $1 content: $2\n";
	    }
	}	
    close(TMPCATFILE);
    
#    print %mapSelTag,"\n";
    push(@mapText,\%mapSelTag)
	&drawText(@mapText);
}



#--- CANVAS subs

#---------------------------------------------------------------------------------------
sub start_move {
&UpdateIndicators2;

	my $c=shift;
	
	#find current item...
	my $item = $c->find('withtag','current');

	my $event=$canvas->XEvent;
	($startxx,$startyy)=($event->x,$event->y);

	#get all items with same tags...
	my ($tag)=$c->itemcget($item,-tags);
	my @sametag=$c->find('withtag',$tag);

	#Binding 'all' items is probably overkill?
	$c->bind('all','<Any-Motion>',[\&move_items, \@sametag]);
	$c->bind('all','<ButtonRelease>',\&end_move);
}

#---------------------------------------------------------------------------------------
sub move_items {
&UpdateIndicators2;

	my $c=shift;
	my $tagarrayref=shift;

	my $deltaxx;
	my $deltayy;
	my $xoffset;
	my $yoffset;

	my $event=$canvas->XEvent;
	($finalxx,$finalyy)=($event->x,$event->y);

	($xoffset,$yoffset)=&get_corners($c);
	($finalxx,$finalyy)=($finalxx+$xoffset,$finalyy+$yoffset);

	$deltaxx=$finalxx-$startxx;
	$deltayy=$finalyy-$startyy;
	foreach(@$tagarrayref){
		$c->move($_,$deltaxx,$deltayy);
	}
	
	$startxx=$finalxx;
	$startyy=$finalyy;
}

#---------------------------------------------------------------------------------------
sub end_move {
&UpdateIndicators2;

	my $c=shift;
	$c->bind('all','<Any-Motion>','');
	$c->bind('all','<ButtonRelease>','');
}

#---------------------------------------------------------------------------------------
sub get_corners {
&UpdateIndicators2;
	#returns coords of topleft and bottom right corners of visible area.
	my $c = shift;
	my (@xview) = $c->xview;
	my (@yview) = $c->yview;
	my (@sr) = @{$c->cget(-scrollregion)};
	my $topleftX = $xview[0] * ($sr[2]-$sr[0]) + $sr[0];
	my $topleftY = $yview[0] * ($sr[3]-$sr[1]) + $sr[1];
        my $botrightX = $xview[1] * ($sr[2]-$sr[0]) + $sr[0];
     	my $botrightY = $yview[1] * ($sr[3]-$sr[1]) + $sr[1];

	return ($topleftX, $topleftY, $botrightX, $botrightY);
}


#---------------------------------------------------------------------------------------
sub liste_alltag_map {
&UpdateIndicators2;

    my ($newtab,$canvas) = @_;

    my %tab = %$newtab;
    my @liste_balises=();
    my %Liste_Markups=();
    my $id = 0; 
    foreach $tagtmp (keys %tab) {
	my $file="MKC-tmp_MAPFile.txt";
	if (!open(TMPMAPFILE,(">$file"))) {
	    &mkPrintErreur("ERREUR : Impossible d\'ouvrir le fichier $file en criture\n");
	    return;
	}
	my $tmp = $tab{$tagtmp};
	$tmp=~s/(> )/$1\n/g;
	print TMPMAPFILE $tmp,"\n";
	close(TMPMAPFILE);
	if (!open(TMPMAPFILE,("$file"))) {
	    &mkPrintErreur("ERREUR : Impossible d\'ouvrir le fichier $file en lecture\n");
	    return;
	}
	while(<TMPMAPFILE>) {

	    while (/(<[^>]+>)/g) {
		if (!exists ($Liste_Markups{$1})) {
		    $Liste_Markups{$1}++;
		    $liste_balises[$id]=$1;
		    $id++;
		}
	    }
	}
	close(TMPMAPFILE);
    }

    $pnDrawSelectionMarkup->destroy if Exists($pnDrawSelectionMarkup);
    $pnDrawSelectionMarkup = $winMain::mw ->Toplevel();
    $pnDrawSelectionMarkup->title("Choose Markups");
    
    $listePn2SelectionMarkup=$pnDrawSelectionMarkup->Scrolled("Listbox", -scrollbars => "e",
							      -selectmode => "extended",
							      -selectforeground => "red",
							      -setgrid => 1,
							      -width => -1)->pack();
    $pnDrawSelectionMarkup->Button(-text => "Search TAG",
				   -command =>  sub{&search_tag_in_map($newtab,$canvas)})->pack(-side => 'left', -pady => 5, -padx => 10);
    
    $pnDrawSelectionMarkup->Button(-text => "Close",
				   -command =>  sub {$pnDrawSelectionMarkup->destroy()})->pack(-side => 'left', -pady => 5, -padx => 10);

    

    if ($#liste_balises > 0) {
	$listePn2SelectionMarkup->delete(0,'end');
	$listePn2SelectionMarkup->insert('end',@liste_balises);
    }
    else {
	$pnDrawSelectionMarkup->destroy if Exists($pnDrawSelectionMarkup);
	&mkPrintMsgInfo("Pas de noeud fils, vous tes sur une feuille de l\'arbre...\n");
    }


}


#---------------------------------------------------------------------------------------
sub search_tag_in_map2 {
&UpdateIndicators2;

    my ($newtab,$canvas) = @_;
    my $tmpSearchString="";
    my @selection = $listePn2SelectionMarkup2->curselection();
    foreach $ind (@selection) {
#	print $element,"\n";
	my $element=$listePn2SelectionMarkup2->get($ind);
	$tmpSearchString = "$tmpSearchString" ."\($element\)"."|" ;
#	print "TAGTOSEARCHy : $tmpSearchString\n";
	

    }
    chop($tmpSearchString);
    $tmpSearchString=~s/\//\\\//g;
    $tmpSearchString=~s/\"/\\\"/g;
#    print "TAGTOSEARCH : $tmpSearchString\n";
    &searchInTagMap($newtab,$tmpSearchString,$canvas)

    }

#---------------------------------------------------------------------------------------
sub search_tag_in_map {
&UpdateIndicators2;

    my ($newtab,$canvas) = @_;
    my $tmpSearchString="";
    my @selection = $listePn2SelectionMarkup->curselection();
    foreach $ind (@selection) {
#	print $element,"\n";
	my $element=$listePn2SelectionMarkup->get($ind);
	$tmpSearchString = "$tmpSearchString" ."\($element\)"."|" ;
#	print "TAGTOSEARCHx : $tmpSearchString\n";
	

    }
    chop($tmpSearchString);
    $tmpSearchString=~s/\//\\\//g;
    $tmpSearchString=~s/\"/\\\"/g;
#    print "TAGTOSEARCH : $tmpSearchString\n";
    &searchInTagMap($newtab,$tmpSearchString,$canvas)

    }

#---------------------------------------------------------------------------------------
sub searchInElementDOM2Map {
&UpdateIndicators2;

    my ($newtab,$search_string,$canvas) = @_;
    print "Recherche : $search_string \n";
    if ($search_string eq "") {
	    &mkPrintErreur("ERREUR : Aucune slection de chane de recherche donne\n");
	    return;
	}
    my %tab = %$newtab;
    foreach my $IndexnodeListChilds (keys %tab) {
	my $nodeListChilds=$tab{$IndexnodeListChilds};
	if (!open(FIC,">MKC-tmp_searchInElementDOM2Map.txt")) {
	    &mkPrintErreur("ERREUR : Impossible d\'ouvrir le fichier MKC-tmp_searchInElementDOM2Map.txt en criture\n");
	    return;
	}	
	my $myTextInNode="";
	&parcourirNodeListDOM2MapandPrint1($nodeListChilds,\$myTextInNode);
	print FIC $myTextInNode;
	close(FIC);

	my $resultat="no";
	if (!open(FIC,"MKC-tmp_searchInElementDOM2Map.txt")) {
	    &mkPrintErreur("ERREUR : Impossible d\'ouvrir le fichier MKC-tmp_searchInElementDOM2Map.txt en lecture\n");
	    return;
	}	
	while (<FIC>) {
	    if (/$search_string/) { $resultat="yes"}
	}
	close(FIC);

	my $color1="red";
	my $color2="white";
	if ($resultat eq "yes") {
	    $canvas->itemconfigure($IndexnodeListChilds, -fill=>$color1);
	}
	else {
	    $canvas->itemconfigure($IndexnodeListChilds, -fill=>$color2);
	}

    }
}

#---------------------------------------------------------------------------------------
sub searchInElementDOM2Map2 {
&UpdateIndicators2;

    my ($newtab1,$newtab2,$search_string,$canvas) = @_;
    print "Recherche : $search_string \n";
    if ($search_string eq "") {
	    &mkPrintErreur("ERREUR : Aucune slection de chane de recherche donne\n");
	    return;
	}
    my %tab1 = %$newtab1;
    my %tab2 = %$newtab2;
    foreach my $IndexnodeListChilds (keys %tab2) {
	my $nodeListChilds=$tab2{$IndexnodeListChilds};
	if (!open(FIC,">MKC-tmp_searchInElementDOM2Map.txt")) {
	    &mkPrintErreur("ERREUR : Impossible d\'ouvrir le fichier MKC-tmp_searchInElementDOM2Map.txt en criture\n");
	    return;
	}	
	my $myTextInNode="";
	&parcourirNodeListDOM2MapandPrint1($nodeListChilds,\$myTextInNode);
	print FIC $myTextInNode;
	close(FIC);

	my $resultat="no";
	if (!open(FIC,"MKC-tmp_searchInElementDOM2Map.txt")) {
	    &mkPrintErreur("ERREUR : Impossible d\'ouvrir le fichier MKC-tmp_searchInElementDOM2Map.txt en lecture\n");
	    return;
	}	
	while (<FIC>) {
	    if (/$search_string/) { $resultat="yes"}
	}
	close(FIC);

	my $color1="red";
	my $color2="white";
	if ($resultat eq "yes") {
	    $canvas->itemconfigure($IndexnodeListChilds, -fill=>$color1);
	}
	else {
	    $canvas->itemconfigure($IndexnodeListChilds, -fill=>$color2);
	}

    }
    foreach my $IndexnodeListChilds (keys %tab1) {
	my $nodeListChilds=$tab1{$IndexnodeListChilds};
	if (!open(FIC,">MKC-tmp_searchInElementDOM2Map.txt")) {
	    &mkPrintErreur("ERREUR : Impossible d\'ouvrir le fichier MKC-tmp_searchInElementDOM2Map.txt en criture\n");
	    return;
	}	
	my $myTextInNode="";
	&parcourirNodeListDOM2MapandPrint1($nodeListChilds,\$myTextInNode);
	print FIC $myTextInNode;
	close(FIC);

	my $resultat="no";
	if (!open(FIC,"MKC-tmp_searchInElementDOM2Map.txt")) {
	    &mkPrintErreur("ERREUR : Impossible d\'ouvrir le fichier MKC-tmp_searchInElementDOM2Map.txt en lecture\n");
	    return;
	}	
	while (<FIC>) {
	    if (/$search_string/) { $resultat="yes"}
	}
	close(FIC);

	my $color1="red";
	my $color2="blue";
	if ($resultat eq "yes") {
	    $canvas->itemconfigure($IndexnodeListChilds, -fill=>$color1);
	}
	else {
	    $canvas->itemconfigure($IndexnodeListChilds, -fill=>$color2);
	}

    }
}

#---------------------------------------------------------------------------------------
sub parcourirNodeListDOM2MapandPrint1 {
&UpdateIndicators2;
    use XML::DOM;
    my ($node,$text) = @_;
    for my $i (0 .. $node->getLength - 1) { 
	my $nodei=$node->item($i);
	my $nodeType = $nodei->getNodeType; 
	if ($nodeType == ELEMENT_NODE) { 
	    my $type = $nodei->getTagName; 
	    my $nodelist = $nodei->getChildNodes;
	    for my $j (0 .. $nodelist->getLength - 1) { 
		my $p=$nodelist->item($j);
		my $t=$p->getNodeType;
		if ($t == TEXT_NODE) {
		    my $content = $p->getData;
		    $$text .= $content;
		    }
		elsif ($t == ELEMENT_NODE) {
		    &parcourirElementDOM2MapandPrint1 ($p,$text);
		}
	    }
	}
	elsif ($nodeType == TEXT_NODE) { 
	    my $content = $nodei->getData;
	    $$text .= $content;
	}
    }
    
}

#---------------------------------------------------------------------------------------
sub parcourirElementDOM2MapandPrint1 {
&UpdateIndicators2;
    use XML::DOM;
    my ($node,$text)=@_;
    foreach my $child ($node->getChildNodes) {
	if ($child->getNodeType==ELEMENT_NODE) {
	    my $name=$child->getNodeName;
	    parcourirElementDOM2MapandPrint1($child,$text);
	} elsif ($child->getNodeType==TEXT_NODE) {
	    my $content = $child->getData;
	    $$text.= $content;
	}
    }
}

#---------------------------------------------------------------------------------------
sub parcourirNodeListDOM2xmlFile {
&UpdateIndicators2;
    use XML::DOM;
    my ($node,$text) = @_;
    for my $i (0 .. $node->getLength - 1) { 
	my $nodei=$node->item($i);
	my $nodeType = $nodei->getNodeType; 
	if ($nodeType == ELEMENT_NODE) { 
	    my $type = $nodei->getTagName; 
	    $$text .= "<$type>";
	    my $nodelist = $nodei->getChildNodes;
	    for my $j (0 .. $nodelist->getLength - 1) { 
		my $p=$nodelist->item($j);
		my $t=$p->getNodeType;
		if ($t == TEXT_NODE) {
		     my $content = $p->getData;
		     $$text .= $content;
		    }
		elsif ($t == ELEMENT_NODE) {
		    my $type = $p->getTagName;
		    $$text .= "<$type>";
		    &parcourirElementDOM2xmlFile ($p,$text);
		    $$text .= "<\/$type>";
		}
	    }
	    $$text .= "<\/$type>";
	}
	elsif ($nodeType == TEXT_NODE) { 
	   
	    my $content = $nodei->getData;
	    $$text .= $content;
	    
	}
    }
    
}

#---------------------------------------------------------------------------------------
sub parcourirElementDOM2xmlFile {
&UpdateIndicators2;
    use XML::DOM;
    my ($node,$text)=@_;
    foreach my $child ($node->getChildNodes) {
	if ($child->getNodeType==ELEMENT_NODE) {
	    my $name=$child->getNodeName;
	    $$text .= "<$name>";
	    parcourirElementDOM2MapandPrint1($child,$text);
	     $$text .= "<\/$name>";
	} elsif ($child->getNodeType==TEXT_NODE) {
	    my $content = $child->getData;
	    $$text.= $content;
	}
    }
}


#---------------------------------------------------------------------------------------
sub searchInTagMap {
&UpdateIndicators2;

    my ($newtab,$search_string,$canvas) = @_;
    if ($search_string eq "") {
	    &mkPrintErreur("ERREUR : Aucune slection de chane de recherche donne\n");
	    return;
	}
    my %tab = %$newtab;
    foreach $tagtmp (keys %tab) {
	my $file="MKC-tmp_MAPFile.txt";
	if (!open(TMPMAPFILE,(">$file"))) {
	    &mkPrintErreur("ERREUR : Impossible d\'ouvrir le fichier $file en criture\n");
	    return;
	}
	print TMPMAPFILE $tab{$tagtmp},"\n";
	print TMPMAPFILE "\n";
	close(TMPMAPFILE);
	if (!open(TMPMAPFILE,("$file"))) {
	    &mkPrintErreur("ERREUR : Impossible d\'ouvrir le fichier $file en lecture\n");
	    return;
	}
	$resultat = "no";
	while (<TMPMAPFILE>) {
	    if ($_=~/$search_string/) {
		$resultat = "yes";
	    }
	}
	close(TMPMAPFILE);
	my $color1="red";
	my $color2="white";
	if ($resultat eq "yes") {
	    $canvas->itemconfigure($tagtmp, -fill=>$color1);
	}
	else {
	    $canvas->itemconfigure($tagtmp, -fill=>$color2);
	}
    }
}

#---------------------------------------------------------------------------------------
sub drawTextWithDOM {
&UpdateIndicators2;
    my %text2map = @_;
    my @selection = $listePn2Map->curselection();
    my $tag="";
    foreach $ind (@selection) {
	$tag.=$listePn2Map->get($ind);
    }
    if ($tag eq "") {
	 foreach $ind ($listePn2SelectionMarkup2->curselection()) {
	     $tag.=$listePn2SelectionMarkup2->get($ind);
	 }
     }
    my $nomsel=$tag;
    $pnDraw->destroy if Exists($pnDraw);
    if (! Exists ($pnDraw)) {
	$winMain::nom_fic=~/([^\/\\]+)$/;
	my $nomFile=$1;
	print "$nomFile\n";
	$pnDraw = $winMain::mw ->Toplevel();
	$pnDraw->title("Map Text Core for $nomFile");
	my $cadre = $pnDraw->Frame->pack(-side => 'left',
					 -fill => 'both', -expand => 1);
	my $cadre2 = $pnDraw->Frame->pack(-side => 'right',
					  -fill => 'both', -expand => 1);
	my $f_label = $cadre->Frame(
				    -bd => 2, 
				    -label => "Text Map For TAGs")->pack(-side => 'top', -fill => 'y');
	my $f0 = $cadre->Frame(
			       -bd => 2)->pack(-side => 'top', -fill => 'y');
	my $f1 = $cadre->Frame(
			       -bd => 2)->pack(-side => 'top', -fill => 'y');
	my $f2 = $cadre->Frame(
			       -bd => 2)->pack(-side => 'top', -fill => 'y');
	my $f3 = $cadre->Frame(
			       -bd => 2)->pack(-side => 'top', -fill => 'y');

	$f0->Button(-text => "Close",
		    -command =>  sub {$pnDraw->destroy()})->pack(-side => 'left', -pady => 5, -padx => 10);

	
        $f0->Menubutton(-text => "Search in Text",
			-tearoff => 0,
			-relief => 'ridge',
			-menuitems => [['command' => "I-Search",
					-command => \&i_search_2],
				       ['command' => "Repeat I-Search",
					-command => \&i_search2_2],
				       ['command' => "Global Search",
					-command => \&search_in_fic_2]
				       ])->pack(-side => 'left');

	my $c = $cadre2->Scrolled("Canvas", -cursor => "crosshair")->pack(
									  -side => 'bottom', -fill => 'both', -expand => 1);

	$canvas = $c->Subwidget("canvas");
	my @textMapFull=();
	%mapTextFull=();
	$texteMp= $cadre->Scrolled("MarkupTools")->pack(-side => 'top',
						     -fill => 'both',
						     -expand => 1);
	my $label = $pnDraw->Label( -background => 'black',
				  -foreground =>  'white', -anchor => 'w' );
	$texteMp->Text(-setgrid => 'true');
	&updateMarkupWindow($texteMp,$label);
	$search_string_map='';
	my $w_string_button = $f1->Button(-text => 'Highlight in Text');
	my $w_string_button1 = $f1->Button(-text => 'No Highlight');
	my $w_string_button3 = $f2->Button(-text => 'ClearSearch');
	my $w_string_button4 = $f2->Button(-text => 'Help');
	my $w_string_button5 = $f2->Button(-text => 'Map2PostScript');
	$w_string_button->pack(-side => 'left', -pady => 5, -padx => 10);
	$w_string_button1->pack(-side => 'left', -pady => 5, -padx => 10);
	$w_string_button3->pack(-side => 'left', -pady => 5, -padx => 10);
	$w_string_button4->pack(-side => 'left', -pady => 5, -padx => 10);
	$w_string_button5->pack(-side => 'left', -pady => 5, -padx => 10);
	$w_string_button->configure(-command => [sub {&text_search($texteMp, $search_string_map, 'search')}, $texteMp]);

	$w_string_button1->configure(-command => [sub {&remove_mark_search_map($texteMp)}]);

	$w_string_button3->configure(-command => [sub {&remove_search_map($texteMp)}]);

	$w_string_button4->configure(-command => [sub {&helpMap2tag($texteMp)}]);
	$w_string_button5->configure(-command => [sub {&map2postscript($c)}]);
	my $w_string2_label = $f3->Label(-text => 'search:', -width => 10, -anchor => 'w');
	my $w_string2_entry = $f3->Entry(-textvariable => \$search_string_map);
	my $w_string2_button = $f3->Button(-text => 'search in Map');
	$w_string2_label->pack(-side => 'left');
	$w_string2_entry->pack(-side => 'left');
	$w_string2_button->pack(-side => 'left', -pady => 5, -padx => 10);
	$w_string2_button->configure(-command => [sub {&searchInElementDOM2Map(\%mapTextFull,$search_string_map,$c)}]);
	$w_string2_entry->bind('<Return>' => [sub {&searchInElementDOM2Map(\%mapTextFull,$search_string_map,$c)}]);
	if ($pnDraw->depth > 1) {
	    &text_toggle($texteMp, ['configure', 'search', -background => 'SeaGreen4', -foreground => 'white'], 800,
			['configure', 'search', -background => undef,       -foreground => undef],   200);
	} else {
	    &text_toggle($texteMp, ['configure', 'search', -background => 'black',     -foreground => 'white'], 800,
			['configure', 'search', -background => undef,       -foreground => undef],   200);
	}
#-----------------------
	my $coordx=15;
	my $coordy=15;
	my $mark=0;
	$markname = "car".$mark;
	my $color1="blue";
	my $color2="red";
	my $color3="white";
	my $color4="yellow";
	my $color5="black";
	my $color6="green";
	@color = ($color1,$color2,$color3,$color4,$color5,$color6);
	my %tmpcolor =();
	my $newcolor ="";
	my $tmpTagColor;
	foreach my $tagtmp (keys %text2map) {
	    my @tag = $tagtmp;
	    if ($newcolor eq "") {
		$newcolor=$color[0];
		my $tmp33 = shift(@color);
		push(@color,$tmp33);
		$tmpcolor{$tmpTagColor}=$newcolor;
		}
	    if (!exists($tmpcolor{$tmpTagColor})) {
		$newcolor=$color[0]; 
		my $tmp33 = shift(@color);
		push(@color,$tmp33);
		$tmpcolor{$tmpTagColor}=$newcolor;
		}
	    $id = $canvas->createRectangle($coordx,$coordy,$coordx+10,$coordy+10,-fill=>$newcolor,-tags => $markname);
	    $mapTextFull{$id}=$text2map{$tagtmp};
#	    my $parent=$tagtmp->getParentNode;
	    my $name="";
#		$parent->getNodeName;
	    $canvas->bind($markname,"<Button-1>", sub {&parcourirElementDOM2Map($name,$text2map{$tagtmp},$texteMp)});

	    $canvas->bind($markname,"<Button-3>", sub {&childElementDOM2Map($text2map{$tagtmp})});
	    $coordx+=15;
	    if ($coordx > 300){ 
		$coordx=15; 
		$coordy+=15;
	    }
	    $mark++;
	    $markname = "car".$mark;
	}

	$canvas->bind('all','<ButtonPress>',\&start_move);

    }
#    else {
#	$pnDraw->destroy();
#    }

}

#---------------------------------------------------------------------------------------
sub drawTextWithDOM2 {
&UpdateIndicators2;
    my ($tag,%text2map) = @_;
    $pnDraw->destroy if Exists($pnDraw);
    if (! Exists ($pnDraw)) {
	$winMain::nom_fic=~/([^\/\\]+)$/;
	#-------SPLASH REFRESH
	&splashProgress( "Work In Progress...", 55 );
	#-------SPLASH REFRESH
	
	my $nomFile=$1;
	print "$nomFile\n";
	$pnDraw = $winMain::mw ->Toplevel();
	$pnDraw->title("Map Text Core for $nomFile");
	$pnDraw->withdraw;
	my $cadre = $pnDraw->Frame->pack(-side => 'left',
					 -fill => 'both', -expand => 1);
	my $cadre2 = $pnDraw->Frame->pack(-side => 'right',
					  -fill => 'both', -expand => 1);
	
	my $f_label = $cadre->Frame(
				    -bd => 2, 
				    -label => "Text Map For TAGs")->pack(-side => 'top', -fill => 'y');
	my $f0 = $cadre->Frame(
			       -bd => 2)->pack(-side => 'top', -fill => 'y');
	my $f1 = $cadre->Frame(
			       -bd => 2)->pack(-side => 'top', -fill => 'y');
	my $f2 = $cadre->Frame(
			       -bd => 2)->pack(-side => 'top', -fill => 'y');
	my $f3 = $cadre->Frame(
			       -bd => 2)->pack(-side => 'top', -fill => 'y');
	
	$f0->Button(-text => "Close",
		    -command =>  sub {$pnDraw->destroy()})->pack(-side => 'left', -pady => 5, -padx => 10);

	
        $f0->Menubutton(-text => "Search in Text",
			-tearoff => 0,
			-relief => 'ridge',
			-menuitems => [['command' => "I-Search",
					-command => \&i_search_2],
				       ['command' => "Repeat I-Search",
					-command => \&i_search2_2],
				       ['command' => "Global Search",
					-command => \&search_in_fic_2]
				       ])->pack(-side => 'left');


	my $c = $cadre2->Scrolled("Canvas", -cursor => "crosshair", -width => "15.0c",-height => "20.0c")->pack(
									  -side => 'bottom', -fill => 'both', -expand => 1);
	
	$canvas = $c->Subwidget("canvas");
	my @textMapFull=();
	%mapTextFull=();
	%mapTextFull2=();
	my $label = $pnDraw->Label( -background => 'black',
				    -foreground =>  'white', -anchor => 'w' );
	$texteMp= $cadre->Scrolled("MarkupTools")->pack(-side => 'top',
						     -fill => 'both',
						     -expand => 1);
	$texteMp->Text(-setgrid => 'true');
	&updateMarkupWindow($texteMp,$label);
	$search_string_map='';
	my $w_string_button = $f1->Button(-text => 'Highlight in Text');
	my $w_string_button1 = $f1->Button(-text => 'No Highlight');
	my $w_string_button3 = $f2->Button(-text => 'ClearSearch');
	my $w_string_button4 = $f2->Button(-text => 'Help');
	my $w_string_button5 = $f2->Button(-text => 'Map2PostScript');
	my $w_string_button6 = $f2->Button(-text => 'Select Node (DOM)');
	my $w_string_button7 = $f2->Button(-text => 'Extract Node with Search_string (DOM)');

	$w_string_button->pack(-side => 'left', -pady => 5, -padx => 10);
	$w_string_button1->pack(-side => 'left', -pady => 5, -padx => 10);
	$w_string_button3->pack(-side => 'left', -pady => 5, -padx => 10);
	$w_string_button4->pack(-side => 'left', -pady => 5, -padx => 10);
	$w_string_button5->pack(-side => 'left', -pady => 5, -padx => 10);
	$w_string_button6->pack(-side => 'left', -pady => 5, -padx => 10);
	$w_string_button7->pack(-side => 'left', -pady => 5, -padx => 10);

	$w_string_button->configure(-command => [sub {&text_search($texteMp, $search_string_map, 'search')}, $texteMp]);

	$w_string_button1->configure(-command => [sub {&remove_mark_search_map($texteMp)}]);
	$w_string_button3->configure(-command => [sub {&remove_search_map($texteMp)}]);
	$w_string_button4->configure(-command => [sub {&helpMap2tag2($texteMp)}]);
	$w_string_button5->configure(-command => [sub {&map2postscript($c)}]);
	$w_string_button6->configure(-command => [sub {&xmlDomExtractTag1}]);
	$w_string_button7->configure(-command => [sub {&xmlDomExtractTagWithSearchStringInMap}]);


	my $w_string2_label = $f3->Label(-text => 'search:', -width => 10, -anchor => 'w');
	my $w_string2_entry = $f3->Entry(-textvariable => \$search_string_map);
	my $w_string2_button = $f3->Button(-text => 'search in Map');
	$w_string2_label->pack(-side => 'left');
	$w_string2_entry->pack(-side => 'left');
	$w_string2_button->pack(-side => 'left', -pady => 5, -padx => 10);
	$w_string2_button->configure(-command => [sub {&searchInElementDOM2Map2(\%mapTextFull2,\%mapTextFull,$search_string_map,$c)}]);
	$w_string2_entry->bind('<Return>' => [sub {&searchInElementDOM2Map2(\%mapTextFull2,\%mapTextFull,$search_string_map,$c)}]);
	if ($pnDraw->depth > 1) {
	    &text_toggle($texteMp, ['configure', 'search', -background => 'SeaGreen4', -foreground => 'white'], 800,
			['configure', 'search', -background => undef,       -foreground => undef],   200);
	} else {
	    &text_toggle($texteMp, ['configure', 'search', -background => 'black',     -foreground => 'white'], 800,
			['configure', 'search', -background => undef,       -foreground => undef],   200);
	}
#-----------------------
	my $coordx=15;
	my $coordy=15;
	my $mark=0;
	$markname = "car".$mark;
	my $color1="blue";
	my $color2="red";
	my $color3="white";
	my $color4="yellow";
	my $color5="black";
	my $color6="green";
	@color = ($color1,$color2,$color3,$color4,$color5,$color6);
	my %tmpcolor =();
	my $newcolor ="";
	my $tmpTagColor;
#-------SPLASH REFRESH
	&splashProgress( "Work In Progress...", 75 );
#-------SPLASH REFRESH

	foreach my $tagtmp (keys %text2map) {
	    my $child=$text2map{$tagtmp};
	    my @child=@$child;
	    my $children=$child[1];
	    my $firstchild=$child[0];
	    my @tag = $tagtmp;
	    if ($newcolor eq "") {
		$newcolor=$color[0];
		my $tmp33 = shift(@color);
		push(@color,$tmp33);
		$tmpcolor{$tmpTagColor}=$newcolor;
		}
	    if (!exists($tmpcolor{$tmpTagColor})) {
		$newcolor=$color[0]; 
		my $tmp33 = shift(@color);
		push(@color,$tmp33);
		$tmpcolor{$tmpTagColor}=$newcolor;
		}

	    $id = $canvas->createRectangle($coordx+10,$coordy,$coordx+20,$coordy+10,-fill=>$newcolor,-tags => $markname);
	    $mapTextFull{$id}=$children;
	    $id = $canvas->createText($coordx+10,$coordy-5,-text => $tag, -justify=> "center", -fill => "black",-tags => $markname);
	    $mapTextFull2{$id}=$children;

	    $canvas->bind($markname,"<Button-1>", sub {&parcourirElementDOM2Map($tag,$children,$texteMp)});

	    $coordx+=15;
	    if ($coordx > 300){ 
		$coordx=15; 
		$coordy+=15;
	    }
	    $mark++;
	    $markname = "car".$mark;
################################	
#           display tree
	    &drawchildElementDOM2Map1($firstchild,\$mark,$texteMp,\$coordx,\$coordy,$c,\%mapTextFull,\%mapTextFull2);
################################
	    $canvas->bind('all','<ButtonPress>',\&start_move);
	    #-------SPLASH REFRESH
	    &splashProgress( "Work In Progress...", 55 );
	    #-------SPLASH REFRESH

	}
	$pnDraw->deiconify;
	$pnDraw->raise;
    }
}


#---------------------------------------------------------------------------------------
sub drawchildElementDOM2Map1 {
&UpdateIndicators2;
    use XML::DOM;
    my ($node,$mark,$texteMp,$coordx,$coordy,$c,$mapTextFull, $mapTextFull2)=@_;
    my @graphxy;
    push(@graphxy,$$coordx);
    push(@graphxy,$$coordy);
    $$coordx+=50;
    my $p=$node;
    for ($p; defined $p; $p=$p->getNextSibling) {
	my @graphxy1;
	my $nodeType = $p->getNodeType; 
	if ($nodeType == ELEMENT_NODE) { 
	    my $nodelist = $p->getFirstChild;
	    my $nodelist1 = $p->getChildNodes;
	    my $name=$p->getNodeName;
	    my $newcolor="yellow";
	    $id = $c->createRectangle($$coordx,$$coordy,$$coordx+10,$$coordy+10,-fill=>$newcolor,-tags => $markname);
	    $$mapTextFull{$id}=$nodelist1;
	    $c->bind($markname,"<Button-1>", sub {&parcourirElementDOM2Map($name,$nodelist1,$texteMp)});

	    $c->bind($markname,"<Button-3>", sub {&saveMapNode2xmlFile($name,$nodelist1,$texteMp)});
	    $id = $c->createText($$coordx+10,$$coordy-5,-text => $name, -justify=> "center",-fill => "black",-tags => $markname);
	    $$mapTextFull2{$id}=$nodelist1;
	    push(@graphxy,$$coordx+10);
	    push(@graphxy,$$coordy+10);
	    push(@graphxy1,$$coordx+10);
	    push(@graphxy1,$$coordy+10);
	    $$mark++;
	    $markname = "car".$$mark;	
	    my $tmpp=$p->getNextSibling;
###########################################################################
#a verifier....
###########################################################################
	    if ((($nodelist1->getLength - 1) eq -1) && (defined $tmpp)) { 
		$$coordy+=20;
		}
############################################################################
	    for my $j (0 .. $nodelist1->getLength - 1) { 
		my $p2=$nodelist1->item($j);
		my $t=$p2->getNodeType;
		if ($t == TEXT_NODE) {
		    my $content = $p2->getData;
		    my $tmp=$content;
		    if ($tmp =~/^$/) {
#			print "VIDE\n";
		    }
		    else {
			my $newcolor="black";
			$id = $c->createRectangle($$coordx + 50,$$coordy,$$coordx+60,$$coordy+10,-fill=>$newcolor,-tags => $markname);
			$c->bind($markname,"<Button-1>", sub {&mkPrintMsgInfo("CONTENT: [$content]\n\nPas de noeud fils, vous tes sur une feuille de l\'arbre...\n");});
			push(@graphxy1,$$coordx+50);
			push(@graphxy1,$$coordy);
			$$mark++;
			$markname = "car".$$mark;	
			$$coordy+=20;
		    }
		}
		elsif ($t == ELEMENT_NODE) {
		    my $name=$p2->getNodeName;
		    my $newcolor="green";
		    my $nodelist11 = $p2->getFirstChild;
		    my $nodelist111 = $p2->getChildNodes;
		    
		    $id = $c->createRectangle($$coordx +50,$$coordy,$$coordx+60,$$coordy+10,-fill=>$newcolor,-tags => $markname);
		    $$mapTextFull{$id}=$nodelist111;
		    $c->bind($markname,"<Button-1>", sub {&parcourirElementDOM2Map($name,$nodelist111,$texteMp)});
		    $c->bind($markname,"<Button-3>", sub {&saveMapNode2xmlFile($name,$nodelist111,$texteMp)});
		    $id=$c->createText($$coordx + 50,$$coordy-5, -text => $name, -justify=> "center",-fill => 'black',-tags => $markname);
		    $$mapTextFull2{$id}=$nodelist111;
		    @graphxy1;
		    push(@graphxy1,$$coordx+50);
		    push(@graphxy1,$$coordy);
		    $$mark++;
		    $markname = "car".$$mark;	
		    my $newX=$$coordx+50;
		    
		    &drawchildElementDOM2Map1($nodelist11,$mark,$texteMp,\$newX,$coordy,$c,$mapTextFull, $mapTextFull2);
		    $$coordy+=20;
		}
	    }
	}
	elsif ($nodeType == TEXT_NODE) { 
	    my $content = $p->getData;
	}
	
	if ($#graphxy1 > 0){
	    &drawProfondeur($c,@graphxy1);
	    }
    }

    if ($#graphxy > 0){
	&drawProfondeur($c,@graphxy);
    }
}

#---------------------------------------------------------------------------------------
sub map2postscript {
&UpdateIndicators2;

    my ($canvas)=@_;
    $canvas->postscript(-file => "MKC-tmp_map.ps");
    &mkPrintMsgInfo("Gnration du Fichier Postscript MKC-tmp_map.ps termine.\n");

}


#---------------------------------------------------------------------------------------
sub drawProfondeur {
&UpdateIndicators2;
    my ($c,@tabxy)=@_;
    my $x=shift(@tabxy);
    my $y=shift(@tabxy);
    while(@tabxy) {
	my $xf= shift(@tabxy);
	my $yf= shift(@tabxy);
	$c->createLine($x,$y,$xf,$yf,-arrow => 'last', -fill => 'blue');
#	$c->createLine($x,$y,$xf,$yf,-arrow => 'last',-smooth => 1, -fill => 'blue');
    }
}

#---------------------------------------------------------------------------------------
sub saveMapNode2xmlFile {
&UpdateIndicators2;
    my ($name,$nodelist1,$texteMp)=@_;
    if (!open(FIC,">MKC-tmp_".$name.".txt")) {
	    &mkPrintErreur("ERREUR : Impossible d\'ouvrir le fichier MKC-tmp_$name.txt en criture\n");
	    return;
	}	    
    my $myTextInNode="";
    $myTextInNode.="<$name>";
    &parcourirNodeListDOM2xmlFile($nodelist1,\$myTextInNode);
    $myTextInNode.="<\/$name>";
    print FIC "<?xml version=\"1.0\" encoding=\"ISO-8859-1\" standalone=\"yes\"?>\n";
    print FIC $myTextInNode;
    close(FIC);
    my $tmpfile="MKC-tmp_".$name.".txt";
    my $msg="MKC-tmp_".$name.".txt";
    &IncludedFileInWindow($tmpfile,$msg);

}

#---------------------------------------------------------------------------------------
sub drawText {
&UpdateIndicators2;
    my (@tab) = @_;
    my $sel=pop(@tab);
    my %sel2 = %$sel;
    print %sel2,"\n";
    my $nomsel ="";
    foreach $selx (keys %sel2) {
	$nomsel="$nomsel"."<"."$sel2{$selx}".">";
    }
    $pnDraw->destroy if Exists($pnDraw);

    if (! Exists ($pnDraw)) {
	$winMain::nom_fic=~/([^\/\\]+)$/;
	my $nomFile=$1;
	print "$nomFile\n";
	$pnDraw = $winMain::mw ->Toplevel();
	$pnDraw->title("Map Text Core for $nomFile");
	my $cadre = $pnDraw->Frame->pack(-side => 'left',
					 -fill => 'both', -expand => 1);
	my $cadre2 = $pnDraw->Frame->pack(-side => 'right',
					 -fill => 'both', -expand => 1);
	my $f_label = $cadre->Frame(
                -bd => 2, 
                -label => "Text Map For TAGs")->pack(-side => 'top', -fill => 'y');


	my $f0 = $cadre->Frame(
                -bd => 2)->pack(-side => 'top', -fill => 'y');
	my $f1 = $cadre->Frame(
                -bd => 2)->pack(-side => 'top', -fill => 'y');
	my $f2 = $cadre->Frame(
                -bd => 2)->pack(-side => 'top', -fill => 'y');
	my $f3 = $cadre->Frame(
                -bd => 2)->pack(-side => 'top', -fill => 'y');

	$f0->Button(-text => "Close",
		     -command =>  sub {$pnDraw->destroy()})->pack(-side => 'left', -pady => 5, -padx => 10);


        $f0->Menubutton(-text => "Search in Text",
			   -tearoff => 0,
			   -relief => 'ridge',
			   -menuitems => [['command' => "I-Search",
					-command => \&i_search_2],
				       ['command' => "Repeat I-Search",
					-command => \&i_search2_2],
				       ['command' => "Global Search",
					-command => \&search_in_fic_2]
					  ])->pack(-side => 'left');

	my $c = $cadre2->Scrolled("Canvas", -cursor => "crosshair")->pack(
								   -side => 'bottom', -fill => 'both', -expand => 1);

	$canvas = $c->Subwidget("canvas");
#-----------------------
	my @textMapFull=();
	%mapTextFull=();
#-----------------------
	my $label = $pnDraw->Label( -background => 'black',
				  -foreground =>  'white', -anchor => 'w' );
	$texteMp= $cadre->Scrolled("MarkupTools")->pack(-side => 'top',
			      -fill => 'both',
	    		      -expand => 1);
	$texteMp->Text(-setgrid => 'true');
	&updateMarkupWindow($texteMp,$label);
#-----------------------
	$search_string_map='';
	my $w_string_button = $f1->Button(-text => 'Highlight in Text');
	my $w_string_button1 = $f1->Button(-text => 'No Highlight');
	my $w_string_button3 = $f2->Button(-text => 'ClearSearch');
	my $w_string_button4 = $f2->Button(-text => 'TAG List All Square');
	my $w_string_button5 = $f2->Button(-text => 'HELP');
	$w_string_button->pack(-side => 'left', -pady => 5, -padx => 10);
	$w_string_button1->pack(-side => 'left', -pady => 5, -padx => 10);
	$w_string_button3->pack(-side => 'left', -pady => 5, -padx => 10);
	$w_string_button4->pack(-side => 'left', -pady => 5, -padx => 10);
	$w_string_button5->pack(-side => 'left', -pady => 5, -padx => 10);
	$w_string_button->configure(-command => [sub {&text_search($texteMp, $search_string_map, 'search')}, $texteMp]);
	$w_string_button1->configure(-command => [sub {&remove_mark_search_map($texteMp)}]);
	$w_string_button3->configure(-command => [sub {&remove_search_map($texteMp)}]);
	$w_string_button4->configure(-command => [sub {&liste_alltag_map(\%mapTextFull,$c)}]);
	$w_string_button5->configure(-command => [sub {&helpMap2tag($texteMp)}]);


	my $w_string2_label = $f3->Label(-text => 'search:', -width => 10, -anchor => 'w');
	my $w_string2_entry = $f3->Entry(-textvariable => \$search_string_map);
	my $w_string2_button = $f3->Button(-text => 'search in Map');
	$w_string2_label->pack(-side => 'left');
	$w_string2_entry->pack(-side => 'left');
	$w_string2_button->pack(-side => 'left', -pady => 5, -padx => 10);
	$w_string2_button->configure(-command => [sub {&searchInTagMap(\%mapTextFull,$search_string_map,$c)}]);
	$w_string2_entry->bind('<Return>' => [sub {&searchInTagMap(\%mapTextFull,$search_string_map,$c)}]);


    if ($pnDraw->depth > 1) {
	&text_toggle($texteMp, ['configure', 'search', -background => 'SeaGreen4', -foreground => 'white'], 800,
		          ['configure', 'search', -background => undef,       -foreground => undef],   200);
      } else {
	&text_toggle($texteMp, ['configure', 'search', -background => 'black',     -foreground => 'white'], 800,
		          ['configure', 'search', -background => undef,       -foreground => undef],   200);
      }


#-----------------------
	my $coordx=15;
	my $coordy=15;
	my $mark=0;
	$markname = "car".$mark;
	my $color1="blue";
	my $color2="red";
	my $color3="white";
	my $color4="yellow";
	my $color5="black";
	my $color6="green";
	@color = ($color1,$color2,$color3,$color4,$color5,$color6);
	my %tmpcolor =();
	my $newcolor ="";
	foreach $tagtmp (@tab) {
	    my %tag = %$tagtmp;
	    my @liste = keys(%tag);
	    $liste[0]=~/<([^=]+)=[^>]+>/;
	    my $tmpTagColor = $1;
	    if ($newcolor eq "") {
		$newcolor=$color[0];
		my $tmp33 = shift(@color);
		push(@color,$tmp33);
		$tmpcolor{$tmpTagColor}=$newcolor;
		}
	    if (!exists($tmpcolor{$tmpTagColor})) {
		$newcolor=$color[0]; 
		my $tmp33 = shift(@color);
		push(@color,$tmp33);
		$tmpcolor{$tmpTagColor}=$newcolor;
		}
	    $id = $canvas->createRectangle($coordx,$coordy,$coordx+10,$coordy+10,-fill=>$newcolor,-tags => $markname);
	    $textMapFull[$mark]=$tag{$liste[0]};
	    $mapTextFull{$id}=$tag{$liste[0]};
	    my %mapTextFull2=();
	    $mapTextFull2{$id}=$tag{$liste[0]};
	    
	    my @tmpTabContent = ();
	    $tmpTabContent[0]= $tag{$liste[0]};
	    $canvas->bind($markname,"<Button-1>", sub {&displayContentTag(\@tmpTabContent,$texteMp)});
	    $canvas->bind($markname,"<Button-3>", sub {&displayTagSquare(\%mapTextFull2,$texteMp,$c,\@tmpTabContent,\%mapTextFull)});
	    $coordx+=15;
	    if ($coordx > 300){ 
		$coordx=15; 
		$coordy+=15;
	    }
	    $mark++;
	    $markname = "car".$mark;
	}

	$canvas->bind('all','<ButtonPress>',\&start_move);

    }
}

#----------------------------------

sub childElementDOM2Map {
&UpdateIndicators2;

    my ($tab) = @_;
    @listxmlDomExtractTag=();
    %listxmlDomExtractTag=();
    use XML::DOM;
    foreach my $node ($tab) {
	
	&parcourirElementDOM2Map1($node); 
    }
    
    $pnDrawSelectionMarkup2->destroy if Exists($pnDrawSelectionMarkup2);
    $pnDrawSelectionMarkup2 = $winMain::mw ->Toplevel();
    $pnDrawSelectionMarkup2->title("Children List");
    
    $listePn2SelectionMarkup2=$pnDrawSelectionMarkup2->Scrolled("Listbox", -scrollbars => "e",
								-selectmode => "extended",
							      -selectforeground => "red",
								-setgrid => 1,
								-width => -1)->pack();
    
    $pnDrawSelectionMarkup2->Button(-text => "Make New Map-TAG",
				    -command =>  sub{&make_text2mapWithDOM2})->pack(-side => 'left', -pady => 5, -padx => 10);
    
    $pnDrawSelectionMarkup2->Button(-text => "Close",
				    -command =>  sub {$pnDrawSelectionMarkup2->destroy()})->pack(-side => 'left', -pady => 5, -padx => 10);
    

    if ($#listxmlDomExtractTag > 0) {
	$listePn2SelectionMarkup2->delete(0,'end');
	$listePn2SelectionMarkup2->insert('end',@listxmlDomExtractTag);
    }
    else {
	$pnDrawSelectionMarkup2->destroy if Exists($pnDrawSelectionMarkup2);
	&mkPrintMsgInfo("Pas de noeud fils, vous tes sur une feuille de l\'arbre...\n");
    }

}


#---------------------------------------------------------------------------------------
sub displayTagSquare {

    my ($tab,$texte,$canvas,$tabsquare,$alltabsquare) = @_;
    my %newtab = %$tab;
 
    my @liste_balises=();
    my %Liste_Markups=();
    my $id = 0; 
 
    foreach $tagtmp (keys %newtab) {
	$newtab{$tagtmp}=~s/(> )/$1\n/gi;
	my $file="MKC-tmp_MAPFile.txt";
	if (!open(TMPMAPFILE,(">$file"))) {
	    &mkPrintErreur("ERREUR : Impossible d\'ouvrir le fichier $file en criture\n");
	    return;
	}
	print TMPMAPFILE $newtab{$tagtmp},"\n";
	close(TMPMAPFILE);
	if (!open(TMPMAPFILE,("$file"))) {
	    &mkPrintErreur("ERREUR : Impossible d\'ouvrir le fichier $file en lecture\n");
	    return;
	}
	while(<TMPMAPFILE>) {
	    while (/(<[^\/][^>]+>)/g) {
		if (!exists ($Liste_Markups{$1})) {
		    $Liste_Markups{$1}++;
		    $liste_balises[$id]=$1;
		    $id++;
		}
	    }
	}
	close(TMPMAPFILE);
    }    
    
    $pnDrawSelectionMarkup2->destroy if Exists($pnDrawSelectionMarkup2);
    $pnDrawSelectionMarkup2 = $winMain::mw ->Toplevel();
    $pnDrawSelectionMarkup2->title("Slection Noeuds-Fils");
    $listePn2SelectionMarkup2=$pnDrawSelectionMarkup2->Scrolled("Listbox", -scrollbars => "e",
							      -selectmode => "extended",
							      -selectforeground => "red",
							      -setgrid => 1,
							      -width => -1)->pack();
    $pnDrawSelectionMarkup2->Button(-text => "Search TAG",
				   -command =>  sub{&search_tag_in_map2($alltabsquare,$canvas)})->pack(-side => 'left', -pady => 5, -padx => 10);
    $pnDrawSelectionMarkup2->Button(-text => "Make New Map-TAG",
				   -command =>  sub{&make_text2map2($tabsquare)})->pack(-side => 'left', -pady => 5, -padx => 10);
    $pnDrawSelectionMarkup2->Button(-text => "Close",
				   -command =>  sub {$pnDrawSelectionMarkup2->destroy()})->pack(-side => 'left', -pady => 5, -padx => 10);
    
	if ($#liste_balises > 0) {
	    $listePn2SelectionMarkup2->delete(0,'end');
	    $listePn2SelectionMarkup2->insert('end',@liste_balises);
	}
	else {
	    $pnDrawSelectionMarkup2->destroy if Exists($pnDrawSelectionMarkup2);
	    &mkPrintMsgInfo("Pas de noeud fils, vous tes sur une feuille de l\'arbre...\n");
	}

}

#----------------------------------
sub displayContentTag {
&UpdateIndicators2;

    my ($tab,$texte) = @_;
    my @newtab = @$tab;
#    &mkPrintTagContent($newtab[0]);
    $texte->delete("1.0","end");
    $newtab[0]=~s/(> )/$1\n/gi;
    $texte->insert('0.0', $newtab[0]);
}

#----------------------------------
sub parcourirElementDOM2Map {
&UpdateIndicators2;
    my ($name,$node,$texte) = @_;
    $texte->delete("1.0","end");
    $texte->insert('end',"Contenu Textuel de l\'ELEMENT : $name \n\n");
    parcourirNodeListDOM2MapandPrint ($node,$texte);
}

#---------------------------------------------------------------------------------------
sub parcourirElementDOM2Map1 {
&UpdateIndicators2;
    my ($node) = @_;
    parcourirNodeListDOM2Map1andPrint1 ($node);
}

#---------------------------------------------------------------------------------------
sub parcourirNodeListDOM2MapandPrint {
&UpdateIndicators2;
    use XML::DOM;
    my ($node,$texte) = @_;
    for my $i (0 .. $node->getLength - 1) { 
	my $nodei=$node->item($i);
	my $nodeType = $nodei->getNodeType; 
	if ($nodeType == ELEMENT_NODE) { 
	    my $type = $nodei->getTagName; 
	   
	    my $nodelist = $nodei->getChildNodes;
	    for my $j (0 .. $nodelist->getLength - 1) { 
		my $p=$nodelist->item($j);
		my $t=$p->getNodeType;
		if ($t == TEXT_NODE) {
		    my $content = "[".$p->getData."]";
		    $texte->insert('end',$content);
		    }
		elsif ($t == ELEMENT_NODE) {
		    &parcourirElementDOM2MapandPrint ($p,$texte);
		}
	    }
	}
	elsif ($nodeType == TEXT_NODE) { 
	    my $content = "[".$nodei->getData."]";
	    $texte->insert('end',$content);
	}
    }
}

#---------------------------------------------------------------------------------------
sub parcourirNodeListDOM2Map1andPrint1 {
&UpdateIndicators2;
    use XML::DOM;
    my ($node) = @_;
    for my $i (0 .. $node->getLength - 1) { 
	my $nodei=$node->item($i);
	my $nodeType = $nodei->getNodeType; 
	if ($nodeType == ELEMENT_NODE) { 
	    my $type = $nodei->getTagName; 
	    if (!exists ($listxmlDomExtractTag{$type})) {
		    $listxmlDomExtractTag{$type}="#ELEMENT_NODE#";
		    push(@listxmlDomExtractTag,$type);
		}
	    my $nodelist = $nodei->getChildNodes;
	    for my $j (0 .. $nodelist->getLength - 1) { 
		my $p=$nodelist->item($j);
		my $t=$p->getNodeType;
		if ($t == TEXT_NODE) {
		    my $content = $p->getData;
		    $listxmlDomExtractTag{"TEXT_NODE"}=$content;
		    }
		elsif ($t == ELEMENT_NODE) {
		     my $type = $p->getTagName; 
		     if (!exists ($listxmlDomExtractTag{$type})) {
			 $listxmlDomExtractTag{$type}="#ELEMENT_NODE#";
			 push(@listxmlDomExtractTag,$type);
		     }
		     &parcourirElementDOM2Map1andPrint1($p);
		}
	    }
	}
	elsif ($nodeType == TEXT_NODE) { 
	    my $content = $nodei->getData;
	    $listxmlDomExtractTag{"TEXT_NODE"}=$content;
	}
    }
}

#---------------------------------------------------------------------------------------
sub parcourirElementDOM2MapandPrint {
&UpdateIndicators2;
    my ($node,$texte)=@_;
    foreach my $child ($node->getChildNodes) {
	if ($child->getNodeType==ELEMENT_NODE) {
	    my $name=$child->getNodeName;
	    my $val= parcourirElementDOM2MapandPrint($child,$texte);
	} elsif ($child->getNodeType==TEXT_NODE) {
	    my $content = "[".$child->getData."]";
	    $texte->insert('end',$content);
	}
    }
}

#---------------------------------------------------------------------------------------
sub parcourirElementDOM2Map1andPrint1 {
&UpdateIndicators2;
    my ($node,$texte)=@_;
    foreach my $child ($node->getChildNodes) {
	if ($child->getNodeType==ELEMENT_NODE) {
	    my $type = $child->getTagName; 
	    if (!exists ($listxmlDomExtractTag{$type})) {
		$listxmlDomExtractTag{$type}="#ELEMENT_NODE#";
		push(@listxmlDomExtractTag,$type);
		}
	    my $name=$child->getNodeName;
	    my $val= parcourirElementDOM2Map1andPrint1($child);
	} elsif ($child->getNodeType==TEXT_NODE) {
	    my $content = $child->getData;
	    $listxmlDomExtractTag{"TEXT_NODE"}=$content;
	}
    }
}

#----------------------------------
sub extract_tagtext_in_balise {
&UpdateIndicators2;
    my @selection = $listePntag->curselection();
    my $tmp_nomfic=$winMain::nom_fic;
    open(TMPCATFILE,">MKC-tmp_catExtractTextInMarkup.txt");

    foreach $ind (@selection) {
	my $element=$listePntag->get($ind);
	$element=~/<([^>]+)>/;
	my $tmp=$1;
	my $tmp2="";
	if ($element=~/<([^ ]+) type=\"([^\"]*)\">/) {$tmp=$1;
					    $tmp2=$2;}
	my $balise_name = $tmp."-".$tmp2;
	my $nom_fic2="MKC-tmp_ExtractText_".$balise_name.".txt";
#	print "$nom_fic2\n";
	&extract_tagbalise($element);
	open(TMPFILEEXTRACT,$nom_fic2);
	while(<TMPFILEEXTRACT>){
	    print TMPCATFILE $_;
	}
	close(TMPFILEEXTRACT);
	}	
    close(TMPCATFILE);

    my $tmpfile="MKC-tmp_catExtractTextInMarkup.txt";
    $mkExtractTextInMarkup->destroy if Exists($mkExtractTextInMarkup);
    $mkExtractTextInMarkup = $winMain::mw->Toplevel();
    my $w = $mkExtractTextInMarkup;
    $w->title('Extract Text');
    $w->iconname('Extract');
    my $w_ok = $w->Button(-text => 'OK', -width => 8, -command => ['destroy', $w]);
    my $w_t = $w->TextUndo(-setgrid => 'true', -width => '60', -height => '28',
			-font => '-Adobe-Helvetica-Bold-R-Normal--*-120-*-*-*-*-*-*');
    my $w_save = $w->Button(-text => "Save",
			    -image => $winMain::imageSave,
			    -command => sub {$w_t->FileSaveAsPopup()})->pack(-side => 'top', -pady => 5, -padx => 10);

    $winMain::winBalloon->attach($w_save,
                  -balloonmsg => "Save"
               );

    my $w_s = $w->Scrollbar(-command => ['yview', $w_t]);
    $w_t->configure(-yscrollcommand => ['set', $w_s]);
    $w_ok->pack(-side => 'top', -pady => 5, -padx => 10);
    $w_s->pack(-side => 'right', -fill => 'y');
    $w_t->pack(-expand => 'yes', -fill => 'both');

    # Set up display styles

    my(@bold, @normal, $tags);
    if ($mkExtractTextInMarkup->depth > 1) {
	@bold = (-foreground => 'red');
	@normal = (-foreground => undef);
    } else {
	@bold = (-foreground => 'white', -background => 'black');
	@normal = (-foreground => undef, -background => undef);
    }

    $w_t->insert('0.0', 'Extract Results...');
    $w_t->insert("end","\n\n");
    $w_t->IncludeFile($tmpfile);
    
}

#---------------------------------------------
sub delete_selected_balise {
&UpdateIndicators2;

    my @selection = $listePn2->curselection();
    foreach $ind (@selection) {
	my $element=$listePn2->get($ind);
	&text_delete($winMain::texte, $element, 'search');
	$element=~/<([^>]+)>/;
	my $new_element="<\/$1>";
	&text_delete($winMain::texte, $new_element, 'search');


    }

}
#---------------------------------------------
sub modify_selected_balise {
&UpdateIndicators2;
    my @selection = $listePn2->curselection();
    foreach $ind (@selection) {
	my $element=$listePn2->get($ind);
	&query_replace($element);
    }
}

#---------------------------------------------
sub modify_selected_char {
&UpdateIndicators2;
    my @selection = $listePnChangeChar->curselection();
    foreach $ind (@selection) {
	my $element=$listePnChangeChar->get($ind);
	&query_replace($element);
    }
}

#---------------------------------------------
sub modify_selected_Unrochognizedchar {
&UpdateIndicators2;
    my @selection = $listePnChangeUnrocognizedChar->curselection();
    foreach $ind (@selection) {
	my $element=$listePnChangeUnrocognizedChar->get($ind);
	&query_replace($element);
    }
}

#---------------------------------------------
sub concordance_char {
&UpdateIndicators2;
    my @selection = $listePnChangeChar->curselection();
    foreach $ind (@selection) {
	my $element=$listePnChangeChar->get($ind);
	$winMain::search_string="$element";
	&text_search($winMain::texte, $winMain::search_string, 'search');
    }
}

#---------------------------------------------------------------------------------------
sub concordance_Unrochognizedchar {
&UpdateIndicators2;
    my @selection = $listePnChangeUnrocognizedChar->curselection();
    foreach $ind (@selection) {
	my $element=$listePnChangeUnrocognizedChar->get($ind);
	$winMain::search_string="$element";
	&text_search($winMain::texte, $winMain::search_string, 'search');
    }
}


#---------------------------------------------
sub delete_selected_char {
&UpdateIndicators2;
    my @selection = $listePnChangeChar->curselection();
    foreach $ind (@selection) {
	my $element=$listePnChangeChar->get($ind);
	&text_delete($winMain::texte, $element, 'search');
    }
}

#---------------------------------------------
sub delete_selected_Unrochognizedchar {
&UpdateIndicators2;
    my @selection = $listePnChangeUnrocognizedChar->curselection();
    foreach $ind (@selection) {
	my $element=$listePnChangeUnrocognizedChar->get($ind);
	&text_delete($winMain::texte, $element, 'search');
    }
}

#---------------------------------------------
sub modify_selected_ascii {
&UpdateIndicators2;
    my @selection = $listePnChangeAscii->curselection();
    foreach $ind (@selection) {
	my $element=$listePnChangeAscii->get($ind);
	&query_replace(chr($element));
    }
}


#---------------------------------------------
sub delete_selected_ascii {
&UpdateIndicators2;
    my @selection = $listePnChangeAscii->curselection();
    foreach $ind (@selection) {
	my $element=$listePnChangeAscii->get($ind);
	&text_delete($winMain::texte, chr($element), 'search');
    }
}

#---------------------------------------------------------------------------------------
sub concordance_Asciichar {
&UpdateIndicators2;
    my @selection = $listePnChangeAscii->curselection();
    foreach $ind (@selection) {
	my $element=$listePnChangeAscii->get($ind);
	$winMain::search_string=chr($element);
	&text_search($winMain::texte, $winMain::search_string, 'search');
    }
}

#---------------------------------------------
sub del_balise {
&UpdateIndicators2;
    
    $winMain::search_string="<[^>]+>";
    &text_delete($winMain::texte, $winMain::search_string, 'search');
    $winMain::saisie2->delete(0,'end');
}

#---------------------------------------------------------------------------------------
sub list_balise {
&UpdateIndicators2;
    
    $winMain::search_string="<[^>]+>";
    &text_balise($winMain::texte, $winMain::search_string, 'search');
    $winMain::saisie2->delete(0,'end');
}

#---------------------------------------------------------------------------------------
sub search_balise {
&UpdateIndicators2;
    
    $winMain::search_string="<[^>]+>";
    &text_search($winMain::texte, $winMain::search_string, 'search');
    if ($winMain::mw->depth > 1) {
	&text_toggle($winMain::texte, ['configure', 'search', -background => 'SeaGreen4', -foreground => 'white'], 800,
		          ['configure', 'search', -background => undef,       -foreground => undef],   200);
      } else {
	&text_toggle($winMain::texte, ['configure', 'search', -background => 'black',     -foreground => 'white'], 800,
		          ['configure', 'search', -background => undef,       -foreground => undef],   200);
      }

    $winMain::saisie2->delete(0,'end');

}

#---------------------------------------------------------------------------------------
sub text_balise {
&UpdateIndicators2;

    # The utility procedure below searches and destroy for all instances of a given string in a text widget and applies a given tag
    # to each instance found.
    # Arguments:
    #
    # w -	The window in which to search.  Must be a text widget.
    # string -	The string to search for. 
    # tag -	Tag to apply to each instance of a matching string.

    my($w, $string, $tag) = @_;
    my $id = 0;
    my @seenElt=();

    $w->tag('remove',  $tag, '0.0', 'end');
    (my $num_lines) = $w->index('end') =~ /(\d*)\.\d*/;
    for($i = 1; $i <=$num_lines; $i++) {
	my $line = $w->get("${i}.0", "${i}.1000");
	next if not defined $line or $line !~ /($string)/;
        my $l = length $1;
	my $stringRegexp=$1;
	my $offset = 0;
	while (1) {
	    my $tmpoffset=0;
	    my $index = index $line, $stringRegexp, $tmpoffset;
	    last if $index == -1;
	    $offset += $index;
	    $seenElt[$id] =[$i, $offset, $i, $offset+$l];
	    $id++;
	    $offset += $l;
	    $line = substr $line, $index+$l;
	    if ($line=~/($string)/) { $stringRegexp=$1;
				      $l = length $1;}

	} # whilend
    } # forend

    $winMain::cpt_file_balises++;
    if (!open(TMPFILE,(">MKC-tmp_Mkbalises.txt"))) {
	&mkPrintErreur("ERREUR : Impossible d\'ouvrir le fichier MKC-tmp_Mkbalises.txt\n");
	return;
    }
    for ($i =0 ; $i <=  $#seenElt; $i++) {
	    $tmpTexte=$w->get(sprintf("%d.%d",$seenElt[$i][0],$seenElt[$i][1]),sprintf("%d.%d",$seenElt[$i][2],$seenElt[$i][3]));
	    print TMPFILE "$tmpTexte\n";
	    }
    close(TMPFILE);


    my $tmpFile="MKC-tmp_Mkbalises.txt";
    &print_list_balise($tmpFile);

}


#---------------------------------------------
sub print_list_balise {
&UpdateIndicators2;

    my ($tmpfile) = @_;
    $mkTextMarkup->destroy if Exists($mkTextMarkup);
    $mkTextMarkup = $winMain::mw->Toplevel();
    my $w = $mkTextMarkup;
    $w->title('Markup List');
    $w->iconname('Markup');
    my $w_ok = $w->Button(-text => 'OK', -width => 8, -command => ['destroy', $w]);
    my $w_t = $w->TextUndo(-setgrid => 'true', -width => '60', -height => '28',
			-font => '-Adobe-Helvetica-Bold-R-Normal--*-120-*-*-*-*-*-*');
    my $w_save = $w->Button(-text => "Save",
			    -image => $winMain::imageSave,
			    -command => sub {$w_t->FileSaveAsPopup()})->pack(-side => 'top', -pady => 5, -padx => 10);

    $winMain::winBalloon->attach($w_save,
                  -balloonmsg => "Save"
               );



    my $w_s = $w->Scrollbar(-command => ['yview', $w_t]);
    $w_t->configure(-yscrollcommand => ['set', $w_s]);
    $w_ok->pack(-side => 'top', -pady => 5, -padx => 10);
    $w_s->pack(-side => 'right', -fill => 'y');
    $w_t->pack(-expand => 'yes', -fill => 'both');

    # Set up display styles

    my(@bold, @normal, $tags);
    if ($mkTextMarkup->depth > 1) {
	@bold = (-foreground => 'red');
	@normal = (-foreground => undef);
    } else {
	@bold = (-foreground => 'white', -background => 'black');
	@normal = (-foreground => undef, -background => undef);
    }

    $w_t->insert('0.0', 'Markup Results...');
    $w_t->insert("end","\n\n");
    $w_t->IncludeFile($tmpfile);
}


#---------------------------------------------
sub extract_balise_i {
&UpdateIndicators2;
    my ($balise_d) = @_;
    $balise_d=~/<([^>]+)>/;
    my $tmp=$1;
    my $ind=0;
    if ($balise_d=~/<([^ ]+) [^>]*>/) {$tmp=$1}
    my $balise_f="<\/$tmp>";
    my $balise_name = $tmp;
    my @chars  = unpack("A1" x length($balise_name), $balise_name);
    my $tmp_string="[^<]*[^\/]*";
    foreach $ch (@chars) {
	$tmp_string .= "[^".$ch."]*";
    }
    $tmp_string .= "[^>]*";
    my $resultat=$winMain::texte->search(-regexp, "$balise_f",'1.0','end');
    if ($resultat eq "") {
	    &mkPrintErreur("ERREUR : Pas de balise fermante '$balise_f' pour cette balise\n");
	return;
    }

    $nom_fic2="MKC-tmp_ExtractText_".$balise_name.".txt";
    if (!open(TMPFILE,("$winMain::nom_fic"))) {
	&mkPrintErreur("ERREUR : Impossible d\'ouvrir le fichier '$winMain::nom_fic'\n");
	return;
    }
    if (!open(TMPFILE2,(">$nom_fic2"))) {
	&mkPrintErreur("ERREUR : Impossible d\'ouvrir le fichier '$nom_fic2'\n");
	return;
    }

    while ($ligne = <TMPFILE>) { 
		if ($ligne =~ /$balise_d(.*)$balise_f/i)
			{ 
			    $ind++;
			    print TMPFILE2 "<$balise_name=NUM$ind>\n";
			    print TMPFILE2 "$1\n";

		    }
		if (($ligne=~/$balise_d(.*)/i) && ($ligne!~/$balise_f/i)){
		    my $tmp="$1";
		    $ind++;
		    print TMPFILE2 "<$balise_name=NUM$ind>\n";
		    print TMPFILE2 "$tmp";
		    $ligne=<TMPFILE>;
		    until ($ligne=~/$balise_f/i){
			print TMPFILE2 "$ligne";
			$ligne=<TMPFILE>;
#			break if $ligne == EOF;
		    }
		    $ligne=~/(.*)$balise_f/;
		    print TMPFILE2 "$1";
		    }
	    }
    print TMPFILE2 "\n";
    close(TMPFILE);
    close(TMPFILE2);

    my $tmpfile="MKC-tmp_ExtractText_".$balise_name.".txt";
    $mkExtractTextInMarkup->destroy if Exists($mkExtractTextInMarkup);
    $mkExtractTextInMarkup = $winMain::mw->Toplevel();
    my $w = $mkExtractTextInMarkup;
    $w->title('Extract Text');
    $w->iconname('Extract');
    my $w_ok = $w->Button(-text => 'OK', -width => 8, -command => ['destroy', $w]);
    my $w_t = $w->TextUndo(-setgrid => 'true', -width => '60', -height => '28',
			-font => '-Adobe-Helvetica-Bold-R-Normal--*-120-*-*-*-*-*-*');
    my $w_save = $w->Button(-text => "Save",
			    -image => $winMain::imageSave,
			    -command => sub {$w_t->FileSaveAsPopup()})->pack(-side => 'top', -pady => 5, -padx => 10);

    $winMain::winBalloon->attach($w_save,
                  -balloonmsg => "Save"
               );


    my $w_s = $w->Scrollbar(-command => ['yview', $w_t]);
    $w_t->configure(-yscrollcommand => ['set', $w_s]);
    $w_ok->pack(-side => 'top', -pady => 5, -padx => 10);
    $w_s->pack(-side => 'right', -fill => 'y');
    $w_t->pack(-expand => 'yes', -fill => 'both');

    # Set up display styles

    my(@bold, @normal, $tags);
    if ($mkExtractTextInMarkup->depth > 1) {
	@bold = (-foreground => 'red');
	@normal = (-foreground => undef);
    } else {
	@bold = (-foreground => 'white', -background => 'black');
	@normal = (-foreground => undef, -background => undef);
    }

    $w_t->insert('0.0', 'Extract Results...');
    $w_t->insert("end","\n\n");
    $w_t->IncludeFile($tmpfile);

}

#---------------------------------------------
sub extract_balise {
&UpdateIndicators2;
    my ($balise_d) = @_;
    $balise_d=~/<([^>]+)>/;
    my $tmp=$1;
    my $ind=0;
    if ($balise_d=~/<([^ ]+) [^>]*>/) {$tmp=$1}
    my $balise_f="<\/$tmp>";
    my $balise_name = $tmp;
    my @chars  = unpack("A1" x length($balise_name), $balise_name);
    my $tmp_string="[^<]*[^\/]*";
    foreach $ch (@chars) {
	$tmp_string .= "[^".$ch."]*";
    }
    $tmp_string .= "[^>]*";
    my $resultat=$winMain::texte->search(-regexp, "$balise_f",'1.0','end');
    if ($resultat eq "") {
	    &mkPrintErreur("ERREUR : Pas de balise fermante '$balise_f' pour cette balise\n");
	return;
    }

    $nom_fic2="MKC-tmp_ExtractText_".$balise_name.".txt";
    if (!open(TMPFILE,("$winMain::nom_fic"))) {
	&mkPrintErreur("ERREUR : Impossible d\'ouvrir le fichier '$winMain::nom_fic'\n");
	return;
    }
    if (!open(TMPFILE2,(">$nom_fic2"))) {
	&mkPrintErreur("ERREUR : Impossible d\'ouvrir le fichier '$nom_fic2'\n");
	return;
    }

    while ($ligne = <TMPFILE>) { 
		if ($ligne =~ /$balise_d(.*)$balise_f/i)
			{ 
			    $ind++;
			    print TMPFILE2 "<$balise_name=NUM$ind>\n";
			    print TMPFILE2 "$1\n";

		    }
		if (($ligne=~/$balise_d(.*)/i) && ($ligne!~/$balise_f/i)){
		    my $tmp="$1";
		    $ind++;
		    print TMPFILE2 "<$balise_name=NUM$ind>\n";
		    print TMPFILE2 "$tmp";
		    $ligne=<TMPFILE>;
		    until ($ligne=~/$balise_f/i){
			print TMPFILE2 "$ligne";
			$ligne=<TMPFILE>;
#			break if $ligne == EOF;
		    }
		    $ligne=~/(.*)$balise_f/;
		    print TMPFILE2 "$1";
		    }
	    }
    print TMPFILE2 "\n";
    close(TMPFILE);
    close(TMPFILE2);

}

#---------------------------------------------
sub extract_balise_oneline {
&UpdateIndicators2;
    my ($balise_d) = @_;
    $balise_d=~/<([^>]+)>/;
    my $tmp=$1;
    my $ind=0;
    if ($balise_d=~/<([^ ]+) [^>]*>/) {$tmp=$1}
    my $balise_f="<\/$tmp>";
    my $balise_name = $tmp;
    my @chars  = unpack("A1" x length($balise_name), $balise_name);
    my $tmp_string="[^<]*[^\/]*";
    foreach $ch (@chars) {
	$tmp_string .= "[^".$ch."]*";
    }
    $tmp_string .= "[^>]*";
    my $resultat=$winMain::texte->search(-regexp, "$balise_f",'1.0','end');
    if ($resultat eq "") {
	    &mkPrintErreur("ERREUR : Pas de balise fermante '$balise_f' pour cette balise\n");
	return;
    }

    $nom_fic2="MKC-tmp_ExtractText_".$balise_name.".txt";
    if (!open(TMPFILE,("$winMain::nom_fic"))) {
	&mkPrintErreur("ERREUR : Impossible d\'ouvrir le fichier '$winMain::nom_fic'\n");
	return;
    }
    if (!open(TMPFILE2,(">$nom_fic2"))) {
	&mkPrintErreur("ERREUR : Impossible d\'ouvrir le fichier '$nom_fic2'\n");
	return;
    }

    while ($ligne = <TMPFILE>) { 
		if ($ligne =~ /$balise_d(.*)$balise_f/i)
			{ 
			    $ind++;
			    print TMPFILE2 "<$balise_name=NUM$ind>#$1\n";
		    }
		if (($ligne=~/$balise_d(.*)/i) && ($ligne!~/$balise_f/i)){
		    my $tmp="$1";
		    $ind++;
		    print TMPFILE2 "<$balise_name=NUM$ind>#";
		    chomp($tmp);
		    print TMPFILE2 "$tmp";
		    $ligne=<TMPFILE>;
		    until ($ligne=~/$balise_f/i){
			chomp($ligne);
			print TMPFILE2 " $ligne";
			$ligne=<TMPFILE>;
#			break if $ligne == EOF;
		    }
		    $ligne=~/(.*)$balise_f/;
		    $tmp=$1;
		    chomp($tmp);
		    print TMPFILE2 " $tmp\n";
		    }
	    }
    close(TMPFILE);
    close(TMPFILE2);

}

#---------------------------------------------
sub extract_balise_oneline2 {
&UpdateIndicators2;
    my ($balise_d,$file) = @_;
    $balise_d=~/<([^>]+)>/;
    my $tmp=$1;
    my $ind=0;
    if ($balise_d=~/<([^ ]+) [^>]*>/) {$tmp=$1}
    my $balise_f="<\/$tmp>";
    my $balise_name = $tmp;
    my @chars  = unpack("A1" x length($balise_name), $balise_name);
    my $tmp_string="[^<]*[^\/]*";
    foreach $ch (@chars) {
	$tmp_string .= "[^".$ch."]*";
    }
    $tmp_string .= "[^>]*";

#pb a regler : on travaille pas dans $winMain::texte....
    my $resultat=$winMain::texte->search(-regexp, "$balise_f",'1.0','end');
    if ($resultat eq "") {
	    &mkPrintErreur("ERREUR : Pas de balise fermante '$balise_f' pour cette balise\n");
	return;
    }

    $nom_fic2="MKC-tmp_ExtractText_".$balise_name.".txt";

    if (!open(TMPFILE,("$file"))) {
	&mkPrintErreur("ERREUR : Impossible d\'ouvrir le fichier '$file'\n");
	return;
    }
    if (!open(TMPFILE2,(">$nom_fic2"))) {
	&mkPrintErreur("ERREUR : Impossible d\'ouvrir le fichier '$nom_fic2'\n");
	return;
    }

    while ($ligne = <TMPFILE>) { 
		if ($ligne =~ /$balise_d(.*)$balise_f/i)
			{ 
			    $ind++;
			    print TMPFILE2 "<$balise_name=NUM$ind>#$1\n";
		    }
		if (($ligne=~/$balise_d(.*)/i) && ($ligne!~/$balise_f/i)){
		    my $tmp="$1";
		    $ind++;
		    print TMPFILE2 "<$balise_name=NUM$ind>#";
		    chomp($tmp);
		    print TMPFILE2 "$tmp";
		    $ligne=<TMPFILE>;
		    until ($ligne=~/$balise_f/i){
			chomp($ligne);
			print TMPFILE2 " $ligne";
			$ligne=<TMPFILE>;
#			break if $ligne == EOF;
		    }
		    $ligne=~/(.*)$balise_f/;
		    $tmp=$1;
		    chomp($tmp);
		    print TMPFILE2 " $tmp\n";
		    }
	    }
    close(TMPFILE);
    close(TMPFILE2);

}

#---------------------------------------------
sub extract_tagbalise {
&UpdateIndicators2;
    my ($balise_d) = @_;

    $balise_d=~/<([^ ]+) type=\"([^\"]+)\">/;
    my $tmp=$1;
    my $tmp2 = $2;
    my $search_d= $balise_d."begin\_".$tmp2."</tagHTML>";
    my $balise_f="<\/$tmp>";
    my $search_f= $balise_d."end\_".$tmp2."</tagHTML>";
    my $balise_name = "$tmp"."-"."$tmp2";
    my $markname = "$tmp2";

    print $balise_name, "\n";
    print $search_d, "\n";
    print $search_f, "\n";

    my $resultat=$winMain::texte->search(-regexp, "$balise_f",'1.0','end');
    if ($resultat eq "") {
	    &mkPrintErreur("ERREUR : Pas de balise fermante '$balise_f' pour cette balise\n");
	return;
    }

    $nom_fic2="MKC-tmp_ExtractText_".$balise_name.".txt";

    if (!open(TMPFILE,("$winMain::nom_fic"))) {
	&mkPrintErreur("ERREUR : Impossible d\'ouvrir le fichier '$winMain::nom_fic'\n");
	return;
    }
    if (!open(TMPFILE2,(">$nom_fic2"))) {
	&mkPrintErreur("ERREUR : Impossible d\'ouvrir le fichier '$nom_fic2'\n");
	return;
    }

    my $ind=0;
    while ($ligne = <TMPFILE>) { 
#		if ($ligne =~ /$search_d(.*)$search_f/i)
#			{ 
#			    $ind++;
#			    print TMPFILE2 "<$markname=NUM$ind>\n\n";
#			    print TMPFILE2 "$1\n";
#
#		    }
		if (($ligne=~/$search_d(.*)/i) && ($ligne!~/$search_f/i)){
		    my $tmp="$1";
		    $ind++;
		    print TMPFILE2 "\n\n<$markname=NUM$ind>\n\n";
		    print TMPFILE2 "$tmp";
		    $ligne=<TMPFILE>;
		    until ($ligne=~/$search_f/i){
			print TMPFILE2 "$ligne";
			$ligne=<TMPFILE>;
#			break if $ligne == EOF;
		    }
		    $ligne=~/(.*)$search_f/;
		    print TMPFILE2 "$1";
		    }
	    }
    print TMPFILE2 "\n";
    close(TMPFILE);
    close(TMPFILE2);

}



#----------------------------- MODULE HTML ----------------------------------
sub help_tidyClean1 {
&UpdateIndicators2;
    if (! Exists ($pn1)) {
	$pn1 = $winMain::mw ->Toplevel();
	$pn1->title("HELP");
	my $label = $pn1->Label( -background => 'black',
				  -foreground =>  'white', -anchor => 'w' );
	my $texte2 = $pn1->Scrolled("MarkupTools")->pack(-side => 'bottom',
				      -fill => 'both',
				      -expand => 1);

	$texte2->Text(-setgrid => 'true');
	&updateMarkupWindow($texte2,$label);
	my $tmpfile="Doc/htmltidy.txt";
	$texte2->IncludeFile($tmpfile);

	$pn1->Button(-text => "Close",
		     -command =>  sub {$pn1->destroy()})->pack(-side => 'top', -pady => 5, -padx => 10);


	my $w_save=$pn1->Button(-text => "Save",
		     -image => $imageSave,
		     -command => sub {$texte2->FileSaveAsPopup()})->pack(-side => 'top', -pady => 5, -padx => 10);
	$winMain::winBalloon->attach($w_save,
			    -balloonmsg => "Save"
			    );

    }
    else {
	$pn1->deiconify();
	$pn1->raise();
    }

}

#---------------------------------------------------------------------------------------
sub query_dir_tidyClean1 {
&UpdateIndicators2;
    if (! Exists ($pn8)) {
	$pn8 = $winMain::mw ->Toplevel();
	$pn8->title("Query Dir");
	$pn8->minsize(qw(800 200)); 
	my $frame0 = $pn8->Frame(-background=>'#edf0f3')->pack(-side=>'top',  -fill => 'both',  -expand => 1); 
	my $cadre1 = $frame0->Frame->pack(-side => 'top',  -fill => 'both',  -expand => 1);
	my $cadre2 = $frame0->Frame->pack(-side => 'top',  -fill => 'both',  -expand => 1);
	my $cadre5 = $frame0->Frame->pack(-side => 'top',  -fill => 'both',  -expand => 1);
	my $cadre3 = $frame0->Frame->pack(-side => 'top',  -fill => 'both',  -expand => 1);
	my $cadre4 = $frame0->Frame->pack(-side => 'top',  -fill => 'both',  -expand => 1);


	$cadre1->Label(-text => "Where is Tidy : (./Tidy/) ",
    	      -relief => 'raised')->pack(-side => 'left',
					 -anchor => 'w',
					 -expand => 1);
	my $tidydir=&GetCWD;
	$tidydir.="Tidy/";
	my $saisie_0=$cadre1->Entry(-textvariable => \$tidydir)->pack(-side => 'left',
						-anchor => 'w',
						-fill => 'both',
						-expand => 1
						);
	$cadre2->Label(-text => "Dir Input : ",
    	      -relief => 'raised')->pack(-side => 'left',
						  -anchor => 'w');
	my $workdirin=&GetCWD;
	my $saisie_1=$cadre2->Entry(-textvariable => \$workdirin)->pack(-side => 'left',
						-anchor => 'w',
						-fill => 'both',
						-expand => 1
						);
	$cadre4->Button(-text => "load parcoursSiteAndCleanWithTidy",
			-command => sub {$pn8->destroy();

					 &parcoursSiteAndCleanWithTidy1($tidydir,$workdirin);
					 })->pack(-side => 'right',
						  -anchor => 'e');
	$pn8->Button(-text => "Close",
		     -command =>  sub {$pn8->destroy()})->pack;
    }
    else {
	$pn8->deiconify();
	$pn8->raise();
    }
}


#---------------------------------------------------------------------------------------
sub parcoursSiteAndCleanWithTidy1 {
&UpdateIndicators2;

    my ($tidyLocation,$dirname)=@_;
    &loadSplashWindow;
    my $filecount=0;
    $tidyLocation=$tidyLocation."\/" unless ($tidyLocation=~/\/$/);
    $dirname=$dirname."\/" unless ($dirname=~/\/$/);
    print "DIRNAME : ",$dirname,"\n";
    if (!open(TRACE, ">MKC-tmp_ListeFichiersNettoyes.txt")) {
	&mkPrintErreur("ERREUR : Impossible d\'ouvrir le fichier MKC-tmp_ListeFichiersNettoyes.txt\n");
	&removeSplashWindow;
	return;
    }
    close(TRACE);

    if (!open(TRACE, "./Tidy/config-html.txt")) {
	&mkPrintErreur("ERREUR : Impossible d\'ouvrir le fichier /Tidy/config-html.txt : fichier de configuration de Tidy\n");
	&removeSplashWindow;
	return;
    }
    close(TRACE);
    Show_Dir_parcoursSiteAndCleanWithTidy1($dirname,\$filecount,$tidyLocation);
    my $tmpfile="MKC-tmp_ListeFichiersNettoyes.txt";
    my $msg="MKC-tmp_ListeFichiersNettoyes.txt";
    &IncludedFileInWindow($tmpfile,$msg);
    &removeSplashWindow;

}

#---------------------------------------------------------------------------------------
sub Show_Dir_parcoursSiteAndCleanWithTidy1 {
&UpdateIndicators2;
    if (!open(TRACE, ">>MKC-tmp_ListeFichiersNettoyes.txt")) {
	&mkPrintErreur("ERREUR : Impossible d\'ouvrir le fichier TRACE : \n");
	&removeSplashWindow;
	return;
    }
    my ($path,$filecount,$tidyLocation) = @_;
    $path=$path."\/" unless ($path=~/\/$/);
    $tidyLocation=$tidyLocation."\/" unless ($tidyLocation=~/\/$/);
    #-------SPLASH REFRESH
    &splashProgress( "Work In Progress......", 25 );
    #-------SPLASH REFRESH
    print "DIRNAME : ",$path,"\n";
    if (!opendir(DIR, $path)) {
	&mkPrintErreur("ERREUR : can't open $path: $!\n");
	&removeSplashWindow;
	return;
    }  
    my @files = readdir(DIR);
    closedir(DIR);
    foreach my $file (@files) {
	$$filecount++;
	next if $file =~ /^\.\.?$/;
	my $tmpfile=$file;
	$file = $path.$file;
	print "F => ",$file,"\n";
	#-------SPLASH REFRESH
	&splashProgress( "Work In Progress......", 50 );
	#-------SPLASH REFRESH

	if (-d $file) {
	    print TRACE "FILE$$filecount = $file cleanTidy : recurse \n";
	    close(TRACE);
	    Show_Dir_parcoursSiteAndCleanWithTidy1($file,\$filecount,$tidyLocation);	#appel recursif
	    if (!open(TRACE, ">>MKC-tmp_ListeFichiersNettoyes.txt")) {
		&mkPrintErreur("ERREUR : Impossible d\'ouvrir le fichier TRACE : \n");
		&removeSplashWindow;
		return;
	    }	
	}
	elsif (-f $file) {
	    if (($file=~/\.htm.*$/)) {
		my $newfile = $file;
		$newfile=~s/\.htm.*/\_mkc\.htm/;
		$file=~s/\.htm.*/\.old_htm/;
		print "N=> ",$newfile,"\n";
		print "FILE$$filecount = $file\n";
		print TRACE "FILE$$filecount = $file cleanTidy done \n";
		print TRACE "FILE$$filecount = $file => $newfile \n";
		$file=~s/\//\\/g;
		$newfile=~s/\//\\/g;
		$tidyLocation=~s/\//\\/g;
		print "".$tidyLocation."tidy -config ".$tidyLocation."config-html.txt $file > $newfile\n";
		system("".$tidyLocation."tidy -config ".$tidyLocation."config-html.txt $file > $newfile");
	    }
	    else {
		print TRACE "FILE$$filecount = $file cleanTidy skipped \n";
	    }
	}
	else {
	    print TRACE "\n";
	}
	
    }
    close(TRACE);
}


#---------------------------------------------------------------------------------------
sub html0 {
&UpdateIndicators2;

use mkCorpusModules::MyParser;

# On cre un objet MyParser (qui hrite de tout ce qui faut
# de HTML::Parser)
    my $p= MyParser->new;

# On lance le parsing du fichier pass en argument
# de la ligne de commande par exemple.
# A chaque fois que le parseur va dtecter du texte
# il va appeler la fonction text (dfinie dans toto.pm)

    eval { $p->parse_file($winMain::nom_fic)};
    if ($@) {
	&mkPrintErreur("Caught Error : $@\n");
	return;
	}

    my $tmpfile="MKC-tmp_formatHtml2text.txt";
    my $msg="MKC-tmp_formatHtml2text.txt";
    &IncludedFileInWindow($tmpfile,$msg);

}

#---------------------------------------------
sub html1 {
&UpdateIndicators2;

    use HTML::Parse;
    my $html = parse_htmlfile($winMain::nom_fic);
    $formatter = HTML::FormatText->new(leftmargin => 0, rightmargin => 50);
    $formatter = HTML::FormatText->new(leftmargin => 0, rightmargin => 50);
    open(TMPTEXT,">MKC-tmp_formatHtml2text.txt");
    print TMPTEXT $formatter->format($html);
    close(TMPTEXT);

    my $tmpfile="MKC-tmp_formatHtml2text.txt";
    my $msg="MKC-tmp_formatHtml2text.txt";
    &IncludedFileInWindow($tmpfile,$msg);

}

#---------------------------------------------
sub html2 {
&UpdateIndicators2;

    use HTML::Parse;
    $html = parse_htmlfile($winMain::nom_fic);
    $formatter = new HTML::FormatPS
	FontFamily => 'Helvetica',
	PaperSize  => 'Letter';
    open(TMPTEXTPS,">MKC-tmp_formatHtml2Postcript.ps");
    print TMPTEXTPS $formatter->format($html);
    close(TMPTEXTPS);

    my $tmpfile="MKC-tmp_formatHtml2Postcript.txt";
    my $msg="MKC-tmp_formatHtml2Postcript.txt";
    &IncludedFileInWindow($tmpfile,$msg);

}

#----------------------------- MODULE XML ----------------------------------
sub showParser {
    &UpdateIndicators2;
    if (! Exists( $top1 )) {	
	$winMain::texte->tellStatusbar( "Preparing the parser..." );
	$top1 = $winMain::texte->Toplevel();
	my ( $parser ) = $top1->Scrolled( "XMLViewer", -scrollbars => 'osoe',
					  -background => "#ffefffffe0c3",
					  -selectforeground => 'white',
					  -selectbackground => "#000070669645",
					  -height => 22, -width => 70,
					  -setgrid => 'true' );
	my ( $menu )    = $top1->Menu();
	$menu->Menubutton( -label => 'File', -tearoff => 0, -underline=>0,
			   -menuitems =>[['command' => '~Parse Edits', -command=> sub {
			       $winMain::texte->tellStatusbar( "Parsing edits..." );
			       $parser->delete( '1.0', 'end' );
			       $parser->insertXML( -text => $winMain::texte->get('1.0','end' ));
			       
			       $winMain::texte->tellStatusbar( "Edits were parsed." );
			   }],
					 ['command' => 'Parse ~File',  -command=> sub {
					     my ( $file ) = $winMain::texte->CreateFileSelect('getOpenFile', -title =>"File Parse", -filetypes=> [["Xml Files", '.xml']]);
					     if ( defined( $file ) and length( $file )) {
						 $winMain::texte->tellStatusbar( "Parsing \"$file\"...");
						 $parser->delete( '1.0', 'end' );
						 $parser->insertXML( -file => $file );
						 return( $winMain::texte->tellStatusbar
							 ( "File \"$file\" was parsed." ));
					     }
					     else {
						 return( $winMain::texte->tellStatusbar
							 ( "Action chanceled!" ));
					     }
					 }], '-',
					 ['command' => '~Exit', -command=> sub{$top1->destroy();}]]);
	my ( $cascade ) = $menu->cascade( -tearoff => 0, -label => 'XML', -underline=>0 );
	$cascade->command( -label=>'~Info', -command => sub{$parser->Showinfo;});
	my ( $entry ) = $cascade->cascade( -tearoff => 0, -label => 'Show To ~Depth' );
	for my $depth (1 .. 6) {
	    my $_depth = $depth;
	    $entry->command( -label => $depth, -command=>sub { $parser->ShowToDepth($_depth) });
	}
	$entry->command(-label => 'Open ~All', -command => sub { $parser->ShowToDepth(undef) });
	$menu->Menubutton( -label => 'View', -tearoff => 0, -underline=>0, -menuitems =>[@{$parser->ViewMenuItems}] );
	$top1->configure( -title => "Parser", -menu => $menu );
	$top1->bind( 'Tk::XMLViewer', '<Button-3>', sub {});
	$parser->pack( -fill => 'both', -expand => 1 );
	$top1->resizable( 0, 0 );
	$winMain::texte->tellStatusbar( "Parsing edits..." );
#	$parser->insertXML( -text => $winMain::nom_fic);
	$parser->insertXML( -text => $winMain::texte->get('1.0','end' ));
	return( $winMain::texte->tellStatusbar( "Edits were parsed." ));
    }
    return( 0 );
}
#---------------------------------------------------------------------------------------
sub textintag {
&UpdateIndicators2;

    use XML::Parser::PerlSAX;
    use mkCorpusModules::TextInTag;
    
    if (!open(TRACE, ">MKC-tmp_textintag.txt")) {
	&mkPrintErreur("ERREUR : Impossible d\'ouvrir le fichier textintag.txt : \n");
	return;
    }
    close(TRACE);

    my $file = $winMain::nom_fic;
    if ($winMain::search_string eq "") {
	&mkPrintErreur("ERREUR : Aucune slection de chane de recherche donne\n");
	return;
    }
    my $text = $winMain::search_string;
    my $my_handler = TextInTag->new($text);
  XML::Parser::PerlSAX->new->parse(Source => { SystemId => $file}, 
				 Handler => $my_handler);
    my $tmpfile="MKC-tmp_textintag.txt";
    my $msg="MKC-tmp_textintag.txt";
    &IncludedFileInWindow($tmpfile,$msg);
 
}
#---------------------------------------------------------------------------------------
sub tagtextsearch {
    &UpdateIndicators2;
    
    use XML::Parser::PerlSAX;
    use mkCorpusModules::TagText;
    
    
    if (!open(TRACE, ">MKC-tmp_tagtextsearch.txt")) {
	&mkPrintErreur("ERREUR : Impossible d\'ouvrir le fichier tagtextsearch.txt : \n");
	return;
    }
    close(TRACE);
    
    my $file = $winMain::nom_fic;
    if ($winMain::search_string eq "") {
	&mkPrintErreur("ERREUR : Aucune slection de chane de recherche donne\n");
	return;
    }
    my $text = $winMain::search_string;
    
    my $my_handler = TagText->new($text);
    
  XML::Parser::PerlSAX->new->parse(Source => { SystemId => $file}, 
				   Handler => $my_handler);
    
    my $tmpfile="MKC-tmp_tagtextsearch.txt";
    my $msg="MKC-tmp_tagtextsearch.txt";
    &IncludedFileInWindow($tmpfile,$msg);
    
}

#---------------------------------------------------------------------------------------
sub processSablotron {
&UpdateIndicators2;

    &load_processSablotron;
}
#---------------------------------------------------------------------------------------
sub load_processSablotron {
&UpdateIndicators2;
    if (! Exists ($pn8)) {
	$pn8 = $winMain::mw ->Toplevel();
	$pn8->title("Query Dir (Sablotron)");
	$pn8->minsize(qw(800 150)); 
	my $frame0 = $pn8->Frame(-background=>'#edf0f3')->pack(-side=>'top',  -fill => 'both',  -expand => 1); 
	my $cadre1 = $frame0->Frame->pack(-side => 'top',  -fill => 'both',  -expand => 1);
	my $cadre2 = $frame0->Frame->pack(-side => 'top',  -fill => 'both',  -expand => 1);
	my $cadre3 = $frame0->Frame->pack(-side => 'top',  -fill => 'both',  -expand => 1);
	my $cadre4 = $frame0->Frame->pack(-side => 'top',  -fill => 'both',  -expand => 1);


	$cadre1->Label(-text => "Input XML File : ",  -relief => 'raised')->pack(-side => 'left',
										 -anchor => 'w');
	my $xsldir=&GetCWD;
	my $saisie_0=$cadre1->Entry(-textvariable => \$xsldir)->pack(-side => 'left',
								     -anchor => 'w',
								     -fill => 'both',
								     -expand => 1
								     );

	$cadre2->Label(-text => "Input XSL File : ",  -relief => 'raised')->pack(-side => 'left',
										 -anchor => 'w');
	
	my $workdirin=&GetCWD;
	my $saisie_1=$cadre2->Entry(-textvariable => \$workdirin)->pack(-side => 'left',
									-anchor => 'w',
									-fill => 'both',
									-expand => 1
									);

	$cadre3->Label(-text => "Output HTML File : ", -relief => 'raised')->pack(-side => 'left',
										  -anchor => 'w');
	my $workdirout=&GetCWD;
	my $saisie_2=$cadre3->Entry(-textvariable => \$workdirout)->pack(-side => 'left',
									  -anchor => 'w',
									  -fill => 'both',
									  -expand => 1
									  );

	$cadre4->Button(-text => "load executeSablotron",
			-command => sub {$pn8->destroy(); &executeSablotron($xsldir,$workdirin,$workdirout); }

			)->pack(-side => 'right',
				-anchor => 'e');
	$pn8->Button(-text => "Close",
		     -command =>  sub {$pn8->destroy()})->pack;
    }
    else {
	$pn8->deiconify();
	$pn8->raise();
    }

}
#---------------------------------------------------------------------------------------
sub processXT {
    &UpdateIndicators2;
    &load_processXT;
}
#---------------------------------------------------------------------------------------
sub processXT2 {
    &UpdateIndicators2;
    &mkIndisponible();
    &load_processXT2;
}
#---------------------------------------------------------------------------------------
sub processLibXSLT {
    &UpdateIndicators2;
    my $dir=&GetCWD;
    &querymodeleLIBXSLT("XML=>HTML(LibXSLT)","Input-XML-File : ",$dir, "Input-XSL-File : ",$dir, "Output-HTML-File : ",$dir);
}

sub querymodeleLIBXSLT {
    my ($title,$label_1,$value_1,$label_2,$value_2,$label_3,$value_3,$label_4,$value_4,$label_5,$value_5) = @_;
    my $query = $winMain::mw ->Toplevel(-title=>$title);
    $query->geometry("400x300+100+100");
    my $imgLogo=$query->Photo(-file=>"pics/logo-mkc.gif");
    my $lblLogo=$query->Button(-image=>$imgLogo)->place(-y=>0,-x=>0,-width=>400,-height=>300);
    my $frame1 = $query->Frame()->pack(-side=>'bottom', -pady=>5);
    my $frameG1 = $frame1->Frame()->pack(-side=>'top', -pady=>5);
    my $frameD1 = $frame1->Frame()->pack(-side=>'bottom', -pady=>5);
    my $frameH1 = $frame1->Frame()->pack(-side=>'bottom', -pady=>5);
    my $frameG2 = $frameG1->Frame()->pack(-side=>'left', -pady=>5);
    my $frameD2 = $frameG1->Frame()->pack(-side=>'right', -pady=>5);
    my $frameG3 = $frameD1->Frame()->pack(-side=>'left', -pady=>5);
    my $frameD3 = $frameD1->Frame()->pack(-side=>'right', -pady=>5);
    my $frameG4 = $frameH1->Frame()->pack(-side=>'left', -pady=>5);
    my $frameD4 = $frameH1->Frame()->pack(-side=>'right', -pady=>5);
    my $frame2 = $query->Frame()->pack();
    my $frame3 = $query->Frame()->pack();

#---1er champ
    my $libelE = $frameG2->Label(-text=>$label_1)->pack(-padx=>5);
    my $defil = $frameD2-> Scrollbar(-orient => "horizontal");
    my $fieldE = $frameD2->Entry(-textvariable => \$value_1, -highlightcolor => "blue", -xscrollcommand => ['set' => $defil] )
	->pack(		-fill => 'x',
			-expand => 1);
    $defil->pack(-fill => 'x',
		 -expand => 1);
    $defil->configure(-command => [$fieldE => 'xview']);
#---2eme champ
    my $libelF = $frameG3->Label(-text=>$label_2)->pack(-padx=>5);
    my $defil2 = $frameD3-> Scrollbar(-orient => "horizontal");
    my $fieldF = $frameD3->Entry(-textvariable => \$value_2, -highlightcolor => "red", -xscrollcommand => ['set' => $defil2] )
	->pack(		-fill => 'x',
			-expand => 1);
    $defil2->pack(-fill => 'x',
		  -expand => 1);
    $defil2->configure(-command => [$fieldF => 'xview']);
#---3eme champ
    my $libelG = $frameG4->Label(-text=>$label_3)->pack(-padx=>5);
    my $defil3 = $frameD4-> Scrollbar(-orient => "horizontal");
    my $fieldG = $frameD4->Entry(-textvariable => \$value_3, -highlightcolor => "red", -xscrollcommand => ['set' => $defil3] )
	->pack(		-fill => 'x',
			-expand => 1);
    $defil3->pack(-fill => 'x',
		  -expand => 1);
    $defil3->configure(-command => [$fieldG => 'xview']);
#----

    my $raz = $query->Button(-text=>'RAZ', -activeforeground=>"blue",-relief=>'flat', -command=>\&eraseField)->pack(-side=>'left', -padx=>5, -pady=>5);
    my $calcul = $query->Button(-text=>'Go', -activeforeground=>"blue",-relief=>'flat', -command=>\&loadQUERYMODELE)->pack(-side=>'left', -padx=>5, -pady=>5);
    my $help = $query->Button(-text=>'Help', -activeforeground=>"blue",-relief=>'flat', -command=>\&helpQUERYMODELE)->pack(-side=>'right', -padx=>5, -pady=>5);
    my $fin = $query->Button(-text=>'Exit', -activeforeground=>"blue",-relief=>'flat', -command=>sub {$query->destroy()})->pack(-side=>'right', -padx=>5, -pady=>5);


    sub eraseField {
	    if (Exists($fieldF)) {$fieldF->delete(0, 'end')};
	    if (Exists($fieldE)) {$fieldE->delete(0, 'end')};
	    if (Exists($fieldG)) {$fieldG->delete(0, 'end')};
    }


    sub helpQUERYMODELE {
        if (! Exists ($pn1)) {
	$pn1 = $winMain::mw ->Toplevel();
	$pn1->title("HELP");
	my $label = $pn1->Label( -background => 'black',
				  -foreground =>  'white', -anchor => 'w' );
	my $texte2 = $pn1->Scrolled("MarkupTools")->pack(-side => 'bottom',
				      -fill => 'both',
				      -expand => 1);

	$texte2->Text(-setgrid => 'true');
	&updateMarkupWindow($texte2,$label);
	
	my $tmpfile="Doc/help_processeurXSLT.txt";
	if (!open(OUTFILE, "$tmpfile")) {
	    &mkPrintErreur("ERREUR : Impossible d\'ouvrir le fichier : $tmpfile \n");
	}
	else {
	    close(OUTFILE);
	    $texte2->IncludeFile($tmpfile);
	}

	$pn1->Button(-text => "Close",
		     -command =>  sub {$pn1->destroy()})->pack(-side => 'top', -pady => 5, -padx => 10);

	my $w_save=$pn1->Button(-text => "Save",
		     -image => $imageSave,
		     -command => sub {$texte2->FileSaveAsPopup()})->pack(-side => 'top', -pady => 5, -padx => 10);
	$winMain::winBalloon->attach($w_save,
			    -balloonmsg => "Save"
			    );
    }
	else {
	    $pn1->deiconify();
	    $pn1->raise();
	}
    }
    sub loadQUERYMODELE {
	my $chemin1=$fieldE->get();
	my $chemin2=$fieldF->get();
	my $chemin3=$fieldG->get();

	use XML::LibXML;
	use XML::LibXSLT;
	if (!open(OUTFILE, "$chemin1")) {
	    &mkPrintErreur("ERREUR : Impossible d\'ouvrir le fichier : $chemin1 \n");
	    return;
	}
    
	close(OUTFILE);
	if (!open(OUTFILE, "$chemin2")) {
	    &mkPrintErreur("ERREUR : Impossible d\'ouvrir le fichier : $chemin2 \n");
	    return;
	}
	close(OUTFILE);
	my $parserObj = XML::LibXML->new();
	my $xsltObj = XML::LibXSLT->new();
	my $inputXMLObj = $parserObj->parse_file($chemin1);
	my $inputStyleSheetObj = $parserObj->parse_file($chemin2);
	my $xsltObj = $xsltObj->parse_stylesheet($inputStyleSheetObj);
	my $resultsObj = $xsltObj->transform($inputXMLObj);
	my $htmlfile = $xsltObj->output_string($resultsObj);
	if (!open(OUTFILE, ">$chemin3")) {
	    &mkPrintErreur("ERREUR : Impossible d\'ouvrir le fichier : $chemin3 \n");
	    return;
	}
	print OUTFILE $htmlfile;
	close(OUTFILE);
	my $tmpfile= "$chemin3";
	my $msg="$chemin3";
	&IncludedFileInWindow($tmpfile,$msg);

	use Win32::OLE;
	my $file = "$chemin3";
	print $file,"\n";
	my $msie;
	eval {my $msie = Win32::OLE->GetActiveObject('InternetExplorer.Application')};
	if ($@) {
	    &mkPrintErreur("InternetExplorer unavailable" );
	}
	unless (defined $msie) {
	    print "Dmarrage de IE \n";
	    $msie = Win32::OLE->new('InternetExplorer.Application');
	    if ($@) {
		&mkPrintErreur("ERREUR : Oops, cannot start IE" );
	    }
	    $msie->{'Visible'}=1;
	    $msie->Navigate($file);
	}  
    }
}

#---------------------------------------------------------------------------------------
sub load_processXT {
    &UpdateIndicators2;
    if (! Exists ($pn8)) {
	$pn8 = $winMain::mw ->Toplevel();
	$pn8->title("Query Dir (XT)");
	$pn8->minsize(qw(800 150)); 
	my $frame0 = $pn8->Frame(-background=>'#edf0f3')->pack(-side=>'top',  -fill => 'both',  -expand => 1); 
	my $cadre1 = $frame0->Frame->pack(-side => 'top',  -fill => 'both',  -expand => 1);
	my $cadre2 = $frame0->Frame->pack(-side => 'top',  -fill => 'both',  -expand => 1);
	my $cadre3 = $frame0->Frame->pack(-side => 'top',  -fill => 'both',  -expand => 1);
	my $cadre4 = $frame0->Frame->pack(-side => 'top',  -fill => 'both',  -expand => 1);

	$cadre1->Label(-text => "Input XML File : ",  -relief => 'raised')->pack(-side => 'left',
										 -anchor => 'w');
	my $xsldir=&GetCWD;
	my $saisie_0=$cadre1->Entry(-textvariable => \$xsldir)->pack(-side => 'left',
								     -anchor => 'w',
								     -fill => 'both',
								     -expand => 1
								     );

	$cadre2->Label(-text => "Input XSL File : ",  -relief => 'raised')->pack(-side => 'left',
										 -anchor => 'w');
	
	my $workdirin=&GetCWD;
	my $saisie_1=$cadre2->Entry(-textvariable => \$workdirin)->pack(-side => 'left',
									-anchor => 'w',
									-fill => 'both',
									-expand => 1
									);

	$cadre3->Label(-text => "Output HTML File : ", -relief => 'raised')->pack(-side => 'left',
										  -anchor => 'w');
	my $workdirout=&GetCWD;
	my $saisie_2=$cadre3->Entry(-textvariable => \$workdirout)->pack(-side => 'left',
									  -anchor => 'w',
									  -fill => 'both',
									  -expand => 1
									  );

	$cadre4->Button(-text => "load executeLIBXSLT",
			-command => sub {$pn8->destroy(); &executeLIBXSLT($xsldir,$workdirin,$workdirout); }

			)->pack(-side => 'right',
				-anchor => 'e');
	$pn8->Button(-text => "Close",
		     -command =>  sub {$pn8->destroy()})->pack;
    }
    else {
	$pn8->deiconify();
	$pn8->raise();
    }

}
#---------------------------------------------------------------------------------------
sub load_processXT2 {
    &UpdateIndicators2;
    if (! Exists ($pn8)) {
	$pn8 = $winMain::mw ->Toplevel();
	$pn8->title("Query Dir (XT2)");
	$pn8->minsize(qw(800 150)); 
	my $frame0 = $pn8->Frame(-background=>'#edf0f3')->pack(-side=>'top',  -fill => 'both',  -expand => 1); 
	my $cadre1 = $frame0->Frame->pack(-side => 'top',  -fill => 'both',  -expand => 1);
	my $cadre2 = $frame0->Frame->pack(-side => 'top',  -fill => 'both',  -expand => 1);
	my $cadre3 = $frame0->Frame->pack(-side => 'top',  -fill => 'both',  -expand => 1);
	my $cadre4 = $frame0->Frame->pack(-side => 'top',  -fill => 'both',  -expand => 1);

	$cadre1->Label(-text => "Input XML File : ",  -relief => 'raised')->pack(-side => 'left',
										 -anchor => 'w');
	my $xsldir=&GetCWD;
	my $saisie_0=$cadre1->Entry(-textvariable => \$xsldir)->pack(-side => 'left',
								     -anchor => 'w',
								     -fill => 'both',
								     -expand => 1
								     );

	$cadre2->Label(-text => "Input XSL File : ",  -relief => 'raised')->pack(-side => 'left',
										 -anchor => 'w');
	
	my $workdirin=&GetCWD;
	my $saisie_1=$cadre2->Entry(-textvariable => \$workdirin)->pack(-side => 'left',
									-anchor => 'w',
									-fill => 'both',
									-expand => 1
									);

	$cadre3->Label(-text => "Output HTML File : ", -relief => 'raised')->pack(-side => 'left',
										  -anchor => 'w');
	my $workdirout=&GetCWD;
	my $saisie_2=$cadre3->Entry(-textvariable => \$workdirout)->pack(-side => 'left',
									  -anchor => 'w',
									  -fill => 'both',
									  -expand => 1
									  );

	$cadre4->Button(-text => "load executeXT",
			-command => sub {$pn8->destroy(); &executeXT2($xsldir,$workdirin,$workdirout); }

			)->pack(-side => 'right',
				-anchor => 'e');
	$pn8->Button(-text => "Close",
		     -command =>  sub {$pn8->destroy()})->pack;
    }
    else {
	$pn8->deiconify();
	$pn8->raise();
    }

}
#---------------------------------------------------------------------------------------
sub processXMLXSLT {
    &UpdateIndicators2;
    &load_processXMLXSLT;
}
#---------------------------------------------------------------------------------------
sub load_processXMLXSLT {
    &UpdateIndicators2;
    if (! Exists ($pn8)) {
	$pn8 = $winMain::mw ->Toplevel();
	$pn8->title("Query Dir (XMLXSLT)");
	$pn8->minsize(qw(800 150)); 
	my $frame0 = $pn8->Frame(-background=>'#edf0f3')->pack(-side=>'top',  -fill => 'both',  -expand => 1); 
	my $cadre1 = $frame0->Frame->pack(-side => 'top',  -fill => 'both',  -expand => 1);
	my $cadre2 = $frame0->Frame->pack(-side => 'top',  -fill => 'both',  -expand => 1);
	my $cadre3 = $frame0->Frame->pack(-side => 'top',  -fill => 'both',  -expand => 1);
	my $cadre4 = $frame0->Frame->pack(-side => 'top',  -fill => 'both',  -expand => 1);

	$cadre1->Label(-text => "Input XML File : ",  -relief => 'raised')->pack(-side => 'left',
										 -anchor => 'w');
	my $xsldir=&GetCWD;
	my $saisie_0=$cadre1->Entry(-textvariable => \$xsldir)->pack(-side => 'left',
								     -anchor => 'w',
								     -fill => 'both',
								     -expand => 1
								     );

	$cadre2->Label(-text => "Input XSL File : ",  -relief => 'raised')->pack(-side => 'left',
										 -anchor => 'w');
	
	my $workdirin=&GetCWD;
	my $saisie_1=$cadre2->Entry(-textvariable => \$workdirin)->pack(-side => 'left',
									-anchor => 'w',
									-fill => 'both',
									-expand => 1
									);

	$cadre3->Label(-text => "Output HTML File : ", -relief => 'raised')->pack(-side => 'left',
										  -anchor => 'w');
	my $workdirout=&GetCWD;
	my $saisie_2=$cadre3->Entry(-textvariable => \$workdirout)->pack(-side => 'left',
									  -anchor => 'w',
									  -fill => 'both',
									  -expand => 1
									  );

	$cadre4->Button(-text => "load executeXMLXSLT",
			-command => sub {$pn8->destroy(); &executeXMLXSLT($xsldir,$workdirin,$workdirout); }

			)->pack(-side => 'right',
				-anchor => 'e');
	$pn8->Button(-text => "Close",
		     -command =>  sub {$pn8->destroy()})->pack;
    }
    else {
	$pn8->deiconify();
	$pn8->raise();
    }

}
#---------------------------------------------------------------------------------------
sub executeXT {
    &UpdateIndicators2;
    my ($input, $data,$output_url)=@_;
 
    if (!open(OUTFILE, "$input")) {
	&mkPrintErreur("ERREUR : Impossible d\'ouvrir le fichier : $input \n");
	return;
    }
    
    close(OUTFILE);
    if (!open(OUTFILE, "$data")) {
	&mkPrintErreur("ERREUR : Impossible d\'ouvrir le fichier : $data \n");
	return;
    }
    close(OUTFILE);

    print "xslt/xt.exe $input $data $output_url\n";
    system("xslt/xt.exe $input $data $output_url");

    if (!open(OUTFILE, ">$output_url")) {
	&mkPrintErreur("ERREUR : Impossible d\'ouvrir le fichier : $output_url \n");
	return;
    }
    close(OUTFILE);

    my $tmpfile= "$output_url";
    my $msg="$output_url";
    &IncludedFileInWindow($tmpfile,$msg);

    use Win32::OLE;
    my $file =  "$output_url";
    print $file,"\n";
    my $msie;
    eval {my $msie = Win32::OLE->GetActiveObject('InternetExplorer.Application')};
    if ($@) {
	     &mkPrintErreur("InternetExplorer unavailable" );
    }
    unless (defined $msie) {
	print "Dmarrage de IE \n";
	$msie = Win32::OLE->new('InternetExplorer.Application');
	if ($@) {
	    &mkPrintErreur("ERREUR : Oops, cannot start IE" );
	}
	$msie->{'Visible'}=1;
	$msie->Navigate($file);
    }  

}

#---------------------------------------------------------------------------------------
sub executeXT2 {
    &UpdateIndicators2;
    my ($input, $data,$output_url)=@_;
 
    if (!open(OUTFILE, "$input")) {
	&mkPrintErreur("ERREUR : Impossible d\'ouvrir le fichier : $input \n");
	return;
    }
    
    close(OUTFILE);
    if (!open(OUTFILE, "$data")) {
	&mkPrintErreur("ERREUR : Impossible d\'ouvrir le fichier : $data \n");
	return;
    }
    close(OUTFILE);

    print "";
    system("java -Dcom.jclark.xsl.sax.parser=sax.jar com.jclark.xsl.Driver $input $data $output_url");

    if (!open(OUTFILE, ">$output_url")) {
	&mkPrintErreur("ERREUR : Impossible d\'ouvrir le fichier : $output_url \n");
	return;
    }
    close(OUTFILE);

    my $tmpfile= "$output_url";
    my $msg="$output_url";
    &IncludedFileInWindow($tmpfile,$msg);

    use Win32::OLE;
    my $file = "$output_url";
    print $file,"\n";
    my $msie;
    eval {my $msie = Win32::OLE->GetActiveObject('InternetExplorer.Application')};
    if ($@) {
	     &mkPrintErreur("InternetExplorer unavailable" );
    }
    unless (defined $msie) {
	print "Dmarrage de IE \n";
	$msie = Win32::OLE->new('InternetExplorer.Application');
	if ($@) {
	    &mkPrintErreur("ERREUR : Oops, cannot start IE" );
	}
	$msie->{'Visible'}=1;
	$msie->Navigate($file);
    }  

}
#---------------------------------------------------------------------------------------
sub executeXMLXSLT {
    &UpdateIndicators2;
    my ($input, $data,$output_url)=@_;

    use XML::XSLT qw(serve); 
    print "test1\n";
#    &set_filter();    # sets the post-processing filter
    print "test2\n";
    my $xslt   = XML::XSLT->new($input);
     print "test3\n";
    if (!open(OUTFILE, "$output_url")) {
	&mkPrintErreur("ERREUR : Impossible d\'ouvrir le fichier : $input \n");
	return;
    }    
     print "test4\n";
    print OUTFILE $xslt->serve( Source => $data);
     print "test5\n";
    close OUTFILE;

    my $tmpfile= "$output_url";
    my $msg="$output_url";
    &IncludedFileInWindow($tmpfile,$msg);

    use Win32::OLE;
    my $file = "$output_url";
    print $file,"\n";
    my $msie;
    eval {my $msie = Win32::OLE->GetActiveObject('InternetExplorer.Application')};
    if ($@) {
	     &mkPrintErreur("InternetExplorer unavailable" );
    }
    unless (defined $msie) {
	print "Dmarrage de IE \n";
	$msie = Win32::OLE->new('InternetExplorer.Application');
	if ($@) {
	    &mkPrintErreur("ERREUR : Oops, cannot start IE" );
	}
	$msie->{'Visible'}=1;
	$msie->Navigate($file);
    }  

sub set_filter   { 
#    return if my $pid= open( STDOUT, "|-");    # magic open
#    die "cannot fork: $!" unless defined $pid;

    my $i=0;
    my $prod='';
    while( <STDIN>)
      { if( m/^\s*\[\]/)
          { unless( $i==0)
              { $prod= add_pos( $prod, $i); 
                $prod= clean_prod( $prod); 
                print "$prod\n" ;
              }
            $i++;
            $prod= '';
          }
          $prod .= $_;
        }
    $prod= &add_pos( $prod, $i); 
    $prod= &clean_prod( $prod); 
    print "$prod\n"; 
    exit;
  }
        
sub clean_prod { 
    my $prod= shift;
    $prod=~ s/&\#160;/ /g;
    $prod=~ s/\n/ /;
    $prod=~ s/\s+/ /g;
    $prod=~ s/^\s*//g;
    $prod=~ s/\s*$//g;
# those are escaped in XML::XSLT
    $prod=~ s/\&lt;/</g;  
    $prod=~ s/\&gt;/>/g;  
    $prod=~ s/\&amp;/&/g; 
    return $prod;
}

sub add_pos {                                    # needed because XSLT does not
    my( $prod, $i)= @_;                        # yet implement position()
    $prod=~ s/^\s*\[\]/\n[$i]/;
    return $prod;
}

}
#---------------------------------------------------------------------------------------
sub executeSablotron {
&UpdateIndicators2;

    use XML::Sablotron;
    my ($input, $data,$output_url)=@_;
 
    if (!open(OUTFILE, "$input")) {
	&mkPrintErreur("ERREUR : Impossible d\'ouvrir le fichier : $input \n");
	return;
    }
    close(OUTFILE);
    if (!open(OUTFILE, "$data")) {
	&mkPrintErreur("ERREUR : Impossible d\'ouvrir le fichier : $data \n");
	return;
    }

    my $oProcessor = new XML::Sablotron();
    my $content = &LoadData("$input");
    my $stylesheet=&LoadData("$data");
    my $result;
    XML::Sablotron::ProcessStrings($stylesheet, $content,$result);

    close(OUTFILE);

    if (!open(OUTFILE, ">$output_url")) {
	&mkPrintErreur("ERREUR : Impossible d\'ouvrir le fichier : $output_url \n");
	return;
    }

    print OUTFILE   $result;
    close(OUTFILE);
    my $tmpfile= "$output_url";
    my $msg="$output_url";
    &IncludedFileInWindow($tmpfile,$msg);

    use Win32::OLE;
    my $file = "$output_url";
    print $file,"\n";
    my $msie;
    eval {my $msie = Win32::OLE->GetActiveObject('InternetExplorer.Application')};
    if ($@) {
	     &mkPrintErreur("InternetExplorer unavailable" );
    }
    unless (defined $msie) {
	print "Dmarrage de IE \n";
	$msie = Win32::OLE->new('InternetExplorer.Application');
	if ($@) {
	    &mkPrintErreur("ERREUR : Oops, cannot start IE" );
	}
	$msie->{'Visible'}=1;
	$msie->Navigate($file);
    }  

sub LoadData {
&UpdateIndicators2;
   my($path) = @_;

   $! = 0; # clear i/o errs
   open HFILE, $path;
   if ($! != 0)
   {
      return "";
   }

   my $eor = $/;
   undef $/;
   my $content = <HFILE>;
   close HFILE;
   $/ = $eor;
   return $content;
}
}
#---------------------------------------------------------------------------------------
sub executeSablotron1 {
&UpdateIndicators2;

    use XML::Sablotron;

    my ($input, $data, $output_url,$output_url2)=@_;

    my ($template) = "$input";
    my $oProcessor = new XML::Sablotron();
    my @params = ();
    my @args = ();
    push @args, "data";
    push @args, LoadData("$input");
    my($out_uri) = "arg:/result"; # bogus arg
    
    $oProcessor->RunProcessor($template, "arg:/data", $out_uri,\@params, \@args);

    my ($res) = $oProcessor->GetResultArg($out_uri);

    if (!open(OUTFILE, ">$output_url2")) {
	&mkPrintErreur("ERREUR : Impossible d\'ouvrir le fichier OUT HTML : \n");
	return;
    }
    print OUTFILE   $res;
    close(OUTFILE);

    my $tmpfile= "$output_url2";
    my $msg="$output_url";
    &IncludedFileInWindow($tmpfile,$msg);
    &tkweb($tmpfile);

sub LoadData {
&UpdateIndicators2;
   my($path) = @_;

   $! = 0; # clear i/o errs
   open HFILE, $path;
   if ($! != 0)
   {
      return "";
   }

   my $eor = $/;
   undef $/;
   my $content = <HFILE>;
   close HFILE;
   $/ = $eor;
   return $content;
}
}
#---------------------------------------------------------------------------------------
sub help_tidyClean {
&UpdateIndicators2;
    if (! Exists ($pn1)) {
	$pn1 = $winMain::mw ->Toplevel();
	$pn1->title("HELP");
	my $label = $pn1->Label( -background => 'black',
				  -foreground =>  'white', -anchor => 'w' );
	my $texte2 = $pn1->Scrolled("MarkupTools")->pack(-side => 'bottom',
				      -fill => 'both',
				      -expand => 1);

	$texte2->Text(-setgrid => 'true');
	&updateMarkupWindow($texte2,$label);
	my $tmpfile="Doc/xmltidy.txt";
	$texte2->IncludeFile($tmpfile);

	$pn1->Button(-text => "Close",
		     -command =>  sub {$pn1->destroy()})->pack(-side => 'top', -pady => 5, -padx => 10);


	my $w_save=$pn1->Button(-text => "Save",
		     -image => $imageSave,
		     -command => sub {$texte2->FileSaveAsPopup()})->pack(-side => 'top', -pady => 5, -padx => 10);
	$winMain::winBalloon->attach($w_save,
			    -balloonmsg => "Save"
			    );

    }
    else {
	$pn1->deiconify();
	$pn1->raise();
    }

}
#---------------------------------------------------------------------------------------
sub query_dir_tidyClean {
&UpdateIndicators2;
    if (! Exists ($pn8)) {
	$pn8 = $winMain::mw ->Toplevel();
	$pn8->title("Query Dir");
	$pn8->minsize(qw(800 200)); 
	my $frame0 = $pn8->Frame(-background=>'#edf0f3')->pack(-side=>'top',  -fill => 'both',  -expand => 1); 
	my $cadre1 = $frame0->Frame->pack(-side => 'top',  -fill => 'both',  -expand => 1);
	my $cadre2 = $frame0->Frame->pack(-side => 'top',  -fill => 'both',  -expand => 1);
	my $cadre5 = $frame0->Frame->pack(-side => 'top',  -fill => 'both',  -expand => 1);
	my $cadre3 = $frame0->Frame->pack(-side => 'top',  -fill => 'both',  -expand => 1);
	my $cadre4 = $frame0->Frame->pack(-side => 'top',  -fill => 'both',  -expand => 1);

	$cadre1->Label(-text => "Where is Tidy : (./Tidy/) ",
    	      -relief => 'raised')->pack(-side => 'left',
					 -anchor => 'w',
					 -expand => 1);
	my $tidydir=&GetCWD;
	$tidydir.="Tidy/";
	my $saisie_0=$cadre1->Entry(-textvariable => \$tidydir)->pack(-side => 'left',
						-anchor => 'w',
						-fill => 'both',
						-expand => 1
						);
	$cadre2->Label(-text => "Dir Input : ",
    	      -relief => 'raised')->pack(-side => 'left',
						  -anchor => 'w');
	my $workdirin=&GetCWD;
	my $saisie_1=$cadre2->Entry(-textvariable => \$workdirin)->pack(-side => 'left',
						-anchor => 'w',
						-fill => 'both',
						-expand => 1
						);
	$cadre4->Button(-text => "load parcoursSiteAndCleanWithTidy",
			-command => sub {$pn8->destroy();

					 &parcoursSiteAndCleanWithTidy($tidydir,$workdirin);
					 })->pack(-side => 'right',
						  -anchor => 'e');
	$pn8->Button(-text => "Close",
		     -command =>  sub {$pn8->destroy()})->pack;
    }
    else {
	$pn8->deiconify();
	$pn8->raise();
    }
}

#---------------------------------------------------------------------------------------
sub parcoursSiteAndCleanWithTidy {
&UpdateIndicators2;

    my ($tidyLocation,$dirname)=@_;
    &loadSplashWindow;
    my $filecount=0;
    $tidyLocation=$tidyLocation."\/" unless ($tidyLocation=~/\/$/);
    $dirname=$dirname."\/" unless ($dirname=~/\/$/);
    print "DIRNAME : ",$dirname,"\n";
    if (!open(TRACE, ">MKC-tmp_ListeFichiersNettoyes.txt")) {
	&mkPrintErreur("ERREUR : Impossible d\'ouvrir le fichier MKC-tmp_ListeFichiersNettoyes.txt\n");
	&removeSplashWindow;
	return;
    }
    close(TRACE);

    if (!open(TRACE, "./Tidy/config-xml.txt")) {
	&mkPrintErreur("ERREUR : Impossible d\'ouvrir le fichier /Tidy/config-xml.txt : fichier de configuration de Tidy\n");
	&removeSplashWindow;
	return;
    }
    close(TRACE);
    Show_Dir_parcoursSiteAndCleanWithTidy($dirname,\$filecount,$tidyLocation);
    my $tmpfile="MKC-tmp_ListeFichiersNettoyes.txt";
    my $msg="MKC-tmp_ListeFichiersNettoyes.txt";
    &IncludedFileInWindow($tmpfile,$msg);
    &removeSplashWindow;
}
#---------------------------------------------------------------------------------------
sub Show_Dir_parcoursSiteAndCleanWithTidy {
&UpdateIndicators2;
    if (!open(TRACE, ">>MKC-tmp_ListeFichiersNettoyes.txt")) {
	&mkPrintErreur("ERREUR : Impossible d\'ouvrir le fichier TRACE : \n");
	&removeSplashWindow;
	return;
    }
    my ($path,$filecount,$tidyLocation) = @_;
    $path=$path."\/" unless ($path=~/\/$/);
    $tidyLocation=$tidyLocation."\/" unless ($tidyLocation=~/\/$/);
    #-------SPLASH REFRESH
    &splashProgress( "Work In Progress......", 25 );
    #-------SPLASH REFRESH
    print "DIRNAME : ",$path,"\n";
    if (!opendir(DIR, $path)) {
	&mkPrintErreur("ERREUR : can't open $path: $!\n");
	&removeSplashWindow;
	return;
    }  
    my @files = readdir(DIR);
    closedir(DIR);
    foreach my $file (@files) {
	$$filecount++;
	next if $file =~ /^\.\.?$/;
	next if $file =~ /\.xml$/;
	my $tmpfile=$file;
	$file = $path.$file;
	print "F => ",$file,"\n";
	#-------SPLASH REFRESH
	&splashProgress( "Work In Progress......", 50 );
	#-------SPLASH REFRESH
	if (-d $file) {
	    print TRACE "FILE$$filecount = $file cleanTidy : recurse \n";
	    close(TRACE);
	    Show_Dir_parcoursSiteAndCleanWithTidy($file,\$filecount,$tidyLocation);	#appel recursif
	    if (!open(TRACE, ">>MKC-tmp_ListeFichiersNettoyes.txt")) {
		&mkPrintErreur("ERREUR : Impossible d\'ouvrir le fichier TRACE : \n");
		&removeSplashWindow;
		return;
	    }
	}
	elsif (-f $file) {
	    if (($file=~/\.htm/)) {
		my $newfile = $file;
		$newfile=~s/\.htm.*/\.xml/;
		print "N=> ",$newfile,"\n";
		print "FILE$$filecount = $file\n";
		print TRACE "FILE$$filecount = $file cleanTidy done \n";
		print TRACE "FILE$$filecount = $file => $newfile \n";
		$file=~s/\//\\/g;
		$newfile=~s/\//\\/g;
		$tidyLocation=~s/\//\\/g;
		print "".$tidyLocation."tidy -config ".$tidyLocation."config-xml.txt $file > $newfile\n";
		system("".$tidyLocation."tidy -config ".$tidyLocation."config-xml.txt $file > $newfile");
	    }
	    else {
		print TRACE "FILE$$filecount = $file cleanTidy skipped \n";
	    }
	}
	else {
	    print TRACE "\n";
	}

    }
    close(TRACE);
    #-------SPLASH REFRESH
    &splashProgress( "Work In Progress : recurse END", 75 );
    #-------SPLASH REFRESH
}

#---------------------------------------------------------------------------------------
sub helpaddTagInTextNode {
&UpdateIndicators2;
    if (! Exists ($pn1)) {
	$pn1 = $winMain::mw ->Toplevel();
	$pn1->title("HELP");
	my $label = $pn1->Label( -background => 'black',
				  -foreground =>  'white', -anchor => 'w' );
	my $texte2 = $pn1->Scrolled("MarkupTools")->pack(-side => 'bottom',
				      -fill => 'both',
				      -expand => 1);

	$texte2->Text(-setgrid => 'true');
	&updateMarkupWindow($texte2,$label);
	my $tmpfile="Doc/addtagintextnode.txt";
	$texte2->IncludeFile($tmpfile);

	$pn1->Button(-text => "Close",
		     -command =>  sub {$pn1->destroy()})->pack(-side => 'top', -pady => 5, -padx => 10);


	my $w_save=$pn1->Button(-text => "Save",
		     -image => $imageSave,
		     -command => sub {$texte2->FileSaveAsPopup()})->pack(-side => 'top', -pady => 5, -padx => 10);
	$winMain::winBalloon->attach($w_save,
			    -balloonmsg => "Save"
			    );

    }
    else {
	$pn1->deiconify();
	$pn1->raise();
    }

}
#---------------------------------------------------------------------------------------
sub iaddTagInTextNode {
&UpdateIndicators2;
    &loadSplashWindow;
    use XML::Parser;
    %liste_tagInput_addTagInTextNode = ();

    if ($winMain::search_string eq "") {
	&mkPrintErreur("ERREUR : Aucune slection de chemin donne dans la zone \"Search string\"\n");
	return;
    }

    if ($winMain::replace_string eq "") {
	&mkPrintErreur("ERREUR : Aucune slection de chemin donne dans la zone \"Replace with string\"\n");
	return;
    }
    $liste_tagInput_addTagInTextNode{$winMain::search_string}="<$winMain::replace_string>$winMain::search_string<\/$winMain::replace_string>";	    
    
#-------Ouverture du corpus
    my $FichierCaracteres = "$winMain::nom_fic".".mod.xml";
    if (!open(TMPFILE2, ">$FichierCaracteres")) {
	&mkPrintErreur("ERREUR : Ouverture Impossible $FichierCaracteres\n");
	return;
    }
    close(TMPFILE2);
#-----------------------
    my $parser = new XML::Parser(ErrorContext => 2);
    $parser->setHandlers( Start => \&start_tag_addTagInTextNode,
			  End => \&end_tag_addTagInTextNode,
			  Char => \&char_addTagInTextNode,
			  Default => \&default_addTagInTextNode
			  );
    
# Parse the input file
    eval {
	$parser->parsefile($winMain::nom_fic);
    };
    if ($@) {
	&removeSplashWindow;
	&mkPrintErreur("Caught Error : $@\n");
    }
#-----------------------
    close(TMPFILE);
    close(TMPFILE2);

    &removeSplashWindow;
    my $tmpfile="$winMain::nom_fic".".mod.xml";
    my $msg="$winMain::nom_fic".".mod.xml";
    &IncludedFileInWindow($tmpfile,$msg);
}

#---------------------------------------------------------------------------------------
sub addTagInTextNode {
&UpdateIndicators2;
    use XML::Parser;
    &loadSplashWindow;
    %liste_tagInput_addTagInTextNode = ();
    
#-------Lecture du trabscodage, ex : #il#pro# pour remplacer ensuite il par <pro>il</pro>
    if (!open(TMPFILE, "MKC-tmp_listeTAG.txt")) {
	&mkPrintErreur("ERREUR : Impossible d\'ouvrir le fichier de transcodage MKC-tmp_listeNEWTAG.txt,\n ce fichier est indispensable pour cette option\n");
	return;
    }
    while(<TMPFILE>) {
	$_=~/^#([^#]+)#([^#]+)#/;
	    $liste_tagInput_addTagInTextNode{$1}="<$2>$1<\/$2>";	    
    }
    close(TMPFILE);
    
#-------Ouverture du corpus
    my $FichierCaracteres = "$winMain::nom_fic".".mod.xml";
    if (!open(TMPFILE2, ">$FichierCaracteres")) {
	&mkPrintErreur("ERREUR : Ouverture Impossible $FichierCaracteres\n");
	return;
    }
    close(TMPFILE2);
#-----------------------
    my $parser = new XML::Parser(ErrorContext => 2);
    $parser->setHandlers( Start => \&start_tag_addTagInTextNode,
			  End => \&end_tag_addTagInTextNode,
			  Char => \&char_addTagInTextNode,
			  Default => \&default_addTagInTextNode
			  );
    
# Parse the input file
    eval {
	$parser->parsefile($winMain::nom_fic);
    };
    if ($@) {
	&removeSplashWindow;
	&mkPrintErreur("Caught Error : $@\n");

    }
#-----------------------
    close(TMPFILE);
    close(TMPFILE2);

    &removeSplashWindow;
    my $tmpfile="$winMain::nom_fic".".mod.xml";
    my $msg="$winMain::nom_fic".".mod.xml";
    &IncludedFileInWindow($tmpfile,$msg);
}

#------------------------------
sub start_tag_addTagInTextNode {
&UpdateIndicators2;
	my ($this, $element, %attributes) = @_;
	my $string = $this->original_string;
	my $FichierCaracteres = "$winMain::nom_fic".".mod.xml";
	if (!open(TMPFILE2, ">>$FichierCaracteres")) {
	    &mkPrintErreur("ERREUR : Ouverture Impossible $FichierCaracteres\n");
	    return;
	}
	print TMPFILE2 $string;
	close(TMPFILE2);
} # end of my_start_tag

#---------------------------------------------------------------------------------------
sub end_tag_addTagInTextNode {
&UpdateIndicators2;
	my ($this, $element) = @_;
	my $string = $this->original_string;
	my $FichierCaracteres = "$winMain::nom_fic".".mod.xml";
	if (!open(TMPFILE2, ">>$FichierCaracteres")) {
	    &mkPrintErreur("ERREUR : Ouverture Impossible $FichierCaracteres\n");
	    return;
	}
	print TMPFILE2 $string;
	close(TMPFILE2);
} # end of my_end_tag

#---------------------------------------------------------------------------------------
sub char_addTagInTextNode {
&UpdateIndicators2;
    my %seen=();
    my $this = shift;
    my $string = $this->original_string;
    $_=$string;
    while ( /(\w[\w]*)/g ){
	$seen{$1}++;
    }
    foreach my $keys (keys %seen) {
	if (exists ($liste_tagInput_addTagInTextNode{$keys})) {
	    $string=~s/([^\w]*)$keys([^\w]*)/$1$liste_tagInput_addTagInTextNode{$keys}$2/g;
	}
    }
    my $FichierCaracteres = "$winMain::nom_fic".".mod.xml";
    if (!open(TMPFILE2, ">>$FichierCaracteres")) {
	&mkPrintErreur("ERREUR : Ouverture Impossible $FichierCaracteres\n");
	return;
    }
    print TMPFILE2 $string;
    close(TMPFILE2);
} # end of my_char

#---------------------------------------------------------------------------------------
sub default_addTagInTextNode {
&UpdateIndicators2;
    my $this = shift;
    my $string = $this->original_string;
    my $FichierCaracteres = "$winMain::nom_fic".".mod.xml";
    if (!open(TMPFILE2, ">>$FichierCaracteres")) {
	&mkPrintErreur("ERREUR : Ouverture Impossible $FichierCaracteres\n");
	return;
    }
    print TMPFILE2 $string;
    close(TMPFILE2);
} # end of my_default

#-----------------------
sub xmlDomExtractTagWithSearchString {
    &UpdateIndicators2;

    use strict; 
    use XML::DOM; 
    if ($winMain::search_string eq "") {
	    &mkPrintErreur("ERREUR : Aucune slection de chane de recherche donne\n");
	    return;
	}
    if (!open(FIC,">MKC-tmp_xmlExtractContentBaliseWithSearchStringWithDOM.txt")) {
	&mkPrintErreur("ERREUR : Impossible d\'ouvrir le fichier MKC-tmp_xmlExtractContentBaliseWithSearchStringWithDOM.txt\n");
	return;
    }
    @listxmlDomExtractTag=();
    %listxmlDomExtractTag=();
    my $p = XML::DOM::Parser->new; 
    my $doc;
    eval { $doc=$p->parsefile($winMain::nom_fic)};
    if ($@) {
	&mkPrintErreur("Caught Error : $@\n");
	return;
    }    
    &process_nodexmlDomExtractTag($doc->getDocumentElement);
#    &process_nodexmlDomExtractTag($doc->getFirstChild); 
    my @selection = @listxmlDomExtractTag;
    print FIC "<OUTPUT>\n";
    my $id=0;
    foreach $ind (@selection) {
	$id++;
	my $tag=$ind;
	my $p = XML::DOM::Parser->new; 
	my $doc = $p->parsefile($winMain::nom_fic); 
	my $elements=$doc->getElementsByTagName($tag);
	for my $i (0..$elements->getLength-1) {
	    my $evElement=$elements->item($i);
	    my $children=$evElement->getChildNodes;
	    for my $j (0..$children->getLength-1) {
		my $p=$children->item($j);
		my $t=$p->getNodeType;
		if ($t == TEXT_NODE) {
		    my $data=$p->getData;
		    if ($data =~/$winMain::search_string/) {
			print FIC "<",$tag,">",$data,"</",$tag,">\n";
		    }
		}
	    }
	}
    }
    print FIC "</OUTPUT>\n";
    close(FIC);
    my $tmpfile="MKC-tmp_xmlExtractContentBaliseWithSearchStringWithDOM.txt";
    my $msg="MKC-tmp_xmlExtractContentBaliseWithSearchStringWithDOM.txt";
    &IncludedFileInWindow($tmpfile,$msg);

}
#---------------------------------------------------------------------------------------
sub xmlDomExtractTagWithSearchStringInMap {
    &UpdateIndicators2;

    use strict; 
    use XML::DOM; 
    if ($search_string_map eq "") {
	    &mkPrintErreur("ERREUR : Aucune slection de chane de recherche donne\n");
	    return;
	}
    if (!open(FIC,">MKC-tmp_xmlExtractContentBaliseWithSearchStringWithDOM.txt")) {
	&mkPrintErreur("ERREUR : Impossible d\'ouvrir le fichier MKC-tmp_xmlExtractContentBaliseWithSearchStringWithDOM.txt\n");
	return;
    }
    @listxmlDomExtractTag=();
    %listxmlDomExtractTag=();
    my $p = XML::DOM::Parser->new; 
    my $doc;
    eval { $doc=$p->parsefile($winMain::nom_fic)};
    if ($@) {
	&mkPrintErreur("Caught Error : $@\n");
	return;
    }    
#    &process_nodexmlDomExtractTag($doc->getFirstChild); 
    &process_nodexmlDomExtractTag($doc->getDocumentElement);
    my @selection = @listxmlDomExtractTag;
    print FIC "<OUTPUT>\n";
    my $id=0;
    foreach $ind (@selection) {
	$id++;
	my $tag=$ind;
	my $p = XML::DOM::Parser->new; 
	my $doc = $p->parsefile($winMain::nom_fic); 
	my $elements=$doc->getElementsByTagName($tag);
	for my $i (0..$elements->getLength-1) {
	    my $evElement=$elements->item($i);
	    my $children=$evElement->getChildNodes;
	    for my $j (0..$children->getLength-1) {
		my $p=$children->item($j);
		my $t=$p->getNodeType;
		if ($t == TEXT_NODE) {
		    my $data=$p->getData;
		    if ($data =~/$search_string_map/) {
			print FIC "<",$tag,">",$data,"</",$tag,">\n";
		    }
		}
	    }
	}
    }
    print FIC "</OUTPUT>\n";
    close(FIC);
    my $tmpfile="MKC-tmp_xmlExtractContentBaliseWithSearchStringWithDOM.txt";
    my $msg="MKC-tmp_xmlExtractContentBaliseWithSearchStringWithDOM.txt";
    &IncludedFileInWindow($tmpfile,$msg);

}

#---------------------------------------------------------------------------------------
sub  xmlDomExtractTag {
    &UpdateIndicators2;
    use strict; 
    use XML::DOM; 
    @listxmlDomExtractTag=();
    %listxmlDomExtractTag=();
    my $p = XML::DOM::Parser->new; 
    my $doc;
    eval { $doc=$p->parsefile($winMain::nom_fic)};
    if ($@) {
	&mkPrintErreur("Caught Error : $@\n");
	return;
    }        
    &process_nodexmlDomExtractTag($doc->getDocumentElement);
#    &process_nodexmlDomExtractTag($doc->getFirstChild); 
    &mkSelectionXMLMarkupWithDOM;
}
#---------------------------------------------------------------------------------------
sub  xmlDomExtractTag1 {
    &UpdateIndicators2;
    use strict; 
    use XML::DOM; 
    @listxmlDomExtractTag=();
    %listxmlDomExtractTag=();
    my $p = XML::DOM::Parser->new; 
    my $doc;
    eval { $doc=$p->parsefile($winMain::nom_fic)};
    if ($@) {
	&mkPrintErreur("Caught Error : $@\n");
	return;
    }        
    &process_nodexmlDomExtractTag($doc->getDocumentElement);
#    &process_nodexmlDomExtractTag($doc->getFirstChild); 
    &mkSelectionXMLMarkupWithDOM1;
}

#---------------------------------------------------------------------------------------
sub mkSelectionXMLMarkupWithDOM1 {
&UpdateIndicators2;
    if (! Exists ($pnXMLBalise)) {
	$pnXMLBalise = $winMain::mw ->Toplevel();
	$pnXMLBalise->title("Choose Markups (DOM)");

	$listePnXMLBaliseWithDOM1=$pnXMLBalise->Scrolled("Listbox", -scrollbars => "e",
							-selectmode => "extended",
							-selectforeground => "red",
							-setgrid => 1,
							-width => -1)->pack();

	$pnXMLBalise->Button(-text => "Delete",
		     -command =>  \&delete_selected_baliseXMLwithDOM1)->pack(-side => 'left', -pady => 5, -padx => 10);
	$pnXMLBalise->Button(-text => "Modify",
		     -command =>  \&modify_selected_baliseXMLwithDOM1)->pack(-side => 'left', -pady => 5, -padx => 10);
	$pnXMLBalise->Button(-text => "Extract Text",
		     -command =>  \&extract_text_in_baliseXMLwithDOM1)->pack(-side => 'left', -pady => 5, -padx => 10);

	$pnXMLBalise->Button(-text => "Close",
		     -command =>  sub {$pnXMLBalise->destroy()})->pack(-side => 'left', -pady => 5, -padx => 10);

	my @liste_balises=@listxmlDomExtractTag;

	$listePnXMLBaliseWithDOM1->delete(0,'end');
	$listePnXMLBaliseWithDOM1->insert('end',@liste_balises);

    }
    else {
	$pnXMLBalise->deiconify();
	$pnXMLBalise->raise();
    }

}
#---------------------------------------------------------------------------------------
sub mkSelectionForLexicoXMLMarkupWithDOM1 {
&UpdateIndicators2;
    if (! Exists ($pnXMLBalise)) {
	$pnXMLBalise = $winMain::mw ->Toplevel();
	$pnXMLBalise->title("Choose Markups (DOM)");

	$listePnXMLBaliseWithDOM1=$pnXMLBalise->Scrolled("Listbox", -scrollbars => "e",
							-selectmode => "extended",
							-selectforeground => "red",
							-setgrid => 1,
							-width => -1)->pack();

	$pnXMLBalise->Button(-text => "Delete",
		     -command =>  \&delete_selected_baliseXMLForLexicowithDOM1)->pack(-side => 'left', -pady => 5, -padx => 10);
	$pnXMLBalise->Button(-text => "Modify",
		     -command =>  \&modify_selected_baliseXMLForLexicowithDOM1)->pack(-side => 'left', -pady => 5, -padx => 10);
	$pnXMLBalise->Button(-text => "Extract Text",
		     -command =>  \&extract_text_in_baliseXMLForLexicowithDOM1)->pack(-side => 'left', -pady => 5, -padx => 10);

	$pnXMLBalise->Button(-text => "Close",
		     -command =>  sub {$pnXMLBalise->destroy()})->pack(-side => 'left', -pady => 5, -padx => 10);

	my @liste_balises=@listxmlDomExtractTag;

	$listePnXMLBaliseWithDOM1->delete(0,'end');
	$listePnXMLBaliseWithDOM1->insert('end',@liste_balises);

    }
    else {
	$pnXMLBalise->deiconify();
	$pnXMLBalise->raise();
    }

}
#---------------------------------------------------------------------------------------
sub mkSelectionXMLMarkupWithDOM {
&UpdateIndicators2;
    if (! Exists ($pnXMLBalise)) {
	$pnXMLBalise = $winMain::mw ->Toplevel();
	$pnXMLBalise->title("Choose Markups (DOM)");

	$listePnXMLBaliseWithDOM=$pnXMLBalise->Scrolled("Listbox", -scrollbars => "e",
							-selectmode => "extended",
							-selectforeground => "red",
							-setgrid => 1,
							-width => -1)->pack();

	$pnXMLBalise->Button(-text => "Delete",
		     -command =>  \&delete_selected_baliseXMLwithDOM)->pack(-side => 'left', -pady => 5, -padx => 10);
	$pnXMLBalise->Button(-text => "Modify",
		     -command =>  \&modify_selected_baliseXMLwithDOM)->pack(-side => 'left', -pady => 5, -padx => 10);
	$pnXMLBalise->Button(-text => "Extract Text",
		     -command =>  \&extract_text_in_baliseXMLwithDOM)->pack(-side => 'left', -pady => 5, -padx => 10);

	$pnXMLBalise->Button(-text => "Close",
		     -command =>  sub {$pnXMLBalise->destroy()})->pack(-side => 'left', -pady => 5, -padx => 10);

	my @liste_balises=@listxmlDomExtractTag;

	$listePnXMLBaliseWithDOM->delete(0,'end');
	$listePnXMLBaliseWithDOM->insert('end',@liste_balises);

    }
    else {
	$pnXMLBalise->deiconify();
	$pnXMLBalise->raise();
    }

}
#---------------------------------------------------------------------------------------
sub process_nodexmlDomExtractTag {
&UpdateIndicators2;
    my ($node) = @_; 
    my $nodeType = $node->getNodeType; 
    if ($nodeType == ELEMENT_NODE) { 
	my $type = $node->getTagName; 
	if (!exists ($listxmlDomExtractTag{$type})) {
		    $listxmlDomExtractTag{$type}="#ELEMENT_NODE#";
		    push(@listxmlDomExtractTag,$type);
		}
	my $nodelist = $node->getChildNodes;
	for (0 .. $nodelist->getLength - 1) { 
	    &process_nodexmlDomExtractTag($nodelist->item($_));
	}
    } 
    elsif ($nodeType == TEXT_NODE) { 
	my $content = $node->getData;
	$listxmlDomExtractTag{"TEXT_NODE"}=$content;
    }
}
#---------------------------------------------------------------------------------------
sub printEltAsTextWithDOM {
    &UpdateIndicators2;
    use strict; 
    use XML::DOM; 
    if (!open(FIC,">MKC-tmp_printEltAsText.txt")) {
	&mkPrintErreur("ERREUR : Impossible d\'ouvrir MKC-tmp_printEltAsText.txt\n");
	return;
    }
    close(FIC);
    my $p = XML::DOM::Parser->new; 
    my $doc;
    eval { $doc=$p->parsefile($winMain::nom_fic)};
    if ($@) {
	&mkPrintErreur("Caught Error : $@\n");
	return;
    }      

    $levelprintEltAsText = 0; 
    &process_nodeEltAsTextWithDOM($doc->getDocumentElement);
#    &process_nodeEltAsTextWithDOM($doc->getFirstChild); 
    my $tmpfile="MKC-tmp_printEltAsText.txt";
    my $msg="MKC-tmp_printEltAsText.txt";
    &IncludedFileInWindow($tmpfile,$msg);
}
#---------------------------------------------------------------------------------------
sub process_nodeEltAsTextWithDOM {
&UpdateIndicators2;
    if (!open(FIC,">>MKC-tmp_printEltAsText.txt")) {
	&mkPrintErreur("ERREUR : Impossible d\'ouvrir MKC-tmp_printEltAsText.txt\n");
	return;
    }
    my ($node) = @_; 
    my $ind = '-->' x $levelprintEltAsText; 
    my $nodeType = $node->getNodeType; 
    if ($nodeType == ELEMENT_NODE) { 
	my $type = $node->getTagName; 
	my $attrs = $node->getAttributes; 
	print FIC $ind, $type, ' ['; 
	my @attrs; 
	foreach (0 .. $attrs->getLength - 1) {
	    my $attr = $attrs->item($_);
	    push @attrs, $attr->getNodeName . ': ' . $attr->getValue;
	}
	print FIC join (', ', @attrs);
	print FIC "]\n";
	
	my $nodelist = $node->getChildNodes;
	++$levelprintEltAsText;
	close(FIC);
	for (0 .. $nodelist->getLength - 1) { 
	    &process_nodeEltAsTextWithDOM($nodelist->item($_));
	} --$levelprintEltAsText; 
    } elsif ($nodeType == TEXT_NODE) { 
	my $content = $node->getData;
	$content =~ s/\n/ /g;
	$content =~ s/^\s+//;
	$content =~ s/\s+$//;
	print FIC $ind, $content, "\n" if $content =~ /\S/; 
	close(FIC);
  }
}

#---------------------------------------------------------------------------------------
sub printTextEltWithDOM {
    &UpdateIndicators2;
    use strict; 
    use XML::DOM; 
    if (!open(FIC,">MKC-tmp_printEltAsText.txt")) {
	&mkPrintErreur("ERREUR : Impossible d\'ouvrir MKC-tmp_printEltAsText.txt\n");
	return;
    }
    close(FIC);
    my $p = XML::DOM::Parser->new; 
    my $doc;
    eval { $doc=$p->parsefile($winMain::nom_fic)};
    if ($@) {
	&mkPrintErreur("Caught Error : $@\n");
	return;
    }      
#    &process_nodeTextEltWithDOM($doc->getFirstChild); 
    &process_nodeTextEltWithDOM($doc->getDocumentElement);
    my $tmpfile="MKC-tmp_printEltAsText.txt";
    my $msg="MKC-tmp_printEltAsText.txt";
    &IncludedFileInWindow($tmpfile,$msg);
}
#---------------------------------------------------------------------------------------
sub process_nodeTextEltWithDOM {
&UpdateIndicators2;
    if (!open(FIC,">>MKC-tmp_printEltAsText.txt")) {
	&mkPrintErreur("ERREUR : Impossible d\'ouvrir MKC-tmp_printEltAsText.txt\n");
	return;
    }
    my ($node) = @_; 
    my $nodeType = $node->getNodeType; 
    if ($nodeType == ELEMENT_NODE) { 
	my $nodelist = $node->getChildNodes;
	for (0 .. $nodelist->getLength - 1) { 
	    &process_nodeTextEltWithDOM($nodelist->item($_));
	};
    } elsif ($nodeType == TEXT_NODE) { 
	my $content = $node->getData;
	$content =~ s/\n/ /g;
	$content =~ s/^\s+//;
	$content =~ s/\s+$//;
	print FIC  $content, "\n" if $content =~ /\S/; 
	close(FIC);
  }
}
#---------------------------------------------------------------------------------------
sub addIDOnTAG {
&UpdateIndicators2;


    if (!open(FIC,">MKC-tmp_addIDOnTAG.txt")) {
	&mkPrintErreur("ERREUR : Impossible d\'ouvrir MKC-tmp_addIDOnTAG.txt\n");
	return;
    }
	close(FIC);

    $idaddIDOnTAG = 'AAAA001';

    my $parser = new XML::Parser(ErrorContext => 2,
				 Handlers     => {Start => \&startaddIDOnTAG,
						  End   => \&endaddIDOnTAG,
						  Char  => \&charaddIDOnTAG});
    $parser->parsefile($winMain::nom_fic);
 
    my $tmpfile="MKC-tmp_addIDOnTAG.txt";
    my $msg="MKC-tmp_addIDOnTAG.txt";
    &IncludedFileInWindow($tmpfile,$msg);
}

###
#---------------------------------------------------------------------------------------
sub escapeaddIDOnTAG {
&UpdateIndicators2;
    my $str = shift;
    $str =~ s/&/\&amp;/g;
    $str =~ s/</\&lt;/g;
    $str =~ s/>/\&gt;/g;
    $str =~ s/\'/\&apos;/g;
    return $str;
}

#---------------------------------------------------------------------------------------
sub charaddIDOnTAG {
&UpdateIndicators2;
    if (!open(FIC,">>MKC-tmp_addIDOnTAG.txt")) {
	&mkPrintErreur("ERREUR : Impossible d\'ouvrir MKC-tmp_addIDOnTAG.txt\n");
	return;
    }
    print FIC escapeaddIDOnTAG($_[1]);
    close(FIC);
}

#---------------------------------------------------------------------------------------
sub endaddIDOnTAG {
&UpdateIndicators2;
    if (!open(FIC,">>MKC-tmp_addIDOnTAG.txt")) {
	&mkPrintErreur("ERREUR : Impossible d\'ouvrir MKC-tmp_addIDOnTAG.txt\n");
	return;
    }
    my $xp = shift; 
    print FIC $xp->recognized_string;
    close(FIC);
}

#---------------------------------------------------------------------------------------
sub startaddIDOnTAG {
&UpdateIndicators2;

    if (!open(FIC,">>MKC-tmp_addIDOnTAG.txt")) {
	&mkPrintErreur("ERREUR : Impossible d\'ouvrir MKC-tmp_addIDOnTAG.txt\n");
	return;
    }
    my $xp = shift;
    my $str = $xp->recognized_string;
    $str =~ s/>$/ id="$idaddIDOnTAG">/;
    print FIC $str;
    $idaddIDOnTAG++;
    close(FIC);
}

#---------------------------------------------------------------------------------------
sub renameTAGXML {
&UpdateIndicators2;

    if ($winMain::search_string eq "") {
	&mkPrintErreur("ERREUR : Aucune slection de chemin donne dans la zone \"Search string\"\n");
	return;
    }

    if ($winMain::replace_string eq "") {
	&mkPrintErreur("ERREUR : Aucune slection de chemin donne dans la zone \"Replace with string\"\n");
	return;
    }

    if (!open(FIC,">MKC-tmp_renameTAG.txt")) {
	&mkPrintErreur("ERREUR : Impossible d\'ouvrir MKC-tmp_renameTAG.txt\n");
	return;
    }
    close(FIC);
    my $parser = new XML::Parser(ErrorContext => 2,
				 Handlers     => {Start => \&startrenameTAGXML,
						  End   => \&endrenameTAGXML,
						  Char  => \&charrenameTAGXML});
    $parser->parsefile($winMain::nom_fic);

    my $tmpfile="MKC-tmp_renameTAG.txt";
    my $msg="MKC-tmp_renameTAG.txt";
    &IncludedFileInWindow($tmpfile,$msg);

}

#---------------------------------------------------------------------------------------
sub escaperenameTAGXML {
&UpdateIndicators2;
  my $str = shift;
  $str =~ s/&/\&amp;/g;
  $str =~ s/</\&lt;/g;
  $str =~ s/>/\&gt;/g;
  $str =~ s/'/\&apos;/g;
  return $str;
}

#---------------------------------------------------------------------------------------
sub charrenameTAGXML {
&UpdateIndicators2;
    if (!open(FIC,">>MKC-tmp_renameTAG.txt")) {
	&mkPrintErreur("ERREUR : Impossible d\'ouvrir MKC-tmp_renameTAG.txt\n");
	return;
    }
    my ($xp, $txt) = @_;
    print FIC escaperenameTAGXML($txt);
    close(FIC);
}

#---------------------------------------------------------------------------------------
sub startrenameTAGXML {
&UpdateIndicators2;
    if (!open(FIC,">>MKC-tmp_renameTAG.txt")) {
	&mkPrintErreur("ERREUR : Impossible d\'ouvrir MKC-tmp_renameTAG.txt\n");
	return;
    }
    my $xp = shift;
    my $el = shift;
    if ($el eq $winMain::search_string) {$el = $winMain::replace_string};
    print FIC "<$el";
    while (@_) {
	print FIC " ", shift, "='", escaperenameTAGXML(shift), "'";
    }
    print FIC ">";
    close(FIC);
}

#---------------------------------------------------------------------------------------
sub endrenameTAGXML {
&UpdateIndicators2;
    if (!open(FIC,">>MKC-tmp_renameTAG.txt")) {
	&mkPrintErreur("ERREUR : Impossible d\'ouvrir MKC-tmp_renameTAG.txt\n");
	return;
    }
    my $xp = shift;
    my $el = shift;
    if ($el eq $winMain::search_string) {$el = $winMain::replace_string};
    print FIC "</$el>";
    close(FIC);
}



#-------XPATH

sub help_xmlXpath {
&UpdateIndicators2;

    if (! Exists ($pn1)) {
	$pn1 = $winMain::mw ->Toplevel();
	$pn1->title("HELP");
	my $label = $pn1->Label( -background => 'black',
				  -foreground =>  'white', -anchor => 'w' );
	my $texte2 = $pn1->Scrolled("MarkupTools")->pack(-side => 'bottom',
				      -fill => 'both',
				      -expand => 1);

	$texte2->Text(-setgrid => 'true');
	&updateMarkupWindow($texte2,$label);
	my $tmpfile="Doc/help_xmlxpath.txt";
	$texte2->IncludeFile($tmpfile);

	$pn1->Button(-text => "Close",
		     -command =>  sub {$pn1->destroy()})->pack(-side => 'top', -pady => 5, -padx => 10);

	my $w_save=$pn1->Button(-text => "Save",
		     -image => $imageSave,
		     -command => sub {$texte2->FileSaveAsPopup()})->pack(-side => 'top', -pady => 5, -padx => 10);
	$winMain::winBalloon->attach($w_save,
			    -balloonmsg => "Save"
			    );

    }
    else {
	$pn1->deiconify();
	$pn1->raise();
    }

}


#---------------------------------------------------------------------------------------
sub xmlXpath {
&UpdateIndicators2;

    if ($winMain::search_string eq "") {
	&mkPrintErreur("ERREUR : Aucune slection de chemin donne dans la zone \"Search string\"\n");
	return;
    }
    $mkTextXpath->destroy if Exists($mkTextXpath);
    $mkTextXpath = $winMain::mw->Toplevel();
    my $w = $mkTextXpath;
    $w->title('XPATH');
    $w->iconname('XPATH');
    my $w_ok = $w->Button(-text => 'OK', -width => 8, -command => ['destroy', $w]);
    my $w_t = $w->TextUndo(-setgrid => 'true', -width => '60', -height => '28',
			-font => '-Adobe-Helvetica-Bold-R-Normal--*-120-*-*-*-*-*-*');
    my $w_save = $w->Button(-text => "Save",
			    -image => $winMain::imageSave,
			    -command => sub {$w_t->FileSaveAsPopup()})->pack(-side => 'top', -pady => 5, -padx => 10);
    $winMain::winBalloon->attach($w_save,
                  -balloonmsg => "Save"
               );


    my $w_s = $w->Scrollbar(-command => ['yview', $w_t]);
    $w_t->configure(-yscrollcommand => ['set', $w_s]);
    $w_ok->pack(-side => 'top', -pady => 5, -padx => 10);
    $w_s->pack(-side => 'right', -fill => 'y');
    $w_t->pack(-expand => 'yes', -fill => 'both');

    # Set up display styles

    my(@bold, @normal, $tags);
    if ($mkTextXpath->depth > 1) {
	@bold = (-foreground => 'red');
	@normal = (-foreground => undef);
    } else {
	@bold = (-foreground => 'white', -background => 'black');
	@normal = (-foreground => undef, -background => undef);
    }


    my $xpath;

    my $xmlp = XML::XPath::XMLParser->new( filename => $winMain::nom_fic);

    my $time = time;
    my $context = $xmlp->parse;

    
    $xpath = XML::XPath->new(filename => $winMain::nom_fic);

    my $nodes = $xpath->find($winMain::search_string,$context);
    print $winMain::search_string , "\n";
    print $nodes->size , "\n";
    unless ($nodes->isa('XML::XPath::NodeSet')) {
      NOTNODES:
	$w_t->insert("end","Query didn't return a nodeset. Value: ");
	$w_t->insert("end","".print $nodes->value."\n");
	return;
    }

	$nodes = find_more($nodes);
	goto NOTNODES unless $nodes->isa('XML::XPath::NodeSet');

    if ($nodes->size) {
	$w_t->insert("end", "<?xml version=\"1.0\" encoding=\"ISO-8859-1\"?>\n<results>\n<title>Rsultats XPATH...</title>\n");
	$w_t->insert("end","<node-number>".$nodes->size."</node-number>\n");
	foreach my $node ($nodes->get_nodelist) {
		$w_t->insert("end","<node>\n");
		$w_t->insert("end",$node->toString);
		$w_t->insert("end","\n</node>\n");
	}
    }
    else {
	$w_t->insert("end", "<?xml version=\"1.0\" encoding=\"ISO-8859-1\"?>\n<results>\n<title>Rsultats XPATH...</title>\n");
	$w_t->insert("end","<empty>No nodes found</empty>\n");
    }

    $w_t->insert("end","</results>\n");

}

#---------------------------------------------------------------------------------------
sub find_more {
&UpdateIndicators2;
	my ($nodes) = @_;
	if (!@ARGV) {
		return $nodes;
	}
	
	my $newnodes = XML::XPath::NodeSet->new;
	
	my $find = shift @ARGV;
	
	foreach my $node ($nodes->get_nodelist) {
		my $new = $xpath->find($find, $node);
		if ($new->isa('XML::XPath::NodeSet')) {
			$newnodes->append($new);
		}
		else {
			warn "Not a nodeset: ", $new->value, "\n";
		}
	}
	
	return find_more($newnodes);
}

#---------------------------------------------------------------------------------------
sub xmlXpath1 {
    &UpdateIndicators2;
    if ($winMain::search_string eq "") {
	&mkPrintErreur("ERREUR : Aucune slection de chemin donne dans la zone \"Search string\"\n");
	return;
    }
    $mkTextXpath->destroy if Exists($mkTextXpath);
    $mkTextXpath = $winMain::mw->Toplevel();
    my $w = $mkTextXpath;
    $w->title('XPATH');
    $w->iconname('XPATH');
    my $w_ok = $w->Button(-text => 'OK', -width => 8, -command => ['destroy', $w]);
    my $w_t = $w->TextUndo(-setgrid => 'true', -width => '60', -height => '28',
			   -font => '-Adobe-Helvetica-Bold-R-Normal--*-120-*-*-*-*-*-*');
    my $w_save = $w->Button(-text => "Save",
			    -image => $winMain::imageSave,
			    -command => sub {$w_t->FileSaveAsPopup()})->pack(-side => 'top', -pady => 5, -padx => 10);
    $winMain::winBalloon->attach($w_save,
				 -balloonmsg => "Save"
				 );
    my $w_s = $w->Scrollbar(-command => ['yview', $w_t]);
    $w_t->configure(-yscrollcommand => ['set', $w_s]);
    $w_ok->pack(-side => 'top', -pady => 5, -padx => 10);
    $w_s->pack(-side => 'right', -fill => 'y');
    $w_t->pack(-expand => 'yes', -fill => 'both');
    # Set up display styles
    my(@bold, @normal, $tags);
    if ($mkTextXpath->depth > 1) {
	@bold = (-foreground => 'red');
	@normal = (-foreground => undef);
    } else {
	@bold = (-foreground => 'white', -background => 'black');
	@normal = (-foreground => undef, -background => undef);
    }
    
    use XML::XPath;
    use XML::XPath::XMLParser;

    my $xpath = XML::XPath->new(filename => $winMain::nom_fic);
    my $nodeset = $xpath->find($winMain::search_string);

    if ($nodeset->size) {
	$w_t->insert("end", "<?xml version=\"1.0\" encoding=\"ISO-8859-1\"?>\n<results>\n<title>Rsultats XPATH...</title>\n");
	foreach my $node ($nodeset->get_nodelist) {
		$w_t->insert("end",XML::XPath::XMLParser::as_string($node)."\n");
	    }
    }
    else {
	$w_t->insert("end", "<?xml version=\"1.0\" encoding=\"ISO-8859-1\"?>\n<results>\n<title>Rsultats XPATH...</title>\n");
	$w_t->insert("end","<empty>No nodes found</empty>\n");
    }

    $w_t->insert("end","</results>\n");

}

#---------------------------------------------------------------------------------------
sub xmlXpath2 {
&UpdateIndicators2;

    if ($winMain::search_string eq "") {
	&mkPrintErreur("ERREUR : Aucune slection de chemin donne dans la zone \"Search string\"\n");
	return;
    }
    $mkTextXpath->destroy if Exists($mkTextXpath);
    $mkTextXpath = $winMain::mw->Toplevel();
    my $w = $mkTextXpath;
    $w->title('XPATH');
    $w->iconname('XPATH');
    my $w_ok = $w->Button(-text => 'OK', -width => 8, -command => ['destroy', $w]);
    my $w_t = $w->TextUndo(-setgrid => 'true', -width => '60', -height => '28',
			-font => '-Adobe-Helvetica-Bold-R-Normal--*-120-*-*-*-*-*-*');
    my $w_save = $w->Button(-text => "Save",
			    -image => $winMain::imageSave,
			    -command => sub {$w_t->FileSaveAsPopup()})->pack(-side => 'top', -pady => 5, -padx => 10);
    $winMain::winBalloon->attach($w_save,
                  -balloonmsg => "Save"
               );
    my $w_s = $w->Scrollbar(-command => ['yview', $w_t]);
    $w_t->configure(-yscrollcommand => ['set', $w_s]);
    $w_ok->pack(-side => 'top', -pady => 5, -padx => 10);
    $w_s->pack(-side => 'right', -fill => 'y');
    $w_t->pack(-expand => 'yes', -fill => 'both');
    # Set up display styles
    my(@bold, @normal, $tags);
    if ($mkTextXpath->depth > 1) {
	@bold = (-foreground => 'red');
	@normal = (-foreground => undef);
    } else {
	@bold = (-foreground => 'white', -background => 'black');
	@normal = (-foreground => undef, -background => undef);
    }
    my $xpath;
    my $xmlp = XML::XPath::XMLParser->new( filename => $winMain::nom_fic);
    my $time = time;
    my $context = $xmlp->parse;
    $xpath = XML::XPath->new(filename => $winMain::nom_fic);
    my $nodeWithTextInput="//*";
    print "SEARCH : ",$nodeWithTextInput,"\n";
    my $nodes = $xpath->find($nodeWithTextInput,$context);
    print $winMain::search_string , "\n";
    print $nodes->size , "\n";
    if ($nodes->size) {
	$w_t->insert("end", "<?xml version=\"1.0\" encoding=\"ISO-8859-1\"?>\n<results>\n<title>Rsultats XPATH...</title>\n");
	foreach my $node ($nodes->get_nodelist) {
	    my $textNode = $xpath->find('string(./text())',$node);
	    if ($textNode =~/$winMain::search_string/) {
		$w_t->insert("end","<node>\n");
		$w_t->insert("end",$node->toString);
		$w_t->insert("end","\n</node>\n");
	    }
	}
    }
    else {
	$w_t->insert("end", "<?xml version=\"1.0\" encoding=\"ISO-8859-1\"?>\n<results>\n<title>Rsultats XPATH...</title>\n");
	$w_t->insert("end","<empty>No nodes found</empty>\n");
    }

    $w_t->insert("end","</results>\n");
}

#---------------------------------------------------------------------------------------
sub xmlXpath3 {
&UpdateIndicators2;

    if ($winMain::search_string eq "") {
	&mkPrintErreur("ERREUR : Aucune slection de chemin donne dans la zone \"Search string\"\n");
	return;
    }
    $mkTextXpath->destroy if Exists($mkTextXpath);
    $mkTextXpath = $winMain::mw->Toplevel();
    my $w = $mkTextXpath;
    $w->title('XPATH');
    $w->iconname('XPATH');
    my $w_ok = $w->Button(-text => 'OK', -width => 8, -command => ['destroy', $w]);
    my $w_t = $w->TextUndo(-setgrid => 'true', -width => '60', -height => '28',
			-font => '-Adobe-Helvetica-Bold-R-Normal--*-120-*-*-*-*-*-*');
    my $w_save = $w->Button(-text => "Save",
			    -image => $winMain::imageSave,
			    -command => sub {$w_t->FileSaveAsPopup()})->pack(-side => 'top', -pady => 5, -padx => 10);
    $winMain::winBalloon->attach($w_save,
                  -balloonmsg => "Save"
               );
    my $w_s = $w->Scrollbar(-command => ['yview', $w_t]);
    $w_t->configure(-yscrollcommand => ['set', $w_s]);
    $w_ok->pack(-side => 'top', -pady => 5, -padx => 10);
    $w_s->pack(-side => 'right', -fill => 'y');
    $w_t->pack(-expand => 'yes', -fill => 'both');
    # Set up display styles
    my(@bold, @normal, $tags);
    if ($mkTextXpath->depth > 1) {
	@bold = (-foreground => 'red');
	@normal = (-foreground => undef);
    } else {
	@bold = (-foreground => 'white', -background => 'black');
	@normal = (-foreground => undef, -background => undef);
    }
    
    $w_t->insert("end", "<?xml version=\"1.0\" encoding=\"ISO-8859-1\"?>\n<results>\n<title>Rsultats XPATH...</title>\n");
    use XML::XPath::XMLParser;
    my $xpp = XML::XPath::XMLParser->new( filename => $winMain::nom_fic);
    my $tree = $xpp->parse;
    my $xp = XML::XPath->new(context => $tree);
    my $nodes = $xp->find("//$winMain::search_string");
    foreach my $node ($nodes->get_nodelist) {
	# get text node children as a string
	$w_t->insert("end","<node>\n");
	$w_t->insert("end",$node->toString);
	$w_t->insert("end","\n</node>\n");
	    }
    $w_t->insert("end","</results>");


}


#---------------------------------------------------------------------------------------
sub xmlXpath4 {
&UpdateIndicators2;

    &mkPrintMsgInfo("Vous avez accs  l'interface XPath via la fentre MSDOS active. Pour utiliser cette interface il faut au pralable charger un document XML dans MKCORPUS.");
    system("java -classpath lib/xalan.jar;/lib/xerces.jar;lib/xml.jar;. ApplyXPath $winMain::nom_fic");

}

#---- FIN XPATH


#---------------------------------------------------------
sub xmlConverter1 {
&UpdateIndicators2;
if (!open(TMPFILE2,(">MKC-tmp_xmlConversion.htm"))) {
    &mkPrintErreur("ERREUR : Impossible d\'ouvrir le fichier MKC-tmp_xmlConversion.htm\n");
    return;
}
my $p = XML::Parser->new(Style => 'Tree'); 
my $tree = $p->parsefile($winMain::nom_fic); 
$levelxmlConverter1 = 0; 
$indxmlConverter1 = ''; 
$headxmlConverter1 = 1; 
print TMPFILE2 "<html>\n";
print TMPFILE2 "<head>\n"; 
print TMPFILE2 "<title>$tree->[1]->[4]->[2]</title>\n"; 
print TMPFILE2 "</head>\n<body>\n"; 
close (TMPFILE2);
process_node1(@$tree); 
if (!open(TMPFILE2,(">>MKC-tmp_xmlConversion.htm"))) {
    &mkPrintErreur("ERREUR : Impossible d\'ouvrir le fichier MKC-tmp_xmlConversion.htm\n");
    return;
}
print TMPFILE2 "</body>\n</html>\n"; 
close (TMPFILE2);
my $tmpfile="MKC-tmp_xmlConversion.htm";
my $msg="MKC-tmp_xmlConversion.htm";
&IncludedFileInWindow($tmpfile,$msg);
}

#---------------------------------------------------------
sub xmlConverter2 {
&UpdateIndicators2;
if (!open(TMPFILE2,(">MKC-tmp_xmlConversion.pod"))) {
    &mkPrintErreur("ERREUR : Impossible d\'ouvrir le fichier MKC-tmp_xmlConversion.pod\n");
	return;
}
my $p = XML::Parser->new(Style => 'Tree'); 
my $tree = $p->parsefile($winMain::nom_fic); 
$levelxmlConverter2 = 0; 
$indxmlConverter2 = ''; 
$headxmlConverter2 = 1; 
print TMPFILE2 "=pod\n\n"; 
close (TMPFILE2);
process_node2(@$tree); 
if (!open(TMPFILE2,(">>MKC-tmp_xmlConversion.pod"))) {
    &mkPrintErreur("ERREUR : Impossible d\'ouvrir le fichier MKC-tmp_xmlConversion.pod\n");
	return;
}
print TMPFILE2 "=cut\n\n"; 
close (TMPFILE2);
my $tmpfile="MKC-tmp_xmlConversion.pod";
my $msg="MKC-tmp_xmlConversion.pod";
&IncludedFileInWindow($tmpfile,$msg);
}
#---------------------------------------------------------

sub xmlConverter3 {
&UpdateIndicators2;
if (!open(TMPFILE2,(">MKC-tmp_xmlConversion.txt"))) {
    &mkPrintErreur("ERREUR : Impossible d\'ouvrir le fichier MKC-tmp_xmlConversion.txt\n");
    return;
}
my $p = XML::Parser->new(Style => 'Tree'); 
my $tree = $p->parsefile($winMain::nom_fic); 
$levelxmlConverter3 = 0; 
$indxmlConverter3 = ''; 
$headxmlConverter3 = 1; 
print TMPFILE2 "\n", $tree->[1]->[4]->[2], "\n"; 
print TMPFILE2 '-' x length($tree->[1]->[4]->[2]), "\n\n"; 
close (TMPFILE2);
process_node3(@$tree); 
my $tmpfile="MKC-tmp_xmlConversion.txt";
my $msg="MKC-tmp_xmlConversion.txt";
&IncludedFileInWindow($tmpfile,$msg);
}

#---------------------------------------------------------

sub xmlConverter4 {
&UpdateIndicators2;
    if (!open(TMPFILE2,(">MKC-tmp_xmlConversion.xml"))) {
	&mkPrintErreur("ERREUR : Impossible d\'ouvrir le fichier MKC-tmp_xmlConversion.txt\n");
	return;
    }
    if (!open(TMPFILE,("$winMain::nom_fic"))) {
	&mkPrintErreur("ERREUR : Impossible d\'ouvrir le fichier '$winMain::nom_fic'\n");
	return;
    }
    print TMPFILE2 "<?xml version=\"1.0\" encoding=\"ISO-8859-1\" standalone=\"yes\"?>\n<result_rtf2xml>\n";
    my $open_count = 0;
    while (<TMPFILE>) {
	while( # Iterate over tokens on each line
	       m<
	       \G(?:
		  ([{}])  # \1
		  |
		  (?: \\
		   ([a-z]+)       # \2: keyword
		   (-?\d+)?       # \3: number
		   \x20?
		   )
		  |
		  (?: \\ 
		   (?:  (?: '([0-9a-fA-F]{2})) # \4: hex escape
              | ([-_|~:*\cm\cj{}])) # \5: magic character
        )
      |
      ([\cm\cj]+) # \6
      |
      ([<>&])     # \7
      |
      ([^\\{}\cm\cj]+)   # \8: unescaped character data (not [<>&])
    )
  >sgx) {
    if( defined $1 ) {
      if($1 eq '{') {
	++$open_count;  print TMPFILE2 "<parenthese>\n";
      } else {
        exit if --$open_count < 0;   print TMPFILE2 "</parenthese>\n";
      }
    } elsif( defined $2 ) {
      #print "\n<!-- Left: [", substr($_, pos($_)), "] -->";
      if(defined($3)) {
        if($2 ne 'bin') {
          print TMPFILE2 "<$2"." att=\"$3\"/>\n"; # always -+\d+, so needs no escaping
        } else { # special case: the 'bin' word.
          if($3 < 1) { # sanity
            print TMPFILE2 "<bin"." att=\"\"/>\n";
          } elsif($3 < (length $_ - pos($_))) {  # all here
            my $b = substr($_,pos($_), $3);
            pos($_) += $3; # skip over that stuff;
            $b =~ s/([^\x21-\x25\x27-\x3B\x3D\x3F-\x7E])/'&#'.(ord($1)).';'/eg;
		 print TMPFILE2 "<bin"." att=\"$b\"/>\n";
	     } else {
            my $b = substr($_,pos($_), $3);
            my $l = $3 - length $b;
            $_ = ''; # clear buffer
            $b =~ s/([^\x21-\x25\x27-\x3B\x3D\x3F-\x7E])/'&#'.(ord($1)).';'/eg;
            print TMPFILE2 "<bin"." att=$b";
            while($l > 0 and !eof) {
		$l -= read(STDIN, $b, ($l > 512) ? 512 : $l);
                # Decent block size, I guess.
              $b =~ s/([^\x21-\x25\x27-\x3B\x3D\x3F-\x7E])/'&#'.(ord($1)).';'/eg;
              print TMPFILE2 $b;
	  }
            print TMPFILE2 "/>\n";
	}
		     }
		} else {
	  print TMPFILE2 "<$2/>\n"; # always a-z, so needs no escaping
    }
	       } elsif( defined $4 ) {
	print TMPFILE2 "&#x$4;";
  } elsif( defined $5 ) {
	# ([-_|~:*\cm\cj{}]) )    # \5: magic character of some sort
	if($5 eq '*')      { print TMPFILE2 "<S/>\n"        } # S for Star.
      elsif($5 eq "\cm"
	    or $5 eq "\cj") { print TMPFILE2 "<par/>\n"      }
      elsif($5 eq '-')   { print TMPFILE2 "&shy;"       }
      elsif($5 eq '|')   { print TMPFILE2 "<Formula/>\n"  }
      elsif($5 eq '_')   { print TMPFILE2 "&#x2011;"  } # nonbreaking hyphen
      elsif($5 eq ':')   { print TMPFILE2 "<Subentry/>\n" }
      elsif($5 eq '~')   { print TMPFILE2 "&nbsp;"      }
      else               { print TMPFILE2 $5            }   # { or }
  } elsif( defined $6 ) {
    } elsif(defined $7) {
	if($7 eq '&')    { print TMPFILE2 "&amp;" }
      elsif($7 eq '<') { print TMPFILE2 "&lt;"  }
      else             { print TMPFILE2 "&gt;"  } 
  } else {
	print TMPFILE2 $8;
  }
	      }
	   }

	print TMPFILE2 "</result_rtf2xml>\n";
	close(TMPFILE);
	close(TMPFILE2);
	my $tmpfile="MKC-tmp_xmlConversion.xml";
	my $msg="MKC-tmp_xmlConversion.xml";
	&IncludedFileInWindow($tmpfile,$msg);
}


#---------------------------------------------------------
sub process_node1 { 
&UpdateIndicators2;
  my ($type, $content) = @_; 
  my $indxmlConverter1 = ' ' x $levelxmlConverter1; 
  if (!open(TMPFILE2,(">>MKC-tmp_xmlConversion.htm"))) {
    &mkPrintErreur("ERREUR : Impossible d\'ouvrir le fichier MKC-tmp_xmlConversion.htm\n");
    return;
}
  if ($type) { # element 
    my $attrs = shift @$content; 
    print TMPFILE2 $indxmlConverter1, $type, ' ['; 
    print TMPFILE2 join(', ', map { "$_: $attrs->{$_}" } keys %{$attrs}); 
    print TMPFILE2 "]\n"; 

    ++$level; 
    while (my @node = splice(@$content, 0, 2)) { 
      process_node1(@node); # Recursively call this subroutine 
    }
    --$level; 
  } else { #text 
    $content =~ s/\n/ /g; 
    $content =~ s/^\s+//; 
    $content =~ s/\s+$//; 
    print TMPFILE2 $indxmlConverter1, $content, "\n"; 
  }

close (TMPFILE2); 
}

#---------------------------------------------------------
sub process_node3 { 
&UpdateIndicators2;
  my ($type, $content) = @_; 
  my $indxmlConverter3 = ' ' x $levelxmlConverter3; 
  if (!open(TMPFILE2,(">>MKC-tmp_xmlConversion.txt"))) {
    &mkPrintErreur("ERREUR : Impossible d\'ouvrir le fichier MKC-tmp_xmlConversion.txt\n");
    return;
}
  if ($type) { # element 
    my $attrs = shift @$content; 
    print TMPFILE2 $indxmlConverter3, $type, ' ['; 
    print TMPFILE2 join(', ', map { "$_: $attrs->{$_}" } keys %{$attrs}); 
    print TMPFILE2 "]\n"; 

    ++$level; 
    while (my @node = splice(@$content, 0, 2)) { 
      process_node3(@node); # Recursively call this subroutine 
    }
    --$level; 
  } else { #text 
    $content =~ s/\n/ /g; 
    $content =~ s/^\s+//; 
    $content =~ s/\s+$//; 
    print TMPFILE2 $indxmlConverter3, $content, "\n"; 
  }

close (TMPFILE2); 
}

#---------------------------------------------------------
sub process_node2 { 
&UpdateIndicators2;
  my ($type, $content) = @_; 
  my $indxmlConverter2 = ' ' x $levelxmlConverter2; 
  if (!open(TMPFILE2,(">>MKC-tmp_xmlConversion.pod"))) {
    &mkPrintErreur("ERREUR : Impossible d\'ouvrir le fichier MKC-tmp_xmlConversion.pod\n");
    return;
}
  if ($type) { # element 
    my $attrs = shift @$content; 
    print TMPFILE2 $indxmlConverter2, $type, ' ['; 
    print TMPFILE2 join(', ', map { "$_: $attrs->{$_}" } keys %{$attrs}); 
    print TMPFILE2 "]\n"; 

    ++$level; 
    while (my @node = splice(@$content, 0, 2)) { 
      process_node2(@node); # Recursively call this subroutine 
    }
    --$level; 
  } else { #text 
    $content =~ s/\n/ /g; 
    $content =~ s/^\s+//; 
    $content =~ s/\s+$//; 
    print TMPFILE2 $indxmlConverter2, $content, "\n"; 
  }

close (TMPFILE2); 
}


#---------------------------------------------------------
sub process_node1b { 
&UpdateIndicators2;
  my ($type, $content) = @_;
  print "TYPE = ".$type."\n";
  print "CONTENT = ".$content."\n";
 
  $indxmlConverter1 = ' ' x $levelxmlConverter1; 
  if ($type) { 
    local $_ = $type; 
    my $attrs = shift @$content;   
#    print "ATTR = ".$attrs."\n";
    /^NAME$/ && name1($content); 
    /^SYNOPSIS$/ && synopsis1($content); 
    /^DESCRIPTION$/ && description1(); 
    /^TEXT$/ && text1($content); 
    /^CODE$/ && code1($content); 
    /^HEAD$/ && head1($content); 
    /^LIST$/ && do {list1($attrs, $content); @$content = ()}; 
    /^AUTHOR$/ && author1(); 
    /^ANAME$/ && aname1($content); 
    /^EMAIL$/ && email1($content); 
    /^SEE_ALSO$/ && see_also1($content); 
    while (my @node = splice @$content, 0, 2) { 
      ++$levelxmlConverter1; 
      ++$headxmlConverter1 if $type eq 'SUBSECTION'; 
#       print "NODE = ".@node."\n";
      process_node1b(@node); 
      --$headxmlConverter1 if $type eq 'SUBSECTION'; 
      --$levelxmlConverter1; 
    } 
  } 
} 
#---------------------------------------------------------
sub process_node2b { 
&UpdateIndicators2;
  my ($type, $content) = @_; 
  $indxmlConverter2 = ' ' x $levelxmlConverter2; 
  if ($type) { 
    local $_ = $type; 
    my $attrs = shift @$content; 
    /^NAME$/ && name2($content); 
    /^SYNOPSIS$/ && synopsis2($content); 
    /^DESCRIPTION$/ && description2(); 
    /^TEXT$/ && text2($content); 
    /^CODE$/ && code2($content); 
    /^HEAD$/ && head2($content); 
    /^LIST$/ && do {list2($attrs, $content); @$content = ()}; 
    /^AUTHOR$/ && author2(); 
    /^ANAME$/ && aname2($content); 
    /^EMAIL$/ && email2($content); 
    /^SEE_ALSO$/ && see_also2($content); 
    while (my @node = splice @$content, 0, 2) { 
      ++$levelxmlConverter2; 
      ++$headxmlConverter2 if $type eq 'SUBSECTION'; 
      process_node2b(@node); 
      --$headxmlConverter2 if $type eq 'SUBSECTION'; 
      --$levelxmlConverter2; 
    } 
  } 
} 
#---------------------------------------------------------
sub process_node3b { 
&UpdateIndicators2;
  my ($type, $content) = @_; 
  $indxmlConverter3 = ' ' x $levelxmlConverter3; 
  if ($type) { 
    local $_ = $type; 
    my $attrs = shift @$content; 
    /^NAME$/ && name3($content); 
    /^SYNOPSIS$/ && synopsis3($content); 
    /^DESCRIPTION$/ && description3(); 
    /^TEXT$/ && text3($content); 
    /^CODE$/ && code3($content); 
    /^HEAD$/ && head3($content); 
    /^LIST$/ && do {list3($attrs, $content); @$content = ()}; 
    /^AUTHOR$/ && author3(); 
    /^ANAME$/ && aname3($content); 
    /^EMAIL$/ && email3($content); 
    /^SEE_ALSO$/ && see_also3($content); 
    while (my @node = splice @$content, 0, 2) { 
      ++$levelxmlConverter3; 
      ++$headxmlConverter3 if $type eq 'SUBSECTION'; 
      process_node3b(@node); 
      --$headxmlConverter3 if $type eq 'SUBSECTION'; 
      --$levelxmlConverter3; 
    } 
  } 
} 
#---------------------------------------------------------
sub name1 { 
&UpdateIndicators2;
  my $content = shift; 
  if (!open(TMPFILE2,(">>MKC-tmp_xmlConversion.htm"))) {
    &mkPrintErreur("ERREUR : Impossible d\'ouvrir le fichier MKC-tmp_xmlConversion.htm\n");
    return;
}  
  print TMPFILE2 "<h1>NAME</h1>\n"; 
  print TMPFILE2 "<p>$content->[1]</p>\n" ;
  close(TMPFILE2);
}
#---------------------------------------------------------
sub name2 { 
&UpdateIndicators2;
  if (!open(TMPFILE2,(">>MKC-tmp_xmlConversion.pod"))) {
    &mkPrintErreur("ERREUR : Impossible d\'ouvrir le fichier MKC-tmp_xmlConversion.pod\n");
    return;
}
  my $content = shift; 
  print TMPFILE2 "=head1 NAME\n\n"; 
  print TMPFILE2 "$content->[1]\n\n"; 
  close(TMPFILE2);
}
#---------------------------------------------------------
sub name3 { 
&UpdateIndicators2;
  if (!open(TMPFILE2,(">>MKC-tmp_xmlConversion.txt"))) {
    &mkPrintErreur("ERREUR : Impossible d\'ouvrir le fichier MKC-tmp_xmlConversion.txt\n");
    return;
}
  my $content = shift; 
  print TMPFILE2 "NAME\n\n"; 
  print TMPFILE2 $indxmlConverter3, "$content->[1]\n\n"; 
  close(TMPFILE2);
}
#---------------------------------------------------------
sub synopsis1 { 
&UpdateIndicators2;
  if (!open(TMPFILE2,(">>MKC-tmp_xmlConversion.htm"))) {
    &mkPrintErreur("ERREUR : Impossible d\'ouvrir le fichier MKC-tmp_xmlConversion.htm\n");
    return;
}
  my $content = shift; 
  print TMPFILE2 "<h1>SYNOPSIS</h1>\n"; 
  print TMPFILE2 "<pre>$content->[1]</pre>\n";
  close(TMPFILE2);
} 
#---------------------------------------------------------
sub synopsis2 { 
&UpdateIndicators2;
  if (!open(TMPFILE2,(">>MKC-tmp_xmlConversion.pod"))) {
    &mkPrintErreur("ERREUR : Impossible d\'ouvrir le fichier MKC-tmp_xmlConversion.pod\n");
    return;
}
  my $content = shift; 
  print TMPFILE2 "=head1 SYNOPSIS\n\n"; 
  print TMPFILE2 "$content->[1]\n"; 
  close(TMPFILE2);
} 
#---------------------------------------------------------
sub synopsis3 { 
&UpdateIndicators2;
  if (!open(TMPFILE2,(">>MKC-tmp_xmlConversion.txt"))) {
    &mkPrintErreur("ERREUR : Impossible d\'ouvrir le fichier MKC-tmp_xmlConversion.txt\n");
    return;
}
  my $content = shift; 
  print TMPFILE2 "SYNOPSIS\n"; 
  print TMPFILE2 "$content->[1]\n"; 
  close(TMPFILE2);
} 
#---------------------------------------------------------
sub description1 { 
&UpdateIndicators2;
  if (!open(TMPFILE2,(">>MKC-tmp_xmlConversion.htm"))) {
    &mkPrintErreur("ERREUR : Impossible d\'ouvrir le fichier MKC-tmp_xmlConversion.htm\n");
    return;
}
  print TMPFILE2 "<h1>DESCRIPTION</h1>\n"; 
  close(TMPFILE2);
} 
#---------------------------------------------------------
sub description2 { 
&UpdateIndicators2;
  if (!open(TMPFILE2,(">>MKC-tmp_xmlConversion.pod"))) {
    &mkPrintErreur("ERREUR : Impossible d\'ouvrir le fichier MKC-tmp_xmlConversion.pod\n");
    return;
}
  print TMPFILE2 "=head1 DESCRIPTION\n\n"; 
  close(TMPFILE2);
} 
#---------------------------------------------------------
sub description3 { 
&UpdateIndicators2;
  if (!open(TMPFILE2,(">>MKC-tmp_xmlConversion.txt"))) {
    &mkPrintErreur("ERREUR : Impossible d\'ouvrir le fichier MKC-tmp_xmlConversion.txt\n");
    return;
}
  print TMPFILE2 "DESCRIPTION\n\n"; 
  close(TMPFILE2);
} 
#---------------------------------------------------------
sub text1 { 
&UpdateIndicators2;
  if (!open(TMPFILE2,(">>MKC-tmp_xmlConversion.htm"))) {
    &mkPrintErreur("ERREUR : Impossible d\'ouvrir le fichier MKC-tmp_xmlConversion.htm\n");
    return;
}
  my $content = shift; 
  print "CONTENT = $content\n";
  print TMPFILE2 "<p>$content->[1]</p>\n";
  print "CONTENT = $content->[1]\n";
  close(TMPFILE2);
} 
#---------------------------------------------------------
sub text2 { 
&UpdateIndicators2;
  if (!open(TMPFILE2,(">>MKC-tmp_xmlConversion.pod"))) {
    &mkPrintErreur("ERREUR : Impossible d\'ouvrir le fichier MKC-tmp_xmlConversion.pod\n");
    return;
}
  my $content = shift; 
  print TMPFILE2 wrap('', '', trim($content->[1])), "\n\n"; 
  close(TMPFILE2);
} 
#---------------------------------------------------------
sub text3 { 
&UpdateIndicators2;
  if (!open(TMPFILE2,(">>MKC-tmp_xmlConversion.txt"))) {
    &mkPrintErreur("ERREUR : Impossible d\'ouvrir le fichier MKC-tmp_xmlConversion.txt\n");
    return;
}
  my $content = shift; 
  print TMPFILE2 wrap($indxmlConverter3, $indxmlConverter3, trim($content->[1])), "\n\n"; 
  close(TMPFILE2);
} 
#---------------------------------------------------------
sub code1 { 
&UpdateIndicators2;
  if (!open(TMPFILE2,(">>MKC-tmp_xmlConversion.htm"))) {
    &mkPrintErreur("ERREUR : Impossible d\'ouvrir le fichier MKC-tmp_xmlConversion.htm\n");
    return;
}
  my $content = shift; 
  print TMPFILE2 "<pre>$content->[1]</pre>\n";
  close(TMPFILE2);
}
#---------------------------------------------------------
sub code2 { 
&UpdateIndicators2;
  if (!open(TMPFILE2,(">>MKC-tmp_xmlConversion.pod"))) {
    &mkPrintErreur("ERREUR : Impossible d\'ouvrir le fichier MKC-tmp_xmlConversion.pod\n");
    return;
}
  my $content = shift; 
  print TMPFILE2 "$content->[1]\n"; 
  close(TMPFILE2);
}
#---------------------------------------------------------
sub code3 { 
&UpdateIndicators2;
  if (!open(TMPFILE2,(">>MKC-tmp_xmlConversion.txt"))) {
    &mkPrintErreur("ERREUR : Impossible d\'ouvrir le fichier MKC-tmp_xmlConversion.txt\n");
    return;
}
  my $content = shift; 
  print TMPFILE2 "$content->[1]\n";
  close(TMPFILE2);
}
#---------------------------------------------------------
sub head1 { 
&UpdateIndicators2;
  if (!open(TMPFILE2,(">>MKC-tmp_xmlConversion.htm"))) {
    &mkPrintErreur("ERREUR : Impossible d\'ouvrir le fichier MKC-tmp_xmlConversion.htm\n");
    return;
}
  my $content = shift; 
  print TMPFILE2 "<h$headxmlConverter1>", trim($content->[1]), "</h$headxmlConverter1>\n" ;
  close(TMPFILE2);
} 
#---------------------------------------------------------
sub head2 { 
&UpdateIndicators2;
  if (!open(TMPFILE2,(">>MKC-tmp_xmlConversion.pod"))) {
    &mkPrintErreur("ERREUR : Impossible d\'ouvrir le fichier MKC-tmp_xmlConversion.pod\n");
    return;
}
  my $content = shift; 
  print TMPFILE2 "=head$headxmlConverter2 ", trim($content->[1]), "\n\n"; 
  close(TMPFILE2);
} 
#---------------------------------------------------------
sub head3 { 
&UpdateIndicators2;
  if (!open(TMPFILE2,(">>MKC-tmp_xmlConversion.txt"))) {
    &mkPrintErreur("ERREUR : Impossible d\'ouvrir le fichier MKC-tmp_xmlConversion.txt\n");
    return;
}
  my $content = shift; 
  print TMPFILE2 trim($content->[1]), "\n\n"; 
  close(TMPFILE2);
} 
#---------------------------------------------------------
sub list1 { 
&UpdateIndicators2;
  if (!open(TMPFILE2,(">>MKC-tmp_xmlConversion.htm"))) {
    &mkPrintErreur("ERREUR : Impossible d\'ouvrir le fichier MKC-tmp_xmlConversion.htm\n");
    return;
}
  my ($attrs, $content) = @_; 
  my %list = (bullet => 'ul', numbered => 'ol');
  my $type = $attrs->{TYPE}; 
  print TMPFILE2 "<$list{$type}>\n"; 
  while (my @node = splice @$content, 0, 2) { 
      if ($node[0] eq 'ITEM') { 
	  print TMPFILE2 "<li>$node[1]->[2]</li>\n"; 
      } 
  } 
  print TMPFILE2 "</$list{$type}>\n"; 
  close(TMPFILE2);
} 
#---------------------------------------------------------
sub list2 { 
&UpdateIndicators2;
  if (!open(TMPFILE2,(">>MKC-tmp_xmlConversion.pod"))) {
    &mkPrintErreur("ERREUR : Impossible d\'ouvrir le fichier MKC-tmp_xmlConversion.pod\n");
    return;
}
  my ($attrs, $content) = @_; 
  my %list = (bullet => 'ul', numbered => 'ol');
  my $type = $attrs->{TYPE}; 
  print TMPFILE2 "=over 4\n"; 
  while (my @node = splice @$content, 0, 2) { 
      my $cnt = 1; 
      if ($node[0] eq 'ITEM') { 
	  print TMPFILE2 "=item *\n$node[1]->[2]\n\n"; 
      } 
  } 
  print TMPFILE2 "=back\n\n"; 
  close(TMPFILE2);
} 
#---------------------------------------------------------
sub list3 { 
&UpdateIndicators2;
  if (!open(TMPFILE2,(">>MKC-tmp_xmlConversion.txt"))) {
    &mkPrintErreur("ERREUR : Impossible d\'ouvrir le fichier MKC-tmp_xmlConversion.txt\n");
    return;
}
  my ($attrs, $content) = @_; 
  my %list = (bullet => 'ul', numbered => 'ol');
  my $type = $attrs->{TYPE}; 
  while (my @node = splice @$content, 0, 2) { 
      my $cnt = 1; 
      if ($node[0] eq 'ITEM') { 
	  print TMPFILE2 $indxmlConverter3, "* $node[1]->[2]\n"; 
      } 
  } 
  print TMPFILE2 "\n"; 
  close(TMPFILE2);
} 
#---------------------------------------------------------
sub author1 { 
&UpdateIndicators2;
  if (!open(TMPFILE2,(">>MKC-tmp_xmlConversion.htm"))) {
    &mkPrintErreur("ERREUR : Impossible d\'ouvrir le fichier MKC-tmp_xmlConversion.htm\n");
    return;
}
  print TMPFILE2 "<h1>AUTHOR</h1>\n";
  close(TMPFILE2);
} 
#---------------------------------------------------------
sub author2 { 
&UpdateIndicators2;
  if (!open(TMPFILE2,(">>MKC-tmp_xmlConversion.pod"))) {
    &mkPrintErreur("ERREUR : Impossible d\'ouvrir le fichier MKC-tmp_xmlConversion.pod\n");
    return;
}
  print TMPFILE2 "=head1 AUTHOR\n\n"; 
  close(TMPFILE2);
} 
#---------------------------------------------------------
sub author3 { 
&UpdateIndicators2;
  if (!open(TMPFILE2,(">>MKC-tmp_xmlConversion.txt"))) {
    &mkPrintErreur("ERREUR : Impossible d\'ouvrir le fichier MKC-tmp_xmlConversion.txt\n");
    return;
}
  print TMPFILE2 "AUTHOR\n\n"; 
  close(TMPFILE2);
} 
#---------------------------------------------------------
sub aname1 { 
&UpdateIndicators2;
  if (!open(TMPFILE2,(">>MKC-tmp_xmlConversion.htm"))) {
    &mkPrintErreur("ERREUR : Impossible d\'ouvrir le fichier MKC-tmp_xmlConversion.htm\n");
    return;
}
  my $content = shift; 
  print TMPFILE2 "<p>$content->[1]\n" ;
  close(TMPFILE2);
} 
#---------------------------------------------------------
sub aname2 { 
&UpdateIndicators2;
  if (!open(TMPFILE2,(">>MKC-tmp_xmlConversion.pod"))) {
    &mkPrintErreur("ERREUR : Impossible d\'ouvrir le fichier MKC-tmp_xmlConversion.pod\n");
    return;
}
  my $content = shift; 
  print TMPFILE2 trim($content->[1]), ' '; 
  close(TMPFILE2);
} 
#---------------------------------------------------------
sub aname3 { 
&UpdateIndicators2;
  if (!open(TMPFILE2,(">>MKC-tmp_xmlConversion.txt"))) {
    &mkPrintErreur("ERREUR : Impossible d\'ouvrir le fichier MKC-tmp_xmlConversion.txt\n");
    return;
}
  my $content = shift; 
  print TMPFILE2 $indxmlConverter3, trim($content->[1]), ' '; 
  close(TMPFILE2);
} 
#---------------------------------------------------------
sub email1 { 
&UpdateIndicators2;
  if (!open(TMPFILE2,(">>MKC-tmp_xmlConversion.htm"))) {
    &mkPrintErreur("ERREUR : Impossible d\'ouvrir le fichier MKC-tmp_xmlConversion.htm\n");
    return;
}
  my $content = shift; 
  print TMPFILE2 '&lt;', trim($content->[1]), "&gt;</p>\n" ;
  close(TMPFILE2);
} 
#---------------------------------------------------------
sub email2 { 
&UpdateIndicators2;
  if (!open(TMPFILE2,(">>MKC-tmp_xmlConversion.pod"))) {
    &mkPrintErreur("ERREUR : Impossible d\'ouvrir le fichier MKC-tmp_xmlConversion.pod\n");
    return;
}
  my $content = shift; 
  print TMPFILE2 '<', trim($content->[1]), ">\n\n"; 
  close(TMPFILE2);
} 
#---------------------------------------------------------
sub email3 { 
&UpdateIndicators2;
  if (!open(TMPFILE2,(">>MKC-tmp_xmlConversion.txt"))) {
    &mkPrintErreur("ERREUR : Impossible d\'ouvrir le fichier MKC-tmp_xmlConversion.txt\n");
    return;
}
  my $content = shift; 
  print TMPFILE2 '<', trim($content->[1]), ">\n\n"; 
  close(TMPFILE2);
} 
#---------------------------------------------------------
sub see_also1 { 
&UpdateIndicators2;
  if (!open(TMPFILE2,(">>MKC-tmp_xmlConversion.htm"))) {
    &mkPrintErreur("ERREUR : Impossible d\'ouvrir le fichier MKC-tmp_xmlConversion.htm\n");
    return;
}
  print TMPFILE2 "<h1>SEE ALSO</h1>\n"; 
  close(TMPFILE2);
} 
#---------------------------------------------------------
sub see_also2 { 
&UpdateIndicators2;
  if (!open(TMPFILE2,(">>MKC-tmp_xmlConversion.pod"))) {
      &mkPrintErreur("ERREUR : Impossible d\'ouvrir le fichier MKC-tmp_xmlConversion.pod\n");
      return;
}
  print TMPFILE2 "=head1 SEE ALSO\n\n"; 
  close(TMPFILE2);
} 
#---------------------------------------------------------
sub see_also3 { 
&UpdateIndicators2;
  if (!open(TMPFILE2,(">>MKC-tmp_xmlConversion.txt"))) {
    &mkPrintErreur("ERREUR : Impossible d\'ouvrir le fichier MKC-tmp_xmlConversion.txt\n");
    return;
}
  print TMPFILE2 "SEE ALSO\n\n"; 
  close(TMPFILE2);
} 
#---------------------------------------------------------

sub trim { 
&UpdateIndicators2;
  local $_ = shift; 

  s/\n/ /g; 
  s/^\s+//; 
  s/\s+$//; 
  
  $_; 
}
#---------------------------------------------------------
sub eventXML {
&UpdateIndicators2;

    &loadSplashWindow;
    $leveleventXML = -1;  # Display item at this indent level

###
#  Create the new parser, set up the various handlers, and
#  parse the XML file.
###

    my $parser = new XML::Parser(ErrorContext => 2);
    eval { $parser->parsefile($winMain::nom_fic)};
    if ($@) {
	&mkPrintErreur("Caught Error : $@\n");
	&removeSplashWindow;
	return;
    }
    print "0\n";
    use XML::Parser;
    $parser->setHandlers(
			 Start => \&start_handlerEventXML,
			 Char  => \&char_handlerEventXML,
			 End   => \&end_handlerEventXML,
			 );
    
    $resulteventXML="";
    print "1\n";
    $parser->parsefile($winMain::nom_fic);
    mkPrintMsgInfo("$resulteventXML");
    &removeSplashWindow;
    
}
###
#  Character and tag event handlers
###

#---------------------------------------------------------------------------------------
sub start_handlerEventXML {
&UpdateIndicators2;
    my ($p, $element, %attrib) = @_;
    my $name;
    my $val;

    #  Increment our print level with the Start Tag

    $leveleventXML++;

    #  Display the element name and all the attributes

    $resulteventXML.= "   " x $leveleventXML;
    $resulteventXML.="$element ";
    
    while (($name, $val) = each %attrib) {
	 $resulteventXML.="A:$name=>$val ";
    }

    $resulteventXML.="\n";
}
#---------------------------------------------------------------------------------------
sub char_handlerEventXML {
&UpdateIndicators2;
    my ($p, $text) = @_;

    #  Only display non-whitespace text

    if ($text =~ /\S+/) {
	++$leveleventXML;

	$text =~ s/^\s+//;  #  Remove beginning whitespace

	$resulteventXML.= "   " x $leveleventXML;
	$resulteventXML.= "Text:[$text]\n";
	--$leveleventXML;
    }
}

#---------------------------------------------------------------------------------------
sub end_handlerEventXML {
&UpdateIndicators2;
    #  Decrement our print level

    $leveleventXML--;
}

#-----------------------------------------------
sub xmlViewver_2 {
&UpdateIndicators2;

    require Tk::HList;
    &loadSplashWindow;
    $statusXmlviewer2Value  = "Xml Viewer";
    create_ui();
    my $parser = new XML::Parser(Style => 'tree');
    eval { $parser->parsefile($winMain::nom_fic)};
    if ($@) {
	$statusXmlviewer2Value="Erreur XML sur le fichier";
	&mkPrintErreur("Caught Error : $@\n");
	&removeSplashWindow;
	$mainXmlviewer2->destroy(); 
	return;
    }
    else {
	@xmllistXmlviewer2 = $parser->parsefile($winMain::nom_fic);
    }
    
    fill_list(@xmllistXmlviewer2);
    @tagsXmlviewer2;
    %tag_countXmlviewer2;
    &removeSplashWindow;
}

#---------------------------------------------------------------------------------------
sub fill_list {
&UpdateIndicators2;
    my $xml = shift;
    my $tag;
    my $value;

    while (@$xml) {
	$tag   = shift @$xml;
	$value = shift @$xml;

	if ($tag) {
	    $tag_countXmlviewer2{$tag}++;
	    push @tagsXmlviewer2, $tag . "." . $tag_countXmlviewer2{$tag};

	    $listXmlviewer2->add(
		get_name(),
		-text       => $tag,
		-data       => shift @$value,
		-itemtype   => 'text',
	    );

	    fill_list($value);

	    pop @tagsXmlviewer2;
	} else {
	    my $text = $value =~ s/\s+/ /g;

	    $tag_countXmlviewer2{"_value_"}++;

	    $listXmlviewer2->add(
		get_name() . "|value." . $tag_countXmlviewer2{"_value_"},
		-text       => "Value: " . $value,
		-itemtype   => 'text',
	    );
	}
    }
}

#---------------------------------------------------------------------------------------
sub get_name {
&UpdateIndicators2;
    my $name = join '|', @tagsXmlviewer2;
    return $name;
}

#---------------------------------------------------------------------------------------
sub create_ui {
&UpdateIndicators2;
    $mainXmlviewer2 = $winMain::mw ->Toplevel();

    my $menu_bar = $mainXmlviewer2->Frame()->pack(-side => 'top');

    $listXmlviewer2 = $mainXmlviewer2->Scrolled(
	'HList',
	-drawbranch => 1,
	-separator  => '|',
	-indent     => 15,
	-height     => 20,
	-width      => 70,
    )->pack(
	-fill       => 'both',
	-expand     => 'y',
    );

    $statusXmlviewer2 = $mainXmlviewer2->Frame()->pack(-side => 'bottom');
    $statusXmlviewer2->Label(
	-text => 'Status:'
    )->pack(
	-side => 'left',
	-padx => 2,
    );
    $statusXmlviewer2->Label(
	-textvariable => \$statusXmlviewer2Value,
	-width  => 70,
	-relief => 'sunken',
    )->pack(
	-fill => 'x',
	-padx => 2,
	-pady => 2,
    );
}


#---- XMLVIEWVER
#---------------------------------------------------------------------------------------
sub xmlViewver {
&UpdateIndicators2;

    &loadSplashWindow;
    my $parser = new XML::Parser(Style => 'Debug');
    eval { $parser->parsefile($winMain::nom_fic)};
    if ($@) {
	&mkPrintErreur("Caught Error : $@\n");
	&removeSplashWindow;
	return;
    }
    my $loaded = 1;
    my $ok = 1;
    print "ok " . $ok++ . "\n";
    
    my $file = "$winMain::nom_fic";
    
    my $top = $winMain::mw->Toplevel;
    $top->title("XML Viewer");
    my $t2 = $top->Toplevel;
    $t2->withdraw;

    my $xmlwidget = $top->Scrolled("XMLViewer" ,
				   -scrollbars => "osoe")->pack;
    $xmlwidget->insertXML(-file => $file);
    $xmlwidget->XMLMenu;
    
    my $xml_string1 = $xmlwidget->DumpXML;
    if ($xml_string1 eq '') { print "not " } print "ok ". $ok++ . "\n";
    
    my $xmlwidget2 = $t2->XMLViewer->pack;
    if (!$xmlwidget2->isa('Tk::XMLViewer')) {print "not "} print "ok ".$ok++."\n";
    
    
    $xmlwidget2->destroy;
    
# test internals
    
    $xmlwidget->ShowHideRegion(1, -open => 0);
    $xmlwidget->ShowHideRegion(1, -open => 1);
    $xmlwidget->OpenCloseDepth(1, 0);
    $xmlwidget->OpenCloseDepth(1, 1);
    $xmlwidget->ShowToDepth(0);
    $xmlwidget->ShowToDepth(undef);
    
    if (!defined &Tk::XMLViewer::_convert_from_unicode) {
	print "not ";
    }
    print "ok " . $ok++ . "\n";
    
    my %info = %{ $xmlwidget->GetInfo };
    if ($info{Version} ne "1.0")         { print "not " } print "ok ". $ok++ ."\n";
    if ($info{Encoding} ne "ISO-8859-1") { print "not " } print "ok ". $ok++ ."\n";
    if ($info{Name} ne "ecollateral")    { print "not " } print "ok ". $ok++ ."\n";
    if ($info{Sysid} ne "test.dtd")      { print "not " } print "ok ". $ok++ ."\n";
    
# definitions for interactive use...
    
    $top->bind("<P>" => sub {
	require Config;
	my $perldir = $Config::Config{'scriptdir'};
	require "$perldir/ptksh";
    });
    
    $depth=10;
    $f=$top->Frame->pack;
    $f->Label(-text => "Depth",
	      #  -command => sub {
	      #      $xmlwidget->ShowToDepth($depth);
	      #  }
	      )->pack(-side => "left");
    $f->Scale(-variable => \$depth,
	      -from => 1,
	      -command => sub {
		  $xmlwidget->ShowToDepth($depth);
	      },
	      -to => 10,
	      -orient => 'horiz')->pack(-side => "left");
    
    my $okb = $f->Button(-text => "OK",
			 -command => sub { $t2->destroy; $top->destroy; })->pack(-side => "left");

    
    $okb->focus;
    $top->update;
#$top->waitVariable(\$not);
    &removeSplashWindow;
}

#--- FIN XMLVIEWVER

#---------------------------------------------------------------------------------------
sub parseDTD {
&UpdateIndicators2;
 
    if (!open(FIC,">MKC-tmp_parseDTD.txt")) {
	&mkPrintErreur("ERREUR : Impossible d\'ouvrir MKC-tmp_parseDTD.txt\n");
	return;
    }
    my @atts;
    my $parser = new DTD_Parse( Catalog => $catalog );
    $parser->parsefile($winMain::nom_fic);
    
    my $element = $parser->get_root;
    my $model = $parser->get_model( $element );
    my @children = $parser->get_children( $element );
    my @attributes = $parser->get_attributes( $element );
    
    foreach my $att ( @attributes ) {
	print FIC " Name:      $att->{name}\n";
	print FIC " Type:      $att->{type}\n";
	print FIC " Default:   $att->{default}\n";
	print FIC " Fixed" if $att->{fixed};
    }
    my $tmpfile="MKC-tmp_parseDTD.txt";
    my $msg="MKC-tmp_parseDTD.txt";
    &IncludedFileInWindow($tmpfile,$msg);
}

#---XML STAT

#---------------------------------------------------------------------------------------
sub bystruct {
&UpdateIndicators2;
    my $refa = $xmlStatElements{$a};
    my $refb = $xmlStatElements{$b};

    $refa->{MINLEV} <=> $refb->{MINLEV}
	or $refa->{SEEN} <=> $refb->{SEEN};
}  # End bystruct

#---------------------------------------------
sub xmlStat {
&UpdateIndicators2;

    %xmlStatElements = ();
    my $seen = 0;
    my $root;
    
    my $file = $winMain::nom_fic;
    
    $xml_subform =
	'      @<<<<<<<<<<<<<<<      @>>>>';
    die "Can't find file \"$file\""
	unless -f $file;
    
    my $parser = new XML::Parser(ErrorContext => 2);
    $parser->setHandlers(Start => \&start_handler1,
			 Char  => \&char_handler1);

    eval { $parser->parsefile($winMain::nom_fic)};
    if ($@) {
	&mkPrintErreur("Caught Error : $@\n");
	return;
	}

    &set_minlev($root, 0);

    my $el;

    if (!open(FIC,">MKC-tmp_xmlstat.txt")) {
	&mkPrintErreur("ERREUR : Impossible d\'ouvrir MKC-tmp_xmlstat.txt\n");
	return;
	}
    close(FIC);
    foreach $el (sort bystruct keys %xmlStatElements)
    {
	if (!open(FIC,">>MKC-tmp_xmlstat.txt")) {
	    &mkPrintErreur("ERREUR : Impossible d\'ouvrir MKC-tmp_xmlstat.txt\n");
	    return;
	}
	my $ref = $xmlStatElements{$el};
	print FIC "\n================\n$el: ", $ref->{COUNT}, "\n";
	print FIC "Had ", $ref->{CHARS}, " bytes of character data\n"
	    if $ref->{CHARS};
	print FIC "Always empty\n"
	    if $ref->{EMPTY};

	close(FIC);

	my $tmpfile="MKC-tmp_xmlstat.txt";
	&showtab('Parents', $ref->{PTAB}, 0,$tmpfile);
	&showtab('Children', $ref->{KTAB}, 1,$tmpfile);
	&showtab('Attributes', $ref->{ATAB}, 0,$tmpfile);
	
    }

    my $tmpfile="MKC-tmp_xmlstat.txt";
    my $msg="MKC-tmp_xmlstat.txt";
    &IncludedFileInWindow($tmpfile,$msg);
}

#---------------------------------------------
sub start_handler1 {
&UpdateIndicators2;
    my $p = shift;
    my $el = shift;

    my $elinf = $xmlStatElements{$el};

    if (not defined($elinf))
    {
	$xmlStatElements{$el} = $elinf = new Elinfo;
	$elinf->{SEEN} = $seen++;
    }

    $elinf->{COUNT}++;

    my $partab = $elinf->{PTAB};

    my $parent = $p->current_element;
    if (defined($parent))
    {
	$partab->{$parent}++;
	my $pinf = $xmlStatElements{$parent};

	# Increment our slot in parent's child table
	$pinf->{KTAB}->{$el}++;
	$pinf->{EMPTY} = 0;
    }
    else
    {
	$root = $el;
    }

    # Deal with attributes

    my $atab = $elinf->{ATAB};

    while (@_)
    {
	my $att = shift;
	
	$atab->{$att}++;
	shift;	# Throw away value
    }

}  # End start_handler

#---------------------------------------------
sub char_handler1 {
&UpdateIndicators2;
    my ($p, $data) = @_;
    my $inf = $xmlStatElements{$p->current_element};

    $inf->{EMPTY} = 0;
    if ($data =~ /\S/)
    {
	$inf->{CHARS} += length($data);
    }
}  # End char_handler

#---------------------------------------------
sub set_minlev {
&UpdateIndicators2;
    my ($el, $lev) = @_;

    my $elinfo = $xmlStatElements{$el};
    if (! defined($elinfo->{MINLEV}) or $elinfo->{MINLEV} > $lev)
    {
	my $newlev = $lev + 1;

	$elinfo->{MINLEV} = $lev;
	foreach (keys %{$elinfo->{KTAB}})
	{
	    set_minlev($_, $newlev);
	}
    }
}  # End set_minlev



#---------------------------------------------
sub showtab {
&UpdateIndicators2;
    my ($title, $table, $dosum,$tmpfile) = @_;

    my @list = sort keys %{$table};

	if (!open(FIC,">>$tmpfile")) {
	    &mkPrintErreur("ERREUR : Impossible d\'ouvrir MKC-tmp_xmlstat.txt\n");
	    return;
	}

    if (@list)
    {
	print FIC "\n   $title:\n";

	my $item;
	my $sum = 0;
	foreach $item (@list)
	{
	    my $cnt = $table->{$item};
	    $sum += $cnt;
	    formline($xml_subform, $item, $cnt);
	    print FIC $ACCUMULATOR, "\n";
	    $ACCUMULATOR = '';
	}

	if ($dosum and @list > 1)
	{
	    print FIC "                            =====\n";
	    formline($xml_subform, '', $sum);
	    print FIC $ACCUMULATOR, "\n";
	    $ACCUMULATOR = '';
	}
    }

    close(FIC);
}  # End showtab

#--- FIN XML STAT

#--- XML COMMENTS

#---------------------------------------------------------------------------------------
sub xmlComment {
&UpdateIndicators2;


    my $file = $winMain::nom_fic;
    die "Can't find file \"$file\""
	unless -f $file;
    
    $xml_countComments = 0;
    $xml_comments ="";
    my $parser = new XML::Parser(ErrorContext => 2);
    $parser->setHandlers(Comment => \&comments);
    eval { $parser->parsefile($winMain::nom_fic)};
    if ($@) {
	&mkPrintErreur("Caught Error : $@\n");
	return;
	}

    &mkPrintMsgInfo("Found $xml_countComments comments.\n"."$xml_comments");
    

}

#---------------------------------------------
sub comments {
&UpdateIndicators2;

    my ($p, $data) = @_;

    my $line = $p->current_line;
    $data =~ s/\n/\n\t/g;
    $xml_comments.="$line:\t<!--$data-->\n";
    $xml_countComments++;

}  # End comments


#---------------------------------------------
sub xmlMkListBalise {
&UpdateIndicators2;

    my $parser = new XML::Parser(Style=>'Subs', Pkg=>'SubHandlers', ErrorContext => 2);
    $parser->setHandlers(End => \&end_handler,
			 Start => \&start_handler);
    @liste_xmlBalise = ();
    %Liste_xmlBalise = ();


    

    eval { $parser->parsefile($winMain::nom_fic)};
    
    if ($@) {
	&mkPrintErreur("Caught Error : $@\n");
#	return;
	}

#    print "LISTE BALISE : @liste_xmlBalise\n";
    &mkSelectionXMLMarkup(@liste_xmlBalise);

}


#--- FIN XML COMMENT


#---------------------------------------------------------------------------------------
sub parseXML {
&UpdateIndicators2;

    &loadSplashWindow;
    my $parser = new XML::Parser(ErrorContext => 2);
    eval { $parser->parsefile($winMain::nom_fic)};
    if ($@) {
	$@=~s/at \/.*?$//s;
	&mkPrintErreur("Error in $winMain::nom_fic :\n $@\n");
	&removeSplashWindow;
	return;
    }
    else {
	&removeSplashWindow;
	&mkPrintMsgInfo("XML-Parsing OK sur $winMain::nom_fic\n");
    }
    
}

#-------------------------------------------------------
sub xml1 {
&UpdateIndicators2;

   my $parser = new XML::Parser(Style => 'Debug');
   eval { $parser->parsefile($winMain::nom_fic)};
   if ($@) {
       &mkPrintErreur("Caught Error : $@\n");
       return;
   }
   
}

#---------------------------------------------

sub xml2 {
&UpdateIndicators2;

   my $parser = new XML::Parser(Style => 'Debug');
   eval { $parser->parsefile($winMain::nom_fic)};
   if ($@) {
       &mkPrintErreur("Caught Error : $@\n");
       return;
   }
}
#---------------------------------------------
sub xml3 {
&UpdateIndicators2;

   my $parser = new XML::Parser(Style => 'Debug');
   eval { $parser->parsefile($winMain::nom_fic)};
   if ($@) {
       &mkPrintErreur("Caught Error : $@\n");
       return;
   }
}

#---------------------------------------------
sub extract_text_in_baliseXMLwithDOM1 {
&UpdateIndicators2;

    if (!open(FIC,">MKC-tmp_xmlExtractContentBaliseWithDOM.txt")) {
	&mkPrintErreur("ERREUR : Impossible d\'ouvrir MKC-tmp_xmlExtractContentBaliseWithDOM.txt\n");
	return;
    }
    @selectionParcourirDOM=();
    %selectionParcourirDOM=();
    my @selection = $listePnXMLBaliseWithDOM1->curselection();
    foreach $ind (@selection) {
	 $selectionParcourirDOM{$listePnXMLBaliseWithDOM1->get($ind)}="OK";
    }
   
    print FIC "<OUTPUT>\n";
    my $xp=new XML::DOM::Parser;
    my $doc;
    eval { $doc=$xp->parsefile($winMain::nom_fic)};
    if ($@) {
	&mkPrintErreur("Caught Error : $@\n");
	return;
    }   
    &parcourirWithDOM1($doc);
    foreach my $child (@selectionParcourirDOM) {
	print FIC "<",$child->getNodeName,">";
	print FIC &parcourirWithDOM2($child);
	print FIC "</",$child->getNodeName,">\n";
    }
    print FIC "</OUTPUT>\n";
    close(FIC);
    my $tmpfile="MKC-tmp_xmlExtractContentBaliseWithDOM.txt";
    my $msg="MKC-tmp_xmlExtractContentBaliseWithDOM.txt";
    &IncludedFileInWindow($tmpfile,$msg);
}

#---------------------------------------------------------------------------------------
sub parcourirWithDOM1 {
&UpdateIndicators2;
    my ($node)=@_;
    my $retVal='';
    foreach my $child ($node->getChildNodes) {
	if ($child->getNodeType==ELEMENT_NODE) {
	    my $name=$child->getNodeName;
	    if (exists ($selectionParcourirDOM{$name})) {
		push(@selectionParcourirDOM,$child);
	    }
	    my $val= &parcourirWithDOM1($child);
	} elsif ($child->getNodeType==TEXT_NODE) {
	    my $name=$child->getNodeName;
	}
    }
}

#---------------------------------------------------------------------------------------
sub parcourirWithDOM2 {
&UpdateIndicators2;
    my ($node)=@_;
    my $retVal='';
    foreach my $child ($node->getChildNodes) {
	if ($child->getNodeType==ELEMENT_NODE) {
	    my $name=$child->getNodeName;
	    my $val= &parcourirWithDOM2($child);
	} elsif ($child->getNodeType==TEXT_NODE) {
		return $child->getData();
	}
    }
}

#---------------------------------------------
sub delete_selected_baliseXMLwithDOM1 {
&UpdateIndicators2;

    &mkIndisponible();

}

#---------------------------------------------
sub modify_selected_baliseXMLwithDOM1 {
&UpdateIndicators2;

    &mkIndisponible();

}

#---------------------------------------------
sub extract_text_in_baliseXMLForLexicowithDOM1 {
&UpdateIndicators2;

    if (!open(FIC,">MKC-tmp_xmlExtractContentBaliseWithDOM.txt")) {
	&mkPrintErreur("ERREUR : Impossible d\'ouvrir MKC-tmp_xmlExtractContentBaliseWithDOM.txt\n");
	return;
    }
    @selectionParcourirDOM=();
    %selectionParcourirDOM=();
    my @selection = $listePnXMLBaliseWithDOM1->curselection();
    foreach $ind (@selection) {
	 $selectionParcourirDOM{$listePnXMLBaliseWithDOM1->get($ind)}=$ind;
    }
   
    my $xp=new XML::DOM::Parser;
    my $doc;
    eval { $doc=$xp->parsefile($winMain::nom_fic)};
    if ($@) {
	&mkPrintErreur("Caught Error : $@\n");
	return;
    }   
     parcourirForLexicoWithDOM1($doc);
    my $ind=0;
    foreach my $child (@selectionParcourirDOM) {
	print FIC "\n<",$child->getNodeName,">\n";
	print FIC parcourirForLexicoWithDOM2($child);
    }
    close(FIC);
    my $tmpfile="MKC-tmp_xmlExtractContentBaliseWithDOM.txt";
    my $msg="MKC-tmp_xmlExtractContentBaliseWithDOM.txt";
    &IncludedFileInWindow($tmpfile,$msg);
}

#---------------------------------------------------------------------------------------
sub parcourirForLexicoWithDOM1 {
&UpdateIndicators2;
    my ($node)=@_;
    my $retVal='';
    foreach my $child ($node->getChildNodes) {
	if ($child->getNodeType==ELEMENT_NODE) {
	    my $name=$child->getNodeName;
	    if (exists ($selectionParcourirDOM{$name})) {
		push(@selectionParcourirDOM,$child);
	    }
	    my $val= parcourirForLexicoWithDOM1($child);
	} elsif ($child->getNodeType==TEXT_NODE) {
	    my $name=$child->getNodeName;
	}
    }
}

#---------------------------------------------------------------------------------------
sub parcourirForLexicoWithDOM2 {
&UpdateIndicators2;
    my ($node)=@_;
    my $retVal='';
    foreach my $child ($node->getChildNodes) {
	if ($child->getNodeType==ELEMENT_NODE) {
	    my $name=$child->getNodeName;
	    my $val= parcourirForLexicoWithDOM2($child);
	} elsif ($child->getNodeType==TEXT_NODE) {
		return $child->getData();
	}
    }
}

#---------------------------------------------
sub delete_selected_baliseXMLForLexicowithDOM1 {
&UpdateIndicators2;

    &mkIndisponible();

}

#---------------------------------------------
sub modify_selected_baliseXMLForLexicowithDOM1 {
&UpdateIndicators2;

    &mkIndisponible();

}

#---------------------------------------------
sub extract_text_in_baliseXMLwithDOM {
&UpdateIndicators2;

    if (!open(FIC,">MKC-tmp_xmlExtractContentBaliseWithDOM.txt")) {
	&mkPrintErreur("ERREUR : Impossible d\'ouvrir MKC-tmp_xmlExtractContentBaliseWithDOM.txt\n");
	return;
    }
    my @selection = $listePnXMLBaliseWithDOM->curselection();
    print FIC "<OUTPUT>\n";
    my $id=0;
    foreach $ind (@selection) {
	$id++;
	my $tag=$listePnXMLBaliseWithDOM->get($ind);
	print FIC "<tag nb=\"$id\" type=\"$tag\">\n";
	my $p = XML::DOM::Parser->new; 
	my $doc;
	eval { $doc=$p->parsefile($winMain::nom_fic)};
	if ($@) {
	    &mkPrintErreur("Caught Error : $@\n");
	    return;
	}   
	my $elements=$doc->getElementsByTagName($tag);
	for my $i (0..$elements->getLength-1) {
	    my $evElement=$elements->item($i);
	    my $children=$evElement->getChildNodes;
	    for my $j (0..$children->getLength-1) {
		my $p=$children->item($j);
		my $t=$p->getNodeType;
		if ($t == TEXT_NODE) {
		    my $data=$p->getData;
		    print FIC "<",$tag,">",$data,"</",$tag,">\n";
		}
	    }
	}
	print FIC "</tag>\n";
    }
    print FIC "</OUTPUT>\n";
    close(FIC);
    my $tmpfile="MKC-tmp_xmlExtractContentBaliseWithDOM.txt";
    my $msg="MKC-tmp_xmlExtractContentBaliseWithDOM.txt";
    &IncludedFileInWindow($tmpfile,$msg);
}
#---------------------------------------------
sub delete_selected_baliseXMLwithDOM {
&UpdateIndicators2;

    &mkIndisponible();

}

#---------------------------------------------
sub modify_selected_baliseXMLwithDOM {
&UpdateIndicators2;

    &mkIndisponible();

}

#---------------------------------------------
sub extract_text_in_baliseXML {
&UpdateIndicators2;

    my @selection = $listePnXMLBalise->curselection();
    %listeBaliseXml = ();
    %compteurBaliseXml = ();
    my $parser = new XML::Parser(ErrorContext => 2);
    $parser->setHandlers(Start => \&start_handler2,
			 Char  => \&char_handler2,
			 Element => \&extracElementXML
			 );

    eval { $parser->parsefile($winMain::nom_fic)};
    if ($@) {
	&mkPrintErreur("Caught Error : $@\n");
	return;
	}

    if (!open(FIC,">MKC-tmp_xmlExtractContentBalise.txt")) {
	&mkPrintErreur("ERREUR : Impossible d\'ouvrir MKC-tmp_xmlExtractContentBalise.txt\n");
	return;
    }

    foreach $ind (@selection) {
	my $element=$listePnXMLBalise->get($ind);
	if (exists ($listeBaliseXml{$element})) {
	    print FIC "$listeBaliseXml{$element}";

	}
    }
    close(FIC);
    my $tmpfile="MKC-tmp_xmlExtractContentBalise.txt";
    my $msg="MKC-tmp_xmlExtractContentBalise.txt";
    &IncludedFileInWindow($tmpfile,$msg);
}
#---------------------------------------------
sub delete_selected_baliseXML {
&UpdateIndicators2;

    &mkIndisponible();

}

#---------------------------------------------
sub modify_selected_baliseXML {
&UpdateIndicators2;

    &mkIndisponible();

}


#---------------------------------------------
sub delete_selected_baliseXMLLexico2 {
&UpdateIndicators2;

    &mkIndisponible();

}

#---------------------------------------------
sub modify_selected_baliseXMLLexico2 {
&UpdateIndicators2;

    &mkIndisponible();

}

#---------------------------------------------
sub extract_text_in_baliseXMLLexico2 {
&UpdateIndicators2;


    my %listeCompteur=();
    my $balise_d="\(";
    my $balise_f="\(";
    my @selection = $listePnXMLLexico2Balise->curselection();

    foreach $ind (@selection) {
	$element=$listePnXMLLexico2Balise->get($ind);
	$listeCompteur{$element}=0;
	$balise_d.="(<$element>)|";
	$balise_f.="(<\/$element>)|";
    }
    chop($balise_d);
    chop($balise_f);
    $balise_d.="\)";
    $balise_f.="\)";
    print $balise_d,"\n";
    print $balise_f,"\n";

    if (!open(TMPFILE,"$winMain::nom_fic")) {
	&mkPrintErreur("ERREUR : Impossible d\'ouvrir '$winMain::nom_fic'\n");
	return;
    }
    if (!open(TMPFILE2,">MKC-tmp_extractSelectedMarkupForLexico.txt")) {
    &mkPrintErreur("ERREUR : Impossible d\'ouvrir MKC-tmp_extractSelectedMarkupForLexico.txt\n");
    return;
	}

    while ($ligne = <TMPFILE>) { 
		if ($ligne =~ /($balise_d)(.*)($balise_f)/i)
			{ 
			    $balise_name=$1;
			    $balise_name=~s/[\<\>]//g;
			    $ligne =~ /<$balise_name>(.*)<\/$balise_name>/;
			    my $tmp=$1;
			    print $tmp,"\n";
			    print $balise_name,"\n";
			    print TMPFILE2 "<$balise_name=NUM".$listeCompteur{$balise_name}++.">\n";
			    print TMPFILE2 "$tmp\n";

		    }
		if (($ligne=~/($balise_d)(.*)/i) && ($ligne!~/$balise_f/i)){

		    $balise_name=$1;
		    $balise_name=~s/[\<\>]//g;
		    print $balise_name,"\n";
		    $ligne=~/<$balise_name>(.*)/;
		    my $tmp=$1;
		    print TMPFILE2 "<$balise_name=NUM".$listeCompteur{$balise_name}++.">\n";
		    print TMPFILE2 "$tmp";
		    $ligne=<TMPFILE>;
		    until ($ligne=~/<\/$balise_name>/i){
			print TMPFILE2 "$ligne";
			$ligne=<TMPFILE>;
#			break if $ligne == EOF;
		    }
		    $ligne=~/(.*)<\/$balise_name>/;
		    print TMPFILE2 "$1";
		    }
	    }
    print TMPFILE2 "\n";

    close (TMPFILE);
    close (TMPFILE2);

    my $tmpfile="MKC-tmp_extractSelectedMarkupForLexico.txt";
    my $msg="MKC-tmp_extractSelectedMarkupForLexico.txt";
    &IncludedFileInWindow($tmpfile,$msg);
     

}
#---------------------------------------------
sub delete_selected_baliseXMLLexico {
&UpdateIndicators2;

    &mkIndisponible();

}

#---------------------------------------------
sub modify_selected_baliseXMLLexico {
&UpdateIndicators2;

    &mkIndisponible();

}

#---------------------------------------------
sub extract_text_in_baliseXMLLexico {
&UpdateIndicators2;

    my @selection = $listePnXMLLexicoBalise->curselection();


    %listeBaliseXmlLexico = ();
    %compteurBaliseXmlLexico = ();
    my $parser = new XML::Parser(ErrorContext => 2);
    $parser->setHandlers(Start => \&start_handler3,
			 Char  => \&char_handler3,
			 Element => \&extracElementXML
			 );

    eval { $parser->parsefile($winMain::nom_fic)};
    if ($@) {
	&mkPrintErreur("Caught Error : $@\n");
	return;
	}

    if (!open(FIC,">MKC-tmp_xmlExtractContentBalise.txt")) {
	&mkPrintErreur("ERREUR : Impossible d\'ouvrir MKC-tmp_xmlExtractContentBalise.txt\n");
	return;
    }

    foreach $ind (@selection) {
	my $element=$listePnXMLLexicoBalise->get($ind);
	if (exists ($listeBaliseXmlLexico{$element})) {
	    print FIC "$listeBaliseXmlLexico{$element}";

	}
    }
    close(FIC);
    my $tmpfile="MKC-tmp_xmlExtractContentBalise.txt";
    my $msg="MKC-tmp_xmlExtractContentBalise.txt";
    &IncludedFileInWindow($tmpfile,$msg);

}
	

#---------------------------------------------
sub start_handler2 {
&UpdateIndicators2;
    my $p = shift;
    my $el = shift;
    $compteurBaliseXml{$el}++;
    $listeBaliseXml{$el}.="\n<".$el."=NUM".$compteurBaliseXml{$el}.">\n";

}

#---------------------------------------------
sub char_handler2 {
&UpdateIndicators2;
    my $p = shift;
    my $data = shift;
#    $listeBaliseXml{$p->current_element}.="\n<".$p->current_element."=NUM".$compteurBaliseXml{$p->current_element}.">\n";
    $listeBaliseXml{$p->current_element}.=$data;
}

#---------------------------------------------
sub start_handler3 {
&UpdateIndicators2;
    my $p = shift;
    my $el = shift;
    $compteurBaliseXmlLexico{$el}++;
    $listeBaliseXmlLexico{$el}.="\n<".$el."=NUM".$compteurBaliseXmlLexico{$el}.">\n";

}

#---------------------------------------------
sub char_handler3 {
&UpdateIndicators2;
    my $p = shift;
    my $data = shift;
#    $listeBaliseXmlLexico{$p->current_element}.="\n<".$p->current_element."=NUM".$compteurBaliseXmlLexico{$p->current_element}.">\n";
    $listeBaliseXmlLexico{$p->current_element}.=$data;
}

#---------------------------------------------
sub extracElementXML {
&UpdateIndicators2;

}


#---------------------------------------------
sub xmlGroveTool1 {
&UpdateIndicators2;
        
   
    &loadSplashWindow;
    my $doc = $winMain::nom_fic;
    my $parser = XML::Parser->new(Style => 'grove');
    my $grove=$parser->parsefile($doc);

    if (!open(FIC,">MKC-tmp_xmlGrove.txt")) {
	&mkPrintErreur("ERREUR : Impossible d\'ouvrir MKC-tmp_xmlGrove.txt\n");
	return;
    }

    &dump_grove ($grove->iter);

    my $tmpfile="MKC-tmp_xmlGrove.txt";
    my $msg="MKC-tmp_xmlGrove.txt";
    &IncludedFileInWindow($tmpfile,$msg);
    &removeSplashWindow;
}

#---------------------------------------------
sub dump_grove {
&UpdateIndicators2;
    my $element = shift;
    my $item;

    if (!open(FIC,">>MKC-tmp_xmlGrove.txt")) {
	&mkPrintErreur("ERREUR : Impossible d\'ouvrir MKC-tmp_xmlGrove.txt\n");
	return;
    }

    # get the names of each element in our path to the root
    my @context = $element->rootpath;
    # remove Grove object, which has no name
    shift @context;
    foreach $item (@context) {
	$item = $item->name;
    }

    # note an idea in Iter.pm to use a tied-array for the return value
    # of `$item->contents' so one could use this here:
    #
    #     foreach $item ($element->contents) {
    #     }

    $item = $element->first_child;
    while ($item) {
	if (ref ($item) =~ /::Element/) {
	    my @attributes = %{$item->attributes};
	    print FIC "@context \\\\ (@attributes)\n";
	    dump_grove ($item);
	    print FIC "@context //\n";
	} elsif (ref ($item) =~ /::PI/) {
	    my $target = $item->target;
	    my $data = $item->data;
	    print FIC "@context ?? $target($data)\n";
	} elsif (ref ($item) =~ /::Scalar/) {
	    my $text = $item->delegate;
	    $text =~ s/([\x80-\xff])/sprintf "#x%X;", ord $1/eg;
	    $text =~ s/([\t\n])/sprintf "#%d;", ord $1/eg;
	    print FIC "@context || $text\n";
	} else {
	    print FIC "@context !! OTHER: $item\n";
	}

	$item = $item->next;
    }

    close(FIC);

}



#----------------------------- MODULE PDF ----------------------------------

sub pdf2xml {
    &UpdateIndicators2;

    use mkCorpusModules::pdf2xml;
    my $file="$winMain::nom_fic";
    my $xml_record_ref = &pdf2xml( \$file );
    if (!open(TMP,(">MKC-tmp_pdf2xml.xml"))) {
	&mkPrintErreur("ERREUR : Impossible d\'ouvrir le fichier MKC-tmp_pdf2xml.xml\n");
	return;
    }
    print TMP $xml_record_ref;
    close(TMP);
    my $tmpfile="MKC-tmp_pdf2xml.xml";
    my $msg="MKC-tmp_pdf2xml.xml";
    &IncludedFileInWindow($tmpfile,$msg);
    
}
#---------------------------------------------
sub pdf2html {
    &UpdateIndicators2;
    use mkCorpusModules::pdf2html;
    my $file="$winMain::nom_fic";
    my $xml_record_ref = &pdf2html( \$file );
    if (!open(TMP,(">MKC-tmp_pdf2html.html"))) {
	&mkPrintErreur("ERREUR : Impossible d\'ouvrir le fichier MKC-tmp_pdf2html.html\n");
	return;
    }
    print TMP $xml_record_ref;
    close(TMP);
    my $tmpfile="MKC-tmp_pdf2html.html";
    my $msg="MKC-tmp_pdf2html.html";
    &IncludedFileInWindow($tmpfile,$msg);

    use Win32::OLE;
    my $file = Win32::GetCwd() . "MKC-tmp_pdf2html.html";
    print $file,"\n";
    my $msie;
    eval {my $msie = Win32::OLE->GetActiveObject('InternetExplorer.Application')};
    if ($@) {
	     &mkPrintErreur("InternetExplorer unavailable" );
    }
    unless (defined $msie) {
	print "Dmarrage de IE \n";
	$msie = Win32::OLE->new('InternetExplorer.Application');
	if ($@) {
	    &mkPrintErreur("ERREUR : Oops, cannot start IE" );
	}
	$msie->{'Visible'}=1;
	$msie->Navigate($file);
    }  
}

#----------------------------- MODULE TRANSCODEURS ----------------------------------

sub rtf2html {
&UpdateIndicators2;

    &mkIndisponible();
}

#---------------------------------------------
sub txt2html {
&UpdateIndicators2;

    &mkIndisponible();
}
#---------------------------------------------
sub perl2html {
&UpdateIndicators2;

    &mkIndisponible();
}
#---------------------------------------------
sub ps2html {
&UpdateIndicators2;

    &mkIndisponible();
}

#----------------------------- MODULE TOOLS CORPUS ----------------------------------


sub mkPrepHtml2txtOneDir {
&UpdateIndicators2;

# program: txtprep - prepares texts in html pages taken from the internet
# for use by linguistics programs such as concordancers or parsers
#
# reads each file in a directory,
# and for each file,
# strips out the html tags,
# rewrites the file as one sentence per line, 
# numbers each line with the line number and text id, 
# creates a special line zero to put a heading describing the text,
# writes the file out with a new file name
# equal to the old file name with the prefix "corp".
# Then you can
# manually write the text description in the heading.
# (Note: If you run this file multiple times on the files in a
# directory it will skip over the files you previously created 
# prefixed with "corp".)

$Data::Dumper::Indent = 0;        
my ($dirname,$dirnameOut,$txtnum, $fullTxtName,$init) = @_;
$dirname =~ s/\/$//;
$dirnameOut =~ s/\/$//;
$dirname =~ s/\\$//;
$dirnameOut =~ s/\\$//;
print "ROOT : $dirname\n";
#return;
#iterate over the files in the directory processing each file 

if (!opendir(DIR,("$dirname"))) {
    &mkPrintErreur("ERREUR : Impossible d\'ouvrir le rpertoire $dirname\n");
    return;
    }
@files = readdir(DIR);
closedir(DIR);


if ($init eq 0) {
    my $fullTxt = "$dirnameOut"."\/"."$fullTxtName";
    if (!open(TMP,(">$fullTxt"))) {
	&mkPrintErreur("ERREUR : Impossible d\'ouvrir le fichier $fullTxt\n");
	return;
    }
    close(TMP);
}

foreach $infile (@files) {
       next if $infile =~ /^\.\.?$/;
       $file = "$dirname"."\/"."$infile";
       print "FILETOREAD : $file\n";
       if (-f "$file") { 
#	   print "FILE : $dirname$infile\n";
	   preptxt($infile,$dirname,$dirnameOut,$txtnum,$fullTxtName);
	   print "processing: $infile  text_number: $txtnum\n"; 
	   $txtnum++;
       }
       if (-d $file) {
	   my $newdir="$dirname"."\/". "$infile";
#	   print "FILEDIR : $newdir\n";
	   mkPrepHtml2txtOneDir($newdir, $dirnameOut, $txtnum,$fullTxtName,1);	
       }
   }
FINIS: print "\nEnd of Program\n";

if ($init eq 0) {
    my $tmpfile="$dirnameOut"."\/"."$fullTxtName";
    my $msg="$dirnameOut"."\/"."$fullTxtName";
    &IncludedFileInWindow($tmpfile,$msg);
}
}

#---------------------------------------------------------
# prepare the text in a given file
sub preptxt {
&UpdateIndicators2;
    my($infile,$indir,$dirnameOut,$txtnum,$fullTxt) = @_;

    my $filename = "$indir\/$infile";
    print "FILETOPREP : $filename \n";
    if (!open(INFILE,("$filename"))) {
	&mkPrintErreur("ERREUR : Impossible d\'ouvrir le fichier '$filename'\n");
	return;
    }
    my $tmpOutfileFull="$dirnameOut"."\/"."$fullTxt";
    if (!open(OUTFILE2,(">>$tmpOutfileFull"))) {
	&mkPrintErreur("ERREUR : Impossible d\'ouvrir le fichier '$tmpOutfileFull'\n");
	return;
    }

    my @text = <INFILE>;             # read the whole file into a list
    my $text = join('', @text);    # create a string with the whole file in it
    $text =~ s/<.*?>//gs;       # strip out html tags
    $text =~ s/\s+/ /g;         # substitute spaces for carriage returns 
    
    my @sentences = ($text =~ m/(\S.*?[!?.])(?=\s)/g);  # extract sentences into an array
    
    $tmplinepreptxt = 0;
    my @sentences2 = map($_ = &lineid($_,$txtnum), @sentences);
    unshift(@sentences2,"<$txtnum:0>   ");
    
    my $outfile    = "corp-" . $infile.".prep";
    my $openstring = "$dirnameOut"."\/"."$outfile";

    if (!open(OUTFILE, ">$openstring")) {
	&mkPrintErreur("ERREUR : Impossible d\'ouvrir '$dirnameOut$outfile'\n");
	return;
    }
    print "FILE writing : $openstring\n";
    print OUTFILE2 "<FILE=$filename>\n";
    foreach $sent (@sentences2) {     
	my $translateSent=&translate($sent);
	print OUTFILE "$translateSent\n";
	print OUTFILE2 "$translateSent\n";
    }
    print OUTFILE2 "</FILE>\n";
    close(OUTFILE);
    close(OUTFILE2);
}

#---------------------------------------------------------
# prefix a text id and a line number
sub lineid {
&UpdateIndicators2;
   my($tmp,$txtnum) = @_;
   $tmplinepreptxt++;
   $tmp = "<$txtnum:$tmplinepreptxt>  " . $_[0];
   return $tmp;
}

#---------------------------------------------------------
sub mkPrepHtml2txtOneFile {
&UpdateIndicators2;


$Data::Dumper::Indent = 0;        
$txtnum = 1;
&preptxt2($winMain::nom_fic,$txtnum);
FINIS: print "\nEnd of Program\n";
}

#---------------------------------------------------------
sub preptxt2 {
&UpdateIndicators2;
    my($infile,$txtnum) = @_;
    if (!open(INFILE,("$infile"))) {
	&mkPrintErreur("ERREUR : Impossible d\'ouvrir le fichier '$infile'\n");
	return;
    }
    my @text = <INFILE>;             # read the whole file into a list
    my $text = join('', @text);    # create a string with the whole file in it
    $text =~ s/<.*?>//gs;       # strip out html tags
    $text =~ s/\s+/ /g;         # substitute spaces for carriage returns 
    
    my @sentences = ($text =~ m/(\S.*?[!?.])(?=\s)/g);  # extract sentences into an array
    
    my $tmplinepreptxt = 0;
    my @sentences2 = map($_ = &lineid($_,$txtnum), @sentences);
    unshift(@sentences2,"<$txtnum:0>   ");
    
    $outfile    = $infile.".prep";
    $openstring = $outfile;

    if (!open(OUTFILE, ">$openstring")) {
	&mkPrintErreur("ERREUR : Impossible d\'ouvrir '$outfile'\n");
	return;
    }

    print "writing: $openstring\n";
    foreach $sent (@sentences2) {     
	my $translateSent=&translate($sent);
	print OUTFILE "$translateSent\n";
    }
    close(OUTFILE);
    my $tmpfile=$infile.".prep" ;
    my $msg=$infile.".prep" ;
    &IncludedFileInWindow($tmpfile,$msg);
}

#---------------------------------------------------------
sub read_text_forStat { 
&UpdateIndicators2;
  my @file; 
  if (!open(TMPFILE1,("$winMain::nom_fic"))) {
	&mkPrintErreur("ERREUR : Impossible d\'ouvrir le fichier '$winMain::nom_fic'\n");
	return;
    }
  push @file, [split] while <TMPFILE1>; 
  close(TMPFILE1);
#  print @file,"\n";
#  return \@file;
  \@file;
}
#---------------------------------------------------------
sub statFile {
&UpdateIndicators2;
    if (!open(TMPFILE,(">MKC-tmp_statFile.txt"))) {
	&mkPrintErreur("ERREUR : Impossible d\'ouvrir le fichier MKC-tmp_statFile.txt\n");
	return;
    }
# Variables to keep track of where we are in the file 
    my ($line, $word, $total_length);
# Variables to store stats 
    my ($num_lines, $num_words); 
    my (%words, %lengths);
    my $text = &read_text_forStat();
    $num_lines = scalar @{$text}; 
    foreach $line (@{$text}) { 
	$num_words += scalar @{$line};
	foreach $word (@{$line}) {
	    $words{$word}++;
	    $lengths{length $word}++; 
	    $total_length += length $word; 
	}
    } 

    my @sorted_words = sort { $words{$b} <=> $words{$a} } keys %words;
    my @sorted_lengths = sort { $lengths{$b} <=> $lengths{$a} } keys %lengths;
    print TMPFILE "Your file contains $num_lines lines "; 
    print TMPFILE "and $num_words words\n\n"; 
    printf TMPFILE "The average word length is %.2f\n\n", $total_length / $num_words;
    print TMPFILE "The 10 most popular words were:\n";
    print TMPFILE map { "$_ ($words{$_} times)\n" } @sorted_words[0 .. 10]; 
    print TMPFILE "\nThe 10 most popular word lengths were:\n"; 
    print TMPFILE map { "$_ ($lengths{$_} words)\n" } @sorted_lengths[0 .. 10];
    close (TMPFILE);
    my $tmpfile="MKC-tmp_statFile.txt" ;
    my $msg="MKC-tmp_statFile.txt" ;
    &IncludedFileInWindow($tmpfile,$msg);
}

#---------------------------------------------------------
sub concatFile2lexico {
    &UpdateIndicators2;
    $mainconcatFile = $winMain::mw ->Toplevel(-title=>'Concatnation de fichier :');
    
    my $frame1 = $mainconcatFile->Frame()->pack();
    my $frameG1 = $frame1->Frame()->pack(-side=>'top', -pady=>5);
    my $frameD1 = $frame1->Frame()->pack(-side=>'bottom', -pady=>5);
    my $frameG2 = $frameG1->Frame()->pack(-side=>'left', -pady=>5);
    my $frameD2 = $frameG1->Frame()->pack(-side=>'right', -pady=>5);    
    my $frameG3 = $frameD1->Frame()->pack(-side=>'left', -pady=>5);
    my $frameD3 = $frameD1->Frame()->pack(-side=>'right', -pady=>5);
    my $frame2 = $mainconcatFile->Frame()->pack();
    my $frame3 = $mainconcatFile->Frame()->pack();
    my $libelF = $frameG2->Label(-text=>'Chemin du rpertoire (input) :')->pack(-padx=>5);
    my $defil = $frameD2-> Scrollbar(-orient => "horizontal");
    $montantF = $frameD2->Entry(-highlightcolor => "blue", -xscrollcommand => ['set' => $defil] )
	->pack(		-fill => 'x',
			-expand => 1);
    $defil->pack(-fill => 'x',
		 -expand => 1);
    $defil->configure(-command => [$montantF => 'xview']);    
    my $libelE = $frameG3->Label(-text=>'Chemin du rpertoire (output) :')->pack(-padx=>5);    
    my $defil2 = $frameD3-> Scrollbar(-orient => "horizontal");
    $montantE = $frameD3->Entry(-highlightcolor => "red", -xscrollcommand => ['set' => $defil2] )
	->pack(		-fill => 'x',
			-expand => 1);
    $defil2->pack(-fill => 'x',
		  -expand => 1);
    $defil2->configure(-command => [$montantE => 'xview']);    
    my $raz = $frame2->Button(-text=>'RAZ', -command=>\&viderMontant)->pack(-side=>'left', -padx=>20, -pady=>5);
    my $calcul = $frame2->Button(-text=>'Concatnation', -command=>\&loadconcat)->pack(-side=>'right', -padx=>20, -pady=>5);
    my $fin = $frame3->Button(-text=>'Exit', -command=>sub {$mainconcatFile->destroy()})->pack(-pady=>5);    
    sub loadconcat {
	&UpdateIndicators2;	
	my $chemin=$montantF->get();
	my $cheminout=$montantE->get();
	if ($chemin ne "") {
	    if ($chemin !~ /[\/\\]$/) { $chemin.="/"};
	    if (!opendir(DIR, $chemin)) {
		&mkPrintErreur("ERREUR : can't open $chemin: $!\n");
		return;
	    }  
	    if ($cheminout eq "") {
		$cheminout = $chemin."result-concatenation.txt";
	    }
	    else {
		if (!opendir(DIR2, $cheminout)) {
		    &mkPrintErreur("ERREUR : can't open $cheminout: $!\n");
		    return;
		} 
		if ($cheminout !~ /[\/\\]$/) { $cheminout.="/"};
		$cheminout = $cheminout."result-concatenation.txt";
	    }
	    my @files = readdir(DIR);
	    closedir(DIR);	    
	    if (!open(TRACE, ">>$cheminout")) {
		    &mkPrintErreur("ERREUR : Impossible d\'ouvrir le fichier en sortie $cheminout  \n");
		    return;
		}	
	    my $filecount = 0;
	    foreach my $file (@files) {
		my $filecount++;
		next if $file =~ /^\.\.?$/;
		$file = $chemin.$file;
		print "I => ",$file,"\n";
		if (-f $file) {
		        if (!open(FILE, $file)) {
			    &mkPrintErreur("ERREUR : Impossible d\'ouvrir le fichier en lecture : $file \n");
			    return;
			}	
			print TRACE "\n<FICHIER=\"$file\">\n";
			while (<FILE>) {
			    print TRACE $_;
			}
			close (FILE);
		    }
	    }
	    close (TRACE);
	    &mkPrintMsgInfo("Concatnation termine dans : $cheminout \n");
	}
	else
	{
	&mkPrintErreur("ERREUR : impossible d\'accder au rpertoire $chemin\n");
	return;
	}
    }

}
#---------------------------------------------------------
sub viderMontant {
    &UpdateIndicators2;
    if (Exists($montantF)) {$montantF->delete(0, 'end')};
    if (Exists($montantE)) {$montantE->delete(0, 'end')};
    if (Exists($montantG)) {$montantG->delete(0, 'end')};
}
#---------------------------------------------------------
sub concatFile2xml {
    &UpdateIndicators2;
    $mainconcatFile = $winMain::mw ->Toplevel(-title=>'Concatnation de fichier :');    
    my $frame1 = $mainconcatFile->Frame()->pack();
    my $frameG1 = $frame1->Frame()->pack(-side=>'top', -pady=>5);
    my $frameD1 = $frame1->Frame()->pack(-side=>'bottom', -pady=>5);
    my $frameG2 = $frameG1->Frame()->pack(-side=>'left', -pady=>5);
    my $frameD2 = $frameG1->Frame()->pack(-side=>'right', -pady=>5);
    
    my $frameG3 = $frameD1->Frame()->pack(-side=>'left', -pady=>5);
    my $frameD3 = $frameD1->Frame()->pack(-side=>'right', -pady=>5);
    
    my $frame2 = $mainconcatFile->Frame()->pack();
    my $frame3 = $mainconcatFile->Frame()->pack();
    
    my $libelF = $frameG2->Label(-text=>'Chemin du rpertoire (input) :')->pack(-padx=>5);
    
    my $defil = $frameD2-> Scrollbar(-orient => "horizontal");
    $montantF = $frameD2->Entry(-highlightcolor => "blue", -xscrollcommand => ['set' => $defil] )
	->pack(		-fill => 'x',
			-expand => 1);
    $defil->pack(-fill => 'x',
		 -expand => 1);
    $defil->configure(-command => [$montantF => 'xview']);
    
    my $libelE = $frameG3->Label(-text=>'Chemin du rpertoire (output) :')->pack(-padx=>5);
    
    my $defil2 = $frameD3-> Scrollbar(-orient => "horizontal");
    
    $montantE = $frameD3->Entry(-highlightcolor => "red", -xscrollcommand => ['set' => $defil2] )
	->pack(		-fill => 'x',
			-expand => 1);
    $defil2->pack(-fill => 'x',
		  -expand => 1);
    $defil2->configure(-command => [$montantE => 'xview']);
    
    my $raz = $frame2->Button(-text=>'RAZ', -command=>\&viderMontant)->pack(-side=>'left', -padx=>20, -pady=>5);
    my $calcul = $frame2->Button(-text=>'Concatnation', -command=>\&loadconcatxml)->pack(-side=>'right', -padx=>20, -pady=>5);
    my $fin = $frame3->Button(-text=>'Exit', -command=>sub {$mainconcatFile->destroy()})->pack(-pady=>5);
    
    sub loadconcatxml {
	&UpdateIndicators2;
	my $chemin=$montantF->get();
	my $cheminout=$montantE->get();
	if ($chemin ne "") {
	    if ($chemin !~ /[\/\\]$/) { $chemin.="/"};
	    if (!opendir(DIR, $chemin)) {
	    &mkPrintErreur("ERREUR : can't open $chemin: $!\n");
	    return;
	}  
	    if ($cheminout eq "") {
		$cheminout = $chemin."result-concatenation.xml";
	    }
	    else {
		if (!opendir(DIR2, $cheminout)) {
		    &mkPrintErreur("ERREUR : can't open $cheminout: $!\n");
		    return;
		} 
		if ($cheminout !~ /[\/\\]$/) { $cheminout.="/"};
		$cheminout = $cheminout."result-concatenation.xml";
	    }
	my @files = readdir(DIR);
	    closedir(DIR);	
	    if (!open(TRACE, ">>$cheminout")) {
		&mkPrintErreur("ERREUR : Impossible d\'ouvrir le fichier en sortie $cheminout  \n");
		return;
	    }	
	    print TRACE "<?xml version=\"1.0\" encoding=\"ISO-8859-1\" standalone=\"yes\"?>\n";
	    print TRACE "<concatfile>\n";
	    my $filecount = 0;
	    foreach my $file (@files) {
		my $filecount++;
		next if $file =~ /^\.\.?$/;
		$file = $chemin.$file;
		print "I => ",$file,"\n";
		if (-f $file) {
		    if (!open(FILE, $file)) {
			&mkPrintErreur("ERREUR : Impossible d\'ouvrir le fichier en lecture : $file \n");
			return;
		    }	
		    print TRACE "\n<file name=\"$file\">\n";
		    while (<FILE>) {
			my $tmp=$_;
			$tmp=~s/</&lt;/g;
			$tmp=~s/>/&gt;/g;
			$tmp=~s/\@/_AROBASE_/g;
			print TRACE $tmp;
		    }
		    close (FILE);
		    print TRACE "</file>\n";
		}
	    }
	    print TRACE "</concatfile>\n";
	    close (TRACE);
	    &mkPrintMsgInfo("Concatnation termine dans : $cheminout \n");
	}
	else
	{
	    &mkPrintErreur("ERREUR : impossible d\'accder au rpertoire $chemin\n");
	    return;
	}
    }
}
#---------------------------------------------------------
sub help_concatFile {
    &UpdateIndicators2;
    if (! Exists ($pn1)) {
	$pn1 = $winMain::mw ->Toplevel();
	$pn1->title("HELP");
	my $label = $pn1->Label( -background => 'black',
				  -foreground =>  'white', -anchor => 'w' );
	my $texte2 = $pn1->Scrolled("MarkupTools")->pack(-side => 'bottom',
				      -fill => 'both',
				      -expand => 1);

	$texte2->Text(-setgrid => 'true');
	&updateMarkupWindow($texte2,$label);
	my $tmpfile="Doc/help_concatFile.txt";
	$texte2->IncludeFile($tmpfile);

	$pn1->Button(-text => "Close",
		     -command =>  sub {$pn1->destroy()})->pack(-side => 'top', -pady => 5, -padx => 10);

	my $w_save=$pn1->Button(-text => "Save",
		     -image => $imageSave,
		     -command => sub {$texte2->FileSaveAsPopup()})->pack(-side => 'top', -pady => 5, -padx => 10);
	$winMain::winBalloon->attach($w_save,
			    -balloonmsg => "Save"
			    );
    }
    else {
	$pn1->deiconify();
	$pn1->raise();
    }
}
#---------------------------------------------------------
sub help_word2lexico {
    &UpdateIndicators2;
    &tkweb("browser/www/helpmodulesv2/help_word2lexico3.htm");
}
#---------------------------------------------------------
sub help_word2xml {
    &UpdateIndicators2;
    &tkweb("browser/www/helpmodulesv2/help_word2xml.htm");

}
#---------------------------------------------------------
sub statxmlnode {
    $mainstatxmlnode = $winMain::mw ->Toplevel(-title=>'(STATXMLNODE)');
    $mainstatxmlnode->geometry("400x300+100+100");
    my $imgLogo=$mainstatxmlnode->Photo(-file=>"pics/logo-mkc.gif");
    my $lblLogo=$mainstatxmlnode->Button(-image=>$imgLogo)->place(-y=>0,-x=>0,-width=>400,-height=>300);
    my $frame1 = $mainstatxmlnode->Frame()->pack(-side=>'bottom', -pady=>5);
    my $frameG1 = $frame1->Frame()->pack(-side=>'top', -pady=>5);
    my $frameD1 = $frame1->Frame()->pack(-side=>'bottom', -pady=>5);
    my $frameG2 = $frameG1->Frame()->pack(-side=>'left', -pady=>5);
    my $frameD2 = $frameG1->Frame()->pack(-side=>'right', -pady=>5);
    my $frameG3 = $frameD1->Frame()->pack(-side=>'left', -pady=>5);
    my $frameD3 = $frameD1->Frame()->pack(-side=>'right', -pady=>5);
    my $frame2 = $mainstatxmlnode->Frame()->pack();
    my $frame3 = $mainstatxmlnode->Frame()->pack();
    my $libelF = $frameG2->Label(-text=>'File (input) :')->pack(-padx=>5);
    my $defil = $frameD2-> Scrollbar(-orient => "horizontal");
    $montantF = $frameD2->Entry(-highlightcolor => "blue", -xscrollcommand => ['set' => $defil] )
	->pack(		-fill => 'x',
			-expand => 1);
    $defil->pack(-fill => 'x',
		 -expand => 1);
    $defil->configure(-command => [$montantF => 'xview']);
    my $libelE = $frameG3->Label(-text=>'Node (XPath) :')->pack(-padx=>5);
    my $defil2 = $frameD3-> Scrollbar(-orient => "horizontal");
    $montantE = $frameD3->Entry(-highlightcolor => "red", -xscrollcommand => ['set' => $defil2] )
	->pack(		-fill => 'x',
			-expand => 1);
    $defil2->pack(-fill => 'x',
		  -expand => 1);
    $defil2->configure(-command => [$montantE => 'xview']);
    my $raz = $mainstatxmlnode->Button(-text=>'RAZ', -activeforeground=>"blue",-relief=>'flat', -command=>\&viderMontant)->pack(-side=>'left', -padx=>5, -pady=>5);
    my $calcul = $mainstatxmlnode->Button(-text=>'stat', -activeforeground=>"blue",-relief=>'flat', -command=>\&loadstatxmlnode)->pack(-side=>'left', -padx=>5, -pady=>5);
    my $help = $mainstatxmlnode->Button(-text=>'Help', -activeforeground=>"blue",-relief=>'flat', -command=>\&helpstatxmlnode)->pack(-side=>'right', -padx=>5, -pady=>5);
    my $fin = $mainstatxmlnode->Button(-text=>'Exit', -activeforeground=>"blue",-relief=>'flat', -command=>sub {$mainstatxmlnode->destroy()})->pack(-side=>'right', -padx=>5, -pady=>5);
}
#---------------------------------------------------------
sub helpstatxmlnode {
    &UpdateIndicators2;
    my $msg ="Statistiques lmentaires pour tous les noeuds donns correspondant au chemin XPath donn dans un fichier donn.\n";
    $winMain::mw->Dialog(
		  -title => "Help : ",
		  -text  => $msg
		)->Show();
}
#---------------------------------------------------------
sub loadstatxmlnode {
    my $chemin=$montantF->get();
    my $path=$montantE->get();
    if ($chemin ne "") {
	if (!open(FILE, $chemin)) {
	    &mkPrintErreur("ERREUR : can't open $chemin: $!\n");
	    return;
	}
	if ($path eq "") {
	    &mkPrintErreur("ERREUR : no XPath definition\n");
	    return;
	}
	if (!open(OUTFILE, ">MKC-tmp_statxmlnolde.txt")) {
	    &mkPrintErreur("ERREUR : can't open MKC-tmp_statxmlnolde.txt \n");
	    return;
	}
	use XML::XPath;
	use XML::XPath::XMLParser;	
	my $xpath = XML::XPath->new(filename => $chemin);
	my $nodeset = $xpath->find($path);	
	if ($nodeset->size) {
	    foreach my $node ($nodeset->get_nodelist) {
		print OUTFILE XML::XPath::XMLParser::as_string($node)."\n";
	    }
	}
	else {
	    print OUTFILE  "No nodes found\n";
	    &mkPrintErreur("ERREUR : No nodes found\n");
	    return;
	}
	close (OUTFILE);
	&makeStatInXPathNodes($chemin,$path);
	my $tmpfile="MKC-tmp_statFile.txt";
	my $msg="MKC-tmp_statFile.txt";
	&IncludedFileInWindow($tmpfile,$msg);
    }
}
#---------------------------------------------------------
sub makeStatInXPathNodes {
    use XML::Writer;
    my ($chemin,$path)=@_;
    if (!open(F,"MKC-tmp_statxmlnolde.txt")) {
	&mkPrintErreur("ERREUR : Impossible d\'ouvrir MKC-tmp_statxmlnolde.txt\n");
	return;
    }
    close(F);

    my $fileOut = "MKC-tmp_statFile.txt";
    my $output = new IO::File(">$fileOut");
    my $directory2xmlrecursewriter = new XML::Writer( DATA_MODE => 'true', DATA_INDENT => 2, OUTPUT => $output);
    $directory2xmlrecursewriter->xmlDecl("ISO-8859-1");

    my ($line, $word, $total_length);
# Variables to store stats 
    my ($num_lines, $num_words); 
    my (%words, %lengths);
    my $text = &read_text_forStatxmlnode();
    $num_lines = scalar @{$text}; 
    foreach $line (@{$text}) { 
	$num_words += scalar @{$line};
	foreach $word (@{$line}) {
	    $words{$word}++;
	    $lengths{length $word}++; 
	    $total_length += length $word; 
	}
    } 

    my @sorted_words = sort { $words{$b} <=> $words{$a} } keys %words;
    my @sorted_lengths = sort { $lengths{$b} <=> $lengths{$a} } keys %lengths;
    $directory2xmlrecursewriter->startTag('statxmlnode');
    $directory2xmlrecursewriter->startTag('file');
    $directory2xmlrecursewriter->characters($chemin);
    $directory2xmlrecursewriter->endTag('file');
    $directory2xmlrecursewriter->startTag('nodes');
    $directory2xmlrecursewriter->characters($path);
    $directory2xmlrecursewriter->endTag('nodes');
    $directory2xmlrecursewriter->startTag('lineNumber');
    $directory2xmlrecursewriter->characters($num_lines);
    $directory2xmlrecursewriter->endTag('lineNumber');
    $directory2xmlrecursewriter->startTag('wordNumber');
    $directory2xmlrecursewriter->characters($num_words);
    $directory2xmlrecursewriter->endTag('wordNumber');
    $directory2xmlrecursewriter->startTag('meanWordLength');
    $directory2xmlrecursewriter->characters("The average word length is : ".$total_length / $num_words);
    $directory2xmlrecursewriter->endTag('meanWordLength');
    $directory2xmlrecursewriter->startTag('words');
    if (!open(TMPF,">MKC-tmp_statxmlnolde2.txt")) {
	&mkPrintErreur("ERREUR : Impossible d\'ouvrir MKC-tmp_statxmlnolde2.txt\n");
	return;
    }
    print TMPF  map { "<r><w>$_</w><occ>$words{$_}</occ></r>\n" } @sorted_words;
    close(TMPF);
   if (!open(TMPF,"MKC-tmp_statxmlnolde2.txt")) {
	&mkPrintErreur("ERREUR : Impossible d\'ouvrir MKC-tmp_statxmlnolde2.txt\n");
	return;
    }
    while (my $tmpmap=<TMPF>) {
	if ($tmpmap=~/<r><w>([^<]+)<\/w><occ>([^<]+)<\/occ><\/r>/) {
	    $directory2xmlrecursewriter->startTag('r');
	    $directory2xmlrecursewriter->startTag('w');
	    $directory2xmlrecursewriter->characters( $1);
	    $directory2xmlrecursewriter->endTag('w');
	    $directory2xmlrecursewriter->startTag('occ');
	    $directory2xmlrecursewriter->characters( $2);
	    $directory2xmlrecursewriter->endTag('occ');
	    $directory2xmlrecursewriter->endTag('r');
	}
    }
    close(TMPF);
    $directory2xmlrecursewriter->endTag('words');

    $directory2xmlrecursewriter->startTag('wordLenght');
    if (!open(TMPF,">MKC-tmp_statxmlnolde2.txt")) {
	&mkPrintErreur("ERREUR : Impossible d\'ouvrir MKC-tmp_statxmlnolde2.txt\n");
	return;
    }
    print TMPF   map { "<r><lg>$_</lg><nb>$lengths{$_}</nb></r>\n" } @sorted_lengths[0 .. 10];
    close(TMPF);
   if (!open(TMPF,"MKC-tmp_statxmlnolde2.txt")) {
	&mkPrintErreur("ERREUR : Impossible d\'ouvrir MKC-tmp_statxmlnolde2.txt\n");
	return;
    }
    while (my $tmpmap=<TMPF>) {
	if ($tmpmap=~/<r><lg>([^<]+)<\/lg><nb>([^<]+)<\/nb><\/r>/) {
	    $directory2xmlrecursewriter->startTag('r');
	    $directory2xmlrecursewriter->startTag('lg');
	    $directory2xmlrecursewriter->characters( $1);
	    $directory2xmlrecursewriter->endTag('lg');
	    $directory2xmlrecursewriter->startTag('nb');
	    $directory2xmlrecursewriter->characters( $2);
	    $directory2xmlrecursewriter->endTag('nb');
	    $directory2xmlrecursewriter->endTag('r');
	}
    }
    close(TMPF);
    $directory2xmlrecursewriter->endTag('wordLenght');
    $directory2xmlrecursewriter->endTag('statxmlnode');

    $output->close();# Variables to keep track of where we are in the file 

    sub read_text_forStatxmlnode {
	my @file; 
	if (!open(TMPFILE1,("MKC-tmp_statxmlnolde.txt"))) {
	    &mkPrintErreur("ERREUR : Impossible d\'ouvrir le fichier MKC-tmp_statxmlnolde.txt\n");
	    return;
	}
	push @file, [split] while <TMPFILE1>; 
	close(TMPFILE1);
	\@file;
    }
}
#---------------------------------------------------------
sub collocInXPath {
    $maincollocInXPath = $winMain::mw ->Toplevel(-title=>'(CollocationInXPath)');
    $maincollocInXPath->geometry("400x300+100+100");
    my $imgLogo=$maincollocInXPath->Photo(-file=>"pics/logo-mkc.gif");
    my $lblLogo=$maincollocInXPath->Button(-image=>$imgLogo)->place(-y=>0,-x=>0,-width=>400,-height=>300);
    my $frame1 = $maincollocInXPath->Frame()->pack(-side=>'bottom', -pady=>5);
    my $frameG1 = $frame1->Frame()->pack(-side=>'top', -pady=>5);
    my $frameD1 = $frame1->Frame()->pack(-side=>'bottom', -pady=>5);
    my $frameG2 = $frameG1->Frame()->pack(-side=>'left', -pady=>5);
    my $frameD2 = $frameG1->Frame()->pack(-side=>'right', -pady=>5);
    my $frameG3 = $frameD1->Frame()->pack(-side=>'left', -pady=>5);
    my $frameD3 = $frameD1->Frame()->pack(-side=>'right', -pady=>5);
    my $frame2 = $maincollocInXPath->Frame()->pack();
    my $frame3 = $maincollocInXPath->Frame()->pack();
    my $libelF = $frameG2->Label(-text=>'File (input) :')->pack(-padx=>5);
    my $defil = $frameD2-> Scrollbar(-orient => "horizontal");
    $montantF = $frameD2->Entry(-highlightcolor => "blue", -xscrollcommand => ['set' => $defil] )
	->pack(		-fill => 'x',
			-expand => 1);
    $defil->pack(-fill => 'x',
		 -expand => 1);
    $defil->configure(-command => [$montantF => 'xview']);
    my $libelE = $frameG3->Label(-text=>'Node (XPath) :')->pack(-padx=>5);
    my $defil2 = $frameD3-> Scrollbar(-orient => "horizontal");
    $montantE = $frameD3->Entry(-highlightcolor => "red", -xscrollcommand => ['set' => $defil2] )
	->pack(		-fill => 'x',
			-expand => 1);
    $defil2->pack(-fill => 'x',
		  -expand => 1);
    $defil2->configure(-command => [$montantE => 'xview']);
    my $raz = $maincollocInXPath->Button(-text=>'RAZ', -activeforeground=>"blue",-relief=>'flat', -command=>\&viderMontant)->pack(-side=>'left', -padx=>5, -pady=>5);
    my $calcul = $maincollocInXPath->Button(-text=>'Colloc', -activeforeground=>"blue",-relief=>'flat', -command=>\&loadcollocInXPath)->pack(-side=>'left', -padx=>5, -pady=>5);
    my $help = $maincollocInXPath->Button(-text=>'Help', -activeforeground=>"blue",-relief=>'flat', -command=>\&helpcollocInXPath)->pack(-side=>'right', -padx=>5, -pady=>5);
    my $fin = $maincollocInXPath->Button(-text=>'Exit', -activeforeground=>"blue",-relief=>'flat', -command=>sub {$maincollocInXPath->destroy()})->pack(-side=>'right', -padx=>5, -pady=>5);
}
#---------------------------------------------------------
sub loadcollocInXPath {
    my $chemin=$montantF->get();
    my $path=$montantE->get();
    if ($chemin ne "") {
	if (!open(FILE, $chemin)) {
	    &mkPrintErreur("ERREUR : can't open $chemin: $!\n");
	    return;
	}
	if ($path eq "") {
	    &mkPrintErreur("ERREUR : no XPath definition\n");
	    return;
	}
	if (!open(OUTFILE, ">MKC-tmp_collocInXPath.txt")) {
	    &mkPrintErreur("ERREUR : can't open MKC-tmp_collocInXPath.txt \n");
	    return;
	}
	use XML::XPath;
	use XML::XPath::XMLParser;	
	my $xpath = XML::XPath->new(filename => $chemin);
	my $nodeset = $xpath->find($path);	
	if ($nodeset->size) {
	    foreach my $node ($nodeset->get_nodelist) {
		print OUTFILE XML::XPath::XMLParser::as_string($node)."\n";
	    }
	}
	else {
	    print OUTFILE  "No nodes found\n";
	    &mkPrintErreur("ERREUR : No nodes found\n");
	    return;
	}
	close (OUTFILE);
	&makeCollocationsInXPathNodes;
	my $tmpfile="MKC-tmp_collocations.txt";
	my $msg="MKC-tmp_collocations.txt";
	&IncludedFileInWindow($tmpfile,$msg);
    }
}

#---------------------------------------------------------------------------------------
sub makeCollocationsInXPathNodes {
    if (!open(F,"MKC-tmp_collocInXPath.txt")) {
	&mkPrintErreur("ERREUR : Impossible d\'ouvrir MKC-tmp_collocInXPath.txt\n");
	return;
    }
    if (!open(FIC2,">MKC-tmp_collocations.txt")) {
    &mkPrintErreur("ERREUR : Impossible d\'ouvrir MKC-tmp_collocations.txt\n");
    return;
	}
    my $debug = 0; 
    my @offsets;
# Debug-Meldungen ein- oder ausschalten
    my $leftRight = 4; 
# immer je $leftRight Wrter nach links und nach rechts. Fenstergre ist somit $leftRight * 2 + 1
    my $begin = time();
    my $typeCnt  = 0;  
# hier werden die Types des Korpus gezhlt
### File Zeile fr Zeile einlesen ###

    my $lineCnt = 0;
    while(my $line = <F> ){
	next if(substr($line, 0, 2) eq "%%");
	print FIC2 "Processing line $lineCnt... (elapsed: ", (time() - $begin), "sec)\n" if( $lineCnt % 1000 == 0);
	$line =~ s/^\s+[0-9]+:\s+//;
	my @tokens = split( /\s+/, $line );
	### Schleife ber jeden Token im Satz ###
	for(my $i = 0; $i <= $#tokens; $i++){
	    dbg("$tokens[$i]\n");
	    ### Fenster, das rechten und linken Kontext eines jeden Tokens betrachtet ###
	    for(my $j = ($i - $leftRight); $j <= ($i + $leftRight); $j++ ){
		$j = 0 if( $j < 0 );
		last if( $j > $#tokens );
		dbg("\t" . $tokens[$j] . " (" . ($j - $i) . ")\n");
		registerType( $tokens[$j] );
		push(
		     @{		# als Array interpretierter ...
			 ${ $offsets[ $typesCollocations{ $tokens[$i] }]  }{$typesCollocations{ $tokens[$j] }} # ... Wert des doppelten Hashs
		 }
		,
		$j - $i 
		    )
		if($j - $i != 0);
	}
	dbg("\n");
    }
    $lineCnt++;	
    last if($lineCnt == 2000);
}
close F;

### Errechnen und ausgeben: mean offset und standard deviation ###
my $token1Nr = 0;
foreach my $hashRef ( @offsets ){
    foreach my $token2Nr ( keys %{$hashRef} ){
	print FIC2 "$numbersCollocations[$token1Nr]\t$numbersCollocations[$token2Nr]\t\t";	
	my @offsetsForToken1AndToken2 = @{ ${ $offsets[$token1Nr] }{ $token2Nr } };
    dbg("( ");
    foreach(@offsetsForToken1AndToken2){
	dbg("$_ ");
    }
    dbg(") ");
    my $meanTmp = mean( @offsetsForToken1AndToken2 );
    $meanTmp = sprintf("%.3f", $meanTmp); # auf 3 Stellen runden
    my $devTmp = stdDev( \@offsetsForToken1AndToken2, $meanTmp );
    $devTmp = sprintf("%.3f", $devTmp) if(defined $devTmp);
    
    # Die Ergebnisse knnte man wieder speichern:
    #${$means{$token1Nr}}{$token2Nr} = $meanTmp;
    #${$stdDev{$token1Nr}}{$token2Nr} = $devTmp;
    
    my $cntTmp = $#offsetsForToken1AndToken2 + 1;
    print FIC2 "CNT = $cntTmp\t";
    print FIC2 "MEAN = $meanTmp";
    print FIC2 "\tDEV = $devTmp", (($cntTmp > 2 && $devTmp <= 1)?(" !!!"):(""))
	if( defined $devTmp );
    print FIC2 "\n";
}
$token1Nr++;
}
close(F);
close(FIC2);


#########################################################################
### mean offset (Mittlerer Abstand) ausrechnen
### Parameter: Einen Array, der alle Abweichungen enthlt, (-1, 3, 2, -2)
#########################################################################
sub mean{
	my @offsets = @_;
	my $sum = 0;
	foreach (@offsets){
		$sum += $_;		
	}
	return ($sum / (($#offsets > 0)?($#offsets + 1):(1)));
}

######################################################################
### standard deviation ausrechnen
### Parameter: Einen Array, der alle Abweichungen enthlt und die mean-offset-Zahl
######################################################################
sub stdDev{
	my ($offsetsRef, $meanOffset) = @_;
	my @offsets = @$offsetsRef;
	return undef if( $#offsets == 0 ); # nur ein Element
	my $stdDev = 0;
	foreach $offset (@offsets){
		$stdDev += (($offset - $meanOffset) * ($offset - $meanOffset));
	}
	return sqrt( $stdDev / $#offsets );
}

######################################################################
# Type neu in den Hash eintragen: Jeder Type bekommt 'ne eigene Nummer 
######################################################################
sub registerType{
	my $w = shift;
	unless(defined $typesCollocations{$w} ){
		$typesCollocations{$w} = $typeCnt++;
		push (@numbersCollocations, $w);
	}
}

###################################################################
### dbg() - Einfache Info-Messages ber den Programmablauf ausgeben
###################################################################
sub dbg{
    $debug && print shift; # Ausgabe nur, wenn $debug wahr.
}
}

#---------------------------------------------------------
sub helpcollocInXPath {
    &UpdateIndicators2;
    my $msg ="Recherche de collocation pour tous les noeuds donns correspondant au chemin XPath donn dans un fichier donn.\n";
    $winMain::mw->Dialog(
		  -title => "Help : ",
		  -text  => $msg
		)->Show();
}
#---------------------------------------------------------
sub randSelectFile {
    $mainrandSelectFile = $winMain::mw ->Toplevel(-title=>'(Copy Random Files)');
    $mainrandSelectFile->geometry("400x300+100+100");
    my $imgLogo=$mainrandSelectFile->Photo(-file=>"pics/logo-mkc.gif");
    my $lblLogo=$mainrandSelectFile->Button(-image=>$imgLogo)->place(-y=>0,-x=>0,-width=>400,-height=>300);
    my $frame1 = $mainrandSelectFile->Frame()->pack(-side=>'bottom', -pady=>5);
    my $frameG1 = $frame1->Frame()->pack(-side=>'top', -pady=>5);
    my $frameD1 = $frame1->Frame()->pack(-side=>'bottom', -pady=>5);
    my $frameH1 = $frame1->Frame()->pack(-side=>'bottom', -pady=>5);
    my $frameG2 = $frameG1->Frame()->pack(-side=>'left', -pady=>5);
    my $frameD2 = $frameG1->Frame()->pack(-side=>'right', -pady=>5);
    my $frameG3 = $frameD1->Frame()->pack(-side=>'left', -pady=>5);
    my $frameD3 = $frameD1->Frame()->pack(-side=>'right', -pady=>5);
    my $frameG4 = $frameH1->Frame()->pack(-side=>'left', -pady=>5);
    my $frameD4 = $frameH1->Frame()->pack(-side=>'right', -pady=>5);
    my $frame2 = $mainrandSelectFile->Frame()->pack();
    my $frame3 = $mainrandSelectFile->Frame()->pack();

    my $libelF = $frameG2->Label(-text=>'Directory (input) :')->pack(-padx=>5);
    my $defil = $frameD2-> Scrollbar(-orient => "horizontal");
    $montantF = $frameD2->Entry(-highlightcolor => "blue", -xscrollcommand => ['set' => $defil] )
	->pack(		-fill => 'x',
			-expand => 1);
    $defil->pack(-fill => 'x',
		 -expand => 1);
    $defil->configure(-command => [$montantF => 'xview']);

    my $libelE = $frameG3->Label(-text=>'Directory (output) :')->pack(-padx=>5);
    my $defil2 = $frameD3-> Scrollbar(-orient => "horizontal");
    $montantE = $frameD3->Entry(-highlightcolor => "red", -xscrollcommand => ['set' => $defil2] )
	->pack(		-fill => 'x',
			-expand => 1);
    $defil2->pack(-fill => 'x',
		  -expand => 1);
    $defil2->configure(-command => [$montantE => 'xview']);

    my $libelG = $frameG4->Label(-text=>'Nombre MAX de fichiers :')->pack(-padx=>5);
    my $defil3 = $frameD4-> Scrollbar(-orient => "horizontal");
    $montantG = $frameD4->Entry(-highlightcolor => "red", -xscrollcommand => ['set' => $defil3] )
	->pack(		-fill => 'x',
			-expand => 1);
    $defil3->pack(-fill => 'x',
		  -expand => 1);
    $defil3->configure(-command => [$montantG => 'xview']);


    my $raz = $mainrandSelectFile->Button(-text=>'RAZ', -activeforeground=>"blue",-relief=>'flat', -command=>\&viderMontant)->pack(-side=>'left', -padx=>5, -pady=>5);
 
    my $calcul = $mainrandSelectFile->Button(-text=>'Copy', -activeforeground=>"blue",-relief=>'flat', -command=>\&loadrandSelectFile)->pack(-side=>'left', -padx=>5, -pady=>5);
    my $help = $mainrandSelectFile->Button(-text=>'Help', -activeforeground=>"blue",-relief=>'flat', -command=>\&help_randSelectFile)->pack(-side=>'right', -padx=>5, -pady=>5);
    my $fin = $mainrandSelectFile->Button(-text=>'Exit', -activeforeground=>"blue",-relief=>'flat', -command=>sub {$mainrandSelectFile->destroy()})->pack(-side=>'right', -padx=>5, -pady=>5);
}

#---------------------------------------------------------------------------------------
sub loadrandSelectFile {
    my $nombreFichiers=0;
    my $chemin=$montantF->get();
    my $cheminout=$montantE->get();
    if ($chemin ne "") {
	if ($chemin !~ /[\/\\]$/) { $chemin.="/"};
	$chemin=~s/\\/\//g;
	if (!opendir(DIR, $chemin)) {
	    &mkPrintErreur("ERREUR : can't open $chemin: $!\n");
	    return;
	}
	closedir(DIR);
   }
    else {
	&mkPrintErreur("ERREUR : input DIR requested\n");
	return;
    }
    if ($cheminout ne "") {
	if ($cheminout !~ /[\/\\]$/) { $cheminout.="/"};
	$cheminout=~s/\\/\//g;
	if (!opendir(DIR, $cheminout)) {
	    &mkPrintErreur("ERREUR : can't open $cheminout: $!\n");
	    return;
	}
	closedir(DIR);
    }
	else {
	    &mkPrintErreur("ERREUR : output DIR requested\n");
	    return;
	}
    my $nombreFichiersMaximum=$montantG->get();
    my $seuilExtractionAleatoire = 0.4;
    &copieFichiers($chemin);
#-------
    sub copieFichiers {
	use File::Copy;
	if ($nombreFichiers > $nombreFichiersMaximum) {return;};
	my $path = shift(@_);
	return unless (-e $path);
	if (-d $path) {
	    my @content=();
	    opendir(DIR, $path) or die "can't open $path: $!\n";
	    while (my $item = readdir(DIR)) {
		next if ($item =~ /^\.\.?$/);
		push (@content, $item);
	    }
	    closedir(DIR);
	    foreach my $file (@content) {
		$file = $path."/".$file;
		&copieFichiers($file);	#recurse!
	    }
	}
	else {
	    next if $path =~ /^\.\.?$/;
	    my $nombreAleatoire=rand;
	    print "$nombreAleatoire = nombreAleatoire --- $nombreFichiers =  nombreFichiers --- $nombreFichiersMaximum = nombreFichiersMaximum\n";
	    if (($nombreAleatoire <= $seuilExtractionAleatoire) && ($nombreFichiers < $nombreFichiersMaximum)) {
		$path=~/\/([^\/]+)$/;
		my $pathout;
		if ($1 ne "") {
		    $pathout=$cheminout."/"."MKC-".$nombreFichiers."-".$1;
		}
		else {
		    $pathout=$cheminout."/"."MKC-".$nombreFichiers."-"."unknownOriginalNameFile";
		}
		copy($path, $pathout);
		$nombreFichiers++;
	    }
	}
    }
}
#---------------------------------------------------------
sub help_randSelectFile {
    &UpdateIndicators2;
    my $msg ="Format d\'entree : un nombre important de fichiers dans un dossier, a extraire de maniere aleatoire. Format de Sortie : le nombre de fichiers passe en argument extraits aleatoirement dans le dossier de sortie out/.\n";
    $winMain::mw->Dialog(
		  -title => "Help : ",
		  -text  => $msg
		)->Show();

}
#---------------------------------------------------------
sub concat2xmlrandSelectFile {
    &mkIndisponible();
}
#---------------------------------------------------------
sub directory2xml {
    $maindirectory2xml = $winMain::mw ->Toplevel(-title=>'(Directory2xml)');
    $maindirectory2xml->geometry("400x300+100+100");
    my $imgLogo=$maindirectory2xml->Photo(-file=>"pics/logo-mkc.gif");
    my $lblLogo=$maindirectory2xml->Button(-image=>$imgLogo)->place(-y=>0,-x=>0,-width=>400,-height=>300);
    my $frame1 = $maindirectory2xml->Frame()->pack(-side=>'bottom', -pady=>5);
    my $frameG1 = $frame1->Frame()->pack(-side=>'top', -pady=>5);
    my $frameD1 = $frame1->Frame()->pack(-side=>'bottom', -pady=>5);
    my $frameG2 = $frameG1->Frame()->pack(-side=>'left', -pady=>5);
    my $frameD2 = $frameG1->Frame()->pack(-side=>'right', -pady=>5);
    my $frameG3 = $frameD1->Frame()->pack(-side=>'left', -pady=>5);
    my $frameD3 = $frameD1->Frame()->pack(-side=>'right', -pady=>5);
    my $frame2 = $maindirectory2xml->Frame()->pack();
    my $frame3 = $maindirectory2xml->Frame()->pack();
    my $libelF = $frameG2->Label(-text=>'Chemin du rpertoire (input) :')->pack(-padx=>5);
    my $defil = $frameD2-> Scrollbar(-orient => "horizontal");
    $montantF = $frameD2->Entry(-highlightcolor => "blue", -xscrollcommand => ['set' => $defil] )
	->pack(		-fill => 'x',
			-expand => 1);
    $defil->pack(-fill => 'x',
		 -expand => 1);
    $defil->configure(-command => [$montantF => 'xview']);
    my $libelE = $frameG3->Label(-text=>'Chemin du rpertoire (output) :')->pack(-padx=>5);
    my $defil2 = $frameD3-> Scrollbar(-orient => "horizontal");
    $montantE = $frameD3->Entry(-highlightcolor => "red", -xscrollcommand => ['set' => $defil2] )
	->pack(		-fill => 'x',
			-expand => 1);
    $defil2->pack(-fill => 'x',
		  -expand => 1);
    $defil2->configure(-command => [$montantE => 'xview']);
    my $raz = $maindirectory2xml->Button(-text=>'RAZ', -activeforeground=>"blue",-relief=>'flat', -command=>\&viderMontant)->pack(-side=>'left', -padx=>5, -pady=>5);
    my $calcul = $maindirectory2xml->Button(-text=>'DIR2XML', -activeforeground=>"blue",-relief=>'flat', -command=>\&loaddirectory2xml)->pack(-side=>'left', -padx=>5, -pady=>5);
    my $help = $maindirectory2xml->Button(-text=>'Help', -activeforeground=>"blue",-relief=>'flat', -command=>\&helpdirectory2xml)->pack(-side=>'right', -padx=>5, -pady=>5);
    my $fin = $maindirectory2xml->Button(-text=>'Exit', -activeforeground=>"blue",-relief=>'flat', -command=>sub {$maindirectory2xml->destroy()})->pack(-side=>'right', -padx=>5, -pady=>5);
    my $calcul2 = $maindirectory2xml->Button(-width=>40, -text=>'DIR2XML-withContent',-activeforeground=>"blue",-relief=>'flat',  -command=>\&loaddirectory2xml2)->pack(-side=>'right',  -fill=>'x', -expand =>1);
}
#---------------------------------------------------------
sub helpdirectory2xml {
    &UpdateIndicators2;
    my $msg ="1. Option DIR2XML : conversion d'une arborescence donne au format XML\n\n2.Option DIR2XML-withContent : conversion d'une arborescence donne au format XML avec intgration du contenu des fichiers lus dans l'arborescence.\n";
    $winMain::mw->Dialog(
		  -title => "Help : ",
		  -text  => $msg
		)->Show();
}
#---------------------------------------------------------
sub loaddirectory2xml {
    use XML::Writer;
    my $chemin=$montantF->get();
    my $cheminout=$montantE->get();
    if ($chemin ne "") {
	if ($chemin !~ /[\/\\]$/) { $chemin.="/"};
	if (!opendir(DIR, $chemin)) {
	    &mkPrintErreur("ERREUR : can't open $chemin: $!\n");
	    return;
	}
	closedir(DIR);
	if ($cheminout eq "") {
		$cheminout = $chemin;
	    }
	else {
	    if (!opendir(DIR2, $cheminout)) {
		&mkPrintErreur("ERREUR : can't open $cheminout: $!\n");
		return;
	    } 
	    if ($cheminout !~ /[\/\\]$/) { $cheminout.="/"};
	}
	my $filecount=0;
	my $fileOut = $cheminout.""."MKC-directory2xml.xml";
	my $output = new IO::File(">$fileOut");
	$directory2xmlrecursewriter = new XML::Writer( DATA_MODE => 'true', DATA_INDENT => 2, OUTPUT => $output);
	$directory2xmlrecursewriter->xmlDecl("ISO-8859-1");
	&directory2xmlrecurse($chemin);
	$output->close();

	my $tmpfile=$fileOut ;
	my $msg="Dir2XML Result" ;
	&IncludedFileInWindow($tmpfile,$msg);


	sub directory2xmlrecurse {
	    my $path = shift(@_);
	    return unless (-e $path);
	    if (-d $path) {
		$directory2xmlrecursewriter->startTag('directory', 'name' => $path);
		my @content=();
		opendir(DIR, $path) or die "can't open $path: $!\n";
		while (my $item = readdir(DIR)) {
		    next if ($item =~ /^\.\.?$/);
		    push (@content, $item);
		}
		closedir(DIR);
		foreach my $file (@content) {
		    $file = $path."/".$file;
		    &directory2xmlrecurse($file);	#recurse!
		}
		$directory2xmlrecursewriter->endTag('directory');
	    }
	    else {
		if ($path!~/MKC-directory2xml\.xml/) {
		    $filecount++;
		    $directory2xmlrecursewriter->startTag('file', 'name' => $path, 'number' => $filecount);
		    $directory2xmlrecursewriter->startTag('content');
		    $directory2xmlrecursewriter->endTag('content');
		    $directory2xmlrecursewriter->endTag('file');
		}
	    }
	}
}
}
#---------------------------------------------------------
sub loaddirectory2xml2 {
    use XML::Writer;
    my $chemin=$montantF->get();
    my $cheminout=$montantE->get();
    if ($chemin ne "") {
	if ($chemin !~ /[\/\\]$/) { $chemin.="/"};
	if (!opendir(DIR, $chemin)) {
	    &mkPrintErreur("ERREUR : can't open $chemin: $!\n");
	    return;
	}
	closedir(DIR);
	if ($cheminout eq "") {
		$cheminout = $chemin;
	    }
	else {
	    if (!opendir(DIR2, $cheminout)) {
		&mkPrintErreur("ERREUR : can't open $cheminout: $!\n");
		return;
	    } 
	    if ($cheminout !~ /[\/\\]$/) { $cheminout.="/"};
	}
	my $filecount=0;
	my $fileOut = $cheminout.""."MKC-directory2xml-content.xml";
	my $output = new IO::File(">$fileOut");
	$directory2xmlrecursewriter = new XML::Writer( DATA_MODE => 'true', DATA_INDENT => 2, OUTPUT => $output);
	$directory2xmlrecursewriter->xmlDecl("ISO-8859-1");
	&directory2xmlrecurse2($chemin);
	$output->close();
	my $tmpfile=$fileOut ;
	my $msg="Dir2XML Result" ;
	&IncludedFileInWindow($tmpfile,$msg);

	sub directory2xmlrecurse2 {
	    my $path = shift(@_);
	    return unless (-e $path);
	    if (-d $path) {
		$directory2xmlrecursewriter->startTag('directory', 'name' => $path);
		my @content=();
		opendir(DIR, $path) or die "can't open $path: $!\n";
		while (my $item = readdir(DIR)) {
		    next if ($item =~ /^\.\.?$/);
		    push (@content, $item);
		}
		closedir(DIR);
		foreach my $file (@content) {
		    $file = $path."/".$file;
		    &directory2xmlrecurse2($file);	#recurse!
		}
		$directory2xmlrecursewriter->endTag('directory');
	    }
	    else {
		if ($path!~/MKC-directory2xml-content\.xml/) {
		    $filecount++;
		    $directory2xmlrecursewriter->startTag('file', 'name' => $path, 'number' => $filecount);
		    $directory2xmlrecursewriter->startTag('content');
		    if (!open(TMPFILE,$path)) {
#		    &mkPrintErreur("ERREUR : Impossible d\'ouvrir '$path'\n");
#		    return;
			my $line = "ERREUR : Impossible d\'ouvrir $path";
			$directory2xmlrecursewriter->characters($line);
		    }
		    while (my $line=<TMPFILE>) {
			$directory2xmlrecursewriter->characters($line);
		    }
		    close(TMPFILE);
		    $directory2xmlrecursewriter->endTag('content');
		    $directory2xmlrecursewriter->endTag('file');
		}
	    }
	}
}
}
#---------------------------------------------------------
sub word2lexico {
    &UpdateIndicators2;
    use Win32::OLE qw(in with);
    my $mainword2lexico = $winMain::mw ->Toplevel(-title=>'((MS-Word2txt) + balisage) pour Lexico3');
    $mainword2lexico->geometry("400x300+100+100");
    my $imgLogo=$mainword2lexico->Photo(-file=>"pics/logo-mkc.gif");
    my $lblLogo=$mainword2lexico->Button(-image=>$imgLogo)->place(-y=>0,-x=>0,-width=>400,-height=>300);
    my $frame1 = $mainword2lexico->Frame()->pack(-side=>'bottom', -pady=>5);
    my $frameG1 = $frame1->Frame()->pack(-side=>'top', -pady=>5);
    my $frameD1 = $frame1->Frame()->pack(-side=>'bottom', -pady=>5);
    my $frameG2 = $frameG1->Frame()->pack(-side=>'left', -pady=>5);
    my $frameD2 = $frameG1->Frame()->pack(-side=>'right', -pady=>5);
    my $frameG3 = $frameD1->Frame()->pack(-side=>'left', -pady=>5);
    my $frameD3 = $frameD1->Frame()->pack(-side=>'right', -pady=>5);
    my $frame2 = $mainword2lexico->Frame()->pack();
    my $frame3 = $mainword2lexico->Frame()->pack();
    my $libelF = $frameG2->Label(-text=>'Chemin du rpertoire (input) :')->pack(-padx=>5);
    my $defil = $frameD2-> Scrollbar(-orient => "horizontal");
    $montantF = $frameD2->Entry(-highlightcolor => "blue", -xscrollcommand => ['set' => $defil] )
	->pack(		-fill => 'x',
			-expand => 1);
    $defil->pack(-fill => 'x',
		 -expand => 1);
    $defil->configure(-command => [$montantF => 'xview']);
    my $libelE = $frameG3->Label(-text=>'Chemin du rpertoire (output) :')->pack(-padx=>5);
    my $defil2 = $frameD3-> Scrollbar(-orient => "horizontal");
    $montantE = $frameD3->Entry(-highlightcolor => "red", -xscrollcommand => ['set' => $defil2] )
	->pack(		-fill => 'x',
			-expand => 1);
    $defil2->pack(-fill => 'x',
		  -expand => 1);
    $defil2->configure(-command => [$montantE => 'xview']);
    my $raz = $mainword2lexico->Button(-text=>'RAZ', -activeforeground=>"blue",-relief=>'flat', -command=>\&viderMontant)->pack(-side=>'left', -padx=>5, -pady=>5);
    my $calcul = $mainword2lexico->Button(-text=>'Word2Lex3', -activeforeground=>"blue",-relief=>'flat', -command=>\&loadword2txt)->pack(-side=>'left', -padx=>5, -pady=>5);
    my $help = $mainword2lexico->Button(-text=>'Help', -activeforeground=>"blue",-relief=>'flat', -command=>\&helpword2lexico)->pack(-side=>'right', -padx=>5, -pady=>5);
    my $fin = $mainword2lexico->Button(-text=>'Exit', -activeforeground=>"blue",-relief=>'flat', -command=>sub {$mainword2lexico->destroy()})->pack(-side=>'right', -padx=>5, -pady=>5);
    my $calcul2 = $mainword2lexico->Button(-width=>40, -text=>'Word2Lex3-Concat',-activeforeground=>"blue",-relief=>'flat',  -command=>\&loadword2txt2)->pack(-side=>'right',  -fill=>'x', -expand =>1);

}
#---------------------------------------------------------
sub helpword2lexico {
    &UpdateIndicators2;
    my $msg ="1. Option Word2Lex3 : conversion de fichiers Word dans un rpertoire donn au format TXT (extension fichier-conv2lex3.txt)\n\n2.Option Word2Lex3-Concat : conversion de fichiers Word dans un rpertoire donn au format TXT avec concatnation dans un seul fichier (concat_and_conversion2Lexico3.txt)\n";
    $winMain::mw->Dialog(
		  -title => "Help : ",
		  -text  => $msg
		)->Show();
}
#---------------------------------------------------------
sub helpword2xml {
    &UpdateIndicators2;
    my $msg ="1. Option Word2Xml : conversion de fichiers Word dans un rpertoire donn au format XML (extension fichier-conv2xml.txt)\n\n2.Option Word2Xml-Concat : conversion de fichiers Word dans un rpertoire donn au format TXT avec concatnation dans un seul fichier (concat_and_conversion2xml.txt)\n";
    $winMain::mw->Dialog(
		  -title => "Help : ",
		  -text  => $msg
		)->Show();
}
#---------------------------------------------------------
sub word2xml {
&UpdateIndicators2;
    use Win32::OLE qw(in with);
    my $mainword2xml = $winMain::mw ->Toplevel(-title=>'(MS-Word2XML)');
    $mainword2xml->geometry("400x300+100+100");
    my $imgLogo=$mainword2xml->Photo(-file=>"pics/logo-mkc.gif");
    my $lblLogo=$mainword2xml->Button(-image=>$imgLogo)->place(-y=>0,-x=>0,-width=>400,-height=>300);
    my $frame1 = $mainword2xml->Frame()->pack(-side=>'bottom', -pady=>5);
    my $frameG1 = $frame1->Frame()->pack(-side=>'top', -pady=>5);
    my $frameD1 = $frame1->Frame()->pack(-side=>'bottom', -pady=>5);
    my $frameG2 = $frameG1->Frame()->pack(-side=>'left', -pady=>5);
    my $frameD2 = $frameG1->Frame()->pack(-side=>'right', -pady=>5);
    my $frameG3 = $frameD1->Frame()->pack(-side=>'left', -pady=>5);
    my $frameD3 = $frameD1->Frame()->pack(-side=>'right', -pady=>5);
    my $frame2 = $mainword2xml->Frame()->pack();
    my $frame3 = $mainword2xml->Frame()->pack();
    my $libelF = $frameG2->Label(-text=>'Chemin du rpertoire (input) :')->pack(-padx=>5);
    my $defil = $frameD2-> Scrollbar(-orient => "horizontal");
    $montantF = $frameD2->Entry(-highlightcolor => "blue", -xscrollcommand => ['set' => $defil] )
	->pack(		-fill => 'x',
			-expand => 1);
    $defil->pack(-fill => 'x',
		 -expand => 1);
    $defil->configure(-command => [$montantF => 'xview']);
    my $libelE = $frameG3->Label(-text=>'Chemin du rpertoire (output) :')->pack(-padx=>5);
    my $defil2 = $frameD3-> Scrollbar(-orient => "horizontal");

    $montantE = $frameD3->Entry(-highlightcolor => "red", -xscrollcommand => ['set' => $defil2] )
	->pack(		-fill => 'x',
			-expand => 1);
    $defil2->pack(-fill => 'x',
		  -expand => 1);
    $defil2->configure(-command => [$montantE => 'xview']);
    my $raz = $mainword2xml->Button(-text=>'RAZ', -activeforeground=>"blue",-relief=>'flat', -command=>\&viderMontant)->pack(-side=>'left', -padx=>5, -pady=>5);
    my $calcul = $mainword2xml->Button(-text=>'Word2Xml', -activeforeground=>"blue",-relief=>'flat', -command=>\&loadword2xml)->pack(-side=>'left', -padx=>5, -pady=>5);
    my $help = $mainword2xml->Button(-text=>'Help', -activeforeground=>"blue",-relief=>'flat', -command=>\&helpword2xml)->pack(-side=>'right', -padx=>5, -pady=>5);
    my $fin = $mainword2xml->Button(-text=>'Exit', -activeforeground=>"blue",-relief=>'flat', -command=>sub {$mainword2xml->destroy()})->pack(-side=>'right', -padx=>5, -pady=>5);
    my $calcul2 = $mainword2xml->Button(-width=>40, -text=>'Word2Xml-Concat',-activeforeground=>"blue",-relief=>'flat',  -command=>\&loadword2xml2)->pack(-side=>'right',  -fill=>'x', -expand =>1);


}
#---------------------------------------------------------
sub loadword2xml {
    &UpdateIndicators2;
    my $chemin=$montantF->get();
    my $cheminout=$montantE->get();
    if ($chemin ne "") {
	if ($chemin !~ /[\/\\]$/) { $chemin.="/"};
	if (!opendir(DIR, $chemin)) {
	    &mkPrintErreur("ERREUR : can't open $chemin: $!\n");
	    return;
	}
	my @files = readdir(DIR);
	closedir(DIR);
	if ($cheminout eq "") {
		$cheminout = $chemin;
	    }
	else {
	    if (!opendir(DIR2, $cheminout)) {
		&mkPrintErreur("ERREUR : can't open $cheminout: $!\n");
		return;
	    } 
	    if ($cheminout !~ /[\/\\]$/) { $cheminout.="/"};
	}
	my $filecount = 0;
	foreach my $file (@files) {
		$filecount++;
		next if $file =~ /^\.\.?$/;
		my $tmpfile=$file;
		$file = $chemin.$file;
		next if $file !~ /\.doc$/i;
		if (-f $file) {
		    my $fileOut = $cheminout."".$tmpfile."-conv2xml.xml";
		    open(OUT,">$fileOut");
		    print OUT "<?xml version=\"1.0\" encoding=\"ISO-8859-1\" standalone=\"yes\"?>\n";
		    print OUT "<document>\n";
		    print OUT "<fileWordInput>\n<name>$file</name>\n";
		    my ($word) = Win32::OLE->new('Word.Application', 'Quit') ||
			die "Couldn't run Word";
		    my ($doc)  = $word->Documents->Open($file);
		    my ($index) = 0;
		    for my $paragraph (in $doc->Paragraphs) {
			$index++;
			# Remove trailing ^M (the paragraph marker) from Range.
			my ($text) = substr($paragraph->Range->Text, 0, -1);
			print OUT "<paragraphe number=\"$index\">\n<content>$text</content>\n</paragraphe>\n";
		    }
		    $doc->{Saved} = 1;
		    $doc->Close;
		    print OUT "</fileWordInput>\n</document>\n";
		    close(OUT);
		}
		
	    }
	&mkPrintMsgInfo("Conversion termine dans : $cheminout \n");
    }
    else {
	&mkPrintErreur("ERREUR : impossible d\'accder au rpertoire $chemin\n");
	return;
    }
}
#---------------------------------------------------------
sub loadword2xml2 {
    &UpdateIndicators2;
    my $chemin=$montantF->get();
    my $cheminout=$montantE->get();
    if ($chemin ne "") {
	if ($chemin !~ /[\/\\]$/) { $chemin.="/"};
	if (!opendir(DIR, $chemin)) {
	    &mkPrintErreur("ERREUR : can't open $chemin: $!\n");
	    return;
	}
	my @files = readdir(DIR);
	closedir(DIR);
	if ($cheminout eq "") {
		$cheminout = $chemin;
	    }
	else {
	    if (!opendir(DIR2, $cheminout)) {
		&mkPrintErreur("ERREUR : can't open $cheminout: $!\n");
		return;
	    } 
	    if ($cheminout !~ /[\/\\]$/) { $cheminout.="/"};
	}
	my $filecount = 0;
	my $fileOut = $cheminout."concat_and_conversion2xml.xml";
	open(OUT,">$fileOut");
	print OUT "<?xml version=\"1.0\" encoding=\"ISO-8859-1\" standalone=\"yes\"?>\n";
	print OUT "<document>\n";
	foreach my $file (@files) {
		$filecount++;
		next if $file =~ /^\.\.?$/;
		my $tmpfile=$file;
		$file = $chemin.$file;
		next if $file !~ /\.doc$/i;
		if (-f $file) {
		    print OUT "<fileWordInput>\n<name>$file</name>\n";		    
		    my ($word) = Win32::OLE->new('Word.Application', 'Quit') ||
			die "Couldn't run Word";
		    my ($doc)  = $word->Documents->Open($file);
		    my($index) = 0;
		    for my $paragraph (in $doc->Paragraphs) {
			$index++;
			# Remove trailing ^M (the paragraph marker) from Range.
			my($text) = substr($paragraph->Range->Text, 0, -1);
			print OUT "<paragraphe number=\"$index\">\n<content>$text</content>\n</paragraphe>\n";
		    }
		    $doc->{Saved} = 1;
		    $doc->Close;
		    print OUT "</fileWordInput>\n";		    
		}
	    }
	 print OUT "</document>\n";
	 close(OUT);
	&mkPrintMsgInfo("Conversion et concatnation termines dans : $fileOut \n");
    }
    else {
	&mkPrintErreur("ERREUR : impossible d\'accder au rpertoire $chemin\n");
	return;
    }
}
#---------------------------------------------------------
sub loadword2txt {
    &UpdateIndicators2;
    my $chemin=$montantF->get();
    my $cheminout=$montantE->get();
    if ($chemin ne "") {
	if ($chemin !~ /[\/\\]$/) { $chemin.="/"};
	if (!opendir(DIR, $chemin)) {
	    &mkPrintErreur("ERREUR : can't open $chemin: $!\n");
	    return;
	}
	my @files = readdir(DIR);
	closedir(DIR);
	if ($cheminout eq "") {
		$cheminout = $chemin;
	    }
	else {
	    if (!opendir(DIR2, $cheminout)) {
		&mkPrintErreur("ERREUR : can't open $cheminout: $!\n");
		return;
	    } 
	    if ($cheminout !~ /[\/\\]$/) { $cheminout.="/"};
	}
	my $filecount = 0;
	foreach my $file (@files) {
		$filecount++;
		next if $file =~ /^\.\.?$/;
		my $tmpfile=$file;
		$file = $chemin.$file;
		next if $file !~ /\.doc$/i;
		if (-f $file) {
		    my $fileOut = $cheminout."".$tmpfile."-conv2Lexico3.txt";
		    open(OUT,">$fileOut");
		    my ($word) = Win32::OLE->new('Word.Application', 'Quit') ||
			die "Couldn't run Word";
		    my ($doc)  = $word->Documents->Open($file);
		    my($index) = 0;
		    for my $paragraph (in $doc->Paragraphs) {
			$index++;
			# Remove trailing ^M (the paragraph marker) from Range.
			my($text) = substr($paragraph->Range->Text, 0, -1);
			print OUT "<paragraphe=\"$index\">\n $text\n";
		    }
		    $doc->{Saved} = 1;
		    $doc->Close;
		    close(OUT);
		}
		
	    }
	&mkPrintMsgInfo("Conversion termine dans : $cheminout \n");
    }
    else {
	&mkPrintErreur("ERREUR : impossible d\'accder au rpertoire $chemin\n");
	return;
    }
}
#---------------------------------------------------------
sub loadword2txt2 {
&UpdateIndicators2;
    my $chemin=$montantF->get();
    my $cheminout=$montantE->get();
    if ($chemin ne "") {
	if ($chemin !~ /[\/\\]$/) { $chemin.="/"};
	if (!opendir(DIR, $chemin)) {
	    &mkPrintErreur("ERREUR : can't open $chemin: $!\n");
	    return;
	}
	my @files = readdir(DIR);
	closedir(DIR);
	if ($cheminout eq "") {
		$cheminout = $chemin;
	    }
	else {
	    if (!opendir(DIR2, $cheminout)) {
		&mkPrintErreur("ERREUR : can't open $cheminout: $!\n");
		return;
	    } 
	    if ($cheminout !~ /[\/\\]$/) { $cheminout.="/"};
	}
	my $filecount = 0;
	my $fileOut = $cheminout."concat_and_conversion2Lexico3.txt";
	open(OUT,">$fileOut");
	foreach my $file (@files) {
		$filecount++;
		next if $file =~ /^\.\.?$/;
		my $tmpfile=$file;
		$file = $chemin.$file;
		next if $file !~ /\.doc$/i;
		if (-f $file) {
		    my ($word) = Win32::OLE->new('Word.Application', 'Quit') ||
			die "Couldn't run Word";
		    my ($doc)  = $word->Documents->Open($file);
		    my($index) = 0;
		    print OUT "<file=\"$file\">\n";
		    for my $paragraph (in $doc->Paragraphs) {
			$index++;
			# Remove trailing ^M (the paragraph marker) from Range.
			my($text) = substr($paragraph->Range->Text, 0, -1);
			print OUT "<paragraphe=\"$index\">\n $text\n";
		    }
		    $doc->{Saved} = 1;
		    $doc->Close;
		   
		}
		
	    }
	 close(OUT);
	&mkPrintMsgInfo("Conversion et concatnation termines dans : $fileOut \n");
    }
    else {
	&mkPrintErreur("ERREUR : impossible d\'accder au rpertoire $chemin\n");
	return;
    }
}
#---------------------------------------------------------
sub readCharInText {
&UpdateIndicators2;

my $AlphaNumerique               = "A-Za-z0-9a-z" ;
my $Accentues                    = "" ;
my $Ponctuation                  = "\[\"{}&~@=*?!;,():<>%\' \+_\/.-" ;
my $Speciaux                     = "\t\r\n" ;
my %CaractereNonPrevu2Frequence  = () ;
my %Caractere2Frequence  = () ;
my %Caractere2Frequence2  = () ;

if (!open(AVERIFIER,"$winMain::nom_fic")) {
    &mkPrintErreur("ERREUR : Impossible d\'ouvrir '$winMain::nom_fic'\n");
    return;
}

while ($Ligne = <AVERIFIER>){
    $Ligne1 = "$Ligne";
    $Ligne1 =~ s/[$AlphaNumerique$Accentues$Speciaux$Ponctuation]//g ;
    my @ListeCaracteresLus = split(//, $Ligne);
    my @ListeCaracteresLus2 = unpack("C*",$Ligne);

    foreach $CaractereLu (@ListeCaracteresLus) {
	$Caractere2Frequence{$CaractereLu}++ ;
    }
    foreach $CaractereLu (@ListeCaracteresLus2) {
	$Caractere2Frequence2{$CaractereLu}++ ;
    }
    my @ListeCaracteresNonPrevus = split(//, $Ligne1) ;
    foreach $CaractereNonPrevu (@ListeCaracteresNonPrevus) {
	$CaractereNonPrevu2Frequence{$CaractereNonPrevu}++ ;
    }
    
}
close(AVERIFIER) ;

$FichierCaracteresNonPrevus = $winMain::nom_fic .  ".VerifieCaracteres" ;
$FichierCaracteres = $winMain::nom_fic .  ".Caracteres" ;
$FichierAscii = $winMain::nom_fic .  ".Ascii" ;

if (!open(CARACTERES, ">$FichierCaracteresNonPrevus")) {
    &mkPrintErreur("ERREUR : Impossible d\'ouvrir '$FichierCaracteresNonPrevus'\n");
    return;
}
if (!open(CARACTERES1, ">$FichierCaracteres")) {
    &mkPrintErreur("ERREUR : Impossible d\'ouvrir '$FichierCaracteres'\n");
    return;
}
if (!open(CARACTERES2, ">$FichierAscii")) {
    &mkPrintErreur("ERREUR : Impossible d\'ouvrir '$FichierCaracteres'\n");
    return;
}

foreach $CaractereNonPrevu (sort { $CaractereNonPrevu2Frequence{$b} <=> $CaractereNonPrevu2Frequence{$a} } keys %CaractereNonPrevu2Frequence)
{print CARACTERES "$CaractereNonPrevu<>$CaractereNonPrevu2Frequence{$CaractereNonPrevu}\n" ;
}
foreach $CaractereLu (sort { $Caractere2Frequence2{$b} <=> $Caractere2Frequence2{$a} } keys %Caractere2Frequence2)
{print CARACTERES2 "$CaractereLu<>$Caractere2Frequence2{$CaractereLu}\n" ;
}
foreach $CaractereLu (sort { $Caractere2Frequence{$b} <=> $Caractere2Frequence{$a} } keys %Caractere2Frequence){
    if ($CaractereLu =~ /\n/){
	print CARACTERES1 "\\n<>$Caractere2Frequence{$CaractereLu}\n" ;
    }
    elsif ($CaractereLu =~ /\t/) {
	print CARACTERES1 "\\t<>$Caractere2Frequence{$CaractereLu}\n" ;
    }
    elsif ($CaractereLu =~ /\r/) {
	print CARACTERES1 "\\r<>$Caractere2Frequence{$CaractereLu}\n" ;
    }
    else {
	print CARACTERES1 "$CaractereLu<>$Caractere2Frequence{$CaractereLu}\n" ;
    }
}

close(CARACTERES) ;
close(CARACTERES1) ;
close(CARACTERES2) ;

my $tmpfile=$winMain::nom_fic .  ".VerifieCaracteres" ;
my $msg="Caractres non reconnus dans : ". $winMain::nom_fic .  ".VerifieCaracteres" ;
&IncludedFileInWindow($tmpfile,$msg);
my $tmpfile=$winMain::nom_fic .  ".Caracteres" ;
my $msg="Caractres lus dans : ".$winMain::nom_fic .  ".Caracteres" ;
&IncludedFileInWindow($tmpfile,$msg);
my $tmpfile=$winMain::nom_fic .  ".Ascii" ;
my $msg="Caractres ascii lus dans : ".$winMain::nom_fic .  ".Ascii" ;
&IncludedFileInWindow($tmpfile,$msg);

}
#---------------------------------------------
sub changeCharInText {
&UpdateIndicators2;

    if (! Exists ($pnChangeChar)) {
	$pnChangeChar = $winMain::mw ->Toplevel();
	$pnChangeChar->title("Choose Char");
	$listePnChangeChar=$pnChangeChar->Scrolled("Listbox", -scrollbars => "e",
			      -selectmode => "extended",
			      -selectforeground => "red",
			      -setgrid => 1,
			      -width => -1)->pack();

	$pnChangeChar->Button(-text => "Delete",
		     -command =>  \&delete_selected_char)->pack(-side => 'left', -pady => 5, -padx => 10);
	$pnChangeChar->Button(-text => "Modify",
		     -command =>  \&modify_selected_char)->pack(-side => 'left', -pady => 5, -padx => 10);
	$pnChangeChar->Button(-text => "Search",
		     -command =>  \&concordance_char)->pack(-side => 'left', -pady => 5, -padx => 10);
	$pnChangeChar->Button(-text => "Close",
		     -command =>  sub {$pnChangeChar->destroy()})->pack(-side => 'left', -pady => 5, -padx => 10);

	my @liste_char= ();

	$FichierCaracteres = $winMain::nom_fic .  ".Caracteres" ;

	if (!open(TMPFILE, "$FichierCaracteres")) {
	    &mkPrintErreur("ERREUR : Impossible d\'ouvrir '$FichierCaracteres'\n, ce fichier est gnr par l'item Read Char\n");
	    return;
	}
	my $id=0;
	while(<TMPFILE>) {
	    chomp;
	    if ($_=~/^(.*)<>(.*)/) {
		$liste_char[$id]=$1;
		$id++;
	    }
	}
	close(TMPFILE);
	$listePnChangeChar->delete(0,'end');
	$listePnChangeChar->insert('end',@liste_char);

    }
    else {
	$pnChangeChar->deiconify();
	$pnChangeChar->raise();
    }



}
#---------------------------------------------
sub changeUnrocognizedCharInText {
&UpdateIndicators2;

    if (! Exists ($pnChangeUnrocognizedChar)) {
	$pnChangeUnrocognizedChar = $winMain::mw ->Toplevel();
	$pnChangeUnrocognizedChar->title("Choose Char");
	$listePnChangeUnrocognizedChar=$pnChangeUnrocognizedChar->Scrolled("Listbox", -scrollbars => "e",
			      -selectmode => "extended",
			      -selectforeground => "red",
			      -setgrid => 1,
			      -width => -1)->pack();

	$pnChangeUnrocognizedChar->Button(-text => "Delete",
		     -command =>  \&delete_selected_Unrochognizedchar)->pack(-side => 'left', -pady => 5, -padx => 10);
	$pnChangeUnrocognizedChar->Button(-text => "Modify",
		     -command =>  \&modify_selected_Unrochognizedchar)->pack(-side => 'left', -pady => 5, -padx => 10);
	$pnChangeUnrocognizedChar->Button(-text => "Search",
		     -command =>  \&concordance_Unrochognizedchar)->pack(-side => 'left', -pady => 5, -padx => 10);
	$pnChangeUnrocognizedChar->Button(-text => "Close",
		     -command =>  sub {$pnChangeUnrocognizedChar->destroy()})->pack(-side => 'left', -pady => 5, -padx => 10);

	my @liste_char= ();

	$FichierCaracteres = $winMain::nom_fic .  ".VerifieCaracteres" ;

	if (!open(TMPFILE, "$FichierCaracteres")) {
	    &mkPrintErreur("ERREUR : Impossible d\'ouvrir '$FichierCaracteres'\n, ce fichier est gnr par l'item Read Char\n");
	    return;
	}
	my $id=0;
	while(<TMPFILE>) {
	    chomp;
	    if ($_=~/^(.*)<>(.*)/) {
		$liste_char[$id]=$1;
		$id++;
	    }
	}
	close(TMPFILE);
	$listePnChangeUnrocognizedChar->delete(0,'end');
	$listePnChangeUnrocognizedChar->insert('end',@liste_char);

    }
    else {
	$pnChangeUnrocognizedChar->deiconify();
	$pnChangeUnrocognizedChar->raise();
    }



}
#---------------------------------------------

sub transcodeurTk {
&UpdateIndicators2;
    if (!open(TMPFILE,"$winMain::nom_fic")) {
	&mkPrintErreur("ERREUR : Impossible d\'ouvrir '$winMain::nom_fic'\n");
	return;
    }
    my @TableButton=();
    my %liste_charInput=();
    while($ligne=<TMPFILE>) {
	chop($ligne);
	my @ListeCaracteresLus = split(//, $ligne);
	my @ListeCaracteresLus2 = unpack("C*",$ligne);
	foreach my $ind (@ListeCaracteresLus2) {
	    $liste_charInput{$ind}++;
	}
    }
    foreach  my $char (keys %liste_charInput) {
	push(@TableButton,$char);  
    }

    &makeTableForTranscodeurTk(\@TableButton);
    close(TMPFILE);
}


#---------------------------------------------------------------------------------------
sub makeTableForTranscodeurTk {
&UpdateIndicators2;

    my ($TableButton1)=shift;
    my @TableButton=@$TableButton1;
    $windowTranscodeurTk = $winMain::mw ->Toplevel(-title=>'Table de caractre');
    my $frameG = $windowTranscodeurTk->Frame()->pack();
    my $frameM= $windowTranscodeurTk->Frame()->pack();
    my $frame1 = $frameG->Frame()->pack(-side=>'left', -pady=>5);
    my $frame2 = $frameG->Frame()->pack(-side=>'left', -pady=>5);
    my $frame3 = $frameG->Frame()->pack(-side=>'left', -pady=>5);
    my $frame4 = $frameG->Frame()->pack(-side=>'left', -pady=>5);
    my $frame5 = $frameG->Frame()->pack(-side=>'left', -pady=>5);
    my $frame6 = $frameG->Frame()->pack(-side=>'left', -pady=>5);
    my $frame7 = $frameG->Frame()->pack(-side=>'left', -pady=>5);
    my $frame8 = $frameG->Frame()->pack(-side=>'left', -pady=>5);
    my $frame9 = $frameG->Frame()->pack(-side=>'left', -pady=>5);
    my $frame10 = $frameG->Frame()->pack(-side=>'left', -pady=>5);
    my $frameb1 = $frameG->Frame()->pack(-side=>'left', -pady=>5);
    my $frameb2 = $frameG->Frame()->pack(-side=>'left', -pady=>5);
    my $frameb3 = $frameG->Frame()->pack(-side=>'left', -pady=>5);
    my $frameb4 = $frameG->Frame()->pack(-side=>'left', -pady=>5);
    my $frameb5 = $frameG->Frame()->pack(-side=>'left', -pady=>5);
    my $frameb6 = $frameG->Frame()->pack(-side=>'left', -pady=>5);
    my $frameb7 = $frameG->Frame()->pack(-side=>'left', -pady=>5);
    my $frameb8 = $frameG->Frame()->pack(-side=>'left', -pady=>5);
    my $frameb9 = $frameG->Frame()->pack(-side=>'left', -pady=>5);
    my $frameb10 = $frameG->Frame()->pack(-side=>'left', -pady=>5);
    my $framec1 = $frameG->Frame()->pack(-side=>'left', -pady=>5);
    my $framec2 = $frameG->Frame()->pack(-side=>'left', -pady=>5);
    my $framec3 = $frameG->Frame()->pack(-side=>'left', -pady=>5);
    my $framec4 = $frameG->Frame()->pack(-side=>'left', -pady=>5);
    my $framec5 = $frameG->Frame()->pack(-side=>'left', -pady=>5);
    my $framec6 = $frameG->Frame()->pack(-side=>'left', -pady=>5);
    my $framec7 = $frameG->Frame()->pack(-side=>'left', -pady=>5);
    my $framec8 = $frameG->Frame()->pack(-side=>'left', -pady=>5);
    my $framec9 = $frameG->Frame()->pack(-side=>'left', -pady=>5);
    my $framec10 = $frameG->Frame()->pack(-side=>'left', -pady=>5);
    my $frame11 = $frameG->Frame()->pack(-side=>'left', -pady=>5);
    

    my $varBouton11; my $varBouton12; my $varBouton13; my $varBouton14; my $varBouton15; my $varBouton16; my $varBouton17; my $varBouton18; my $varBouton19; my $varBouton110; my $varBouton111; my $varBouton112; my $varBouton113; my $varBouton114; my $varBouton115; my $varBouton116; my $varBouton117; my $varBouton118; my $varBouton119; my $varBouton120; my $varBouton21; my $varBouton22; my $varBouton23; my $varBouton24; my $varBouton25; my $varBouton26; my $varBouton27; my $varBouton28; my $varBouton29; my $varBouton210; my $varBouton211; my $varBouton212; my $varBouton213; my $varBouton214; my $varBouton215; my $varBouton216; my $varBouton217; my $varBouton218; my $varBouton219; my $varBouton220; my $varBouton31; my $varBouton32; my $varBouton33; my $varBouton34; my $varBouton35; my $varBouton36; my $varBouton37; my $varBouton38; my $varBouton39; my $varBouton310; my $varBouton311; my $varBouton312; my $varBouton313; my $varBouton314; my $varBouton315; my $varBouton316; my $varBouton317; my $varBouton318; my $varBouton319; my $varBouton320; my $varBouton41; my $varBouton42; my $varBouton43; my $varBouton44; my $varBouton45; my $varBouton46; my $varBouton47; my $varBouton48; my $varBouton49; my $varBouton410; my $varBouton411; my $varBouton412; my $varBouton413; my $varBouton414; my $varBouton415; my $varBouton416; my $varBouton417; my $varBouton418; my $varBouton419; my $varBouton420; my $varBouton51; my $varBouton52; my $varBouton53; my $varBouton54; my $varBouton55; my $varBouton56; my $varBouton57; my $varBouton58; my $varBouton59; my $varBouton510; my $varBouton511; my $varBouton512; my $varBouton513; my $varBouton514; my $varBouton515; my $varBouton516; my $varBouton517; my $varBouton518; my $varBouton519; my $varBouton520; my $varBouton61; my $varBouton62; my $varBouton63; my $varBouton64; my $varBouton65; my $varBouton66; my $varBouton67; my $varBouton68; my $varBouton69; my $varBouton610; my $varBouton611; my $varBouton612; my $varBouton613; my $varBouton614; my $varBouton615; my $varBouton616; my $varBouton617; my $varBouton618; my $varBouton619; my $varBouton620; my $varBouton71; my $varBouton72; my $varBouton73; my $varBouton74; my $varBouton75; my $varBouton76; my $varBouton77; my $varBouton78; my $varBouton79; my $varBouton710; my $varBouton711; my $varBouton712; my $varBouton713; my $varBouton714; my $varBouton715; my $varBouton716; my $varBouton717; my $varBouton718; my $varBouton719; my $varBouton720; my $varBouton81; my $varBouton82; my $varBouton83; my $varBouton84; my $varBouton85; my $varBouton86; my $varBouton87; my $varBouton88; my $varBouton89; my $varBouton810; my $varBouton811; my $varBouton812; my $varBouton813; my $varBouton814; my $varBouton815; my $varBouton816; my $varBouton817; my $varBouton818; my $varBouton819; my $varBouton820; my $varBouton91; my $varBouton92; my $varBouton93; my $varBouton94; my $varBouton95; my $varBouton96; my $varBouton97; my $varBouton98; my $varBouton99; my $varBouton910; my $varBouton911; my $varBouton912; my $varBouton913; my $varBouton914; my $varBouton915; my $varBouton916; my $varBouton917; my $varBouton918; my $varBouton919; my $varBouton920; my $varBoutona11; my $varBoutona12; my $varBoutona13; my $varBoutona14; my $varBoutona15; my $varBoutona16; my $varBoutona17; my $varBoutona18; my $varBoutona19; my $varBoutona110; my $varBoutona111; my $varBoutona112; my $varBoutona113; my $varBoutona114; my $varBoutona115; my $varBoutona116; my $varBoutona117; my $varBoutona118; my $varBoutona119; my $varBoutona120; my $varBoutona21; my $varBoutona22; my $varBoutona23; my $varBoutona24; my $varBoutona25; my $varBoutona26; my $varBoutona27; my $varBoutona28; my $varBoutona29; my $varBoutona210; my $varBoutona211; my $varBoutona212; my $varBoutona213; my $varBoutona214; my $varBoutona215; my $varBoutona216; my $varBoutona217; my $varBoutona218; my $varBoutona219; my $varBoutona220; my $varBoutona31; my $varBoutona32; my $varBoutona33; my $varBoutona34; my $varBoutona35; my $varBoutona36; my $varBoutona37; my $varBoutona38; my $varBoutona39; my $varBoutona310; my $varBoutona311; my $varBoutona312; my $varBoutona313; my $varBoutona314; my $varBoutona315; my $varBoutona316; my $varBoutona317; my $varBoutona318; my $varBoutona319; my $varBoutona320; my $varBoutona41; my $varBoutona42; my $varBoutona43; my $varBoutona44; my $varBoutona45; my $varBoutona46; my $varBoutona47; my $varBoutona48; my $varBoutona49; my $varBoutona410; my $varBoutona411; my $varBoutona412; my $varBoutona413; my $varBoutona414; my $varBoutona415; my $varBoutona416; my $varBoutona417; my $varBoutona418; my $varBoutona419; my $varBoutona420; my $varBoutona51; my $varBoutona52; my $varBoutona53; my $varBoutona54; my $varBoutona55; my $varBoutona56; my $varBoutona57; my $varBoutona58; my $varBoutona59; my $varBoutona510; my $varBoutona511; my $varBoutona512; my $varBoutona513; my $varBoutona514; my $varBoutona515; my $varBoutona516; my $varBoutona517; my $varBoutona518; my $varBoutona519; my $varBoutona520; my $varBoutona61; my $varBoutona62; my $varBoutona63; my $varBoutona64; my $varBoutona65; my $varBoutona66; my $varBoutona67; my $varBoutona68; my $varBoutona69; my $varBoutona610; my $varBoutona611; my $varBoutona612; my $varBoutona613; my $varBoutona614; my $varBoutona615; my $varBoutona616; my $varBoutona617; my $varBoutona618; my $varBoutona619; my $varBoutona620; my $varBoutona71; my $varBoutona72; my $varBoutona73; my $varBoutona74; my $varBoutona75; my $varBoutona76; my $varBoutona77; my $varBoutona78; my $varBoutona79; my $varBoutona710; my $varBoutona711; my $varBoutona712; my $varBoutona713; my $varBoutona714; my $varBoutona715; my $varBoutona716; my $varBoutona717; my $varBoutona718; my $varBoutona719; my $varBoutona720; my $varBoutona81; my $varBoutona82; my $varBoutona83; my $varBoutona84; my $varBoutona85; my $varBoutona86; my $varBoutona87; my $varBoutona88; my $varBoutona89; my $varBoutona810; my $varBoutona811; my $varBoutona812; my $varBoutona813; my $varBoutona814; my $varBoutona815; my $varBoutona816; my $varBoutona817; my $varBoutona818; my $varBoutona819; my $varBoutona820; my $varBoutona91; my $varBoutona92; my $varBoutona93; my $varBoutona94; my $varBoutona95; my $varBoutona96; my $varBoutona97; my $varBoutona98; my $varBoutona99; my $varBoutona910; my $varBoutona911; my $varBoutona912; my $varBoutona913; my $varBoutona914; my $varBoutona915; my $varBoutona916; my $varBoutona917; my $varBoutona918; my $varBoutona919; my $varBoutona920; my $varBoutonb11; my $varBoutonb12; my $varBoutonb13; my $varBoutonb14; my $varBoutonb15; my $varBoutonb16; my $varBoutonb17; my $varBoutonb18; my $varBoutonb19; my $varBoutonb110; my $varBoutonb111; my $varBoutonb112; my $varBoutonb113; my $varBoutonb114; my $varBoutonb115; my $varBoutonb116; my $varBoutonb117; my $varBoutonb118; my $varBoutonb119; my $varBoutonb120; my $varBoutonb21; my $varBoutonb22; my $varBoutonb23; my $varBoutonb24; my $varBoutonb25; my $varBoutonb26; my $varBoutonb27; my $varBoutonb28; my $varBoutonb29; my $varBoutonb210; my $varBoutonb211; my $varBoutonb212; my $varBoutonb213; my $varBoutonb214; my $varBoutonb215; my $varBoutonb216; my $varBoutonb217; my $varBoutonb218; my $varBoutonb219; my $varBoutonb220; my $varBoutonb31; my $varBoutonb32; my $varBoutonb33; my $varBoutonb34; my $varBoutonb35; my $varBoutonb36; my $varBoutonb37; my $varBoutonb38; my $varBoutonb39; my $varBoutonb310; my $varBoutonb311; my $varBoutonb312; my $varBoutonb313; my $varBoutonb314; my $varBoutonb315; my $varBoutonb316; my $varBoutonb317; my $varBoutonb318; my $varBoutonb319; my $varBoutonb320; my $varBoutonb41; my $varBoutonb42; my $varBoutonb43; my $varBoutonb44; my $varBoutonb45; my $varBoutonb46; my $varBoutonb47; my $varBoutonb48; my $varBoutonb49; my $varBoutonb410; my $varBoutonb411; my $varBoutonb412; my $varBoutonb413; my $varBoutonb414; my $varBoutonb415; my $varBoutonb416; my $varBoutonb417; my $varBoutonb418; my $varBoutonb419; my $varBoutonb420; my $varBoutonb51; my $varBoutonb52; my $varBoutonb53; my $varBoutonb54; my $varBoutonb55; my $varBoutonb56; my $varBoutonb57; my $varBoutonb58; my $varBoutonb59; my $varBoutonb510; my $varBoutonb511; my $varBoutonb512; my $varBoutonb513; my $varBoutonb514; my $varBoutonb515; my $varBoutonb516; my $varBoutonb517; my $varBoutonb518; my $varBoutonb519; my $varBoutonb520; my $varBoutonb61; my $varBoutonb62; my $varBoutonb63; my $varBoutonb64; my $varBoutonb65; my $varBoutonb66; my $varBoutonb67; my $varBoutonb68; my $varBoutonb69; my $varBoutonb610; my $varBoutonb611; my $varBoutonb612; my $varBoutonb613; my $varBoutonb614; my $varBoutonb615; my $varBoutonb616; my $varBoutonb617; my $varBoutonb618; my $varBoutonb619; my $varBoutonb620; my $varBoutonb71; my $varBoutonb72; my $varBoutonb73; my $varBoutonb74; my $varBoutonb75; my $varBoutonb76; my $varBoutonb77; my $varBoutonb78; my $varBoutonb79; my $varBoutonb710; my $varBoutonb711; my $varBoutonb712; my $varBoutonb713; my $varBoutonb714; my $varBoutonb715; my $varBoutonb716; my $varBoutonb717; my $varBoutonb718; my $varBoutonb719; my $varBoutonb720; my $varBoutonb81; my $varBoutonb82; my $varBoutonb83; my $varBoutonb84; my $varBoutonb85; my $varBoutonb86; my $varBoutonb87; my $varBoutonb88; my $varBoutonb89; my $varBoutonb810; my $varBoutonb811; my $varBoutonb812; my $varBoutonb813; my $varBoutonb814; my $varBoutonb815; my $varBoutonb816; my $varBoutonb817; my $varBoutonb818; my $varBoutonb819; my $varBoutonb820; my $varBoutonb91; my $varBoutonb92; my $varBoutonb93; my $varBoutonb94; my $varBoutonb95; my $varBoutonb96; my $varBoutonb97; my $varBoutonb98; my $varBoutonb99; my $varBoutonb910; my $varBoutonb911; my $varBoutonb912; my $varBoutonb913; my $varBoutonb914; my $varBoutonb915; my $varBoutonb916; my $varBoutonb917; my $varBoutonb918; my $varBoutonb919; my $varBoutonb920; my $varBoutonLeg1; my $varBoutonLeg2 ;

    my @selectedBouttons=[];

    my $tmpButt;
    if (scalar @TableButton >  0) {
	$tmpButt=shift(@TableButton);
	$tmpButt=chr($tmpButt);
	my $bouton11=$frame1->Checkbutton(-onvalue=>$tmpButt, -offvalue=>$transcodeurTkReplaceChar, -text=>$tmpButt, -variable => \$varBouton11, -relief => 'flat')->pack();
	$bouton11->select;
	push(@selectedBouttons,$bouton11);
    }

    if (scalar @TableButton >  0) {
	$tmpButt=shift(@TableButton);
	$tmpButt=chr($tmpButt);
	my $bouton12=$frame1->Checkbutton(-onvalue=>$tmpButt, -offvalue=>$transcodeurTkReplaceChar, -text=>$tmpButt, -variable => \$varBouton12, -relief => 'flat')->pack();
	$bouton12->select;
	push(@selectedBouttons,$bouton12);
    }
    if (scalar @TableButton >  0) {
	$tmpButt=shift(@TableButton);
	$tmpButt=chr($tmpButt);
	my $bouton13=$frame1->Checkbutton(-onvalue=>$tmpButt, -offvalue=>$transcodeurTkReplaceChar, -text=>$tmpButt, -variable => \$varBouton13, -relief => 'flat')->pack();
	$bouton13->select;
	push(@selectedBouttons,$bouton13);
    }
    if (scalar @TableButton >  0) {
	$tmpButt=shift(@TableButton);
	$tmpButt=chr($tmpButt);
	my $bouton14=$frame1->Checkbutton(-onvalue=>$tmpButt, -offvalue=>$transcodeurTkReplaceChar, -text=>$tmpButt, -variable => \$varBouton14, -relief => 'flat')->pack();
	$bouton14->select;
	push(@selectedBouttons,$bouton14);
    }
    if (scalar @TableButton >  0) {
	$tmpButt=shift(@TableButton);
	$tmpButt=chr($tmpButt);
	my $bouton15=$frame1->Checkbutton(-onvalue=>$tmpButt, -offvalue=>$transcodeurTkReplaceChar, -text=>$tmpButt, -variable => \$varBouton15, -relief => 'flat')->pack();
	$bouton15->select;
	push(@selectedBouttons,$bouton15);
    }
    if (scalar @TableButton >  0) {
	$tmpButt=shift(@TableButton);
	$tmpButt=chr($tmpButt);
	my $bouton16=$frame1->Checkbutton(-onvalue=>$tmpButt, -offvalue=>$transcodeurTkReplaceChar, -text=>$tmpButt, -variable => \$varBouton16, -relief => 'flat')->pack();
	$bouton16->select;
	push(@selectedBouttons,$bouton16);
    }
    if (scalar @TableButton >  0) {
	$tmpButt=shift(@TableButton);
	$tmpButt=chr($tmpButt);
	my $bouton17=$frame1->Checkbutton(-onvalue=>$tmpButt, -offvalue=>$transcodeurTkReplaceChar, -text=>$tmpButt, -variable => \$varBouton17, -relief => 'flat')->pack();
	$bouton17->select;
	push(@selectedBouttons,$bouton17);
    }
    if (scalar @TableButton >  0) {
	$tmpButt=shift(@TableButton);
	$tmpButt=chr($tmpButt);
	my $bouton18=$frame1->Checkbutton(-onvalue=>$tmpButt, -offvalue=>$transcodeurTkReplaceChar, -text=>$tmpButt, -variable => \$varBouton18, -relief => 'flat')->pack();
	$bouton18->select;
	push(@selectedBouttons,$bouton18);
    }
    if (scalar @TableButton >  0) {
	$tmpButt=shift(@TableButton);
	$tmpButt=chr($tmpButt);
	my $bouton19=$frame1->Checkbutton(-onvalue=>$tmpButt, -offvalue=>$transcodeurTkReplaceChar, -text=>$tmpButt, -variable => \$varBouton19, -relief => 'flat')->pack();
	$bouton19->select;
	push(@selectedBouttons,$bouton19);
    }
    if (scalar @TableButton >  0) {
	$tmpButt=shift(@TableButton);
	$tmpButt=chr($tmpButt);
	my $bouton110=$frame1->Checkbutton(-onvalue=>$tmpButt, -offvalue=>$transcodeurTkReplaceChar, -text=>$tmpButt, -variable => \$varBouton110, -relief => 'flat')->pack();
	$bouton110->select;
	push(@selectedBouttons,$bouton110);
    }
    if (scalar @TableButton >  0) {
	$tmpButt=shift(@TableButton);
	$tmpButt=chr($tmpButt);
	my $bouton111=$frame1->Checkbutton(-onvalue=>$tmpButt, -offvalue=>$transcodeurTkReplaceChar, -text=>$tmpButt, -variable => \$varBouton111, -relief => 'flat')->pack();
	$bouton111->select;
	push(@selectedBouttons,$bouton111);
    }
    if (scalar @TableButton >  0) {
	$tmpButt=shift(@TableButton);
	$tmpButt=chr($tmpButt);
	my $bouton112=$frame1->Checkbutton(-onvalue=>$tmpButt, -offvalue=>$transcodeurTkReplaceChar, -text=>$tmpButt, -variable => \$varBouton112, -relief => 'flat')->pack();
	$bouton112->select;
	push(@selectedBouttons,$bouton112);
    }
    if (scalar @TableButton >  0) {
	$tmpButt=shift(@TableButton);
	$tmpButt=chr($tmpButt);
	my $bouton113=$frame1->Checkbutton(-onvalue=>$tmpButt, -offvalue=>$transcodeurTkReplaceChar, -text=>$tmpButt, -variable => \$varBouton113, -relief => 'flat')->pack();
	$bouton113->select;
	push(@selectedBouttons,$bouton113);
    }
    if (scalar @TableButton >  0) {
	$tmpButt=shift(@TableButton);
	$tmpButt=chr($tmpButt);
	my $bouton114=$frame1->Checkbutton(-onvalue=>$tmpButt, -offvalue=>$transcodeurTkReplaceChar, -text=>$tmpButt, -variable => \$varBouton114, -relief => 'flat')->pack();
	$bouton114->select;
	push(@selectedBouttons,$bouton114);
    }
    if (scalar @TableButton >  0) {
	$tmpButt=shift(@TableButton);
	$tmpButt=chr($tmpButt);
	my $bouton115=$frame1->Checkbutton(-onvalue=>$tmpButt, -offvalue=>$transcodeurTkReplaceChar, -text=>$tmpButt, -variable => \$varBouton115, -relief => 'flat')->pack();
	$bouton115->select;
	push(@selectedBouttons,$bouton115);
    }
    if (scalar @TableButton >  0) {
	$tmpButt=shift(@TableButton);
	$tmpButt=chr($tmpButt);
	my $bouton116=$frame1->Checkbutton(-onvalue=>$tmpButt, -offvalue=>$transcodeurTkReplaceChar, -text=>$tmpButt, -variable => \$varBouton116, -relief => 'flat')->pack();
	$bouton116->select;
	push(@selectedBouttons,$bouton116);
    }
    if (scalar @TableButton >  0) {
	$tmpButt=shift(@TableButton);
	$tmpButt=chr($tmpButt);
	my $bouton117=$frame1->Checkbutton(-onvalue=>$tmpButt, -offvalue=>$transcodeurTkReplaceChar, -text=>$tmpButt, -variable => \$varBouton117, -relief => 'flat')->pack();
	$bouton117->select;
	push(@selectedBouttons,$bouton117);
    }
    if (scalar @TableButton >  0) {
	$tmpButt=shift(@TableButton);
	$tmpButt=chr($tmpButt);
	my $bouton118=$frame1->Checkbutton(-onvalue=>$tmpButt, -offvalue=>$transcodeurTkReplaceChar, -text=>$tmpButt, -variable => \$varBouton118, -relief => 'flat')->pack();
	$bouton118->select;
	push(@selectedBouttons,$bouton118);
    }
    if (scalar @TableButton >  0) {
	$tmpButt=shift(@TableButton);
	$tmpButt=chr($tmpButt);
	my $bouton119=$frame1->Checkbutton(-onvalue=>$tmpButt, -offvalue=>$transcodeurTkReplaceChar, -text=>$tmpButt, -variable => \$varBouton119, -relief => 'flat')->pack();
	$bouton119->select;
	push(@selectedBouttons,$bouton119);
    }
    if (scalar @TableButton >  0) {
	$tmpButt=shift(@TableButton);
	$tmpButt=chr($tmpButt);
	my $bouton120=$frame1->Checkbutton(-onvalue=>$tmpButt, -offvalue=>$transcodeurTkReplaceChar, -text=>$tmpButt, -variable => \$varBouton120, -relief => 'flat')->pack();
	$bouton120->select;
	push(@selectedBouttons,$bouton120);
    }
    if (scalar @TableButton >  0) {
	$tmpButt=shift(@TableButton);
	$tmpButt=chr($tmpButt);
	my $bouton21=$frame2->Checkbutton(-onvalue=>$tmpButt, -offvalue=>$transcodeurTkReplaceChar, -text=>$tmpButt, -variable => \$varBouton21, -relief => 'flat')->pack();
	$bouton21->select;
	push(@selectedBouttons,$bouton21);
    }
    if (scalar @TableButton >  0) {
	$tmpButt=shift(@TableButton);
	$tmpButt=chr($tmpButt);
	my $bouton22=$frame2->Checkbutton(-onvalue=>$tmpButt, -offvalue=>$transcodeurTkReplaceChar, -text=>$tmpButt, -variable => \$varBouton22, -relief => 'flat')->pack();
	$bouton22->select;
	push(@selectedBouttons,$bouton22);
    }
    if (scalar @TableButton >  0) {
	$tmpButt=shift(@TableButton);
	$tmpButt=chr($tmpButt);
	my $bouton23=$frame2->Checkbutton(-onvalue=>$tmpButt, -offvalue=>$transcodeurTkReplaceChar, -text=>$tmpButt, -variable => \$varBouton23, -relief => 'flat')->pack();
	$bouton23->select;
	push(@selectedBouttons,$bouton23);
    }
    if (scalar @TableButton >  0) {
	$tmpButt=shift(@TableButton);
	$tmpButt=chr($tmpButt);
	my $bouton24=$frame2->Checkbutton(-onvalue=>$tmpButt, -offvalue=>$transcodeurTkReplaceChar, -text=>$tmpButt, -variable => \$varBouton24, -relief => 'flat')->pack();
	$bouton24->select;
	push(@selectedBouttons,$bouton24);
    }
    if (scalar @TableButton >  0) {
	$tmpButt=shift(@TableButton);
	$tmpButt=chr($tmpButt);
	my $bouton25=$frame2->Checkbutton(-onvalue=>$tmpButt, -offvalue=>$transcodeurTkReplaceChar, -text=>$tmpButt, -variable => \$varBouton25, -relief => 'flat')->pack();
	$bouton25->select;
	push(@selectedBouttons,$bouton25);
    }
    if (scalar @TableButton >  0) {
	$tmpButt=shift(@TableButton);
	$tmpButt=chr($tmpButt);
	my $bouton26=$frame2->Checkbutton(-onvalue=>$tmpButt, -offvalue=>$transcodeurTkReplaceChar, -text=>$tmpButt, -variable => \$varBouton26, -relief => 'flat')->pack();
	$bouton26->select;
	push(@selectedBouttons,$bouton26);
    }
    if (scalar @TableButton >  0) {
	$tmpButt=shift(@TableButton);
	$tmpButt=chr($tmpButt);
	my $bouton27=$frame2->Checkbutton(-onvalue=>$tmpButt, -offvalue=>$transcodeurTkReplaceChar, -text=>$tmpButt, -variable => \$varBouton27, -relief => 'flat')->pack();
	$bouton27->select;
	push(@selectedBouttons,$bouton27);
    }
    if (scalar @TableButton >  0) {
	$tmpButt=shift(@TableButton);
	$tmpButt=chr($tmpButt);
	my $bouton28=$frame2->Checkbutton(-onvalue=>$tmpButt, -offvalue=>$transcodeurTkReplaceChar, -text=>$tmpButt, -variable => \$varBouton28, -relief => 'flat')->pack();
	$bouton28->select;
	push(@selectedBouttons,$bouton28);
    }
    if (scalar @TableButton >  0) {
	$tmpButt=shift(@TableButton);
	$tmpButt=chr($tmpButt);
	my $bouton29=$frame2->Checkbutton(-onvalue=>$tmpButt, -offvalue=>$transcodeurTkReplaceChar, -text=>$tmpButt, -variable => \$varBouton29, -relief => 'flat')->pack();
	$bouton29->select;
	push(@selectedBouttons,$bouton29);
    }
    if (scalar @TableButton >  0) {
	$tmpButt=shift(@TableButton);
	$tmpButt=chr($tmpButt);
	my $bouton210=$frame2->Checkbutton(-onvalue=>$tmpButt, -offvalue=>$transcodeurTkReplaceChar, -text=>$tmpButt, -variable => \$varBouton210, -relief => 'flat')->pack();
	$bouton210->select;
	push(@selectedBouttons,$bouton210);
    }
    if (scalar @TableButton >  0) {
	$tmpButt=shift(@TableButton);
	$tmpButt=chr($tmpButt);
	my $bouton211=$frame2->Checkbutton(-onvalue=>$tmpButt, -offvalue=>$transcodeurTkReplaceChar, -text=>$tmpButt, -variable => \$varBouton211, -relief => 'flat')->pack();
	$bouton211->select;
	push(@selectedBouttons,$bouton211);
    }
    if (scalar @TableButton >  0) {
	$tmpButt=shift(@TableButton);
	$tmpButt=chr($tmpButt);
	my $bouton212=$frame2->Checkbutton(-onvalue=>$tmpButt, -offvalue=>$transcodeurTkReplaceChar, -text=>$tmpButt, -variable => \$varBouton212, -relief => 'flat')->pack();
	$bouton212->select;
	push(@selectedBouttons,$bouton212);
    }
    if (scalar @TableButton >  0) {
	$tmpButt=shift(@TableButton);
	$tmpButt=chr($tmpButt);
	my $bouton213=$frame2->Checkbutton(-onvalue=>$tmpButt, -offvalue=>$transcodeurTkReplaceChar, -text=>$tmpButt, -variable => \$varBouton213, -relief => 'flat')->pack();
	$bouton213->select;
	push(@selectedBouttons,$bouton213);
    }
    if (scalar @TableButton >  0) {
	$tmpButt=shift(@TableButton);
	$tmpButt=chr($tmpButt);
	my $bouton214=$frame2->Checkbutton(-onvalue=>$tmpButt, -offvalue=>$transcodeurTkReplaceChar, -text=>$tmpButt, -variable => \$varBouton214, -relief => 'flat')->pack();
	$bouton214->select;
	push(@selectedBouttons,$bouton214);
    }
    if (scalar @TableButton >  0) {
	$tmpButt=shift(@TableButton);
	$tmpButt=chr($tmpButt);
	my $bouton215=$frame2->Checkbutton(-onvalue=>$tmpButt, -offvalue=>$transcodeurTkReplaceChar, -text=>$tmpButt, -variable => \$varBouton215, -relief => 'flat')->pack();
	$bouton215->select;
	push(@selectedBouttons,$bouton215);
    }
    if (scalar @TableButton >  0) {
	$tmpButt=shift(@TableButton);
	$tmpButt=chr($tmpButt);
	my $bouton216=$frame2->Checkbutton(-onvalue=>$tmpButt, -offvalue=>$transcodeurTkReplaceChar, -text=>$tmpButt, -variable => \$varBouton216, -relief => 'flat')->pack();
	$bouton216->select;
	push(@selectedBouttons,$bouton216);
    }
    if (scalar @TableButton >  0) {
	$tmpButt=shift(@TableButton);
	$tmpButt=chr($tmpButt);
	my $bouton217=$frame2->Checkbutton(-onvalue=>$tmpButt, -offvalue=>$transcodeurTkReplaceChar, -text=>$tmpButt, -variable => \$varBouton217, -relief => 'flat')->pack();
	$bouton217->select;
	push(@selectedBouttons,$bouton217);
    }
    if (scalar @TableButton >  0) {
	$tmpButt=shift(@TableButton);
	$tmpButt=chr($tmpButt);
	my $bouton218=$frame2->Checkbutton(-onvalue=>$tmpButt, -offvalue=>$transcodeurTkReplaceChar, -text=>$tmpButt, -variable => \$varBouton218, -relief => 'flat')->pack();
	$bouton218->select;
	push(@selectedBouttons,$bouton218);
    }
    if (scalar @TableButton >  0) {
	$tmpButt=shift(@TableButton);
	$tmpButt=chr($tmpButt);
	my $bouton219=$frame2->Checkbutton(-onvalue=>$tmpButt, -offvalue=>$transcodeurTkReplaceChar, -text=>$tmpButt, -variable => \$varBouton219, -relief => 'flat')->pack();
	$bouton219->select;
	push(@selectedBouttons,$bouton219);
    }
    if (scalar @TableButton >  0) {
	$tmpButt=shift(@TableButton);
	$tmpButt=chr($tmpButt);
	my $bouton220=$frame2->Checkbutton(-onvalue=>$tmpButt, -offvalue=>$transcodeurTkReplaceChar, -text=>$tmpButt, -variable => \$varBouton220, -relief => 'flat')->pack();
	$bouton220->select;
	push(@selectedBouttons,$bouton220);
    }
    if (scalar @TableButton >  0) {
	$tmpButt=shift(@TableButton);
	$tmpButt=chr($tmpButt);
	my $bouton31=$frame3->Checkbutton(-onvalue=>$tmpButt, -offvalue=>$transcodeurTkReplaceChar, -text=>$tmpButt, -variable => \$varBouton31, -relief => 'flat')->pack();
	$bouton31->select;
	push(@selectedBouttons,$bouton31);
    }
    if (scalar @TableButton >  0) {
	$tmpButt=shift(@TableButton);
	$tmpButt=chr($tmpButt);
	my $bouton32=$frame3->Checkbutton(-onvalue=>$tmpButt, -offvalue=>$transcodeurTkReplaceChar, -text=>$tmpButt, -variable => \$varBouton32, -relief => 'flat')->pack();
	$bouton32->select;
	push(@selectedBouttons,$bouton32);
    }
    if (scalar @TableButton >  0) {
	$tmpButt=shift(@TableButton);
	$tmpButt=chr($tmpButt);
	my $bouton33=$frame3->Checkbutton(-onvalue=>$tmpButt, -offvalue=>$transcodeurTkReplaceChar, -text=>$tmpButt, -variable => \$varBouton33, -relief => 'flat')->pack();
	$bouton33->select;
	push(@selectedBouttons,$bouton33);
    }
    if (scalar @TableButton >  0) {
	$tmpButt=shift(@TableButton);
	$tmpButt=chr($tmpButt);
	my $bouton34=$frame3->Checkbutton(-onvalue=>$tmpButt, -offvalue=>$transcodeurTkReplaceChar, -text=>$tmpButt, -variable => \$varBouton34, -relief => 'flat')->pack();
	$bouton34->select;
	push(@selectedBouttons,$bouton34);
    }
    if (scalar @TableButton >  0) {
	$tmpButt=shift(@TableButton);
	$tmpButt=chr($tmpButt);
	my $bouton35=$frame3->Checkbutton(-onvalue=>$tmpButt, -offvalue=>$transcodeurTkReplaceChar, -text=>$tmpButt, -variable => \$varBouton35, -relief => 'flat')->pack();
	$bouton35->select;
	push(@selectedBouttons,$bouton35);
    }
    if (scalar @TableButton >  0) {
	$tmpButt=shift(@TableButton);
	$tmpButt=chr($tmpButt);
	my $bouton36=$frame3->Checkbutton(-onvalue=>$tmpButt, -offvalue=>$transcodeurTkReplaceChar, -text=>$tmpButt, -variable => \$varBouton36, -relief => 'flat')->pack();
	$bouton36->select;
	push(@selectedBouttons,$bouton36);
    }
    if (scalar @TableButton >  0) {
	$tmpButt=shift(@TableButton);
	$tmpButt=chr($tmpButt);
	my $bouton37=$frame3->Checkbutton(-onvalue=>$tmpButt, -offvalue=>$transcodeurTkReplaceChar, -text=>$tmpButt, -variable => \$varBouton37, -relief => 'flat')->pack();
	$bouton37->select;
	push(@selectedBouttons,$bouton37);
    }
    if (scalar @TableButton >  0) {
	$tmpButt=shift(@TableButton);
	$tmpButt=chr($tmpButt);
	my $bouton38=$frame3->Checkbutton(-onvalue=>$tmpButt, -offvalue=>$transcodeurTkReplaceChar, -text=>$tmpButt, -variable => \$varBouton38, -relief => 'flat')->pack();
	$bouton38->select;
	push(@selectedBouttons,$bouton38);
    }
    if (scalar @TableButton >  0) {
	$tmpButt=shift(@TableButton);
	$tmpButt=chr($tmpButt);
	my $bouton39=$frame3->Checkbutton(-onvalue=>$tmpButt, -offvalue=>$transcodeurTkReplaceChar, -text=>$tmpButt, -variable => \$varBouton39, -relief => 'flat')->pack();
	$bouton39->select;
	push(@selectedBouttons,$bouton39);
    }
    if (scalar @TableButton >  0) {
	$tmpButt=shift(@TableButton);
	$tmpButt=chr($tmpButt);
	my $bouton310=$frame3->Checkbutton(-onvalue=>$tmpButt, -offvalue=>$transcodeurTkReplaceChar, -text=>$tmpButt, -variable => \$varBouton310, -relief => 'flat')->pack();
	$bouton310->select;
	push(@selectedBouttons,$bouton310);
    }
    if (scalar @TableButton >  0) {
	$tmpButt=shift(@TableButton);
	$tmpButt=chr($tmpButt);
	my $bouton311=$frame3->Checkbutton(-onvalue=>$tmpButt, -offvalue=>$transcodeurTkReplaceChar, -text=>$tmpButt, -variable => \$varBouton311, -relief => 'flat')->pack();
	$bouton311->select;
	push(@selectedBouttons,$bouton311);
    }
    if (scalar @TableButton >  0) {
	$tmpButt=shift(@TableButton);
	$tmpButt=chr($tmpButt);
	my $bouton312=$frame3->Checkbutton(-onvalue=>$tmpButt, -offvalue=>$transcodeurTkReplaceChar, -text=>$tmpButt, -variable => \$varBouton312, -relief => 'flat')->pack();
	$bouton312->select;
	push(@selectedBouttons,$bouton312);
    }
    if (scalar @TableButton >  0) {
	$tmpButt=shift(@TableButton);
	$tmpButt=chr($tmpButt);
	my $bouton313=$frame3->Checkbutton(-onvalue=>$tmpButt, -offvalue=>$transcodeurTkReplaceChar, -text=>$tmpButt, -variable => \$varBouton313, -relief => 'flat')->pack();
	$bouton313->select;
	push(@selectedBouttons,$bouton313);
    }
    if (scalar @TableButton >  0) {
	$tmpButt=shift(@TableButton);
	$tmpButt=chr($tmpButt);
	my $bouton314=$frame3->Checkbutton(-onvalue=>$tmpButt, -offvalue=>$transcodeurTkReplaceChar, -text=>$tmpButt, -variable => \$varBouton314, -relief => 'flat')->pack();
	$bouton314->select;
	push(@selectedBouttons,$bouton314);
    }
    if (scalar @TableButton >  0) {
	$tmpButt=shift(@TableButton);
	$tmpButt=chr($tmpButt);
	my $bouton315=$frame3->Checkbutton(-onvalue=>$tmpButt, -offvalue=>$transcodeurTkReplaceChar, -text=>$tmpButt, -variable => \$varBouton315, -relief => 'flat')->pack();
	$bouton315->select;
	push(@selectedBouttons,$bouton315);
    }
    if (scalar @TableButton >  0) {
	$tmpButt=shift(@TableButton);
	$tmpButt=chr($tmpButt);
	my $bouton316=$frame3->Checkbutton(-onvalue=>$tmpButt, -offvalue=>$transcodeurTkReplaceChar, -text=>$tmpButt, -variable => \$varBouton316, -relief => 'flat')->pack();
	$bouton316->select;
	push(@selectedBouttons,$bouton316);
    }
    if (scalar @TableButton >  0) {
	$tmpButt=shift(@TableButton);
	$tmpButt=chr($tmpButt);
	my $bouton317=$frame3->Checkbutton(-onvalue=>$tmpButt, -offvalue=>$transcodeurTkReplaceChar, -text=>$tmpButt, -variable => \$varBouton317, -relief => 'flat')->pack();
	$bouton317->select;
	push(@selectedBouttons,$bouton317);
    }
    if (scalar @TableButton >  0) {
	$tmpButt=shift(@TableButton);
	$tmpButt=chr($tmpButt);
	my $bouton318=$frame3->Checkbutton(-onvalue=>$tmpButt, -offvalue=>$transcodeurTkReplaceChar, -text=>$tmpButt, -variable => \$varBouton318, -relief => 'flat')->pack();
	$bouton318->select;
	push(@selectedBouttons,$bouton318);
    }
    if (scalar @TableButton >  0) {
	$tmpButt=shift(@TableButton);
	$tmpButt=chr($tmpButt);
	my $bouton319=$frame3->Checkbutton(-onvalue=>$tmpButt, -offvalue=>$transcodeurTkReplaceChar, -text=>$tmpButt, -variable => \$varBouton319, -relief => 'flat')->pack();
	$bouton319->select;
	push(@selectedBouttons,$bouton319);
    }
    if (scalar @TableButton >  0) {
	$tmpButt=shift(@TableButton);
	$tmpButt=chr($tmpButt);
	my $bouton320=$frame3->Checkbutton(-onvalue=>$tmpButt, -offvalue=>$transcodeurTkReplaceChar, -text=>$tmpButt, -variable => \$varBouton320, -relief => 'flat')->pack();
	$bouton320->select;
	push(@selectedBouttons,$bouton320);
    }
    if (scalar @TableButton >  0) {
	$tmpButt=shift(@TableButton);
	$tmpButt=chr($tmpButt);
	my $bouton41=$frame4->Checkbutton(-onvalue=>$tmpButt, -offvalue=>$transcodeurTkReplaceChar, -text=>$tmpButt, -variable => \$varBouton41, -relief => 'flat')->pack();
	$bouton41->select;
	push(@selectedBouttons,$bouton41);
    }
    if (scalar @TableButton >  0) {
	$tmpButt=shift(@TableButton);
	$tmpButt=chr($tmpButt);
	my $bouton42=$frame4->Checkbutton(-onvalue=>$tmpButt, -offvalue=>$transcodeurTkReplaceChar, -text=>$tmpButt, -variable => \$varBouton42, -relief => 'flat')->pack();
	$bouton42->select;
	push(@selectedBouttons,$bouton42);
    }
    if (scalar @TableButton >  0) {
	$tmpButt=shift(@TableButton);
	$tmpButt=chr($tmpButt);
	my $bouton43=$frame4->Checkbutton(-onvalue=>$tmpButt, -offvalue=>$transcodeurTkReplaceChar, -text=>$tmpButt, -variable => \$varBouton43, -relief => 'flat')->pack();
	$bouton43->select;
	push(@selectedBouttons,$bouton43);
    }
    if (scalar @TableButton >  0) {
	$tmpButt=shift(@TableButton);
	$tmpButt=chr($tmpButt);
	my $bouton44=$frame4->Checkbutton(-onvalue=>$tmpButt, -offvalue=>$transcodeurTkReplaceChar, -text=>$tmpButt, -variable => \$varBouton44, -relief => 'flat')->pack();
	$bouton44->select;
	push(@selectedBouttons,$bouton44);
    }
    if (scalar @TableButton >  0) {
	$tmpButt=shift(@TableButton);
	$tmpButt=chr($tmpButt);
	my $bouton45=$frame4->Checkbutton(-onvalue=>$tmpButt, -offvalue=>$transcodeurTkReplaceChar, -text=>$tmpButt, -variable => \$varBouton45, -relief => 'flat')->pack();
	$bouton45->select;
	push(@selectedBouttons,$bouton45);
    }
    if (scalar @TableButton >  0) {
	$tmpButt=shift(@TableButton);
	$tmpButt=chr($tmpButt);
	my $bouton46=$frame4->Checkbutton(-onvalue=>$tmpButt, -offvalue=>$transcodeurTkReplaceChar, -text=>$tmpButt, -variable => \$varBouton46, -relief => 'flat')->pack();
	$bouton46->select;
	push(@selectedBouttons,$bouton46);
    }
    if (scalar @TableButton >  0) {
	$tmpButt=shift(@TableButton);
	$tmpButt=chr($tmpButt);
	my $bouton47=$frame4->Checkbutton(-onvalue=>$tmpButt, -offvalue=>$transcodeurTkReplaceChar, -text=>$tmpButt, -variable => \$varBouton47, -relief => 'flat')->pack();
	$bouton47->select;
	push(@selectedBouttons,$bouton47);
    }
    if (scalar @TableButton >  0) {
	$tmpButt=shift(@TableButton);
	$tmpButt=chr($tmpButt);
	my $bouton48=$frame4->Checkbutton(-onvalue=>$tmpButt, -offvalue=>$transcodeurTkReplaceChar, -text=>$tmpButt, -variable => \$varBouton48, -relief => 'flat')->pack();
	$bouton48->select;
	push(@selectedBouttons,$bouton48);
    }
    if (scalar @TableButton >  0) {
	$tmpButt=shift(@TableButton);
	$tmpButt=chr($tmpButt);
	my $bouton49=$frame4->Checkbutton(-onvalue=>$tmpButt, -offvalue=>$transcodeurTkReplaceChar, -text=>$tmpButt, -variable => \$varBouton49, -relief => 'flat')->pack();
	$bouton49->select;
	push(@selectedBouttons,$bouton49);
    }
    if (scalar @TableButton >  0) {
	$tmpButt=shift(@TableButton);
	$tmpButt=chr($tmpButt);
	my $bouton410=$frame4->Checkbutton(-onvalue=>$tmpButt, -offvalue=>$transcodeurTkReplaceChar, -text=>$tmpButt, -variable => \$varBouton410, -relief => 'flat')->pack();
	$bouton410->select;
	push(@selectedBouttons,$bouton410);
    }
    if (scalar @TableButton >  0) {
	$tmpButt=shift(@TableButton);
	$tmpButt=chr($tmpButt);
	my $bouton411=$frame4->Checkbutton(-onvalue=>$tmpButt, -offvalue=>$transcodeurTkReplaceChar, -text=>$tmpButt, -variable => \$varBouton411, -relief => 'flat')->pack();
	$bouton411->select;
	push(@selectedBouttons,$bouton411);
    }
    if (scalar @TableButton >  0) {
	$tmpButt=shift(@TableButton);
	$tmpButt=chr($tmpButt);
	my $bouton412=$frame4->Checkbutton(-onvalue=>$tmpButt, -offvalue=>$transcodeurTkReplaceChar, -text=>$tmpButt, -variable => \$varBouton412, -relief => 'flat')->pack();
	$bouton412->select;
	push(@selectedBouttons,$bouton412);
    }
    if (scalar @TableButton >  0) {
	$tmpButt=shift(@TableButton);
	$tmpButt=chr($tmpButt);
	my $bouton413=$frame4->Checkbutton(-onvalue=>$tmpButt, -offvalue=>$transcodeurTkReplaceChar, -text=>$tmpButt, -variable => \$varBouton413, -relief => 'flat')->pack();
	$bouton413->select;
	push(@selectedBouttons,$bouton413);
    }
    if (scalar @TableButton >  0) {
	$tmpButt=shift(@TableButton);
	$tmpButt=chr($tmpButt);
	my $bouton414=$frame4->Checkbutton(-onvalue=>$tmpButt, -offvalue=>$transcodeurTkReplaceChar, -text=>$tmpButt, -variable => \$varBouton414, -relief => 'flat')->pack();
	$bouton414->select;
	push(@selectedBouttons,$bouton414);
    }
    if (scalar @TableButton >  0) {
	$tmpButt=shift(@TableButton);
	$tmpButt=chr($tmpButt);
	my $bouton415=$frame4->Checkbutton(-onvalue=>$tmpButt, -offvalue=>$transcodeurTkReplaceChar, -text=>$tmpButt, -variable => \$varBouton415, -relief => 'flat')->pack();
	$bouton415->select;
	push(@selectedBouttons,$bouton415);
    }
    if (scalar @TableButton >  0) {
	$tmpButt=shift(@TableButton);
	$tmpButt=chr($tmpButt);
	my $bouton416=$frame4->Checkbutton(-onvalue=>$tmpButt, -offvalue=>$transcodeurTkReplaceChar, -text=>$tmpButt, -variable => \$varBouton416, -relief => 'flat')->pack();
	$bouton416->select;
	push(@selectedBouttons,$bouton416);
    }
    if (scalar @TableButton >  0) {
	$tmpButt=shift(@TableButton);
	$tmpButt=chr($tmpButt);
	my $bouton417=$frame4->Checkbutton(-onvalue=>$tmpButt, -offvalue=>$transcodeurTkReplaceChar, -text=>$tmpButt, -variable => \$varBouton417, -relief => 'flat')->pack();
	$bouton417->select;
	push(@selectedBouttons,$bouton417);
    }
    if (scalar @TableButton >  0) {
	$tmpButt=shift(@TableButton);
	$tmpButt=chr($tmpButt);
	my $bouton418=$frame4->Checkbutton(-onvalue=>$tmpButt, -offvalue=>$transcodeurTkReplaceChar, -text=>$tmpButt, -variable => \$varBouton418, -relief => 'flat')->pack();
	$bouton418->select;
	push(@selectedBouttons,$bouton418);
    }
    if (scalar @TableButton >  0) {
	$tmpButt=shift(@TableButton);
	$tmpButt=chr($tmpButt);
	my $bouton419=$frame4->Checkbutton(-onvalue=>$tmpButt, -offvalue=>$transcodeurTkReplaceChar, -text=>$tmpButt, -variable => \$varBouton419, -relief => 'flat')->pack();
	$bouton419->select;
	push(@selectedBouttons,$bouton419);
    }
    if (scalar @TableButton >  0) {
	$tmpButt=shift(@TableButton);
	$tmpButt=chr($tmpButt);
	my $bouton420=$frame4->Checkbutton(-onvalue=>$tmpButt, -offvalue=>$transcodeurTkReplaceChar, -text=>$tmpButt, -variable => \$varBouton420, -relief => 'flat')->pack();
	$bouton420->select;
	push(@selectedBouttons,$bouton420);
    }
    if (scalar @TableButton >  0) {
	$tmpButt=shift(@TableButton);
	$tmpButt=chr($tmpButt);
	my $bouton51=$frame5->Checkbutton(-onvalue=>$tmpButt, -offvalue=>$transcodeurTkReplaceChar, -text=>$tmpButt, -variable => \$varBouton51, -relief => 'flat')->pack();
	$bouton51->select;
	push(@selectedBouttons,$bouton51);
    }
    if (scalar @TableButton >  0) {
	$tmpButt=shift(@TableButton);
	$tmpButt=chr($tmpButt);
	my $bouton52=$frame5->Checkbutton(-onvalue=>$tmpButt, -offvalue=>$transcodeurTkReplaceChar, -text=>$tmpButt, -variable => \$varBouton52, -relief => 'flat')->pack();
	$bouton52->select;
	push(@selectedBouttons,$bouton52);
    }
    if (scalar @TableButton >  0) {
	$tmpButt=shift(@TableButton);
	$tmpButt=chr($tmpButt);
	my $bouton53=$frame5->Checkbutton(-onvalue=>$tmpButt, -offvalue=>$transcodeurTkReplaceChar, -text=>$tmpButt, -variable => \$varBouton53, -relief => 'flat')->pack();
	$bouton53->select;
	push(@selectedBouttons,$bouton53);
    }
    if (scalar @TableButton >  0) {
	$tmpButt=shift(@TableButton);
	$tmpButt=chr($tmpButt);
	my $bouton54=$frame5->Checkbutton(-onvalue=>$tmpButt, -offvalue=>$transcodeurTkReplaceChar, -text=>$tmpButt, -variable => \$varBouton54, -relief => 'flat')->pack();
	$bouton54->select;
	push(@selectedBouttons,$bouton54);
    }
    if (scalar @TableButton >  0) {
	$tmpButt=shift(@TableButton);
	$tmpButt=chr($tmpButt);
	my $bouton55=$frame5->Checkbutton(-onvalue=>$tmpButt, -offvalue=>$transcodeurTkReplaceChar, -text=>$tmpButt, -variable => \$varBouton55, -relief => 'flat')->pack();
	$bouton55->select;
	push(@selectedBouttons,$bouton55);
    }
    if (scalar @TableButton >  0) {
	$tmpButt=shift(@TableButton);
	$tmpButt=chr($tmpButt);
	my $bouton56=$frame5->Checkbutton(-onvalue=>$tmpButt, -offvalue=>$transcodeurTkReplaceChar, -text=>$tmpButt, -variable => \$varBouton56, -relief => 'flat')->pack();
	$bouton56->select;
	push(@selectedBouttons,$bouton56);
    }
    if (scalar @TableButton >  0) {
	$tmpButt=shift(@TableButton);
	$tmpButt=chr($tmpButt);
	my $bouton57=$frame5->Checkbutton(-onvalue=>$tmpButt, -offvalue=>$transcodeurTkReplaceChar, -text=>$tmpButt, -variable => \$varBouton57, -relief => 'flat')->pack();
	$bouton57->select;
	push(@selectedBouttons,$bouton57);
    }
    if (scalar @TableButton >  0) {
	$tmpButt=shift(@TableButton);
	$tmpButt=chr($tmpButt);
	my $bouton58=$frame5->Checkbutton(-onvalue=>$tmpButt, -offvalue=>$transcodeurTkReplaceChar, -text=>$tmpButt, -variable => \$varBouton58, -relief => 'flat')->pack();
	$bouton58->select;
	push(@selectedBouttons,$bouton58);
    }
    if (scalar @TableButton >  0) {
	$tmpButt=shift(@TableButton);
	$tmpButt=chr($tmpButt);
	my $bouton59=$frame5->Checkbutton(-onvalue=>$tmpButt, -offvalue=>$transcodeurTkReplaceChar, -text=>$tmpButt, -variable => \$varBouton59, -relief => 'flat')->pack();
	$bouton59->select;
	push(@selectedBouttons,$bouton59);
    }
    if (scalar @TableButton >  0) {
	$tmpButt=shift(@TableButton);
	$tmpButt=chr($tmpButt);
	my $bouton510=$frame5->Checkbutton(-onvalue=>$tmpButt, -offvalue=>$transcodeurTkReplaceChar, -text=>$tmpButt, -variable => \$varBouton510, -relief => 'flat')->pack();
	$bouton510->select;
	push(@selectedBouttons,$bouton510);
    }
    if (scalar @TableButton >  0) {
	$tmpButt=shift(@TableButton);
	$tmpButt=chr($tmpButt);
	my $bouton511=$frame5->Checkbutton(-onvalue=>$tmpButt, -offvalue=>$transcodeurTkReplaceChar, -text=>$tmpButt, -variable => \$varBouton511, -relief => 'flat')->pack();
	$bouton511->select;
	push(@selectedBouttons,$bouton511);
    }
    if (scalar @TableButton >  0) {
	$tmpButt=shift(@TableButton);
	$tmpButt=chr($tmpButt);
	my $bouton512=$frame5->Checkbutton(-onvalue=>$tmpButt, -offvalue=>$transcodeurTkReplaceChar, -text=>$tmpButt, -variable => \$varBouton512, -relief => 'flat')->pack();
	$bouton512->select;
	push(@selectedBouttons,$bouton512);
    }
    if (scalar @TableButton >  0) {
	$tmpButt=shift(@TableButton);
	$tmpButt=chr($tmpButt);
	my $bouton513=$frame5->Checkbutton(-onvalue=>$tmpButt, -offvalue=>$transcodeurTkReplaceChar, -text=>$tmpButt, -variable => \$varBouton513, -relief => 'flat')->pack();
	$bouton513->select;
	push(@selectedBouttons,$bouton513);
    }
    if (scalar @TableButton >  0) {
	$tmpButt=shift(@TableButton);
	$tmpButt=chr($tmpButt);
	my $bouton514=$frame5->Checkbutton(-onvalue=>$tmpButt, -offvalue=>$transcodeurTkReplaceChar, -text=>$tmpButt, -variable => \$varBouton514, -relief => 'flat')->pack();
	$bouton514->select;
	push(@selectedBouttons,$bouton514);
    }
    if (scalar @TableButton >  0) {
	$tmpButt=shift(@TableButton);
	$tmpButt=chr($tmpButt);
	my $bouton515=$frame5->Checkbutton(-onvalue=>$tmpButt, -offvalue=>$transcodeurTkReplaceChar, -text=>$tmpButt, -variable => \$varBouton515, -relief => 'flat')->pack();
	$bouton515->select;
	push(@selectedBouttons,$bouton515);
    }
    if (scalar @TableButton >  0) {
	$tmpButt=shift(@TableButton);
	$tmpButt=chr($tmpButt);
	my $bouton516=$frame5->Checkbutton(-onvalue=>$tmpButt, -offvalue=>$transcodeurTkReplaceChar, -text=>$tmpButt, -variable => \$varBouton516, -relief => 'flat')->pack();
	$bouton516->select;
	push(@selectedBouttons,$bouton516);
    }
    if (scalar @TableButton >  0) {
	$tmpButt=shift(@TableButton);
	$tmpButt=chr($tmpButt);
	my $bouton517=$frame5->Checkbutton(-onvalue=>$tmpButt, -offvalue=>$transcodeurTkReplaceChar, -text=>$tmpButt, -variable => \$varBouton517, -relief => 'flat')->pack();
	$bouton517->select;
	push(@selectedBouttons,$bouton517);
    }
    if (scalar @TableButton >  0) {
	$tmpButt=shift(@TableButton);
	$tmpButt=chr($tmpButt);
	my $bouton518=$frame5->Checkbutton(-onvalue=>$tmpButt, -offvalue=>$transcodeurTkReplaceChar, -text=>$tmpButt, -variable => \$varBouton518, -relief => 'flat')->pack();
	$bouton518->select;
	push(@selectedBouttons,$bouton518);
    }
    if (scalar @TableButton >  0) {
	$tmpButt=shift(@TableButton);
	$tmpButt=chr($tmpButt);
	my $bouton519=$frame5->Checkbutton(-onvalue=>$tmpButt, -offvalue=>$transcodeurTkReplaceChar, -text=>$tmpButt, -variable => \$varBouton519, -relief => 'flat')->pack();
	$bouton519->select;
	push(@selectedBouttons,$bouton519);
    }
    if (scalar @TableButton >  0) {
	$tmpButt=shift(@TableButton);
	$tmpButt=chr($tmpButt);
	my $bouton520=$frame5->Checkbutton(-onvalue=>$tmpButt, -offvalue=>$transcodeurTkReplaceChar, -text=>$tmpButt, -variable => \$varBouton520, -relief => 'flat')->pack();
	$bouton520->select;
	push(@selectedBouttons,$bouton520);
    }
    if (scalar @TableButton >  0) {
	$tmpButt=shift(@TableButton);
	$tmpButt=chr($tmpButt);
	my $bouton61=$frame6->Checkbutton(-onvalue=>$tmpButt, -offvalue=>$transcodeurTkReplaceChar, -text=>$tmpButt, -variable => \$varBouton61, -relief => 'flat')->pack();
	$bouton61->select;
	push(@selectedBouttons,$bouton61);
    }
    if (scalar @TableButton >  0) {
	$tmpButt=shift(@TableButton);
	$tmpButt=chr($tmpButt);
	my $bouton62=$frame6->Checkbutton(-onvalue=>$tmpButt, -offvalue=>$transcodeurTkReplaceChar, -text=>$tmpButt, -variable => \$varBouton62, -relief => 'flat')->pack();
	$bouton62->select;
	push(@selectedBouttons,$bouton62);
    }
    if (scalar @TableButton >  0) {
	$tmpButt=shift(@TableButton);
	$tmpButt=chr($tmpButt);
	my $bouton63=$frame6->Checkbutton(-onvalue=>$tmpButt, -offvalue=>$transcodeurTkReplaceChar, -text=>$tmpButt, -variable => \$varBouton63, -relief => 'flat')->pack();
	$bouton63->select;
	push(@selectedBouttons,$bouton63);
    }
    if (scalar @TableButton >  0) {
	$tmpButt=shift(@TableButton);
	$tmpButt=chr($tmpButt);
	my $bouton64=$frame6->Checkbutton(-onvalue=>$tmpButt, -offvalue=>$transcodeurTkReplaceChar, -text=>$tmpButt, -variable => \$varBouton64, -relief => 'flat')->pack();
	$bouton64->select;
	push(@selectedBouttons,$bouton64);
    }
    if (scalar @TableButton >  0) {
	$tmpButt=shift(@TableButton);
	$tmpButt=chr($tmpButt);
	my $bouton65=$frame6->Checkbutton(-onvalue=>$tmpButt, -offvalue=>$transcodeurTkReplaceChar, -text=>$tmpButt, -variable => \$varBouton65, -relief => 'flat')->pack();
	$bouton65->select;
	push(@selectedBouttons,$bouton65);
    }
    if (scalar @TableButton >  0) {
	$tmpButt=shift(@TableButton);
	$tmpButt=chr($tmpButt);
	my $bouton66=$frame6->Checkbutton(-onvalue=>$tmpButt, -offvalue=>$transcodeurTkReplaceChar, -text=>$tmpButt, -variable => \$varBouton66, -relief => 'flat')->pack();
	$bouton66->select;
	push(@selectedBouttons,$bouton66);
    }
    if (scalar @TableButton >  0) {
	$tmpButt=shift(@TableButton);
	$tmpButt=chr($tmpButt);
	my $bouton67=$frame6->Checkbutton(-onvalue=>$tmpButt, -offvalue=>$transcodeurTkReplaceChar, -text=>$tmpButt, -variable => \$varBouton67, -relief => 'flat')->pack();
	$bouton67->select;
	push(@selectedBouttons,$bouton67);
    }
    if (scalar @TableButton >  0) {
	$tmpButt=shift(@TableButton);
	$tmpButt=chr($tmpButt);
	my $bouton68=$frame6->Checkbutton(-onvalue=>$tmpButt, -offvalue=>$transcodeurTkReplaceChar, -text=>$tmpButt, -variable => \$varBouton68, -relief => 'flat')->pack();
	$bouton68->select;
	push(@selectedBouttons,$bouton68);
    }
    if (scalar @TableButton >  0) {
	$tmpButt=shift(@TableButton);
	$tmpButt=chr($tmpButt);
	my $bouton69=$frame6->Checkbutton(-onvalue=>$tmpButt, -offvalue=>$transcodeurTkReplaceChar, -text=>$tmpButt, -variable => \$varBouton69, -relief => 'flat')->pack();
	$bouton69->select;
	push(@selectedBouttons,$bouton69);
    }
    if (scalar @TableButton >  0) {
	$tmpButt=shift(@TableButton);
	$tmpButt=chr($tmpButt);
	my $bouton610=$frame6->Checkbutton(-onvalue=>$tmpButt, -offvalue=>$transcodeurTkReplaceChar, -text=>$tmpButt, -variable => \$varBouton610, -relief => 'flat')->pack();
	$bouton610->select;
	push(@selectedBouttons,$bouton610);
    }
    if (scalar @TableButton >  0) {
	$tmpButt=shift(@TableButton);
	$tmpButt=chr($tmpButt);
	my $bouton611=$frame6->Checkbutton(-onvalue=>$tmpButt, -offvalue=>$transcodeurTkReplaceChar, -text=>$tmpButt, -variable => \$varBouton611, -relief => 'flat')->pack();
	$bouton611->select;
	push(@selectedBouttons,$bouton611);
    }
    if (scalar @TableButton >  0) {
	$tmpButt=shift(@TableButton);
	$tmpButt=chr($tmpButt);
	my $bouton612=$frame6->Checkbutton(-onvalue=>$tmpButt, -offvalue=>$transcodeurTkReplaceChar, -text=>$tmpButt, -variable => \$varBouton612, -relief => 'flat')->pack();
	$bouton612->select;
	push(@selectedBouttons,$bouton612);
    }
    if (scalar @TableButton >  0) {
	$tmpButt=shift(@TableButton);
	$tmpButt=chr($tmpButt);
	my $bouton613=$frame6->Checkbutton(-onvalue=>$tmpButt, -offvalue=>$transcodeurTkReplaceChar, -text=>$tmpButt, -variable => \$varBouton613, -relief => 'flat')->pack();
	$bouton613->select;
	push(@selectedBouttons,$bouton613);
    }
    if (scalar @TableButton >  0) {
	$tmpButt=shift(@TableButton);
	$tmpButt=chr($tmpButt);
	my $bouton614=$frame6->Checkbutton(-onvalue=>$tmpButt, -offvalue=>$transcodeurTkReplaceChar, -text=>$tmpButt, -variable => \$varBouton614, -relief => 'flat')->pack();
	$bouton614->select;
	push(@selectedBouttons,$bouton614);
    }
    if (scalar @TableButton >  0) {
	$tmpButt=shift(@TableButton);
	$tmpButt=chr($tmpButt);
	my $bouton615=$frame6->Checkbutton(-onvalue=>$tmpButt, -offvalue=>$transcodeurTkReplaceChar, -text=>$tmpButt, -variable => \$varBouton615, -relief => 'flat')->pack();
	$bouton615->select;
	push(@selectedBouttons,$bouton615);
    }
    if (scalar @TableButton >  0) {
	$tmpButt=shift(@TableButton);
	$tmpButt=chr($tmpButt);
	my $bouton616=$frame6->Checkbutton(-onvalue=>$tmpButt, -offvalue=>$transcodeurTkReplaceChar, -text=>$tmpButt, -variable => \$varBouton616, -relief => 'flat')->pack();
	$bouton616->select;
	push(@selectedBouttons,$bouton616);
    }
    if (scalar @TableButton >  0) {
	$tmpButt=shift(@TableButton);
	$tmpButt=chr($tmpButt);
	my $bouton617=$frame6->Checkbutton(-onvalue=>$tmpButt, -offvalue=>$transcodeurTkReplaceChar, -text=>$tmpButt, -variable => \$varBouton617, -relief => 'flat')->pack();
	$bouton617->select;
	push(@selectedBouttons,$bouton617);
    }
    if (scalar @TableButton >  0) {
	$tmpButt=shift(@TableButton);
	$tmpButt=chr($tmpButt);
	my $bouton618=$frame6->Checkbutton(-onvalue=>$tmpButt, -offvalue=>$transcodeurTkReplaceChar, -text=>$tmpButt, -variable => \$varBouton618, -relief => 'flat')->pack();
	$bouton618->select;
	push(@selectedBouttons,$bouton618);
    }
    if (scalar @TableButton >  0) {
	$tmpButt=shift(@TableButton);
	$tmpButt=chr($tmpButt);
	my $bouton619=$frame6->Checkbutton(-onvalue=>$tmpButt, -offvalue=>$transcodeurTkReplaceChar, -text=>$tmpButt, -variable => \$varBouton619, -relief => 'flat')->pack();
	$bouton619->select;
	push(@selectedBouttons,$bouton619);
    }
    if (scalar @TableButton >  0) {
	$tmpButt=shift(@TableButton);
	$tmpButt=chr($tmpButt);
	my $bouton620=$frame6->Checkbutton(-onvalue=>$tmpButt, -offvalue=>$transcodeurTkReplaceChar, -text=>$tmpButt, -variable => \$varBouton620, -relief => 'flat')->pack();
	$bouton620->select;
	push(@selectedBouttons,$bouton620);
    }
    if (scalar @TableButton >  0) {
	$tmpButt=shift(@TableButton);
	$tmpButt=chr($tmpButt);
	my $bouton71=$frame7->Checkbutton(-onvalue=>$tmpButt, -offvalue=>$transcodeurTkReplaceChar, -text=>$tmpButt, -variable => \$varBouton71, -relief => 'flat')->pack();
	$bouton71->select;
	push(@selectedBouttons,$bouton71);
    }
    if (scalar @TableButton >  0) {
	$tmpButt=shift(@TableButton);
	$tmpButt=chr($tmpButt);
	my $bouton72=$frame7->Checkbutton(-onvalue=>$tmpButt, -offvalue=>$transcodeurTkReplaceChar, -text=>$tmpButt, -variable => \$varBouton72, -relief => 'flat')->pack();
	$bouton72->select;
	push(@selectedBouttons,$bouton72);
    }
    if (scalar @TableButton >  0) {
	$tmpButt=shift(@TableButton);
	$tmpButt=chr($tmpButt);
	my $bouton73=$frame7->Checkbutton(-onvalue=>$tmpButt, -offvalue=>$transcodeurTkReplaceChar, -text=>$tmpButt, -variable => \$varBouton73, -relief => 'flat')->pack();
	$bouton73->select;
	push(@selectedBouttons,$bouton73);
    }
    if (scalar @TableButton >  0) {
	$tmpButt=shift(@TableButton);
	$tmpButt=chr($tmpButt);
	my $bouton74=$frame7->Checkbutton(-onvalue=>$tmpButt, -offvalue=>$transcodeurTkReplaceChar, -text=>$tmpButt, -variable => \$varBouton74, -relief => 'flat')->pack();
	$bouton74->select;
	push(@selectedBouttons,$bouton74);
    }
    if (scalar @TableButton >  0) {
	$tmpButt=shift(@TableButton);
	$tmpButt=chr($tmpButt);
	my $bouton75=$frame7->Checkbutton(-onvalue=>$tmpButt, -offvalue=>$transcodeurTkReplaceChar, -text=>$tmpButt, -variable => \$varBouton75, -relief => 'flat')->pack();
	$bouton75->select;
	push(@selectedBouttons,$bouton75);
    }
    if (scalar @TableButton >  0) {
	$tmpButt=shift(@TableButton);
	$tmpButt=chr($tmpButt);
	my $bouton76=$frame7->Checkbutton(-onvalue=>$tmpButt, -offvalue=>$transcodeurTkReplaceChar, -text=>$tmpButt, -variable => \$varBouton76, -relief => 'flat')->pack();
	$bouton76->select;
	push(@selectedBouttons,$bouton76);
    }
    if (scalar @TableButton >  0) {
	$tmpButt=shift(@TableButton);
	$tmpButt=chr($tmpButt);
	my $bouton77=$frame7->Checkbutton(-onvalue=>$tmpButt, -offvalue=>$transcodeurTkReplaceChar, -text=>$tmpButt, -variable => \$varBouton77, -relief => 'flat')->pack();
	$bouton77->select;
	push(@selectedBouttons,$bouton77);
    }
    if (scalar @TableButton >  0) {
	$tmpButt=shift(@TableButton);
	$tmpButt=chr($tmpButt);
	my $bouton78=$frame7->Checkbutton(-onvalue=>$tmpButt, -offvalue=>$transcodeurTkReplaceChar, -text=>$tmpButt, -variable => \$varBouton78, -relief => 'flat')->pack();
	$bouton78->select;
	push(@selectedBouttons,$bouton78);
    }
    if (scalar @TableButton >  0) {
	$tmpButt=shift(@TableButton);
	$tmpButt=chr($tmpButt);
	my $bouton79=$frame7->Checkbutton(-onvalue=>$tmpButt, -offvalue=>$transcodeurTkReplaceChar, -text=>$tmpButt, -variable => \$varBouton79, -relief => 'flat')->pack();
	$bouton79->select;
	push(@selectedBouttons,$bouton79);
    }
    if (scalar @TableButton >  0) {
	$tmpButt=shift(@TableButton);
	$tmpButt=chr($tmpButt);
	my $bouton710=$frame7->Checkbutton(-onvalue=>$tmpButt, -offvalue=>$transcodeurTkReplaceChar, -text=>$tmpButt, -variable => \$varBouton710, -relief => 'flat')->pack();
	$bouton710->select;
	push(@selectedBouttons,$bouton710);
    }
    if (scalar @TableButton >  0) {
	$tmpButt=shift(@TableButton);
	$tmpButt=chr($tmpButt);
	my $bouton711=$frame7->Checkbutton(-onvalue=>$tmpButt, -offvalue=>$transcodeurTkReplaceChar, -text=>$tmpButt, -variable => \$varBouton711, -relief => 'flat')->pack();
	$bouton711->select;
	push(@selectedBouttons,$bouton711);
    }
    if (scalar @TableButton >  0) {
	$tmpButt=shift(@TableButton);
	$tmpButt=chr($tmpButt);
	my $bouton712=$frame7->Checkbutton(-onvalue=>$tmpButt, -offvalue=>$transcodeurTkReplaceChar, -text=>$tmpButt, -variable => \$varBouton712, -relief => 'flat')->pack();
	$bouton712->select;
	push(@selectedBouttons,$bouton712);
    }
    if (scalar @TableButton >  0) {
	$tmpButt=shift(@TableButton);
	$tmpButt=chr($tmpButt);
	my $bouton713=$frame7->Checkbutton(-onvalue=>$tmpButt, -offvalue=>$transcodeurTkReplaceChar, -text=>$tmpButt, -variable => \$varBouton713, -relief => 'flat')->pack();
	$bouton713->select;
	push(@selectedBouttons,$bouton713);
    }
    if (scalar @TableButton >  0) {
	$tmpButt=shift(@TableButton);
	$tmpButt=chr($tmpButt);
	my $bouton714=$frame7->Checkbutton(-onvalue=>$tmpButt, -offvalue=>$transcodeurTkReplaceChar, -text=>$tmpButt, -variable => \$varBouton714, -relief => 'flat')->pack();
	$bouton714->select;
	push(@selectedBouttons,$bouton714);
    }
    if (scalar @TableButton >  0) {
	$tmpButt=shift(@TableButton);
	$tmpButt=chr($tmpButt);
	my $bouton715=$frame7->Checkbutton(-onvalue=>$tmpButt, -offvalue=>$transcodeurTkReplaceChar, -text=>$tmpButt, -variable => \$varBouton715, -relief => 'flat')->pack();
	$bouton715->select;
	push(@selectedBouttons,$bouton715);
    }
    if (scalar @TableButton >  0) {
	$tmpButt=shift(@TableButton);
	$tmpButt=chr($tmpButt);
	my $bouton716=$frame7->Checkbutton(-onvalue=>$tmpButt, -offvalue=>$transcodeurTkReplaceChar, -text=>$tmpButt, -variable => \$varBouton716, -relief => 'flat')->pack();
	$bouton716->select;
	push(@selectedBouttons,$bouton716);
    }
    if (scalar @TableButton >  0) {
	$tmpButt=shift(@TableButton);
	$tmpButt=chr($tmpButt);
	my $bouton717=$frame7->Checkbutton(-onvalue=>$tmpButt, -offvalue=>$transcodeurTkReplaceChar, -text=>$tmpButt, -variable => \$varBouton717, -relief => 'flat')->pack();
	$bouton717->select;
	push(@selectedBouttons,$bouton717);
    }
    if (scalar @TableButton >  0) {
	$tmpButt=shift(@TableButton);
	$tmpButt=chr($tmpButt);
	my $bouton718=$frame7->Checkbutton(-onvalue=>$tmpButt, -offvalue=>$transcodeurTkReplaceChar, -text=>$tmpButt, -variable => \$varBouton718, -relief => 'flat')->pack();
	$bouton718->select;
	push(@selectedBouttons,$bouton718);
    }
    if (scalar @TableButton >  0) {
	$tmpButt=shift(@TableButton);
	$tmpButt=chr($tmpButt);
	my $bouton719=$frame7->Checkbutton(-onvalue=>$tmpButt, -offvalue=>$transcodeurTkReplaceChar, -text=>$tmpButt, -variable => \$varBouton719, -relief => 'flat')->pack();
	$bouton719->select;
	push(@selectedBouttons,$bouton719);
    }
    if (scalar @TableButton >  0) {
	$tmpButt=shift(@TableButton);
	$tmpButt=chr($tmpButt);
	my $bouton720=$frame7->Checkbutton(-onvalue=>$tmpButt, -offvalue=>$transcodeurTkReplaceChar, -text=>$tmpButt, -variable => \$varBouton720, -relief => 'flat')->pack();
	$bouton720->select;
	push(@selectedBouttons,$bouton720);
    }
    if (scalar @TableButton >  0) {
	$tmpButt=shift(@TableButton);
	$tmpButt=chr($tmpButt);
	my $bouton81=$frame8->Checkbutton(-onvalue=>$tmpButt, -offvalue=>$transcodeurTkReplaceChar, -text=>$tmpButt, -variable => \$varBouton81, -relief => 'flat')->pack();
	$bouton81->select;
	push(@selectedBouttons,$bouton81);
    }
    if (scalar @TableButton >  0) {
	$tmpButt=shift(@TableButton);
	$tmpButt=chr($tmpButt);
	my $bouton82=$frame8->Checkbutton(-onvalue=>$tmpButt, -offvalue=>$transcodeurTkReplaceChar, -text=>$tmpButt, -variable => \$varBouton82, -relief => 'flat')->pack();
	$bouton82->select;
	push(@selectedBouttons,$bouton82);
    }
    if (scalar @TableButton >  0) {
	$tmpButt=shift(@TableButton);
	$tmpButt=chr($tmpButt);
	my $bouton83=$frame8->Checkbutton(-onvalue=>$tmpButt, -offvalue=>$transcodeurTkReplaceChar, -text=>$tmpButt, -variable => \$varBouton83, -relief => 'flat')->pack();
	$bouton83->select;
	push(@selectedBouttons,$bouton83);
    }
    if (scalar @TableButton >  0) {
	$tmpButt=shift(@TableButton);
	$tmpButt=chr($tmpButt);
	my $bouton84=$frame8->Checkbutton(-onvalue=>$tmpButt, -offvalue=>$transcodeurTkReplaceChar, -text=>$tmpButt, -variable => \$varBouton84, -relief => 'flat')->pack();
	$bouton84->select;
	push(@selectedBouttons,$bouton84);
    }
    if (scalar @TableButton >  0) {
	$tmpButt=shift(@TableButton);
	$tmpButt=chr($tmpButt);
	my $bouton85=$frame8->Checkbutton(-onvalue=>$tmpButt, -offvalue=>$transcodeurTkReplaceChar, -text=>$tmpButt, -variable => \$varBouton85, -relief => 'flat')->pack();
	$bouton85->select;
	push(@selectedBouttons,$bouton85);
    }
    if (scalar @TableButton >  0) {
	$tmpButt=shift(@TableButton);
	$tmpButt=chr($tmpButt);
	my $bouton86=$frame8->Checkbutton(-onvalue=>$tmpButt, -offvalue=>$transcodeurTkReplaceChar, -text=>$tmpButt, -variable => \$varBouton86, -relief => 'flat')->pack();
	$bouton86->select;
	push(@selectedBouttons,$bouton86);
    }
    if (scalar @TableButton >  0) {
	$tmpButt=shift(@TableButton);
	$tmpButt=chr($tmpButt);
	my $bouton87=$frame8->Checkbutton(-onvalue=>$tmpButt, -offvalue=>$transcodeurTkReplaceChar, -text=>$tmpButt, -variable => \$varBouton87, -relief => 'flat')->pack();
	$bouton87->select;
	push(@selectedBouttons,$bouton87);
    }
    if (scalar @TableButton >  0) {
	$tmpButt=shift(@TableButton);
	$tmpButt=chr($tmpButt);
	my $bouton88=$frame8->Checkbutton(-onvalue=>$tmpButt, -offvalue=>$transcodeurTkReplaceChar, -text=>$tmpButt, -variable => \$varBouton88, -relief => 'flat')->pack();
	$bouton88->select;
	push(@selectedBouttons,$bouton88);
    }
    if (scalar @TableButton >  0) {
	$tmpButt=shift(@TableButton);
	$tmpButt=chr($tmpButt);
	my $bouton89=$frame8->Checkbutton(-onvalue=>$tmpButt, -offvalue=>$transcodeurTkReplaceChar, -text=>$tmpButt, -variable => \$varBouton89, -relief => 'flat')->pack();
	$bouton89->select;
	push(@selectedBouttons,$bouton89);
    }
    if (scalar @TableButton >  0) {
	$tmpButt=shift(@TableButton);
	$tmpButt=chr($tmpButt);
	my $bouton810=$frame8->Checkbutton(-onvalue=>$tmpButt, -offvalue=>$transcodeurTkReplaceChar, -text=>$tmpButt, -variable => \$varBouton810, -relief => 'flat')->pack();
	$bouton810->select;
	push(@selectedBouttons,$bouton810);
    }
    if (scalar @TableButton >  0) {
	$tmpButt=shift(@TableButton);
	$tmpButt=chr($tmpButt);
	my $bouton811=$frame8->Checkbutton(-onvalue=>$tmpButt, -offvalue=>$transcodeurTkReplaceChar, -text=>$tmpButt, -variable => \$varBouton811, -relief => 'flat')->pack();
	$bouton811->select;
	push(@selectedBouttons,$bouton811);
    }
    if (scalar @TableButton >  0) {
	$tmpButt=shift(@TableButton);
	$tmpButt=chr($tmpButt);
	my $bouton812=$frame8->Checkbutton(-onvalue=>$tmpButt, -offvalue=>$transcodeurTkReplaceChar, -text=>$tmpButt, -variable => \$varBouton812, -relief => 'flat')->pack();
	$bouton812->select;
	push(@selectedBouttons,$bouton812);
    }
    if (scalar @TableButton >  0) {
	$tmpButt=shift(@TableButton);
	$tmpButt=chr($tmpButt);
	my $bouton813=$frame8->Checkbutton(-onvalue=>$tmpButt, -offvalue=>$transcodeurTkReplaceChar, -text=>$tmpButt, -variable => \$varBouton813, -relief => 'flat')->pack();
	$bouton813->select;
	push(@selectedBouttons,$bouton813);
    }
    if (scalar @TableButton >  0) {
	$tmpButt=shift(@TableButton);
	$tmpButt=chr($tmpButt);
	my $bouton814=$frame8->Checkbutton(-onvalue=>$tmpButt, -offvalue=>$transcodeurTkReplaceChar, -text=>$tmpButt, -variable => \$varBouton814, -relief => 'flat')->pack();
	$bouton814->select;
	push(@selectedBouttons,$bouton814);
    }
    if (scalar @TableButton >  0) {
	$tmpButt=shift(@TableButton);
	$tmpButt=chr($tmpButt);
	my $bouton815=$frame8->Checkbutton(-onvalue=>$tmpButt, -offvalue=>$transcodeurTkReplaceChar, -text=>$tmpButt, -variable => \$varBouton815, -relief => 'flat')->pack();
	$bouton815->select;
	push(@selectedBouttons,$bouton815);
    }
    if (scalar @TableButton >  0) {
	$tmpButt=shift(@TableButton);
	$tmpButt=chr($tmpButt);
	my $bouton816=$frame8->Checkbutton(-onvalue=>$tmpButt, -offvalue=>$transcodeurTkReplaceChar, -text=>$tmpButt, -variable => \$varBouton816, -relief => 'flat')->pack();
	$bouton816->select;
	push(@selectedBouttons,$bouton816);
    }
    if (scalar @TableButton >  0) {
	$tmpButt=shift(@TableButton);
	$tmpButt=chr($tmpButt);
	my $bouton817=$frame8->Checkbutton(-onvalue=>$tmpButt, -offvalue=>$transcodeurTkReplaceChar, -text=>$tmpButt, -variable => \$varBouton817, -relief => 'flat')->pack();
	$bouton817->select;
	push(@selectedBouttons,$bouton817);
    }
    if (scalar @TableButton >  0) {
	$tmpButt=shift(@TableButton);
	$tmpButt=chr($tmpButt);
	my $bouton818=$frame8->Checkbutton(-onvalue=>$tmpButt, -offvalue=>$transcodeurTkReplaceChar, -text=>$tmpButt, -variable => \$varBouton818, -relief => 'flat')->pack();
	$bouton818->select;
	push(@selectedBouttons,$bouton818);
    }
    if (scalar @TableButton >  0) {
	$tmpButt=shift(@TableButton);
	$tmpButt=chr($tmpButt);
	my $bouton819=$frame8->Checkbutton(-onvalue=>$tmpButt, -offvalue=>$transcodeurTkReplaceChar, -text=>$tmpButt, -variable => \$varBouton819, -relief => 'flat')->pack();
	$bouton819->select;
	push(@selectedBouttons,$bouton819);
    }
    if (scalar @TableButton >  0) {
	$tmpButt=shift(@TableButton);
	$tmpButt=chr($tmpButt);
	my $bouton820=$frame8->Checkbutton(-onvalue=>$tmpButt, -offvalue=>$transcodeurTkReplaceChar, -text=>$tmpButt, -variable => \$varBouton820, -relief => 'flat')->pack();
	$bouton820->select;
	push(@selectedBouttons,$bouton820);
    }
    if (scalar @TableButton >  0) {
	$tmpButt=shift(@TableButton);
	$tmpButt=chr($tmpButt);
	my $bouton91=$frame9->Checkbutton(-onvalue=>$tmpButt, -offvalue=>$transcodeurTkReplaceChar, -text=>$tmpButt, -variable => \$varBouton91, -relief => 'flat')->pack();
	$bouton91->select;
	push(@selectedBouttons,$bouton91);
    }
    if (scalar @TableButton >  0) {
	$tmpButt=shift(@TableButton);
	$tmpButt=chr($tmpButt);
	my $bouton92=$frame9->Checkbutton(-onvalue=>$tmpButt, -offvalue=>$transcodeurTkReplaceChar, -text=>$tmpButt, -variable => \$varBouton92, -relief => 'flat')->pack();
	$bouton92->select;
	push(@selectedBouttons,$bouton92);
    }
    if (scalar @TableButton >  0) {
	$tmpButt=shift(@TableButton);
	$tmpButt=chr($tmpButt);
	my $bouton93=$frame9->Checkbutton(-onvalue=>$tmpButt, -offvalue=>$transcodeurTkReplaceChar, -text=>$tmpButt, -variable => \$varBouton93, -relief => 'flat')->pack();
	$bouton93->select;
	push(@selectedBouttons,$bouton93);
    }
    if (scalar @TableButton >  0) {
	$tmpButt=shift(@TableButton);
	$tmpButt=chr($tmpButt);
	my $bouton94=$frame9->Checkbutton(-onvalue=>$tmpButt, -offvalue=>$transcodeurTkReplaceChar, -text=>$tmpButt, -variable => \$varBouton94, -relief => 'flat')->pack();
	$bouton94->select;
	push(@selectedBouttons,$bouton94);
    }
    if (scalar @TableButton >  0) {
	$tmpButt=shift(@TableButton);
	$tmpButt=chr($tmpButt);
	my $bouton95=$frame9->Checkbutton(-onvalue=>$tmpButt, -offvalue=>$transcodeurTkReplaceChar, -text=>$tmpButt, -variable => \$varBouton95, -relief => 'flat')->pack();
	$bouton95->select;
	push(@selectedBouttons,$bouton95);
    }
    if (scalar @TableButton >  0) {
	$tmpButt=shift(@TableButton);
	$tmpButt=chr($tmpButt);
	my $bouton96=$frame9->Checkbutton(-onvalue=>$tmpButt, -offvalue=>$transcodeurTkReplaceChar, -text=>$tmpButt, -variable => \$varBouton96, -relief => 'flat')->pack();
	$bouton96->select;
	push(@selectedBouttons,$bouton96);
    }
    if (scalar @TableButton >  0) {
	$tmpButt=shift(@TableButton);
	$tmpButt=chr($tmpButt);
	my $bouton97=$frame9->Checkbutton(-onvalue=>$tmpButt, -offvalue=>$transcodeurTkReplaceChar, -text=>$tmpButt, -variable => \$varBouton97, -relief => 'flat')->pack();
	$bouton97->select;
	push(@selectedBouttons,$bouton97);
    }
    if (scalar @TableButton >  0) {
	$tmpButt=shift(@TableButton);
	$tmpButt=chr($tmpButt);
	my $bouton98=$frame9->Checkbutton(-onvalue=>$tmpButt, -offvalue=>$transcodeurTkReplaceChar, -text=>$tmpButt, -variable => \$varBouton98, -relief => 'flat')->pack();
	$bouton98->select;
	push(@selectedBouttons,$bouton98);
    }
    if (scalar @TableButton >  0) {
	$tmpButt=shift(@TableButton);
	$tmpButt=chr($tmpButt);
	my $bouton99=$frame9->Checkbutton(-onvalue=>$tmpButt, -offvalue=>$transcodeurTkReplaceChar, -text=>$tmpButt, -variable => \$varBouton99, -relief => 'flat')->pack();
	$bouton99->select;
	push(@selectedBouttons,$bouton99);
    }
    if (scalar @TableButton >  0) {
	$tmpButt=shift(@TableButton);
	$tmpButt=chr($tmpButt);
	my $bouton910=$frame9->Checkbutton(-onvalue=>$tmpButt, -offvalue=>$transcodeurTkReplaceChar, -text=>$tmpButt, -variable => \$varBouton910, -relief => 'flat')->pack();
	$bouton910->select;
	push(@selectedBouttons,$bouton910);
    }
    if (scalar @TableButton >  0) {
	$tmpButt=shift(@TableButton);
	$tmpButt=chr($tmpButt);
	my $bouton911=$frame9->Checkbutton(-onvalue=>$tmpButt, -offvalue=>$transcodeurTkReplaceChar, -text=>$tmpButt, -variable => \$varBouton911, -relief => 'flat')->pack();
	$bouton911->select;
	push(@selectedBouttons,$bouton911);
    }
    if (scalar @TableButton >  0) {
	$tmpButt=shift(@TableButton);
	$tmpButt=chr($tmpButt);
	my $bouton912=$frame9->Checkbutton(-onvalue=>$tmpButt, -offvalue=>$transcodeurTkReplaceChar, -text=>$tmpButt, -variable => \$varBouton912, -relief => 'flat')->pack();
	$bouton912->select;
	push(@selectedBouttons,$bouton912);
    }
    if (scalar @TableButton >  0) {
	$tmpButt=shift(@TableButton);
	$tmpButt=chr($tmpButt);
	my $bouton913=$frame9->Checkbutton(-onvalue=>$tmpButt, -offvalue=>$transcodeurTkReplaceChar, -text=>$tmpButt, -variable => \$varBouton913, -relief => 'flat')->pack();
	$bouton913->select;
	push(@selectedBouttons,$bouton913);
    }
    if (scalar @TableButton >  0) {
	$tmpButt=shift(@TableButton);
	$tmpButt=chr($tmpButt);
	my $bouton914=$frame9->Checkbutton(-onvalue=>$tmpButt, -offvalue=>$transcodeurTkReplaceChar, -text=>$tmpButt, -variable => \$varBouton914, -relief => 'flat')->pack();
	$bouton914->select;
	push(@selectedBouttons,$bouton914);
    }
    if (scalar @TableButton >  0) {
	$tmpButt=shift(@TableButton);
	$tmpButt=chr($tmpButt);
	my $bouton915=$frame9->Checkbutton(-onvalue=>$tmpButt, -offvalue=>$transcodeurTkReplaceChar, -text=>$tmpButt, -variable => \$varBouton915, -relief => 'flat')->pack();
	$bouton915->select;
	push(@selectedBouttons,$bouton915);
    }
    if (scalar @TableButton >  0) {
	$tmpButt=shift(@TableButton);
	$tmpButt=chr($tmpButt);
	my $bouton916=$frame9->Checkbutton(-onvalue=>$tmpButt, -offvalue=>$transcodeurTkReplaceChar, -text=>$tmpButt, -variable => \$varBouton916, -relief => 'flat')->pack();
	$bouton916->select;
	push(@selectedBouttons,$bouton916);
    }
    if (scalar @TableButton >  0) {
	$tmpButt=shift(@TableButton);
	$tmpButt=chr($tmpButt);
	my $bouton917=$frame9->Checkbutton(-onvalue=>$tmpButt, -offvalue=>$transcodeurTkReplaceChar, -text=>$tmpButt, -variable => \$varBouton917, -relief => 'flat')->pack();
	$bouton917->select;
	push(@selectedBouttons,$bouton917);
    }
    if (scalar @TableButton >  0) {
	$tmpButt=shift(@TableButton);
	$tmpButt=chr($tmpButt);
	my $bouton918=$frame9->Checkbutton(-onvalue=>$tmpButt, -offvalue=>$transcodeurTkReplaceChar, -text=>$tmpButt, -variable => \$varBouton918, -relief => 'flat')->pack();
	$bouton918->select;
	push(@selectedBouttons,$bouton918);
    }
    if (scalar @TableButton >  0) {
	$tmpButt=shift(@TableButton);
	$tmpButt=chr($tmpButt);
	my $bouton919=$frame9->Checkbutton(-onvalue=>$tmpButt, -offvalue=>$transcodeurTkReplaceChar, -text=>$tmpButt, -variable => \$varBouton919, -relief => 'flat')->pack();
	$bouton919->select;
	push(@selectedBouttons,$bouton919);
    }
    if (scalar @TableButton >  0) {
	$tmpButt=shift(@TableButton);
	$tmpButt=chr($tmpButt);
	my $bouton920=$frame9->Checkbutton(-onvalue=>$tmpButt, -offvalue=>$transcodeurTkReplaceChar, -text=>$tmpButt, -variable => \$varBouton920, -relief => 'flat')->pack();
	$bouton920->select;
	push(@selectedBouttons,$bouton920);
    }
    if (scalar @TableButton >  0) {
	$tmpButt=shift(@TableButton);
	$tmpButt=chr($tmpButt);
	my $boutona11=$frameb1->Checkbutton(-onvalue=>$tmpButt, -offvalue=>$transcodeurTkReplaceChar, -text=>$tmpButt, -variable => \$varBoutona11, -relief => 'flat')->pack();
	$boutona11->select;
	push(@selectedBouttons,$boutona11);
    }
    if (scalar @TableButton >  0) {
	$tmpButt=shift(@TableButton);
	$tmpButt=chr($tmpButt);
	my $boutona12=$frameb1->Checkbutton(-onvalue=>$tmpButt, -offvalue=>$transcodeurTkReplaceChar, -text=>$tmpButt, -variable => \$varBoutona12, -relief => 'flat')->pack();
	$boutona12->select;
	push(@selectedBouttons,$boutona12);
    }
    if (scalar @TableButton >  0) {
	$tmpButt=shift(@TableButton);
	$tmpButt=chr($tmpButt);
	my $boutona13=$frameb1->Checkbutton(-onvalue=>$tmpButt, -offvalue=>$transcodeurTkReplaceChar, -text=>$tmpButt, -variable => \$varBoutona13, -relief => 'flat')->pack();
	$boutona13->select;
	push(@selectedBouttons,$boutona13);
    }
    if (scalar @TableButton >  0) {
	$tmpButt=shift(@TableButton);
	$tmpButt=chr($tmpButt);
	my $boutona14=$frameb1->Checkbutton(-onvalue=>$tmpButt, -offvalue=>$transcodeurTkReplaceChar, -text=>$tmpButt, -variable => \$varBoutona14, -relief => 'flat')->pack();
	$boutona14->select;
	push(@selectedBouttons,$boutona14);
    }
    if (scalar @TableButton >  0) {
	$tmpButt=shift(@TableButton);
	$tmpButt=chr($tmpButt);
	my $boutona15=$frameb1->Checkbutton(-onvalue=>$tmpButt, -offvalue=>$transcodeurTkReplaceChar, -text=>$tmpButt, -variable => \$varBoutona15, -relief => 'flat')->pack();
	$boutona15->select;
	push(@selectedBouttons,$boutona15);
    }
    if (scalar @TableButton >  0) {
	$tmpButt=shift(@TableButton);
	$tmpButt=chr($tmpButt);
	my $boutona16=$frameb1->Checkbutton(-onvalue=>$tmpButt, -offvalue=>$transcodeurTkReplaceChar, -text=>$tmpButt, -variable => \$varBoutona16, -relief => 'flat')->pack();
	$boutona16->select;
	push(@selectedBouttons,$boutona16);
    }
    if (scalar @TableButton >  0) {
	$tmpButt=shift(@TableButton);
	$tmpButt=chr($tmpButt);
	my $boutona17=$frameb1->Checkbutton(-onvalue=>$tmpButt, -offvalue=>$transcodeurTkReplaceChar, -text=>$tmpButt, -variable => \$varBoutona17, -relief => 'flat')->pack();
	$boutona17->select;
	push(@selectedBouttons,$boutona17);
    }
    if (scalar @TableButton >  0) {
	$tmpButt=shift(@TableButton);
	$tmpButt=chr($tmpButt);
	my $boutona18=$frameb1->Checkbutton(-onvalue=>$tmpButt, -offvalue=>$transcodeurTkReplaceChar, -text=>$tmpButt, -variable => \$varBoutona18, -relief => 'flat')->pack();
	$boutona18->select;
	push(@selectedBouttons,$boutona18);
    }
    if (scalar @TableButton >  0) {
	$tmpButt=shift(@TableButton);
	$tmpButt=chr($tmpButt);
	my $boutona19=$frameb1->Checkbutton(-onvalue=>$tmpButt, -offvalue=>$transcodeurTkReplaceChar, -text=>$tmpButt, -variable => \$varBoutona19, -relief => 'flat')->pack();
	$boutona19->select;
	push(@selectedBouttons,$boutona19);
    }
    if (scalar @TableButton >  0) {
	$tmpButt=shift(@TableButton);
	$tmpButt=chr($tmpButt);
	my $boutona110=$frameb1->Checkbutton(-onvalue=>$tmpButt, -offvalue=>$transcodeurTkReplaceChar, -text=>$tmpButt, -variable => \$varBoutona110, -relief => 'flat')->pack();
	$boutona110->select;
	push(@selectedBouttons,$boutona110);
    }
    if (scalar @TableButton >  0) {
	$tmpButt=shift(@TableButton);
	$tmpButt=chr($tmpButt);
	my $boutona111=$frameb1->Checkbutton(-onvalue=>$tmpButt, -offvalue=>$transcodeurTkReplaceChar, -text=>$tmpButt, -variable => \$varBoutona111, -relief => 'flat')->pack();
	$boutona111->select;
	push(@selectedBouttons,$boutona111);
    }
    if (scalar @TableButton >  0) {
	$tmpButt=shift(@TableButton);
	$tmpButt=chr($tmpButt);
	my $boutona112=$frameb1->Checkbutton(-onvalue=>$tmpButt, -offvalue=>$transcodeurTkReplaceChar, -text=>$tmpButt, -variable => \$varBoutona112, -relief => 'flat')->pack();
	$boutona112->select;
	push(@selectedBouttons,$boutona112);
    }
    if (scalar @TableButton >  0) {
	$tmpButt=shift(@TableButton);
	$tmpButt=chr($tmpButt);
	my $boutona113=$frameb1->Checkbutton(-onvalue=>$tmpButt, -offvalue=>$transcodeurTkReplaceChar, -text=>$tmpButt, -variable => \$varBoutona113, -relief => 'flat')->pack();
	$boutona113->select;
	push(@selectedBouttons,$boutona113);
    }
    if (scalar @TableButton >  0) {
	$tmpButt=shift(@TableButton);
	$tmpButt=chr($tmpButt);
	my $boutona114=$frameb1->Checkbutton(-onvalue=>$tmpButt, -offvalue=>$transcodeurTkReplaceChar, -text=>$tmpButt, -variable => \$varBoutona114, -relief => 'flat')->pack();
	$boutona114->select;
	push(@selectedBouttons,$boutona114);
    }
    if (scalar @TableButton >  0) {
	$tmpButt=shift(@TableButton);
	$tmpButt=chr($tmpButt);
	my $boutona115=$frameb1->Checkbutton(-onvalue=>$tmpButt, -offvalue=>$transcodeurTkReplaceChar, -text=>$tmpButt, -variable => \$varBoutona115, -relief => 'flat')->pack();
	$boutona115->select;
	push(@selectedBouttons,$boutona115);
    }
    if (scalar @TableButton >  0) {
	$tmpButt=shift(@TableButton);
	$tmpButt=chr($tmpButt);
	my $boutona116=$frameb1->Checkbutton(-onvalue=>$tmpButt, -offvalue=>$transcodeurTkReplaceChar, -text=>$tmpButt, -variable => \$varBoutona116, -relief => 'flat')->pack();
	$boutona116->select;
	push(@selectedBouttons,$boutona116);
    }
    if (scalar @TableButton >  0) {
	$tmpButt=shift(@TableButton);
	$tmpButt=chr($tmpButt);
	my $boutona117=$frameb1->Checkbutton(-onvalue=>$tmpButt, -offvalue=>$transcodeurTkReplaceChar, -text=>$tmpButt, -variable => \$varBoutona117, -relief => 'flat')->pack();
	$boutona117->select;
	push(@selectedBouttons,$boutona117);
    }
    if (scalar @TableButton >  0) {
	$tmpButt=shift(@TableButton);
	$tmpButt=chr($tmpButt);
	my $boutona118=$frameb1->Checkbutton(-onvalue=>$tmpButt, -offvalue=>$transcodeurTkReplaceChar, -text=>$tmpButt, -variable => \$varBoutona118, -relief => 'flat')->pack();
	$boutona118->select;
	push(@selectedBouttons,$boutona118);
    }
    if (scalar @TableButton >  0) {
	$tmpButt=shift(@TableButton);
	$tmpButt=chr($tmpButt);
	my $boutona119=$frameb1->Checkbutton(-onvalue=>$tmpButt, -offvalue=>$transcodeurTkReplaceChar, -text=>$tmpButt, -variable => \$varBoutona119, -relief => 'flat')->pack();
	$boutona119->select;
	push(@selectedBouttons,$boutona119);
    }
    if (scalar @TableButton >  0) {
	$tmpButt=shift(@TableButton);
	$tmpButt=chr($tmpButt);
	my $boutona120=$frameb1->Checkbutton(-onvalue=>$tmpButt, -offvalue=>$transcodeurTkReplaceChar, -text=>$tmpButt, -variable => \$varBoutona120, -relief => 'flat')->pack();
	$boutona120->select;
	push(@selectedBouttons,$boutona120);
    }
    if (scalar @TableButton >  0) {
	$tmpButt=shift(@TableButton);
	$tmpButt=chr($tmpButt);
	my $boutona21=$frameb2->Checkbutton(-onvalue=>$tmpButt, -offvalue=>$transcodeurTkReplaceChar, -text=>$tmpButt, -variable => \$varBoutona21, -relief => 'flat')->pack();
	$boutona21->select;
	push(@selectedBouttons,$boutona21);
    }
    if (scalar @TableButton >  0) {
	$tmpButt=shift(@TableButton);
	$tmpButt=chr($tmpButt);
	my $boutona22=$frameb2->Checkbutton(-onvalue=>$tmpButt, -offvalue=>$transcodeurTkReplaceChar, -text=>$tmpButt, -variable => \$varBoutona22, -relief => 'flat')->pack();
	$boutona22->select;
	push(@selectedBouttons,$boutona22);
    }
    if (scalar @TableButton >  0) {
	$tmpButt=shift(@TableButton);
	$tmpButt=chr($tmpButt);
	my $boutona23=$frameb2->Checkbutton(-onvalue=>$tmpButt, -offvalue=>$transcodeurTkReplaceChar, -text=>$tmpButt, -variable => \$varBoutona23, -relief => 'flat')->pack();
	$boutona23->select;
	push(@selectedBouttons,$boutona23);
    }
    if (scalar @TableButton >  0) {
	$tmpButt=shift(@TableButton);
	$tmpButt=chr($tmpButt);
	my $boutona24=$frameb2->Checkbutton(-onvalue=>$tmpButt, -offvalue=>$transcodeurTkReplaceChar, -text=>$tmpButt, -variable => \$varBoutona24, -relief => 'flat')->pack();
	$boutona24->select;
	push(@selectedBouttons,$boutona24);
    }
    if (scalar @TableButton >  0) {
	$tmpButt=shift(@TableButton);
	$tmpButt=chr($tmpButt);
	my $boutona25=$frameb2->Checkbutton(-onvalue=>$tmpButt, -offvalue=>$transcodeurTkReplaceChar, -text=>$tmpButt, -variable => \$varBoutona25, -relief => 'flat')->pack();
	$boutona25->select;
	push(@selectedBouttons,$boutona25);
    }
    if (scalar @TableButton >  0) {
	$tmpButt=shift(@TableButton);
	$tmpButt=chr($tmpButt);
	my $boutona26=$frameb2->Checkbutton(-onvalue=>$tmpButt, -offvalue=>$transcodeurTkReplaceChar, -text=>$tmpButt, -variable => \$varBoutona26, -relief => 'flat')->pack();
	$boutona26->select;
	push(@selectedBouttons,$boutona26);
    }
    if (scalar @TableButton >  0) {
	$tmpButt=shift(@TableButton);
	$tmpButt=chr($tmpButt);
	my $boutona27=$frameb2->Checkbutton(-onvalue=>$tmpButt, -offvalue=>$transcodeurTkReplaceChar, -text=>$tmpButt, -variable => \$varBoutona27, -relief => 'flat')->pack();
	$boutona27->select;
	push(@selectedBouttons,$boutona27);
    }
    if (scalar @TableButton >  0) {
	$tmpButt=shift(@TableButton);
	$tmpButt=chr($tmpButt);
	my $boutona28=$frameb2->Checkbutton(-onvalue=>$tmpButt, -offvalue=>$transcodeurTkReplaceChar, -text=>$tmpButt, -variable => \$varBoutona28, -relief => 'flat')->pack();
	$boutona28->select;
	push(@selectedBouttons,$boutona28);
    }
    if (scalar @TableButton >  0) {
	$tmpButt=shift(@TableButton);
	$tmpButt=chr($tmpButt);
	my $boutona29=$frameb2->Checkbutton(-onvalue=>$tmpButt, -offvalue=>$transcodeurTkReplaceChar, -text=>$tmpButt, -variable => \$varBoutona29, -relief => 'flat')->pack();
	$boutona29->select;
	push(@selectedBouttons,$boutona29);
    }
    if (scalar @TableButton >  0) {
	$tmpButt=shift(@TableButton);
	$tmpButt=chr($tmpButt);
	my $boutona210=$frameb2->Checkbutton(-onvalue=>$tmpButt, -offvalue=>$transcodeurTkReplaceChar, -text=>$tmpButt, -variable => \$varBoutona210, -relief => 'flat')->pack();
	$boutona210->select;
	push(@selectedBouttons,$boutona210);
    }
    if (scalar @TableButton >  0) {
	$tmpButt=shift(@TableButton);
	$tmpButt=chr($tmpButt);
	my $boutona211=$frameb2->Checkbutton(-onvalue=>$tmpButt, -offvalue=>$transcodeurTkReplaceChar, -text=>$tmpButt, -variable => \$varBoutona211, -relief => 'flat')->pack();
	$boutona211->select;
	push(@selectedBouttons,$boutona211);
    }
    if (scalar @TableButton >  0) {
	$tmpButt=shift(@TableButton);
	$tmpButt=chr($tmpButt);
	my $boutona212=$frameb2->Checkbutton(-onvalue=>$tmpButt, -offvalue=>$transcodeurTkReplaceChar, -text=>$tmpButt, -variable => \$varBoutona212, -relief => 'flat')->pack();
	$boutona212->select;
	push(@selectedBouttons,$boutona212);
    }
    if (scalar @TableButton >  0) {
	$tmpButt=shift(@TableButton);
	$tmpButt=chr($tmpButt);
	my $boutona213=$frameb2->Checkbutton(-onvalue=>$tmpButt, -offvalue=>$transcodeurTkReplaceChar, -text=>$tmpButt, -variable => \$varBoutona213, -relief => 'flat')->pack();
	$boutona213->select;
	push(@selectedBouttons,$boutona213);
    }
    if (scalar @TableButton >  0) {
	$tmpButt=shift(@TableButton);
	$tmpButt=chr($tmpButt);
	my $boutona214=$frameb2->Checkbutton(-onvalue=>$tmpButt, -offvalue=>$transcodeurTkReplaceChar, -text=>$tmpButt, -variable => \$varBoutona214, -relief => 'flat')->pack();
	$boutona214->select;
	push(@selectedBouttons,$boutona214);
    }
    if (scalar @TableButton >  0) {
	$tmpButt=shift(@TableButton);
	$tmpButt=chr($tmpButt);
	my $boutona215=$frameb2->Checkbutton(-onvalue=>$tmpButt, -offvalue=>$transcodeurTkReplaceChar, -text=>$tmpButt, -variable => \$varBoutona215, -relief => 'flat')->pack();
	$boutona215->select;
	push(@selectedBouttons,$boutona215);
    }
    if (scalar @TableButton >  0) {
	$tmpButt=shift(@TableButton);
	$tmpButt=chr($tmpButt);
	my $boutona216=$frameb2->Checkbutton(-onvalue=>$tmpButt, -offvalue=>$transcodeurTkReplaceChar, -text=>$tmpButt, -variable => \$varBoutona216, -relief => 'flat')->pack();
	$boutona216->select;
	push(@selectedBouttons,$boutona216);
    }
    if (scalar @TableButton >  0) {
	$tmpButt=shift(@TableButton);
	$tmpButt=chr($tmpButt);
	my $boutona217=$frameb2->Checkbutton(-onvalue=>$tmpButt, -offvalue=>$transcodeurTkReplaceChar, -text=>$tmpButt, -variable => \$varBoutona217, -relief => 'flat')->pack();
	$boutona217->select;
	push(@selectedBouttons,$boutona217);
    }
    if (scalar @TableButton >  0) {
	$tmpButt=shift(@TableButton);
	$tmpButt=chr($tmpButt);
	my $boutona218=$frameb2->Checkbutton(-onvalue=>$tmpButt, -offvalue=>$transcodeurTkReplaceChar, -text=>$tmpButt, -variable => \$varBoutona218, -relief => 'flat')->pack();
	$boutona218->select;
	push(@selectedBouttons,$boutona218);
    }
    if (scalar @TableButton >  0) {
	$tmpButt=shift(@TableButton);
	$tmpButt=chr($tmpButt);
	my $boutona219=$frameb2->Checkbutton(-onvalue=>$tmpButt, -offvalue=>$transcodeurTkReplaceChar, -text=>$tmpButt, -variable => \$varBoutona219, -relief => 'flat')->pack();
	$boutona219->select;
	push(@selectedBouttons,$boutona219);
    }
    if (scalar @TableButton >  0) {
	$tmpButt=shift(@TableButton);
	$tmpButt=chr($tmpButt);
	my $boutona220=$frameb2->Checkbutton(-onvalue=>$tmpButt, -offvalue=>$transcodeurTkReplaceChar, -text=>$tmpButt, -variable => \$varBoutona220, -relief => 'flat')->pack();
	$boutona220->select;
	push(@selectedBouttons,$boutona220);
    }
    if (scalar @TableButton >  0) {
	$tmpButt=shift(@TableButton);
	$tmpButt=chr($tmpButt);
	my $boutona31=$frameb3->Checkbutton(-onvalue=>$tmpButt, -offvalue=>$transcodeurTkReplaceChar, -text=>$tmpButt, -variable => \$varBoutona31, -relief => 'flat')->pack();
	$boutona31->select;
	push(@selectedBouttons,$boutona31);
    }
    if (scalar @TableButton >  0) {
	$tmpButt=shift(@TableButton);
	$tmpButt=chr($tmpButt);
	my $boutona32=$frameb3->Checkbutton(-onvalue=>$tmpButt, -offvalue=>$transcodeurTkReplaceChar, -text=>$tmpButt, -variable => \$varBoutona32, -relief => 'flat')->pack();
	$boutona32->select;
	push(@selectedBouttons,$boutona32);
    }
    if (scalar @TableButton >  0) {
	$tmpButt=shift(@TableButton);
	$tmpButt=chr($tmpButt);
	my $boutona33=$frameb3->Checkbutton(-onvalue=>$tmpButt, -offvalue=>$transcodeurTkReplaceChar, -text=>$tmpButt, -variable => \$varBoutona33, -relief => 'flat')->pack();
	$boutona33->select;
	push(@selectedBouttons,$boutona33);
    }
    if (scalar @TableButton >  0) {
	$tmpButt=shift(@TableButton);
	$tmpButt=chr($tmpButt);
	my $boutona34=$frameb3->Checkbutton(-onvalue=>$tmpButt, -offvalue=>$transcodeurTkReplaceChar, -text=>$tmpButt, -variable => \$varBoutona34, -relief => 'flat')->pack();
	$boutona34->select;
	push(@selectedBouttons,$boutona34);
    }
    if (scalar @TableButton >  0) {
	$tmpButt=shift(@TableButton);
	$tmpButt=chr($tmpButt);
	my $boutona35=$frameb3->Checkbutton(-onvalue=>$tmpButt, -offvalue=>$transcodeurTkReplaceChar, -text=>$tmpButt, -variable => \$varBoutona35, -relief => 'flat')->pack();
	$boutona35->select;
	push(@selectedBouttons,$boutona35);
    }
    if (scalar @TableButton >  0) {
	$tmpButt=shift(@TableButton);
	$tmpButt=chr($tmpButt);
	my $boutona36=$frameb3->Checkbutton(-onvalue=>$tmpButt, -offvalue=>$transcodeurTkReplaceChar, -text=>$tmpButt, -variable => \$varBoutona36, -relief => 'flat')->pack();
	$boutona36->select;
	push(@selectedBouttons,$boutona36);
    }
    if (scalar @TableButton >  0) {
	$tmpButt=shift(@TableButton);
	$tmpButt=chr($tmpButt);
	my $boutona37=$frameb3->Checkbutton(-onvalue=>$tmpButt, -offvalue=>$transcodeurTkReplaceChar, -text=>$tmpButt, -variable => \$varBoutona37, -relief => 'flat')->pack();
	$boutona37->select;
	push(@selectedBouttons,$boutona37);
    }
    if (scalar @TableButton >  0) {
	$tmpButt=shift(@TableButton);
	$tmpButt=chr($tmpButt);
	my $boutona38=$frameb3->Checkbutton(-onvalue=>$tmpButt, -offvalue=>$transcodeurTkReplaceChar, -text=>$tmpButt, -variable => \$varBoutona38, -relief => 'flat')->pack();
	$boutona38->select;
	push(@selectedBouttons,$boutona38);
    }
    if (scalar @TableButton >  0) {
	$tmpButt=shift(@TableButton);
	$tmpButt=chr($tmpButt);
	my $boutona39=$frameb3->Checkbutton(-onvalue=>$tmpButt, -offvalue=>$transcodeurTkReplaceChar, -text=>$tmpButt, -variable => \$varBoutona39, -relief => 'flat')->pack();
	$boutona39->select;
	push(@selectedBouttons,$boutona39);
    }
    if (scalar @TableButton >  0) {
	$tmpButt=shift(@TableButton);
	$tmpButt=chr($tmpButt);
	my $boutona310=$frameb3->Checkbutton(-onvalue=>$tmpButt, -offvalue=>$transcodeurTkReplaceChar, -text=>$tmpButt, -variable => \$varBoutona310, -relief => 'flat')->pack();
	$boutona310->select;
	push(@selectedBouttons,$boutona310);
    }
    if (scalar @TableButton >  0) {
	$tmpButt=shift(@TableButton);
	$tmpButt=chr($tmpButt);
	my $boutona311=$frameb3->Checkbutton(-onvalue=>$tmpButt, -offvalue=>$transcodeurTkReplaceChar, -text=>$tmpButt, -variable => \$varBoutona311, -relief => 'flat')->pack();
	$boutona311->select;
	push(@selectedBouttons,$boutona311);
    }
    if (scalar @TableButton >  0) {
	$tmpButt=shift(@TableButton);
	$tmpButt=chr($tmpButt);
	my $boutona312=$frameb3->Checkbutton(-onvalue=>$tmpButt, -offvalue=>$transcodeurTkReplaceChar, -text=>$tmpButt, -variable => \$varBoutona312, -relief => 'flat')->pack();
	$boutona312->select;
	push(@selectedBouttons,$boutona312);
    }
    if (scalar @TableButton >  0) {
	$tmpButt=shift(@TableButton);
	$tmpButt=chr($tmpButt);
	my $boutona313=$frameb3->Checkbutton(-onvalue=>$tmpButt, -offvalue=>$transcodeurTkReplaceChar, -text=>$tmpButt, -variable => \$varBoutona313, -relief => 'flat')->pack();
	$boutona313->select;
	push(@selectedBouttons,$boutona313);
    }
    if (scalar @TableButton >  0) {
	$tmpButt=shift(@TableButton);
	$tmpButt=chr($tmpButt);
	my $boutona314=$frameb3->Checkbutton(-onvalue=>$tmpButt, -offvalue=>$transcodeurTkReplaceChar, -text=>$tmpButt, -variable => \$varBoutona314, -relief => 'flat')->pack();
	$boutona314->select;
	push(@selectedBouttons,$boutona314);
    }
    if (scalar @TableButton >  0) {
	$tmpButt=shift(@TableButton);
	$tmpButt=chr($tmpButt);
	my $boutona315=$frameb3->Checkbutton(-onvalue=>$tmpButt, -offvalue=>$transcodeurTkReplaceChar, -text=>$tmpButt, -variable => \$varBoutona315, -relief => 'flat')->pack();
	$boutona315->select;
	push(@selectedBouttons,$boutona315);
    }
    if (scalar @TableButton >  0) {
	$tmpButt=shift(@TableButton);
	$tmpButt=chr($tmpButt);
	my $boutona316=$frameb3->Checkbutton(-onvalue=>$tmpButt, -offvalue=>$transcodeurTkReplaceChar, -text=>$tmpButt, -variable => \$varBoutona316, -relief => 'flat')->pack();
	$boutona316->select;
	push(@selectedBouttons,$boutona316);
    }
    if (scalar @TableButton >  0) {
	$tmpButt=shift(@TableButton);
	$tmpButt=chr($tmpButt);
	my $boutona317=$frameb3->Checkbutton(-onvalue=>$tmpButt, -offvalue=>$transcodeurTkReplaceChar, -text=>$tmpButt, -variable => \$varBoutona317, -relief => 'flat')->pack();
	$boutona317->select;
	push(@selectedBouttons,$boutona317);
    }
    if (scalar @TableButton >  0) {
	$tmpButt=shift(@TableButton);
	$tmpButt=chr($tmpButt);
	my $boutona318=$frameb3->Checkbutton(-onvalue=>$tmpButt, -offvalue=>$transcodeurTkReplaceChar, -text=>$tmpButt, -variable => \$varBoutona318, -relief => 'flat')->pack();
	$boutona318->select;
	push(@selectedBouttons,$boutona318);
    }
    if (scalar @TableButton >  0) {
	$tmpButt=shift(@TableButton);
	$tmpButt=chr($tmpButt);
	my $boutona319=$frameb3->Checkbutton(-onvalue=>$tmpButt, -offvalue=>$transcodeurTkReplaceChar, -text=>$tmpButt, -variable => \$varBoutona319, -relief => 'flat')->pack();
	$boutona319->select;
	push(@selectedBouttons,$boutona319);
    }
    if (scalar @TableButton >  0) {
	$tmpButt=shift(@TableButton);
	$tmpButt=chr($tmpButt);
	my $boutona320=$frameb3->Checkbutton(-onvalue=>$tmpButt, -offvalue=>$transcodeurTkReplaceChar, -text=>$tmpButt, -variable => \$varBoutona320, -relief => 'flat')->pack();
	$boutona320->select;
	push(@selectedBouttons,$boutona320);
    }
    if (scalar @TableButton >  0) {
	$tmpButt=shift(@TableButton);
	$tmpButt=chr($tmpButt);
	my $boutona41=$frameb4->Checkbutton(-onvalue=>$tmpButt, -offvalue=>$transcodeurTkReplaceChar, -text=>$tmpButt, -variable => \$varBoutona41, -relief => 'flat')->pack();
	$boutona41->select;
	push(@selectedBouttons,$boutona41);
    }
    if (scalar @TableButton >  0) {
	$tmpButt=shift(@TableButton);
	$tmpButt=chr($tmpButt);
	my $boutona42=$frameb4->Checkbutton(-onvalue=>$tmpButt, -offvalue=>$transcodeurTkReplaceChar, -text=>$tmpButt, -variable => \$varBoutona42, -relief => 'flat')->pack();
	$boutona42->select;
	push(@selectedBouttons,$boutona42);
    }
    if (scalar @TableButton >  0) {
	$tmpButt=shift(@TableButton);
	$tmpButt=chr($tmpButt);
	my $boutona43=$frameb4->Checkbutton(-onvalue=>$tmpButt, -offvalue=>$transcodeurTkReplaceChar, -text=>$tmpButt, -variable => \$varBoutona43, -relief => 'flat')->pack();
	$boutona43->select;
	push(@selectedBouttons,$boutona43);
    }
    if (scalar @TableButton >  0) {
	$tmpButt=shift(@TableButton);
	$tmpButt=chr($tmpButt);
	my $boutona44=$frameb4->Checkbutton(-onvalue=>$tmpButt, -offvalue=>$transcodeurTkReplaceChar, -text=>$tmpButt, -variable => \$varBoutona44, -relief => 'flat')->pack();
	$boutona44->select;
	push(@selectedBouttons,$boutona44);
    }
    if (scalar @TableButton >  0) {
	$tmpButt=shift(@TableButton);
	$tmpButt=chr($tmpButt);
	my $boutona45=$frameb4->Checkbutton(-onvalue=>$tmpButt, -offvalue=>$transcodeurTkReplaceChar, -text=>$tmpButt, -variable => \$varBoutona45, -relief => 'flat')->pack();
	$boutona45->select;
	push(@selectedBouttons,$boutona45);
    }
    if (scalar @TableButton >  0) {
	$tmpButt=shift(@TableButton);
	$tmpButt=chr($tmpButt);
	my $boutona46=$frameb4->Checkbutton(-onvalue=>$tmpButt, -offvalue=>$transcodeurTkReplaceChar, -text=>$tmpButt, -variable => \$varBoutona46, -relief => 'flat')->pack();
	$boutona46->select;
	push(@selectedBouttons,$boutona46);
    }
    if (scalar @TableButton >  0) {
	$tmpButt=shift(@TableButton);
	$tmpButt=chr($tmpButt);
	my $boutona47=$frameb4->Checkbutton(-onvalue=>$tmpButt, -offvalue=>$transcodeurTkReplaceChar, -text=>$tmpButt, -variable => \$varBoutona47, -relief => 'flat')->pack();
	$boutona47->select;
	push(@selectedBouttons,$boutona47);
    }
    if (scalar @TableButton >  0) {
	$tmpButt=shift(@TableButton);
	$tmpButt=chr($tmpButt);
	my $boutona48=$frameb4->Checkbutton(-onvalue=>$tmpButt, -offvalue=>$transcodeurTkReplaceChar, -text=>$tmpButt, -variable => \$varBoutona48, -relief => 'flat')->pack();
	$boutona48->select;
	push(@selectedBouttons,$boutona48);
    }
    if (scalar @TableButton >  0) {
	$tmpButt=shift(@TableButton);
	$tmpButt=chr($tmpButt);
	my $boutona49=$frameb4->Checkbutton(-onvalue=>$tmpButt, -offvalue=>$transcodeurTkReplaceChar, -text=>$tmpButt, -variable => \$varBoutona49, -relief => 'flat')->pack();
	$boutona49->select;
	push(@selectedBouttons,$boutona49);
    }
    if (scalar @TableButton >  0) {
	$tmpButt=shift(@TableButton);
	$tmpButt=chr($tmpButt);
	my $boutona410=$frameb4->Checkbutton(-onvalue=>$tmpButt, -offvalue=>$transcodeurTkReplaceChar, -text=>$tmpButt, -variable => \$varBoutona410, -relief => 'flat')->pack();
	$boutona410->select;
	push(@selectedBouttons,$boutona410);
    }
    if (scalar @TableButton >  0) {
	$tmpButt=shift(@TableButton);
	$tmpButt=chr($tmpButt);
	my $boutona411=$frameb4->Checkbutton(-onvalue=>$tmpButt, -offvalue=>$transcodeurTkReplaceChar, -text=>$tmpButt, -variable => \$varBoutona411, -relief => 'flat')->pack();
	$boutona411->select;
	push(@selectedBouttons,$boutona411);
    }
    if (scalar @TableButton >  0) {
	$tmpButt=shift(@TableButton);
	$tmpButt=chr($tmpButt);
	my $boutona412=$frameb4->Checkbutton(-onvalue=>$tmpButt, -offvalue=>$transcodeurTkReplaceChar, -text=>$tmpButt, -variable => \$varBoutona412, -relief => 'flat')->pack();
	$boutona412->select;
	push(@selectedBouttons,$boutona412);
    }
    if (scalar @TableButton >  0) {
	$tmpButt=shift(@TableButton);
	$tmpButt=chr($tmpButt);
	my $boutona413=$frameb4->Checkbutton(-onvalue=>$tmpButt, -offvalue=>$transcodeurTkReplaceChar, -text=>$tmpButt, -variable => \$varBoutona413, -relief => 'flat')->pack();
	$boutona413->select;
	push(@selectedBouttons,$boutona413);
    }
    if (scalar @TableButton >  0) {
	$tmpButt=shift(@TableButton);
	$tmpButt=chr($tmpButt);
	my $boutona414=$frameb4->Checkbutton(-onvalue=>$tmpButt, -offvalue=>$transcodeurTkReplaceChar, -text=>$tmpButt, -variable => \$varBoutona414, -relief => 'flat')->pack();
	$boutona414->select;
	push(@selectedBouttons,$boutona414);
    }
    if (scalar @TableButton >  0) {
	$tmpButt=shift(@TableButton);
	$tmpButt=chr($tmpButt);
	my $boutona415=$frameb4->Checkbutton(-onvalue=>$tmpButt, -offvalue=>$transcodeurTkReplaceChar, -text=>$tmpButt, -variable => \$varBoutona415, -relief => 'flat')->pack();
	$boutona415->select;
	push(@selectedBouttons,$boutona415);
    }
    if (scalar @TableButton >  0) {
	$tmpButt=shift(@TableButton);
	$tmpButt=chr($tmpButt);
	my $boutona416=$frameb4->Checkbutton(-onvalue=>$tmpButt, -offvalue=>$transcodeurTkReplaceChar, -text=>$tmpButt, -variable => \$varBoutona416, -relief => 'flat')->pack();
	$boutona416->select;
	push(@selectedBouttons,$boutona416);
    }
    if (scalar @TableButton >  0) {
	$tmpButt=shift(@TableButton);
	$tmpButt=chr($tmpButt);
	my $boutona417=$frameb4->Checkbutton(-onvalue=>$tmpButt, -offvalue=>$transcodeurTkReplaceChar, -text=>$tmpButt, -variable => \$varBoutona417, -relief => 'flat')->pack();
	$boutona417->select;
	push(@selectedBouttons,$boutona417);
    }
    if (scalar @TableButton >  0) {
	$tmpButt=shift(@TableButton);
	$tmpButt=chr($tmpButt);
	my $boutona418=$frameb4->Checkbutton(-onvalue=>$tmpButt, -offvalue=>$transcodeurTkReplaceChar, -text=>$tmpButt, -variable => \$varBoutona418, -relief => 'flat')->pack();
	$boutona418->select;
	push(@selectedBouttons,$boutona418);
    }
    if (scalar @TableButton >  0) {
	$tmpButt=shift(@TableButton);
	$tmpButt=chr($tmpButt);
	my $boutona419=$frameb4->Checkbutton(-onvalue=>$tmpButt, -offvalue=>$transcodeurTkReplaceChar, -text=>$tmpButt, -variable => \$varBoutona419, -relief => 'flat')->pack();
	$boutona419->select;
	push(@selectedBouttons,$boutona419);
    }
    if (scalar @TableButton >  0) {
	$tmpButt=shift(@TableButton);
	$tmpButt=chr($tmpButt);
	my $boutona420=$frameb4->Checkbutton(-onvalue=>$tmpButt, -offvalue=>$transcodeurTkReplaceChar, -text=>$tmpButt, -variable => \$varBoutona420, -relief => 'flat')->pack();
	$boutona420->select;
	push(@selectedBouttons,$boutona420);
    }
    if (scalar @TableButton >  0) {
	$tmpButt=shift(@TableButton);
	$tmpButt=chr($tmpButt);
	my $boutona51=$frameb5->Checkbutton(-onvalue=>$tmpButt, -offvalue=>$transcodeurTkReplaceChar, -text=>$tmpButt, -variable => \$varBoutona51, -relief => 'flat')->pack();
	$boutona51->select;
	push(@selectedBouttons,$boutona51);
    }
    if (scalar @TableButton >  0) {
	$tmpButt=shift(@TableButton);
	$tmpButt=chr($tmpButt);
	my $boutona52=$frameb5->Checkbutton(-onvalue=>$tmpButt, -offvalue=>$transcodeurTkReplaceChar, -text=>$tmpButt, -variable => \$varBoutona52, -relief => 'flat')->pack();
	$boutona52->select;
	push(@selectedBouttons,$boutona52);
    }
    if (scalar @TableButton >  0) {
	$tmpButt=shift(@TableButton);
	$tmpButt=chr($tmpButt);
	my $boutona53=$frameb5->Checkbutton(-onvalue=>$tmpButt, -offvalue=>$transcodeurTkReplaceChar, -text=>$tmpButt, -variable => \$varBoutona53, -relief => 'flat')->pack();
	$boutona53->select;
	push(@selectedBouttons,$boutona53);
    }
    if (scalar @TableButton >  0) {
	$tmpButt=shift(@TableButton);
	$tmpButt=chr($tmpButt);
	my $boutona54=$frameb5->Checkbutton(-onvalue=>$tmpButt, -offvalue=>$transcodeurTkReplaceChar, -text=>$tmpButt, -variable => \$varBoutona54, -relief => 'flat')->pack();
	$boutona54->select;
	push(@selectedBouttons,$boutona54);
    }
    if (scalar @TableButton >  0) {
	$tmpButt=shift(@TableButton);
	$tmpButt=chr($tmpButt);
	my $boutona55=$frameb5->Checkbutton(-onvalue=>$tmpButt, -offvalue=>$transcodeurTkReplaceChar, -text=>$tmpButt, -variable => \$varBoutona55, -relief => 'flat')->pack();
	$boutona55->select;
	push(@selectedBouttons,$boutona55);
    }
    if (scalar @TableButton >  0) {
	$tmpButt=shift(@TableButton);
	$tmpButt=chr($tmpButt);
	my $boutona56=$frameb5->Checkbutton(-onvalue=>$tmpButt, -offvalue=>$transcodeurTkReplaceChar, -text=>$tmpButt, -variable => \$varBoutona56, -relief => 'flat')->pack();
	$boutona56->select;
	push(@selectedBouttons,$boutona56);
    }
    if (scalar @TableButton >  0) {
	$tmpButt=shift(@TableButton);
	$tmpButt=chr($tmpButt);
	my $boutona57=$frameb5->Checkbutton(-onvalue=>$tmpButt, -offvalue=>$transcodeurTkReplaceChar, -text=>$tmpButt, -variable => \$varBoutona57, -relief => 'flat')->pack();
	$boutona57->select;
	push(@selectedBouttons,$boutona57);
    }
    if (scalar @TableButton >  0) {
	$tmpButt=shift(@TableButton);
	$tmpButt=chr($tmpButt);
	my $boutona58=$frameb5->Checkbutton(-onvalue=>$tmpButt, -offvalue=>$transcodeurTkReplaceChar, -text=>$tmpButt, -variable => \$varBoutona58, -relief => 'flat')->pack();
	$boutona58->select;
	push(@selectedBouttons,$boutona58);
    }
    if (scalar @TableButton >  0) {
	$tmpButt=shift(@TableButton);
	$tmpButt=chr($tmpButt);
	my $boutona59=$frameb5->Checkbutton(-onvalue=>$tmpButt, -offvalue=>$transcodeurTkReplaceChar, -text=>$tmpButt, -variable => \$varBoutona59, -relief => 'flat')->pack();
	$boutona59->select;
	push(@selectedBouttons,$boutona59);
    }
    if (scalar @TableButton >  0) {
	$tmpButt=shift(@TableButton);
	$tmpButt=chr($tmpButt);
	my $boutona510=$frameb5->Checkbutton(-onvalue=>$tmpButt, -offvalue=>$transcodeurTkReplaceChar, -text=>$tmpButt, -variable => \$varBoutona510, -relief => 'flat')->pack();
	$boutona510->select;
	push(@selectedBouttons,$boutona510);
    }
    if (scalar @TableButton >  0) {
	$tmpButt=shift(@TableButton);
	$tmpButt=chr($tmpButt);
	my $boutona511=$frameb5->Checkbutton(-onvalue=>$tmpButt, -offvalue=>$transcodeurTkReplaceChar, -text=>$tmpButt, -variable => \$varBoutona511, -relief => 'flat')->pack();
	$boutona511->select;
	push(@selectedBouttons,$boutona511);
    }
    if (scalar @TableButton >  0) {
	$tmpButt=shift(@TableButton);
	$tmpButt=chr($tmpButt);
	my $boutona512=$frameb5->Checkbutton(-onvalue=>$tmpButt, -offvalue=>$transcodeurTkReplaceChar, -text=>$tmpButt, -variable => \$varBoutona512, -relief => 'flat')->pack();
	$boutona512->select;
	push(@selectedBouttons,$boutona512);
    }
    if (scalar @TableButton >  0) {
	$tmpButt=shift(@TableButton);
	$tmpButt=chr($tmpButt);
	my $boutona513=$frameb5->Checkbutton(-onvalue=>$tmpButt, -offvalue=>$transcodeurTkReplaceChar, -text=>$tmpButt, -variable => \$varBoutona513, -relief => 'flat')->pack();
	$boutona513->select;
	push(@selectedBouttons,$boutona513);
    }
    if (scalar @TableButton >  0) {
	$tmpButt=shift(@TableButton);
	$tmpButt=chr($tmpButt);
	my $boutona514=$frameb5->Checkbutton(-onvalue=>$tmpButt, -offvalue=>$transcodeurTkReplaceChar, -text=>$tmpButt, -variable => \$varBoutona514, -relief => 'flat')->pack();
	$boutona514->select;
	push(@selectedBouttons,$boutona514);
    }
    if (scalar @TableButton >  0) {
	$tmpButt=shift(@TableButton);
	$tmpButt=chr($tmpButt);
	my $boutona515=$frameb5->Checkbutton(-onvalue=>$tmpButt, -offvalue=>$transcodeurTkReplaceChar, -text=>$tmpButt, -variable => \$varBoutona515, -relief => 'flat')->pack();
	$boutona515->select;
	push(@selectedBouttons,$boutona515);
    }
    if (scalar @TableButton >  0) {
	$tmpButt=shift(@TableButton);
	$tmpButt=chr($tmpButt);
	my $boutona516=$frameb5->Checkbutton(-onvalue=>$tmpButt, -offvalue=>$transcodeurTkReplaceChar, -text=>$tmpButt, -variable => \$varBoutona516, -relief => 'flat')->pack();
	$boutona516->select;
	push(@selectedBouttons,$boutona516);
    }
    if (scalar @TableButton >  0) {
	$tmpButt=shift(@TableButton);
	$tmpButt=chr($tmpButt);
	my $boutona517=$frameb5->Checkbutton(-onvalue=>$tmpButt, -offvalue=>$transcodeurTkReplaceChar, -text=>$tmpButt, -variable => \$varBoutona517, -relief => 'flat')->pack();
	$boutona517->select;
	push(@selectedBouttons,$boutona517);
    }
    if (scalar @TableButton >  0) {
	$tmpButt=shift(@TableButton);
	$tmpButt=chr($tmpButt);
	my $boutona518=$frameb5->Checkbutton(-onvalue=>$tmpButt, -offvalue=>$transcodeurTkReplaceChar, -text=>$tmpButt, -variable => \$varBoutona518, -relief => 'flat')->pack();
	$boutona518->select;
	push(@selectedBouttons,$boutona518);
    }
    if (scalar @TableButton >  0) {
	$tmpButt=shift(@TableButton);
	$tmpButt=chr($tmpButt);
	my $boutona519=$frameb5->Checkbutton(-onvalue=>$tmpButt, -offvalue=>$transcodeurTkReplaceChar, -text=>$tmpButt, -variable => \$varBoutona519, -relief => 'flat')->pack();
	$boutona519->select;
	push(@selectedBouttons,$boutona519);
    }
    if (scalar @TableButton >  0) {
	$tmpButt=shift(@TableButton);
	$tmpButt=chr($tmpButt);
	my $boutona520=$frameb5->Checkbutton(-onvalue=>$tmpButt, -offvalue=>$transcodeurTkReplaceChar, -text=>$tmpButt, -variable => \$varBoutona520, -relief => 'flat')->pack();
	$boutona520->select;
	push(@selectedBouttons,$boutona520);
    }
    if (scalar @TableButton >  0) {
	$tmpButt=shift(@TableButton);
	$tmpButt=chr($tmpButt);
	my $boutona61=$frameb6->Checkbutton(-onvalue=>$tmpButt, -offvalue=>$transcodeurTkReplaceChar, -text=>$tmpButt, -variable => \$varBoutona61, -relief => 'flat')->pack();
	$boutona61->select;
	push(@selectedBouttons,$boutona61);
    }
    if (scalar @TableButton >  0) {
	$tmpButt=shift(@TableButton);
	$tmpButt=chr($tmpButt);
	my $boutona62=$frameb6->Checkbutton(-onvalue=>$tmpButt, -offvalue=>$transcodeurTkReplaceChar, -text=>$tmpButt, -variable => \$varBoutona62, -relief => 'flat')->pack();
	$boutona62->select;
	push(@selectedBouttons,$boutona62);
    }
    if (scalar @TableButton >  0) {
	$tmpButt=shift(@TableButton);
	$tmpButt=chr($tmpButt);
	my $boutona63=$frameb6->Checkbutton(-onvalue=>$tmpButt, -offvalue=>$transcodeurTkReplaceChar, -text=>$tmpButt, -variable => \$varBoutona63, -relief => 'flat')->pack();
	$boutona63->select;
	push(@selectedBouttons,$boutona63);
    }
    if (scalar @TableButton >  0) {
	$tmpButt=shift(@TableButton);
	$tmpButt=chr($tmpButt);
	my $boutona64=$frameb6->Checkbutton(-onvalue=>$tmpButt, -offvalue=>$transcodeurTkReplaceChar, -text=>$tmpButt, -variable => \$varBoutona64, -relief => 'flat')->pack();
	$boutona64->select;
	push(@selectedBouttons,$boutona64);
    }
    if (scalar @TableButton >  0) {
	$tmpButt=shift(@TableButton);
	$tmpButt=chr($tmpButt);
	my $boutona65=$frameb6->Checkbutton(-onvalue=>$tmpButt, -offvalue=>$transcodeurTkReplaceChar, -text=>$tmpButt, -variable => \$varBoutona65, -relief => 'flat')->pack();
	$boutona65->select;
	push(@selectedBouttons,$boutona65);
    }
    if (scalar @TableButton >  0) {
	$tmpButt=shift(@TableButton);
	$tmpButt=chr($tmpButt);
	my $boutona66=$frameb6->Checkbutton(-onvalue=>$tmpButt, -offvalue=>$transcodeurTkReplaceChar, -text=>$tmpButt, -variable => \$varBoutona66, -relief => 'flat')->pack();
	$boutona66->select;
	push(@selectedBouttons,$boutona66);
    }
    if (scalar @TableButton >  0) {
	$tmpButt=shift(@TableButton);
	$tmpButt=chr($tmpButt);
	my $boutona67=$frameb6->Checkbutton(-onvalue=>$tmpButt, -offvalue=>$transcodeurTkReplaceChar, -text=>$tmpButt, -variable => \$varBoutona67, -relief => 'flat')->pack();
	$boutona67->select;
	push(@selectedBouttons,$boutona67);
    }
    if (scalar @TableButton >  0) {
	$tmpButt=shift(@TableButton);
	$tmpButt=chr($tmpButt);
	my $boutona68=$frameb6->Checkbutton(-onvalue=>$tmpButt, -offvalue=>$transcodeurTkReplaceChar, -text=>$tmpButt, -variable => \$varBoutona68, -relief => 'flat')->pack();
	$boutona68->select;
	push(@selectedBouttons,$boutona68);
    }
    if (scalar @TableButton >  0) {
	$tmpButt=shift(@TableButton);
	$tmpButt=chr($tmpButt);
	my $boutona69=$frameb6->Checkbutton(-onvalue=>$tmpButt, -offvalue=>$transcodeurTkReplaceChar, -text=>$tmpButt, -variable => \$varBoutona69, -relief => 'flat')->pack();
	$boutona69->select;
	push(@selectedBouttons,$boutona69);
    }
    if (scalar @TableButton >  0) {
	$tmpButt=shift(@TableButton);
	$tmpButt=chr($tmpButt);
	my $boutona610=$frameb6->Checkbutton(-onvalue=>$tmpButt, -offvalue=>$transcodeurTkReplaceChar, -text=>$tmpButt, -variable => \$varBoutona610, -relief => 'flat')->pack();
	$boutona610->select;
	push(@selectedBouttons,$boutona610);
    }
    if (scalar @TableButton >  0) {
	$tmpButt=shift(@TableButton);
	$tmpButt=chr($tmpButt);
	my $boutona611=$frameb6->Checkbutton(-onvalue=>$tmpButt, -offvalue=>$transcodeurTkReplaceChar, -text=>$tmpButt, -variable => \$varBoutona611, -relief => 'flat')->pack();
	$boutona611->select;
	push(@selectedBouttons,$boutona611);
    }
    if (scalar @TableButton >  0) {
	$tmpButt=shift(@TableButton);
	$tmpButt=chr($tmpButt);
	my $boutona612=$frameb6->Checkbutton(-onvalue=>$tmpButt, -offvalue=>$transcodeurTkReplaceChar, -text=>$tmpButt, -variable => \$varBoutona612, -relief => 'flat')->pack();
	$boutona612->select;
	push(@selectedBouttons,$boutona612);
    }
    if (scalar @TableButton >  0) {
	$tmpButt=shift(@TableButton);
	$tmpButt=chr($tmpButt);
	my $boutona613=$frameb6->Checkbutton(-onvalue=>$tmpButt, -offvalue=>$transcodeurTkReplaceChar, -text=>$tmpButt, -variable => \$varBoutona613, -relief => 'flat')->pack();
	$boutona613->select;
	push(@selectedBouttons,$boutona613);
    }
    if (scalar @TableButton >  0) {
	$tmpButt=shift(@TableButton);
	$tmpButt=chr($tmpButt);
	my $boutona614=$frameb6->Checkbutton(-onvalue=>$tmpButt, -offvalue=>$transcodeurTkReplaceChar, -text=>$tmpButt, -variable => \$varBoutona614, -relief => 'flat')->pack();
	$boutona614->select;
	push(@selectedBouttons,$boutona614);
    }
    if (scalar @TableButton >  0) {
	$tmpButt=shift(@TableButton);
	$tmpButt=chr($tmpButt);
	my $boutona615=$frameb6->Checkbutton(-onvalue=>$tmpButt, -offvalue=>$transcodeurTkReplaceChar, -text=>$tmpButt, -variable => \$varBoutona615, -relief => 'flat')->pack();
	$boutona615->select;
	push(@selectedBouttons,$boutona615);
    }
    if (scalar @TableButton >  0) {
	$tmpButt=shift(@TableButton);
	$tmpButt=chr($tmpButt);
	my $boutona616=$frameb6->Checkbutton(-onvalue=>$tmpButt, -offvalue=>$transcodeurTkReplaceChar, -text=>$tmpButt, -variable => \$varBoutona616, -relief => 'flat')->pack();
	$boutona616->select;
	push(@selectedBouttons,$boutona616);
    }
    if (scalar @TableButton >  0) {
	$tmpButt=shift(@TableButton);
	$tmpButt=chr($tmpButt);
	my $boutona617=$frameb6->Checkbutton(-onvalue=>$tmpButt, -offvalue=>$transcodeurTkReplaceChar, -text=>$tmpButt, -variable => \$varBoutona617, -relief => 'flat')->pack();
	$boutona617->select;
	push(@selectedBouttons,$boutona617);
    }
    if (scalar @TableButton >  0) {
	$tmpButt=shift(@TableButton);
	$tmpButt=chr($tmpButt);
	my $boutona618=$frameb6->Checkbutton(-onvalue=>$tmpButt, -offvalue=>$transcodeurTkReplaceChar, -text=>$tmpButt, -variable => \$varBoutona618, -relief => 'flat')->pack();
	$boutona618->select;
	push(@selectedBouttons,$boutona618);
    }
    if (scalar @TableButton >  0) {
	$tmpButt=shift(@TableButton);
	$tmpButt=chr($tmpButt);
	my $boutona619=$frameb6->Checkbutton(-onvalue=>$tmpButt, -offvalue=>$transcodeurTkReplaceChar, -text=>$tmpButt, -variable => \$varBoutona619, -relief => 'flat')->pack();
	$boutona619->select;
	push(@selectedBouttons,$boutona619);
    }
    if (scalar @TableButton >  0) {
	$tmpButt=shift(@TableButton);
	$tmpButt=chr($tmpButt);
	my $boutona620=$frameb6->Checkbutton(-onvalue=>$tmpButt, -offvalue=>$transcodeurTkReplaceChar, -text=>$tmpButt, -variable => \$varBoutona620, -relief => 'flat')->pack();
	$boutona620->select;
	push(@selectedBouttons,$boutona620);
    }
    if (scalar @TableButton >  0) {
	$tmpButt=shift(@TableButton);
	$tmpButt=chr($tmpButt);
	my $boutona71=$frameb7->Checkbutton(-onvalue=>$tmpButt, -offvalue=>$transcodeurTkReplaceChar, -text=>$tmpButt, -variable => \$varBoutona71, -relief => 'flat')->pack();
	$boutona71->select;
	push(@selectedBouttons,$boutona71);
    }
    if (scalar @TableButton >  0) {
	$tmpButt=shift(@TableButton);
	$tmpButt=chr($tmpButt);
	my $boutona72=$frameb7->Checkbutton(-onvalue=>$tmpButt, -offvalue=>$transcodeurTkReplaceChar, -text=>$tmpButt, -variable => \$varBoutona72, -relief => 'flat')->pack();
	$boutona72->select;
	push(@selectedBouttons,$boutona72);
    }
    if (scalar @TableButton >  0) {
	$tmpButt=shift(@TableButton);
	$tmpButt=chr($tmpButt);
	my $boutona73=$frameb7->Checkbutton(-onvalue=>$tmpButt, -offvalue=>$transcodeurTkReplaceChar, -text=>$tmpButt, -variable => \$varBoutona73, -relief => 'flat')->pack();
	$boutona73->select;
	push(@selectedBouttons,$boutona73);
    }
    if (scalar @TableButton >  0) {
	$tmpButt=shift(@TableButton);
	$tmpButt=chr($tmpButt);
	my $boutona74=$frameb7->Checkbutton(-onvalue=>$tmpButt, -offvalue=>$transcodeurTkReplaceChar, -text=>$tmpButt, -variable => \$varBoutona74, -relief => 'flat')->pack();
	$boutona74->select;
	push(@selectedBouttons,$boutona74);
    }
    if (scalar @TableButton >  0) {
	$tmpButt=shift(@TableButton);
	$tmpButt=chr($tmpButt);
	my $boutona75=$frameb7->Checkbutton(-onvalue=>$tmpButt, -offvalue=>$transcodeurTkReplaceChar, -text=>$tmpButt, -variable => \$varBoutona75, -relief => 'flat')->pack();
	$boutona75->select;
	push(@selectedBouttons,$boutona75);
    }
    if (scalar @TableButton >  0) {
	$tmpButt=shift(@TableButton);
	$tmpButt=chr($tmpButt);
	my $boutona76=$frameb7->Checkbutton(-onvalue=>$tmpButt, -offvalue=>$transcodeurTkReplaceChar, -text=>$tmpButt, -variable => \$varBoutona76, -relief => 'flat')->pack();
	$boutona76->select;
	push(@selectedBouttons,$boutona76);
    }
    if (scalar @TableButton >  0) {
	$tmpButt=shift(@TableButton);
	$tmpButt=chr($tmpButt);
	my $boutona77=$frameb7->Checkbutton(-onvalue=>$tmpButt, -offvalue=>$transcodeurTkReplaceChar, -text=>$tmpButt, -variable => \$varBoutona77, -relief => 'flat')->pack();
	$boutona77->select;
	push(@selectedBouttons,$boutona77);
    }
    if (scalar @TableButton >  0) {
	$tmpButt=shift(@TableButton);
	$tmpButt=chr($tmpButt);
	my $boutona78=$frameb7->Checkbutton(-onvalue=>$tmpButt, -offvalue=>$transcodeurTkReplaceChar, -text=>$tmpButt, -variable => \$varBoutona78, -relief => 'flat')->pack();
	$boutona78->select;
	push(@selectedBouttons,$boutona78);
    }
    if (scalar @TableButton >  0) {
	$tmpButt=shift(@TableButton);
	$tmpButt=chr($tmpButt);
	my $boutona79=$frameb7->Checkbutton(-onvalue=>$tmpButt, -offvalue=>$transcodeurTkReplaceChar, -text=>$tmpButt, -variable => \$varBoutona79, -relief => 'flat')->pack();
	$boutona79->select;
	push(@selectedBouttons,$boutona79);
    }
    if (scalar @TableButton >  0) {
	$tmpButt=shift(@TableButton);
	$tmpButt=chr($tmpButt);
	my $boutona710=$frameb7->Checkbutton(-onvalue=>$tmpButt, -offvalue=>$transcodeurTkReplaceChar, -text=>$tmpButt, -variable => \$varBoutona710, -relief => 'flat')->pack();
	$boutona710->select;
	push(@selectedBouttons,$boutona710);
    }
    if (scalar @TableButton >  0) {
	$tmpButt=shift(@TableButton);
	$tmpButt=chr($tmpButt);
	my $boutona711=$frameb7->Checkbutton(-onvalue=>$tmpButt, -offvalue=>$transcodeurTkReplaceChar, -text=>$tmpButt, -variable => \$varBoutona711, -relief => 'flat')->pack();
	$boutona711->select;
	push(@selectedBouttons,$boutona711);
    }
    if (scalar @TableButton >  0) {
	$tmpButt=shift(@TableButton);
	$tmpButt=chr($tmpButt);
	my $boutona712=$frameb7->Checkbutton(-onvalue=>$tmpButt, -offvalue=>$transcodeurTkReplaceChar, -text=>$tmpButt, -variable => \$varBoutona712, -relief => 'flat')->pack();
	$boutona712->select;
	push(@selectedBouttons,$boutona712);
    }
    if (scalar @TableButton >  0) {
	$tmpButt=shift(@TableButton);
	$tmpButt=chr($tmpButt);
	my $boutona713=$frameb7->Checkbutton(-onvalue=>$tmpButt, -offvalue=>$transcodeurTkReplaceChar, -text=>$tmpButt, -variable => \$varBoutona713, -relief => 'flat')->pack();
	$boutona713->select;
	push(@selectedBouttons,$boutona713);
    }
    if (scalar @TableButton >  0) {
	$tmpButt=shift(@TableButton);
	$tmpButt=chr($tmpButt);
	my $boutona714=$frameb7->Checkbutton(-onvalue=>$tmpButt, -offvalue=>$transcodeurTkReplaceChar, -text=>$tmpButt, -variable => \$varBoutona714, -relief => 'flat')->pack();
	$boutona714->select;
	push(@selectedBouttons,$boutona714);
    }
    if (scalar @TableButton >  0) {
	$tmpButt=shift(@TableButton);
	$tmpButt=chr($tmpButt);
	my $boutona715=$frameb7->Checkbutton(-onvalue=>$tmpButt, -offvalue=>$transcodeurTkReplaceChar, -text=>$tmpButt, -variable => \$varBoutona715, -relief => 'flat')->pack();
	$boutona715->select;
	push(@selectedBouttons,$boutona715);
    }
    if (scalar @TableButton >  0) {
	$tmpButt=shift(@TableButton);
	$tmpButt=chr($tmpButt);
	my $boutona716=$frameb7->Checkbutton(-onvalue=>$tmpButt, -offvalue=>$transcodeurTkReplaceChar, -text=>$tmpButt, -variable => \$varBoutona716, -relief => 'flat')->pack();
	$boutona716->select;
	push(@selectedBouttons,$boutona716);
    }
    if (scalar @TableButton >  0) {
	$tmpButt=shift(@TableButton);
	$tmpButt=chr($tmpButt);
	my $boutona717=$frameb7->Checkbutton(-onvalue=>$tmpButt, -offvalue=>$transcodeurTkReplaceChar, -text=>$tmpButt, -variable => \$varBoutona717, -relief => 'flat')->pack();
	$boutona717->select;
	push(@selectedBouttons,$boutona717);
    }
    if (scalar @TableButton >  0) {
	$tmpButt=shift(@TableButton);
	$tmpButt=chr($tmpButt);
	my $boutona718=$frameb7->Checkbutton(-onvalue=>$tmpButt, -offvalue=>$transcodeurTkReplaceChar, -text=>$tmpButt, -variable => \$varBoutona718, -relief => 'flat')->pack();
	$boutona718->select;
	push(@selectedBouttons,$boutona718);
    }
    if (scalar @TableButton >  0) {
	$tmpButt=shift(@TableButton);
	$tmpButt=chr($tmpButt);
	my $boutona719=$frameb7->Checkbutton(-onvalue=>$tmpButt, -offvalue=>$transcodeurTkReplaceChar, -text=>$tmpButt, -variable => \$varBoutona719, -relief => 'flat')->pack();
	$boutona719->select;
	push(@selectedBouttons,$boutona719);
    }
    if (scalar @TableButton >  0) {
	$tmpButt=shift(@TableButton);
	$tmpButt=chr($tmpButt);
	my $boutona720=$frameb7->Checkbutton(-onvalue=>$tmpButt, -offvalue=>$transcodeurTkReplaceChar, -text=>$tmpButt, -variable => \$varBoutona720, -relief => 'flat')->pack();
	$boutona720->select;
	push(@selectedBouttons,$boutona720);
    }
    if (scalar @TableButton >  0) {
	$tmpButt=shift(@TableButton);
	$tmpButt=chr($tmpButt);
	my $boutona81=$frameb8->Checkbutton(-onvalue=>$tmpButt, -offvalue=>$transcodeurTkReplaceChar, -text=>$tmpButt, -variable => \$varBoutona81, -relief => 'flat')->pack();
	$boutona81->select;
	push(@selectedBouttons,$boutona81);
    }
    if (scalar @TableButton >  0) {
	$tmpButt=shift(@TableButton);
	$tmpButt=chr($tmpButt);
	my $boutona82=$frameb8->Checkbutton(-onvalue=>$tmpButt, -offvalue=>$transcodeurTkReplaceChar, -text=>$tmpButt, -variable => \$varBoutona82, -relief => 'flat')->pack();
	$boutona82->select;
	push(@selectedBouttons,$boutona82);
    }
    if (scalar @TableButton >  0) {
	$tmpButt=shift(@TableButton);
	$tmpButt=chr($tmpButt);
	my $boutona83=$frameb8->Checkbutton(-onvalue=>$tmpButt, -offvalue=>$transcodeurTkReplaceChar, -text=>$tmpButt, -variable => \$varBoutona83, -relief => 'flat')->pack();
	$boutona83->select;
	push(@selectedBouttons,$boutona83);
    }
    if (scalar @TableButton >  0) {
	$tmpButt=shift(@TableButton);
	$tmpButt=chr($tmpButt);
	my $boutona84=$frameb8->Checkbutton(-onvalue=>$tmpButt, -offvalue=>$transcodeurTkReplaceChar, -text=>$tmpButt, -variable => \$varBoutona84, -relief => 'flat')->pack();
	$boutona84->select;
	push(@selectedBouttons,$boutona84);
    }
    if (scalar @TableButton >  0) {
	$tmpButt=shift(@TableButton);
	$tmpButt=chr($tmpButt);
	my $boutona85=$frameb8->Checkbutton(-onvalue=>$tmpButt, -offvalue=>$transcodeurTkReplaceChar, -text=>$tmpButt, -variable => \$varBoutona85, -relief => 'flat')->pack();
	$boutona85->select;
	push(@selectedBouttons,$boutona85);
    }
    if (scalar @TableButton >  0) {
	$tmpButt=shift(@TableButton);
	$tmpButt=chr($tmpButt);
	my $boutona86=$frameb8->Checkbutton(-onvalue=>$tmpButt, -offvalue=>$transcodeurTkReplaceChar, -text=>$tmpButt, -variable => \$varBoutona86, -relief => 'flat')->pack();
	$boutona86->select;
	push(@selectedBouttons,$boutona86);
    }
    if (scalar @TableButton >  0) {
	$tmpButt=shift(@TableButton);
	$tmpButt=chr($tmpButt);
	my $boutona87=$frameb8->Checkbutton(-onvalue=>$tmpButt, -offvalue=>$transcodeurTkReplaceChar, -text=>$tmpButt, -variable => \$varBoutona87, -relief => 'flat')->pack();
	$boutona87->select;
	push(@selectedBouttons,$boutona87);
    }
    if (scalar @TableButton >  0) {
	$tmpButt=shift(@TableButton);
	$tmpButt=chr($tmpButt);
	my $boutona88=$frameb8->Checkbutton(-onvalue=>$tmpButt, -offvalue=>$transcodeurTkReplaceChar, -text=>$tmpButt, -variable => \$varBoutona88, -relief => 'flat')->pack();
	$boutona88->select;
	push(@selectedBouttons,$boutona88);
    }
    if (scalar @TableButton >  0) {
	$tmpButt=shift(@TableButton);
	$tmpButt=chr($tmpButt);
	my $boutona89=$frameb8->Checkbutton(-onvalue=>$tmpButt, -offvalue=>$transcodeurTkReplaceChar, -text=>$tmpButt, -variable => \$varBoutona89, -relief => 'flat')->pack();
	$boutona89->select;
	push(@selectedBouttons,$boutona89);
    }
    if (scalar @TableButton >  0) {
	$tmpButt=shift(@TableButton);
	$tmpButt=chr($tmpButt);
	my $boutona810=$frameb8->Checkbutton(-onvalue=>$tmpButt, -offvalue=>$transcodeurTkReplaceChar, -text=>$tmpButt, -variable => \$varBoutona810, -relief => 'flat')->pack();
	$boutona810->select;
	push(@selectedBouttons,$boutona810);
    }
    if (scalar @TableButton >  0) {
	$tmpButt=shift(@TableButton);
	$tmpButt=chr($tmpButt);
	my $boutona811=$frameb8->Checkbutton(-onvalue=>$tmpButt, -offvalue=>$transcodeurTkReplaceChar, -text=>$tmpButt, -variable => \$varBoutona811, -relief => 'flat')->pack();
	$boutona811->select;
	push(@selectedBouttons,$boutona811);
    }
    if (scalar @TableButton >  0) {
	$tmpButt=shift(@TableButton);
	$tmpButt=chr($tmpButt);
	my $boutona812=$frameb8->Checkbutton(-onvalue=>$tmpButt, -offvalue=>$transcodeurTkReplaceChar, -text=>$tmpButt, -variable => \$varBoutona812, -relief => 'flat')->pack();
	$boutona812->select;
	push(@selectedBouttons,$boutona812);
    }
    if (scalar @TableButton >  0) {
	$tmpButt=shift(@TableButton);
	$tmpButt=chr($tmpButt);
	my $boutona813=$frameb8->Checkbutton(-onvalue=>$tmpButt, -offvalue=>$transcodeurTkReplaceChar, -text=>$tmpButt, -variable => \$varBoutona813, -relief => 'flat')->pack();
	$boutona813->select;
	push(@selectedBouttons,$boutona813);
    }
    if (scalar @TableButton >  0) {
	$tmpButt=shift(@TableButton);
	$tmpButt=chr($tmpButt);
	my $boutona814=$frameb8->Checkbutton(-onvalue=>$tmpButt, -offvalue=>$transcodeurTkReplaceChar, -text=>$tmpButt, -variable => \$varBoutona814, -relief => 'flat')->pack();
	$boutona814->select;
	push(@selectedBouttons,$boutona814);
    }
    if (scalar @TableButton >  0) {
	$tmpButt=shift(@TableButton);
	$tmpButt=chr($tmpButt);
	my $boutona815=$frameb8->Checkbutton(-onvalue=>$tmpButt, -offvalue=>$transcodeurTkReplaceChar, -text=>$tmpButt, -variable => \$varBoutona815, -relief => 'flat')->pack();
	$boutona815->select;
	push(@selectedBouttons,$boutona815);
    }
    if (scalar @TableButton >  0) {
	$tmpButt=shift(@TableButton);
	$tmpButt=chr($tmpButt);
	my $boutona816=$frameb8->Checkbutton(-onvalue=>$tmpButt, -offvalue=>$transcodeurTkReplaceChar, -text=>$tmpButt, -variable => \$varBoutona816, -relief => 'flat')->pack();
	$boutona816->select;
	push(@selectedBouttons,$boutona816);
    }
    if (scalar @TableButton >  0) {
	$tmpButt=shift(@TableButton);
	$tmpButt=chr($tmpButt);
	my $boutona817=$frameb8->Checkbutton(-onvalue=>$tmpButt, -offvalue=>$transcodeurTkReplaceChar, -text=>$tmpButt, -variable => \$varBoutona817, -relief => 'flat')->pack();
	$boutona817->select;
	push(@selectedBouttons,$boutona817);
    }
    if (scalar @TableButton >  0) {
	$tmpButt=shift(@TableButton);
	$tmpButt=chr($tmpButt);
	my $boutona818=$frameb8->Checkbutton(-onvalue=>$tmpButt, -offvalue=>$transcodeurTkReplaceChar, -text=>$tmpButt, -variable => \$varBoutona818, -relief => 'flat')->pack();
	$boutona818->select;
	push(@selectedBouttons,$boutona818);
    }
    if (scalar @TableButton >  0) {
	$tmpButt=shift(@TableButton);
	$tmpButt=chr($tmpButt);
	my $boutona819=$frameb8->Checkbutton(-onvalue=>$tmpButt, -offvalue=>$transcodeurTkReplaceChar, -text=>$tmpButt, -variable => \$varBoutona819, -relief => 'flat')->pack();
	$boutona819->select;
	push(@selectedBouttons,$boutona819);
    }
    if (scalar @TableButton >  0) {
	$tmpButt=shift(@TableButton);
	$tmpButt=chr($tmpButt);
	my $boutona820=$frameb8->Checkbutton(-onvalue=>$tmpButt, -offvalue=>$transcodeurTkReplaceChar, -text=>$tmpButt, -variable => \$varBoutona820, -relief => 'flat')->pack();
	$boutona820->select;
	push(@selectedBouttons,$boutona820);
    }
    if (scalar @TableButton >  0) {
	$tmpButt=shift(@TableButton);
	$tmpButt=chr($tmpButt);
	my $boutona91=$frameb9->Checkbutton(-onvalue=>$tmpButt, -offvalue=>$transcodeurTkReplaceChar, -text=>$tmpButt, -variable => \$varBoutona91, -relief => 'flat')->pack();
	$boutona91->select;
	push(@selectedBouttons,$boutona91);
    }
    if (scalar @TableButton >  0) {
	$tmpButt=shift(@TableButton);
	$tmpButt=chr($tmpButt);
	my $boutona92=$frameb9->Checkbutton(-onvalue=>$tmpButt, -offvalue=>$transcodeurTkReplaceChar, -text=>$tmpButt, -variable => \$varBoutona92, -relief => 'flat')->pack();
	$boutona92->select;
	push(@selectedBouttons,$boutona92);
    }
    if (scalar @TableButton >  0) {
	$tmpButt=shift(@TableButton);
	$tmpButt=chr($tmpButt);
	my $boutona93=$frameb9->Checkbutton(-onvalue=>$tmpButt, -offvalue=>$transcodeurTkReplaceChar, -text=>$tmpButt, -variable => \$varBoutona93, -relief => 'flat')->pack();
	$boutona93->select;
	push(@selectedBouttons,$boutona93);
    }
    if (scalar @TableButton >  0) {
	$tmpButt=shift(@TableButton);
	$tmpButt=chr($tmpButt);
	my $boutona94=$frameb9->Checkbutton(-onvalue=>$tmpButt, -offvalue=>$transcodeurTkReplaceChar, -text=>$tmpButt, -variable => \$varBoutona94, -relief => 'flat')->pack();
	$boutona94->select;
	push(@selectedBouttons,$boutona94);
    }
    if (scalar @TableButton >  0) {
	$tmpButt=shift(@TableButton);
	$tmpButt=chr($tmpButt);
	my $boutona95=$frameb9->Checkbutton(-onvalue=>$tmpButt, -offvalue=>$transcodeurTkReplaceChar, -text=>$tmpButt, -variable => \$varBoutona95, -relief => 'flat')->pack();
	$boutona95->select;
	push(@selectedBouttons,$boutona95);
    }
    if (scalar @TableButton >  0) {
	$tmpButt=shift(@TableButton);
	$tmpButt=chr($tmpButt);
	my $boutona96=$frameb9->Checkbutton(-onvalue=>$tmpButt, -offvalue=>$transcodeurTkReplaceChar, -text=>$tmpButt, -variable => \$varBoutona96, -relief => 'flat')->pack();
	$boutona96->select;
	push(@selectedBouttons,$boutona96);
    }
    if (scalar @TableButton >  0) {
	$tmpButt=shift(@TableButton);
	$tmpButt=chr($tmpButt);
	my $boutona97=$frameb9->Checkbutton(-onvalue=>$tmpButt, -offvalue=>$transcodeurTkReplaceChar, -text=>$tmpButt, -variable => \$varBoutona97, -relief => 'flat')->pack();
	$boutona97->select;
	push(@selectedBouttons,$boutona97);
    }
    if (scalar @TableButton >  0) {
	$tmpButt=shift(@TableButton);
	$tmpButt=chr($tmpButt);
	my $boutona98=$frameb9->Checkbutton(-onvalue=>$tmpButt, -offvalue=>$transcodeurTkReplaceChar, -text=>$tmpButt, -variable => \$varBoutona98, -relief => 'flat')->pack();
	$boutona98->select;
	push(@selectedBouttons,$boutona98);
    }
    if (scalar @TableButton >  0) {
	$tmpButt=shift(@TableButton);
	$tmpButt=chr($tmpButt);
	my $boutona99=$frameb9->Checkbutton(-onvalue=>$tmpButt, -offvalue=>$transcodeurTkReplaceChar, -text=>$tmpButt, -variable => \$varBoutona99, -relief => 'flat')->pack();
	$boutona99->select;
	push(@selectedBouttons,$boutona99);
    }
    if (scalar @TableButton >  0) {
	$tmpButt=shift(@TableButton);
	$tmpButt=chr($tmpButt);
	my $boutona910=$frameb9->Checkbutton(-onvalue=>$tmpButt, -offvalue=>$transcodeurTkReplaceChar, -text=>$tmpButt, -variable => \$varBoutona910, -relief => 'flat')->pack();
	$boutona910->select;
	push(@selectedBouttons,$boutona910);
    }
    if (scalar @TableButton >  0) {
	$tmpButt=shift(@TableButton);
	$tmpButt=chr($tmpButt);
	my $boutona911=$frameb9->Checkbutton(-onvalue=>$tmpButt, -offvalue=>$transcodeurTkReplaceChar, -text=>$tmpButt, -variable => \$varBoutona911, -relief => 'flat')->pack();
	$boutona911->select;
	push(@selectedBouttons,$boutona911);
    }
    if (scalar @TableButton >  0) {
	$tmpButt=shift(@TableButton);
	$tmpButt=chr($tmpButt);
	my $boutona912=$frameb9->Checkbutton(-onvalue=>$tmpButt, -offvalue=>$transcodeurTkReplaceChar, -text=>$tmpButt, -variable => \$varBoutona912, -relief => 'flat')->pack();
	$boutona912->select;
	push(@selectedBouttons,$boutona912);
    }
    if (scalar @TableButton >  0) {
	$tmpButt=shift(@TableButton);
	$tmpButt=chr($tmpButt);
	my $boutona913=$frameb9->Checkbutton(-onvalue=>$tmpButt, -offvalue=>$transcodeurTkReplaceChar, -text=>$tmpButt, -variable => \$varBoutona913, -relief => 'flat')->pack();
	$boutona913->select;
	push(@selectedBouttons,$boutona913);
    }
    if (scalar @TableButton >  0) {
	$tmpButt=shift(@TableButton);
	$tmpButt=chr($tmpButt);
	my $boutona914=$frameb9->Checkbutton(-onvalue=>$tmpButt, -offvalue=>$transcodeurTkReplaceChar, -text=>$tmpButt, -variable => \$varBoutona914, -relief => 'flat')->pack();
	$boutona914->select;
	push(@selectedBouttons,$boutona914);
    }
    if (scalar @TableButton >  0) {
	$tmpButt=shift(@TableButton);
	$tmpButt=chr($tmpButt);
	my $boutona915=$frameb9->Checkbutton(-onvalue=>$tmpButt, -offvalue=>$transcodeurTkReplaceChar, -text=>$tmpButt, -variable => \$varBoutona915, -relief => 'flat')->pack();
	$boutona915->select;
	push(@selectedBouttons,$boutona915);
    }
    if (scalar @TableButton >  0) {
	$tmpButt=shift(@TableButton);
	$tmpButt=chr($tmpButt);
	my $boutona916=$frameb9->Checkbutton(-onvalue=>$tmpButt, -offvalue=>$transcodeurTkReplaceChar, -text=>$tmpButt, -variable => \$varBoutona916, -relief => 'flat')->pack();
	$boutona916->select;
	push(@selectedBouttons,$boutona916);
    }
    if (scalar @TableButton >  0) {
	$tmpButt=shift(@TableButton);
	$tmpButt=chr($tmpButt);
	my $boutona917=$frameb9->Checkbutton(-onvalue=>$tmpButt, -offvalue=>$transcodeurTkReplaceChar, -text=>$tmpButt, -variable => \$varBoutona917, -relief => 'flat')->pack();
	$boutona917->select;
	push(@selectedBouttons,$boutona917);
    }
    if (scalar @TableButton >  0) {
	$tmpButt=shift(@TableButton);
	$tmpButt=chr($tmpButt);
	my $boutona918=$frameb9->Checkbutton(-onvalue=>$tmpButt, -offvalue=>$transcodeurTkReplaceChar, -text=>$tmpButt, -variable => \$varBoutona918, -relief => 'flat')->pack();
	$boutona918->select;
	push(@selectedBouttons,$boutona918);
    }
    if (scalar @TableButton >  0) {
	$tmpButt=shift(@TableButton);
	$tmpButt=chr($tmpButt);
	my $boutona919=$frameb9->Checkbutton(-onvalue=>$tmpButt, -offvalue=>$transcodeurTkReplaceChar, -text=>$tmpButt, -variable => \$varBoutona919, -relief => 'flat')->pack();
	$boutona919->select;
	push(@selectedBouttons,$boutona919);
    }
    if (scalar @TableButton >  0) {
	$tmpButt=shift(@TableButton);
	$tmpButt=chr($tmpButt);
	my $boutona920=$frameb9->Checkbutton(-onvalue=>$tmpButt, -offvalue=>$transcodeurTkReplaceChar, -text=>$tmpButt, -variable => \$varBoutona920, -relief => 'flat')->pack();
	$boutona920->select;
	push(@selectedBouttons,$boutona920);
    }
    if (scalar @TableButton >  0) {
	$tmpButt=shift(@TableButton);
	$tmpButt=chr($tmpButt);
	my $boutonb11=$framec1->Checkbutton(-onvalue=>$tmpButt, -offvalue=>$transcodeurTkReplaceChar, -text=>$tmpButt, -variable => \$varBoutonb11, -relief => 'flat')->pack();
	$boutonb11->select;
	push(@selectedBouttons,$boutonb11);
    }
    if (scalar @TableButton >  0) {
	$tmpButt=shift(@TableButton);
	$tmpButt=chr($tmpButt);
	my $boutonb12=$framec1->Checkbutton(-onvalue=>$tmpButt, -offvalue=>$transcodeurTkReplaceChar, -text=>$tmpButt, -variable => \$varBoutonb12, -relief => 'flat')->pack();
	$boutonb12->select;
	push(@selectedBouttons,$boutonb12);
    }
    if (scalar @TableButton >  0) {
	$tmpButt=shift(@TableButton);
	$tmpButt=chr($tmpButt);
	my $boutonb13=$framec1->Checkbutton(-onvalue=>$tmpButt, -offvalue=>$transcodeurTkReplaceChar, -text=>$tmpButt, -variable => \$varBoutonb13, -relief => 'flat')->pack();
	$boutonb13->select;
	push(@selectedBouttons,$boutonb13);
    }
    if (scalar @TableButton >  0) {
	$tmpButt=shift(@TableButton);
	$tmpButt=chr($tmpButt);
	my $boutonb14=$framec1->Checkbutton(-onvalue=>$tmpButt, -offvalue=>$transcodeurTkReplaceChar, -text=>$tmpButt, -variable => \$varBoutonb14, -relief => 'flat')->pack();
	$boutonb14->select;
	push(@selectedBouttons,$boutonb14);
    }
    if (scalar @TableButton >  0) {
	$tmpButt=shift(@TableButton);
	$tmpButt=chr($tmpButt);
	my $boutonb15=$framec1->Checkbutton(-onvalue=>$tmpButt, -offvalue=>$transcodeurTkReplaceChar, -text=>$tmpButt, -variable => \$varBoutonb15, -relief => 'flat')->pack();
	$boutonb15->select;
	push(@selectedBouttons,$boutonb15);
    }
    if (scalar @TableButton >  0) {
	$tmpButt=shift(@TableButton);
	$tmpButt=chr($tmpButt);
	my $boutonb16=$framec1->Checkbutton(-onvalue=>$tmpButt, -offvalue=>$transcodeurTkReplaceChar, -text=>$tmpButt, -variable => \$varBoutonb16, -relief => 'flat')->pack();
	$boutonb16->select;
	push(@selectedBouttons,$boutonb16);
    }
    if (scalar @TableButton >  0) {
	$tmpButt=shift(@TableButton);
	$tmpButt=chr($tmpButt);
	my $boutonb17=$framec1->Checkbutton(-onvalue=>$tmpButt, -offvalue=>$transcodeurTkReplaceChar, -text=>$tmpButt, -variable => \$varBoutonb17, -relief => 'flat')->pack();
	$boutonb17->select;
	push(@selectedBouttons,$boutonb17);
    }
    if (scalar @TableButton >  0) {
	$tmpButt=shift(@TableButton);
	$tmpButt=chr($tmpButt);
	my $boutonb18=$framec1->Checkbutton(-onvalue=>$tmpButt, -offvalue=>$transcodeurTkReplaceChar, -text=>$tmpButt, -variable => \$varBoutonb18, -relief => 'flat')->pack();
	$boutonb18->select;
	push(@selectedBouttons,$boutonb18);
    }
    if (scalar @TableButton >  0) {
	$tmpButt=shift(@TableButton);
	$tmpButt=chr($tmpButt);
	my $boutonb19=$framec1->Checkbutton(-onvalue=>$tmpButt, -offvalue=>$transcodeurTkReplaceChar, -text=>$tmpButt, -variable => \$varBoutonb19, -relief => 'flat')->pack();
	$boutonb19->select;
	push(@selectedBouttons,$boutonb19);
    }
    if (scalar @TableButton >  0) {
	$tmpButt=shift(@TableButton);
	$tmpButt=chr($tmpButt);
	my $boutonb110=$framec1->Checkbutton(-onvalue=>$tmpButt, -offvalue=>$transcodeurTkReplaceChar, -text=>$tmpButt, -variable => \$varBoutonb110, -relief => 'flat')->pack();
	$boutonb110->select;
	push(@selectedBouttons,$boutonb110);
    }
    if (scalar @TableButton >  0) {
	$tmpButt=shift(@TableButton);
	$tmpButt=chr($tmpButt);
	my $boutonb111=$framec1->Checkbutton(-onvalue=>$tmpButt, -offvalue=>$transcodeurTkReplaceChar, -text=>$tmpButt, -variable => \$varBoutonb111, -relief => 'flat')->pack();
	$boutonb111->select;
	push(@selectedBouttons,$boutonb111);
    }
    if (scalar @TableButton >  0) {
	$tmpButt=shift(@TableButton);
	$tmpButt=chr($tmpButt);
	my $boutonb112=$framec1->Checkbutton(-onvalue=>$tmpButt, -offvalue=>$transcodeurTkReplaceChar, -text=>$tmpButt, -variable => \$varBoutonb112, -relief => 'flat')->pack();
	$boutonb112->select;
	push(@selectedBouttons,$boutonb112);
    }
    if (scalar @TableButton >  0) {
	$tmpButt=shift(@TableButton);
	$tmpButt=chr($tmpButt);
	my $boutonb113=$framec1->Checkbutton(-onvalue=>$tmpButt, -offvalue=>$transcodeurTkReplaceChar, -text=>$tmpButt, -variable => \$varBoutonb113, -relief => 'flat')->pack();
	$boutonb113->select;
	push(@selectedBouttons,$boutonb113);
    }
    if (scalar @TableButton >  0) {
	$tmpButt=shift(@TableButton);
	$tmpButt=chr($tmpButt);
	my $boutonb114=$framec1->Checkbutton(-onvalue=>$tmpButt, -offvalue=>$transcodeurTkReplaceChar, -text=>$tmpButt, -variable => \$varBoutonb114, -relief => 'flat')->pack();
	$boutonb114->select;
	push(@selectedBouttons,$boutonb114);
    }
    if (scalar @TableButton >  0) {
	$tmpButt=shift(@TableButton);
	$tmpButt=chr($tmpButt);
	my $boutonb115=$framec1->Checkbutton(-onvalue=>$tmpButt, -offvalue=>$transcodeurTkReplaceChar, -text=>$tmpButt, -variable => \$varBoutonb115, -relief => 'flat')->pack();
	$boutonb115->select;
	push(@selectedBouttons,$boutonb115);
    }
    if (scalar @TableButton >  0) {
	$tmpButt=shift(@TableButton);
	$tmpButt=chr($tmpButt);
	my $boutonb116=$framec1->Checkbutton(-onvalue=>$tmpButt, -offvalue=>$transcodeurTkReplaceChar, -text=>$tmpButt, -variable => \$varBoutonb116, -relief => 'flat')->pack();
	$boutonb116->select;
	push(@selectedBouttons,$boutonb116);
    }
    if (scalar @TableButton >  0) {
	$tmpButt=shift(@TableButton);
	$tmpButt=chr($tmpButt);
	my $boutonb117=$framec1->Checkbutton(-onvalue=>$tmpButt, -offvalue=>$transcodeurTkReplaceChar, -text=>$tmpButt, -variable => \$varBoutonb117, -relief => 'flat')->pack();
	$boutonb117->select;
	push(@selectedBouttons,$boutonb117);
    }
    if (scalar @TableButton >  0) {
	$tmpButt=shift(@TableButton);
	$tmpButt=chr($tmpButt);
	my $boutonb118=$framec1->Checkbutton(-onvalue=>$tmpButt, -offvalue=>$transcodeurTkReplaceChar, -text=>$tmpButt, -variable => \$varBoutonb118, -relief => 'flat')->pack();
	$boutonb118->select;
	push(@selectedBouttons,$boutonb118);
    }
    if (scalar @TableButton >  0) {
	$tmpButt=shift(@TableButton);
	$tmpButt=chr($tmpButt);
	my $boutonb119=$framec1->Checkbutton(-onvalue=>$tmpButt, -offvalue=>$transcodeurTkReplaceChar, -text=>$tmpButt, -variable => \$varBoutonb119, -relief => 'flat')->pack();
	$boutonb119->select;
	push(@selectedBouttons,$boutonb119);
    }
    if (scalar @TableButton >  0) {
	$tmpButt=shift(@TableButton);
	$tmpButt=chr($tmpButt);
	my $boutonb120=$framec1->Checkbutton(-onvalue=>$tmpButt, -offvalue=>$transcodeurTkReplaceChar, -text=>$tmpButt, -variable => \$varBoutonb120, -relief => 'flat')->pack();
	$boutonb120->select;
	push(@selectedBouttons,$boutonb120);
    }
    if (scalar @TableButton >  0) {
	$tmpButt=shift(@TableButton);
	$tmpButt=chr($tmpButt);
	my $boutonb21=$framec2->Checkbutton(-onvalue=>$tmpButt, -offvalue=>$transcodeurTkReplaceChar, -text=>$tmpButt, -variable => \$varBoutonb21, -relief => 'flat')->pack();
	$boutonb21->select;
	push(@selectedBouttons,$boutonb21);
    }
    if (scalar @TableButton >  0) {
	$tmpButt=shift(@TableButton);
	$tmpButt=chr($tmpButt);
	my $boutonb22=$framec2->Checkbutton(-onvalue=>$tmpButt, -offvalue=>$transcodeurTkReplaceChar, -text=>$tmpButt, -variable => \$varBoutonb22, -relief => 'flat')->pack();
	$boutonb22->select;
	push(@selectedBouttons,$boutonb22);
    }
    if (scalar @TableButton >  0) {
	$tmpButt=shift(@TableButton);
	$tmpButt=chr($tmpButt);
	my $boutonb23=$framec2->Checkbutton(-onvalue=>$tmpButt, -offvalue=>$transcodeurTkReplaceChar, -text=>$tmpButt, -variable => \$varBoutonb23, -relief => 'flat')->pack();
	$boutonb23->select;
	push(@selectedBouttons,$boutonb23);
    }
    if (scalar @TableButton >  0) {
	$tmpButt=shift(@TableButton);
	$tmpButt=chr($tmpButt);
	my $boutonb24=$framec2->Checkbutton(-onvalue=>$tmpButt, -offvalue=>$transcodeurTkReplaceChar, -text=>$tmpButt, -variable => \$varBoutonb24, -relief => 'flat')->pack();
	$boutonb24->select;
	push(@selectedBouttons,$boutonb24);
    }
    if (scalar @TableButton >  0) {
	$tmpButt=shift(@TableButton);
	$tmpButt=chr($tmpButt);
	my $boutonb25=$framec2->Checkbutton(-onvalue=>$tmpButt, -offvalue=>$transcodeurTkReplaceChar, -text=>$tmpButt, -variable => \$varBoutonb25, -relief => 'flat')->pack();
	$boutonb25->select;
	push(@selectedBouttons,$boutonb25);
    }
    if (scalar @TableButton >  0) {
	$tmpButt=shift(@TableButton);
	$tmpButt=chr($tmpButt);
	my $boutonb26=$framec2->Checkbutton(-onvalue=>$tmpButt, -offvalue=>$transcodeurTkReplaceChar, -text=>$tmpButt, -variable => \$varBoutonb26, -relief => 'flat')->pack();
	$boutonb26->select;
	push(@selectedBouttons,$boutonb26);
    }
    if (scalar @TableButton >  0) {
	$tmpButt=shift(@TableButton);
	$tmpButt=chr($tmpButt);
	my $boutonb27=$framec2->Checkbutton(-onvalue=>$tmpButt, -offvalue=>$transcodeurTkReplaceChar, -text=>$tmpButt, -variable => \$varBoutonb27, -relief => 'flat')->pack();
	$boutonb27->select;
	push(@selectedBouttons,$boutonb27);
    }
    if (scalar @TableButton >  0) {
	$tmpButt=shift(@TableButton);
	$tmpButt=chr($tmpButt);
	my $boutonb28=$framec2->Checkbutton(-onvalue=>$tmpButt, -offvalue=>$transcodeurTkReplaceChar, -text=>$tmpButt, -variable => \$varBoutonb28, -relief => 'flat')->pack();
	$boutonb28->select;
	push(@selectedBouttons,$boutonb28);
    }
    if (scalar @TableButton >  0) {
	$tmpButt=shift(@TableButton);
	$tmpButt=chr($tmpButt);
	my $boutonb29=$framec2->Checkbutton(-onvalue=>$tmpButt, -offvalue=>$transcodeurTkReplaceChar, -text=>$tmpButt, -variable => \$varBoutonb29, -relief => 'flat')->pack();
	$boutonb29->select;
	push(@selectedBouttons,$boutonb29);
    }
    if (scalar @TableButton >  0) {
	$tmpButt=shift(@TableButton);
	$tmpButt=chr($tmpButt);
	my $boutonb210=$framec2->Checkbutton(-onvalue=>$tmpButt, -offvalue=>$transcodeurTkReplaceChar, -text=>$tmpButt, -variable => \$varBoutonb210, -relief => 'flat')->pack();
	$boutonb210->select;
	push(@selectedBouttons,$boutonb210);
    }
    if (scalar @TableButton >  0) {
	$tmpButt=shift(@TableButton);
	$tmpButt=chr($tmpButt);
	my $boutonb211=$framec2->Checkbutton(-onvalue=>$tmpButt, -offvalue=>$transcodeurTkReplaceChar, -text=>$tmpButt, -variable => \$varBoutonb211, -relief => 'flat')->pack();
	$boutonb211->select;
	push(@selectedBouttons,$boutonb211);
    }
    if (scalar @TableButton >  0) {
	$tmpButt=shift(@TableButton);
	$tmpButt=chr($tmpButt);
	my $boutonb212=$framec2->Checkbutton(-onvalue=>$tmpButt, -offvalue=>$transcodeurTkReplaceChar, -text=>$tmpButt, -variable => \$varBoutonb212, -relief => 'flat')->pack();
	$boutonb212->select;
	push(@selectedBouttons,$boutonb212);
    }
    if (scalar @TableButton >  0) {
	$tmpButt=shift(@TableButton);
	$tmpButt=chr($tmpButt);
	my $boutonb213=$framec2->Checkbutton(-onvalue=>$tmpButt, -offvalue=>$transcodeurTkReplaceChar, -text=>$tmpButt, -variable => \$varBoutonb213, -relief => 'flat')->pack();
	$boutonb213->select;
	push(@selectedBouttons,$boutonb213);
    }
    if (scalar @TableButton >  0) {
	$tmpButt=shift(@TableButton);
	$tmpButt=chr($tmpButt);
	my $boutonb214=$framec2->Checkbutton(-onvalue=>$tmpButt, -offvalue=>$transcodeurTkReplaceChar, -text=>$tmpButt, -variable => \$varBoutonb214, -relief => 'flat')->pack();
	$boutonb214->select;
	push(@selectedBouttons,$boutonb214);
    }
    if (scalar @TableButton >  0) {
	$tmpButt=shift(@TableButton);
	$tmpButt=chr($tmpButt);
	my $boutonb215=$framec2->Checkbutton(-onvalue=>$tmpButt, -offvalue=>$transcodeurTkReplaceChar, -text=>$tmpButt, -variable => \$varBoutonb215, -relief => 'flat')->pack();
	$boutonb215->select;
	push(@selectedBouttons,$boutonb215);
    }
    if (scalar @TableButton >  0) {
	$tmpButt=shift(@TableButton);
	$tmpButt=chr($tmpButt);
	my $boutonb216=$framec2->Checkbutton(-onvalue=>$tmpButt, -offvalue=>$transcodeurTkReplaceChar, -text=>$tmpButt, -variable => \$varBoutonb216, -relief => 'flat')->pack();
	$boutonb216->select;
	push(@selectedBouttons,$boutonb216);
    }
    if (scalar @TableButton >  0) {
	$tmpButt=shift(@TableButton);
	$tmpButt=chr($tmpButt);
	my $boutonb217=$framec2->Checkbutton(-onvalue=>$tmpButt, -offvalue=>$transcodeurTkReplaceChar, -text=>$tmpButt, -variable => \$varBoutonb217, -relief => 'flat')->pack();
	$boutonb217->select;
	push(@selectedBouttons,$boutonb217);
    }
    if (scalar @TableButton >  0) {
	$tmpButt=shift(@TableButton);
	$tmpButt=chr($tmpButt);
	my $boutonb218=$framec2->Checkbutton(-onvalue=>$tmpButt, -offvalue=>$transcodeurTkReplaceChar, -text=>$tmpButt, -variable => \$varBoutonb218, -relief => 'flat')->pack();
	$boutonb218->select;
	push(@selectedBouttons,$boutonb218);
    }
    if (scalar @TableButton >  0) {
	$tmpButt=shift(@TableButton);
	$tmpButt=chr($tmpButt);
	my $boutonb219=$framec2->Checkbutton(-onvalue=>$tmpButt, -offvalue=>$transcodeurTkReplaceChar, -text=>$tmpButt, -variable => \$varBoutonb219, -relief => 'flat')->pack();
	$boutonb219->select;
	push(@selectedBouttons,$boutonb219);
    }
    if (scalar @TableButton >  0) {
	$tmpButt=shift(@TableButton);
	$tmpButt=chr($tmpButt);
	my $boutonb220=$framec2->Checkbutton(-onvalue=>$tmpButt, -offvalue=>$transcodeurTkReplaceChar, -text=>$tmpButt, -variable => \$varBoutonb220, -relief => 'flat')->pack();
	$boutonb220->select;
	push(@selectedBouttons,$boutonb220);
    }
    if (scalar @TableButton >  0) {
	$tmpButt=shift(@TableButton);
	$tmpButt=chr($tmpButt);
	my $boutonb31=$framec3->Checkbutton(-onvalue=>$tmpButt, -offvalue=>$transcodeurTkReplaceChar, -text=>$tmpButt, -variable => \$varBoutonb31, -relief => 'flat')->pack();
	$boutonb31->select;
	push(@selectedBouttons,$boutonb31);
    }
    if (scalar @TableButton >  0) {
	$tmpButt=shift(@TableButton);
	$tmpButt=chr($tmpButt);
	my $boutonb32=$framec3->Checkbutton(-onvalue=>$tmpButt, -offvalue=>$transcodeurTkReplaceChar, -text=>$tmpButt, -variable => \$varBoutonb32, -relief => 'flat')->pack();
	$boutonb32->select;
	push(@selectedBouttons,$boutonb32);
    }
    if (scalar @TableButton >  0) {
	$tmpButt=shift(@TableButton);
	$tmpButt=chr($tmpButt);
	my $boutonb33=$framec3->Checkbutton(-onvalue=>$tmpButt, -offvalue=>$transcodeurTkReplaceChar, -text=>$tmpButt, -variable => \$varBoutonb33, -relief => 'flat')->pack();
	$boutonb33->select;
	push(@selectedBouttons,$boutonb33);
    }
    if (scalar @TableButton >  0) {
	$tmpButt=shift(@TableButton);
	$tmpButt=chr($tmpButt);
	my $boutonb34=$framec3->Checkbutton(-onvalue=>$tmpButt, -offvalue=>$transcodeurTkReplaceChar, -text=>$tmpButt, -variable => \$varBoutonb34, -relief => 'flat')->pack();
	$boutonb34->select;
	push(@selectedBouttons,$boutonb34);
    }
    if (scalar @TableButton >  0) {
	$tmpButt=shift(@TableButton);
	$tmpButt=chr($tmpButt);
	my $boutonb35=$framec3->Checkbutton(-onvalue=>$tmpButt, -offvalue=>$transcodeurTkReplaceChar, -text=>$tmpButt, -variable => \$varBoutonb35, -relief => 'flat')->pack();
	$boutonb35->select;
	push(@selectedBouttons,$boutonb35);
    }
    if (scalar @TableButton >  0) {
	$tmpButt=shift(@TableButton);
	$tmpButt=chr($tmpButt);
	my $boutonb36=$framec3->Checkbutton(-onvalue=>$tmpButt, -offvalue=>$transcodeurTkReplaceChar, -text=>$tmpButt, -variable => \$varBoutonb36, -relief => 'flat')->pack();
	$boutonb36->select;
	push(@selectedBouttons,$boutonb36);
    }
    if (scalar @TableButton >  0) {
	$tmpButt=shift(@TableButton);
	$tmpButt=chr($tmpButt);
	my $boutonb37=$framec3->Checkbutton(-onvalue=>$tmpButt, -offvalue=>$transcodeurTkReplaceChar, -text=>$tmpButt, -variable => \$varBoutonb37, -relief => 'flat')->pack();
	$boutonb37->select;
	push(@selectedBouttons,$boutonb37);
    }
    if (scalar @TableButton >  0) {
	$tmpButt=shift(@TableButton);
	$tmpButt=chr($tmpButt);
	my $boutonb38=$framec3->Checkbutton(-onvalue=>$tmpButt, -offvalue=>$transcodeurTkReplaceChar, -text=>$tmpButt, -variable => \$varBoutonb38, -relief => 'flat')->pack();
	$boutonb38->select;
	push(@selectedBouttons,$boutonb38);
    }
    if (scalar @TableButton >  0) {
	$tmpButt=shift(@TableButton);
	$tmpButt=chr($tmpButt);
	my $boutonb39=$framec3->Checkbutton(-onvalue=>$tmpButt, -offvalue=>$transcodeurTkReplaceChar, -text=>$tmpButt, -variable => \$varBoutonb39, -relief => 'flat')->pack();
	$boutonb39->select;
	push(@selectedBouttons,$boutonb39);
    }
    if (scalar @TableButton >  0) {
	$tmpButt=shift(@TableButton);
	$tmpButt=chr($tmpButt);
	my $boutonb310=$framec3->Checkbutton(-onvalue=>$tmpButt, -offvalue=>$transcodeurTkReplaceChar, -text=>$tmpButt, -variable => \$varBoutonb310, -relief => 'flat')->pack();
	$boutonb310->select;
	push(@selectedBouttons,$boutonb310);
    }
    if (scalar @TableButton >  0) {
	$tmpButt=shift(@TableButton);
	$tmpButt=chr($tmpButt);
	my $boutonb311=$framec3->Checkbutton(-onvalue=>$tmpButt, -offvalue=>$transcodeurTkReplaceChar, -text=>$tmpButt, -variable => \$varBoutonb311, -relief => 'flat')->pack();
	$boutonb311->select;
	push(@selectedBouttons,$boutonb311);
    }
    if (scalar @TableButton >  0) {
	$tmpButt=shift(@TableButton);
	$tmpButt=chr($tmpButt);
	my $boutonb312=$framec3->Checkbutton(-onvalue=>$tmpButt, -offvalue=>$transcodeurTkReplaceChar, -text=>$tmpButt, -variable => \$varBoutonb312, -relief => 'flat')->pack();
	$boutonb312->select;
	push(@selectedBouttons,$boutonb312);
    }
    if (scalar @TableButton >  0) {
	$tmpButt=shift(@TableButton);
	$tmpButt=chr($tmpButt);
	my $boutonb313=$framec3->Checkbutton(-onvalue=>$tmpButt, -offvalue=>$transcodeurTkReplaceChar, -text=>$tmpButt, -variable => \$varBoutonb313, -relief => 'flat')->pack();
	$boutonb313->select;
	push(@selectedBouttons,$boutonb313);
    }
    if (scalar @TableButton >  0) {
	$tmpButt=shift(@TableButton);
	$tmpButt=chr($tmpButt);
	my $boutonb314=$framec3->Checkbutton(-onvalue=>$tmpButt, -offvalue=>$transcodeurTkReplaceChar, -text=>$tmpButt, -variable => \$varBoutonb314, -relief => 'flat')->pack();
	$boutonb314->select;
	push(@selectedBouttons,$boutonb314);
    }
    if (scalar @TableButton >  0) {
	$tmpButt=shift(@TableButton);
	$tmpButt=chr($tmpButt);
	my $boutonb315=$framec3->Checkbutton(-onvalue=>$tmpButt, -offvalue=>$transcodeurTkReplaceChar, -text=>$tmpButt, -variable => \$varBoutonb315, -relief => 'flat')->pack();
	$boutonb315->select;
	push(@selectedBouttons,$boutonb315);
    }
    if (scalar @TableButton >  0) {
	$tmpButt=shift(@TableButton);
	$tmpButt=chr($tmpButt);
	my $boutonb316=$framec3->Checkbutton(-onvalue=>$tmpButt, -offvalue=>$transcodeurTkReplaceChar, -text=>$tmpButt, -variable => \$varBoutonb316, -relief => 'flat')->pack();
	$boutonb316->select;
	push(@selectedBouttons,$boutonb316);
    }
    if (scalar @TableButton >  0) {
	$tmpButt=shift(@TableButton);
	$tmpButt=chr($tmpButt);
	my $boutonb317=$framec3->Checkbutton(-onvalue=>$tmpButt, -offvalue=>$transcodeurTkReplaceChar, -text=>$tmpButt, -variable => \$varBoutonb317, -relief => 'flat')->pack();
	$boutonb317->select;
	push(@selectedBouttons,$boutonb317);
    }
    if (scalar @TableButton >  0) {
	$tmpButt=shift(@TableButton);
	$tmpButt=chr($tmpButt);
	my $boutonb318=$framec3->Checkbutton(-onvalue=>$tmpButt, -offvalue=>$transcodeurTkReplaceChar, -text=>$tmpButt, -variable => \$varBoutonb318, -relief => 'flat')->pack();
	$boutonb318->select;
	push(@selectedBouttons,$boutonb318);
    }
    if (scalar @TableButton >  0) {
	$tmpButt=shift(@TableButton);
	$tmpButt=chr($tmpButt);
	my $boutonb319=$framec3->Checkbutton(-onvalue=>$tmpButt, -offvalue=>$transcodeurTkReplaceChar, -text=>$tmpButt, -variable => \$varBoutonb319, -relief => 'flat')->pack();
	$boutonb319->select;
	push(@selectedBouttons,$boutonb319);
    }
    if (scalar @TableButton >  0) {
	$tmpButt=shift(@TableButton);
	$tmpButt=chr($tmpButt);
	my $boutonb320=$framec3->Checkbutton(-onvalue=>$tmpButt, -offvalue=>$transcodeurTkReplaceChar, -text=>$tmpButt, -variable => \$varBoutonb320, -relief => 'flat')->pack();
	$boutonb320->select;
	push(@selectedBouttons,$boutonb320);
    }
    
    if (scalar @TableButton >  0) {
	$tmpButt=shift(@TableButton);
	$tmpButt=chr($tmpButt);
	my $boutonb41=$framec4->Checkbutton(-onvalue=>$tmpButt, -offvalue=>$transcodeurTkReplaceChar, -text=>$tmpButt, -variable => \$varBoutonb41, -relief => 'flat')->pack();
	$boutonb41->select;
	push(@selectedBouttons,$boutonb41);
    }
    if (scalar @TableButton >  0) {
	$tmpButt=shift(@TableButton);
	$tmpButt=chr($tmpButt);
	my $boutonb42=$framec4->Checkbutton(-onvalue=>$tmpButt, -offvalue=>$transcodeurTkReplaceChar, -text=>$tmpButt, -variable => \$varBoutonb42, -relief => 'flat')->pack();
	$boutonb42->select;
	push(@selectedBouttons,$boutonb42);
    }
    if (scalar @TableButton >  0) {
	$tmpButt=shift(@TableButton);
	$tmpButt=chr($tmpButt);
	my $boutonb43=$framec4->Checkbutton(-onvalue=>$tmpButt, -offvalue=>$transcodeurTkReplaceChar, -text=>$tmpButt, -variable => \$varBoutonb43, -relief => 'flat')->pack();
	$boutonb43->select;
	push(@selectedBouttons,$boutonb43);
    }
    if (scalar @TableButton >  0) {
	$tmpButt=shift(@TableButton);
	$tmpButt=chr($tmpButt);
	my $boutonb44=$framec4->Checkbutton(-onvalue=>$tmpButt, -offvalue=>$transcodeurTkReplaceChar, -text=>$tmpButt, -variable => \$varBoutonb44, -relief => 'flat')->pack();
	$boutonb44->select;
	push(@selectedBouttons,$boutonb44);
    }
    if (scalar @TableButton >  0) {
	$tmpButt=shift(@TableButton);
	$tmpButt=chr($tmpButt);
	my $boutonb45=$framec4->Checkbutton(-onvalue=>$tmpButt, -offvalue=>$transcodeurTkReplaceChar, -text=>$tmpButt, -variable => \$varBoutonb45, -relief => 'flat')->pack();
	$boutonb45->select;
	push(@selectedBouttons,$boutonb45);
    }
    if (scalar @TableButton >  0) {
	$tmpButt=shift(@TableButton);
	$tmpButt=chr($tmpButt);
	my $boutonb46=$framec4->Checkbutton(-onvalue=>$tmpButt, -offvalue=>$transcodeurTkReplaceChar, -text=>$tmpButt, -variable => \$varBoutonb46, -relief => 'flat')->pack();
	$boutonb46->select;
	push(@selectedBouttons,$boutonb46);
    }
    if (scalar @TableButton >  0) {
	$tmpButt=shift(@TableButton);
	$tmpButt=chr($tmpButt);
	my $boutonb47=$framec4->Checkbutton(-onvalue=>$tmpButt, -offvalue=>$transcodeurTkReplaceChar, -text=>$tmpButt, -variable => \$varBoutonb47, -relief => 'flat')->pack();
	$boutonb47->select;
	push(@selectedBouttons,$boutonb47);
    }
    if (scalar @TableButton >  0) {
	$tmpButt=shift(@TableButton);
	$tmpButt=chr($tmpButt);
	my $boutonb48=$framec4->Checkbutton(-onvalue=>$tmpButt, -offvalue=>$transcodeurTkReplaceChar, -text=>$tmpButt, -variable => \$varBoutonb48, -relief => 'flat')->pack();
	$boutonb48->select;
	push(@selectedBouttons,$boutonb48);
    }
    if (scalar @TableButton >  0) {
	$tmpButt=shift(@TableButton);
	$tmpButt=chr($tmpButt);
	my $boutonb49=$framec4->Checkbutton(-onvalue=>$tmpButt, -offvalue=>$transcodeurTkReplaceChar, -text=>$tmpButt, -variable => \$varBoutonb49, -relief => 'flat')->pack();
	$boutonb49->select;
	push(@selectedBouttons,$boutonb49);
    }
    if (scalar @TableButton >  0) {
	$tmpButt=shift(@TableButton);
	$tmpButt=chr($tmpButt);
	my $boutonb410=$framec4->Checkbutton(-onvalue=>$tmpButt, -offvalue=>$transcodeurTkReplaceChar, -text=>$tmpButt, -variable => \$varBoutonb410, -relief => 'flat')->pack();
	$boutonb410->select;
	push(@selectedBouttons,$boutonb410);
    }
    if (scalar @TableButton >  0) {
	$tmpButt=shift(@TableButton);
	$tmpButt=chr($tmpButt);
	my $boutonb411=$framec4->Checkbutton(-onvalue=>$tmpButt, -offvalue=>$transcodeurTkReplaceChar, -text=>$tmpButt, -variable => \$varBoutonb411, -relief => 'flat')->pack();
	$boutonb411->select;
	push(@selectedBouttons,$boutonb411);
    }
    if (scalar @TableButton >  0) {
	$tmpButt=shift(@TableButton);
	$tmpButt=chr($tmpButt);
	my $boutonb412=$framec4->Checkbutton(-onvalue=>$tmpButt, -offvalue=>$transcodeurTkReplaceChar, -text=>$tmpButt, -variable => \$varBoutonb412, -relief => 'flat')->pack();
	$boutonb412->select;
	push(@selectedBouttons,$boutonb412);
    }
    if (scalar @TableButton >  0) {
	$tmpButt=shift(@TableButton);
	$tmpButt=chr($tmpButt);
	my $boutonb413=$framec4->Checkbutton(-onvalue=>$tmpButt, -offvalue=>$transcodeurTkReplaceChar, -text=>$tmpButt, -variable => \$varBoutonb413, -relief => 'flat')->pack();
	$boutonb413->select;
	push(@selectedBouttons,$boutonb413);
    }
    if (scalar @TableButton >  0) {
	$tmpButt=shift(@TableButton);
	$tmpButt=chr($tmpButt);
	my $boutonb414=$framec4->Checkbutton(-onvalue=>$tmpButt, -offvalue=>$transcodeurTkReplaceChar, -text=>$tmpButt, -variable => \$varBoutonb414, -relief => 'flat')->pack();
	$boutonb414->select;
	push(@selectedBouttons,$boutonb414);
    }
    if (scalar @TableButton >  0) {
	$tmpButt=shift(@TableButton);
	$tmpButt=chr($tmpButt);
	my $boutonb415=$framec4->Checkbutton(-onvalue=>$tmpButt, -offvalue=>$transcodeurTkReplaceChar, -text=>$tmpButt, -variable => \$varBoutonb415, -relief => 'flat')->pack();
	$boutonb415->select;
	push(@selectedBouttons,$boutonb415);
    }
    if (scalar @TableButton >  0) {
	$tmpButt=shift(@TableButton);
	$tmpButt=chr($tmpButt);
	my $boutonb416=$framec4->Checkbutton(-onvalue=>$tmpButt, -offvalue=>$transcodeurTkReplaceChar, -text=>$tmpButt, -variable => \$varBoutonb416, -relief => 'flat')->pack();
	$boutonb416->select;
	push(@selectedBouttons,$boutonb416);
    }
    if (scalar @TableButton >  0) {
	$tmpButt=shift(@TableButton);
	$tmpButt=chr($tmpButt);
	my $boutonb417=$framec4->Checkbutton(-onvalue=>$tmpButt, -offvalue=>$transcodeurTkReplaceChar, -text=>$tmpButt, -variable => \$varBoutonb417, -relief => 'flat')->pack();
	$boutonb417->select;
	push(@selectedBouttons,$boutonb417);
    }
    if (scalar @TableButton >  0) {
	$tmpButt=shift(@TableButton);
	$tmpButt=chr($tmpButt);
	my $boutonb418=$framec4->Checkbutton(-onvalue=>$tmpButt, -offvalue=>$transcodeurTkReplaceChar, -text=>$tmpButt, -variable => \$varBoutonb418, -relief => 'flat')->pack();
	$boutonb418->select;
	push(@selectedBouttons,$boutonb418);
    }
    if (scalar @TableButton >  0) {
	$tmpButt=shift(@TableButton);
	$tmpButt=chr($tmpButt);
	my $boutonb419=$framec4->Checkbutton(-onvalue=>$tmpButt, -offvalue=>$transcodeurTkReplaceChar, -text=>$tmpButt, -variable => \$varBoutonb419, -relief => 'flat')->pack();
	$boutonb419->select;
	push(@selectedBouttons,$boutonb419);
    }
    if (scalar @TableButton >  0) {
	$tmpButt=shift(@TableButton);
	$tmpButt=chr($tmpButt);
	my $boutonb420=$framec4->Checkbutton(-onvalue=>$tmpButt, -offvalue=>$transcodeurTkReplaceChar, -text=>$tmpButt, -variable => \$varBoutonb420, -relief => 'flat')->pack();
	$boutonb420->select;
	push(@selectedBouttons,$boutonb420);
    }
    if (scalar @TableButton >  0) {
	$tmpButt=shift(@TableButton);
	$tmpButt=chr($tmpButt);
	my $boutonb51=$framec5->Checkbutton(-onvalue=>$tmpButt, -offvalue=>$transcodeurTkReplaceChar, -text=>$tmpButt, -variable => \$varBoutonb51, -relief => 'flat')->pack();
	$boutonb51->select;
	push(@selectedBouttons,$boutonb51);
    }
    if (scalar @TableButton >  0) {
	$tmpButt=shift(@TableButton);
	$tmpButt=chr($tmpButt);
	my $boutonb52=$framec5->Checkbutton(-onvalue=>$tmpButt, -offvalue=>$transcodeurTkReplaceChar, -text=>$tmpButt, -variable => \$varBoutonb52, -relief => 'flat')->pack();
	$boutonb52->select;
	push(@selectedBouttons,$boutonb52);
    }
    if (scalar @TableButton >  0) {
	$tmpButt=shift(@TableButton);
	$tmpButt=chr($tmpButt);
	my $boutonb53=$framec5->Checkbutton(-onvalue=>$tmpButt, -offvalue=>$transcodeurTkReplaceChar, -text=>$tmpButt, -variable => \$varBoutonb53, -relief => 'flat')->pack();
	$boutonb53->select;
	push(@selectedBouttons,$boutonb53);
    }
    if (scalar @TableButton >  0) {
	$tmpButt=shift(@TableButton);
	$tmpButt=chr($tmpButt);
	my $boutonb54=$framec5->Checkbutton(-onvalue=>$tmpButt, -offvalue=>$transcodeurTkReplaceChar, -text=>$tmpButt, -variable => \$varBoutonb54, -relief => 'flat')->pack();
	$boutonb54->select;
	push(@selectedBouttons,$boutonb54);
    }
    if (scalar @TableButton >  0) {
	$tmpButt=shift(@TableButton);
	$tmpButt=chr($tmpButt);
	my $boutonb55=$framec5->Checkbutton(-onvalue=>$tmpButt, -offvalue=>$transcodeurTkReplaceChar, -text=>$tmpButt, -variable => \$varBoutonb55, -relief => 'flat')->pack();
	$boutonb55->select;
	push(@selectedBouttons,$boutonb55);
    }
    if (scalar @TableButton >  0) {
	$tmpButt=shift(@TableButton);
	$tmpButt=chr($tmpButt);
	my $boutonb56=$framec5->Checkbutton(-onvalue=>$tmpButt, -offvalue=>$transcodeurTkReplaceChar, -text=>$tmpButt, -variable => \$varBoutonb56, -relief => 'flat')->pack();
	$boutonb56->select;
	push(@selectedBouttons,$boutonb56);
    }
    if (scalar @TableButton >  0) {
	$tmpButt=shift(@TableButton);
	$tmpButt=chr($tmpButt);
	my $boutonb57=$framec5->Checkbutton(-onvalue=>$tmpButt, -offvalue=>$transcodeurTkReplaceChar, -text=>$tmpButt, -variable => \$varBoutonb57, -relief => 'flat')->pack();
	$boutonb57->select;
	push(@selectedBouttons,$boutonb57);
    }
    if (scalar @TableButton >  0) {
	$tmpButt=shift(@TableButton);
	$tmpButt=chr($tmpButt);
	my $boutonb58=$framec5->Checkbutton(-onvalue=>$tmpButt, -offvalue=>$transcodeurTkReplaceChar, -text=>$tmpButt, -variable => \$varBoutonb58, -relief => 'flat')->pack();
	$boutonb58->select;
	push(@selectedBouttons,$boutonb58);
    }
    if (scalar @TableButton >  0) {
	$tmpButt=shift(@TableButton);
	$tmpButt=chr($tmpButt);
	my $boutonb59=$framec5->Checkbutton(-onvalue=>$tmpButt, -offvalue=>$transcodeurTkReplaceChar, -text=>$tmpButt, -variable => \$varBoutonb59, -relief => 'flat')->pack();
	$boutonb59->select;
	push(@selectedBouttons,$boutonb59);
    }
    if (scalar @TableButton >  0) {
	$tmpButt=shift(@TableButton);
	$tmpButt=chr($tmpButt);
	my $boutonb510=$framec5->Checkbutton(-onvalue=>$tmpButt, -offvalue=>$transcodeurTkReplaceChar, -text=>$tmpButt, -variable => \$varBoutonb510, -relief => 'flat')->pack();
	$boutonb510->select;
	push(@selectedBouttons,$boutonb510);
    }
    if (scalar @TableButton >  0) {
	$tmpButt=shift(@TableButton);
	$tmpButt=chr($tmpButt);
	my $boutonb511=$framec5->Checkbutton(-onvalue=>$tmpButt, -offvalue=>$transcodeurTkReplaceChar, -text=>$tmpButt, -variable => \$varBoutonb511, -relief => 'flat')->pack();
	$boutonb511->select;
	push(@selectedBouttons,$boutonb511);
    }
    if (scalar @TableButton >  0) {
	$tmpButt=shift(@TableButton);
	$tmpButt=chr($tmpButt);
	my $boutonb512=$framec5->Checkbutton(-onvalue=>$tmpButt, -offvalue=>$transcodeurTkReplaceChar, -text=>$tmpButt, -variable => \$varBoutonb512, -relief => 'flat')->pack();
	$boutonb512->select;
	push(@selectedBouttons,$boutonb512);
    }
    if (scalar @TableButton >  0) {
	$tmpButt=shift(@TableButton);
	$tmpButt=chr($tmpButt);
	my $boutonb513=$framec5->Checkbutton(-onvalue=>$tmpButt, -offvalue=>$transcodeurTkReplaceChar, -text=>$tmpButt, -variable => \$varBoutonb513, -relief => 'flat')->pack();
	$boutonb513->select;
	push(@selectedBouttons,$boutonb513);
    }
    if (scalar @TableButton >  0) {
	$tmpButt=shift(@TableButton);
	$tmpButt=chr($tmpButt);
	my $boutonb514=$framec5->Checkbutton(-onvalue=>$tmpButt, -offvalue=>$transcodeurTkReplaceChar, -text=>$tmpButt, -variable => \$varBoutonb514, -relief => 'flat')->pack();
	$boutonb514->select;
	push(@selectedBouttons,$boutonb514);
    }
    if (scalar @TableButton >  0) {
	$tmpButt=shift(@TableButton);
	$tmpButt=chr($tmpButt);
	my $boutonb515=$framec5->Checkbutton(-onvalue=>$tmpButt, -offvalue=>$transcodeurTkReplaceChar, -text=>$tmpButt, -variable => \$varBoutonb515, -relief => 'flat')->pack();
	$boutonb515->select;
	push(@selectedBouttons,$boutonb515);
    }
    if (scalar @TableButton >  0) {
	$tmpButt=shift(@TableButton);
	$tmpButt=chr($tmpButt);
	my $boutonb516=$framec5->Checkbutton(-onvalue=>$tmpButt, -offvalue=>$transcodeurTkReplaceChar, -text=>$tmpButt, -variable => \$varBoutonb516, -relief => 'flat')->pack();
	$boutonb516->select;
	push(@selectedBouttons,$boutonb516);
    }
    if (scalar @TableButton >  0) {
	$tmpButt=shift(@TableButton);
	$tmpButt=chr($tmpButt);
	my $boutonb517=$framec5->Checkbutton(-onvalue=>$tmpButt, -offvalue=>$transcodeurTkReplaceChar, -text=>$tmpButt, -variable => \$varBoutonb517, -relief => 'flat')->pack();
	$boutonb517->select;
	push(@selectedBouttons,$boutonb517);
    }
    if (scalar @TableButton >  0) {
	$tmpButt=shift(@TableButton);
	$tmpButt=chr($tmpButt);
	my $boutonb518=$framec5->Checkbutton(-onvalue=>$tmpButt, -offvalue=>$transcodeurTkReplaceChar, -text=>$tmpButt, -variable => \$varBoutonb518, -relief => 'flat')->pack();
	$boutonb518->select;
	push(@selectedBouttons,$boutonb518);
    }
    if (scalar @TableButton >  0) {
	$tmpButt=shift(@TableButton);
	$tmpButt=chr($tmpButt);
	my $boutonb519=$framec5->Checkbutton(-onvalue=>$tmpButt, -offvalue=>$transcodeurTkReplaceChar, -text=>$tmpButt, -variable => \$varBoutonb519, -relief => 'flat')->pack();
	$boutonb519->select;
	push(@selectedBouttons,$boutonb519);
    }
    if (scalar @TableButton >  0) {
	$tmpButt=shift(@TableButton);
	$tmpButt=chr($tmpButt);
	my $boutonb520=$framec5->Checkbutton(-onvalue=>$tmpButt, -offvalue=>$transcodeurTkReplaceChar, -text=>$tmpButt, -variable => \$varBoutonb520, -relief => 'flat')->pack();
	$boutonb520->select;
	push(@selectedBouttons,$boutonb520);
    }
    if (scalar @TableButton >  0) {
	$tmpButt=shift(@TableButton);
	$tmpButt=chr($tmpButt);
	my $boutonb61=$framec6->Checkbutton(-onvalue=>$tmpButt, -offvalue=>$transcodeurTkReplaceChar, -text=>$tmpButt, -variable => \$varBoutonb61, -relief => 'flat')->pack();
	$boutonb61->select;
	push(@selectedBouttons,$boutonb61);
    }
    if (scalar @TableButton >  0) {
	$tmpButt=shift(@TableButton);
	$tmpButt=chr($tmpButt);
	my $boutonb62=$framec6->Checkbutton(-onvalue=>$tmpButt, -offvalue=>$transcodeurTkReplaceChar, -text=>$tmpButt, -variable => \$varBoutonb62, -relief => 'flat')->pack();
	$boutonb62->select;
	push(@selectedBouttons,$boutonb62);
    }
    if (scalar @TableButton >  0) {
	$tmpButt=shift(@TableButton);
	$tmpButt=chr($tmpButt);
	my $boutonb63=$framec6->Checkbutton(-onvalue=>$tmpButt, -offvalue=>$transcodeurTkReplaceChar, -text=>$tmpButt, -variable => \$varBoutonb63, -relief => 'flat')->pack();
	$boutonb63->select;
	push(@selectedBouttons,$boutonb63);
    }
    if (scalar @TableButton >  0) {
	$tmpButt=shift(@TableButton);
	$tmpButt=chr($tmpButt);
	my $boutonb64=$framec6->Checkbutton(-onvalue=>$tmpButt, -offvalue=>$transcodeurTkReplaceChar, -text=>$tmpButt, -variable => \$varBoutonb64, -relief => 'flat')->pack();
	$boutonb64->select;
	push(@selectedBouttons,$boutonb64);
    }
    if (scalar @TableButton >  0) {
	$tmpButt=shift(@TableButton);
	$tmpButt=chr($tmpButt);
	my $boutonb65=$framec6->Checkbutton(-onvalue=>$tmpButt, -offvalue=>$transcodeurTkReplaceChar, -text=>$tmpButt, -variable => \$varBoutonb65, -relief => 'flat')->pack();
	$boutonb65->select;
	push(@selectedBouttons,$boutonb65);
    }
    if (scalar @TableButton >  0) {
	$tmpButt=shift(@TableButton);
	$tmpButt=chr($tmpButt);
	my $boutonb66=$framec6->Checkbutton(-onvalue=>$tmpButt, -offvalue=>$transcodeurTkReplaceChar, -text=>$tmpButt, -variable => \$varBoutonb66, -relief => 'flat')->pack();
	$boutonb66->select;
	push(@selectedBouttons,$boutonb66);
    }
    if (scalar @TableButton >  0) {
	$tmpButt=shift(@TableButton);
	$tmpButt=chr($tmpButt);
	my $boutonb67=$framec6->Checkbutton(-onvalue=>$tmpButt, -offvalue=>$transcodeurTkReplaceChar, -text=>$tmpButt, -variable => \$varBoutonb67, -relief => 'flat')->pack();
	$boutonb67->select;
	push(@selectedBouttons,$boutonb67);
    }
    if (scalar @TableButton >  0) {
	$tmpButt=shift(@TableButton);
	$tmpButt=chr($tmpButt);
	my $boutonb68=$framec6->Checkbutton(-onvalue=>$tmpButt, -offvalue=>$transcodeurTkReplaceChar, -text=>$tmpButt, -variable => \$varBoutonb68, -relief => 'flat')->pack();
	$boutonb68->select;
	push(@selectedBouttons,$boutonb68);
    }
    if (scalar @TableButton >  0) {
	$tmpButt=shift(@TableButton);
	$tmpButt=chr($tmpButt);
	my $boutonb69=$framec6->Checkbutton(-onvalue=>$tmpButt, -offvalue=>$transcodeurTkReplaceChar, -text=>$tmpButt, -variable => \$varBoutonb69, -relief => 'flat')->pack();
	$boutonb69->select;
	push(@selectedBouttons,$boutonb69);
    }
    if (scalar @TableButton >  0) {
	$tmpButt=shift(@TableButton);
	$tmpButt=chr($tmpButt);
	my $boutonb610=$framec6->Checkbutton(-onvalue=>$tmpButt, -offvalue=>$transcodeurTkReplaceChar, -text=>$tmpButt, -variable => \$varBoutonb610, -relief => 'flat')->pack();
	$boutonb610->select;
	push(@selectedBouttons,$boutonb610);
    }
    if (scalar @TableButton >  0) {
	$tmpButt=shift(@TableButton);
	$tmpButt=chr($tmpButt);
	my $boutonb611=$framec6->Checkbutton(-onvalue=>$tmpButt, -offvalue=>$transcodeurTkReplaceChar, -text=>$tmpButt, -variable => \$varBoutonb611, -relief => 'flat')->pack();
	$boutonb611->select;
	push(@selectedBouttons,$boutonb611);
    }
    if (scalar @TableButton >  0) {
	$tmpButt=shift(@TableButton);
	$tmpButt=chr($tmpButt);
	my $boutonb612=$framec6->Checkbutton(-onvalue=>$tmpButt, -offvalue=>$transcodeurTkReplaceChar, -text=>$tmpButt, -variable => \$varBoutonb612, -relief => 'flat')->pack();
	$boutonb612->select;
	push(@selectedBouttons,$boutonb612);
    }
    if (scalar @TableButton >  0) {
	$tmpButt=shift(@TableButton);
	$tmpButt=chr($tmpButt);
	my $boutonb613=$framec6->Checkbutton(-onvalue=>$tmpButt, -offvalue=>$transcodeurTkReplaceChar, -text=>$tmpButt, -variable => \$varBoutonb613, -relief => 'flat')->pack();
	$boutonb613->select;
	push(@selectedBouttons,$boutonb613);
    }
    if (scalar @TableButton >  0) {
	$tmpButt=shift(@TableButton);
	$tmpButt=chr($tmpButt);
	my $boutonb614=$framec6->Checkbutton(-onvalue=>$tmpButt, -offvalue=>$transcodeurTkReplaceChar, -text=>$tmpButt, -variable => \$varBoutonb614, -relief => 'flat')->pack();
	$boutonb614->select;
	push(@selectedBouttons,$boutonb614);
    }
    if (scalar @TableButton >  0) {
	$tmpButt=shift(@TableButton);
	$tmpButt=chr($tmpButt);
	my $boutonb615=$framec6->Checkbutton(-onvalue=>$tmpButt, -offvalue=>$transcodeurTkReplaceChar, -text=>$tmpButt, -variable => \$varBoutonb615, -relief => 'flat')->pack();
	$boutonb615->select;
	push(@selectedBouttons,$boutonb615);
    }
    if (scalar @TableButton >  0) {
	$tmpButt=shift(@TableButton);
	$tmpButt=chr($tmpButt);
	my $boutonb616=$framec6->Checkbutton(-onvalue=>$tmpButt, -offvalue=>$transcodeurTkReplaceChar, -text=>$tmpButt, -variable => \$varBoutonb616, -relief => 'flat')->pack();
	$boutonb616->select;
	push(@selectedBouttons,$boutonb616);
    }
    if (scalar @TableButton >  0) {
	$tmpButt=shift(@TableButton);
	$tmpButt=chr($tmpButt);
	my $boutonb617=$framec6->Checkbutton(-onvalue=>$tmpButt, -offvalue=>$transcodeurTkReplaceChar, -text=>$tmpButt, -variable => \$varBoutonb617, -relief => 'flat')->pack();
	$boutonb617->select;
	push(@selectedBouttons,$boutonb617);
    }
    if (scalar @TableButton >  0) {
	$tmpButt=shift(@TableButton);
	$tmpButt=chr($tmpButt);
	my $boutonb618=$framec6->Checkbutton(-onvalue=>$tmpButt, -offvalue=>$transcodeurTkReplaceChar, -text=>$tmpButt, -variable => \$varBoutonb618, -relief => 'flat')->pack();
	$boutonb618->select;
	push(@selectedBouttons,$boutonb618);
    }
    if (scalar @TableButton >  0) {
	$tmpButt=shift(@TableButton);
	$tmpButt=chr($tmpButt);
	my $boutonb619=$framec6->Checkbutton(-onvalue=>$tmpButt, -offvalue=>$transcodeurTkReplaceChar, -text=>$tmpButt, -variable => \$varBoutonb619, -relief => 'flat')->pack();
	$boutonb619->select;
	push(@selectedBouttons,$boutonb619);
    }
    if (scalar @TableButton >  0) {
	$tmpButt=shift(@TableButton);
	$tmpButt=chr($tmpButt);
	my $boutonb620=$framec6->Checkbutton(-onvalue=>$tmpButt, -offvalue=>$transcodeurTkReplaceChar, -text=>$tmpButt, -variable => \$varBoutonb620, -relief => 'flat')->pack();
	$boutonb620->select;
	push(@selectedBouttons,$boutonb620);
    }
    if (scalar @TableButton >  0) {
	$tmpButt=shift(@TableButton);
	$tmpButt=chr($tmpButt);
	my $boutonb71=$framec7->Checkbutton(-onvalue=>$tmpButt, -offvalue=>$transcodeurTkReplaceChar, -text=>$tmpButt, -variable => \$varBoutonb71, -relief => 'flat')->pack();
	$boutonb71->select;
	push(@selectedBouttons,$boutonb71);
    }
    if (scalar @TableButton >  0) {
	$tmpButt=shift(@TableButton);
	$tmpButt=chr($tmpButt);
	my $boutonb72=$framec7->Checkbutton(-onvalue=>$tmpButt, -offvalue=>$transcodeurTkReplaceChar, -text=>$tmpButt, -variable => \$varBoutonb72, -relief => 'flat')->pack();
	$boutonb72->select;
	push(@selectedBouttons,$boutonb72);
    }
    if (scalar @TableButton >  0) {
	$tmpButt=shift(@TableButton);
	$tmpButt=chr($tmpButt);
	my $boutonb73=$framec7->Checkbutton(-onvalue=>$tmpButt, -offvalue=>$transcodeurTkReplaceChar, -text=>$tmpButt, -variable => \$varBoutonb73, -relief => 'flat')->pack();
	$boutonb73->select;
	push(@selectedBouttons,$boutonb73);
    }
    if (scalar @TableButton >  0) {
	$tmpButt=shift(@TableButton);
	$tmpButt=chr($tmpButt);
	my $boutonb74=$framec7->Checkbutton(-onvalue=>$tmpButt, -offvalue=>$transcodeurTkReplaceChar, -text=>$tmpButt, -variable => \$varBoutonb74, -relief => 'flat')->pack();
	$boutonb74->select;
	push(@selectedBouttons,$boutonb74);
    }
    if (scalar @TableButton >  0) {
	$tmpButt=shift(@TableButton);
	$tmpButt=chr($tmpButt);
	my $boutonb75=$framec7->Checkbutton(-onvalue=>$tmpButt, -offvalue=>$transcodeurTkReplaceChar, -text=>$tmpButt, -variable => \$varBoutonb75, -relief => 'flat')->pack();
	$boutonb75->select;
	push(@selectedBouttons,$boutonb75);
    }
    if (scalar @TableButton >  0) {
	$tmpButt=shift(@TableButton);
	$tmpButt=chr($tmpButt);
	my $boutonb76=$framec7->Checkbutton(-onvalue=>$tmpButt, -offvalue=>$transcodeurTkReplaceChar, -text=>$tmpButt, -variable => \$varBoutonb76, -relief => 'flat')->pack();
	$boutonb76->select;
	push(@selectedBouttons,$boutonb76);
    }
    if (scalar @TableButton >  0) {
	$tmpButt=shift(@TableButton);
	$tmpButt=chr($tmpButt);
	my $boutonb77=$framec7->Checkbutton(-onvalue=>$tmpButt, -offvalue=>$transcodeurTkReplaceChar, -text=>$tmpButt, -variable => \$varBoutonb77, -relief => 'flat')->pack();
	$boutonb77->select;
	push(@selectedBouttons,$boutonb77);
    }
    if (scalar @TableButton >  0) {
	$tmpButt=shift(@TableButton);
	$tmpButt=chr($tmpButt);
	my $boutonb78=$framec7->Checkbutton(-onvalue=>$tmpButt, -offvalue=>$transcodeurTkReplaceChar, -text=>$tmpButt, -variable => \$varBoutonb78, -relief => 'flat')->pack();
	$boutonb78->select;
	push(@selectedBouttons,$boutonb78);
    }
    if (scalar @TableButton >  0) {
	$tmpButt=shift(@TableButton);
	$tmpButt=chr($tmpButt);
	my $boutonb79=$framec7->Checkbutton(-onvalue=>$tmpButt, -offvalue=>$transcodeurTkReplaceChar, -text=>$tmpButt, -variable => \$varBoutonb79, -relief => 'flat')->pack();
	$boutonb79->select;
	push(@selectedBouttons,$boutonb79);
    }
    if (scalar @TableButton >  0) {
	$tmpButt=shift(@TableButton);
	$tmpButt=chr($tmpButt);
	my $boutonb710=$framec7->Checkbutton(-onvalue=>$tmpButt, -offvalue=>$transcodeurTkReplaceChar, -text=>$tmpButt, -variable => \$varBoutonb710, -relief => 'flat')->pack();
	$boutonb710->select;
	push(@selectedBouttons,$boutonb710);
    }
    if (scalar @TableButton >  0) {
	$tmpButt=shift(@TableButton);
	$tmpButt=chr($tmpButt);
	my $boutonb711=$framec7->Checkbutton(-onvalue=>$tmpButt, -offvalue=>$transcodeurTkReplaceChar, -text=>$tmpButt, -variable => \$varBoutonb711, -relief => 'flat')->pack();
	$boutonb711->select;
	push(@selectedBouttons,$boutonb711);
    }
    if (scalar @TableButton >  0) {
	$tmpButt=shift(@TableButton);
	$tmpButt=chr($tmpButt);
	my $boutonb712=$framec7->Checkbutton(-onvalue=>$tmpButt, -offvalue=>$transcodeurTkReplaceChar, -text=>$tmpButt, -variable => \$varBoutonb712, -relief => 'flat')->pack();
	$boutonb712->select;
	push(@selectedBouttons,$boutonb712);
    }
    if (scalar @TableButton >  0) {
	$tmpButt=shift(@TableButton);
	$tmpButt=chr($tmpButt);
	my $boutonb713=$framec7->Checkbutton(-onvalue=>$tmpButt, -offvalue=>$transcodeurTkReplaceChar, -text=>$tmpButt, -variable => \$varBoutonb713, -relief => 'flat')->pack();
	$boutonb713->select;
	push(@selectedBouttons,$boutonb713);
    }
    if (scalar @TableButton >  0) {
	$tmpButt=shift(@TableButton);
	$tmpButt=chr($tmpButt);
	my $boutonb714=$framec7->Checkbutton(-onvalue=>$tmpButt, -offvalue=>$transcodeurTkReplaceChar, -text=>$tmpButt, -variable => \$varBoutonb714, -relief => 'flat')->pack();
	$boutonb714->select;
	push(@selectedBouttons,$boutonb714);
    }
    if (scalar @TableButton >  0) {
	$tmpButt=shift(@TableButton);
	$tmpButt=chr($tmpButt);
	my $boutonb715=$framec7->Checkbutton(-onvalue=>$tmpButt, -offvalue=>$transcodeurTkReplaceChar, -text=>$tmpButt, -variable => \$varBoutonb715, -relief => 'flat')->pack();
	$boutonb715->select;
	push(@selectedBouttons,$boutonb715);
    }
    if (scalar @TableButton >  0) {
	$tmpButt=shift(@TableButton);
	$tmpButt=chr($tmpButt);
	my $boutonb716=$framec7->Checkbutton(-onvalue=>$tmpButt, -offvalue=>$transcodeurTkReplaceChar, -text=>$tmpButt, -variable => \$varBoutonb716, -relief => 'flat')->pack();
	$boutonb716->select;
	push(@selectedBouttons,$boutonb716);
    }
    if (scalar @TableButton >  0) {
	$tmpButt=shift(@TableButton);
	$tmpButt=chr($tmpButt);
	my $boutonb717=$framec7->Checkbutton(-onvalue=>$tmpButt, -offvalue=>$transcodeurTkReplaceChar, -text=>$tmpButt, -variable => \$varBoutonb717, -relief => 'flat')->pack();
	$boutonb717->select;
	push(@selectedBouttons,$boutonb717);
    }
    if (scalar @TableButton >  0) {
	$tmpButt=shift(@TableButton);
	$tmpButt=chr($tmpButt);
	my $boutonb718=$framec7->Checkbutton(-onvalue=>$tmpButt, -offvalue=>$transcodeurTkReplaceChar, -text=>$tmpButt, -variable => \$varBoutonb718, -relief => 'flat')->pack();
	$boutonb718->select;
	push(@selectedBouttons,$boutonb718);
    }
    if (scalar @TableButton >  0) {
	$tmpButt=shift(@TableButton);
	$tmpButt=chr($tmpButt);
	my $boutonb719=$framec7->Checkbutton(-onvalue=>$tmpButt, -offvalue=>$transcodeurTkReplaceChar, -text=>$tmpButt, -variable => \$varBoutonb719, -relief => 'flat')->pack();
	$boutonb719->select;
	push(@selectedBouttons,$boutonb719);
    }
    if (scalar @TableButton >  0) {
	$tmpButt=shift(@TableButton);
	$tmpButt=chr($tmpButt);
	my $boutonb720=$framec7->Checkbutton(-onvalue=>$tmpButt, -offvalue=>$transcodeurTkReplaceChar, -text=>$tmpButt, -variable => \$varBoutonb720, -relief => 'flat')->pack();
	$boutonb720->select;
	push(@selectedBouttons,$boutonb720);
    }
    if (scalar @TableButton >  0) {
	$tmpButt=shift(@TableButton);
	$tmpButt=chr($tmpButt);
	my $boutonb81=$framec8->Checkbutton(-onvalue=>$tmpButt, -offvalue=>$transcodeurTkReplaceChar, -text=>$tmpButt, -variable => \$varBoutonb81, -relief => 'flat')->pack();
	$boutonb81->select;
	push(@selectedBouttons,$boutonb81);
    }
    if (scalar @TableButton >  0) {
	$tmpButt=shift(@TableButton);
	$tmpButt=chr($tmpButt);
	my $boutonb82=$framec8->Checkbutton(-onvalue=>$tmpButt, -offvalue=>$transcodeurTkReplaceChar, -text=>$tmpButt, -variable => \$varBoutonb82, -relief => 'flat')->pack();
	$boutonb82->select;
	push(@selectedBouttons,$boutonb82);
    }
    if (scalar @TableButton >  0) {
	$tmpButt=shift(@TableButton);
	$tmpButt=chr($tmpButt);
	my $boutonb83=$framec8->Checkbutton(-onvalue=>$tmpButt, -offvalue=>$transcodeurTkReplaceChar, -text=>$tmpButt, -variable => \$varBoutonb83, -relief => 'flat')->pack();
	$boutonb83->select;
	push(@selectedBouttons,$boutonb83);
    }
    if (scalar @TableButton >  0) {
	$tmpButt=shift(@TableButton);
	$tmpButt=chr($tmpButt);
	my $boutonb84=$framec8->Checkbutton(-onvalue=>$tmpButt, -offvalue=>$transcodeurTkReplaceChar, -text=>$tmpButt, -variable => \$varBoutonb84, -relief => 'flat')->pack();
	$boutonb84->select;
	push(@selectedBouttons,$boutonb84);
    }
    if (scalar @TableButton >  0) {
	$tmpButt=shift(@TableButton);
	$tmpButt=chr($tmpButt);
	my $boutonb85=$framec8->Checkbutton(-onvalue=>$tmpButt, -offvalue=>$transcodeurTkReplaceChar, -text=>$tmpButt, -variable => \$varBoutonb85, -relief => 'flat')->pack();
	$boutonb85->select;
	push(@selectedBouttons,$boutonb85);
    }
    if (scalar @TableButton >  0) {
	$tmpButt=shift(@TableButton);
	$tmpButt=chr($tmpButt);
	my $boutonb86=$framec8->Checkbutton(-onvalue=>$tmpButt, -offvalue=>$transcodeurTkReplaceChar, -text=>$tmpButt, -variable => \$varBoutonb86, -relief => 'flat')->pack();
	$boutonb86->select;
	push(@selectedBouttons,$boutonb86);
    }
    if (scalar @TableButton >  0) {
	$tmpButt=shift(@TableButton);
	$tmpButt=chr($tmpButt);
	my $boutonb87=$framec8->Checkbutton(-onvalue=>$tmpButt, -offvalue=>$transcodeurTkReplaceChar, -text=>$tmpButt, -variable => \$varBoutonb87, -relief => 'flat')->pack();
	$boutonb87->select;
	push(@selectedBouttons,$boutonb87);
    }
    if (scalar @TableButton >  0) {
	$tmpButt=shift(@TableButton);
	$tmpButt=chr($tmpButt);
	my $boutonb88=$framec8->Checkbutton(-onvalue=>$tmpButt, -offvalue=>$transcodeurTkReplaceChar, -text=>$tmpButt, -variable => \$varBoutonb88, -relief => 'flat')->pack();
	$boutonb88->select;
	push(@selectedBouttons,$boutonb88);
    }
    if (scalar @TableButton >  0) {
	$tmpButt=shift(@TableButton);
	$tmpButt=chr($tmpButt);
	my $boutonb89=$framec8->Checkbutton(-onvalue=>$tmpButt, -offvalue=>$transcodeurTkReplaceChar, -text=>$tmpButt, -variable => \$varBoutonb89, -relief => 'flat')->pack();
	$boutonb89->select;
	push(@selectedBouttons,$boutonb89);
    }
    if (scalar @TableButton >  0) {
	$tmpButt=shift(@TableButton);
	$tmpButt=chr($tmpButt);
	my $boutonb810=$framec8->Checkbutton(-onvalue=>$tmpButt, -offvalue=>$transcodeurTkReplaceChar, -text=>$tmpButt, -variable => \$varBoutonb810, -relief => 'flat')->pack();
	$boutonb810->select;
	push(@selectedBouttons,$boutonb810);
    }
    if (scalar @TableButton >  0) {
	$tmpButt=shift(@TableButton);
	$tmpButt=chr($tmpButt);
	my $boutonb811=$framec8->Checkbutton(-onvalue=>$tmpButt, -offvalue=>$transcodeurTkReplaceChar, -text=>$tmpButt, -variable => \$varBoutonb811, -relief => 'flat')->pack();
	$boutonb811->select;
	push(@selectedBouttons,$boutonb811);
    }
    if (scalar @TableButton >  0) {
	$tmpButt=shift(@TableButton);
	$tmpButt=chr($tmpButt);
	my $boutonb812=$framec8->Checkbutton(-onvalue=>$tmpButt, -offvalue=>$transcodeurTkReplaceChar, -text=>$tmpButt, -variable => \$varBoutonb812, -relief => 'flat')->pack();
	$boutonb812->select;
	push(@selectedBouttons,$boutonb812);
    }
    if (scalar @TableButton >  0) {
	$tmpButt=shift(@TableButton);
	$tmpButt=chr($tmpButt);
	my $boutonb813=$framec8->Checkbutton(-onvalue=>$tmpButt, -offvalue=>$transcodeurTkReplaceChar, -text=>$tmpButt, -variable => \$varBoutonb813, -relief => 'flat')->pack();
	$boutonb813->select;
	push(@selectedBouttons,$boutonb813);
    }
    if (scalar @TableButton >  0) {
	$tmpButt=shift(@TableButton);
	$tmpButt=chr($tmpButt);
	my $boutonb814=$framec8->Checkbutton(-onvalue=>$tmpButt, -offvalue=>$transcodeurTkReplaceChar, -text=>$tmpButt, -variable => \$varBoutonb814, -relief => 'flat')->pack();
	$boutonb814->select;
	push(@selectedBouttons,$boutonb814);
    }
    if (scalar @TableButton >  0) {
	$tmpButt=shift(@TableButton);
	$tmpButt=chr($tmpButt);
	my $boutonb815=$framec8->Checkbutton(-onvalue=>$tmpButt, -offvalue=>$transcodeurTkReplaceChar, -text=>$tmpButt, -variable => \$varBoutonb815, -relief => 'flat')->pack();
	$boutonb815->select;
	push(@selectedBouttons,$boutonb815);
    }
    if (scalar @TableButton >  0) {
	$tmpButt=shift(@TableButton);
	$tmpButt=chr($tmpButt);
	my $boutonb816=$framec8->Checkbutton(-onvalue=>$tmpButt, -offvalue=>$transcodeurTkReplaceChar, -text=>$tmpButt, -variable => \$varBoutonb816, -relief => 'flat')->pack();
	$boutonb816->select;
	push(@selectedBouttons,$boutonb816);
    }
    if (scalar @TableButton >  0) {
	$tmpButt=shift(@TableButton);
	$tmpButt=chr($tmpButt);
	my $boutonb817=$framec8->Checkbutton(-onvalue=>$tmpButt, -offvalue=>$transcodeurTkReplaceChar, -text=>$tmpButt, -variable => \$varBoutonb817, -relief => 'flat')->pack();
	$boutonb817->select;
	push(@selectedBouttons,$boutonb817);
    }
    if (scalar @TableButton >  0) {
	$tmpButt=shift(@TableButton);
	$tmpButt=chr($tmpButt);
	my $boutonb818=$framec8->Checkbutton(-onvalue=>$tmpButt, -offvalue=>$transcodeurTkReplaceChar, -text=>$tmpButt, -variable => \$varBoutonb818, -relief => 'flat')->pack();
	$boutonb818->select;
	push(@selectedBouttons,$boutonb818);
    }
    if (scalar @TableButton >  0) {
	$tmpButt=shift(@TableButton);
	$tmpButt=chr($tmpButt);
	my $boutonb819=$framec8->Checkbutton(-onvalue=>$tmpButt, -offvalue=>$transcodeurTkReplaceChar, -text=>$tmpButt, -variable => \$varBoutonb819, -relief => 'flat')->pack();
	$boutonb819->select;
	push(@selectedBouttons,$boutonb819);
    }
    if (scalar @TableButton >  0) {
	$tmpButt=shift(@TableButton);
	$tmpButt=chr($tmpButt);
	my $boutonb820=$framec8->Checkbutton(-onvalue=>$tmpButt, -offvalue=>$transcodeurTkReplaceChar, -text=>$tmpButt, -variable => \$varBoutonb820, -relief => 'flat')->pack();
	$boutonb820->select;
	push(@selectedBouttons,$boutonb820);
    }
    if (scalar @TableButton >  0) {
	$tmpButt=shift(@TableButton);
	$tmpButt=chr($tmpButt);
	my $boutonb91=$framec9->Checkbutton(-onvalue=>$tmpButt, -offvalue=>$transcodeurTkReplaceChar, -text=>$tmpButt, -variable => \$varBoutonb91, -relief => 'flat')->pack();
	$boutonb91->select;
	push(@selectedBouttons,$boutonb91);
    }
    if (scalar @TableButton >  0) {
	$tmpButt=shift(@TableButton);
	$tmpButt=chr($tmpButt);
	my $boutonb92=$framec9->Checkbutton(-onvalue=>$tmpButt, -offvalue=>$transcodeurTkReplaceChar, -text=>$tmpButt, -variable => \$varBoutonb92, -relief => 'flat')->pack();
	$boutonb92->select;
	push(@selectedBouttons,$boutonb92);
    }
    if (scalar @TableButton >  0) {
	$tmpButt=shift(@TableButton);
	$tmpButt=chr($tmpButt);
	my $boutonb93=$framec9->Checkbutton(-onvalue=>$tmpButt, -offvalue=>$transcodeurTkReplaceChar, -text=>$tmpButt, -variable => \$varBoutonb93, -relief => 'flat')->pack();
	$boutonb93->select;
	push(@selectedBouttons,$boutonb93);
    }
    if (scalar @TableButton >  0) {
	$tmpButt=shift(@TableButton);
	$tmpButt=chr($tmpButt);
	my $boutonb94=$framec9->Checkbutton(-onvalue=>$tmpButt, -offvalue=>$transcodeurTkReplaceChar, -text=>$tmpButt, -variable => \$varBoutonb94, -relief => 'flat')->pack();
	$boutonb94->select;
	push(@selectedBouttons,$boutonb94);
    }
    if (scalar @TableButton >  0) {
	$tmpButt=shift(@TableButton);
	$tmpButt=chr($tmpButt);
	my $boutonb95=$framec9->Checkbutton(-onvalue=>$tmpButt, -offvalue=>$transcodeurTkReplaceChar, -text=>$tmpButt, -variable => \$varBoutonb95, -relief => 'flat')->pack();
	$boutonb95->select;
	push(@selectedBouttons,$boutonb95);
    }
    if (scalar @TableButton >  0) {
	$tmpButt=shift(@TableButton);
	$tmpButt=chr($tmpButt);
	my $boutonb96=$framec9->Checkbutton(-onvalue=>$tmpButt, -offvalue=>$transcodeurTkReplaceChar, -text=>$tmpButt, -variable => \$varBoutonb96, -relief => 'flat')->pack();
	$boutonb96->select;
	push(@selectedBouttons,$boutonb96);
    }
    if (scalar @TableButton >  0) {
	$tmpButt=shift(@TableButton);
	$tmpButt=chr($tmpButt);
	my $boutonb97=$framec9->Checkbutton(-onvalue=>$tmpButt, -offvalue=>$transcodeurTkReplaceChar, -text=>$tmpButt, -variable => \$varBoutonb97, -relief => 'flat')->pack();
	$boutonb97->select;
	push(@selectedBouttons,$boutonb97);
    }
    if (scalar @TableButton >  0) {
	$tmpButt=shift(@TableButton);
	$tmpButt=chr($tmpButt);
	my $boutonb98=$framec9->Checkbutton(-onvalue=>$tmpButt, -offvalue=>$transcodeurTkReplaceChar, -text=>$tmpButt, -variable => \$varBoutonb98, -relief => 'flat')->pack();
	$boutonb98->select;
	push(@selectedBouttons,$boutonb98);
    }
    if (scalar @TableButton >  0) {
	$tmpButt=shift(@TableButton);
	$tmpButt=chr($tmpButt);
	my $boutonb99=$framec9->Checkbutton(-onvalue=>$tmpButt, -offvalue=>$transcodeurTkReplaceChar, -text=>$tmpButt, -variable => \$varBoutonb99, -relief => 'flat')->pack();
	$boutonb99->select;
	push(@selectedBouttons,$boutonb99);
    }
    if (scalar @TableButton >  0) {
	$tmpButt=shift(@TableButton);
	$tmpButt=chr($tmpButt);
	my $boutonb910=$framec9->Checkbutton(-onvalue=>$tmpButt, -offvalue=>$transcodeurTkReplaceChar, -text=>$tmpButt, -variable => \$varBoutonb910, -relief => 'flat')->pack();
	$boutonb910->select;
	push(@selectedBouttons,$boutonb910);
    }
    if (scalar @TableButton >  0) {
	$tmpButt=shift(@TableButton);
	$tmpButt=chr($tmpButt);
	my $boutonb911=$framec9->Checkbutton(-onvalue=>$tmpButt, -offvalue=>$transcodeurTkReplaceChar, -text=>$tmpButt, -variable => \$varBoutonb911, -relief => 'flat')->pack();
	$boutonb911->select;
	push(@selectedBouttons,$boutonb911);
    }
    if (scalar @TableButton >  0) {
	$tmpButt=shift(@TableButton);
	$tmpButt=chr($tmpButt);
	my $boutonb912=$framec9->Checkbutton(-onvalue=>$tmpButt, -offvalue=>$transcodeurTkReplaceChar, -text=>$tmpButt, -variable => \$varBoutonb912, -relief => 'flat')->pack();
	$boutonb912->select;
	push(@selectedBouttons,$boutonb912);
    }
    if (scalar @TableButton >  0) {
	$tmpButt=shift(@TableButton);
	$tmpButt=chr($tmpButt);
	my $boutonb913=$framec9->Checkbutton(-onvalue=>$tmpButt, -offvalue=>$transcodeurTkReplaceChar, -text=>$tmpButt, -variable => \$varBoutonb913, -relief => 'flat')->pack();
	$boutonb913->select;
	push(@selectedBouttons,$boutonb913);
    }
    if (scalar @TableButton >  0) {
	$tmpButt=shift(@TableButton);
	$tmpButt=chr($tmpButt);
	my $boutonb914=$framec9->Checkbutton(-onvalue=>$tmpButt, -offvalue=>$transcodeurTkReplaceChar, -text=>$tmpButt, -variable => \$varBoutonb914, -relief => 'flat')->pack();
	$boutonb914->select;
	push(@selectedBouttons,$boutonb914);
    }
    if (scalar @TableButton >  0) {
	$tmpButt=shift(@TableButton);
	$tmpButt=chr($tmpButt);
	my $boutonb915=$framec9->Checkbutton(-onvalue=>$tmpButt, -offvalue=>$transcodeurTkReplaceChar, -text=>$tmpButt, -variable => \$varBoutonb915, -relief => 'flat')->pack();
	$boutonb915->select;
	push(@selectedBouttons,$boutonb915);
    }
    if (scalar @TableButton >  0) {
	$tmpButt=shift(@TableButton);
	$tmpButt=chr($tmpButt);
	my $boutonb916=$framec9->Checkbutton(-onvalue=>$tmpButt, -offvalue=>$transcodeurTkReplaceChar, -text=>$tmpButt, -variable => \$varBoutonb916, -relief => 'flat')->pack();
	$boutonb916->select;
	push(@selectedBouttons,$boutonb916);
    }
    if (scalar @TableButton >  0) {
	$tmpButt=shift(@TableButton);
	$tmpButt=chr($tmpButt);
	my $boutonb917=$framec9->Checkbutton(-onvalue=>$tmpButt, -offvalue=>$transcodeurTkReplaceChar, -text=>$tmpButt, -variable => \$varBoutonb917, -relief => 'flat')->pack();
	$boutonb917->select;
	push(@selectedBouttons,$boutonb917);
    }
    if (scalar @TableButton >  0) {
	$tmpButt=shift(@TableButton);
	$tmpButt=chr($tmpButt);
	my $boutonb918=$framec9->Checkbutton(-onvalue=>$tmpButt, -offvalue=>$transcodeurTkReplaceChar, -text=>$tmpButt, -variable => \$varBoutonb918, -relief => 'flat')->pack();
	$boutonb918->select;
	push(@selectedBouttons,$boutonb918);
    }
    if (scalar @TableButton >  0) {
	$tmpButt=shift(@TableButton);
	$tmpButt=chr($tmpButt);
	my $boutonb919=$framec9->Checkbutton(-onvalue=>$tmpButt, -offvalue=>$transcodeurTkReplaceChar, -text=>$tmpButt, -variable => \$varBoutonb919, -relief => 'flat')->pack();
	$boutonb919->select;
	push(@selectedBouttons,$boutonb919);
    }
    if (scalar @TableButton >  0) {
	$tmpButt=shift(@TableButton);
	$tmpButt=chr($tmpButt);
	my $boutonb920=$framec9->Checkbutton(-onvalue=>$tmpButt, -offvalue=>$transcodeurTkReplaceChar, -text=>$tmpButt, -variable => \$varBoutonb920, -relief => 'flat')->pack();
	$boutonb920->select;
	push(@selectedBouttons,$boutonb920);
    }
    my $legende=$frame11->Frame()->pack();
    my $present = $frame11->Frame()->pack(-side => 'top', -fill => 'x');
    my $label1 = $present->Label(-text => 'Les caractres slectionns', -width => 30, -anchor => 'w')->pack(-side => 'top');;
    my $label2 = $present->Label(-text => 'seront maintenus, les autres seront', -width => 30, -anchor => 'w')->pack(-side => 'top');;
    my $label3 = $present->Label(-text => 'remplacs par le caractre de', -width => 30, -anchor => 'w')->pack(-side => 'top');;
    my $label4 = $present->Label(-text => 'remplacement', -width => 30, -anchor => 'w')->pack(-side => 'top');;

    my $w_string = $frame11->Frame()->pack(-side => 'top', -fill => 'x');
    my $label = $w_string->Label(-text => 'Replace-Char', -width => 20, -anchor => 'w');
    $transcodeurTkReplaceChar="~";
    my $saisie =  $w_string->Entry(-textvariable => \$transcodeurTkReplaceChar);
    $label->pack(-side => 'top');
    $saisie->pack(-side => 'top');


    my $continua=$frame11->Button(-text => "Apply Translate-Char",
			      -command => \&ContinueTranscodeurTk($transcodeurTkReplaceChar))->pack();
    my $exit=$frame11->Button(-text => "Close",
			      -command => sub {$windowTranscodeurTk->destroy()})->pack();


}

#---------------------------------------------------------------------------------------
sub ContinueTranscodeurTk {
&UpdateIndicators2;
    if (!open(TMPFILE,"$winMain::nom_fic")) {
	&mkPrintErreur("ERREUR : Impossible d\'ouvrir '$winMain::nom_fic'\n");
	return;
    }
    my @TableButton=();
    my %liste_charInput=();
    while($ligne=<TMPFILE>) {
	foreach  my $char (keys %liste_charInput) {
	    push(@TableButton,$char);  
	}


    }
    close(TMPFILE);
}

#---------------------------------------------------------------------------------------
sub applyChangeInTableCharacter1 {
&UpdateIndicators2;

	my @liste_char= ();
	my %liste_charInput= ();

	$FichierCaracteres = $winMain::nom_fic .  ".VerifieCaracteres" ;

	if (!open(TMPFILE, "TableCharacter.txt")) {
	    &mkPrintErreur("ERREUR : Impossible d\'ouvrir le fichier TableCharacter.txt\n, ce fichier est indispensable pour cette option\n");
	    return;
	}
	while(<TMPFILE>) {
	    $_=~/^(.)(.)\d/;
	    $liste_charInput{$1}=$2;	    
	    print "$1 devient $2\n";
	}
	close(TMPFILE);

	if (!open(TMPFILE,"$winMain::nom_fic")) {
	&mkPrintErreur("ERREUR : Ouverture impossible de $winMain::nom_fic\n");
	return;
        }
	$FichierCaracteres = "$winMain::nom_fic".".modified";
	if (!open(TMPFILE2, ">$FichierCaracteres")) {
	    &mkPrintErreur("ERREUR : Impossible d\'ouvrir '$FichierCaracteres'\n");
	    return;
	}

	my $id=0;
	while($ligne=<TMPFILE>) {
	    $id++;
	    $newline="";
	    $modification="no";
	    while ($ligne=~/(.)/g) {
		$ind=$1;
		if (exists $liste_charInput{$ind}) {
		    $newline.=$liste_charInput{$ind};
		}
		else {
		    $modification="yes";
#		    $newline.=$ind;
		    $newline.=" ";
		}
	    }
	    print TMPFILE2 "$newline\n";
	}
	close(TMPFILE);
	close(TMPFILE2);
	close(TMPFILE3);
	$FichierCaracteres = "$winMain::nom_fic".".modified";
	my $tmpfile=$FichierCaracteres;
	my $msg="Modified File : ".$FichierCaracteres;
	&IncludedFileInWindow($tmpfile,$msg);
}

#---------------------------------------------
sub applyChangeInTableCharacter2 {
&UpdateIndicators2;

	my @liste_char= ();
	my %liste_charInput= ();

	$FichierCaracteres = $winMain::nom_fic .  ".VerifieCaracteres" ;

	if (!open(TMPFILE, "TableCharacter.txt")) {
	    &mkPrintErreur("ERREUR : Impossible d\'ouvrir le fichier TableCharacter.txt\n, ce fichier est indispensable pour cette option\n");
	    return;
	}
	while(<TMPFILE>) {
	    $_=~/^(.)(.)\d/;
	    $liste_charInput{$1}=$2;	    
	    print "$1 devient $2\n";
	}
	close(TMPFILE);

	if (!open(TMPFILE,"$winMain::nom_fic")) {
	&mkPrintErreur("ERREUR : Ouverture impossible de $winMain::nom_fic\n");
	return;
        }
	$FichierCaracteres = "$winMain::nom_fic".".modified";
	if (!open(TMPFILE2, ">$FichierCaracteres")) {
	    &mkPrintErreur("ERREUR : Impossible d\'ouvrir '$FichierCaracteres'\n");
	    return;
	}
	$FichierCaracteres = "$winMain::nom_fic".".modification";
	if (!open(TMPFILE3, ">$FichierCaracteres")) {
	    &mkPrintErreur("ERREUR : Impossible d\'ouvrir '$FichierCaracteres'\n");
	    return;
	}
	print TMPFILE3 "Liste modifications : \n";
	print TMPFILE3 "--------------------- \n\n";

	my $id=0;
	while($ligne=<TMPFILE>) {
	    $id++;
	    $newline="";
	    $modification="no";
	    while ($ligne=~/(.)/g) {
		$ind=$1;
		if (exists $liste_charInput{$ind}) {
		    $newline.=$liste_charInput{$ind};
		}
		else {
		    $modification="yes";
#		    $newline.=$ind;
		    $newline.=" ";
		    print TMPFILE3 "--------------------------------------------------------\n";
		    print TMPFILE3 "Ligne ($id) ->  modifie : \n";
		    print TMPFILE3 "$ligne";
		    print TMPFILE3 "Caractre remplac par un blanc : char =<$ind> ascii=<".ord($ind)."> \n";
		    
		}
	    }
	    if ($modification eq "yes") {print TMPFILE3 "Ligne ($id) -> Rcriture (entre chevron) :\n<$newline>\n";} 
	    print TMPFILE2 "$newline\n";
	}
	close(TMPFILE);
	close(TMPFILE2);
	close(TMPFILE3);
	$FichierCaracteres = "$winMain::nom_fic".".modified";
	my $tmpfile=$FichierCaracteres;
	my $msg="Modified File : ".$FichierCaracteres;
	&IncludedFileInWindow($tmpfile,$msg);
	$FichierCaracteres = "$winMain::nom_fic".".modification";
	my $tmpfile=$FichierCaracteres;
	my $msg="Modification : ".$FichierCaracteres;
	&IncludedFileInWindow($tmpfile,$msg);

}


#---------------------------------------------
sub changeAsciiInText {
&UpdateIndicators2;

    if (! Exists ($pnChangeAscii)) {
	$pnChangeAscii = $winMain::mw ->Toplevel();
	$pnChangeAscii->title("Choose Char");
	$listePnChangeAscii=$pnChangeAscii->Scrolled("Listbox", -scrollbars => "e",
			      -selectmode => "extended",
			      -selectforeground => "red",
			      -setgrid => 1,
			      -width => -1)->pack();

	$pnChangeAscii->Button(-text => "Delete",
		     -command =>  \&delete_selected_ascii)->pack(-side => 'left', -pady => 5, -padx => 10);
	$pnChangeAscii->Button(-text => "Modify",
		     -command =>  \&modify_selected_ascii)->pack(-side => 'left', -pady => 5, -padx => 10);
	$pnChangeAscii->Button(-text => "Search",
		     -command =>  \&concordance_Asciichar)->pack(-side => 'left', -pady => 5, -padx => 10);
	$pnChangeAscii->Button(-text => "Close",
		     -command =>  sub {$pnChangeAscii->destroy()})->pack(-side => 'left', -pady => 5, -padx => 10);

	my @liste_char= ();

	$FichierCaracteres = $winMain::nom_fic .  ".Ascii" ;

	if (!open(TMPFILE, "$FichierCaracteres")) {
	    &mkPrintErreur("ERREUR : Impossible d\'ouvrir '$FichierCaracteres'\n, ce fichier est gnr par l'item Read Char\n");
	    return;
	}
	my $id=0;
	while(<TMPFILE>) {
	    chomp;
	    if ($_=~/^(.*)<>(.*)/) {
		$liste_char[$id]=$1;
		$id++;
	    }
	}
	close(TMPFILE);
	$listePnChangeAscii->delete(0,'end');
	$listePnChangeAscii->insert('end',@liste_char);
    }
    else {
	$pnChangeAscii->deiconify();
	$pnChangeAscii->raise();
    }
}
#---------------------------------------------
sub maketagmap {
&UpdateIndicators2;
    if (! Exists ($pn2Map)) {
	$pn2Map = $winMain::mw ->Toplevel();
	$pn2Map->title("Choose Markups (DOM)");

	$listePn2Map=$pn2Map->Scrolled("Listbox", -scrollbars => "e",
			      -selectmode => "extended",
			      -selectforeground => "red",
			      -setgrid => 1,
			      -width => -1)->pack();
	$pn2Map->Button(-text => "Text 2 Map",
		     -command =>  \&make_text2mapWithDOM)->pack(-side => 'left', -pady => 5, -padx => 10);

	$pn2Map->Button(-text => "Close",
		     -command =>  sub {$pn2Map->destroy()})->pack(-side => 'left', -pady => 5, -padx => 10);

	use strict; 
	use XML::DOM; 
	@listxmlDomExtractTag=();
	%listxmlDomExtractTag=();
	my $p = XML::DOM::Parser->new; 
	my $doc;
	eval { $doc=$p->parsefile($winMain::nom_fic)};
	if ($@) {
	    my $msg=$@;
	    $pn2Map->destroy();
	    &mkPrintErreur("Caught Error : $msg\n");
	    return;
	}
	else {
	    &process_nodexmlDomExtractTag($doc->getDocumentElement);
#	    &process_nodexmlDomExtractTag($doc->getFirstChild); 
	    $listePn2Map->delete(0,'end');
	    $listePn2Map->insert('end',@listxmlDomExtractTag);
	}
    }
    else {
	$pn2Map->deiconify();
	$pn2Map->raise();
    }
}
#---------------------------------------------
sub maketreetagmap_libxml {

    &UpdateIndicators2;
    use strict; 
    use XML::LibXML;
    my $p = XML::LibXML->new();
    my $doc;
    &loadSplashWindow;
    eval { $doc=$p->parse_file($winMain::nom_fic)};
    if ($@) {
	my $msg=$@;
	&mkPrintErreur("Caught Error : $msg\n");
	&removeSplashWindow;
	return;
    }
    else {
	#-------SPLASH REFRESH
	&splashProgress( "Work In Progress...", 25 );
        #-------SPLASH REFRESH

#	my $node = $doc->getFirstChild ;
	my $node = $doc->documentElement;
	print $node,"\n";
	my $type;
	my $nodeType = $node->nodeType; 
	print "NODE TYPE : ", $nodeType,"\n";;
	if ($nodeType == ELEMENT_NODE) { 
	    $type = $node->nodeName; 
	    print "TYPE : ",$type,"\n";
	} 
	#-------SPLASH REFRESH
	&splashProgress( "Work In Progress...", 70 );
        #-------SPLASH REFRESH

	&make_text2mapWithDOM3($type,$node);
    }
    &removeSplashWindow;
}

#---------------------------------------------
sub maketreetagmap {
&UpdateIndicators2;
    use strict; 
    use XML::DOM; 
    my $p = XML::DOM::Parser->new; 
    my $doc;
    &loadSplashWindow;
    eval { $doc=$p->parsefile($winMain::nom_fic)};
    if ($@) {
	my $msg=$@;
	&mkPrintErreur("Caught Error : $msg\n");
	&removeSplashWindow;
	return;
    }
    else {
	#-------SPLASH REFRESH
	&splashProgress( "Work In Progress...", 25 );
        #-------SPLASH REFRESH

#	my $node = $doc->getFirstChild ;
	my $node = $doc->getDocumentElement;
	print $node,"\n";
	my $type;
	my $nodeType = $node->getNodeType; 
	if ($nodeType == ELEMENT_NODE) { 
	    $type = $node->getTagName; 
	    print "TYPE : ",$type,"\n";
	} 
	#-------SPLASH REFRESH
	&splashProgress( "Work In Progress...", 70 );
        #-------SPLASH REFRESH

	&make_text2mapWithDOM3($type,$node);
    }
    &removeSplashWindow;
}
#---------------------------------------------
sub lexico3 {
    &UpdateIndicators2;

    use strict; 
    use XML::DOM; 
    @listxmlDomExtractTag=();
    %listxmlDomExtractTag=();
    my $p = XML::DOM::Parser->new; 
    my $doc;
	eval { $doc=$p->parsefile($winMain::nom_fic)};
	if ($@) {
	    &mkPrintErreur("Caught Error : $@\n");
	    return;
	}   
#    &process_nodexmlDomExtractTag($doc->getFirstChild); 
    &process_nodexmlDomExtractTag($doc->getDocumentElement);
    &mkSelectionForLexicoXMLMarkupWithDOM1;

}
#---------------------------------------------
sub helpMap2tag {
&UpdateIndicators2;

    my ($texteMp) = @_;
    $texteMp->delete("1.0","end");
    my $msg="HELP\n\n";
    $texteMp->insert('end',$msg);
    $msg="1\tCLIC GAUCHE sur carr => affichage du contenu textuel du noeud-carr et de ses fils dans la zone d\'dition\n\n";
    $texteMp->insert('end',$msg);
    $msg="2\tCLIC DROIT sur carr => affichage des fils du noeud-carr (descente dans l'arbre...)\n\n";
    $texteMp->insert('end',$msg);
    $msg="3\tLa Fonction \"search in Map\" recherche dans tous les noeuds-carr la prsence de la chane de caractre donne dans la zone \"search : \" ; les carrs devenus rouge contiennent la chane, les carrs devenus blanc ne la contiennent pas.\n\n";
    $texteMp->insert('end',$msg);
    $msg="4\tLes fonctions \"HighLight in text\" et \"search in text\" recherchent dans la zone dans la zone d\'dition  la prsence de la chane de caractre donne dans la zone \"search : \".\n\n";
    $texteMp->insert('end',$msg);
}
#---------------------------------------------------------------------------------------
sub helpMap2tag2 {
&UpdateIndicators2;

    my ($texteMp) = @_;
    $texteMp->delete("1.0","end");
    my $msg="HELP\n\n";
    $texteMp->insert('end',$msg);
    $msg="1\tCLIC GAUCHE sur carr => affichage du contenu textuel du carr (un lment) et de ses fils dans la zone d\'dition\n\n";
    $texteMp->insert('end',$msg);
    $msg="2\tCLIC DROIT sur carr => sauvegarde du carr-noeud et de ses fils dans un fichier XML\n\n";
    $texteMp->insert('end',$msg);
    $msg="3\tLa Fonction \"search in Map\" recherche dans tous les noeuds-carr la prsence de la chane de caractre donne dans la zone \"search : \": les carrs devenus rouge contiennent la chane, les carrs devenus blanc ne la contiennent pas.\n\n";
    $texteMp->insert('end',$msg);
    $msg="4\tLes fonctions \"HighLight in text\" et \"search in text\" recherchent dans la zone dans la zone d\'dition  la prsence de la chane de caractre donne dans la zone \"search : \".\n\n";
    $texteMp->insert('end',$msg);
}

#---------------------------------------------
sub help_lexico4 {
&UpdateIndicators2;
    if (! Exists ($pn1)) {
	$pn1 = $winMain::mw ->Toplevel();
	$pn1->title("HELP");
	my $label = $pn1->Label( -background => 'black',
				  -foreground =>  'white', -anchor => 'w' );
	my $texte2 = $pn1->Scrolled("MarkupTools")->pack(-side => 'bottom',
				      -fill => 'both',
				      -expand => 1);

	$texte2->Text(-setgrid => 'true');
	&updateMarkupWindow($texte2,$label);
	my $tmpfile="Doc/lexico4.txt";
	$texte2->IncludeFile($tmpfile);

	$pn1->Button(-text => "Close",
		     -command =>  sub {$pn1->destroy()})->pack(-side => 'top', -pady => 5, -padx => 10);

	my $w_save=$pn1->Button(-text => "Save",
		     -image => $imageSave,
		     -command => sub {$texte2->FileSaveAsPopup()})->pack(-side => 'top', -pady => 5, -padx => 10);
	$winMain::winBalloon->attach($w_save,
			    -balloonmsg => "Save"
			    );

    }
    else {
	$pn1->deiconify();
	$pn1->raise();
    }
}


#---------------------------------------------------------------------------------------
sub lexico4 {
&UpdateIndicators2;

    if (!open(INPUT,"$winMain::nom_fic")) {
	&mkPrintErreur("ERREUR : Impossible d\'ouvrir '$winMain::nom_fic'\n");
	return;
    }
    if (!open(OUTPUT,">MKC-tmp_lexico4.txt")) {
    &mkPrintErreur("ERREUR : Impossible d\'ouvrir MKC-tmp_lexico4.txt\n");
    return;
	}
    while ($ligne =<INPUT>){
	if ($ligne=~/[A-Z]/){
	    $ligne=~s/<([^>]+)>/<\L$1>/gi;
	    $ligne=~s/([A-Z])/*\l$1/g;
	    $ligne=~s/<([^>]+)>/<\U$1>/gi;
	}
	print OUTPUT $ligne ;
    }
    close (INPUT );
    close (OUTPUT) ;
    my $tmpfile="MKC-tmp_lexico4.txt";
    my $msg="MKC-tmp_lexico4.txt";
    &IncludedFileInWindow($tmpfile,$msg);


}
#---------------------------------------------
sub help_lexico5 {
&UpdateIndicators2;
    if (! Exists ($pn1)) {
	$pn1 = $winMain::mw ->Toplevel();
	$pn1->title("HELP");
	my $label = $pn1->Label( -background => 'black',
				  -foreground =>  'white', -anchor => 'w' );
	my $texte2 = $pn1->Scrolled("MarkupTools")->pack(-side => 'bottom',
				      -fill => 'both',
				      -expand => 1);

	$texte2->Text(-setgrid => 'true');
	&updateMarkupWindow($texte2,$label);
	my $tmpfile="Doc/lexico5.txt";
	$texte2->IncludeFile($tmpfile);

	$pn1->Button(-text => "Close",
		     -command =>  sub {$pn1->destroy()})->pack(-side => 'top', -pady => 5, -padx => 10);

	my $w_save=$pn1->Button(-text => "Save",
		     -image => $imageSave,
		     -command => sub {$texte2->FileSaveAsPopup()})->pack(-side => 'top', -pady => 5, -padx => 10);
	$winMain::winBalloon->attach($w_save,
			    -balloonmsg => "Save"
			    );

    }
    else {
	$pn1->deiconify();
	$pn1->raise();
    }
}

#---------------------------------------------------------------------------------------
sub lexico5 {
&UpdateIndicators2;

    if (!open(INPUT,"$winMain::nom_fic")) {
	&mkPrintErreur("ERREUR : Impossible d\'ouvrir '$winMain::nom_fic'\n");
	return;
    }
    if (!open(OUTPUT,">MKC-tmp_lexico5.txt")) {
	&mkPrintErreur("ERREUR : Impossible d\'ouvrir MKC-tmp_lexico5.txt\n");
	return;
    }
    
    while ($ligne =<INPUT>){
	if ($ligne =~ /^\s*\d+\s([^\d]+)(.*).$/){
	    $SegmentOuForme = $1 ;
	    if ($SegmentOuForme   !~ /^$MotsAEnlever /i && $SegmentOuForme   !~ / $MotsAEnlever\s+$/i) {
		print OUTPUT $ligne ;
	    }
	}
	else { 
	    print $ligne ;
	}
    }
    close (INPUT );
    close (OUTPUT) ;
    my $tmpfile="MKC-tmp_lexico5.txt";
    my $msg="MKC-tmp_lexico4.txt";
    &IncludedFileInWindow($tmpfile,$msg);

}
#---------------------------------------------
sub help_lexico6 {
&UpdateIndicators2;
    if (! Exists ($pn1)) {
	$pn1 = $winMain::mw ->Toplevel();
	$pn1->title("HELP");
	my $label = $pn1->Label( -background => 'black',
				  -foreground =>  'white', -anchor => 'w' );
	my $texte2 = $pn1->Scrolled("MarkupTools")->pack(-side => 'bottom',
				      -fill => 'both',
				      -expand => 1);

	$texte2->Text(-setgrid => 'true');
	&updateMarkupWindow($texte2,$label);
	my $tmpfile="Doc/lexico6.txt";
	$texte2->IncludeFile($tmpfile);

	$pn1->Button(-text => "Close",
		     -command =>  sub {$pn1->destroy()})->pack(-side => 'top', -pady => 5, -padx => 10);

	my $w_save=$pn1->Button(-text => "Save",
		     -image => $imageSave,
		     -command => sub {$texte2->FileSaveAsPopup()})->pack(-side => 'top', -pady => 5, -padx => 10);
	$winMain::winBalloon->attach($w_save,
			    -balloonmsg => "Save"
			    );

    }
    else {
	$pn1->deiconify();
	$pn1->raise();
    }
}

#---------------------------------------------------------------------------------------
sub lexico6 {
&UpdateIndicators2;

    if (!open(INPUT,"$winMain::nom_fic")) {
	&mkPrintErreur("ERREUR : Impossible d\'ouvrir '$winMain::nom_fic'\n");
	return;
    }
    if (!open(OUTPUT,">MKC-tmp_lexico6.txt")) {
	&mkPrintErreur("ERREUR : Impossible d\'ouvrir MKC-tmp_lexico6.txt\n");
	return;
    }
    while ($ligne =<STDIN>){
	if ($ligne =~ /F= +([0-9]+) +(.*)/) {
	    $Frequence = $1 ;
	    $Segment   = $2 ;
	    if ($Segment   !~ /^$MotsAEnlever /i && $Segment   !~ / $MotsAEnlever\r$/i) {
		print OUTPUT "$Frequence $Segment\n" ;
	    }
	}
    }
    close (INPUT );
    close (OUTPUT) ;
    my $tmpfile="MKC-tmp_lexico6.txt";
    my $msg="MKC-tmp_lexico6.txt";
    &IncludedFileInWindow($tmpfile,$msg);
}


#---------------------------------------------
sub lexico1 {
&UpdateIndicators2;

    my $parser = new XML::Parser(Style=>'Subs', Pkg=>'SubHandlers', ErrorContext => 2);
    $parser->setHandlers(End => \&end_handler,
			 Start => \&start_handlerLexico);
    @liste_xmlLexicoBalise = ();
    %Liste_xmlLexicoBalise = ();
    eval { $parser->parsefile($winMain::nom_fic)};
    if ($@) {
	&mkPrintErreur("Caught Error : $@\n");
#	return;
	}
#    print "LISTE BALISE : @liste_xmlBalise\n";
    &mkSelectionXMLLexicoMarkup(@liste_xmlLexicoBalise);
}
#---------------------------------------------
sub lexico2 {
&UpdateIndicators2;
    my $parser = new XML::Parser(Style=>'Subs', Pkg=>'SubHandlers', ErrorContext => 2);
    $parser->setHandlers(End => \&end_handler,
			 Start => \&start_handlerLexico);
    @liste_xmlLexicoBalise2 = ();
    %Liste_xmlLexicoBalise2 = ();
    eval { $parser->parsefile($winMain::nom_fic)};
    if ($@) {
	&mkPrintErreur("Caught Error : $@\n");
#	return;
	}
    &mkSelectionXMLLexicoMarkup2(@liste_xmlLexicoBalise2);
}
#---------------------------------------------
sub alceste1 {
&UpdateIndicators2;

    &mkIndisponible();
}

#---------------------------------------------
sub alceste2 {
&UpdateIndicators2;

    &mkIndisponible();
}
#---------------------------------------------
sub help_cordial {
&UpdateIndicators2;
    if (! Exists ($pnCordial)) {
	$pnCordial = $winMain::mw ->Toplevel();
	$pnCordial->title("Aide Cordial");
	my $label = $pnCordial->Label( -background => 'black',
				  -foreground =>  'white', -anchor => 'w' );
	my $texte2 = $pnCordial->Scrolled("MarkupTools")->pack(-side => 'bottom',
				      -fill => 'both',
				      -expand => 1);
	$texte2->Text(-setgrid => 'true');
	&updateMarkupWindow($texte2,$label);
	$texte2->insert("end","##############################################################################\n");
	$texte2->insert("end","B. Habert\n");
	$texte2->insert("end","17.02.00\n");
	$texte2->insert("end","Format d\'entre : \n");
	$texte2->insert("end","     Sorties de Cordial 6 universits avec des tiquettes au format GRACE. Exemple :\n");
	$texte2->insert("end","N mot  mot     lemme   Codegram\n");
	$texte2->insert("end","        ==== DEBUT DE PHRASE ====\n");
	$texte2->insert("end","0       \r<#Art-513-1>\r\n");
	$texte2->insert("end","1       Repenser        repenser        Vmn--\n");
	$texte2->insert("end","2       la      le      Da-fs-d\n");
	$texte2->insert("end","3       loi     loi     Ncfs\n");
	$texte2->insert("end","4       de      de      Sp\n");
	$texte2->insert("end","5       fixation        fixation        Ncfs\n");
	$texte2->insert("end","6       des     de      Da-.p-i\n");
	$texte2->insert("end","7       prix    prix    Ncmp\n");
	$texte2->insert("end","8        \n");
	$texte2->insert("end","        ===== FIN DE PHRASE =====\n");
	$texte2->insert("end","        ==== DEBUT DE PHRASE ====\n");
	$texte2->insert("end","Attention, il s'agit d'un fichier Windows dont les fins de lignes sont marques par \r\n\n");
	$texte2->insert("end","\n");
	$texte2->insert("end","Format de sortie :\n");
	$texte2->insert("end","     Chaque fin de phrase est remplace par la mention de <BLOC>. Pour chaque item, son lemme et sa catgorie, soudes par un sparateur dont il faut vrifier qu'il n'est pas employ dans le texte tiquet. Exemple :\n");
	$texte2->insert("end","repenser_V\n");
	$texte2->insert("end","le_D\n");
	$texte2->insert("end","loi_N\n");
	$texte2->insert("end","de_S\n");
	$texte2->insert("end","fixation_N\n");
	$texte2->insert("end","de_D\n");
	$texte2->insert("end","prix_N\n");
	$texte2->insert("end","<BLOC>\n");
	$texte2->insert("end","le_D\n");
	$texte2->insert("end","article_N\n");
	$texte2->insert("end","45_N\n");
	$texte2->insert("end","\n");
	$texte2->insert("end","\n");
	$texte2->insert("end","NB : pour ne pas parpiller les lemmes, on ne garde que la partie du discours et pas les traits supplmentaires. Sinon, on obtiendrait :\n");

	$texte2->insert("end","\n");
	$texte2->insert("end","repenser_Vmn--\n");
        $texte2->insert("end","le_Da-fs-d\n");
        $texte2->insert("end","loi_Ncfs\n");
        $texte2->insert("end","de_Sp\n");
        $texte2->insert("end","fixation_Ncfs\n");
        $texte2->insert("end","de_Da-.p-i\n");
        $texte2->insert("end","prix_Ncmp\n");
        $texte2->insert("end","<BLOC>\n");
        $texte2->insert("end","le_Da-ms-d\n");
        $texte2->insert("end","article_Ncms\n");
        $texte2->insert("end","45_Ncm.\n");
        $texte2->insert("end","A faire :\n");
        $texte2->insert("end","Bugs et problmes :\n");
	$texte2->insert("end","\n");
	$texte2->insert("end","\n");
	$pnCordial->Button(-text => "Close",
		     -command =>  sub {$pnCordial->destroy()})->pack(-side => 'top', -pady => 5, -padx => 10);
	my $w_save=$pnCordial->Button(-text => "Save",
			   -image => $winMain::imageSave,
			   -command => sub {$texte2->FileSaveAsPopup()})->pack(-side => 'top', -pady => 5, -padx => 10);
	$winMain::winBalloon->attach($w_save,
			    -balloonmsg => "Save"
			    );

    }
    else {
	$pnCordial->deiconify();
	$pnCordial->raise();
    }
}

#---------------------------------------------
sub cordial2 {
&UpdateIndicators2;


    if (!open(RES1,(">".$winMain::start_dir."cordial/cordial_format1.txt"))) {
	&mkPrintErreur("ERREUR : Impossible d\'ouvrir le fichier cordial_format1.txt\n");
	return;
    }
    if (!open(RES2,(">".$winMain::start_dir."cordial/cordial_format2.txt"))) {
	&mkPrintErreur("ERREUR : Impossible d\'ouvrir le fichier cordial_format2.txt\n");
	return;
    }
    if (!open(RES3,(">".$winMain::start_dir."cordial/cordial_format3.txt"))) {
	&mkPrintErreur("ERREUR : Impossible d\'ouvrir le fichier cordial_format3.txt\n");
	return;
    }
    if (!open(TMPFILE,$winMain::nom_fic)) {
	&mkPrintErreur("ERREUR : Impossible d\'ouvrir le fichier $winMain::nom_fic\n");
	return;
    }

#ouvrir la sortie de cordial6 et lui donner un nom ETIQUETTE comme handle de #fichier

my @lines = <TMPFILE>;

close (TMPFILE);

# on stocke la sortie de Cordial6 dans @lines et ferme la liste

#ouvrir trois nouveaux fichiers. Chaque fichier contiendra un rsultat diffrent

my $text="";
my $text1="";
my $text2="";


# initialiser trois variables. On y colle les lments de la liste. 

foreach $line(@lines){ # traiter chaque lment de @lines

chomp ($line);

#supprimer des retours de chariot 

$line =~ s/^\s+[\w \W]*//;

# effacer toutes les lignes qui ne commencent par des espaces
# cest  dire des marqueurs de ligne 

$line =~ s/^\d+[^< > \( \)=\.,!?:+]+([< > \( \)=\.,!?:+]).*/$1/; 

# conserver  < > = :,!?+ mais jeter leur lemme et leur catgorie.

$line =~ s/^\d+\s+([\w        '  ]+)\s+([\w        '  ]+)\s+(\w+)/$1#$2#$3/;

# combiner les mots et leurs lemmes et leurs catgories par un unificateur #  #  # En franais, on doit tenir compte des accents

$text .=" $line"; 

# concatner chaque lment  $text # construire une ligne de texte

} # la fin de loop foreach

$text =~ s/<\s([\w        ']+)#([\w        ']+)#(\w+)\s+= ([\w        ']+)#([\w        ']+)#(\w+)\s+>/<$1 = $4>/g;

# les motifs < mot#lemme#catgorie = mot#lemme#catgorie > sont remplacer # par <mot = mot(numro)> # les cls sont redevenues en forme comme <jour = 1> 

$text =~ s/ ([\. , ? ! : ])/$1/g;

#supprimer un espace devant les caractres. Cet espace a t ajout au # moment de la concatnation. Remarquons quil y a un espace devant $line # de $text .=  $line  ; 

$text =~ s/([> \w \.])\s*</$1\n\n</g;

$text =~ s/>/>\n/g;

# pour la raison de lisibilit des fichiers de sortie, changer la ligne aprs la # cl

$text2=$text1=$text;

# crer 2 copies de $text

$text =~ s/([\w        '  ]+)#([\w        '  ]+)#(\w+)/$1_$3/g;

# chaque mot et leur catgorie sunifient de lunificateur -

$text1 =~ s/([\w        '   ]+)#([\w        '  ]+)#(\w+)/ $2_$3/g;

# chaque lemme et leur catgorie sunifient

$text2 =~ s/([\w        '  ]+)#([\w        '  ]+)#(\w+)/ $3/g;

# on ne garde que les catgories

print RES1 $text;
print RES2 $text1;
print RES3 $text2;

#enregistrer le rsultat dans les trois fichiers en criture 

close (RES1);
close (RES2);
close (RES3);

#fermer ces trois fichiers

my $tmpfile=$winMain::start_dir."cordial/cordial_format1.txt";
my $msg=$winMain::start_dir."cordial/cordial_format1.txt";
&IncludedFileInWindow($tmpfile,$msg);
my $tmpfile=$winMain::start_dir."cordial/cordial_format2.txt";
my $msg=$winMain::start_dir."cordial/cordial_format2.txt";
&IncludedFileInWindow($tmpfile,$msg);
my $tmpfile=$winMain::start_dir."cordial/cordial_format3.txt";
my $msg=$winMain::start_dir."cordial/cordial_format3.txt";
&IncludedFileInWindow($tmpfile,$msg);
 
}


#---------------------------------------------
sub cordial {
&UpdateIndicators2;


my $Forme      = "" ;
my $Lemme      = "" ;
my $Categorie  = "" ;
my $Separateur = "_" ;

    if (!open(RES1,(">".$winMain::start_dir."cordial/cordial_format1.txt"))) {
	&mkPrintErreur("ERREUR : Impossible d\'ouvrir le fichier cordial_format1.txt\n");
	return;
    }
    if (!open(RES2,(">".$winMain::start_dir."cordial/cordial_format2.txt"))) {
	&mkPrintErreur("ERREUR : Impossible d\'ouvrir le fichier cordial_format2.txt\n");
	return;
    }
    if (!open(RES3,(">".$winMain::start_dir."cordial/cordial_format3.txt"))) {
	&mkPrintErreur("ERREUR : Impossible d\'ouvrir le fichier cordial_format3.txt\n");
	return;
    }
    if (!open(RES4,(">".$winMain::start_dir."cordial/cordial_format4.txt"))) {
	&mkPrintErreur("ERREUR : Impossible d\'ouvrir le fichier cordial_format4.txt\n");
	return;
    }
    if (!open(RES5,(">".$winMain::start_dir."cordial/cordial_format5.txt"))) {
	&mkPrintErreur("ERREUR : Impossible d\'ouvrir le fichier cordial_format5.txt\n");
	return;
    }
    if (!open(TMPFILE,$winMain::nom_fic)) {
	&mkPrintErreur("ERREUR : Impossible d\'ouvrir le fichier $winMain::nom_fic\n");
	return;
    }


while ($Ligne = <TMPFILE>){
 if ($Ligne =~ /DEBUT DE PHRASE/ 
     ||
     $Ligne =~ /N\tmot\tmot\tlemme\tCodegram/
     ||
     $Ligne =~ /^0\t/
     ||
     $Ligne =~ /^[0-9]+[\t ]+[0-9]+.*Ncm.\r/
     ||
     $Ligne =~ /Mc\.\./
     ||
     $Ligne =~ /^[0-9]+[\t ]+\r/)
  # Ce sont des lignes qu'on limine
  { 
  }
  elsif ($Ligne =~ /FIN DE PHRASE/)
        {
         print RES1 "<BLOC>\n" ; 
         print RES2 "<BLOC>\n" ; 
         print RES3 "<BLOC>\n" ; 
         print RES4 "<BLOC>\n" ; 
         print RES5 "<BLOC>\n" ; 
        }
  elsif ($Ligne =~ /^[0-9]+\t([^\t]+)\t([^\t]+)\t(.)([^\r]+)/)
        {$Forme = $1 ;
         $Lemme = $2 ;
         $Categorie = $3 ;
         $Traits    = $4 ;
         print RES1 "$Lemme$Separateur$Forme$Separateur$Categorie$Traits " ;
         print RES2 "$Lemme$Separateur$Categorie " ;
         print RES3 "$Forme$Separateur$Categorie " ;
         print RES4 "$Forme " ;
         print RES5 "$Categorie$Traits$Separateur$Lemme$Separateur$Forme " ;
        }
}


close RES1;
close RES2;
close RES3;
close RES4;
close RES5;
close TMPFILE;

my $tmpfile=$winMain::start_dir."cordial/cordial_format1.txt";
my $msg=$winMain::start_dir."cordial/cordial_format1.txt";
&IncludedFileInWindow($tmpfile,$msg);

my $tmpfile=$winMain::start_dir."cordial/cordial_format2.txt";
my $msg=$winMain::start_dir."cordial/cordial_format2.txt";
&IncludedFileInWindow($tmpfile,$msg);

my $tmpfile=$winMain::start_dir."cordial/cordial_format3.txt";
my $msg=$winMain::start_dir."cordial/cordial_format3.txt";
&IncludedFileInWindow($tmpfile,$msg);

my $tmpfile=$winMain::start_dir."cordial/cordial_format4.txt";
my $msg=$winMain::start_dir."cordial/cordial_format4.txt";
&IncludedFileInWindow($tmpfile,$msg);

my $tmpfile=$winMain::start_dir."cordial/cordial_format5.txt";
my $msg=$winMain::start_dir."cordial/cordial_format5.txt";
&IncludedFileInWindow($tmpfile,$msg);


}


#---------------------------------------------
sub cordial2Lexico {
&UpdateIndicators2;


my $Forme      = "" ;
my $Lemme      = "" ;
my $Categorie  = "" ;
my $Separateur = "_" ;

    if (!open(RES1,(">".$winMain::start_dir."cordial/cordialLemCat.txt"))) {
	&mkPrintErreur("ERREUR : Impossible d\'ouvrir le fichier cordialLemCat.txt\n");
	return;
    }
    if (!open(RES2,(">".$winMain::start_dir."cordial/cordialFormCat.txt"))) {
	&mkPrintErreur("ERREUR : Impossible d\'ouvrir le fichier cordialFormCat.txt\n");
	return;
    }
    if (!open(RES3,(">".$winMain::start_dir."cordial/cordialCateg.txt"))) {
	&mkPrintErreur("ERREUR : Impossible d\'ouvrir le fichier cordialCateg.txt\n");
	return;
    }
    if (!open(RES4,(">".$winMain::start_dir."cordial/cordialForme.txt"))) {
	&mkPrintErreur("ERREUR : Impossible d\'ouvrir le fichier cordialForme.txt\n");
	return;
    }
    if (!open(RES5,(">".$winMain::start_dir."cordial/cordialLemme.txt"))) {
	&mkPrintErreur("ERREUR : Impossible d\'ouvrir le fichier cordialLemme.txt\n");
	return;
    }
    if (!open(TMPFILE,$winMain::nom_fic)) {
	&mkPrintErreur("ERREUR : Impossible d\'ouvrir le fichier $winMain::nom_fic\n");
	return;
    }


while ($Ligne = <TMPFILE>){
    $Ligne =~ s/\r//g;
    if ($Ligne =~ /DEBUT DE PHRASE/ 
	||
	$Ligne =~ /N\tmot\tmot\tlemme\tCodegram/
	||
	$Ligne =~ /^[0-9]+[\t ]+[0-9]+.*Ncm.\r/
	||
	$Ligne =~ /Mc\.\./
	||
	$Ligne =~ /^[0-9]+[\t ]+\r/)
	# Ce sont des lignes qu'on limine
    { 
    }
    elsif ($Ligne =~ /^[0-9]+\t.*</) {
	my $baliseAgarder="<";
	$Ligne=<TMPFILE>;
	until ($Ligne=~/>/){
	    $Ligne =~ /^[0-9]+\t([^\t]+)/;
	    my $tmp=$1;
	    chomp($tmp);
	    $baliseAgarder.=$tmp;
	    $Ligne=<TMPFILE>;
#	    break if $Ligne == EOF;
	}
	$baliseAgarder.=">";
	if ($baliseAgarder!~/<[^=]+=[^=>]+>/) {
	    if ($baliseAgarder=~/<[^=-]+-[^-=>]+>/) {
		$baliseAgarder=~s/(<[^=-]+)-([^-=>]+>)/$1=$2/;
	    }
	}
	print RES1 "$baliseAgarder" ;
	print RES2 "$baliseAgarder" ;
	print RES3 "$baliseAgarder" ;
	print RES4 "$baliseAgarder" ;
	print RES5 "$baliseAgarder" ;
	next;
    }
    elsif ($Ligne =~ /FIN DE PHRASE/)
    {
	print RES1 "\n" ; 
	print RES2 "\n" ; 
	print RES3 "\n" ; 
	print RES4 "\n" ; 
	print RES5 "\n" ; 
    }
    elsif ($Ligne =~ /^[0-9]+\t([^\t]+)\t([^\t]+)\t([^\t]+)/)
    {
	$Forme = $1 ;
	$Lemme = $2 ;
	$Categorie = $3 ;
	print RES1 "$Lemme$Separateur$Categorie " ;
	print RES2 "$Forme$Separateur$Categorie " ;
	if (($Categorie=~/PCTFORTE/) || ($Categorie=~/PCTFAIB/)) {
	    print RES3 "$Categorie $Forme " ;
	}
	else {
	    print RES3 "$Categorie " ;
	}
	print RES4 "$Forme " ;
	print RES5 "$Lemme " ;
    }
}

close RES1;
close RES2;
close RES3;
close RES4;
close RES5;
close TMPFILE;

if (!open(RESFULL,(">".$winMain::start_dir."cordial/cordial2lexico.txt"))) {
    &mkPrintErreur("ERREUR : Impossible d\'ouvrir le fichier cordial2lexico.txt\n");
    return;
}
if (!open(RES5,($winMain::start_dir."cordial/cordialCateg.txt"))) {
    &mkPrintErreur("ERREUR : Impossible d\'ouvrir le fichier cordialCateg.txt\n");
    return;
}
while(<RES5>){
    print RESFULL $_;
}
close (RES5);
if (!open(RES5,($winMain::start_dir."cordial/cordialForme.txt"))) {
    &mkPrintErreur("ERREUR : Impossible d\'ouvrir le fichier cordialForme.txt\n");
    return;
    }
while(<RES5>){
    print RESFULL $_;
}
close (RES5);
if (!open(RES5,($winMain::start_dir."cordial/cordialLemme.txt"))) {
    &mkPrintErreur("ERREUR : Impossible d\'ouvrir le fichier cordialLemme.txt\n");
    return;
}
while(<RES5>){
    print RESFULL $_;
}
close (RES5);
close (RESFULL);


my $tmpfile=$winMain::start_dir."cordial/cordialLemCat.txt";
my $msg=$winMain::start_dir."cordial/cordialLemCat.txt";
&IncludedFileInWindow($tmpfile,$msg);

my $tmpfile=$winMain::start_dir."cordial/cordialFormCat.txt";
my $msg=$winMain::start_dir."cordial/cordialFormCat.txt";
&IncludedFileInWindow($tmpfile,$msg);

my $tmpfile=$winMain::start_dir."cordial/cordialCateg.txt";
my $msg=$winMain::start_dir."cordial/cordialCateg.txt";
&IncludedFileInWindow($tmpfile,$msg);

my $tmpfile=$winMain::start_dir."cordial/cordialForme.txt";
my $msg=$winMain::start_dir."cordial/cordialForme.txt";
&IncludedFileInWindow($tmpfile,$msg);

my $tmpfile=$winMain::start_dir."cordial/cordialLemme.txt";
my $msg=$winMain::start_dir."cordial/cordialLemme.txt";
&IncludedFileInWindow($tmpfile,$msg);

my $tmpfile=$winMain::start_dir."cordial/cordial2lexico.txt";
my $msg=$winMain::start_dir."cordial/cordial2lexico.txt";
&IncludedFileInWindow($tmpfile,$msg);


&mkPrintMsgInfo("Gnration des sorties Cordial->Lexico termine, Fichiers contenus dans ". $winMain::start_dir."cordial/ : \ncordialCateg.txt, cordialForme.txt, cordialLemme.txt, cordialFormCat.txt, cordialLemCat.txt, cordial2lexico.txt.\n");

}


#---------------------------------------------
sub cordial2Lexico2 {
&UpdateIndicators2;


my $Forme      = "" ;
my $Lemme      = "" ;
my $Categorie  = "" ;
my $Separateur = "_" ;

    if (!open(RES1,(">".$winMain::start_dir."cordial/cordialLemCat.txt"))) {
	&mkPrintErreur("ERREUR : Impossible d\'ouvrir le fichier cordialLemCat.txt\n");
	return;
    }
    if (!open(RES2,(">".$winMain::start_dir."cordial/cordialFormCat.txt"))) {
	&mkPrintErreur("ERREUR : Impossible d\'ouvrir le fichier cordialFormCat.txt\n");
	return;
    }
    if (!open(RES3,(">".$winMain::start_dir."cordial/cordialCateg.txt"))) {
	&mkPrintErreur("ERREUR : Impossible d\'ouvrir le fichier cordialCateg.txt\n");
	return;
    }
    if (!open(RES4,(">".$winMain::start_dir."cordial/cordialForme.txt"))) {
	&mkPrintErreur("ERREUR : Impossible d\'ouvrir le fichier cordialForme.txt\n");
	return;
    }
    if (!open(RES5,(">".$winMain::start_dir."cordial/cordialLemme.txt"))) {
	&mkPrintErreur("ERREUR : Impossible d\'ouvrir le fichier cordialLemme.txt\n");
	return;
    }
    if (!open(TMPFILE,$winMain::nom_fic)) {
	&mkPrintErreur("ERREUR : Impossible d\'ouvrir le fichier $winMain::nom_fic\n");
	return;
    }


while ($Ligne = <TMPFILE>){
    $Ligne =~ s/\r//g;
    if ($Ligne =~ /DEBUT DE PHRASE/ 
	||
	$Ligne =~ /N\tmot\tmot\tlemme\tCodegram/
	||
	$Ligne =~ /^[0-9]+[\t ]+[0-9]+.*Ncm.\r/
	||
	$Ligne =~ /Mc\.\./
	||
	$Ligne =~ /^[0-9]+[\t ]+\r/)
	# Ce sont des lignes qu'on limine
    { 
    }
    elsif ($Ligne =~ /^[0-9]+\t.*</) {
	my $baliseAgarder="<";
	$Ligne=<TMPFILE>;
	until ($Ligne=~/>/){
	    $Ligne =~ /^[0-9]+\t([^\t]+)/;
	    my $tmp=$1;
	    chomp($tmp);
	    $baliseAgarder.=$tmp;
	    $Ligne=<TMPFILE>;
#	    break if $Ligne == EOF;
	}
	$baliseAgarder.=">";
	if ($baliseAgarder!~/<[^=]+=[^=>]+>/) {
	    if ($baliseAgarder=~/<[^=-]+-[^-=>]+>/) {
		$baliseAgarder=~s/(<[^=-]+)-([^-=>]+>)/$1=$2/;
	    }
	}
	print RES1 "$baliseAgarder" ;
	print RES2 "$baliseAgarder" ;
	print RES3 "$baliseAgarder" ;
	print RES4 "$baliseAgarder" ;
	print RES5 "$baliseAgarder" ;
	if ($Ligne=~/></) { &recurseFichierCordial}
	next;
    }
    elsif ($Ligne =~ /FIN DE PHRASE/)
    {
	print RES1 "\n" ; 
	print RES2 "\n" ; 
	print RES3 "\n" ; 
	print RES4 "\n" ; 
	print RES5 "\n" ; 
    }
    elsif ($Ligne =~ /^[0-9]+\t([^\t]+)\t([^\t]+)\t([^\t]+)/)
    {
	$Forme = $1 ;
	$Lemme = $2 ;
	$Categorie = $3 ;
	print RES1 "$Lemme$Separateur$Categorie " ;
	print RES2 "$Forme$Separateur$Categorie " ;
	if (($Categorie=~/PCTFORTE/) || ($Categorie=~/PCTFAIB/)) {
	    print RES3 "~1$Categorie $Forme " ;
	}
	else {
	    print RES3 "~1$Categorie " ;
	}
	print RES4 "$Forme " ;
	if (($Categorie=~/PCTFORTE/) || ($Categorie=~/PCTFAIB/)) {
	    print RES5 "$Lemme " ;
	}
	else {
	    print RES5 "~2$Lemme " ;
	}
    }
}

close RES1;
close RES2;
close RES3;
close RES4;
close RES5;
close TMPFILE;

if (!open(RESFULL,(">".$winMain::start_dir."cordial/cordial2lexico.txt"))) {
    &mkPrintErreur("ERREUR : Impossible d\'ouvrir le fichier cordial2lexico.txt\n");
    return;
}
if (!open(RES5,($winMain::start_dir."cordial/cordialCateg.txt"))) {
    &mkPrintErreur("ERREUR : Impossible d\'ouvrir le fichier cordialCateg.txt\n");
    return;
}
while(<RES5>){
    print RESFULL $_;
}
close (RES5);
if (!open(RES5,($winMain::start_dir."cordial/cordialForme.txt"))) {
    &mkPrintErreur("ERREUR : Impossible d\'ouvrir le fichier cordialForme.txt\n");
    return;
    }
while(<RES5>){
    print RESFULL $_;
}
close (RES5);
if (!open(RES5,($winMain::start_dir."cordial/cordialLemme.txt"))) {
    &mkPrintErreur("ERREUR : Impossible d\'ouvrir le fichier cordialLemme.txt\n");
    return;
}
while(<RES5>){
    print RESFULL $_;
}
close (RES5);
close (RESFULL);


my $tmpfile=$winMain::start_dir."cordial/cordialLemCat.txt";
my $msg=$winMain::start_dir."cordial/cordialLemCat.txt";
&IncludedFileInWindow($tmpfile,$msg);

my $tmpfile=$winMain::start_dir."cordial/cordialFormCat.txt";
my $msg=$winMain::start_dir."cordial/cordialFormCat.txt";
&IncludedFileInWindow($tmpfile,$msg);

my $tmpfile=$winMain::start_dir."cordial/cordialCateg.txt";
my $msg=$winMain::start_dir."cordial/cordialCateg.txt";
&IncludedFileInWindow($tmpfile,$msg);

my $tmpfile=$winMain::start_dir."cordial/cordialForme.txt";
my $msg=$winMain::start_dir."cordial/cordialForme.txt";
&IncludedFileInWindow($tmpfile,$msg);

my $tmpfile=$winMain::start_dir."cordial/cordialLemme.txt";
my $msg=$winMain::start_dir."cordial/cordialLemme.txt";
&IncludedFileInWindow($tmpfile,$msg);

my $tmpfile=$winMain::start_dir."cordial/cordial2lexico.txt";
my $msg=$winMain::start_dir."cordial/cordial2lexico.txt";
&IncludedFileInWindow($tmpfile,$msg);


&mkPrintMsgInfo("Gnration des sorties Cordial->Lexico termine, Fichiers contenus dans ". $winMain::start_dir."cordial/ : \ncordialCateg.txt, cordialForme.txt, cordialLemme.txt, cordialFormCat.txt, cordialLemCat.txt, cordial2lexico.txt.\n");

#---------------------------------------------------------------------------------------
sub recurseFichierCordial {
&UpdateIndicators2;
	my $baliseAgarder="<";
	$Ligne=<TMPFILE>;
	until ($Ligne=~/>/){
	    $Ligne =~ /^[0-9]+\t([^\t]+)/;
	    my $tmp=$1;
	    chomp($tmp);
	    $baliseAgarder.=$tmp;
	    $Ligne=<TMPFILE>;
#	    break if $Ligne == EOF;
	}
	$baliseAgarder.=">";
	if ($baliseAgarder!~/<[^=]+=[^=>]+>/) {
	    if ($baliseAgarder=~/<[^=-]+-[^-=>]+>/) {
		$baliseAgarder=~s/(<[^=-]+)-([^-=>]+>)/$1=$2/;
	    }
	}
	print RES1 "$baliseAgarder" ;
	print RES2 "$baliseAgarder" ;
	print RES3 "$baliseAgarder" ;
	print RES4 "$baliseAgarder" ;
	print RES5 "$baliseAgarder" ;
	if ($Ligne=~/></) { &recuseFichierCordial}
    }

}

#---------------------------------------------------------------------------------------
sub help_cordial2xml {
&UpdateIndicators2;


    if (! Exists ($pn1)) {
	$pn1 = $winMain::mw ->Toplevel();
	$pn1->title("HELP");
	my $label = $pn1->Label( -background => 'black',
				  -foreground =>  'white', -anchor => 'w' );
	my $texte2 = $pn1->Scrolled("MarkupTools")->pack(-side => 'bottom',
				      -fill => 'both',
				      -expand => 1);

	$texte2->Text(-setgrid => 'true');
	&updateMarkupWindow($texte2,$label);
	my $tmpfile="Doc/help_cordial2xml.txt";
	$texte2->IncludeFile($tmpfile);

	$pn1->Button(-text => "Close",
		     -command =>  sub {$pn1->destroy()})->pack(-side => 'top', -pady => 5, -padx => 10);

	my $w_save=$pn1->Button(-text => "Save",
		     -image => $imageSave,
		     -command => sub {$texte2->FileSaveAsPopup()})->pack(-side => 'top', -pady => 5, -padx => 10);
	$winMain::winBalloon->attach($w_save,
			    -balloonmsg => "Save"
			    );

    }
    else {
	$pn1->deiconify();
	$pn1->raise();
    }


}

#---------------------------------------------------------------------------------------
sub cordial2xml {
&UpdateIndicators2;


my $Forme      = "" ;
my $Lemme      = "" ;
my $Categorie  = "" ;
my $Separateur = "_" ;

    if (!open(RES1,(">".$winMain::start_dir."cordial/cordial2xml.xml"))) {
	&mkPrintErreur("ERREUR : Impossible d\'ouvrir le fichier cordial2xml.xml\n");
	return;
    }
    if (!open(TMPFILE,$winMain::nom_fic)) {
	&mkPrintErreur("ERREUR : Impossible d\'ouvrir le fichier $winMain::nom_fic\n");
	return;
    }

print RES1 "<?xml version=\"1.0\" encoding=\"ISO-8859-1\"?>\n" ;
print RES1 "<cordial2xml>\n" ;

while ($Ligne = <TMPFILE>){
   $Ligne =~ s/\r//g;
    if ($Ligne =~ /DEBUT DE PHRASE/ 
	||
	$Ligne =~ /N\tmot\tmot\tlemme\tCodegram/
	||
	$Ligne =~ /^[0-9]+[\t ]+[0-9]+.*Ncm.\r/
	||
	$Ligne =~ /Mc\.\./
	||
	$Ligne =~ /^[0-9]+[\t ]+\r/)
	
    { 
	# Ce sont des lignes qu'on limine

    }
  elsif ($Ligne =~ /^[0-9]+\t.*<(\/)*/) {
      my $baliseAgarder="<$1";
    nextBalise:
      $Ligne=<TMPFILE>;
      until (($Ligne=~/>[^<]/) || ($Ligne=~/\/>[^<]/)  || ($Ligne=~/\">[^<]/) || ($Ligne=~/\"\/>[^<]/) || ($Ligne=~/></)  ){
	  $Ligne =~ /^[0-9]+\t([^\t]+)/;
	  my $tmp=$1;
	  chomp($tmp);
	  $baliseAgarder.=$tmp;
	  if ($tmp!~/=\"/) {$baliseAgarder.=" "};
	  $Ligne=<TMPFILE>;
#	    break if $Ligne == EOF;
      }

      if ($Ligne!~/></) {
	  if ($Ligne=~/[^\"]\/>/) {
	      $baliseAgarder.="/>";
	  }
	  if ($Ligne=~/[^\/\"]>/) {
	      $baliseAgarder.=">";
	  }
	  if ($Ligne=~/[^\/]\">/) {
	      $baliseAgarder.="\">";
	  }
	  if ($Ligne=~/\"\/>/) {
	      $baliseAgarder.="\"\/>";
	    }
	  $baliseAgarder=~s/(<[^>]+) ([\"\/]*>)/$1$2/;
	  $baliseAgarder=~s/([^=]+) =([^=]+)/$1=$2/g;
	  print RES1 "$baliseAgarder" ;
      }
      else {
	  if ($Ligne=~/([\/\"]*)></) {
	      $baliseAgarder.="$1>";
	  }
	  $baliseAgarder=~s/(<[^>]+) ([\"\/]*>)/$1$2/;
	  $baliseAgarder=~s/([^=]+) =([^=]+)/$1=$2/g;
	  print RES1 "$baliseAgarder" ;
	  $Ligne=~/><([\/\"]*)/;
	  $baliseAgarder="<$1";
	  goto nextBalise;
      }
      next;
  }
   elsif ($Ligne =~ /^[0-9]+\t.*<\//) {
       my $baliseAgarder="</";
	$Ligne=<TMPFILE>;
       until ($Ligne=~/>/){
	   $Ligne =~ /^[0-9]+\t([^\t]+)/;
	   my $tmp=$1;
	   chomp($tmp);
	   $baliseAgarder.=$tmp;
	   $Ligne=<TMPFILE>;
#	    break if $Ligne == EOF;
       }
       $baliseAgarder.=">";
       print RES1 "$baliseAgarder" ;
       next;
   }
   elsif ($Ligne =~ /^[0-9]+\t.*<\?/) {
	my $baliseAgarder="<?";
	$Ligne=<TMPFILE>;
	until ($Ligne=~/>/){
	    $Ligne =~ /^[0-9]+\t([^\t]+)/;
	    my $tmp=$1;
	    chomp($tmp);
	    $baliseAgarder.=$tmp;
	    $Ligne=<TMPFILE>;
#	    break if $Ligne == EOF;
	}
	$baliseAgarder.=">";
	print RES1 "$baliseAgarder" ;
	next;
    }
    elsif ($Ligne =~ /^[0-9]+\t.*<\!/) {
	my $baliseAgarder="<!";
	$Ligne=<TMPFILE>;
	until ($Ligne=~/>/){
	    $Ligne =~ /^[0-9]+\t([^\t]+)/;
	    my $tmp=$1;
	    chomp($tmp);
	    $baliseAgarder.=$tmp;
	    $Ligne=<TMPFILE>;
#	    break if $Ligne == EOF;
	}
	$baliseAgarder.=">";
	print RES1 "$baliseAgarder" ;
	next;
    }

    elsif ($Ligne =~ /FIN DE PHRASE/)
    {
	print RES1 "\n" ; 
    }
    elsif ($Ligne =~ /^[0-9]+\t([^\t]+)\t([^\t]+)\t([^\t]+)/)
    {
	$Forme = $1 ;
	$Lemme = $2 ;
	$Categorie = $3 ;
	print RES1 "<w><forme>$Forme</forme><lemme>$Lemme</lemme><categorie>$Categorie</categorie></w>" ;
    }
}


print RES1 "\n</cordial2xml>\n" ;

close RES1;
close TMPFILE;

my $cordialFile=$winMain::start_dir."cordial/cordial2xml.xml";

&loadSplashWindow;
my $parser = new XML::Parser(Style => 'Debug');
eval { $parser->parsefile($cordialFile)};
if ($@) {
    &mkPrintErreur("XML-ERROR sur $cordialFile => Caught Error : $@\n");
    &removeSplashWindow;
    return;
}
else {
    &removeSplashWindow;
    &mkPrintMsgInfo("XML-Parsing OK sur $cordialFile\n");
}


my $tmpfile=$winMain::start_dir."cordial/cordial2xml.xml";
my $msg=$winMain::start_dir."cordial/cordial2xml.xml";
&IncludedFileInWindow($tmpfile,$msg);

&mkPrintMsgInfo("Gnration des sorties Cordial->XML termine, Fichiers contenus dans ". $winMain::start_dir."cordial/ : \ncordial2xml.xml\n");

}


#----------------------------- MODULE TYPWEB ----------------------------------

sub decanteur {
&UpdateIndicators2;

}


#---------------------------------------------------------------------------------------
sub makeXMLCorpusTypweb {
&UpdateIndicators2;

    if (! Exists ($pn1)) {
	$pn1 = $winMain::mw ->Toplevel();
	$pn1->title("HELP");
	my $label = $pn1->Label( -background => 'black',
				  -foreground =>  'white', -anchor => 'w' );
	my $texte2 = $pn1->Scrolled("MarkupTools")->pack(-side => 'bottom',
				      -fill => 'both',
				      -expand => 1);

	$texte2->Text(-setgrid => 'true');
	&updateMarkupWindow($texte2,$label);
	my $tmpfile="Doc/makeCorpusTypweb.txt";
	$texte2->IncludeFile($tmpfile);

	$pn1->Button(-text => "Close",
		     -command =>  sub {$pn1->destroy()})->pack(-side => 'top', -pady => 5, -padx => 10);

	my $w_save=$pn1->Button(-text => "Save",
		     -image => $winMain::imageSave,
		     -command => sub {$texte2->FileSaveAsPopup()})->pack(-side => 'top', -pady => 5, -padx => 10);
	$winMain::winBalloon->attach($w_save,
			    -balloonmsg => "Save"
			    );

    }
    else {
	$pn1->deiconify();
	$pn1->raise();
    }

}

#---------------------------------------------------------------------------------------
sub query_dir_makeXMLCorpusTypweb {
&UpdateIndicators2;

 &mkIndisponible();
}

#---------------------------------------------------------------------------------------
sub load_makeXMLCorpusTypweb {
&UpdateIndicators2;
 &mkIndisponible();
}

#---------------------------------------------------------------------------------------
sub makeMatrice {
&UpdateIndicators2;
    &query_dir_makeMatrice;
}

#---------------------------------------------------------------------------------------
sub query_dir_makeMatrice {
&UpdateIndicators2;
    if (! Exists ($pn8)) {
	$pn8 = $winMain::mw ->Toplevel();
	$pn8->title("Query Dir (make matrice)");
	$pn8->minsize(qw(800 150)); 
	my $frame0 = $pn8->Frame(-background=>'#edf0f3')->pack(-side=>'top',  -fill => 'both',  -expand => 1); 
	my $cadre1 = $frame0->Frame->pack(-side => 'top',  -fill => 'both',  -expand => 1);
	my $cadre2 = $frame0->Frame->pack(-side => 'top',  -fill => 'both',  -expand => 1);
	my $cadre3 = $frame0->Frame->pack(-side => 'top',  -fill => 'both',  -expand => 1);
	my $cadre4 = $frame0->Frame->pack(-side => 'top',  -fill => 'both',  -expand => 1);
	$cadre1->Label(-text => "Where is makeMatrice : (./Typweb/ToolsLynx/) ",
    	      -relief => 'raised')->pack(-side => 'left',
					 -anchor => 'w',
					 -expand => 1);
	my $webxrefdir=&GetCWD;
	my $saisie_0=$cadre1->Entry(-textvariable => \$webxrefdir)->pack(-side => 'left',
						-anchor => 'w',
						-fill => 'x',
						-expand => 1
						);
	$cadre2->Label(-text => "Dir Input : ",
    	      -relief => 'raised')->pack(-side => 'left',
						  -anchor => 'w');
	my $workdirin=&GetCWD;
	my $saisie_1=$cadre2->Entry(-textvariable => \$workdirin)->pack(-side => 'left',
						-anchor => 'w',
						-fill => 'both',
						-expand => 1
						);
	$cadre3->Label(-text => "File Output :  ",
    	      -relief => 'raised')->pack(-side => 'left',
						  -anchor => 'w');

	my $workdirout=&GetCWD;
	my $saisie_2=$cadre3->Entry(-textvariable => \$workdirout)->pack(-side => 'left',
						-anchor => 'w',
						-fill => 'both',
						-expand => 1
						);
	$cadre4->Button(-text => "Load LanceSurRepertoireDeSitesHTML2StatWordByFilePourMots",
	       -command => sub {$pn8->destroy();
				&loadmakeMatriceLinks($webxrefdir,$workdirin,$workdirout);
			    })->pack(-side => 'right',
				     -anchor => 'e');
	$pn8->Button(-text => "Close",
		     -command =>  sub {$pn8->destroy()})->pack;
    }
    else {
	$pn8->deiconify();
	$pn8->raise();
    }
}

#---------------------------------------------------------------------------------------
sub loadmakeMatrice {
&UpdateIndicators2;

    my ($dir0,$dir1,$dir2)=@_;
    $file1=$dir0;
    $file2=$dir1;
    $file3=$dir2;

    if (defined $file1 and $file1 ne '' 
	and defined $file2 and $file2 ne '' 
	and defined $file3 and $file3 ne ''
	) {
	print "perl $dir0"."LanceSurRepertoireDeSitesHTML2StatWordByFilePourMots.pl $dir1 $dir2\n";
	eval { system("perl $dir0"."LanceSurRepertoireDeSitesHTML2StatWordByFilePourMots.pl $dir1 $dir2\n")};
	if ($@) {
	    &mkPrintErreur("Caught Error : $@\n");
	    return;
	}

	&mkPrintMsgInfo("Gnration termine\n");

    }
    else {
	&mkPrintErreur("Problme au lancement de makeMatrice : vrifier prsence programme, input, output\n");
    }
}

#---------------------------------------------------------------------------------------
sub makeMatrice2 {
&UpdateIndicators2;
    &query_dir_makeMatrice2;
}

#---------------------------------------------------------------------------------------
sub query_dir_makeMatrice2 {
&UpdateIndicators2;
    if (! Exists ($pn8)) {
	$pn8 = $winMain::mw ->Toplevel();
	$pn8->title("Query Dir (make matrice 2)");
	$pn8->minsize(qw(800 150)); 
	my $frame0 = $pn8->Frame(-background=>'#edf0f3')->pack(-side=>'top',  -fill => 'both',  -expand => 1); 
	my $cadre1 = $frame0->Frame->pack(-side => 'top',  -fill => 'both',  -expand => 1);
	my $cadre2 = $frame0->Frame->pack(-side => 'top',  -fill => 'both',  -expand => 1);
	my $cadre3 = $frame0->Frame->pack(-side => 'top',  -fill => 'both',  -expand => 1);
	my $cadre4 = $frame0->Frame->pack(-side => 'top',  -fill => 'both',  -expand => 1);

	$cadre1->Label(-text => "Where is makeMatrice : (./Typweb/ToolsLynx/) ",
    	      -relief => 'raised')->pack(-side => 'left',
						  -anchor => 'w');
	my $webxrefdir=&GetCWD;
	my $saisie_0=$cadre1->Entry(-textvariable => \$webxrefdir)->pack(-side => 'left',
						-anchor => 'w',
						-fill => 'x',
						-expand => 1,
						);
	$cadre2->Label(-text => "Dir Input : ",
    	      -relief => 'raised')->pack(-side => 'left',
						  -anchor => 'w');
	my $workdirin=&GetCWD;
	my $saisie_1=$cadre2->Entry(-textvariable => \$workdirin)->pack(-side => 'left',
						-anchor => 'w',
						-fill => 'x',
						-expand => 1,
						);
	$cadre3->Label(-text => "File Output :  ",
    	      -relief => 'raised')->pack(-side => 'left',
						  -anchor => 'w');

	my $workdirout=&GetCWD;
	my $saisie_2=$cadre3->Entry(-textvariable => \$workdirout)->pack(-side => 'left',
						-anchor => 'w',
						-fill => 'x',
						-expand => 1,
						);
	$cadre4->Button(-text => "Load LanceSurRepertoireDeSitesHTML2TexteNu ",
	       -command => sub {$pn8->destroy();
				&loadmakeMatriceLinks($webxrefdir,$workdirin,$workdirout);
			    })->pack(-side => 'right',
						   -anchor => 'e');
	$pn8->Button(-text => "Close",
		     -command =>  sub {$pn8->destroy()})->pack;
    }
    else {
	$pn8->deiconify();
	$pn8->raise();
    }
}

#---------------------------------------------------------------------------------------
sub loadmakeMatrice2 {
&UpdateIndicators2;
    my ($dir0,$dir1,$dir2)=@_;
    $file1=$dir0;
    $file2=$dir1;
    $file3=$dir2;

    if (defined $file1 and $file1 ne '' 
	and defined $file2 and $file2 ne '' 
	and defined $file3 and $file3 ne ''
	) {
	print "perl $dir0"."LanceSurRepertoireDeSitesHTML2TexteNu.pl $dir1 $dir2\n";
	eval { system("perl $dir0"."LanceSurRepertoireDeSitesHTML2TexteNu.pl $dir1 $dir2\n")};
	if ($@) {
	    &mkPrintErreur("Caught Error : $@\n");
	    return;
	}

	&mkPrintMsgInfo("Gnration termine\n");

    }
    else {
	&mkPrintErreur("Problme au lancement de makeMatrice : vrifier prsence programme, input, output\n");
    }
}

#---------------------------------------------------------------------------------------
sub makeMatriceLinks {
&UpdateIndicators2;
&query_dir_makeMatriceLinks;
}

#---------------------------------------------------------------------------------------
sub query_dir_makeMatriceLinks {
&UpdateIndicators2;
    if (! Exists ($pn8)) {
	$pn8 = $winMain::mw ->Toplevel();
	$pn8->title("Query Dir (make matrice links)");
	$pn8->minsize(qw(800 200)); 
	my $frame0 = $pn8->Frame(-background=>'#edf0f3')->pack(-side=>'top',  -fill => 'both',  -expand => 1); 
	my $cadre1 = $frame0->Frame->pack(-side => 'top',  -fill => 'both',  -expand => 1);
	my $cadre2 = $frame0->Frame->pack(-side => 'top',  -fill => 'both',  -expand => 1);
	my $cadre5 = $frame0->Frame->pack(-side => 'top',  -fill => 'both',  -expand => 1);
	my $cadre3 = $frame0->Frame->pack(-side => 'top',  -fill => 'both',  -expand => 1);
	my $cadre4 = $frame0->Frame->pack(-side => 'top',  -fill => 'both',  -expand => 1);

	$cadre1->Label(-text => "Where is makeMatriceLinks : ",
    	      -relief => 'raised')->pack(-side => 'left',
						  -anchor => 'w');
	my $webxrefdir=&GetCWD;
	my $saisie_0=$cadre1->Entry(-textvariable => \$webxrefdir)->pack(-side => 'left',
						-anchor => 'w',
						-fill => 'x',
						-expand => 1,
						);
	$cadre2->Label(-text => "Dir Input : ",
    	      -relief => 'raised')->pack(-side => 'left',
						  -anchor => 'w');
	my $workdirin=&GetCWD;
	my $saisie_1=$cadre2->Entry(-textvariable => \$workdirin)->pack(-side => 'left',
						-anchor => 'w',
						-fill => 'x',
						-expand => 1,
						);
	$cadre5->Label(-text => "CorpusXML Name : ",
    	      -relief => 'raised')->pack(-side => 'left',
						  -anchor => 'w');
	my $sitename="GiveSiteName (.xml)";
	my $saisie_3=$cadre5->Entry(-textvariable => \$sitename)->pack(-side => 'left',
						-anchor => 'w',
						-fill => 'x',
						-expand => 1,
						);
	$cadre3->Label(-text => "Dir Output :  ",
    	      -relief => 'raised')->pack(-side => 'left',
						  -anchor => 'w');

	my $workdirout=&GetCWD;
	my $saisie_2=$cadre3->Entry(-textvariable => \$workdirout)->pack(-side => 'left',
						-anchor => 'w',
						-fill => 'x',
						-expand => 1,
						);
	$cadre4->Button(-text => "Load makeMatriceLinks",
	       -command => sub {$pn8->destroy();
				&loadmakeMatriceLinks($webxrefdir,$workdirin,$sitename,$workdirout);
			    })->pack(-side => 'right',
				     -anchor => 'e');
	$pn8->Button(-text => "Close",
		     -command =>  sub {$pn8->destroy()})->pack;
    }
    else {
	$pn8->deiconify();
	$pn8->raise();
    }
}

#---------------------------------------------------------------------------------------
sub loadmakeMatriceLinks {
&UpdateIndicators2;
    my ($dir0,$dir1,$CORPUSNAME,$dir2)=@_;
    
    $file1=$dir0;
    $file2=$dir1;
    $file3=$dir2;
    $file4=$CORPUSNAME;

    if (defined $file1 and $file1 ne '' 
	and defined $file2 and $file2 ne '' 
#	and defined $file3 and $file3 ne ''
	and defined $file4 and $file4 ne ''
	) {
	print "perl $dir0"."makeMatriceLinks-038-pajek.pl -at $dir2 $dir1"."$CORPUSNAME \n";
	eval { system("perl $dir0"."makeMatriceLinks-038-pajek.pl  -at $dir2 $dir1"."$CORPUSNAME")};
	if ($@) {
	    &mkPrintErreur("Caught Error : $@\n");
	    return;
	}
	
	my $msg=$dir2."StatLinks.txt";
	my $file=$dir2."StatLinks.txt";
	&IncludedFileInWindow($file,$msg);
	my $msg=$dir2."MatriceLinks.txt";
	my $file=$dir2."MatriceLinks.txt";
	&IncludedFileInWindow($file,$msg);
	my $msg=$dir2."MatriceLinksPajek.net";
	my $file=$dir2."MatriceLinksPajek.net";
	&IncludedFileInWindow($file,$msg);
	my $msg=$dir2."MatriceLinksValue.txt";
	my $file=$dir2."MatriceLinksValue.txt";
	&IncludedFileInWindow($file,$msg);
	my $msg=$dir2."MatriceLinksPajek-accueil.net";
	my $file=$dir2."MatriceLinksPajek-accueil.net";
	&IncludedFileInWindow($file,$msg);


	&mkPrintMsgInfo("Gnration termine\n");

    }
    else {
	&mkPrintErreur("Problme au lancement de makeMatriceLinks : vrifier prsence programme, input, output\n");
    }

}

#---------------------------------------------------------------------------------------
sub makeCorpusTAG {
&UpdateIndicators2;
&query_dir_makeCorpusTAG;
}

#---------------------------------------------------------------------------------------
sub query_dir_makeCorpusTAG {
&UpdateIndicators2;
    if (! Exists ($pn8)) {
	$pn8 = $winMain::mw ->Toplevel();
	$pn8->title("Query Dir (makeCorpusTag)");
	$pn8->minsize(qw(800 250)); 
	my $frame0 = $pn8->Frame(-background=>'#edf0f3')->pack(-side=>'top',  -fill => 'both',  -expand => 1); 
	my $cadre1 = $frame0->Frame->pack(-side => 'top',  -fill => 'both',  -expand => 1);
	my $cadre2 = $frame0->Frame->pack(-side => 'top',  -fill => 'both',  -expand => 1);
	my $cadre5 = $frame0->Frame->pack(-side => 'top',  -fill => 'both',  -expand => 1);
	my $cadre3 = $frame0->Frame->pack(-side => 'top',  -fill => 'both',  -expand => 1);
	my $cadre4 = $frame0->Frame->pack(-side => 'top',  -fill => 'both',  -expand => 1);
	my $cadre6 = $frame0->Frame->pack(-side => 'top',  -fill => 'both',  -expand => 1);

	$cadre1->Label(-text => "Where is makeCorpusTag (default is .) : ",
    	      -relief => 'raised')->pack(-side => 'left',
						  -anchor => 'w');
	my $webxrefdir=&GetCWD;
	my $saisie_0=$cadre1->Entry(-textvariable => \$webxrefdir)->pack(-side => 'left',
						-anchor => 'w',
						-fill => 'x',
						-expand => 1,
						);
	$cadre2->Label(-text => "Dir Input : ",
    	      -relief => 'raised')->pack(-side => 'left',
						  -anchor => 'w');
	my $workdirin=&GetCWD;
	my $saisie_1=$cadre2->Entry(-textvariable => \$workdirin)->pack(-side => 'left',
						-anchor => 'w',
						-fill => 'x',
						-expand => 1,
						);
	$cadre5->Label(-text => "CorpusXMLName : ",
    	      -relief => 'raised')->pack(-side => 'left',
						  -anchor => 'w');
	my $sitename="GiveCorpusName (.xml)";
	my $saisie_3=$cadre5->Entry(-textvariable => \$sitename)->pack(-side => 'left',
						-anchor => 'w',
						-fill => 'x',
						-expand => 1,
						);
	$cadre3->Label(-text => "Selected Markup FileName : ",
    	      -relief => 'raised')->pack(-side => 'left',
						  -anchor => 'w');

	my $xmlfilename="GiveFileName (.txt)";
	my $saisie_2=$cadre3->Entry(-textvariable => \$xmlfilename)->pack(-side => 'left',
						-anchor => 'w',
						-fill => 'x',
						-expand => 1,
						);
	$cadre4->Label(-text => "Dir Output :  ",
    	      -relief => 'raised')->pack(-side => 'left',
						  -anchor => 'w');

	my $workdirout=&GetCWD;
	my $saisie_6=$cadre4->Entry(-textvariable => \$workdirout)->pack(-side => 'left',
						-anchor => 'w',
						-fill => 'x',
						-expand => 1,
						);
	$cadre6->Button(-text => "Load makeCorpusTag",
	       -command => sub {$pn8->destroy();
				&loadmakeCorpusTAG($webxrefdir,$workdirin,$sitename,$workdirout,$xmlfilename);
			    })->pack(-side => 'right',
				     -anchor => 'e');
	$pn8->Button(-text => "Close",
		     -command =>  sub {$pn8->destroy()})->pack;
    }
    else {
	$pn8->deiconify();
	$pn8->raise();
    }
}

#---------------------------------------------------------------------------------------
sub loadmakeCorpusTAG {
&UpdateIndicators2;
    my ($dir0,$dir1,$CORPUSNAME,$out,$dir2)=@_;
    
    my $file1=$dir0;
    my $file2=$dir1;
    my $file3=$dir2;
    my $file4=$CORPUSNAME;
    my $file5=$out;

    if (defined $file1 and $file1 ne '' 
	and defined $file2 and $file2 ne '' 
	and defined $file3 and $file3 ne ''
	and defined $file4 and $file4 ne ''
	and defined $file5 and $file5 ne ''
	) {
	print "perl $dir0"."makeCorpusSelectedTagForLexico3.pl -at $out  $dir1"."$CORPUSNAME $dir2 \n";
	eval { system("perl $dir0"."makeCorpusSelectedTagForLexico3.pl -at $out $dir1"."$CORPUSNAME $dir2")};
	if ($@) {
	    &mkPrintErreur("Caught Error : $@\n");
	    return;
	}
	

	my $msg=$out."SELECTEDTAG.txt";
	my $file=$out."SELECTEDTAG.txt";
	&IncludedFileInWindow($file,$msg);
	my $msg=$out."SELECTEDTAGCONV.txt";
	my $file=$out."SELECTEDTAGCONV.txt";
	&IncludedFileInWindow($file,$msg);
	my $msg=$out."SELECTEDTAGFRQ.txt";
	my $file=$out."SELECTEDTAGFRQ.txt";
	&IncludedFileInWindow($file,$msg);
	my $msg=$out."LIST-CONVTAG.txt";
	my $file=$out."LIST-CONVTAG.txt";
	&IncludedFileInWindow($file,$msg);
	&mkPrintMsgInfo("Gnration termine\n");

    }
    else {
	&mkPrintErreur("Problme au lancement de makeMatriceLinks : vrifier prsence programme, input, output\n");
    }

}

#---------------------------------------------------------------------------------------
sub helpmakeMatriceLinks {
&UpdateIndicators2;
    if (! Exists ($pn1)) {
	$pn1 = $winMain::mw ->Toplevel();
	$pn1->title("HELP");
	my $label = $pn1->Label( -background => 'black',
				  -foreground =>  'white', -anchor => 'w' );
	my $texte2 = $pn1->Scrolled("MarkupTools")->pack(-side => 'bottom',
				      -fill => 'both',
				      -expand => 1);

	$texte2->Text(-setgrid => 'true');
	&updateMarkupWindow($texte2,$label);
	my $tmpfile="Doc/helpmakeMatriceLinks.txt";
	$texte2->IncludeFile($tmpfile);

	$pn1->Button(-text => "Close",
		     -command =>  sub {$pn1->destroy()})->pack(-side => 'top', -pady => 5, -padx => 10);

	my $w_save=$pn1->Button(-text => "Save",
		     -image => $winMain::imageSave,
		     -command => sub {$texte2->FileSaveAsPopup()})->pack(-side => 'top', -pady => 5, -padx => 10);
	$winMain::winBalloon->attach($w_save,
			    -balloonmsg => "Save"
			    );

    }
    else {
	$pn1->deiconify();
	$pn1->raise();
    }

}
#---------------------------------------------------------------------------------------
sub helpmakeCorpusTAG {
&UpdateIndicators2;
    if (! Exists ($pn1)) {
	$pn1 = $winMain::mw ->Toplevel();
	$pn1->title("HELP");
	my $label = $pn1->Label( -background => 'black',
				  -foreground =>  'white', -anchor => 'w' );
	my $texte2 = $pn1->Scrolled("MarkupTools")->pack(-side => 'bottom',
				      -fill => 'both',
				      -expand => 1);

	$texte2->Text(-setgrid => 'true');
	&updateMarkupWindow($texte2,$label);
	my $tmpfile="Doc/helpmakeCorpusTag.txt";
	$texte2->IncludeFile($tmpfile);

	$pn1->Button(-text => "Close",
		     -command =>  sub {$pn1->destroy()})->pack(-side => 'top', -pady => 5, -padx => 10);

	my $w_save=$pn1->Button(-text => "Save",
		     -image => $winMain::imageSave,
		     -command => sub {$texte2->FileSaveAsPopup()})->pack(-side => 'top', -pady => 5, -padx => 10);
	$winMain::winBalloon->attach($w_save,
			    -balloonmsg => "Save"
			    );

    }
    else {
	$pn1->deiconify();
	$pn1->raise();
    }

}
#---------------------------------------------------------------------------------------
sub helpmakeMatrice {
&UpdateIndicators2;
    if (! Exists ($pn1)) {
	$pn1 = $winMain::mw ->Toplevel();
	$pn1->title("HELP");
	my $label = $pn1->Label( -background => 'black',
				  -foreground =>  'white', -anchor => 'w' );
	my $texte2 = $pn1->Scrolled("MarkupTools")->pack(-side => 'bottom',
				      -fill => 'both',
				      -expand => 1);

	$texte2->Text(-setgrid => 'true');
	&updateMarkupWindow($texte2,$label);
	my $tmpfile="Doc/helpmakeMatrice.txt";
	$texte2->IncludeFile($tmpfile);

	$pn1->Button(-text => "Close",
		     -command =>  sub {$pn1->destroy()})->pack(-side => 'top', -pady => 5, -padx => 10);

	my $w_save=$pn1->Button(-text => "Save",
		     -image => $winMain::imageSave,
		     -command => sub {$texte2->FileSaveAsPopup()})->pack(-side => 'top', -pady => 5, -padx => 10);
	$winMain::winBalloon->attach($w_save,
			    -balloonmsg => "Save"
			    );

    }
    else {
	$pn1->deiconify();
	$pn1->raise();
    }

}

#---------------------------------------------------------------------------------------
sub helpwebxref {
&UpdateIndicators2;
    if (! Exists ($pn1)) {
	$pn1 = $winMain::mw ->Toplevel();
	$pn1->title("HELP");
	my $label = $pn1->Label( -background => 'black',
				  -foreground =>  'white', -anchor => 'w' );
	my $texte2 = $pn1->Scrolled("MarkupTools")->pack(-side => 'bottom',
				      -fill => 'both',
				      -expand => 1);

	$texte2->Text(-setgrid => 'true');
	&updateMarkupWindow($texte2,$label);
	my $tmpfile="Doc/helpWebxref.txt";
	$texte2->IncludeFile($tmpfile);

	$pn1->Button(-text => "Close",
		     -command =>  sub {$pn1->destroy()})->pack(-side => 'top', -pady => 5, -padx => 10);

	my $w_save=$pn1->Button(-text => "Save",
		     -image => $winMain::imageSave,
		     -command => sub {$texte2->FileSaveAsPopup()})->pack(-side => 'top', -pady => 5, -padx => 10);
	$winMain::winBalloon->attach($w_save,
			    -balloonmsg => "Save"
			    );

    }
    else {
	$pn1->deiconify();
	$pn1->raise();
    }
} 
#---------------------------------------------------------------------------------------
sub helptypweb {
&UpdateIndicators2;
    if (! Exists ($pn1)) {
	$pn1 = $winMain::mw ->Toplevel();
	$pn1->title("HELP");
	my $label = $pn1->Label( -background => 'black',
				  -foreground =>  'white', -anchor => 'w' );
	my $texte2 = $pn1->Scrolled("MarkupTools")->pack(-side => 'bottom',
				      -fill => 'both',
				      -expand => 1);

	$texte2->Text(-setgrid => 'true');
	&updateMarkupWindow($texte2,$label);
	my $tmpfile="Doc/helpTypweb.txt";
	$texte2->IncludeFile($tmpfile);

	$pn1->Button(-text => "Close",
		     -command =>  sub {$pn1->destroy()})->pack(-side => 'top', -pady => 5, -padx => 10);

	my $w_save=$pn1->Button(-text => "Save",
		     -image => $winMain::imageSave,
		     -command => sub {$texte2->FileSaveAsPopup()})->pack(-side => 'top', -pady => 5, -padx => 10);
	$winMain::winBalloon->attach($w_save,
			    -balloonmsg => "Save"
			    );

    }
    else {
	$pn1->deiconify();
	$pn1->raise();
    }
}

#---------------------------------------------------------------------------------------
sub loadUploading {
&UpdateIndicators2;

    &mkIndisponible();
    return;

my $debug      = 1;
my $remserver  = undef;
my $remport    = '21';
my $user       = 'anonymous';
my $password   = 'me@foo.bar';
my $dir        = '.';
my $localdir   = './';
my $curxfermode = 'ASCII';

unless (GetOptions("d" => \$debug,
                   "s=s" => \$remserver,
                   "r=s" => \$dir,
                   "p=i" => \$remport,
                   "u=s" => \$user,
                   "w=s" => \$password,
                   "l=s" => \$localdir
                   ))
{
    usageUploading();
}

usageUploading() unless $remserver;

$localdir = './' unless ($localdir);
my $ftp = Net::FTP->new($remserver, 'Port' => $remport);
die "Could not connect to $remserver" unless $ftp;
$ftp->login($user, $password) 
    or die "Couldn't login to $remserver";
$ftp->cwd($dir) 
    or die "Invalid directory ($dir) on FTP Server";
$ftp->ascii()
    or warn "Couldn't change default xfer mode, continuing";

chdir($localdir);
my $currentdir = getcwd();
find(\&sendfile,'.');

$ftp->quit();


}
#---------------------------------------------------------------------------------------
sub sendfile {
&UpdateIndicators2;
    my $file      =  $File::Find::name;
    $file         =~ s#^\./##g;
    my $localfile =  "$currentdir/$file";
    $localfile    =~ s#//#/#g;
    my $remfile   =  $file;

    print "Processing $localfile rem($remfile)\n" if $debug;

    if (-d $localfile)
    {
        my $remcurdir = $ftp->pwd();
        unless($ftp->cwd($remfile))
        {
            unless ($localfile eq '..')
            {
                print "Attempting to make directory $remfile\n";
                $ftp->mkdir($remfile,1) or 
                    die "Couldn't make directory $remfile";
            }
        }
        else
        {
            $ftp->cwd($remcurdir) or
                die "Couldn't change to directory $currentdir";
        }
    }
    else
    {
        my ($remtime,$localtime,$upload) = (undef,undef,0);
        unless($remtime = $ftp->mdtm($remfile))
        {
            $remtime = 0;
        }
        $localtime = (stat($file))[9];
        if (defined($localtime) and defined($remtime))
        {
            if ($localtime > $remtime)
            {
                $upload=1;
            }
        }
        else
        {
            $upload=1;
        }
        if ($upload)
        {
            if (-B $localfile)
            {
                if ($curxfermode eq 'ASCII')
                {
                    if ($ftp->binary())
                    {
                        $curxfermode = 'BIN';
                        print "Changed mode to BINary\n" 
                            if $debug;
                    }
                    else
                    {
                        warn "Couldn't change transfer mode";
                    }
                }
            }
            else
            {
                if ($curxfermode eq 'BIN')
                {
                    if ($ftp->ascii())
                    {
                        $curxfermode = 'ASCII';
                        print "Changed mode to ASCII\n" 
                            if $debug;
                    }
                    else
                    {
                        warn "Couldn't change transfer mode";
                    }
                }
            }
            print "Uploading $localfile to $remfile\n" if $debug;
            $ftp->put($localfile,$remfile) 
                or warn "Couldn't upload $remfile";
        }
        else
        {
            print "File $remfile appears to be up to date\n" 
                if $debug;
        }
    }
}

#---------------------------------------------------------------------------------------
sub loadWget {
&UpdateIndicators2;
    my ($host,$localdir);
    system("Program/wget/bin/wget $host");

}

#------------------------DEBUT MIRRORING---------------
sub loadMirroring {
&UpdateIndicators2;
    my ($file,$host,$localdir,$curhost);
#    my ($url, $specdir, $quiet, $silent, $inchost, $unrestrict) = @_;
    my ($url, $specdir) = @_;
    print $url, "1\n";
    print $specdir, "1\n";
    $quiet = 0;
    $silent = 1;
    my %fullurl;
#    my @urlstack = ($url);
    @urlstack = ($url);
#    my @urls = ();
    @urls = ();
    my $p = HTML::LinkExtor->new(\&callback);
    print @urls, "\n";
    my $ua = new LWP::UserAgent;
  
    print $url, "2\n";
    print $specdir, "2\n";

    my $res = $ua->request(HTTP::Request->new(GET => $url));
    print $res, "3\n";
    print $url, "3\n";
    print $specdir, "3\n";

    eval { $res->base };
    if ($@) {
	&mkPrintErreur("Caught Error : $@\n");
	return;
	}

    my $base = $res->base;

    print $url, "4\n";
    print $specdir, "4\n";

    $curhost = $host = url($url,'')->host;
    print "Retrieving from $url to $specdir", ($inchost ? "$host\n" : "\n") unless ($silent);
    while ($url = pop(@urlstack)){
	$host = url($url,'')->host;
	if ($host ne $curhost) {
	    my $ua = new LWP::UserAgent;
	    my $res = $ua->request(HTTP::Request->new(GET => $url));
	    my $base = $res->base;
	    $host = url($url,'')->host;
	    $curhost = $host;
	    print "Changing host to $host\n" unless $quiet;
	} 
	$localdir = ($inchost ? "$specdir$host/" : "$specdir/");
	$file = url($url,$base)->full_path;
	if ($file =~ /\/$/) {$file .= "index.html" };
	$file =~ s/^\//$localdir/;
	print "Retrieving: $url to $file\n" unless ($quiet);
	my $dir = dirname($file);
	unless (-d $dir)
	{
	    mkdirhier($dir);
	}
	getfile($url,$file);
	if (-e $file)
	{
	    $p->parse_file($file);
	    @urls = map { $_ = url($_, $base)->abs; } @urls;
	    addtostack(@urls);
	}
    }
}

#---------------------------------------------------------------------------------------
sub loadMirroringPage {
&UpdateIndicators2;

    my ($url, $specdir) = @_;
    print $url, "1\n";
    print $specdir, "1\n";
    my $page_contents = get("$url");
    if (!open(RES5,(">".$winMain::start_dir."loadMirroringPage.htm"))) {
	&mkPrintErreur("ERREUR : Impossible de crer le fichier loadMirroringPage.htm\n");
	return;
    }
    print RES5 $page_contents;
    close (RES5);
    my $file = $winMain::start_dir."loadMirroringPage.htm";
    my $msg = $winMain::start_dir."loadMirroringPage.htm";
    &IncludedFileInWindow($file,$msg);
    &tkweb($winMain::start_dir."loadMirroringPage.htm");

}
#---------------------------------------
sub addtostack {
&UpdateIndicators2;
    my (@urllist) = @_;
    for my $url (@urllist) {
        next if ($url =~ /\#/);
	next unless ($url =~ /^http/);
	my $urlhost = url($url,$base)->host;
	unless (defined($unrestrict)) { next unless ($urlhost eq $host); };
        push(@urlstack,$url) unless(defined($fullurl{$url}));
        $fullurl{$url} = 1;
    }
}
#---------------------------------------
sub callback {
&UpdateIndicators2;
    my($tag, %attr) = @_;
    push(@urls, values %attr);
}
#---------------------------------------
sub getfile {
&UpdateIndicators2;
    my ($url,$file) = @_;
    my $rc = mirror($url, $file);
    
    if ($rc == 304) {
        print "File is up to date\n" unless ($quiet);
    } 
    elsif (!is_success($rc)){
        warn "sitemirr: $rc ", status_message($rc), " ($url)\n" 
            unless ($silent);
        return(0);
    }
}
#---------------------------------------
sub mkdirhier {
&UpdateIndicators2;
    my ($fullpath) = @_;
    my $path;
    for my $dir (split("/",$fullpath)){
        unless (-d "$path$dir") {
            mkdir("$path$dir",0777) 
                or die "Couldn't make directory $path/$dir: $!";
        }
        $path .= "$dir/";
    }
}

#------------------------FIN MIRRORING---------------
#--------------------------------------------------------------------------
sub webxref1 {
&UpdateIndicators2;
    &query_dir_webxref;
}


#---------------------------------------------------------------------------------------
sub webxrefOneDir {
&UpdateIndicators2;
    &query_dir_webxrefOneDir;
}

#---------------------------------------------------------------------------------------
sub webxrefOneDirLynx {
&UpdateIndicators2;
    &query_dir_webxrefOneDirLynx;
}

#---------------------------------------------
sub webxref2 {
&UpdateIndicators2;
        $winMain::nom_fic =~ /\/([^\/]+)\/([^\/]+)$/;
        my $sitename=$1;
        my $reste=$2;
	
        my $start= &GetCWD;
	my $resultsDir="$start"."res1("."$sitename".")/";
        print "perl $dir0"."webxref.pl -html  $winMain::nom_fic\n";
	eval { system("perl $dir0"."webxref.pl -html  $winMain::nom_fic")};
	if ($@) {
	    &mkPrintErreur("Caught Error : $@\n");
	    return;
	}

	my $results="$start"."res1("."$sitename".")/"."analysis_results.html";
	my $rapportDir="$start"."res1("."$sitename".")";
	my $file = $results;
	if (defined $file and $file ne '') {
	    my $msg="$start"."res1("."$sitename".")/"."analysis_results.html";
	    &IncludedFileInWindow($file,$msg);
	    &mkPrintMsgInfo("Gnration des rapports HTML via WebXref termine\nRapport gnral charg dans nouvelle fentre,\nRapport pour chaque page HTML contenu dans $rapportDir\n");
	    &tkweb($file);

	}
	else {
	&mkPrintErreur("Impossible d'ouvrir le fichier rsultat.\n");	}

    }

#---------------------------------------------------------------------------------------
sub webxref11 {
    &UpdateIndicators2;
    &query_dir_webxref2;
}
#---------------------------------------------------------------------------------------
sub webxref11Lynx {
    &UpdateIndicators2;
    &query_dir_webxref2Lynx;
}

#---------------------------------------------------------------------------------------
sub webxref111 {
    &UpdateIndicators2;
    &query_dir_webxref22;
}
#---------------------------------------------------------------------------------------
sub webxref1111 {
    &UpdateIndicators2;
    &query_dir_webxref222;
}
#---------------------------------------------------------------------------------------
sub sensnetXref1 {
    &UpdateIndicators2;
    &query_sensnetxref1;
}
#---------------------------------------------------------------------------------------
sub sensnetXref2 {
    &UpdateIndicators2;
    &query_sensnetxref2;
}
#---------------------------------------------------------------------------------------
sub sensnetXref3 {
    &UpdateIndicators2;
    $winMain::nom_fic =~ /\/([^\/]+)\/([^\/]+)$/;
    my $sitename=$1;
    my $reste=$2;
    my $start= &GetCWD;
    my $resultsDir="$start"."res1("."$sitename".")/";
    print "perl $dir0"."webxref-sensnet.pl -html -lynx  $winMain::nom_fic\n";
    eval { system("perl $dir0"."webxref-sensnet.pl -html -lynx $winMain::nom_fic")};
    if ($@) {
	&mkPrintErreur("Caught Error : $@\n");
	return;
    }
    my $results="$start"."res1("."$sitename".")/"."analysis_results.html";
    my $rapportDir="$start"."res1("."$sitename".")";
    my $file = $results;
    if (defined $file and $file ne '') {
	my $msg="$start"."res1("."$sitename".")/"."analysis_results.html";
#---------------------------------------------------------------------------	
	my $msie;
	eval {my $msie = Win32::OLE->GetActiveObject('InternetExplorer.Application')};
	if ($@) {
	    &mkPrintErreur("InternetExplorer unavailable" );
	}
	unless (defined $msie) {
	    print "Dmarrage de IE \n";
	    $msie = Win32::OLE->new('InternetExplorer.Application');
	    if ($@) {
		&mkPrintErreur("ERREUR : Oops, cannot start IE" );
	    }
	    $msie->{'Visible'}=1;
	    $msie->Navigate($file);
	}
#---------------------------------------------------------------------------	
#	&IncludedFileInWindow($file,$msg);
	my $tmpfile = "$start"."res1($sitename)/corp-"."$sitename".".xml";
	my $msg = "$start"."res1($sitename)/corp-"."$sitename".".xml";
#---------------------------------------------------------------------------	
	my $msie;
	eval {my $msie = Win32::OLE->GetActiveObject('InternetExplorer.Application')};
	if ($@) {
	    &mkPrintErreur("InternetExplorer unavailable" );
	}
	unless (defined $msie) {
	    print "Dmarrage de IE \n";
	    $msie = Win32::OLE->new('InternetExplorer.Application');
	    if ($@) {
		&mkPrintErreur("ERREUR : Oops, cannot start IE" );
	    }
	    $msie->{'Visible'}=1;
	    $msie->Navigate($tmpfile);
	}
#---------------------------------------------------------------------------	
#	&IncludedFileInWindow($tmpfile,$msg);
	my $tmpfile = "$start"."res1($sitename)/corp-"."$sitename".".txt";
	my $msg = "$start"."res1($sitename)/corp-"."$sitename".".txt";
	&IncludedFileInWindow($tmpfile,$msg);
	my $tmpfile = "$start"."res1($sitename)/StatWordFull.txt";
	my $msg = "$start"."res1($sitename)/StatWordFull.txt";
	&IncludedFileInWindow($tmpfile,$msg);
	my $tmpfile = "$start"."res1($sitename)/StatWordByFile.txt";
	my $msg = "$start"."res1($sitename)/StatWordByFile.txt";
	&IncludedFileInWindow($tmpfile,$msg);
	&mkPrintMsgInfo("Gnration des rapports HTML via WebXref termine\nRapport gnral charg dans nouvelle fentre,\nCorpus XML et statistiques chargs dans nouvelles fentres,\nRapport pour chaque page HTML contenu dans $rapportDir\n");
    }
    else {
	&mkPrintErreur("Impossible d'ouvrir le fichier rsultat.\n");	
    }
}
#---------------------------------------------------------------------------------------
sub sensnetXref4 {
    &UpdateIndicators2;
    &query_sensnetxref4;
}
#---------------------------------------------------------------------------------------
sub sensnetXref5 {
    &UpdateIndicators2;
    &query_sensnetxref5;
}
#---------------------------------------------------------------------------------------
sub sensnetXref6 {
    &UpdateIndicators2;
    $winMain::nom_fic =~ /\/([^\/]+)\/([^\/]+)$/;
    my $sitename=$1;
    my $reste=$2;
    my $start= &GetCWD;
    my $resultsDir="$start"."res1("."$sitename".")/";
    print "perl $dir0"."webxref-sensnet-lynx32.pl -html -lynx  $winMain::nom_fic\n";
    eval { system("perl $dir0"."webxref-sensnet-lynx32.pl -html -lynx $winMain::nom_fic")};
    if ($@) {
	&mkPrintErreur("Caught Error : $@\n");
	return;
    }
    my $results="$start"."res1("."$sitename".")/"."analysis_results.html";
    my $rapportDir="$start"."res1("."$sitename".")";
    my $file = $results;
    if (defined $file and $file ne '') {
	my $msg="$start"."res1("."$sitename".")/"."analysis_results.html";
#---------------------------------------------------------------------------	
	my $msie;
	eval {my $msie = Win32::OLE->GetActiveObject('InternetExplorer.Application')};
	if ($@) {
	    &mkPrintErreur("InternetExplorer unavailable" );
	}
	unless (defined $msie) {
	    print "Dmarrage de IE \n";
	    $msie = Win32::OLE->new('InternetExplorer.Application');
	    if ($@) {
		&mkPrintErreur("ERREUR : Oops, cannot start IE" );
	    }
	    $msie->{'Visible'}=1;
	    $msie->Navigate($file);
	}
#---------------------------------------------------------------------------	
#	&IncludedFileInWindow($file,$msg);
	my $tmpfile = "$start"."res1($sitename)/corp-"."$sitename".".xml";
	my $msg = "$start"."res1($sitename)/corp-"."$sitename".".xml";
#---------------------------------------------------------------------------	
	my $msie;
	eval {my $msie = Win32::OLE->GetActiveObject('InternetExplorer.Application')};
	if ($@) {
	    &mkPrintErreur("InternetExplorer unavailable" );
	}
	unless (defined $msie) {
	    print "Dmarrage de IE \n";
	    $msie = Win32::OLE->new('InternetExplorer.Application');
	    if ($@) {
		&mkPrintErreur("ERREUR : Oops, cannot start IE" );
	    }
	    $msie->{'Visible'}=1;
	    $msie->Navigate($tmpfile);
	}
#---------------------------------------------------------------------------	
#	&IncludedFileInWindow($tmpfile,$msg);
	my $tmpfile = "$start"."res1($sitename)/corp-"."$sitename".".txt";
	my $msg = "$start"."res1($sitename)/corp-"."$sitename".".txt";
	&IncludedFileInWindow($tmpfile,$msg);
	my $tmpfile = "$start"."res1($sitename)/StatWordFull.txt";
	my $msg = "$start"."res1($sitename)/StatWordFull.txt";
	&IncludedFileInWindow($tmpfile,$msg);
	my $tmpfile = "$start"."res1($sitename)/StatWordByFile.txt";
	my $msg = "$start"."res1($sitename)/StatWordByFile.txt";
	&IncludedFileInWindow($tmpfile,$msg);
	&mkPrintMsgInfo("Gnration des rapports HTML via WebXref termine\nRapport gnral charg dans nouvelle fentre,\nCorpus XML et statistiques chargs dans nouvelles fentres,\nRapport pour chaque page HTML contenu dans $rapportDir\n");
    }
    else {
	&mkPrintErreur("Impossible d'ouvrir le fichier rsultat.\n");	
    }
}
#---------------------------------------------
sub webxref22 {
&UpdateIndicators2;
        $winMain::nom_fic =~ /\/([^\/]+)\/([^\/]+)$/;
        my $sitename=$1;
        my $reste=$2;
	
        my $start= &GetCWD;
	my $resultsDir="$start"."res1("."$sitename".")/";
        print "perl $dir0"."webxref2.pl -html  $winMain::nom_fic\n";
	eval { system("perl $dir0"."webxref2.pl -html  $winMain::nom_fic")};
	if ($@) {
	    &mkPrintErreur("Caught Error : $@\n");
	    return;
	}

	my $results="$start"."res1("."$sitename".")/"."analysis_results.html";
	my $rapportDir="$start"."res1("."$sitename".")";
	my $file = $results;
	if (defined $file and $file ne '') {
	    my $msg="$start"."res1("."$sitename".")/"."analysis_results.html";
	    &IncludedFileInWindow($file,$msg);
	    &tkweb($file);
	    my $tmpfile = "$start"."res1($sitename)/corp-"."$sitename".".xml";
	    my $msg = "$start"."res1($sitename)/corp-"."$sitename".".xml";
	    &IncludedFileInWindow($tmpfile,$msg);
	    my $tmpfile = "$start"."res1($sitename)/corp-"."$sitename".".txt";
	    my $msg = "$start"."res1($sitename)/corp-"."$sitename".".txt";
	    &IncludedFileInWindow($tmpfile,$msg);
	    my $tmpfile = "$start"."res1($sitename)/StatWordFull.txt";
	    my $msg = "$start"."res1($sitename)/StatWordFull.txt";
	    &IncludedFileInWindow($tmpfile,$msg);
	    my $tmpfile = "$start"."res1($sitename)/StatWordByFile.txt";
	    my $msg = "$start"."res1($sitename)/StatWordByFile.txt";
	    &IncludedFileInWindow($tmpfile,$msg);
	    &mkPrintMsgInfo("Gnration des rapports HTML via WebXref termine\nRapport gnral charg dans nouvelle fentre,\nCorpus XML et statistiques chargs dans nouvelles fentres,\nRapport pour chaque page HTML contenu dans $rapportDir\n");
	}
	else {
	&mkPrintErreur("Impossible d'ouvrir le fichier rsultat.\n");	}

    }

#---------------------------------------------------------------------------------------
sub webxref22Lynx {
&UpdateIndicators2;
        $winMain::nom_fic =~ /\/([^\/]+)\/([^\/]+)$/;
        my $sitename=$1;
        my $reste=$2;
	
        my $start= &GetCWD;
	my $resultsDir="$start"."res1("."$sitename".")/";
        print "perl $dir0"."webxref2.pl -html -lynx $winMain::nom_fic\n";
	eval { system("perl $dir0"."webxref2.pl -html -lynx  $winMain::nom_fic")};
	if ($@) {
	    &mkPrintErreur("Caught Error : $@\n");
	    return;
	}

	my $results="$start"."res1("."$sitename".")/"."analysis_results.html";
	my $rapportDir="$start"."res1("."$sitename".")";
	my $file = $results;
	if (defined $file and $file ne '') {
	    my $msg="$start"."res1("."$sitename".")/"."analysis_results.html";
	    &IncludedFileInWindow($file,$msg);
	    &tkweb($file);
	    my $tmpfile = "$start"."res1($sitename)/corp-"."$sitename".".xml";
	    my $msg = "$start"."res1($sitename)/corp-"."$sitename".".xml";
	    &IncludedFileInWindow($tmpfile,$msg);
	    my $tmpfile = "$start"."res1($sitename)/corp-"."$sitename".".txt";
	    my $msg = "$start"."res1($sitename)/corp-"."$sitename".".txt";
	    &IncludedFileInWindow($tmpfile,$msg);
	    my $tmpfile = "$start"."res1($sitename)/StatWordFull.txt";
	    my $msg = "$start"."res1($sitename)/StatWordFull.txt";
	    &IncludedFileInWindow($tmpfile,$msg);
	    my $tmpfile = "$start"."res1($sitename)/StatWordByFile.txt";
	    my $msg = "$start"."res1($sitename)/StatWordByFile.txt";
	    &IncludedFileInWindow($tmpfile,$msg);
	    &mkPrintMsgInfo("Gnration des rapports HTML via WebXref termine\nRapport gnral charg dans nouvelle fentre,\nCorpus XML et statistiques chargs dans nouvelles fentres,\nRapport pour chaque page HTML contenu dans $rapportDir\n");
	}
	else {
	&mkPrintErreur("Impossible d'ouvrir le fichier rsultat.\n");	}

    }

#---------------------------------------------
sub webxref222 {
&UpdateIndicators2;
        $winMain::nom_fic =~ /\/([^\/]+)\/([^\/]+)$/;
        my $sitename=$1;
        my $reste=$2;
	
        my $start= &GetCWD;
	my $resultsDir="$start"."res1("."$sitename".")/";
        print "perl $dir0"."webxref3.pl -html  $winMain::nom_fic\n";
	eval { system("perl $dir0"."webxref3.pl -html  $winMain::nom_fic")};
	if ($@) {
	    &mkPrintErreur("Caught Error : $@\n");
	    return;
	}

	my $results="$start"."res1("."$sitename".")/"."analysis_results.html";
	my $rapportDir="$start"."res1("."$sitename".")";
	my $file = $results;
	if (defined $file and $file ne '') {
	    my $msg="$start"."res1("."$sitename".")/"."analysis_results.html";
	    &IncludedFileInWindow($file,$msg);
	    &tkweb($file);
	    my $tmpfile = "$start"."res1($sitename)/corp-"."$sitename".".xml";
	    my $msg = "$start"."res1($sitename)/corp-"."$sitename".".xml";
	    &IncludedFileInWindow($tmpfile,$msg);
	    my $tmpfile = "$start"."res1($sitename)/corp-"."$sitename".".txt";
	    my $msg = "$start"."res1($sitename)/corp-"."$sitename".".txt";
	    &IncludedFileInWindow($tmpfile,$msg);
	    my $tmpfile = "$start"."res1($sitename)/StatWordFull.txt";
	    my $msg = "$start"."res1($sitename)/StatWordFull.txt";
	    &IncludedFileInWindow($tmpfile,$msg);
	    my $tmpfile = "$start"."res1($sitename)/StatWordByFile.txt";
	    my $msg = "$start"."res1($sitename)/StatWordByFile.txt";
	    &IncludedFileInWindow($tmpfile,$msg);
	    &mkPrintMsgInfo("Gnration des rapports HTML via WebXref termine\nRapport gnral charg dans nouvelle fentre,\nCorpus XML et statistiques chargs dans nouvelles fentres,\nRapport pour chaque page HTML contenu dans $rapportDir\n");
	}
	else {
	&mkPrintErreur("Impossible d'ouvrir le fichier rsultat.\n");	}

    }
#---------------------------------------------
sub webxref2222 {
&UpdateIndicators2;
        $winMain::nom_fic =~ /\/([^\/]+)\/([^\/]+)$/;
        my $sitename=$1;
        my $reste=$2;
	
        my $start= &GetCWD;
	my $resultsDir="$start"."res1("."$sitename".")/";
        print "perl $dir0"."webxref3.pl -html -lynx $winMain::nom_fic\n";
	eval { system("perl $dir0"."webxref3.pl -html -lynx  $winMain::nom_fic")};
	if ($@) {
	    &mkPrintErreur("Caught Error : $@\n");
	    return;
	}

	my $results="$start"."res1("."$sitename".")/"."analysis_results.html";
	my $rapportDir="$start"."res1("."$sitename".")";
	my $file = $results;
	if (defined $file and $file ne '') {
	    my $msg="$start"."res1("."$sitename".")/"."analysis_results.html";
	    &IncludedFileInWindow($file,$msg);
	    &tkweb($file);
	    my $tmpfile = "$start"."res1($sitename)/corp-"."$sitename".".xml";
	    my $msg = "$start"."res1($sitename)/corp-"."$sitename".".xml";
	    &IncludedFileInWindow($tmpfile,$msg);
	    my $tmpfile = "$start"."res1($sitename)/corp-"."$sitename".".txt";
	    my $msg = "$start"."res1($sitename)/corp-"."$sitename".".txt";
	    &IncludedFileInWindow($tmpfile,$msg);
	    my $tmpfile = "$start"."res1($sitename)/StatWordFull.txt";
	    my $msg = "$start"."res1($sitename)/StatWordFull.txt";
	    &IncludedFileInWindow($tmpfile,$msg);
	    my $tmpfile = "$start"."res1($sitename)/StatWordByFile.txt";
	    my $msg = "$start"."res1($sitename)/StatWordByFile.txt";
	    &IncludedFileInWindow($tmpfile,$msg);
	    &mkPrintMsgInfo("Gnration des rapports HTML via WebXref termine\nRapport gnral charg dans nouvelle fentre,\nCorpus XML et statistiques chargs dans nouvelles fentres,\nRapport pour chaque page HTML contenu dans $rapportDir\n");
	}
	else {
	&mkPrintErreur("Impossible d'ouvrir le fichier rsultat.\n");	}

    }

#---------------------------------------------
sub mktipo1 {
&UpdateIndicators2;

    &query_dir_mktipo;

}

#---------------------------------------------
sub makestat1 {
&UpdateIndicators2;

    &query_dir_makestat1;

}

#---------------------------------------------
sub loadwebxref {
&UpdateIndicators2;

    my ($dir0,$dir1,$sitename,$dir2)=@_;
    
    $file1=$dir0;
    $file2=$dir1;
    $file3=$dir2;
    $file4=$sitename;

    if (defined $file1 and $file1 ne '' 
	and defined $file2 and $file2 ne '' 
	and defined $file3 and $file3 ne ''
	and defined $file4 and $file4 ne ''
	) {
	print "perl $dir0"."webxref.pl -html -at $dir2 $dir1"."$sitename \n";
	eval { system("perl $dir0"."webxref.pl -html -at $dir2 $dir1"."$sitename")};
	if ($@) {
	    &mkPrintErreur("Caught Error : $@\n");
	    return;
	}
	
	my $results="$dir2"."res1($sitename)/analysis_results.html";
	my $rapportDir="$dir2"."res1($sitename)";
	my $file = $results;
	if (defined $file and $file ne '') {
	    my $msg="$dir2"."res1($sitename)/analysis_results.html";
	    &IncludedFileInWindow($file,$msg);
	    &tkweb($file);
	    &mkPrintMsgInfo("Gnration des rapports HTML via WebXref termine\nRapport gnral charg dans nouvelle fentre,\nRapport pour chaque page HTML contenu dans $rapportDir\n");
	}
	else {
	&mkPrintErreur("Impossible d'ouvrir le fichier rsultat.\n");	}

    }
    else {
	&mkPrintErreur("Problme au lancement de Webref : vrifier prsence programme, input, output\n");
    }

}

#---------------------------------------------
sub loadwebxref2 {
&UpdateIndicators2;

    my ($dir0,$dir1,$sitename,$dir2)=@_;
    
    $file1=$dir0;
    $file2=$dir1;
    $file3=$dir2;
    $file4=$sitename;

    if (defined $file1 and $file1 ne '' 
	and defined $file2 and $file2 ne '' 
	and defined $file3 and $file3 ne ''
	and defined $file4 and $file4 ne ''
	) {
	print "perl $dir0"."webxref2.pl -html -at $dir2 $dir1"."$sitename \n";
	eval { system("perl $dir0"."webxref2.pl -html -at $dir2 $dir1"."$sitename")};
	if ($@) {
	    &mkPrintErreur("Caught Error : $@\n");
	    return;
	}
	
	my $results="$dir2"."res1($sitename)/analysis_results.html";
	my $rapportDir="$dir2"."res1($sitename)";
	my $file = $results;
	if (defined $file and $file ne '') {
	    my $msg="$dir2"."res1($sitename)/analysis_results.html";
	    &IncludedFileInWindow($file,$msg);
	    &tkweb($file);
	    my $tmpfile = "$dir2"."res1($sitename)/corp-"."$sitename".".xml";
	    my $msg = "$dir2"."res1($sitename)/corp-"."$sitename".".xml";
	    &IncludedFileInWindow($tmpfile,$msg);
	    my $tmpfile = "$dir2"."res1($sitename)/StatWordFull.txt";
	    my $msg = "$dir2"."res1($sitename)/StatWordFull.txt";
	    &IncludedFileInWindow($tmpfile,$msg);
	    my $tmpfile = "$dir2"."res1($sitename)/StatWordByFile.txt";
	    my $msg = "$dir2"."res1($sitename)/StatWordByFile.txt";
	    &IncludedFileInWindow($tmpfile,$msg);

	    &mkPrintMsgInfo("Gnration des rapports HTML via WebXref termine\nRapport gnral charg dans nouvelle fentre,\nCorpus XML et statistiques chargs dans nouvelles fentres,\nRapport pour chaque page HTML contenu dans $rapportDir\n");
	}
	else {
	&mkPrintErreur("Impossible d'ouvrir le fichier rsultat.\n");	}

    }
    else {
	&mkPrintErreur("Problme au lancement de Webref : vrifier prsence programme, input, output\n");
    }

}

#---------------------------------------------------------------------------------------
sub loadwebxref2Lynx {
&UpdateIndicators2;

    my ($dir0,$dir1,$sitename,$dir2)=@_;
    
    $file1=$dir0;
    $file2=$dir1;
    $file3=$dir2;
    $file4=$sitename;

    if (defined $file1 and $file1 ne '' 
	and defined $file2 and $file2 ne '' 
	and defined $file3 and $file3 ne ''
	and defined $file4 and $file4 ne ''
	) {
	print "perl $dir0"."webxref2.pl -html -lynx -at $dir2 $dir1"."$sitename \n";
	eval { system("perl $dir0"."webxref2.pl -html -lynx -at $dir2 $dir1"."$sitename")};
	if ($@) {
	    &mkPrintErreur("Caught Error : $@\n");
	    return;
	}
	
	my $results="$dir2"."res1($sitename)/analysis_results.html";
	my $rapportDir="$dir2"."res1($sitename)";
	my $file = $results;
	if (defined $file and $file ne '') {
	    my $msg="$dir2"."res1($sitename)/analysis_results.html";
	    &IncludedFileInWindow($file,$msg);
	    &tkweb($file);
	    my $tmpfile = "$dir2"."res1($sitename)/corp-"."$sitename".".xml";
	    my $msg = "$dir2"."res1($sitename)/corp-"."$sitename".".xml";
	    &IncludedFileInWindow($tmpfile,$msg);
	    my $tmpfile = "$dir2"."res1($sitename)/StatWordFull.txt";
	    my $msg = "$dir2"."res1($sitename)/StatWordFull.txt";
	    &IncludedFileInWindow($tmpfile,$msg);
	    my $tmpfile = "$dir2"."res1($sitename)/StatWordByFile.txt";
	    my $msg = "$dir2"."res1($sitename)/StatWordByFile.txt";
	    &IncludedFileInWindow($tmpfile,$msg);

	    &mkPrintMsgInfo("Gnration des rapports HTML via WebXref termine\nRapport gnral charg dans nouvelle fentre,\nCorpus XML et statistiques chargs dans nouvelles fentres,\nRapport pour chaque page HTML contenu dans $rapportDir\n");
	}
	else {
	&mkPrintErreur("Impossible d'ouvrir le fichier rsultat.\n");	}

    }
    else {
	&mkPrintErreur("Problme au lancement de Webref : vrifier prsence programme, input, output\n");
    }

}


#---------------------------------------------------------------------------------------
sub loadwebxrefOneDir {
&UpdateIndicators2;

    my ($dir0,$dir1,$dir2)=@_;
    
    $file1=$dir0;
    $file2=$dir1;
    $file3=$dir2;
    my $cpt;
    $cpt=0;

    if (defined $file1 and $file1 ne '' and defined $file2 and $file2 ne '' and defined $file3 and $file3 ne '') {
	opendir(DIR, $dir1) or die "can't open $dir1: $!\n";
	my @files = readdir(DIR);
	closedir(DIR);
	foreach my $file (@files) {
	    next if $file =~ /^\.\.?$/;
	    $file = $dir1."/".$file;
	    if (-d $file) {
#		$file.="/";
		print "perl $dir0"."webxref2.pl -rappspec $cpt -html -at $dir2 $file \n";
		eval { system("perl $dir0"."webxref2.pl -rappspec $cpt -html -at $dir2 $file")};
		if ($@) {
		    &mkPrintErreur("Caught Error : $@\n");
		    return;
		}
		$cpt++;
	    }
	}
	&mkPrintMsgInfo("Gnration des rapports HTML via WebXref termine\nRapport pour chaque site contenu dans $dir2\n");
    }
    else {
	&mkPrintErreur("Problme au lancement de Webref : vrifier prsence programme, input, output\n");
    }
    
}

#---------------------------------------------------------------------------------------
sub loadwebxrefOneDirLynx {
&UpdateIndicators2;

    my ($dir0,$dir1,$dir2)=@_;
    
    $file1=$dir0;
    $file2=$dir1;
    $file3=$dir2;
    my $cpt;
    $cpt=0;

    if (defined $file1 and $file1 ne '' and defined $file2 and $file2 ne '' and defined $file3 and $file3 ne '') {
	opendir(DIR, $dir1) or die "can't open $dir1: $!\n";
	my @files = readdir(DIR);
	closedir(DIR);
	foreach my $file (@files) {
	    next if $file =~ /^\.\.?$/;
	    $file = $dir1."/".$file;
	    if (-d $file) {
#		$file.="/";
		print "perl $dir0"."webxref2.pl -rappspec $cpt -html -lynx -at $dir2 $file \n";
		eval { system("perl $dir0"."webxref2.pl -rappspec $cpt -html -lynx -at $dir2 $file")};
		if ($@) {
		    &mkPrintErreur("Caught Error : $@\n");
		    return;
		}
		$cpt++;
	    }
	}

	&mkPrintMsgInfo("Gnration des rapports HTML via WebXref termine\nRapport pour chaque site contenu dans $dir2\n");
    }
    else {
	&mkPrintErreur("Problme au lancement de Webref : vrifier prsence programme, input, output\n");
    }
    
}

#---------------------------------------------
sub loadwebxref22 {
&UpdateIndicators2;

    my ($dir0,$dir1,$sitename,$dir2)=@_;
    
    $file1=$dir0;
    $file2=$dir1;
    $file3=$dir2;
    $file4=$sitename;

    if (defined $file1 and $file1 ne '' 
	and defined $file2 and $file2 ne '' 
	and defined $file3 and $file3 ne ''
	and defined $file4 and $file4 ne ''
	) {
	print "perl $dir0"."webxref3.pl -html -at $dir2 $dir1"."$sitename \n";
	eval { system("perl $dir0"."webxref3.pl -html -at $dir2 $dir1"."$sitename")};
	if ($@) {
	    &mkPrintErreur("Caught Error : $@\n");
	    return;
	}
	
	my $results="$dir2"."res1($sitename)/analysis_results.html";
	my $rapportDir="$dir2"."res1($sitename)";
	my $file = $results;
	if (defined $file and $file ne '') {
	    my $msg="$dir2"."res1($sitename)/analysis_results.html";
	    &IncludedFileInWindow($file,$msg);
	    &tkweb($file);
	    my $tmpfile = "$dir2"."res1($sitename)/corp-"."$sitename".".xml";
	    my $msg = "$dir2"."res1($sitename)/corp-"."$sitename".".xml";
	    &IncludedFileInWindow($tmpfile,$msg);
	    my $tmpfile = "$dir2"."res1($sitename)/StatWordFull.txt";
	    my $msg = "$dir2"."res1($sitename)/StatWordFull.txt";
	    &IncludedFileInWindow($tmpfile,$msg);
	    my $tmpfile = "$dir2"."res1($sitename)/StatWordByFile.txt";
	    my $msg = "$dir2"."res1($sitename)/StatWordByFile.txt";
	    &IncludedFileInWindow($tmpfile,$msg);

	    &mkPrintMsgInfo("Gnration des rapports HTML via WebXref termine\nRapport gnral charg dans nouvelle fentre,\nCorpus XML et statistiques chargs dans nouvelles fentres,\nRapport pour chaque page HTML contenu dans $rapportDir\n");
	}
	else {
	&mkPrintErreur("Impossible d'ouvrir le fichier rsultat.\n");	}

    }
    else {
	&mkPrintErreur("Problme au lancement de Webref : vrifier prsence programme, input, output\n");
    }

}
#---------------------------------------------
sub loadwebxref222 {
&UpdateIndicators2;

    my ($dir0,$dir1,$sitename,$dir2)=@_;
    
    $file1=$dir0;
    $file2=$dir1;
    $file3=$dir2;
    $file4=$sitename;

    if (defined $file1 and $file1 ne '' 
	and defined $file2 and $file2 ne '' 
	and defined $file3 and $file3 ne ''
	and defined $file4 and $file4 ne ''
	) {
	print "perl $dir0"."webxref3.pl -html -lynx -at $dir2 $dir1"."$sitename \n";
	eval { system("perl $dir0"."webxref3.pl -html -lynx -at $dir2 $dir1"."$sitename")};
	if ($@) {
	    &mkPrintErreur("Caught Error : $@\n");
	    return;
	}
	
	my $results="$dir2"."res1($sitename)/analysis_results.html";
	my $rapportDir="$dir2"."res1($sitename)";
	my $file = $results;
	if (defined $file and $file ne '') {
	    my $msg="$dir2"."res1($sitename)/analysis_results.html";
	    &IncludedFileInWindow($file,$msg);
	    &tkweb($file);
	    my $tmpfile = "$dir2"."res1($sitename)/corp-"."$sitename".".xml";
	    my $msg = "$dir2"."res1($sitename)/corp-"."$sitename".".xml";
	    &IncludedFileInWindow($tmpfile,$msg);
	    my $tmpfile = "$dir2"."res1($sitename)/StatWordFull.txt";
	    my $msg = "$dir2"."res1($sitename)/StatWordFull.txt";
	    &IncludedFileInWindow($tmpfile,$msg);
	    my $tmpfile = "$dir2"."res1($sitename)/StatWordByFile.txt";
	    my $msg = "$dir2"."res1($sitename)/StatWordByFile.txt";
	    &IncludedFileInWindow($tmpfile,$msg);

	    &mkPrintMsgInfo("Gnration des rapports HTML via WebXref termine\nRapport gnral charg dans nouvelle fentre,\nCorpus XML et statistiques chargs dans nouvelles fentres,\nRapport pour chaque page HTML contenu dans $rapportDir\n");
	}
	else {
	&mkPrintErreur("Impossible d'ouvrir le fichier rsultat.\n");	}

    }
    else {
	&mkPrintErreur("Problme au lancement de Webref : vrifier prsence programme, input, output\n");
    }

}
#---------------------------------------------
sub loadsensnetxref1 {
    &UpdateIndicators2;
    my ($dir0,$dir1,$sitename,$dir2)=@_;
    $file1=$dir0;
    $file2=$dir1;
    $file3=$dir2;
    $file4=$sitename;
    if (defined $file1 and $file1 ne '' 
	and defined $file2 and $file2 ne '' 
	and defined $file3 and $file3 ne ''
	and defined $file4 and $file4 ne ''
	) {
	print "perl $dir0"."webxref-sensnet.pl -html -at $dir2 $dir1"."$sitename \n";
	eval { system("perl $dir0"."webxref-sensnet.pl -html -at $dir2 $dir1"."$sitename")};
	if ($@) {
	    &mkPrintErreur("Caught Error : $@\n");
	    return;
	}
	
	my $results="$dir2"."res1($sitename)/analysis_results.html";
	my $rapportDir="$dir2"."res1($sitename)";
	my $file = $results;
	if (defined $file and $file ne '') {
	    my $msg="$dir2"."res1($sitename)/analysis_results.html";
#---------------------------------------------------------------------------	
	    my $msie;
	    eval {my $msie = Win32::OLE->GetActiveObject('InternetExplorer.Application')};
	    if ($@) {
		&mkPrintErreur("InternetExplorer unavailable" );
	    }
	    unless (defined $msie) {
		print "Dmarrage de IE \n";
		$msie = Win32::OLE->new('InternetExplorer.Application');
		if ($@) {
		    &mkPrintErreur("ERREUR : Oops, cannot start IE" );
		}
		$msie->{'Visible'}=1;
		$msie->Navigate($file);
	    }
#---------------------------------------------------------------------------	
#	    &IncludedFileInWindow($file,$msg);
	    my $tmpfile = "$dir2"."res1($sitename)/corp-"."$sitename".".xml";
	    my $msg = "$dir2"."res1($sitename)/corp-"."$sitename".".xml";
#---------------------------------------------------------------------------	
	    my $msie;
	    eval {my $msie = Win32::OLE->GetActiveObject('InternetExplorer.Application')};
	    if ($@) {
		&mkPrintErreur("InternetExplorer unavailable" );
	    }
	    unless (defined $msie) {
		print "Dmarrage de IE \n";
		$msie = Win32::OLE->new('InternetExplorer.Application');
		if ($@) {
		    &mkPrintErreur("ERREUR : Oops, cannot start IE" );
		}
		$msie->{'Visible'}=1;
		$msie->Navigate($tmpfile);
	    }
#---------------------------------------------------------------------------	
	    &IncludedFileInWindow($tmpfile,$msg);
	    my $tmpfile = "$dir2"."res1($sitename)/StatWordFull.txt";
	    my $msg = "$dir2"."res1($sitename)/StatWordFull.txt";
	    &IncludedFileInWindow($tmpfile,$msg);
	    my $tmpfile = "$dir2"."res1($sitename)/StatWordByFile.txt";
	    my $msg = "$dir2"."res1($sitename)/StatWordByFile.txt";
	    &IncludedFileInWindow($tmpfile,$msg);

	    &mkPrintMsgInfo("Gnration des rapports HTML via WebXref termine\nRapport gnral charg dans nouvelle fentre,\nCorpus XML et statistiques chargs dans nouvelles fentres,\nRapport pour chaque page HTML contenu dans $rapportDir\n");
	}
	else {
	&mkPrintErreur("Impossible d'ouvrir le fichier rsultat.\n");	}

    }
    else {
	&mkPrintErreur("Problme au lancement de Webref : vrifier prsence programme, input, output\n");
    }

}
#---------------------------------------------
sub loadsensnetxref2 {
    &UpdateIndicators2;
    my ($dir0,$dir1,$dir2)=@_;
    $file1=$dir0;
    $file2=$dir1;
    $file3=$dir2;
    my $cpt;
    $cpt=0;
    if (defined $file1 and $file1 ne '' and defined $file2 and $file2 ne '' and defined $file3 and $file3 ne '') {
	opendir(DIR, $dir1) or die "can't open $dir1: $!\n";
	my @files = readdir(DIR);
	closedir(DIR);
	foreach my $file (@files) {
	    next if $file =~ /^\.\.?$/;
	    $file = $dir1."/".$file;
	    if (-d $file) {
#		$file.="/";
		print "perl $dir0"."webxref-sensnet.pl -rappspec $cpt -html -lynx -at $dir2 $file \n";
		eval { system("perl $dir0"."webxref-sensnet.pl -rappspec $cpt -html -lynx -at $dir2 $file")};
		if ($@) {
		    &mkPrintErreur("Caught Error : $@\n");
		    return;
		}
		$cpt++;
	    }
	}
	&mkPrintMsgInfo("Gnration des rapports HTML via WebXref termine\nRapport pour chaque site contenu dans $dir2\n");
    }
    else {
	&mkPrintErreur("Problme au lancement de Webref : vrifier prsence programme, input, output\n");
    }
    
}
#---------------------------------------------
sub loadsensnetxref4 {
    &UpdateIndicators2;
    my ($dir0,$dir1,$sitename,$dir2)=@_;
    $file1=$dir0;
    $file2=$dir1;
    $file3=$dir2;
    $file4=$sitename;
    if (defined $file1 and $file1 ne '' 
	and defined $file2 and $file2 ne '' 
	and defined $file3 and $file3 ne ''
	and defined $file4 and $file4 ne ''
	) {
	print "perl $dir0"."webxref-sensnet-lynx32.pl -html -lynx -at $dir2 $dir1"."$sitename \n";
	eval { system("perl $dir0"."webxref-sensnet-lynx32.pl -html -lynx -at $dir2 $dir1"."$sitename")};
	if ($@) {
	    &mkPrintErreur("Caught Error : $@\n");
	    return;
	}
	
	my $results="$dir2"."res1($sitename)/analysis_results.html";
	my $rapportDir="$dir2"."res1($sitename)";
	my $file = $results;
	if (defined $file and $file ne '') {
	    my $msg="$dir2"."res1($sitename)/analysis_results.html";
#---------------------------------------------------------------------------	
	    my $msie;
	    eval {my $msie = Win32::OLE->GetActiveObject('InternetExplorer.Application')};
	    if ($@) {
		&mkPrintErreur("InternetExplorer unavailable" );
	    }
	    unless (defined $msie) {
		print "Dmarrage de IE \n";
		$msie = Win32::OLE->new('InternetExplorer.Application');
		if ($@) {
		    &mkPrintErreur("ERREUR : Oops, cannot start IE" );
		}
		$msie->{'Visible'}=1;
		$msie->Navigate($file);
	    }
#---------------------------------------------------------------------------	
#	    &IncludedFileInWindow($file,$msg);
	    my $tmpfile = "$dir2"."res1($sitename)/corp-"."$sitename".".xml";
	    my $msg = "$dir2"."res1($sitename)/corp-"."$sitename".".xml";
#---------------------------------------------------------------------------	
	    my $msie;
	    eval {my $msie = Win32::OLE->GetActiveObject('InternetExplorer.Application')};
	    if ($@) {
		&mkPrintErreur("InternetExplorer unavailable" );
	    }
	    unless (defined $msie) {
		print "Dmarrage de IE \n";
		$msie = Win32::OLE->new('InternetExplorer.Application');
		if ($@) {
		    &mkPrintErreur("ERREUR : Oops, cannot start IE" );
		}
		$msie->{'Visible'}=1;
		$msie->Navigate($tmpfile);
	    }
#---------------------------------------------------------------------------	
	    &IncludedFileInWindow($tmpfile,$msg);
	    my $tmpfile = "$dir2"."res1($sitename)/StatWordFull.txt";
	    my $msg = "$dir2"."res1($sitename)/StatWordFull.txt";
	    &IncludedFileInWindow($tmpfile,$msg);
	    my $tmpfile = "$dir2"."res1($sitename)/StatWordByFile.txt";
	    my $msg = "$dir2"."res1($sitename)/StatWordByFile.txt";
	    &IncludedFileInWindow($tmpfile,$msg);

	    &mkPrintMsgInfo("Gnration des rapports HTML via WebXref termine\nRapport gnral charg dans nouvelle fentre,\nCorpus XML et statistiques chargs dans nouvelles fentres,\nRapport pour chaque page HTML contenu dans $rapportDir\n");
	}
	else {
	&mkPrintErreur("Impossible d'ouvrir le fichier rsultat.\n");	}

    }
    else {
	&mkPrintErreur("Problme au lancement de Webref : vrifier prsence programme, input, output\n");
    }

}
#---------------------------------------------
sub loadsensnetxref5 {
    &UpdateIndicators2;
    my ($dir0,$dir1,$dir2)=@_;
    $file1=$dir0;
    $file2=$dir1;
    $file3=$dir2;
    my $cpt;
    $cpt=0;
    if (defined $file1 and $file1 ne '' and defined $file2 and $file2 ne '' and defined $file3 and $file3 ne '') {
	opendir(DIR, $dir1) or die "can't open $dir1: $!\n";
	my @files = readdir(DIR);
	closedir(DIR);
	foreach my $file (@files) {
	    next if $file =~ /^\.\.?$/;
	    $file = $dir1."/".$file;
	    if (-d $file) {
#		$file.="/";
		print "perl $dir0"."webxref-sensnet-lynx32.pl -rappspec $cpt -html -lynx -at $dir2 $file \n";
		eval { system("perl $dir0"."webxref-sensnet-lynx32.pl -rappspec $cpt -html -lynx -at $dir2 $file")};
		if ($@) {
		    &mkPrintErreur("Caught Error : $@\n");
		    return;
		}
		$cpt++;
	    }
	}
	&mkPrintMsgInfo("Gnration des rapports HTML via WebXref termine\nRapport pour chaque site contenu dans $dir2\n");
    }
    else {
	&mkPrintErreur("Problme au lancement de Webref : vrifier prsence programme, input, output\n");
    }
    
}
#---------------------------------------------

sub loadMktipo {
&UpdateIndicators2;

    my ($dir0,$dir1,$sitename,$dir2)=@_;
    
    $file1=$dir0;
    $file2=$dir1;
    $file3=$dir2;
    $file4=$sitename;

    if (defined $file1 and $file1 ne '' 
	and defined $file2 and $file2 ne '' 
	and defined $file3 and $file3 ne ''
	and defined $file4 and $file4 ne ''
	) {
	print "perl $dir0"."mktipo.pl $dir1"."$sitename \n";
	system("perl $dir0"."mktipo.pl $dir1"."$sitename");
	&mkPrintMsgInfo("Gnration du corpus XML via Mktipo termine dans rpertoire de travail\n");
	$sitename=~/res1\(([^\)]+)\)/;
	my $sitename2=$1;
	my $file="$dir1"."corp-$sitename2".".xml";
	my $tmpfile="$dir1"."corp-$sitename2".".xml";
	my $msg="$dir1"."corp-$sitename2".".xml";
	&IncludedFileInWindow($tmpfile,$msg);

    }
    else {
	&mkPrintErreur("Problme au lancement de MkTipo : vrifier prsence programme, input, output\n");
    }

}

#---------------------------------------------
sub loadMkStatXML {
&UpdateIndicators2;

    my ($dir0,$dir1,$sitename,$dir2)=@_;
    $file1=$dir0;
    $file2=$dir1;
    $file3=$dir2;
    $file4=$sitename;
    if (defined $file1 and $file1 ne '' 
	and defined $file2 and $file2 ne '' 
	and defined $file3 and $file3 ne ''
	and defined $file4 and $file4 ne ''
	) {
#	$winMain::mw->withdraw;

	print "perl $dir0"."mkStatCorpXML.pl $dir1"."$sitename \n";
	system("perl $dir0"."mkStatCorpXML.pl $dir1"."$sitename"." $sitename");
	sleep(2);
	$wd->unShow;
	&mkPrintMsgInfo("Stat sur corpus XML via mkStatCorpXML termine\nFichiers gnrs : index (indexFile.txt),\n stat globale (StatWordFull.txt),\n stat par fichier (StatWordByFile.txt), \n et corpus brut textuel (corp-XML2TxtBrut.txt).\n");
	my $tmpfile="$dir0"."corp-XML2TxtBrut\(".$sitename."\).txt";
	my $msg="$dir0"."corp-XML2TxtBrut\(".$sitename."\).txt";
	&IncludedFileInWindow($tmpfile,$msg);
	my $tmpfile="$dir0"."StatWordFull\(".$sitename."\).txt";
	my $msg="$dir0"."StatWordFull\(".$sitename."\).txt";
	&IncludedFileInWindow($tmpfile,$msg);
	my $tmpfile="$dir0"."StatWordByFile\(".$sitename."\).txt";
	my $msg="$dir0"."StatWordByFile\(".$sitename."\).txt";
	&IncludedFileInWindow($tmpfile,$msg);
	my $tmpfile="$dir0"."indexFile\(".$sitename."\).txt";
	my $msg="$dir0"."indexFile\(".$sitename."\).txt";
	&IncludedFileInWindow($tmpfile,$msg);
    }
    else {
	&mkPrintErreur("Problme au lancement de MkStatCorpXML : vrifier prsence programme, input, output\n");
    }

}


#---------------------------------------------
sub typwebExtractTagHTML {
&UpdateIndicators2;

    if (! Exists ($pntag)) {
	$pntag = $winMain::mw ->Toplevel();
	$pntag->title("Choose Markups");
	$listePntag=$pntag->Scrolled("Listbox", -scrollbars => "e",
			      -selectmode => "extended",
			      -selectforeground => "red",
			      -setgrid => 1,
			      -width => -1)->pack();

	$pntag->Button(-text => "Extract Text",
		     -command =>  \&extract_tagtext_in_balise)->pack(-side => 'left', -pady => 5, -padx => 10);

	$pntag->Button(-text => "Close",
		     -command =>  sub {$pntag->destroy()})->pack(-side => 'left', -pady => 5, -padx => 10);

	my($w, $string, $tag) = ($winMain::texte,"<tagHTML[^>]+>",'search');
	my $id=0;
	my @seenElt=();
	$w->tag('remove',  $tag, '0.0', 'end');
	(my $num_lines) = $w->index('end') =~ /(\d*)\.\d*/;
	for($i = 1; $i <=$num_lines; $i++) {
	my $line = $w->get("${i}.0", "${i}.1000");
	next if not defined $line or $line !~ /($string)/;
        my $l = length $1;
	my $stringRegexp=$1;
	my $offset = 0;
	while (1) {
	    my $tmpoffset=0;
	    my $index = index $line, $stringRegexp, $tmpoffset;
	    last if $index == -1;
	    $offset += $index;
	    $seenElt[$id] =[$i, $offset, $i, $offset+$l];
	    $id++;
	    $offset += $l;
	    $line = substr $line, $index+$l;
	    if ($line=~/($string)/) { $stringRegexp=$1;
				      $l = length $1;}

	} # whilend
    } # forend

	$winMain::cpt_file_balises++;
	if (!open(TMPFILE,(">MKC-tmp_Mkbalises.txt"))) {
	    &mkPrintErreur("ERREUR : Impossible d\'ouvrir le fichier MKC-tmp_Mkbalises.txt\n");
	    return;
	}
	for ($i =0 ; $i <=  $#seenElt; $i++) {
	    $tmpTexte=$w->get(sprintf("%d.%d",$seenElt[$i][0],$seenElt[$i][1]),sprintf("%d.%d",$seenElt[$i][2],$seenElt[$i][3]));
	    print TMPFILE "$tmpTexte\n";
	}
	close(TMPFILE);

	if (!open(TMPFILE,("MKC-tmp_Mkbalises.txt"))) {
	    &mkPrintErreur("ERREUR : Impossible d\'ouvrir le fichier MKC-tmp_Mkbalises.txt\n");
	    return;
	}


	my @liste_balises=();
	my %Liste_Markups=();
	my $id = 0; 
	while(<TMPFILE>) {
	    chomp;
	    if ($_!~/\//) {
		if (!exists ($Liste_Markups{$_})) {
		    $Liste_Markups{$_}++;
		    $liste_balises[$id]=$_;
		    $id++;
		}
	    }
	    
	}

	close(TMPFILE);
	$listePntag->delete(0,'end');
	$listePntag->insert('end',@liste_balises);

    }
    else {
	$pntag->deiconify();
	$pntag->raise();
    }

}

#---------------------------------------------
sub typwebExtractTxtBrut {
&UpdateIndicators2;

    my $parser = new XML::Parser(Style=>'Subs', Pkg=>'SubHandlers', ErrorContext => 2);
    $parser->setHandlers(Char  => \&char_handler);
    eval { $parser->parsefile($winMain::nom_fic)};
    if ($@) {
	&mkPrintErreur("Caught Error : $@\n");
	return;
	}
    $mkXML2TxtBrut->destroy if Exists($mkXML2TxtBrut);
    $mkXML2TxtBrut = $winMain::mw->Toplevel();
    my $w = $mkXML2TxtBrut;
    $w->title('XML2TxtBrut');
    $w->iconname('XML2TxtBrut...');
    my $w_ok = $w->Button(-text => 'OK', -width => 8, -command => ['destroy', $w]);
    my $w_t = $w->TextUndo(-setgrid => 'true', -width => '60', -height => '28',
			-font => '-Adobe-Helvetica-Bold-R-Normal--*-120-*-*-*-*-*-*');
    my $w_save = $w->Button(-text => "Save",
			    -image => $winMain::imageSave,
			    -command => sub {$w_t->FileSaveAsPopup()})->pack(-side => 'top', -pady => 5, -padx => 10);
    $winMain::winBalloon->attach($w_save,
			-balloonmsg => "Save"
			);


    my $w_s = $w->Scrollbar(-command => ['yview', $w_t]);

    $w_t->configure(-yscrollcommand => ['set', $w_s]);
    $w_ok->pack(-side => 'top', -pady => 5, -padx => 10);
    $w_s->pack(-side => 'right', -fill => 'y');
    $w_t->pack(-expand => 'yes', -fill => 'both');

    # Set up display styles

    my(@bold, @normal, $tags);
    if ($mkXML2TxtBrut->depth > 1) {
	@bold = (-foreground => 'red');
	@normal = (-foreground => undef);
    } else {
	@bold = (-foreground => 'white', -background => 'black');
	@normal = (-foreground => undef, -background => undef);
    }
    if (!open(TMPFILE,("MKC-tmp_xml2txtbrut.txt"))) {
	$w_t->insert("end","ERREUR : Impossible d\'ouvrir le fichier MKC-tmp_xml2txtbrut.txt\n");
	return;
	}
    close(TMPFILE);

    my $file="MKC-tmp_xml2txtbrut.txt";
    $w_t->insert('0.0', 'Rsultats XML2TxtBrut...');
    $w_t->insert("end","\n\n");
    $w_t->IncludeFile($file);

}

#-----------------------
sub typwebMkListBalise {
&UpdateIndicators2;
    my $parser = new XML::Parser(Style=>'Subs', Pkg=>'SubHandlers', ErrorContext => 2);
    $parser->setHandlers(End => \&end_handler,
			 Start => \&start_handler);
    @liste_xmlBalise = ();
    %Liste_xmlBalise = ();
    eval { $parser->parsefile($winMain::nom_fic)};
    if ($@) {
	&mkPrintErreur("Caught Error : $@\n");
	}

    &mkSelectionXMLMarkup(@liste_xmlBalise);
}

#-----------------------
sub mkSelectionXMLMarkup {
&UpdateIndicators2;
    if (! Exists ($pnXMLBalise)) {
	$pnXMLBalise = $winMain::mw ->Toplevel();
	$pnXMLBalise->title("Choose Markups (Handlers) ");

	$listePnXMLBalise=$pnXMLBalise->Scrolled("Listbox", -scrollbars => "e",
			      -selectmode => "extended",
			      -selectforeground => "red",
			      -setgrid => 1,
			      -width => -1)->pack();

	$pnXMLBalise->Button(-text => "Delete",
		     -command =>  \&delete_selected_baliseXML)->pack(-side => 'left', -pady => 5, -padx => 10);
	$pnXMLBalise->Button(-text => "Modify",
		     -command =>  \&modify_selected_baliseXML)->pack(-side => 'left', -pady => 5, -padx => 10);
	$pnXMLBalise->Button(-text => "Extract Text",
		     -command =>  \&extract_text_in_baliseXML)->pack(-side => 'left', -pady => 5, -padx => 10);

	$pnXMLBalise->Button(-text => "Close",
		     -command =>  sub {$pnXMLBalise->destroy()})->pack(-side => 'left', -pady => 5, -padx => 10);

	my @liste_balises=@liste_xmlBalise;

	$listePnXMLBalise->delete(0,'end');
	$listePnXMLBalise->insert('end',@liste_balises);

    }
    else {
	$pnXMLBalise->deiconify();
	$pnXMLBalise->raise();
    }

}

#-----------------------
sub mkSelectionXMLLexicoMarkup {
&UpdateIndicators2;
    if (! Exists ($pnXMLLexicoBalise)) {
	$pnXMLLexicoBalise = $winMain::mw ->Toplevel();
	$pnXMLLexicoBalise->title("Choose Markups (Handlers)");

	$listePnXMLLexicoBalise=$pnXMLLexicoBalise->Scrolled("Listbox", -scrollbars => "e",
			      -selectmode => "extended",
			      -selectforeground => "red",
			      -setgrid => 1,
			      -width => -1)->pack();

	$pnXMLLexicoBalise->Button(-text => "Delete",
		     -command =>  \&delete_selected_baliseXMLLexico)->pack(-side => 'left', -pady => 5, -padx => 10);
	$pnXMLLexicoBalise->Button(-text => "Modify",
		     -command =>  \&modify_selected_baliseXMLLexico)->pack(-side => 'left', -pady => 5, -padx => 10);
	$pnXMLLexicoBalise->Button(-text => "Extract Text",
		     -command =>  \&extract_text_in_baliseXMLLexico)->pack(-side => 'left', -pady => 5, -padx => 10);

	$pnXMLLexicoBalise->Button(-text => "Close",
		     -command =>  sub {$pnXMLLexicoBalise->destroy()})->pack(-side => 'left', -pady => 5, -padx => 10);

	my @liste_balises=@liste_xmlLexicoBalise;

	$listePnXMLLexicoBalise->delete(0,'end');
	$listePnXMLLexicoBalise->insert('end',@liste_balises);
    }
    else {
	$pnXMLLexicoBalise->deiconify();
	$pnXMLLexicoBalise->raise();
    }

}

#-----------------------
sub mkSelectionXMLLexicoMarkup2 {
&UpdateIndicators2;
    if (! Exists ($pnXMLLexico2Balise)) {
	$pnXMLLexico2Balise = $winMain::mw ->Toplevel();
	$pnXMLLexico2Balise->title("Choose Markups (Handlers-Regexp)");

	$listePnXMLLexico2Balise=$pnXMLLexico2Balise->Scrolled("Listbox", -scrollbars => "e",
			      -selectmode => "extended",
			      -selectforeground => "red",
			      -setgrid => 1,
			      -width => -1)->pack();

	$pnXMLLexico2Balise->Button(-text => "Delete",
		     -command =>  \&delete_selected_baliseXMLLexico2)->pack(-side => 'left', -pady => 5, -padx => 10);
	$pnXMLLexico2Balise->Button(-text => "Modify",
		     -command =>  \&modify_selected_baliseXMLLexico2)->pack(-side => 'left', -pady => 5, -padx => 10);
	$pnXMLLexico2Balise->Button(-text => "Extract Text",
		     -command =>  \&extract_text_in_baliseXMLLexico2)->pack(-side => 'left', -pady => 5, -padx => 10);

	$pnXMLLexico2Balise->Button(-text => "Close",
		     -command =>  sub {$pnXMLLexico2Balise->destroy()})->pack(-side => 'left', -pady => 5, -padx => 10);

	my @liste_balises=@liste_xmlLexicoBalise;

	$listePnXMLLexico2Balise->delete(0,'end');
	$listePnXMLLexico2Balise->insert('end',@liste_balises);
    }
    else {
	$pnXMLLexico2Balise->deiconify();
	$pnXMLLexico2Balise->raise();
    }

}
#---------------------------- Module XWORD -------------------------------
sub mkXWord {
&UpdateIndicators2;
    system("perl Program/xword.pl");
}
#---------------------------- Module NLPTOOLS -------------------------------
sub findTypes {
&UpdateIndicators2;
########################################################################
# Author:  I. Dan Melamed
# Computes:	positions of all instances of all given types
# Loads:	text
# Streams:	set of target types
#######################################################################
    if ($winMain::search_string eq "") {
	&mkPrintErreur("ERREUR : Aucune slection de chane de recherche donne dans la zone \"Search string\"\n");
	return;
    }
    if (!open(F,"$winMain::nom_fic")) {
	&mkPrintErreur("ERREUR : Impossible d\'ouvrir '$winMain::nom_fic'\n");
	return;
    }
    if (!open(FIC2,">MKC-tmp_findTypes.txt")) {
	&mkPrintErreur("ERREUR : Impossible d\'ouvrir MKC-tmp_findTypes.txt\n");
	return;
    }
    my @text = <F>;
    close(F);
    my $search = $winMain::search_string;
    my $pos=1;
    while (@text) {
	$_=shift(@text);
	if (/($search)/g) {
	    my $hit = $1;
	    my $len = length($hit);
	    my $meanoffset = $len * .5 - .5;
	    printf FIC2 "%.1f %s\n", $pos - $meanoffset, $hit;
	}
	$pos++;
	
    }
    close(FIC2);
    my $tmpfile="MKC-tmp_findTypes.txt";
    my $msg="MKC-tmp_findTypes.txt";
    &IncludedFileInWindow($tmpfile,$msg);
    
}

#---------------------------------------------------------------------------------------
sub extractRegion {
&UpdateIndicators2;

    my $TRUE = 1;
    my $FALSE = 0;
    my $INFINITY = 9999999999;
    my $TINY = 0.0000001;

    if ($winMain::search_string eq "") {
	&mkPrintErreur("ERREUR : Aucune balise de dbut de zone donne dans la zone \"Search string\"\n");
	return;
    }
    if ($winMain::replace_string eq "") {
	&mkPrintErreur("ERREUR : Aucune balise de fin de zone donne dans la zone \"Replace string\"\n");
	return;
    }
    if (!open(FIC,"$winMain::nom_fic")) {
	&mkPrintErreur("ERREUR : Impossible d\'ouvrir '$winMain::nom_fic'\n");
	return;
    }
    if (!open(FIC2,">MKC-tmp_extractregion.txt")) {
	&mkPrintErreur("ERREUR : Impossible d\'ouvrir MKC-tmp_extractregion.txt\n");
	return;
    }

    my $start = $winMain::search_string;
    my $end = $winMain::replace_string;
    my $extracting = $FALSE;
    while (<FIC>) {
	if ($extracting) {
	    if (/$end/) {
		$extracting = $FALSE;
	    };
	    print FIC2 $_;
	} 
	else {
	    if (/$start/) {
		$extracting = $TRUE;
		print FIC2 $_;
		if (/$end/) {
		    $extracting = $FALSE;
		}
	    }
	}
    }

    close(FIC);
    close(FIC2);
    my $tmpfile="MKC-tmp_extractregion.txt";
    my $msg="MKC-tmp_extractregion.txt";
    &IncludedFileInWindow($tmpfile,$msg);

}

#---------------------------------------------------------------------------------------
sub webfix {
&UpdateIndicators2;
    use LWP::Simple;
    use URI::URL;

    if ($winMain::search_string eq "") {
	&mkPrintErreur("ERREUR : Aucune slection de chane de recherche donne dans la zone \"Search string\"\n");
	return;
    }

    &loadSplashWindow;

    if (Exists ($pn1)) {$pn1->destroy()};
    if (! Exists ($pn1)) {
	
	$pn1 = $winMain::mw ->Toplevel();
	$pn1->title("WEBFIF");
	$pn1->withdraw;
	my $label = $pn1->Label( -background => 'black',
				  -foreground =>  'white', -anchor => 'w' );
	my $texte = $pn1->Scrolled("MarkupTools")->pack(-side => 'bottom',
						     -fill => 'both',
						     -expand => 1);

	$texte->Text(-setgrid => 'true');
	&updateMarkupWindow($texte,$label);
	$pn1->Button(-text => "Close",
		     -command =>  sub {$pn1->destroy()})->pack(-side => 'top', -pady => 5, -padx => 10);

	my $msg="WEBFIX \n";
	$msg.="Ludovic Tanguy\n";
	$msg.="ERSS - Universit de Toulouse Le Mirail\n";
	$msg.="E-mail : Ludovic.Tanguy\@univ-tlse2.fr\n";
	$msg.="LICENCE : \n";
	$msg.="WEBFIX est diffus sous la Licence Publique Gnrale (GPL) et peut\n";
	$msg.="tre librement diffus et modifi. Voir les fichiers gpl.txt et\n";
	$msg.="gpl-francais.txt\n--------------------------\n\n";
	$texte->insert('end',$msg);
	
	if (!open(FIC,">MKC-tmp_resultwebfix.txt")) {
	    &mkPrintErreur("ERREUR : Impossible d\'ouvrir MKC-tmp_resultwebfix.txt\n");
	    return;
	}

	
	my $LANG="fr";
	my $suffixe=$winMain::search_string;
	my $suffixesansaccents=$suffixe;
	my $DICOFILE = "Dico/dico-fr.txt";
	$texte->insert('end', "Pas de prise en compte des accents\n");
	print FIC "Pas de prise en compte des accents\n";
	$texte->insert('end', "Filtrage des mots en \"$suffixe\" du dictionnaire $DICOFILE\n" );
	print FIC "Filtrage des mots en \"$suffixe\" du dictionnaire $DICOFILE\n";
	
	
	my %frequent=();
	open(IN, "<$DICOFILE") or die "Fichier introuvable : $DICOFILE ($!)\n";
#-------SPLASH REFRESH
	&splashProgress( "Work In Progress...", 25 );
#-------SPLASH REFRESH
	while(<IN>){
	    unless ($_ =~/ /){
		chomp;
		my $sansaccents =$_;
		$sansaccents =~tr//aaaeeeeiioouuuc/;
		if (m/$suffixe$/oi || ($sansaccents =~m/$suffixesansaccents$/oi )){
		    my $pref=substr($_, 0, 3);
	    $_=~tr//aaaeeeeiioouuuc/;
		    $frequent{$pref}.=" -$_" unless $frequent{$pref}=~/\-$_\b/;
		}
	    }
	}
    
	foreach (sort keys %frequent){
	    print FIC $_,"\t",$frequent{$_},"\n";
	}
	
	print FIC "Chargement de la liste des prfixes\n";
#-------SPLASH REFRESH
	&splashProgress( "Work In Progress...", 80 );
#-------SPLASH REFRESH
	my $PREFIXFILE = "Dico/prefixe.txt";
	
	my @MotsCles;
	
	open (IN, "<$PREFIXFILE") or die "Fichier introuvable : $PREFIXFILE ($!)\n";
	while(<IN>){
	    chomp;
	push @MotsCles, $_ unless ($_ =~/^[\#\>]/);}
	
	close IN;
	
	print FIC "Dbut de la recherche\n";
	print FIC "Pas de recherche des mots en majuscules\n";
	
	foreach my $MotCle(@MotsCles){ 
	    print FIC "$MotCle\n";
#-------SPLASH REFRESH
	    &splashProgress( "Work In Progress...", 50 );
#-------SPLASH REFRESH
	    &LanceWEBFIX($MotCle,$suffixe,\%frequent);
	}
	
	my $tmpfile="MKC-tmp_resultwebfix.txt";
	my $msg="MKC-tmp_resultwebfix.txt";
	&IncludedFileInWindow($tmpfile,$msg);


	$pn1->deiconify;
	$pn1->raise;
    }

    &removeSplashWindow;
}

#---------------------------------------------------------------------------------------
sub LanceWEBFIX {
&UpdateIndicators2;
    if (!open(FIC,">>MKC-tmp_resultwebfix.txt")) {
	&mkPrintErreur("ERREUR : Impossible d\'ouvrir MKC-tmp_resultwebfix.txt\n");
	return;
	}
    my ($MotCle,$suffixe,$freq) = @_;
    my %frequent= %$freq;
    my $url = url('http://www.altavista.com/cgi-bin/query');
    my $result="";
    $url->query_form(
		     q=>"$MotCle*****$suffixe ".$frequent{$MotCle},
		     kl=>"fr",
		     pg=>'q',
		     wt=>'y',
		     Translate=>'on',
		     );

    if (defined (my $contenu = get $url)) {
#	print $contenu;
	if ($contenu =~/We found (about )?(.*?) results?/i){
	    $result=$2;
	    $result=~s/[,\. ]//g;
	}
	elsif ($contenu =~/AltaVista found no document matching your query/i)
	{$result=0;}
	else {warn "Problme de la part d'AltaVista !\n";}
	my $secondpage;
	my $site;
	if ($result>0) {
	    print FIC "PREFIXE : $MotCle  ($result)\n";
	    print FIC "ATTESTATIONS : ",$frequent{$MotCle},"\n" if $frequent{$MotCle};
	   	    
	    if ($contenu =~/<a href=\"(.*?)\" target=\"_self\">\[Next \&gt\;\&gt\;\]\<\/a\>/){
		$secondpage = "http://www.altavista.com$1";
	    }
	    else {$secondpage="";}
	    
	    while ($contenu =~/r=(http:\/\/.*?)\"/){
		$contenu=$';
		$site=$1;
		if (defined (my $page = get $1)){
		    while ($page =~/\b($MotCle(\w|\-)*$suffixe)/g){
			print FIC "$1\t$site\n" unless $frequent{$MotCle}=~/\-$1/i;}
		}
	    }	    
	    if ($secondpage){
		if (defined (my $contenu = get $secondpage)) {
		    
		    while ($contenu =~/r=(http:\/\/.*?)\"/){
			$contenu=$';
			$site=$1;
			if (defined (my $page = get $1)){
				while ($page =~/\b($MotCle(\w|\-)*$suffixe)/g){
				    print FIC "$1\t$site\n" unless $frequent{$MotCle}=~/\-$1/i;}
			    }
		    }
		}		
	    }
	}
    }
    close(FIC);
}

#---------------------------------------------------------------------------------------
sub helpwebfix {
&UpdateIndicators2;
    if (! Exists ($pn1)) {
	$pn1 = $winMain::mw ->Toplevel();
	$pn1->title("HELP");
	my $label = $pn1->Label( -background => 'black',
				  -foreground =>  'white', -anchor => 'w' );
	my $texte2 = $pn1->Scrolled("MarkupTools")->pack(-side => 'bottom',
				      -fill => 'both',
				      -expand => 1);

	$texte2->Text(-setgrid => 'true');
	&updateMarkupWindow($texte2,$label);
	my $tmpfile="Doc/help_webfix.txt";
	$texte2->IncludeFile($tmpfile);

	$pn1->Button(-text => "Close",
		     -command =>  sub {$pn1->destroy()})->pack(-side => 'top', -pady => 5, -padx => 10);

	my $w_save=$pn1->Button(-text => "Save",
		     -image => $imageSave,
		     -command => sub {$texte2->FileSaveAsPopup()})->pack(-side => 'top', -pady => 5, -padx => 10);
	$winMain::winBalloon->attach($w_save,
			    -balloonmsg => "Save"
			    );

    }
    else {
	$pn1->deiconify();
	$pn1->raise();
    }
}

#---------------------------------------------------------------------------------------
sub bigrammesUniques2Distance {
&UpdateIndicators2;

    if (!open(FIC,"$winMain::nom_fic")) {
	&mkPrintErreur("ERREUR : Impossible d\'ouvrir '$winMain::nom_fic'\n");
	return;
    }
    if (!open(FIC2,">MKC-tmp_bigrammesUniques2Distance.txt")) {
	&mkPrintErreur("ERREUR : Impossible d\'ouvrir MKC-tmp_bigrammesUniques2Distance.txt\n");
	return;
	
    }
    print FIC2 "<indice de Dice> <nombre de bigrammes partags> <nombre de bigrammes mot1 seulement> <nombre de bigrammes mot2 seulement>  <mot1> <mot2> <bigrammes mot1> <bigrammes mot2>\n\n";
    close(FIC2);
    @ListeBigrammesMot1 =();
    @ListeBigrammesMot2 =();
    my @Mots                    = () ;
    my @BigrammesUniques        = () ;
    my $MinimumBigrammesUniques = 2 ;
    my @ListeBigrammes = ();
    my $Ligne;

# Mmorisation de tous les mots et de tous les bigrammes uniques

    while ($Ligne =<FIC>){
	$Ligne =~ /([^\t]+)\t(.*)/ ;
	my $Mot = $1 ;
	my $ChaineDeBigrammes = $2 ;
	@ListeBigrammes = split(/ /, $ChaineDeBigrammes) ;
	push(@Mots, $Mot) ;
	# La liste de bigrammes est mmorise comme une liste, 
	# pour ne pas avoir  la redcomposer  chaque comparaison.
	push(@BigrammesUniques, [ @ListeBigrammes ]) ;
    }

# Pour chaque mot, calcul de la distance de ses bigrammes uniques 
# avec les bigrammes uniques de TOUS les autres mots
# Condition : chacun des mots compars a au moins le
# nombre minimal requis de bigrammes uniques.

    for (my $i = 0 ; $i <= $#Mots ; $i++) {
	@ListeBigrammesMot1 = @{ $BigrammesUniques[$i] } ;
	for (my $j = $i + 1 ; $j <= $#Mots ; $j++) {
	    @ListeBigrammesMot2 = @{ $BigrammesUniques[$j] } ;
	    if ($#ListeBigrammesMot1 > $MinimumBigrammesUniques 
		&& 
		$#ListeBigrammesMot2 > $MinimumBigrammesUniques) {
		DistanceEntreBigrammes() ;
		if (!open(FIC2,">>MKC-tmp_bigrammesUniques2Distance.txt")) {
		    &mkPrintErreur("ERREUR : Impossible d\'ouvrir MKC-tmp_wordPosition.txt\n");
		    return;
		}
		print FIC2 "\t$Mots[$i]\t$Mots[$j]\t@ListeBigrammesMot1\t@ListeBigrammesMot2\n" ;
		close (FIC2)
	    }
	}
    }
    close (FIC);
#    close (FIC2);
    my $tmpfile="MKC-tmp_bigrammesUniques2Distance.txt";
    my $msg="MKC-tmp_bigrammesUniques2Distance.txt";
    &IncludedFileInWindow($tmpfile,$msg);

}

#---------------------------------------------------------------------------------------
sub DistanceEntreBigrammes{ 
&UpdateIndicators2;
    if (!open(FIC2,">>MKC-tmp_bigrammesUniques2Distance.txt")) {
	&mkPrintErreur("ERREUR : Impossible d\'ouvrir MKC-tmp_wordPosition.txt\n");
	return;
    }

# Un dictionnaire Bigramme / Emploi stocke les correspondances : 
#  1 - employ dans mot1 seulement ;
#  2 - employ dans mot1 et mot2 ;
#  0 - employ dans mot2 seulement.
# Le total de chacun des cas permet de calculer l'indice de Dice.
    my %Bigramme2Emploi = () ;
    for (my $k = 0 ; $k <= $#ListeBigrammesMot1 ; $k++) {
	$Bigramme2Emploi{$ListeBigrammesMot1[$k]} = 1 ;
    }
    for (my $l = 0 ; $l <= $#ListeBigrammesMot2 ; $l++) {
	if (exists $Bigramme2Emploi{$ListeBigrammesMot2[$l]}) {
	    $Bigramme2Emploi{$ListeBigrammesMot2[$l]} = 0 ; 
	}
	else {
	    $Bigramme2Emploi{$ListeBigrammesMot2[$l]} = 2 ; 
	}
    }
    my $BigrammesMot1Seulement = 0 ;
    my $BigrammesMot2Seulement = 0 ;
    my $BigrammesPartages = 0 ;
    for my $Bigramme (keys %Bigramme2Emploi) {
	if ($Bigramme2Emploi{$Bigramme} == 0) { 
	    $BigrammesPartages++ ; 
	}
	if ($Bigramme2Emploi{$Bigramme} == 1) { 
	    $BigrammesMot1Seulement++ ; 
	}
	if ($Bigramme2Emploi{$Bigramme} == 2) { 
	    $BigrammesMot2Seulement++ ; 
	}
    }
    my $IndiceDice;
    if (($BigrammesMot1Seulement + $BigrammesMot2Seulement) > 0) {
	$IndiceDice = ($BigrammesPartages * 2)/ ($BigrammesMot1Seulement + $BigrammesMot2Seulement) ; 
    }
    else {
	$IndiceDice = 0 ; 
    }
    printf FIC2 "%1.2f\t", $IndiceDice ;
    print FIC2 "$BigrammesPartages $BigrammesMot1Seulement $BigrammesMot2Seulement\t" ;

    close (FIC2);
}


#---------------------------------------------------------------------------------------
sub help_bigramChar {
&UpdateIndicators2;
    if (! Exists ($pn1)) {
	$pn1 = $winMain::mw ->Toplevel();
	$pn1->title("HELP");
	my $label = $pn1->Label( -background => 'black',
				  -foreground =>  'white', -anchor => 'w' );
	my $texte2 = $pn1->Scrolled("MarkupTools")->pack(-side => 'bottom',
				      -fill => 'both',
				      -expand => 1);

	$texte2->Text(-setgrid => 'true');
	&updateMarkupWindow($texte2,$label);
	my $tmpfile="Doc/helpBigramChar.txt";
	$texte2->IncludeFile($tmpfile);

	$pn1->Button(-text => "Close",
		     -command =>  sub {$pn1->destroy()})->pack(-side => 'top', -pady => 5, -padx => 10);

	my $w_save=$pn1->Button(-text => "Save",
		     -image => $winMain::imageSave,
		     -command => sub {$texte2->FileSaveAsPopup()})->pack(-side => 'top', -pady => 5, -padx => 10);
	$winMain::winBalloon->attach($w_save,
			    -balloonmsg => "Save"
			    );

    }
    else {
	$pn1->deiconify();
	$pn1->raise();
    }
}

#---------------------------------------------------------------------------------------
sub makeIndex {
&UpdateIndicators2;

    if (!open(FIC,"$winMain::nom_fic")) {
	&mkPrintErreur("ERREUR : Impossible d\'ouvrir '$winMain::nom_fic'\n");
	return;
    }
    if (!open(DIC1,">MKC-tmp_index.txt")) {
	&mkPrintErreur("ERREUR : Impossible d\'ouvrir MKC-tmp_wordPosition.txt\n");
	return;
    }
    my %dico1=();
    my $i = 0;
    my $Ligne = 0;
    my %Lignes=();
    my @Mots=();

  READ: while(<FIC>)
  {  
      #saute les lignes vides
      next READ if (/^$/);
      s/[\(\)\[\]\"]//g;	
# nettoyage
      s/,/ ,/g;		
# on isole les ,
      chop;
      $Ligne++;
      $Lignes[$Ligne] = $_ ;
      @Mots = split(/[\[\"\{\}&~\@=*?!;,():<>%\' \+_\/.-]+/);
      for my $mot (@Mots) {
	  $mot =~ /\D/ or next ;
	  print "$mot \n";
	  if (! exists $dico1{$mot}) {
	      $dico1{$mot}++;
	  }
      }
  }
    
    print "Lecture/Ecriture dico1 \n";
    foreach my $mot (keys %dico1)
    {
	print "mot in dico1 : $mot\n";
	print DIC1 "$mot\n";
    }
    close(DIC1);
    close(FIC);
    my $tmpfile="MKC-tmp_index.txt";
    my $msg="MKC-tmp_index.txt";
    &IncludedFileInWindow($tmpfile,$msg);
    
}

#---------------------------------------------------------------------------------------
sub mots2Distance {
&UpdateIndicators2;
    
    system("cp $winMain::nom_fic MKC-tmp_index-trie-full.txt");
    system("perl Program/Mot2BigrammesUniques.pl < MKC-tmp_index-trie-full.txt | perl Program/BigrammesUniques2Distance.pl | sort -n -r > MKC-tmp_tmpmots2distances.txt ");
    my $tmpfile="MKC-tmp_tmpmots2distances.txt";
    my $msg="MKC-tmp_tmpmots2distances.txt";
    &IncludedFileInWindow($tmpfile,$msg);

}


#---------------------------------------------------------------------------------------
sub mots2BigramUniques {
&UpdateIndicators2;
    if (!open(FIC,"$winMain::nom_fic")) {
	&mkPrintErreur("ERREUR : Impossible d\'ouvrir '$winMain::nom_fic'\n");
	return;
    }
    if (!open(FIC1,">MKC-tmp_mots2BigramUniques.txt")) {
	&mkPrintErreur("ERREUR : Impossible d\'ouvrir MKC-tmp_wordPosition.txt\n");
	return;
    }
    my $Ligne;
    my $Mot;
    my @ListeLettres =();
    while ($Ligne =<FIC>){
	$Mot = $Ligne ;
	chop($Mot) ;
	@ListeLettres = split(//, $Mot) ;
	print FIC1 "$Mot\t" ;
	# Pour chaque lettre successive du mot, impression de cette lettre, de la suivante et d'un blanc
	for (my $i = 0 ; $i < $#ListeLettres ; $i++) {
	    print FIC1 "$ListeLettres[$i]$ListeLettres[$i+1] " ;
	}
	print FIC1 "\n" ;
    }
    close(FIC);
    close(FIC1);
    my $tmpfile="MKC-tmp_mots2BigramUniques.txt";
    my $msg="MKC-tmp_mots2BigramUniques.txt";
    &IncludedFileInWindow($tmpfile,$msg);
}


#---------------------------------------------------------------------------------------
sub mkTrigramWord {
&UpdateIndicators2;

    if (!open(FIC,"$winMain::nom_fic")) {
	&mkPrintErreur("ERREUR : Impossible d\'ouvrir '$winMain::nom_fic'\n");
	return;
    }
    if (!open(FIC2,">MKC-tmp_trigram.txt")) {
    &mkPrintErreur("ERREUR : Impossible d\'ouvrir MKC-tmp_trigram.txt\n");
    return;
	}

    while (<FIC>) {

	# remove parens and tokenize
	s/\(/ /g;
	s/\)/ /g;
	@token = split;

	# count trigrams
	for($i=0; $i < @token - 2; $i++) {
	    $count{"$token[$i] $token[$i+1] $token[$i+2]"}++;
	};
    };

# output
    while (($key, $value) = each %count) {
        print FIC2 "$value $key\n";
    };

    close(FIC);
    close(FIC2);
    my $tmpfile="MKC-tmp_trigram.txt";
    my $msg="MKC-tmp_trigram.txt";
    &IncludedFileInWindow($tmpfile,$msg);

}

#---------------------------------------------------------------------------------------
sub mkBigramWord {
&UpdateIndicators2;
#program: bigramcount - counts the number of bigrams in a text,
#                        prints them out in order of decreasing frequency

    if (!open(FIC,"$winMain::nom_fic")) {
	&mkPrintErreur("ERREUR : Impossible d\'ouvrir '$winMain::nom_fic'\n");
	return;
    }
    if (!open(FIC2,">MKC-tmp_bigram.txt")) {
    &mkPrintErreur("ERREUR : Impossible d\'ouvrir MKC-tmp_bigram.txt\n");
    return;
	}


    while(<FIC>) {
	chop;
	tr/A-Z/a-z/;
	tr/.,:;!?\"(){}//d;
	foreach $word1 (split) {
	    $bigram = "$word2 $word1";  
	    $word2  = $word1;          
	    $count{$bigram}++;         
	}
    }
    foreach $bigram (sort numerically keys %count) { 
	print FIC2 "$count{$bigram} $bigram\n";               
    }
        close(FIC);
    close(FIC2);
    my $tmpfile="MKC-tmp_bigram.txt";
    my $msg="MKC-tmp_bigram.txt";
    &IncludedFileInWindow($tmpfile,$msg);
   
}
#-------------------------------------------
sub numerically {                    # compare two words numerically
&UpdateIndicators2;
   $count{$b} <=> $count{$a};        # decreasing order
   # $count{$b} <=> $count{$a};      # increasing order
}
#-------------------------------------------
sub mkFourgramWord {
&UpdateIndicators2;
########################################################################
# Tallies 4-grams in each line
########################################################################

    if (!open(FIC,"$winMain::nom_fic")) {
	&mkPrintErreur("ERREUR : Impossible d\'ouvrir '$winMain::nom_fic'\n");
	return;
    }
    if (!open(FIC2,">MKC-tmp_fourgram.txt")) {
    &mkPrintErreur("ERREUR : Impossible d\'ouvrir MKC-tmp_fourgram.txt\n");
    return;
	}
    while (<FIC>) {
	# remove parens and tokenize
	s/\(/ /g;
	s/\)/ /g;
	@token = split;
	# count 4-grams
	for($i=0; $i < @token - 3; $i++) {
		$count{"$token[$i] $token[$i+1] $token[$i+2] $token[$i+3]"}++;
	};
};
# output
while (($key, $value) = each %count) {
        print FIC2 "$value $key\n";
}
    close(FIC);
    close(FIC2);
    my $tmpfile="MKC-tmp_fourgram.txt";
    my $msg="MKC-tmp_fourgram.txt";
    &IncludedFileInWindow($tmpfile,$msg);
   
}
#-----------------------------------------------
sub mkWordCount {
&UpdateIndicators2;
    if (!open(FIC,"$winMain::nom_fic")) {
	&mkPrintErreur("ERREUR : Impossible d\'ouvrir '$winMain::nom_fic'\n");
	return;
    }
    if (!open(FIC2,">MKC-tmp_wordcount.txt")) {
    &mkPrintErreur("ERREUR : Impossible d\'ouvrir MKC-tmp_wordcount.txt\n");
    return;
	}
    while(<FIC>) {
	chop;                
	tr/A-Z/a-z/;             # convert to lower case
	tr/.,:;!?\"(){}//d;       
# strip out punctuation
	foreach $word (split) {  
# split line into words 
	    $count{$word}++;     # count words, put count into hash (word is key, count is value)
	}
    }
    foreach $word (sort keys %count) {   # sort hash by the value of the key
	print FIC2 "word:<$word>\tcount:<$count{$word}>\n";    # print out the hash in key order
    }
    close(FIC);
    close(FIC2);
    my $tmpfile="MKC-tmp_wordcount.txt";
    my $msg="MKC-tmp_wordcount.txt";
    &IncludedFileInWindow($tmpfile,$msg);
}
#-----------------------------------------------
sub mkCollocate {
&UpdateIndicators2;
# program: collocate - 
# Creates a KWIC (key word in context) listing of collocations,
# aligning the context around the word in the center.
#
# Such KWIC listings are found in books like 
# Sinclair (1991) Corpus, Concordance, Collocation. (Oxford) 
# The program reads in a file, finds all instances of a word
# along with the context of the word, i.e. 4 words to the right
# (the right context or $right) and 4 words to the left of the 
# word (the left context or $left)and then prints the word out 
# in context centered around the word. 
# 
# The tricky part:
# To center the left and right contexts around the word the program 
# has to find the maximum length of all left contexts and then right 
# align each left context in a string of spaces equal to this maximum length.
# 


if ($winMain::search_string eq "") {
	    &mkPrintErreur("ERREUR : Aucune slection de chane de recherche donne dans la zone \"Search string\"\n");
	    return;
	}

my $word = $winMain::search_string;
if (!open(FILE,"$winMain::nom_fic")) {
	&mkPrintErreur("ERREUR : Impossible d\'ouvrir '$winMain::nom_fic'\n");
	return;
    }
if (!open(FIC2,">MKC-tmp_collocate.txt")) {
    &mkPrintErreur("ERREUR : Impossible d\'ouvrir MKC-tmp_collocate.txt\n");
    return;
	}

my @lines=();
@lines = <FILE>;
my $lines = join("",@lines);
$lines =~ s/\n/ /g;
$lines =~ s/\r/ /g;

@words=();
@contexts3=();

@words = ($lines =~ /(\S+)\s+/gi);     

my $max = 0;
for ($i = 0; $i < @words; $i++) {
   if ($words[$i] eq $word) {
      my @collocates = ();
      push(@collocates,&collocate(\@words,$i,-4));
      push(@collocates,&collocate(\@words,$i,-3));
      push(@collocates,&collocate(\@words,$i,-2));
      push(@collocates,&collocate(\@words,$i,-1));
      push(@collocates,&collocate(\@words,$i,0));
      push(@collocates,&collocate(\@words,$i,1));
      push(@collocates,&collocate(\@words,$i,2));
      push(@collocates,&collocate(\@words,$i,3));
      push(@collocates,&collocate(\@words,$i,4));
      my $left   = join(" ", splice(@collocates,0,4));
      my $middle = splice(@collocates,0,1);
      my $right  = join(" ", splice(@collocates,0,4));
      my @tmp = ($left,$middle,$right);
      push(@contexts3,[ @tmp ]);
      $max = (length($left) > $max) ? length($left) : $max;
   }
}

# create a string filled with blanks equal to the max left context
my $dummy = "";
for ($i=1; $i < $max; $i++) { 
   $dummy .= " ";
} 

# |<-----$remainder------->|<---------------$lenleft----------->|
# |<---------------------------$max---------------------------->|
foreach $context (@contexts3) {
   $lenleft = length($context->[0]);
   $remainder = $max - $lenleft;
   $spacer = $dummy;
   substr($spacer,$remainder,$lenleft) = substr($context->[0],0,$lenleft);
   print FIC2 "$spacer   $context->[1]   $context->[2]\n";
}
FINIS: print "\nEnd of Program\n";
close(FILE);
close(FIC2);
    my $tmpfile="MKC-tmp_collocate.txt";
    my $msg="MKC-tmp_collocate.txt";
    &IncludedFileInWindow($tmpfile,$msg);
}


#-----------------------------------------------
sub mkCollocations {
    &UpdateIndicators2;
# Markus Dreyer
# 28.08.2000
# Kollokationen finden
    if (!open(F,"$winMain::nom_fic")) {
	&mkPrintErreur("ERREUR : Impossible d\'ouvrir '$winMain::nom_fic'\n");
	return;
    }
    if (!open(FIC2,">MKC-tmp_collocations.txt")) {
    &mkPrintErreur("ERREUR : Impossible d\'ouvrir MKC-tmp_collocate.txt\n");
    return;
	}
    my $debug = 0; 
    my @offsets;
# Debug-Meldungen ein- oder ausschalten
    my $leftRight = 4; 
# immer je $leftRight Wrter nach links und nach rechts. Fenstergre ist somit $leftRight * 2 + 1
    my $begin = time();
    my $typeCnt  = 0;  
# hier werden die Types des Korpus gezhlt
### File Zeile fr Zeile einlesen ###

    my $lineCnt = 0;
    while(my $line = <F> ){
	next if(substr($line, 0, 2) eq "%%");
	print FIC2 "Processing line $lineCnt... (elapsed: ", (time() - $begin), "sec)\n" if( $lineCnt % 1000 == 0);
	$line =~ s/^\s+[0-9]+:\s+//;
	my @tokens = split( /\s+/, $line );
	### Schleife ber jeden Token im Satz ###
	for(my $i = 0; $i <= $#tokens; $i++){
	    dbg("$tokens[$i]\n");
	    ### Fenster, das rechten und linken Kontext eines jeden Tokens betrachtet ###
	    for(my $j = ($i - $leftRight); $j <= ($i + $leftRight); $j++ ){
		$j = 0 if( $j < 0 );
		last if( $j > $#tokens );
		dbg("\t" . $tokens[$j] . " (" . ($j - $i) . ")\n");
		registerType( $tokens[$j] );
		push(
		     @{		# als Array interpretierter ...
			 ${ $offsets[ $typesCollocations{ $tokens[$i] }]  }{$typesCollocations{ $tokens[$j] }} # ... Wert des doppelten Hashs
		 }
		,
		$j - $i 
		    )
		if($j - $i != 0);
	}
	dbg("\n");
    }
    $lineCnt++;	
    last if($lineCnt == 2000);
}
close F;


### Errechnen und ausgeben: mean offset und standard deviation ###
my $token1Nr = 0;
foreach my $hashRef ( @offsets ){
    foreach my $token2Nr ( keys %{$hashRef} ){
	print FIC2 "$numbersCollocations[$token1Nr]\t$numbersCollocations[$token2Nr]\t\t";	
	my @offsetsForToken1AndToken2 = @{ ${ $offsets[$token1Nr] }{ $token2Nr } };
    dbg("( ");
    foreach(@offsetsForToken1AndToken2){
	dbg("$_ ");
    }
    dbg(") ");
    my $meanTmp = mean( @offsetsForToken1AndToken2 );
    $meanTmp = sprintf("%.3f", $meanTmp); # auf 3 Stellen runden
    my $devTmp = stdDev( \@offsetsForToken1AndToken2, $meanTmp );
    $devTmp = sprintf("%.3f", $devTmp) if(defined $devTmp);
    
    # Die Ergebnisse knnte man wieder speichern:
    #${$means{$token1Nr}}{$token2Nr} = $meanTmp;
    #${$stdDev{$token1Nr}}{$token2Nr} = $devTmp;
    
    my $cntTmp = $#offsetsForToken1AndToken2 + 1;
    print FIC2 "CNT = $cntTmp\t";
    print FIC2 "MEAN = $meanTmp";
    print FIC2 "\tDEV = $devTmp", (($cntTmp > 2 && $devTmp <= 1)?(" !!!"):(""))
	if( defined $devTmp );
    print FIC2 "\n";
}
$token1Nr++;
}
close(F);
close(FIC2);
my $tmpfile="MKC-tmp_collocations.txt";
my $msg="MKC-tmp_collocations.txt";
&IncludedFileInWindow($tmpfile,$msg);


#########################################################################
### mean offset (Mittlerer Abstand) ausrechnen
### Parameter: Einen Array, der alle Abweichungen enthlt, (-1, 3, 2, -2)
#########################################################################
sub mean{
	my @offsets = @_;
	my $sum = 0;
	foreach (@offsets){
		$sum += $_;		
	}
	return ($sum / (($#offsets > 0)?($#offsets + 1):(1)));
}

######################################################################
### standard deviation ausrechnen
### Parameter: Einen Array, der alle Abweichungen enthlt und die mean-offset-Zahl
######################################################################
sub stdDev{
	my ($offsetsRef, $meanOffset) = @_;
	my @offsets = @$offsetsRef;
	return undef if( $#offsets == 0 ); # nur ein Element
	my $stdDev = 0;
	foreach $offset (@offsets){
		$stdDev += (($offset - $meanOffset) * ($offset - $meanOffset));
	}
	return sqrt( $stdDev / $#offsets );
}

######################################################################
# Type neu in den Hash eintragen: Jeder Type bekommt 'ne eigene Nummer 
######################################################################
sub registerType{
	my $w = shift;
	unless(defined $typesCollocations{$w} ){
		$typesCollocations{$w} = $typeCnt++;
		push (@numbersCollocations, $w);
	}
}

###################################################################
### dbg() - Einfache Info-Messages ber den Programmablauf ausgeben
###################################################################
sub dbg{
    $debug && print shift; # Ausgabe nur, wenn $debug wahr.
}


}
#-----------------------------------------------
sub collocate {
    &UpdateIndicators2;
   my($words,$i,$delta) = @_;
   my($target);
   # check bounds
   $target = $i + $delta;
   if (($target < 0) || ($target > @words - 1)) {
      #print "out of bounds\n";
      return "";
   } 
   #print "in bounds: $words->[$target]\n";
   return $words->[$target];
}
#------------------------------------------------
sub concordanceFormat {
&UpdateIndicators2;
$concordance_TOP  =
'Mot         nLigne # Extrait Contenu Ligne
';
    $concordance_subform =
'@<<<<<<<<<<< @>>>>> @<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<                  ';
#'@<<<<<<<<<<< @>>>>> @<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<                  ';
    my($Mot, %Exclude);
#for $Mot ("un", "le", "la", "une", "les") {
#    $Exclude{$Mot} = 1;
#}
    my(@Mots,$Mot,%Concord);
    my($Ligne) = 0;
    if (!open(FIC,"$winMain::nom_fic")) {
	&mkPrintErreur("ERREUR : Impossible d\'ouvrir '$winMain::nom_fic'\n");
	return;
    }
  READ: while(<FIC>)
{  
   #saute les lignes vides
   next READ if (/^$/);
   s/[ ]+/ /g;
   chop;
   $Ligne++;
   $::Lignes[$Ligne] = $_ ;
   @Mots = split(/[\[\"\{\}&~\@=*?!;,():<>%\' \+_\/.-]+/);
#      @Mots = split(/\W+/);
   for $Mot (@Mots) {
        $Mot =~ /\D/ or next ;
        $Exclude{"\L$Mot "} and next ;
        push(@{$Concord{$Mot}},$Ligne);
       }
}
if (!open(FIC2,">MKC-tmp_concordanceformat.txt")) {
    &mkPrintErreur("ERREUR : Impossible d\'ouvrir MKC-tmp_concordanceformat.txt\n");
    return;
	}
formline($concordance_TOP);
for $::Mot (sort keys %Concord) {
    for $::Ligne (@{$Concord{$::Mot}})
    {
#	formline($concordance_subform, $::Ligne);
	formline($concordance_subform, $::Mot,$::Ligne, $::Lignes[$ ::Ligne]);
	print FIC2 $ACCUMULATOR, "\n";
	$ACCUMULATOR = '';
	$::Mot = "";
    }
}
    close(FIC2);
    close(FIC);
    my $tmpfile="MKC-tmp_concordanceformat.txt";
    my $msg="MKC-tmp_concordanceformat.txt";
    &IncludedFileInWindow($tmpfile,$msg);
}
#---------------------------------------------
sub mkConcordanceOneWord2 {
&UpdateIndicators2;
    if ($winMain::search_string eq "") {
	    &mkPrintErreur("ERREUR : Aucune slection de chane de recherche donne dans la zone \"Search string\"\n");
	    return;
	}
    $mkTextConcordance->destroy if Exists($mkTextConcordance);
    $mkTextConcordance = $winMain::mw->Toplevel();
    my $w = $mkTextConcordance;
    $w->title('Concordance');
    $w->iconname('Text Concordance');
    my $w_ok = $w->Button(-text => 'OK', -width => 8, -command => ['destroy', $w]);
    my $w_t = $w->TextUndo(-setgrid => 'true', -width => '60', -height => '28',
			-font => '-Adobe-Helvetica-Bold-R-Normal--*-120-*-*-*-*-*-*');
    my $w_save = $w->Button(-text => "Save",
			    -image => $winMain::imageSave,
			    -command => sub {$w_t->FileSaveAsPopup()})->pack(-side => 'top', -pady => 5, -padx => 10);
    $winMain::winBalloon->attach($w_save,
			-balloonmsg => "Save"
			);

    my $w_s = $w->Scrollbar(-command => ['yview', $w_t]);
    $w_t->configure(-yscrollcommand => ['set', $w_s]);
    $w_ok->pack(-side => 'top', -pady => 5, -padx => 10);
    $w_s->pack(-side => 'right', -fill => 'y');
    $w_t->pack(-expand => 'yes', -fill => 'both');
    # Set up display styles
    my(@bold, @normal, $tags);
    if ($mkTextConcordance->depth > 1) {
	@bold = (-foreground => 'red');
	@normal = (-foreground => undef);
    } else {
	@bold = (-foreground => 'white', -background => 'black');
	@normal = (-foreground => undef, -background => undef);
    }
    if (!open(FIC,"$winMain::nom_fic")) {
	$w_t->insert("end","ERREUR : Impossible d\'ouvrir '$winMain::nom_fic'\n");
	return;
    }
    $w_t->insert('0.0', 'Rsultats Concordance...');
    $w_t->insert("end","\n\n");
    my %Lignes=();
    my %Concord=();
    my $Ligne = 0;
    my @Mots=();
  READ: while(<FIC>)
  {  
      #saute les lignes vides
      next READ if (/^$/);
      s/[ ]+/ /g;
      chop;
      $Ligne++;
      $Lignes[$Ligne] = $_ ;
      @Mots = split(/[\[\"\{\}&~\@=*?!;,():<>%\' \+_\/.-]+/);
#      @Mots = split(/\W+/);
      for $Mot (@Mots) {
	  $Mot =~ /\D/ or next ;
	$Mot =~ /$winMain::search_string/ or next ;
	  push(@{$Concord{$Mot}},$Ligne);
      }
  }
    for $Mot (sort keys %Concord) {
	$w_t->insert("end","-------------------------------------------------\n");
	$w_t->insert("end","Mot : $Mot \n");
	for $Ligne (@{$Concord{$Mot}})
	{
            $w_t->insert("end","\tLigne n$Ligne: $Lignes[$Ligne]\n");
	}
	
    }
    close(FIC);
}
#---------------------------------------------
sub mkConcordanceOneWord {
&UpdateIndicators2;
    if ($winMain::search_string eq "") {
	    &mkPrintErreur("ERREUR : Aucune slection de chane de recherche donne\n");
	    return;
	}
$concordance_TOP  =
'Mot         nLigne # Extrait Contenu Ligne
';
    $concordance_subform =
'@<<<<<<<<<<< @>>>>> @<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<                  ';
    my($Mot, %Exclude);
#for $Mot ("un", "le", "la", "une", "les") {
#    $Exclude{$Mot} = 1;
#}
    my(@Mots,$Mot,%Concord);
    my($Ligne) = 0;

    if (!open(FIC,"$winMain::nom_fic")) {
	&mkPrintErreur("ERREUR : Impossible d\'ouvrir '$winMain::nom_fic'\n");
	return;
    }

  READ: while(<FIC>)
{  
   #saute les lignes vides
   next READ if (/^$/);
   s/[ ]+/ /g;
   chop;
   $Ligne++;
   $Lignes[$Ligne] = $_ ;
      @Mots = split(/[\[\"\{\}&~\@=*?!;,():<>%\' \+_\/.-]+/);
#      @Mots = split(/\W+/);
   for $Mot (@Mots) {
        $Mot =~ /\D/ or next ;
	$Mot =~ /$winMain::search_string/ or next ;
        $Exclude{"\L$Mot "} and next ;
        push(@{$Concord{$Mot}},$Ligne);
       }
}

if (!open(FIC2,">MKC-tmp_concordanceformat.txt")) {
    &mkPrintErreur("ERREUR : Impossible d\'ouvrir MKC-tmp_concordanceformat.txt\n");
    return;
	}
formline($concordance_TOP);
for $Mot (sort keys %Concord) {
    for $Ligne (@{$Concord{$Mot}})
    {
#	formline($concordance_subform, $Ligne);
	formline($concordance_subform, $Mot,$Ligne, $Lignes[$Ligne]);
	print FIC2 $ACCUMULATOR, "\n";
	$ACCUMULATOR = '';
	$Mot = "";
    }
}
    close(FIC2);
    close(FIC);
    my $tmpfile="MKC-tmp_concordanceformat.txt";
    my $msg="MKC-tmp_concordanceformat.txt";
    &IncludedFileInWindow($tmpfile,$msg);
}
#---------------------------------------------
sub mkConcordance {
&UpdateIndicators2;
    $mkTextConcordance->destroy if Exists($mkTextConcordance);
    $mkTextConcordance = $winMain::mw->Toplevel();
    my $w = $mkTextConcordance;
    $w->title('Concordance');
    $w->iconname('Text Concordance');
    my $w_ok = $w->Button(-text => 'OK', -width => 8, -command => ['destroy', $w]);
    my $w_t = $w->TextUndo(-setgrid => 'true', -width => '60', -height => '28',
			-font => '-Adobe-Helvetica-Bold-R-Normal--*-120-*-*-*-*-*-*');
    my $w_save = $w->Button(-text => "Save",
			    -image => $winMain::imageSave,
			    -command => sub {$w_t->FileSaveAsPopup()})->pack(-side => 'top', -pady => 5, -padx => 10);
    $winMain::winBalloon->attach($w_save,
			-balloonmsg => "Save"
			);

    my $w_s = $w->Scrollbar(-command => ['yview', $w_t]);
    $w_t->configure(-yscrollcommand => ['set', $w_s]);
    $w_ok->pack(-side => 'top', -pady => 5, -padx => 10);
    $w_s->pack(-side => 'right', -fill => 'y');
    $w_t->pack(-expand => 'yes', -fill => 'both');

    # Set up display styles

    my(@bold, @normal, $tags);
    if ($mkTextConcordance->depth > 1) {
	@bold = (-foreground => 'red');
	@normal = (-foreground => undef);
    } else {
	@bold = (-foreground => 'white', -background => 'black');
	@normal = (-foreground => undef, -background => undef);
    }

    if (!open(FIC,"$winMain::nom_fic")) {
	$w_t->insert("end","ERREUR : Impossible d\'ouvrir '$winMain::nom_fic'\n");
	return;
    }

    $w_t->insert('0.0', 'Rsultats Concordance...');
    $w_t->insert("end","\n\n");

    my %Lignes=();
    my %Concord=();
    my $Ligne = 0;
    my @Mots=();
  READ: while(<FIC>)
  {  
      #saute les lignes vides
      next READ if (/^$/);
      s/[ ]+/ /g;
      chop;
      $Ligne++;
      $Lignes[$Ligne] = $_ ;
      @Mots = split(/[\[\"\{\}&~\@=*?!;,():<>%\' \+_\/.-]+/);
#      @Mots = split(/\W+/);
      for $Mot (@Mots) {
	  $Mot =~ /\D/ or next ;
	  push(@{$Concord{$Mot}},$Ligne);
      }
  }
    for $Mot (sort keys %Concord) {
	$w_t->insert("end","-------------------------------------------------\n");
	$w_t->insert("end","Mot : $Mot \n");
	for $Ligne (@{$Concord{$Mot}})
	{
            $w_t->insert("end","\tLigne n$Ligne: $Lignes[$Ligne]\n");
	}
    }
    close(FIC);
}
#---------------------------------------------
#---------------------------------------------------------------------
# Premiers niveaux
#---------------------------------------------------------------------
#PN0
sub trt_en_cours {
&UpdateIndicators2;
    my ($trt,$message)=@_;
    if (! Exists ($pn0)) {
	$pn0 = $winMain::mw ->Toplevel();
	$pn0->title("Traitement en cours");
	$pn0->Label(-text => 'Traitement '.$trt.' dbut', -width => -1, -anchor => 'w')->pack;
	$pn0->Label(-text => $message, -width => -1, -anchor => 'w')->pack;
	$pn0->Button(-text => "OK",
		     -command =>  sub {$pn0->destroy()})->pack;
    }
    else {
	$pn0->deiconify();
	$pn0->raise();
    }
}
#---------------------------------------------
sub trt_fini {
&UpdateIndicators2;
    my ($trt,$message)=@_;
    if (! Exists ($pn0_1)) {
	$pn0_1 = $winMain::mw ->Toplevel();
	$pn0_1->title("Traitement fini");
	$pn0_1->Label(-text => 'Traitement '.$trt.' fini', -width => -1, -anchor => 'w')->pack;
	$pn0_1->Label(-text => $message, -width => -1, -anchor => 'w')->pack;
	$pn0_1->Button(-text => "OK",
		     -command =>  sub {$pn0_1->destroy()})->pack;
    }
    else {
	$pn0_1->deiconify();
	$pn0_1->raise();
    }
}
#-----------------------------------
sub command_help {
&UpdateIndicators2;
    &tkweb("browser/www/mkcorpusProjectv2.htm");
}



#---------------------------------------------------------------------------------------
#sub helpPackage {
#    use Tk::Browser;
#    use Lib::Module qw(new retrieve readlib basename DESTROY);
#    use Env qw(_);
#    my $d; my @dirs; my @files;
#    my $bb = Tk::Browser -> new;
#    $bb -> open();
#    }

#---------------------------------------------------------------------------------------
sub helpPod2txt {
&UpdateIndicators2;
    if ($winMain::search_string eq "") {
	&mkPrintErreur("ERREUR : Entrez un nom de package dans la zone \"Search string\"\n");
	return;
	}
#    `tkpod $winMain::search_string`;

    use Tk::Pod;
    require Tk::ErrorDialog;

    my $mw = $winMain::mw ->Toplevel();
    $mw->withdraw;
    my $ufont = $mw->optionGet('userFont','UserFont');     # fixed width
    my $sfont = $mw->optionGet('systemFont','SystemFont'); # proportional
    if (defined($ufont) and defined($sfont)) {
	foreach ($ufont, $sfont) { s/:$//; };
	$mw->optionAdd('*Font',       $sfont);
	$mw->optionAdd('*Entry.Font', $ufont);
	$mw->optionAdd('*Text.Font',  $ufont);
    }
    $mw->optionAdd('*Menu.tearOff', 0);
    my $file;
    my @tmpArray;
    push (@tmpArray,$winMain::search_string);
    foreach $file (@tmpArray) {
	if (-d $file) {
	  Tk::Pod->Dir($file);
	}
	else {
	    my $tl = $mw->Pod(-file => $file);
	    $tl->focus;
	}
    }   
    if ($mw->children) {
	$mw->repeat(1000, sub {
	    # ErrorDialog is withdrawn not deleted :-(
	    foreach ($mw->children) {
		return if "$_" =~ /^Tk::Pod/  # ->isa('Tk::Pod')
		}
	    $mw->destroy;
	});
    } 
    else {
	$mw->destroy;
    }

}

#---------------------------------------------------------------------------------------
sub browser1 {
&UpdateIndicators2;

    &tkweb("browser/www/mkcorpusProjectv2.htm");

}

#---------------------------------------------------------------------------------------
sub browser2 {
&UpdateIndicators2;
    &tkweb;
}


#---------------------------------------------------------------------------------------
sub browser_ie {
&UpdateIndicators2;

    use Win32::OLE;
    my $file = Win32::GetCwd() . "\\browser\\www\\mkcorpusProjectv2.htm";
    print $file,"\n";
    my $msie;
    eval {my $msie = Win32::OLE->GetActiveObject('InternetExplorer.Application')};
    if ($@) {
	     &mkPrintErreur("InternetExplorer unavailable" );
    }
    unless (defined $msie) {
	print "Dmarrage de IE \n";
	$msie = Win32::OLE->new('InternetExplorer.Application');
	if ($@) {
	    &mkPrintErreur("ERREUR : Oops, cannot start IE" );
	}
	$msie->{'Visible'}=1;
	$msie->Navigate($file);
    }  
}

#---------------------------------------------------------------------------------------
sub tkweb {
&UpdateIndicators2;

&loadSplashWindow;
#-------SPLASH REFRESH
    &splashProgress( "Work In Progress...", 25 );
#-------SPLASH REFRESH
require Tk::Web;
# require Tk::ErrorDialog;
require Tk::LabEntry;
require URI::URL;
require Tk::Menubar;

my $pwd = `pwd`;
chomp($pwd);

my $urltxt;
my $showlink;

my $mw = $winMain::mw ->Toplevel();
my $mb  = $mw->Menubar;#->pack(-fill => 'x');
my $fm  = $mb->Menubutton(-text => 'File', -underline => 0);#->pack(-side => 'left');; 
my $em  = $mb->Menubutton(-text => 'Edit', -underline => 0);#->pack(-side => 'left');; 
my $vm  = $mb->Menubutton(-text => 'View', -underline => 0);#->pack(-side => 'left');; 
my $hm  = $mb->Menubutton(-text => 'Help', -underline => 0);#->pack(-side => 'right');; 
my $but = $mw->Frame->pack(-fill => 'x');
my $w   = Tk::Web->new($mw,-showlink => sub { $showlink = shift }, -urlcommand => sub { $urltxt = shift} );
my $e   = $mw->LabEntry(-label => 'Location:',-labelPack => [-side => 'left',-anchor => 'e'],-textvariable => \$urltxt )->pack(-fill => 'x');

$e->bind('<Return>',[$w,'url',Tk::Ev(['get'])]);

$w->{'-header'} = {'Accept' => join(',','text/html', 'text/plain', 'image/gif', 
                                    'image/x-xbitmap', 'image/x-pixmap', '*/*'),
		   'User-Agent' => 'tkweb/.xx'};

$w->pack(-expand => 1, -fill => 'both');
$fm->command(-label => 'Open...',-underline => 0, -command => [$w,'Open']); 
$fm->command(-label => 'Save as...',-underline => 0, -command => [$w,'SaveAs']); 
$fm->command(-label => 'Exit',-underline => 1, -command => [$mw,'destroy']); 
$vm->command(-label => 'Reload',-underline => 0, -command => [$w,'Reload']); 
$vm->command(-label => 'Source...',-underline => 0, -command => [$w,'ShowSource']); 
$vm->command(-label => 'HTML...',-underline => 0, -command => [$w,'ShowHTML']); 

$but->Button(-text => 'Back', -command => [$w,'Back'])->pack(-side => 'left');
$but->Button(-text => 'Forward', -command => [$w,'Forward'])->pack(-side => 'left');
$but->Button(-text => 'Home', -command => [$w,'Home'])->pack(-side => 'left');
$but->Button(-text => 'Reload', -command => [$w,'Reload'])->pack(-side => 'left');
$but->Button(-text => 'Images', -command => [$w,'Images'], -state => 'disabled')->pack(-side => 'left');
$but->Button(-text => 'Open', -command => [$w,'Open'])->pack(-side => 'left');
$but->Button(-text => 'Print', -command => [$w,'Print'])->pack(-side => 'left');
$but->Button(-text => 'Find', -command => [$w,'Find'])->pack(-side => 'left');
$but->Button(-text => 'Stop', -command => [$w,'Stop'])->pack(-side => 'left');
$mw->AddScrollbars($w);
my $show = $mw->Frame(-label => 'URL : ',-labelPack => [-side => 'left'])->pack(-fill => 'x');
$show->Label(-textvariable => \$showlink, -anchor => 'w')->pack(-fill => 'y',-anchor => 'w', -expand => 1, -side => 'left');
$show->Frame(-height => '3m', -width => '60m', -borderwidth => 3, -background => 'cyan', -relief => 'sunken')
             ->pack(-side => 'right', -padx => '3m');
my %args = (-scrollbars => 'w');
$mw->ConfigDefault(\%args);
$mw->configure(%args);
my $viewUrl = shift(@_);
$w->url($viewUrl);
$w->focus;
&removeSplashWindow;

}




#-----------------------------------
#PN2
sub mkSelectionMarkup {
&UpdateIndicators2;
    if (! Exists ($pn2)) {
	$pn2 = $winMain::mw ->Toplevel();
	$pn2->title("Choose Markups");


	$listePn2=$pn2->Scrolled("Listbox", -scrollbars => "e",
			      -selectmode => "extended",
			      -selectforeground => "red",
			      -setgrid => 1,
			      -width => -1)->pack();

	$pn2->Button(-text => "Delete",
		     -command =>  \&delete_selected_balise)->pack(-side => 'left', -pady => 5, -padx => 10);
	$pn2->Button(-text => "Modify",
		     -command =>  \&modify_selected_balise)->pack(-side => 'left', -pady => 5, -padx => 10);
	$pn2->Button(-text => "Extract Text",
		     -command =>  \&extract_text_in_balise)->pack(-side => 'left', -pady => 5, -padx => 10);

	$pn2->Button(-text => "Close",
		     -command =>  sub {$pn2->destroy()})->pack(-side => 'left', -pady => 5, -padx => 10);

	my($w, $string, $tag) = ($winMain::texte,"<[^>]+>",'search');
	my $id=0;
	my @seenElt=();
	$w->tag('remove',  $tag, '0.0', 'end');
	(my $num_lines) = $w->index('end') =~ /(\d*)\.\d*/;
	for($i = 1; $i <=$num_lines; $i++) {
	my $line = $w->get("${i}.0", "${i}.1000");
	next if not defined $line or $line !~ /($string)/;
        my $l = length $1;
	my $stringRegexp=$1;
	my $offset = 0;
	while (1) {
	    my $tmpoffset=0;
	    my $index = index $line, $stringRegexp, $tmpoffset;
	    last if $index == -1;
	    $offset += $index;
	    $seenElt[$id] =[$i, $offset, $i, $offset+$l];
	    $id++;
	    $offset += $l;
	    $line = substr $line, $index+$l;
	    if ($line=~/($string)/) { $stringRegexp=$1;
				      $l = length $1;}
	} # whilend
    } # forend
	$winMain::cpt_file_balises++;
	if (!open(TMPFILE,(">MKC-tmp_Mkbalises.txt"))) {
	    &mkPrintErreur("ERREUR : Impossible d\'ouvrir le fichier MKC-tmp_Mkbalises.txt\n");
	    return;
	}
	for ($i =0 ; $i <=  $#seenElt; $i++) {
	    $tmpTexte=$w->get(sprintf("%d.%d",$seenElt[$i][0],$seenElt[$i][1]),sprintf("%d.%d",$seenElt[$i][2],$seenElt[$i][3]));
	    print TMPFILE "$tmpTexte\n";
	}
	close(TMPFILE);

	if (!open(TMPFILE,("MKC-tmp_Mkbalises.txt"))) {
	    &mkPrintErreur("ERREUR : Impossible d\'ouvrir le fichier MKC-tmp_Mkbalises.txt\n");
	    return;
	}
	my @liste_balises=();
	my %Liste_Markups=();
	my $id = 0; 
	while(<TMPFILE>) {
	    chomp;
	    if ($_!~/\//) {
		if (!exists ($Liste_Markups{$_})) {
		    $Liste_Markups{$_}++;
		    $liste_balises[$id]=$_;
		    $id++;
		}
	    }   
	}
	close(TMPFILE);

	$listePn2->delete(0,'end');
	$listePn2->insert('end',@liste_balises);
    }
    else {
	$pn2->deiconify();
	$pn2->raise();
    }
}
#-----------------------------------
sub makeTextToMap {
&UpdateIndicators2;
    $pn2Map->destroy if Exists($pn2Map);
    if (! Exists ($pn2Map)) {
	$pn2Map = $winMain::mw ->Toplevel();
	$pn2Map->title("Choose Markups");

	$listePn2Map=$pn2Map->Scrolled("Listbox", -scrollbars => "e",
			      -selectmode => "extended",
			      -selectforeground => "red",
			      -setgrid => 1,
			      -width => -1)->pack();
	$pn2Map->Button(-text => "Text 2 Map",
		     -command =>  \&make_text2map)->pack(-side => 'left', -pady => 5, -padx => 10);

	$pn2Map->Button(-text => "Close",
		     -command =>  sub {$pn2Map->destroy()})->pack(-side => 'left', -pady => 5, -padx => 10);

	my($w, $string, $tag) = ($winMain::texte,"<[^>]+>",'search');
	my $id=0;
	my @seenElt=();
	$w->tag('remove',  $tag, '0.0', 'end');
	(my $num_lines) = $w->index('end') =~ /(\d*)\.\d*/;
	for($i = 1; $i <=$num_lines; $i++) {
	my $line = $w->get("${i}.0", "${i}.1000");
	next if not defined $line or $line !~ /($string)/;
        my $l = length $1;
	my $stringRegexp=$1;
	my $offset = 0;
	while (1) {
	    my $tmpoffset=0;
	    my $index = index $line, $stringRegexp, $tmpoffset;
	    last if $index == -1;
	    $offset += $index;
	    $seenElt[$id] =[$i, $offset, $i, $offset+$l];
	    $id++;
	    $offset += $l;
	    $line = substr $line, $index+$l;
	    if ($line=~/($string)/) { $stringRegexp=$1;
				      $l = length $1;}

	} # whilend
    } # forend
	$winMain::cpt_file_balises++;
	if (!open(TMPFILE,(">MKC-tmp_Mkbalises.txt"))) {
	    &mkPrintErreur("ERREUR : Impossible d\'ouvrir le fichier MKC-tmp_Mkbalises.txt\n");
	    return;
	}
	for ($i =0 ; $i <=  $#seenElt; $i++) {
	    $tmpTexte=$w->get(sprintf("%d.%d",$seenElt[$i][0],$seenElt[$i][1]),sprintf("%d.%d",$seenElt[$i][2],$seenElt[$i][3]));
	    print TMPFILE "$tmpTexte\n";
	}
	close(TMPFILE);

	if (!open(TMPFILE,("MKC-tmp_Mkbalises.txt"))) {
	    &mkPrintErreur("ERREUR : Impossible d\'ouvrir le fichier MKC-tmp_Mkbalises.txt\n");
	    return;
	}
	my @liste_balises=();
	my %Liste_Markups=();
	my $id = 0; 
	while(<TMPFILE>) {
	    chomp;
	    if ($_!~/\//) {
		if (!exists ($Liste_Markups{$_})) {
		    $Liste_Markups{$_}++;
		    $liste_balises[$id]=$_;
		    $id++;
		}
	    }   
	}
	close(TMPFILE);

	if ($#liste_balises > 0) {
	    $listePn2Map->delete(0,'end');
	    $listePn2Map->insert('end',@liste_balises);
	}
	else {
	    $pn2Map->destroy if Exists($pn2Map);
	    &mkPrintMsgInfo("Pas de balise dans ce texte...\n");
	}
    }
    else {
	$pn2Map->deiconify();
	$pn2Map->raise();
    }
}
#-----------------------------------
#PN3
sub query_search_replace {
&UpdateIndicators2;
    if (! Exists ($pn3)) {
	$pn3 = $winMain::mw ->Toplevel();
	$pn3->title("Query Replace");
	my $cadre = $pn3->Frame->pack(-side => 'top',
			  -fill => 'x');
	$cadre->Label(-text => "Search : ",
    	      -relief => 'raised')->pack(-side => 'left',
						  -anchor => 'w');
	my $search="";
	my $saisie_1=$cadre->Entry(-textvariable => \$search)->pack(-side => 'left',
						-anchor => 'w',
						-fill => 'x',
						-expand => 1);
	$cadre->Label(-text => "Replace : ",
    	      -relief => 'raised')->pack(-side => 'left',
						  -anchor => 'w');
	my $replace="";
	my $saisie_2=$cadre->Entry(-textvariable => \$replace)->pack(-side => 'left',
						-anchor => 'w',
						-fill => 'x',
						-expand => 1);
	$cadre->Button(-text => "Search&Replace",
	       -command => sub {&search_replace($search,$replace)})->pack(-side => 'right',
						   -anchor => 'e');
	$pn3->Button(-text => "Close",
		     -command =>  sub {$pn3->destroy()})->pack;
    }
    else {
	$pn3->deiconify();
	$pn3->raise();
    }
}
#-----------------------------------
#PN4
sub query_replace {
&UpdateIndicators2;
    if (! Exists ($pn4)) {
	my ($search) = @_;
	$pn4 = $winMain::mw ->Toplevel();
	$pn4->title("Query Replace");
	my $cadre = $pn4->Frame->pack(-side => 'top',
			  -fill => 'x');
	$cadre->Label(-text => "Search : $search ",
    	      -relief => 'raised')->pack(-side => 'left',
						  -anchor => 'w');
	$cadre->Label(-text => "Replace : ",
    	      -relief => 'raised')->pack(-side => 'left',
						  -anchor => 'w');
	my $replace="";
	my $saisie_2=$cadre->Entry(-textvariable => \$replace)->pack(-side => 'left',
						-anchor => 'w',
						-fill => 'x',
						-expand => 1);
	$cadre->Button(-text => "Search&Replace",
	       -command => sub {&search_replace($search,$replace)})->pack(-side => 'right',
						   -anchor => 'e');
	$pn4->Button(-text => "Close",
		     -command =>  sub {$pn4->destroy()})->pack;
    }
    else {
	$pn4->deiconify();
	$pn4->raise();
    }
}
#-----------------------------------
#PN5
sub open_dir {
&UpdateIndicators2;
    if (! Exists ($pn5)) {
	my $pn5 = $winMain::mw ->Toplevel();
	my $dl  = $pn5->Scrolled("DirTree")->pack(-expand => 1 , -fill => 'both');
    }
    else {
	$pn5->deiconify();
	$pn5->raise();
    }
}
#-----------------------------------
sub viewAndSelectDir {
&UpdateIndicators2;
 my $dir = $winMain::mw->DirSelect->Show;
 return $dir;
}
#-----------------------------------
#PN6
sub fileDialog {
&UpdateIndicators2;
    my $w = shift;
    my $ent = shift;
    my $operation = shift;
    my $types;
    my $file;
    #   Type names		Extension(s)	Mac File Type(s)
    #
    #---------------------------------------------------------
    @types =
      (
       ["(HT/X/SG)ML files",           [qw/.xml .html .sgml .htm .dtd/]],
       ["Text files",           [qw/.txt .doc/]],
       ["Text files",           '',             'TEXT'],
       ["Perl Scripts",         '.pl',		'TEXT'],
       ["C Source Files",	['.c', '.h']],
       ["All Source Files",     [qw/.tcl .c .h/]],
       ["Image Files",		'.gif'],
       ["Image Files",		['.jpeg', '.jpg']],
       ["Image Files",   	'',		[qw/GIFF JPEG/]],
       ["All files",		'*']
      );
    if ($operation eq 'open') {
	$file = $w->getOpenFile(-filetypes => \@types);
	if (defined $file and $file ne '') {&load_selected_fic($file);}
	if (Exists ($pn9)) {$pn9->destroy();}
    } else {
	$file = $w->getSaveFile(-filetypes => \@types,
				-initialfile => 'Untitled',
				-defaultextension => '.txt');
	if (Exists ($pn9)) {$pn9->destroy();}
    }
}
#----------------------------------------------
sub fileDialog2 {
&UpdateIndicators2;
    my $w = shift;
    my $ent = shift;
    my $operation = shift;
    my $types;
    my $file;
    #   Type names		Extension(s)	Mac File Type(s)
    #
    #---------------------------------------------------------
    @types =
      (
       ["(HT/X/SG)ML files",           [qw/.xml .html .sgml/]],
       ["Text files",           [qw/.txt .doc/]],
       ["Text files",           '',             'TEXT'],
       ["Perl Scripts",         '.pl',		'TEXT'],
       ["C Source Files",	['.c', '.h']],
       ["All Source Files",     [qw/.tcl .c .h/]],
       ["Image Files",		'.gif'],
       ["Image Files",		['.jpeg', '.jpg']],
       ["Image Files",   	'',		[qw/GIFF JPEG/]],
       ["All files",		'*']
      );
    if ($operation eq 'open') {
	$file = $w->getOpenFile(-filetypes => \@types);
	if (defined $file and $file ne '') {&attach_selected_fic($file);}
	if (Exists ($pn11)) {$pn11->destroy();}
    } else {
	$file = $w->getSaveFile(-filetypes => \@types,
				-initialfile => 'Untitled',
				-defaultextension => '.txt');
	if (Exists ($pn11)) {$pn11->destroy();}
    }
}
#-----------------------------------
#PN7
sub query_search_text_in_balise {
&UpdateIndicators2;
    if (! Exists ($pn7)) {
	$pn7 = $winMain::mw ->Toplevel();
	$pn7->title("Text-Extractor");
	my $cadre = $pn7->Frame->pack(-side => 'top',
			  -fill => 'x');
	$cadre->Label(-text => "Search : ",
    	      -relief => 'raised')->pack(-side => 'left',
						  -anchor => 'w');
	my $search="";
	my $saisie_1=$cadre->Entry(-textvariable => \$search)->pack(-side => 'left',
						-anchor => 'w',
						-fill => 'x',
						-expand => 1);
	$cadre->Button(-text => "Extract Text",
	       -command => sub {&extract_balise_i($search)})->pack(-side => 'right',
						   -anchor => 'e');
	$pn7->Button(-text => "Close",
		     -command =>  sub {$pn7->destroy()})->pack;
    }
    else {
	$pn7->deiconify();
	$pn7->raise();
    }
}
#-----------------------------------
#PN8
sub query_dir_prepOneDir {
&UpdateIndicators2;
    if (! Exists ($pn8)) {
	$pn8 = $winMain::mw ->Toplevel();
	$pn8->title("Query Dir (preponedir)");
	$pn8->minsize(qw(800 200)); 
	my $frame0 = $pn8->Frame(-background=>'#edf0f3')->pack(-side=>'top',  -fill => 'both',  -expand => 1); 
	my $cadre1 = $frame0->Frame->pack(-side => 'top',  -fill => 'both',  -expand => 1);
	my $cadre2 = $frame0->Frame->pack(-side => 'top',  -fill => 'both',  -expand => 1);
	my $cadre5 = $frame0->Frame->pack(-side => 'top',  -fill => 'both',  -expand => 1);
	my $cadre3 = $frame0->Frame->pack(-side => 'top',  -fill => 'both',  -expand => 1);
	my $cadre4 = $frame0->Frame->pack(-side => 'top',  -fill => 'both',  -expand => 1);
	$cadre2->Label(-text => "Dir Input : ",
    	      -relief => 'raised')->pack(-side => 'left',
						  -anchor => 'w');
	my $workdirin=&GetCWD;
	my $saisie_1=$cadre2->Entry(-textvariable => \$workdirin)->pack(-side => 'left',
						-anchor => 'w',
						-fill => 'x',
						-expand => 1,
						);
	$cadre3->Label(-text => "Dir Output : ",
    	      -relief => 'raised')->pack(-side => 'left',
						  -anchor => 'w');
	my $workdirout=&GetCWD;
	my $saisie_2=$cadre3->Entry(-textvariable => \$workdirout)->pack(-side => 'left',
						-anchor => 'w',
						-fill => 'x',
						-expand => 1,
						);
	$cadre4->Button(-text => "Load mkPrepHtml2txtOneDir",
	       -command => sub {$pn8->destroy();
				&mkPrepHtml2txtOneDir($workdirin,$workdirout, 0, "corpFull.txt", 0);
			    })->pack(-side => 'right',
				     -anchor => 'e');
	$pn8->Button(-text => "Close",
		     -command =>  sub {$pn8->destroy()})->pack;
    }
    else {
	$pn8->deiconify();
	$pn8->raise();
    }
}


#-----------------------------------
#PN8
sub query_dir_webxref {
&UpdateIndicators2;
    if (! Exists ($pn8)) {
	$pn8 = $winMain::mw ->Toplevel();
	$pn8->title("Query Dir (webxref)");
	$pn8->minsize(qw(800 200)); 
	my $frame0 = $pn8->Frame(-background=>'#edf0f3')->pack(-side=>'top',  -fill => 'both',  -expand => 1); 
	my $cadre1 = $frame0->Frame->pack(-side => 'top',  -fill => 'both',  -expand => 1);
	my $cadre2 = $frame0->Frame->pack(-side => 'top',  -fill => 'both',  -expand => 1);
	my $cadre5 = $frame0->Frame->pack(-side => 'top',  -fill => 'both',  -expand => 1);
	my $cadre3 = $frame0->Frame->pack(-side => 'top',  -fill => 'both',  -expand => 1);
	my $cadre4 = $frame0->Frame->pack(-side => 'top',  -fill => 'both',  -expand => 1);
	$cadre1->Label(-text => "Where is Webxref : ",
    	      -relief => 'raised')->pack(-side => 'left',
						  -anchor => 'w');
	my $webxrefdir=&GetCWD;
	my $saisie_0=$cadre1->Entry(-textvariable => \$webxrefdir)->pack(-side => 'left',
						-anchor => 'w',
						-fill => 'x',
						-expand => 1,
						);
	$cadre2->Label(-text => "Dir Input : ",
    	      -relief => 'raised')->pack(-side => 'left',
						  -anchor => 'w');
	my $workdirin=&GetCWD;
	my $saisie_1=$cadre2->Entry(-textvariable => \$workdirin)->pack(-side => 'left',
						-anchor => 'w',
						-fill => 'x',
						-expand => 1,
						);
	$cadre5->Label(-text => "Site Name : ",
    	      -relief => 'raised')->pack(-side => 'left',
						  -anchor => 'w');
	my $sitename="GiveSiteName (DirName)";
	my $saisie_3=$cadre5->Entry(-textvariable => \$sitename)->pack(-side => 'left',
						-anchor => 'w',
						-fill => 'x',
						-expand => 1,
						);
	$cadre3->Label(-text => "Dir Output : ",
    	      -relief => 'raised')->pack(-side => 'left',
						  -anchor => 'w');

	my $workdirout=&GetCWD;
	my $saisie_2=$cadre3->Entry(-textvariable => \$workdirout)->pack(-side => 'left',
						-anchor => 'w',
						-fill => 'x',
						-expand => 1,
						);
	$cadre4->Button(-text => "Load Webxref",
	       -command => sub {$pn8->destroy();
				&loadwebxref($webxrefdir,$workdirin,$sitename,$workdirout);
			    })->pack(-side => 'right',
				     -anchor => 'e');
	$pn8->Button(-text => "Close",
		     -command =>  sub {$pn8->destroy()})->pack;
    }
    else {
	$pn8->deiconify();
	$pn8->raise();
    }
}


#---------------------------------------------------------------------------------------
sub query_dir_webxrefOneDir {
    &UpdateIndicators2;
    if (! Exists ($pn8)) {
	$pn8 = $winMain::mw ->Toplevel();
	$pn8->title("Query Dir (webxrefOneDir)");
	$pn8->minsize(qw(800 200)); 
	my $frame0 = $pn8->Frame(-background=>'#edf0f3')->pack(-side=>'top',  -fill => 'both',  -expand => 1); 
	my $cadre1 = $frame0->Frame->pack(-side => 'top',  -fill => 'both',  -expand => 1);
	my $cadre2 = $frame0->Frame->pack(-side => 'top',  -fill => 'both',  -expand => 1);
	my $cadre5 = $frame0->Frame->pack(-side => 'top',  -fill => 'both',  -expand => 1);
	my $cadre3 = $frame0->Frame->pack(-side => 'top',  -fill => 'both',  -expand => 1);
	my $cadre4 = $frame0->Frame->pack(-side => 'top',  -fill => 'both',  -expand => 1);

	$cadre1->Label(-text => "Where is Webxref : ",
    	      -relief => 'raised')->pack(-side => 'left',
						  -anchor => 'w');
	my $webxrefdir=&GetCWD;
	my $saisie_0=$cadre1->Entry(-textvariable => \$webxrefdir)->pack(-side => 'left',
						-anchor => 'w',
						-fill => 'x',
						-expand => 1,
						);
	$cadre2->Label(-text => "Dir Input : ",
    	      -relief => 'raised')->pack(-side => 'left',
						  -anchor => 'w');
	my $workdirin=&GetCWD;
	my $saisie_1=$cadre2->Entry(-textvariable => \$workdirin)->pack(-side => 'left',
						-anchor => 'w',
						-fill => 'x',
						-expand => 1,
						);
	$cadre3->Label(-text => "Dir Output : ",
    	      -relief => 'raised')->pack(-side => 'left',
						  -anchor => 'w');

	my $workdirout=&GetCWD;
	my $saisie_2=$cadre3->Entry(-textvariable => \$workdirout)->pack(-side => 'left',
						-anchor => 'w',
						-fill => 'x',
						-expand => 1,
						);
	$cadre4->Button(-text => "Load Webxref",
	       -command => sub {$pn8->destroy();
				&loadwebxrefOneDir($webxrefdir,$workdirin,$workdirout);
			    })->pack(-side => 'right',
				     -anchor => 'e');
	$pn8->Button(-text => "Close",
		     -command =>  sub {$pn8->destroy()})->pack;
    }
    else {
	$pn8->deiconify();
	$pn8->raise();
    }
}

#---------------------------------------------------------------------------------------
sub query_dir_webxrefOneDirLynx {
    &UpdateIndicators2;
    if (! Exists ($pn8)) {
	$pn8 = $winMain::mw ->Toplevel();
	$pn8->title("Query Dir (webxrefOneDirLynx)");
	$pn8->minsize(qw(800 200)); 
	my $frame0 = $pn8->Frame(-background=>'#edf0f3')->pack(-side=>'top',  -fill => 'both',  -expand => 1); 
	my $cadre1 = $frame0->Frame->pack(-side => 'top',  -fill => 'both',  -expand => 1);
	my $cadre2 = $frame0->Frame->pack(-side => 'top',  -fill => 'both',  -expand => 1);
	my $cadre5 = $frame0->Frame->pack(-side => 'top',  -fill => 'both',  -expand => 1);
	my $cadre3 = $frame0->Frame->pack(-side => 'top',  -fill => 'both',  -expand => 1);
	my $cadre4 = $frame0->Frame->pack(-side => 'top',  -fill => 'both',  -expand => 1);
	$cadre1->Label(-text => "Where is Webxref : ",
    	      -relief => 'raised')->pack(-side => 'left',
						  -anchor => 'w');
	my $webxrefdir=&GetCWD;
	my $saisie_0=$cadre1->Entry(-textvariable => \$webxrefdir)->pack(-side => 'left',
						-anchor => 'w',
						-fill => 'x',
						-expand => 1,
						);
	$cadre2->Label(-text => "Dir Input : ",
    	      -relief => 'raised')->pack(-side => 'left',
						  -anchor => 'w');
	my $workdirin=&GetCWD;
	my $saisie_1=$cadre2->Entry(-textvariable => \$workdirin)->pack(-side => 'left',
						-anchor => 'w',
						-fill => 'x',
						-expand => 1,
						);
	$cadre3->Label(-text => "Dir Output : ",
    	      -relief => 'raised')->pack(-side => 'left',
						  -anchor => 'w');

	my $workdirout=&GetCWD;
	my $saisie_2=$cadre3->Entry(-textvariable => \$workdirout)->pack(-side => 'left',
						-anchor => 'w',
						-fill => 'x',
						-expand => 1,
						);
	$cadre4->Button(-text => "Load Webxref",
	       -command => sub {$pn8->destroy();
				&loadwebxrefOneDirLynx($webxrefdir,$workdirin,$workdirout);
			    })->pack(-side => 'right',
				     -anchor => 'e');
	$pn8->Button(-text => "Close",
		     -command =>  sub {$pn8->destroy()})->pack;
    }
    else {
	$pn8->deiconify();
	$pn8->raise();
    }
}
#---------------------------------------------
sub query_dir_webxref2 {
&UpdateIndicators2;
    if (! Exists ($pn8)) {
	$pn8 = $winMain::mw ->Toplevel();
	$pn8->title("Query Dir (webxref2)");
	$pn8->minsize(qw(800 200)); 
	my $frame0 = $pn8->Frame(-background=>'#edf0f3')->pack(-side=>'top',  -fill => 'both',  -expand => 1); 
	my $cadre1 = $frame0->Frame->pack(-side => 'top',  -fill => 'both',  -expand => 1);
	my $cadre2 = $frame0->Frame->pack(-side => 'top',  -fill => 'both',  -expand => 1);
	my $cadre5 = $frame0->Frame->pack(-side => 'top',  -fill => 'both',  -expand => 1);
	my $cadre3 = $frame0->Frame->pack(-side => 'top',  -fill => 'both',  -expand => 1);
	my $cadre4 = $frame0->Frame->pack(-side => 'top',  -fill => 'both',  -expand => 1);

	$cadre1->Label(-text => "Where is Webxref : ",
    	      -relief => 'raised')->pack(-side => 'left',
						  -anchor => 'w');
	my $webxrefdir=&GetCWD;
	my $saisie_0=$cadre1->Entry(-textvariable => \$webxrefdir)->pack(-side => 'left',
						-anchor => 'w',
						-fill => 'x',
						-expand => 1,
						);
	$cadre2->Label(-text => "Dir Input : ",
    	      -relief => 'raised')->pack(-side => 'left',
						  -anchor => 'w');
	my $workdirin=&GetCWD;
	my $saisie_1=$cadre2->Entry(-textvariable => \$workdirin)->pack(-side => 'left',
						-anchor => 'w',
						-fill => 'x',
						-expand => 1,
						);
	$cadre5->Label(-text => "Site Name : ",
    	      -relief => 'raised')->pack(-side => 'left',
						  -anchor => 'w');
	my $sitename="GiveSiteName (DirName)";
	my $saisie_3=$cadre5->Entry(-textvariable => \$sitename)->pack(-side => 'left',
						-anchor => 'w',
						-fill => 'x',
						-expand => 1,
						);
	$cadre3->Label(-text => "Dir Output : ",
    	      -relief => 'raised')->pack(-side => 'left',
						  -anchor => 'w');
	my $workdirout=&GetCWD;
	my $saisie_2=$cadre3->Entry(-textvariable => \$workdirout)->pack(-side => 'left',
						-anchor => 'w',
						-fill => 'x',
						-expand => 1,
						);
	$cadre4->Button(-text => "Load Webxref",
	       -command => sub {$pn8->destroy();
				&loadwebxref2($webxrefdir,$workdirin,$sitename,$workdirout);
			    })->pack(-side => 'right',
				     -anchor => 'e');
	$pn8->Button(-text => "Close",
		     -command =>  sub {$pn8->destroy()})->pack;
    }
    else {
	$pn8->deiconify();
	$pn8->raise();
    }
}

#---------------------------------------------
sub query_dir_webxref2Lynx {
&UpdateIndicators2;
    if (! Exists ($pn8)) {
	$pn8 = $winMain::mw ->Toplevel();
	$pn8->title("Query Dir (webxref2Lynx)");
	$pn8->minsize(qw(800 200)); 
	my $frame0 = $pn8->Frame(-background=>'#edf0f3')->pack(-side=>'top',  -fill => 'both',  -expand => 1); 
	my $cadre1 = $frame0->Frame->pack(-side => 'top',  -fill => 'both',  -expand => 1);
	my $cadre2 = $frame0->Frame->pack(-side => 'top',  -fill => 'both',  -expand => 1);
	my $cadre5 = $frame0->Frame->pack(-side => 'top',  -fill => 'both',  -expand => 1);
	my $cadre3 = $frame0->Frame->pack(-side => 'top',  -fill => 'both',  -expand => 1);
	my $cadre4 = $frame0->Frame->pack(-side => 'top',  -fill => 'both',  -expand => 1);

	$cadre1->Label(-text => "Where is Webxref : ",
    	      -relief => 'raised')->pack(-side => 'left',
						  -anchor => 'w');
	my $webxrefdir=&GetCWD;
	my $saisie_0=$cadre1->Entry(-textvariable => \$webxrefdir)->pack(-side => 'left',
						-anchor => 'w',
						-fill => 'x',
						-expand => 1,
						);
	$cadre2->Label(-text => "Dir Input : ",
    	      -relief => 'raised')->pack(-side => 'left',
						  -anchor => 'w');
	my $workdirin=&GetCWD;
	my $saisie_1=$cadre2->Entry(-textvariable => \$workdirin)->pack(-side => 'left',
						-anchor => 'w',
						-fill => 'x',
						-expand => 1,
						);
	$cadre5->Label(-text => "Site Name : ",
    	      -relief => 'raised')->pack(-side => 'left',
						  -anchor => 'w');
	my $sitename="GiveSiteName (DirName)";
	my $saisie_3=$cadre5->Entry(-textvariable => \$sitename)->pack(-side => 'left',
						-anchor => 'w',
						-fill => 'x',
						-expand => 1,
						);
	$cadre3->Label(-text => "Dir Output : ",
    	      -relief => 'raised')->pack(-side => 'left',
						  -anchor => 'w');
	my $workdirout=&GetCWD;
	my $saisie_2=$cadre3->Entry(-textvariable => \$workdirout)->pack(-side => 'left',
						-anchor => 'w',
						-fill => 'x',
						-expand => 1,
						);
	$cadre4->Button(-text => "Load Webxref",
	       -command => sub {$pn8->destroy();
				&loadwebxref2Lynx($webxrefdir,$workdirin,$sitename,$workdirout);
			    })->pack(-side => 'right',
				     -anchor => 'e');
	$pn8->Button(-text => "Close",
		     -command =>  sub {$pn8->destroy()})->pack;
    }
    else {
	$pn8->deiconify();
	$pn8->raise();
    }
}
#---------------------------------------
sub query_dir_webxref22 {
&UpdateIndicators2;
    if (! Exists ($pn8)) {
	$pn8 = $winMain::mw ->Toplevel();
	$pn8->title("Query Dir (webxref22)");
	$pn8->minsize(qw(800 200)); 
	my $frame0 = $pn8->Frame(-background=>'#edf0f3')->pack(-side=>'top',  -fill => 'both',  -expand => 1); 
	my $cadre1 = $frame0->Frame->pack(-side => 'top',  -fill => 'both',  -expand => 1);
	my $cadre2 = $frame0->Frame->pack(-side => 'top',  -fill => 'both',  -expand => 1);
	my $cadre5 = $frame0->Frame->pack(-side => 'top',  -fill => 'both',  -expand => 1);
	my $cadre3 = $frame0->Frame->pack(-side => 'top',  -fill => 'both',  -expand => 1);
	my $cadre4 = $frame0->Frame->pack(-side => 'top',  -fill => 'both',  -expand => 1);

	$cadre1->Label(-text => "Where is Webxref : ",
    	      -relief => 'raised')->pack(-side => 'left',
						  -anchor => 'w');
	my $webxrefdir=&GetCWD;
	my $saisie_0=$cadre1->Entry(-textvariable => \$webxrefdir)->pack(-side => 'left',
						-anchor => 'w',
						-fill => 'x',
						-expand => 1,
						);
	$cadre2->Label(-text => "Dir Input : ",
    	      -relief => 'raised')->pack(-side => 'left',
						  -anchor => 'w');
	my $workdirin=&GetCWD;
	my $saisie_1=$cadre2->Entry(-textvariable => \$workdirin)->pack(-side => 'left',
						-anchor => 'w',
						-fill => 'x',
						-expand => 1,
						);
	$cadre5->Label(-text => "Site Name : ",
    	      -relief => 'raised')->pack(-side => 'left',
						  -anchor => 'w');
	my $sitename="GiveSiteName (DirName)";
	my $saisie_3=$cadre5->Entry(-textvariable => \$sitename)->pack(-side => 'left',
						-anchor => 'w',
						-fill => 'x',
						-expand => 1,
						);
	$cadre3->Label(-text => "Dir Output : ",
    	      -relief => 'raised')->pack(-side => 'left',
						  -anchor => 'w');
	my $workdirout=&GetCWD;
	my $saisie_2=$cadre3->Entry(-textvariable => \$workdirout)->pack(-side => 'left',
						-anchor => 'w',
						-fill => 'x',
						-expand => 1,
						);
	$cadre4->Button(-text => "Load Webxref",
	       -command => sub {$pn8->destroy();
				&loadwebxref22($webxrefdir,$workdirin,$sitename,$workdirout);
			    })->pack(-side => 'right',
				     -anchor => 'e');
	$pn8->Button(-text => "Close",
		     -command =>  sub {$pn8->destroy()})->pack;
    }
    else {
	$pn8->deiconify();
	$pn8->raise();
    }
}
#---------------------------------------------------------------------------------------
sub query_dir_webxref222 {
&UpdateIndicators2;
    if (! Exists ($pn8)) {
	$pn8 = $winMain::mw ->Toplevel();
	$pn8->title("Query Dir (webxref222)");
	$pn8->minsize(qw(800 200)); 
	my $frame0 = $pn8->Frame(-background=>'#edf0f3')->pack(-side=>'top',  -fill => 'both',  -expand => 1); 
	my $cadre1 = $frame0->Frame->pack(-side => 'top',  -fill => 'both',  -expand => 1);
	my $cadre2 = $frame0->Frame->pack(-side => 'top',  -fill => 'both',  -expand => 1);
	my $cadre5 = $frame0->Frame->pack(-side => 'top',  -fill => 'both',  -expand => 1);
	my $cadre3 = $frame0->Frame->pack(-side => 'top',  -fill => 'both',  -expand => 1);
	my $cadre4 = $frame0->Frame->pack(-side => 'top',  -fill => 'both',  -expand => 1);

	$cadre1->Label(-text => "Where is Webxref : ",
    	      -relief => 'raised')->pack(-side => 'left',
						  -anchor => 'w');
	my $webxrefdir=&GetCWD;
	my $saisie_0=$cadre1->Entry(-textvariable => \$webxrefdir)->pack(-side => 'left',
						-anchor => 'w',
						-fill => 'x',
						-expand => 1,
						);
	$cadre2->Label(-text => "Dir Input : ",
    	      -relief => 'raised')->pack(-side => 'left',
						  -anchor => 'w');
	my $workdirin=&GetCWD;
	my $saisie_1=$cadre2->Entry(-textvariable => \$workdirin)->pack(-side => 'left',
						-anchor => 'w',
						-fill => 'x',
						-expand => 1,
						);
	$cadre5->Label(-text => "Site Name : ",
    	      -relief => 'raised')->pack(-side => 'left',
						  -anchor => 'w');
	my $sitename="GiveSiteName (DirName)";
	my $saisie_3=$cadre5->Entry(-textvariable => \$sitename)->pack(-side => 'left',
						-anchor => 'w',
						-fill => 'x',
						-expand => 1,
						);
	$cadre3->Label(-text => "Dir Output : ",
    	      -relief => 'raised')->pack(-side => 'left',
						  -anchor => 'w');
	my $workdirout=&GetCWD;
	my $saisie_2=$cadre3->Entry(-textvariable => \$workdirout)->pack(-side => 'left',
						-anchor => 'w',
						-fill => 'x',
						-expand => 1,
						);
	$cadre4->Button(-text => "Load Webxref",
	       -command => sub {$pn8->destroy();
				&loadwebxref222($webxrefdir,$workdirin,$sitename,$workdirout);
			    })->pack(-side => 'right',
				     -anchor => 'e');
	$pn8->Button(-text => "Close",
		     -command =>  sub {$pn8->destroy()})->pack;
    }
    else {
	$pn8->deiconify();
	$pn8->raise();
    }
}

#---------------------------------------------------------------------------------------
sub query_sensnetxref2 {
    &UpdateIndicators2;
    if (! Exists ($pn8)) {
	$pn8 = $winMain::mw ->Toplevel();
	$pn8->title("Query Dir (sensnetxref2)");
	$pn8->minsize(qw(800 200)); 
	my $frame0 = $pn8->Frame(-background=>'#edf0f3')->pack(-side=>'top',  -fill => 'both',  -expand => 1); 
	my $cadre1 = $frame0->Frame->pack(-side => 'top',  -fill => 'both',  -expand => 1);
	my $cadre2 = $frame0->Frame->pack(-side => 'top',  -fill => 'both',  -expand => 1);
	my $cadre5 = $frame0->Frame->pack(-side => 'top',  -fill => 'both',  -expand => 1);
	my $cadre3 = $frame0->Frame->pack(-side => 'top',  -fill => 'both',  -expand => 1);
	my $cadre4 = $frame0->Frame->pack(-side => 'top',  -fill => 'both',  -expand => 1);
	$cadre1->Label(-text => "Where is Webxref : ",
    	      -relief => 'raised')->pack(-side => 'left',
						  -anchor => 'w');
	my $webxrefdir=&GetCWD;
	my $saisie_0=$cadre1->Entry(-textvariable => \$webxrefdir)->pack(-side => 'left',
						-anchor => 'w',
						-fill => 'x',
						-expand => 1,
						);
	$cadre2->Label(-text => "Dir Input : ",
    	      -relief => 'raised')->pack(-side => 'left',
						  -anchor => 'w');
	my $workdirin=&GetCWD;
	my $saisie_1=$cadre2->Entry(-textvariable => \$workdirin)->pack(-side => 'left',
						-anchor => 'w',
						-fill => 'x',
						-expand => 1,
						);
	$cadre3->Label(-text => "Dir Output : ",
    	      -relief => 'raised')->pack(-side => 'left',
						  -anchor => 'w');

	my $workdirout=&GetCWD;
	my $saisie_2=$cadre3->Entry(-textvariable => \$workdirout)->pack(-side => 'left',
						-anchor => 'w',
						-fill => 'x',
						-expand => 1,
						);
	$cadre4->Button(-text => "Load sensnetxref2",
	       -command => sub {$pn8->destroy();
				&loadsensnetxref2($webxrefdir,$workdirin,$workdirout);
			    })->pack(-side => 'right',
				     -anchor => 'e');
	$pn8->Button(-text => "Close",
		     -command =>  sub {$pn8->destroy()})->pack;
    }
    else {
	$pn8->deiconify();
	$pn8->raise();
    }
}
#---------------------------------------------------------------------------------------
sub query_sensnetxref1 {
    &UpdateIndicators2;
    if (! Exists ($pn8)) {
	$pn8 = $winMain::mw ->Toplevel();
	$pn8->title("Query Dir (sensnetxref1)");
	$pn8->minsize(qw(800 200)); 
	my $frame0 = $pn8->Frame(-background=>'#edf0f3')->pack(-side=>'top',  -fill => 'both',  -expand => 1); 
	my $cadre1 = $frame0->Frame->pack(-side => 'top',  -fill => 'both',  -expand => 1);
	my $cadre2 = $frame0->Frame->pack(-side => 'top',  -fill => 'both',  -expand => 1);
	my $cadre5 = $frame0->Frame->pack(-side => 'top',  -fill => 'both',  -expand => 1);
	my $cadre3 = $frame0->Frame->pack(-side => 'top',  -fill => 'both',  -expand => 1);
	my $cadre4 = $frame0->Frame->pack(-side => 'top',  -fill => 'both',  -expand => 1);

	$cadre1->Label(-text => "Where is Webxref : ",
    	      -relief => 'raised')->pack(-side => 'left',
						  -anchor => 'w');
	my $webxrefdir=&GetCWD;
	my $saisie_0=$cadre1->Entry(-textvariable => \$webxrefdir)->pack(-side => 'left',
						-anchor => 'w',
						-fill => 'x',
						-expand => 1,
						);
	$cadre2->Label(-text => "Dir Input : ",
    	      -relief => 'raised')->pack(-side => 'left',
						  -anchor => 'w');
	my $workdirin=&GetCWD;
	my $saisie_1=$cadre2->Entry(-textvariable => \$workdirin)->pack(-side => 'left',
						-anchor => 'w',
						-fill => 'x',
						-expand => 1,
						);
	$cadre5->Label(-text => "Site Name : ",
    	      -relief => 'raised')->pack(-side => 'left',
						  -anchor => 'w');
	my $sitename="GiveSiteName (DirName)";
	my $saisie_3=$cadre5->Entry(-textvariable => \$sitename)->pack(-side => 'left',
						-anchor => 'w',
						-fill => 'x',
						-expand => 1,
						);
	$cadre3->Label(-text => "Dir Output : ",
    	      -relief => 'raised')->pack(-side => 'left',
						  -anchor => 'w');
	my $workdirout=&GetCWD;
	my $saisie_2=$cadre3->Entry(-textvariable => \$workdirout)->pack(-side => 'left',
						-anchor => 'w',
						-fill => 'x',
						-expand => 1,
						);
	$cadre4->Button(-text => "Load sensnetXref1",
	       -command => sub {$pn8->destroy();
				&loadsensnetxref1($webxrefdir,$workdirin,$sitename,$workdirout);
			    })->pack(-side => 'right',
				     -anchor => 'e');
	$pn8->Button(-text => "Close",
		     -command =>  sub {$pn8->destroy()})->pack;
    }
    else {
	$pn8->deiconify();
	$pn8->raise();
    }
}

#---------------------------------------------------------------------------------------
sub query_sensnetxref4 {
    &UpdateIndicators2;
    if (! Exists ($pn8)) {
	$pn8 = $winMain::mw ->Toplevel();
	$pn8->title("Query Dir (sensnetxref4)");
	$pn8->minsize(qw(800 200)); 
	my $frame0 = $pn8->Frame(-background=>'#edf0f3')->pack(-side=>'top',  -fill => 'both',  -expand => 1); 
	my $cadre1 = $frame0->Frame->pack(-side => 'top',  -fill => 'both',  -expand => 1);
	my $cadre2 = $frame0->Frame->pack(-side => 'top',  -fill => 'both',  -expand => 1);
	my $cadre5 = $frame0->Frame->pack(-side => 'top',  -fill => 'both',  -expand => 1);
	my $cadre3 = $frame0->Frame->pack(-side => 'top',  -fill => 'both',  -expand => 1);
	my $cadre4 = $frame0->Frame->pack(-side => 'top',  -fill => 'both',  -expand => 1);

	$cadre1->Label(-text => "Where is Webxref : ",
    	      -relief => 'raised')->pack(-side => 'left',
						  -anchor => 'w');
	my $webxrefdir=&GetCWD;
	my $saisie_0=$cadre1->Entry(-textvariable => \$webxrefdir)->pack(-side => 'left',
						-anchor => 'w',
						-fill => 'x',
						-expand => 1,
						);
	$cadre2->Label(-text => "Dir Input : ",
    	      -relief => 'raised')->pack(-side => 'left',
						  -anchor => 'w');
	my $workdirin=&GetCWD;
	my $saisie_1=$cadre2->Entry(-textvariable => \$workdirin)->pack(-side => 'left',
						-anchor => 'w',
						-fill => 'x',
						-expand => 1,
						);
	$cadre5->Label(-text => "Site Name : ",
    	      -relief => 'raised')->pack(-side => 'left',
						  -anchor => 'w');
	my $sitename="GiveSiteName (DirName)";
	my $saisie_3=$cadre5->Entry(-textvariable => \$sitename)->pack(-side => 'left',
						-anchor => 'w',
						-fill => 'x',
						-expand => 1,
						);
	$cadre3->Label(-text => "Dir Output : ",
    	      -relief => 'raised')->pack(-side => 'left',
						  -anchor => 'w');
	my $workdirout=&GetCWD;
	my $saisie_2=$cadre3->Entry(-textvariable => \$workdirout)->pack(-side => 'left',
						-anchor => 'w',
						-fill => 'x',
						-expand => 1,
						);
	$cadre4->Button(-text => "Load sensnetxref4",
	       -command => sub {$pn8->destroy();
				&loadsensnetxref4($webxrefdir,$workdirin,$sitename,$workdirout);
			    })->pack(-side => 'right',
				     -anchor => 'e');
	$pn8->Button(-text => "Close",
		     -command =>  sub {$pn8->destroy()})->pack;
    }
    else {
	$pn8->deiconify();
	$pn8->raise();
    }
}

#---------------------------------------------------------------------------------------
sub query_sensnetxref5 {
    &UpdateIndicators2;
    if (! Exists ($pn8)) {
	$pn8 = $winMain::mw ->Toplevel();
	$pn8->title("Query Dir (sensnetxref5)");
	$pn8->minsize(qw(800 200)); 
	my $frame0 = $pn8->Frame(-background=>'#edf0f3')->pack(-side=>'top',  -fill => 'both',  -expand => 1); 
	my $cadre1 = $frame0->Frame->pack(-side => 'top',  -fill => 'both',  -expand => 1);
	my $cadre2 = $frame0->Frame->pack(-side => 'top',  -fill => 'both',  -expand => 1);
	my $cadre5 = $frame0->Frame->pack(-side => 'top',  -fill => 'both',  -expand => 1);
	my $cadre3 = $frame0->Frame->pack(-side => 'top',  -fill => 'both',  -expand => 1);
	my $cadre4 = $frame0->Frame->pack(-side => 'top',  -fill => 'both',  -expand => 1);
	$cadre1->Label(-text => "Where is Webxref : ",
    	      -relief => 'raised')->pack(-side => 'left',
						  -anchor => 'w');
	my $webxrefdir=&GetCWD;
	my $saisie_0=$cadre1->Entry(-textvariable => \$webxrefdir)->pack(-side => 'left',
						-anchor => 'w',
						-fill => 'x',
						-expand => 1,
						);
	$cadre2->Label(-text => "Dir Input : ",
    	      -relief => 'raised')->pack(-side => 'left',
						  -anchor => 'w');
	my $workdirin=&GetCWD;
	my $saisie_1=$cadre2->Entry(-textvariable => \$workdirin)->pack(-side => 'left',
						-anchor => 'w',
						-fill => 'x',
						-expand => 1,
						);
	$cadre3->Label(-text => "Dir Output : ",
    	      -relief => 'raised')->pack(-side => 'left',
						  -anchor => 'w');

	my $workdirout=&GetCWD;
	my $saisie_2=$cadre3->Entry(-textvariable => \$workdirout)->pack(-side => 'left',
						-anchor => 'w',
						-fill => 'x',
						-expand => 1,
						);
	$cadre4->Button(-text => "Load sensnetxref5",
	       -command => sub {$pn8->destroy();
				&loadsensnetxref5($webxrefdir,$workdirin,$workdirout);
			    })->pack(-side => 'right',
				     -anchor => 'e');
	$pn8->Button(-text => "Close",
		     -command =>  sub {$pn8->destroy()})->pack;
    }
    else {
	$pn8->deiconify();
	$pn8->raise();
    }
}

#---------------------------------------------------------------------------------------
#PN8Bis
sub query_dir_mktipo {
&UpdateIndicators2;
    if (! Exists ($pn8b)) {
	$pn8b = $winMain::mw ->Toplevel();
	$pn8b->title("Query Dir (Mktipo)");
	$pn8b->minsize(qw(800 200)); 
	my $frame0 = $pn8b->Frame(-background=>'#edf0f3')->pack(-side=>'top',  -fill => 'both',  -expand => 1); 
	my $cadre1 = $frame0->Frame->pack(-side => 'top',  -fill => 'both',  -expand => 1);
	my $cadre2 = $frame0->Frame->pack(-side => 'top',  -fill => 'both',  -expand => 1);
	my $cadre5 = $frame0->Frame->pack(-side => 'top',  -fill => 'both',  -expand => 1);
	my $cadre3 = $frame0->Frame->pack(-side => 'top',  -fill => 'both',  -expand => 1);
	my $cadre4 = $frame0->Frame->pack(-side => 'top',  -fill => 'both',  -expand => 1);

	$cadre1->Label(-text => "Where is Mktipo : ",
    	      -relief => 'raised')->pack(-side => 'left',
						  -anchor => 'w');
	my $mktipodir=&GetCWD;
	my $saisie_0=$cadre1->Entry(-textvariable => \$mktipodir)->pack(-side => 'left',
						-anchor => 'w',
						-fill => 'x',
						-expand => 1,
						);
	$cadre2->Label(-text => "Dir Input : ",
    	      -relief => 'raised')->pack(-side => 'left',
						  -anchor => 'w');
	my $workdirin=&GetCWD;
	my $saisie_1=$cadre2->Entry(-textvariable => \$workdirin)->pack(-side => 'left',
						-anchor => 'w',
						-fill => 'x',
						-expand => 1,
						);
	$cadre5->Label(-text => "Site Name : ",
    	      -relief => 'raised')->pack(-side => 'left',
						  -anchor => 'w');
	my $sitename="res1(GiveSiteName)";
	my $saisie_3=$cadre5->Entry(-textvariable => \$sitename)->pack(-side => 'left',
						-anchor => 'w',
						-fill => 'x',
						-expand => 1,
						);
#	my $workdirout=&GetCWD;
	my $workdirout=$workdirin;
	$cadre3->Label(-text => "Dir Output : $workdirout",
    	      -relief => 'raised')->pack(-side => 'left',
						  -anchor => 'w');
	$cadre4->Button(-text => "Load MkTipo",
	       -command => sub {$pn8b->destroy();
				&loadMktipo($mktipodir,$workdirin,$sitename,$workdirout);
			    })->pack(-side => 'right',
				     -anchor => 'e');
	$pn8b->Button(-text => "Close",
		     -command =>  sub {$pn8b->destroy()})->pack;
    }
    else {
	$pn8b->deiconify();
	$pn8b->raise();
    }
}
#-----------------------------------
#PN8Ter
sub query_dir_makestat1 {
&UpdateIndicators2;
    if (! Exists ($pn8c)) {
	$pn8c = $winMain::mw ->Toplevel();
	$pn8c->title("Query Dir (makestat1)");
	$pn8c->minsize(qw(800 200)); 
	my $frame0 = $pn8c->Frame(-background=>'#edf0f3')->pack(-side=>'top',  -fill => 'both',  -expand => 1); 
	my $cadre1 = $frame0->Frame->pack(-side => 'top',  -fill => 'both',  -expand => 1);
	my $cadre2 = $frame0->Frame->pack(-side => 'top',  -fill => 'both',  -expand => 1);
	my $cadre5 = $frame0->Frame->pack(-side => 'top',  -fill => 'both',  -expand => 1);
	my $cadre3 = $frame0->Frame->pack(-side => 'top',  -fill => 'both',  -expand => 1);
	my $cadre4 = $frame0->Frame->pack(-side => 'top',  -fill => 'both',  -expand => 1);

	$cadre1->Label(-text => "Where is MkStatCorpXML : ",
    	      -relief => 'raised')->pack(-side => 'left',
						  -anchor => 'w');

	my $mkStatXMLdir=&GetCWD;
	my $saisie_0=$cadre1->Entry(-textvariable => \$mkStatXMLdir)->pack(-side => 'left',
						-anchor => 'w',
						-fill => 'x',
						-expand => 1,
						);
	$cadre2->Label(-text => "Dir Input : ",
    	      -relief => 'raised')->pack(-side => 'left',
						  -anchor => 'w');
	my $workdirin=&GetCWD;
	my $saisie_1=$cadre2->Entry(-textvariable => \$workdirin)->pack(-side => 'left',
						-anchor => 'w',
						-fill => 'x',
						-expand => 1,
						);
	$cadre5->Label(-text => "CorpusXML Name : ",
    	      -relief => 'raised')->pack(-side => 'left',
						  -anchor => 'w');
	my $sitename="corp-GiveSiteName.xml";
	my $saisie_3=$cadre5->Entry(-textvariable => \$sitename)->pack(-side => 'left',
						-anchor => 'w',
						-fill => 'x',
						-expand => 1,
						);
#	my $workdirout=&GetCWD;
	my $workdirout=$workdirin;
	$cadre3->Label(-text => "Dir Output : $workdirout",
    	      -relief => 'raised')->pack(-side => 'left',
						  -anchor => 'w');
	$cadre4->Button(-text => "Load MkStatXML",
	       -command => sub {$pn8c->destroy();
				&loadMkStatXML($mkStatXMLdir,$workdirin,$sitename,$workdirout);
			    })->pack(-side => 'right',
				     -anchor => 'e');
	$pn8c->Button(-text => "Close",
		     -command =>  sub {$pn8c->destroy()})->pack;
    }
    else {
	$pn8c->deiconify();
	$pn8c->raise();
    }
}
#-----------------------------------
#PN8Quat
sub query_loadMirroring {
&UpdateIndicators2;
    if (! Exists ($pn8d)) {
	$pn8d = $winMain::mw ->Toplevel();
	$pn8d->title("Query Dir (loadMirroring)");
	$pn8d->minsize(qw(800 200)); 
	my $frame0 = $pn8d->Frame(-background=>'#edf0f3')->pack(-side=>'top',  -fill => 'both',  -expand => 1); 
	my $cadre1 = $frame0->Frame->pack(-side => 'top',  -fill => 'both',  -expand => 1);
	my $cadre2 = $frame0->Frame->pack(-side => 'top',  -fill => 'both',  -expand => 1);
	my $cadre5 = $frame0->Frame->pack(-side => 'top',  -fill => 'both',  -expand => 1);
	my $cadre3 = $frame0->Frame->pack(-side => 'top',  -fill => 'both',  -expand => 1);
	my $cadre4 = $frame0->Frame->pack(-side => 'top',  -fill => 'both',  -expand => 1);

	$cadre1->Label(-text => "URL address : ",
    	      -relief => 'raised')->pack(-side => 'left',
						  -anchor => 'w');
	my $saisie_0=$cadre1->Entry(-textvariable => \$urlAddress)->pack(-side => 'left',
						-anchor => 'w',
						-fill => 'x',
						-expand => 1,
						);
	my $workdirout=&GetCWD;
	$cadre3->Label(-text => "Dir Output : $workdirout",
    	      -relief => 'raised')->pack(-side => 'left',
						  -anchor => 'w');
	$cadre4->Button(-text => "Load MirroringSite",
	       -command => sub {$pn8d->destroy();
				&loadMirroring ($urlAddress,$workdirout);
			    })->pack(-side => 'right',
				     -anchor => 'e');
	$pn8d->Button(-text => "Close",
		     -command =>  sub {$pn8d->destroy()})->pack;
    }
    else {
	$pn8d->deiconify();
	$pn8d->raise();
    }
}
#-----------------------------------
#PN8Quatb
sub query_loadPageMirroring {
&UpdateIndicators2;
    if (! Exists ($pn8db)) {
	$pn8db = $winMain::mw ->Toplevel();
	$pn8db->title("Query Dir (loadPageMirroring)");
	$pn8db->minsize(qw(800 200)); 
	my $frame0 = $pn8db->Frame(-background=>'#edf0f3')->pack(-side=>'top',  -fill => 'both',  -expand => 1); 
	my $cadre1 = $frame0->Frame->pack(-side => 'top',  -fill => 'both',  -expand => 1);
	my $cadre2 = $frame0->Frame->pack(-side => 'top',  -fill => 'both',  -expand => 1);
	my $cadre5 = $frame0->Frame->pack(-side => 'top',  -fill => 'both',  -expand => 1);
	my $cadre3 = $frame0->Frame->pack(-side => 'top',  -fill => 'both',  -expand => 1);
	my $cadre4 = $frame0->Frame->pack(-side => 'top',  -fill => 'both',  -expand => 1);

	$cadre1->Label(-text => "URL-File address : ",
    	      -relief => 'raised')->pack(-side => 'left',
						  -anchor => 'w');
	my $urlAddress = "http://";
	my $saisie_0=$cadre1->Entry(-textvariable => \$urlAddress)->pack(-side => 'left',
						-anchor => 'w',
						-fill => 'x',
						-expand => 1,
						);
	my $workdirout=&GetCWD;
	$cadre3->Label(-text => "Dir Output : $workdirout",
    	      -relief => 'raised')->pack(-side => 'left',
						  -anchor => 'w');

	$cadre4->Button(-text => "Load MirroringPage",
	       -command => sub {$pn8db->destroy();
				&loadMirroringPage ($urlAddress,$workdirout);
			    })->pack(-side => 'right',
				     -anchor => 'e');
	$pn8db->Button(-text => "Close",
		     -command =>  sub {$pn8db->destroy()})->pack;
    }
    else {
	$pn8db->deiconify();
	$pn8db->raise();
    }
}
#-----------------------------------
#PN8Quatc
sub query_wget {
&UpdateIndicators2;
    if (! Exists ($pn8de)) {
	$pn8de = $winMain::mw ->Toplevel();
	$pn8de->title("Query Dir (wget)");
	$pn8de->minsize(qw(800 200)); 
	my $frame0 = $pn8de->Frame(-background=>'#edf0f3')->pack(-side=>'top',  -fill => 'both',  -expand => 1); 
	my $cadre1 = $frame0->Frame->pack(-side => 'top',  -fill => 'both',  -expand => 1);
	my $cadre2 = $frame0->Frame->pack(-side => 'top',  -fill => 'both',  -expand => 1);
	my $cadre5 = $frame0->Frame->pack(-side => 'top',  -fill => 'both',  -expand => 1);
	my $cadre3 = $frame0->Frame->pack(-side => 'top',  -fill => 'both',  -expand => 1);
	my $cadre4 = $frame0->Frame->pack(-side => 'top',  -fill => 'both',  -expand => 1);

	$cadre1->Label(-text => "URL address : ",
    	      -relief => 'raised')->pack(-side => 'left',
						  -anchor => 'w');
	my $saisie_0=$cadre1->Entry(-textvariable => \$urlAddress)->pack(-side => 'left',
						-anchor => 'w',
						-fill => 'x',
						-expand => 1,
						);
	my $workdirout=&GetCWD;
	$cadre3->Label(-text => "Dir Output : $workdirout",
    	      -relief => 'raised')->pack(-side => 'left',
						  -anchor => 'w');
	$cadre4->Button(-text => "Load wget",
	       -command => sub {$pn8de->destroy();
				&loadWget ($urlAddress,$workdirout);
			    })->pack(-side => 'right',
				     -anchor => 'e');
	$pn8de->Button(-text => "Close",
		     -command =>  sub {$pn8de->destroy()})->pack;
    }
    else {
	$pn8de->deiconify();
	$pn8de->raise();
    }
}
#-----------------------------------
#PN8Cinq
sub query_uploading {
&UpdateIndicators2;
    if (! Exists ($pn8e)) {
	$pn8e = $winMain::mw ->Toplevel();
	$pn8e->title("Query Dir (uploading)");
	$pn8e->minsize(qw(800 200)); 
	my $frame0 = $pn8e->Frame(-background=>'#edf0f3')->pack(-side=>'top',  -fill => 'both',  -expand => 1); 
	my $cadre1 = $frame0->Frame->pack(-side => 'top',  -fill => 'both',  -expand => 1);
	my $cadre2 = $frame0->Frame->pack(-side => 'top',  -fill => 'both',  -expand => 1);
	my $cadre5 = $frame0->Frame->pack(-side => 'top',  -fill => 'both',  -expand => 1);
	my $cadre3 = $frame0->Frame->pack(-side => 'top',  -fill => 'both',  -expand => 1);
	my $cadre4 = $frame0->Frame->pack(-side => 'top',  -fill => 'both',  -expand => 1);


	$cadre1->Label(-text => "URL address : ",
    	      -relief => 'raised')->pack(-side => 'left',
						  -anchor => 'w');

	my $saisie_0=$cadre1->Entry(-textvariable => \$urlAddress)->pack(-side => 'left',
						-anchor => 'w',
						-fill => 'x',
						-expand => 1,
						);
	my $workdirout=&GetCWD;
	$cadre3->Label(-text => "Dir Output : $workdirout",
    	      -relief => 'raised')->pack(-side => 'left',
						  -anchor => 'w');
	$cadre4->Button(-text => "Load MirroringSite",
	       -command => sub {$pn8e->destroy();
				&loadUploading ($urlAddress,$workdirout);
			    })->pack(-side => 'right',
						   -anchor => 'e');
	$pn8e->Button(-text => "Close",
		     -command =>  sub {$pn8e->destroy()})->pack;
    }
    else {
	$pn8e->deiconify();
	$pn8e->raise();
    }
}
#-----------------------------------
#PN9
sub  query_file_dialog {
&UpdateIndicators2;

    if (! Exists ($pn9)) {


	$pn9 = $winMain::mw ->Toplevel();
    foreach my $i (qw(open)) {
	my $f = $pn9->Frame;
	my $lab = $f->Label(-text => "Select a file to $i: ",
			    -anchor => 'e');
	my $ent = $f->Entry(-width => 20);
	my $but = $f->Button(-text => "Browse ...",
			     -command => sub { fileDialog($pn9, $ent, $i)});
	$lab->pack(-side => 'left');
	$ent->pack(-side => 'left',-expand => 'yes', -fill => 'x');
	$but->pack(-side => 'left');
	$f->pack(-fill => 'x', -padx => '1c', -pady => 3);
    }

    my $cbf = $pn9->Frame->pack(-fill => 'x', -padx => '1c', -pady => 3);
    my $fd;
    $cbf->Radiobutton
      (-text => 'FileSelect',
       -variable => \$fd,
       -value => 'FileSelect',
       -command => sub { local($^W) = 0;
			 require Tk::FileSelect;
			 Tk::FileSelect->import('as_default');
			 # XXX remove cached dialogs
			 my $pn9 = $pn9->MainWindow;
			 delete $pn9->{'tk_getOpenFile'};
#			 delete $pn9->{'tk_getSaveFile'};
		     })->pack(-side => 'left');
    my $fdb = $cbf->Radiobutton
      (-text => 'FBox',
       -variable => \$fd,
       -value => 'FBox',
       -command => sub { local($^W) = 0;
			 require Tk::FBox;
			 Tk::FBox->import('as_default');
			 # XXX remove cached dialogs
			 my $pn9 = $pn9->MainWindow;
			 delete $pn9->{'tk_getOpenFile'};
#			 delete $pn9->{'tk_getSaveFile'};
		     })->pack(-side => 'left');
    $fdb->invoke;
    }
}
#-----------------------------------
#PN10
sub  query_file_dialog2 {
&UpdateIndicators2;
    $winMain::texte->FileSaveAsPopup();
}
#-----------------------------------
#PN11
sub  query_file_dialog3 {
&UpdateIndicators2;

    if (! Exists ($pn11)) {
	$pn11 = $winMain::mw ->Toplevel();
	foreach my $i (qw(open)) {
	    my $f = $pn11->Frame;
	    my $lab = $f->Label(-text => "Select a file to $i: ",
				-anchor => 'e');
	    my $ent = $f->Entry(-width => 20);
	    my $but = $f->Button(-text => "Browse ...",
				 -command => sub { fileDialog2($pn11, $ent, $i)});
	    $lab->pack(-side => 'left');
	    $ent->pack(-side => 'left',-expand => 'yes', -fill => 'x');
	    $but->pack(-side => 'left');
	    $f->pack(-fill => 'x', -padx => '1c', -pady => 3);
	}
	
	my $cbf = $pn11->Frame->pack(-fill => 'x', -padx => '1c', -pady => 3);
	my $fd;
	$cbf->Radiobutton
	(-text => 'FileSelect',
	 -variable => \$fd,
	 -value => 'FileSelect',
	 -command => sub { local($^W) = 0;
			   require Tk::FileSelect;
			 Tk::FileSelect->import('as_default');
			   # XXX remove cached dialogs
			   my $pn11 = $pn11->MainWindow;
			   delete $pn11->{'tk_getOpenFile'};
#			 delete $pn11->{'tk_getSaveFile'};
		       })->pack(-side => 'left');
	my $fdb = $cbf->Radiobutton
	    (-text => 'FBox',
	     -variable => \$fd,
	     -value => 'FBox',
	     -command => sub { local($^W) = 0;
			       require Tk::FBox;
			     Tk::FBox->import('as_default');
			       # XXX remove cached dialogs
			       my $pn11 = $pn11->MainWindow;
			       delete $pn11->{'tk_getOpenFile'};
#			 delete $pn11->{'tk_getSaveFile'};
			   })->pack(-side => 'left');
	$fdb->invoke;
    }
}
#-----------------------------------
#PN12
sub  mkIndisponible {
&UpdateIndicators2;
    $winMain::mw->Dialog(
		-title => "Indisponible",
		-text  => "Indisponible pour le moment... "
		)->Show();
}
#-----------------------------------
sub mkWaitBox {
&UpdateIndicators2;
	$waitBoxWidget = $winMain::mw->Toplevel();
	$waitBoxWidget->title("Work In Progress");
	$waitBoxWidget->Label(-image => $winMain::logoMKC)->pack(-side => 'right');
	my $txt = "MKCorpus is working for you...";
	$waitBoxWidget->Label(-text => $txt)->pack(-side => 'top');

}
#-----------------------------------
sub removeWaitBox {
&UpdateIndicators2;

    $waitBoxWidget->destroy if Exists($waitBoxWidget);
}
#-----------------------------------
sub  mkPrintErreur {
&UpdateIndicators2;
   my $msg = shift;

   $winMain::mw->Dialog(
      -title => "ERROR !",
      -text  => $msg
   )->Show();
}
#-----------------------------------
#PN14
sub  mkPrintMsgInfo {
&UpdateIndicators2;
    my $msg = shift;
    $winMain::mw->Dialog(
		-title => "Info : ",
		-text  => $msg
		)->Show();
}
#-------------------------XML PARSER routines-------------------------
sub char_handler {
&UpdateIndicators2;
    my ($p, $data) = @_;
    if ($::state::store_contents) {
      $::state::storage{$::state::store_contents} .= $data;
    } else {
       # print $data;
    }
}
#---------------------------------------------
sub start_handler {
&UpdateIndicators2;
    my $expat=shift;
    my $element=shift;
    if (!exists ($Liste_xmlBalise{$element})) {
		    $Liste_xmlBalise{$element}=1;
		    push (@liste_xmlBalise, $element);
		}
}
#---------------------------------------------
sub start_handlerLexico {
&UpdateIndicators2;
    my $expat=shift;
    my $element=shift;
    if (!exists ($Liste_xmlLexicoBalise{$element})) {
		    $Liste_xmlLexicoBalise{$element}=1;
		    push (@liste_xmlLexicoBalise, $element);
		}
    if (!exists ($Liste_xmlLexicoBalise2{$element})) {
		    $Liste_xmlLexicoBalise2{$element}=1;
		    push (@liste_xmlLexicoBalise2, $element);
		}
}
#---------------------------------------------
sub end_handler {
&UpdateIndicators2;
    my $expat = shift; my $element = shift;
}
#---------------------------------------------
sub usageUploading {
&UpdateIndicators2;
	print STDERR join("\n", @_) . "\n" if @_;
#	print STDERR $Usage;
}
#---------------------------------------------
sub translate {
&UpdateIndicators2;
  # this is taken from HTML::Entities.pm

  %entity2char = (
  # Some normal chars that have special meaning in SGML context
 amp    => '&',  # ampersand 
'gt'    => '>',  # greater than
'lt'    => '<',  # less than
 quot   => '"',  # double quote


 # PUBLIC ISO 8879-1986//ENTITIES Added Latin 1//EN//HTML
 AElig	=> '',  # capital AE diphthong (ligature)
 Aacute	=> '',  # capital A, acute accent
 Acirc	=> '',  # capital A, circumflex accent
 Agrave	=> '',  # capital A, grave accent
 Aring	=> '',  # capital A, ring
 Atilde	=> '',  # capital A, tilde
 Auml       => '',  # capital A, dieresis or umlaut mark
 Ccedil	=> '',  # capital C, cedilla
 ETH        => '',  # capital Eth, Icelandic
 Eacute	=> '',  # capital E, acute accent
 Ecirc	=> '',  # capital E, circumflex accent
 Egrave	=> '',  # capital E, grave accent
 Euml       => '',  # capital E, dieresis or umlaut mark
 Dstrok     => '',  # capital 
 Iacute	=> '',  # capital I, acute accent
 Icirc	=> '',  # capital I, circumflex accent
 Igrave	=> '',  # capital I, grave accent
 Iuml       => '',  # capital I, dieresis or umlaut mark
 Ntilde	=> '',  # capital N, tilde
 Oacute	=> '',  # capital O, acute accent
 Ocirc	=> '',  # capital O, circumflex accent
 OElig      => '',  # capital , diphtong
 Ograve	=> '',  # capital O, grave accent
 Oslash	=> '',  # capital O, slash
 Otilde	=> '',  # capital O, tilde
 Ouml       => '',  # capital O, dieresis or umlaut mark
 THORN	=> '',  # capital THORN, Icelandic
 Uacute	=> '',  # capital U, acute accent
 Ucirc	=> '',  # capital U, circumflex accent
 Ugrave	=> '',  # capital U, grave accent
 Uuml       => '',  # capital U, dieresis or umlaut mark
 Yacute	=> '',  # capital Y, acute accent
 aelig      => '',  # small , diphtong
 aacute	=> '',  # small a, acute accent
 acirc	=> '',  # small a, circumflex accent
 aelig	=> '',  # small ae diphthong (ligature)
 agrave	=> '',  # small a, grave accent
 aring	=> '',  # small a, ring
 atilde	=> '',  # small a, tilde
 auml       => '',  # small a, dieresis or umlaut mark
 ccedil	=> '',  # small c, cedilla
 eacute	=> '',  # small e, acute accent
 ecirc	=> '',  # small e, circumflex accent
 egrave	=> '',  # small e, grave accent
 eth        => '',  # small eth, Icelandic
 euml       => '',  # small e, dieresis or umlaut mark
 iacute	=> '',  # small i, acute accent
 icirc	=> '',  # small i, circumflex accent
 igrave	=> '',  # small i, grave accent
 iuml       => '',  # small i, dieresis or umlaut mark
 ntilde	=> '',  # small n, tilde
 oacute	=> '',  # small o, acute accent
 ocirc	=> '',  # small o, circumflex accent
 ograve	=> '',  # small o, grave accent
 oslash	=> '',  # small o, slash
 otilde	=> '',  # small o, tilde
 ouml       => '',  # small o, dieresis or umlaut mark
 pound	=> '',  # symbol
 szlig	=> '',  # small sharp s, German (sz ligature)
 thorn	=> '',  # small thorn, Icelandic
 uacute	=> '',  # small u, acute accent
 ucirc	=> '',  # small u, circumflex accent
 ugrave	=> '',  # small u, grave accent
 uuml       => '',  # small u, dieresis or umlaut mark
 yacute	=> '',  # small , acute accent
 yuml       => '',  # small , circumflex accent

 acute  => '',
 brkbar => '',
 cedil  => '',
 cent   => '',
 copy   => '(c)',
 curren => '',
 deg    => '',
 divide => '',
 emdash => '-',
 endash => '',
 frac14 => '1/4',
 frac12 => '1/2',
 frac34 => '3/4',
 hellip => '...',
 hibar  => '',
 iexcl  => '',
 iquest => '',
 laquo  => '"',
 macr   => '',
 micro  => '',
 middot => '',
 nbsp   => ' ',
 not    => '',
 ordf   => '',
 ordm   => '',
 para   => '',
 plusmn => '',
 raquo  => '"',
 reg    => '(r)',
 sect   => '',
 shy    => '',
 sup1   => '',
 sup2   => '',
 sup3   => '',
'times' => '',    # times is a keyword in perl
 uml    => '',
 yen    => '',
);

  # Make the oposite mapping
  while (($entity, $char) = each(%entity2char)) {
    $char2entity{$char} = "&$entity;";
  }

  # Fill inn missing entities
  for (0 .. 255) {
    next if exists $char2entity{chr($_)};
    $char2entity{chr($_)} = "&#$_;";
  }

  my $array;
  if (defined wantarray) {
    $array = [@_]; # copy
  }
  else {
    $array = \@_;  # modify in-place
  }
  my $c;
  for (@$array) {
    s/&amp;?/&/g;

    s/(&\#(\d+);?)/$2 < 256 ? chr($2) : $1/eg;
    s/(&\#[xX]([0-9a-fA-F]+);?)/$c = hex($2); $c < 256 ? chr($c) : $1/eg;
    s/(&(\w+);?)/$entity2char{$2} || "$1;"/eg;

    s/&Oelig;?//g;
    s/&oelig;?//g;
    s/&eaacute;?//g;
    s/&\#9484;?//g;
    s/&ecric;?//g;
    s/&laqno;?/"/g;
    s#\s+# #sg;

    # local spelling
  }
  wantarray ? @$array : $array->[0];
}

#------------------------------------------------------------------------

sub loadSplashWindow {
&UpdateIndicators2;
    $winMain::mw->withdraw;
    $winMain::splash = $winMain::mw->Toplevel(-title => "Work In Progress..." , -visual => 'truecolor');
    $winMain::splash->protocol( 'WM_DELETE_WINDOW' => sub {&removeSplashWindow} ) ;

    my $img = $winMain::splash->Photo(-file=> 'pics/logo-mkc-work.gif');
    $winMain::splash->Label( -image => $img)->pack;
    my $camel=$winMain::splash->Animation('-format' => 'gif',
			   -file => Tk->findINC('anim.gif'));
    my $l = $winMain::splash->Label(-image => $camel)->pack(-side => 'bottom');
    $camel->start_animation(80);

    $winMain::pctComplete = 0;
    my $progress = $winMain::splash->ProgressBar(-variable => \$winMain::pctComplete,
						 -borderwidth => 7, -relief => 'flat', -width => 20, -length => 300,
						 -padx => 0, -pady => 0,-gap => 0,
						 -from => 0, -to => 100,
						 -colors => [0 => 'blue', 40 => 'black' , 80 => 'red'],
						 -troughcolor => 'white',
						 )->pack;
    
    $winMain::progressText = "Once again, mkCorpus is working...";
    $winMain::splash->Label( -textvariable => \$winMain::progressText )->pack;
    sleep 1;
    &splashProgress( "Work In Progress...", 5 );
}

#---------------------------------------------------------------------------------------
sub removeSplashWindow {
&UpdateIndicators2;
    $winMain::splash->destroy;
    $winMain::mw->deiconify;
    $winMain::mw->raise;
}

#---------------------------------------------------------------------------------------
sub splashProgress {
&UpdateIndicators2;
   my ($text, $pct) = @_;
   $winMain::progressText = $text;
   $winMain::pctComplete = $pct;
   $winMain::splash->Animation->start_animation(80);
   ## Hourglass cursor...
   $winMain::splash->Busy(-recurse => 1);
   ## Pop to top (if not! can be annoying tho')...
   $winMain::splash->raise;
   $winMain::splash->update;
}

#---------------------------------------------------------------------------------------
sub updateMarkupWindow {
    my ($texte,$label) = @_;
    $texte->getEditPreferences();
    $texte->loadEditPreferences();
    $texte->SetGUICallbacks([
			     sub {&UpdateIndicators($texte,$label);}, sub {$texte->HighlightAllPairsBracketingCursor;}
#    sub {&UpdateMenu();}
]);
}

#---------------------------------------------------------------------------------------
sub UpdateIndicators {
    my ($texte,$label) = @_;
    my ( $file, $mode,
	 $line, $colon1,
	 $end, $colon2,
	 $top_visible, $bottom_visible, $percent );

    $file = $texte->FileName();
    if ( defined( $file )) {
	if ( $file =~ /([^\/\\]+)$/ ) {
	    $file = $1;
	}
    }
    else { $file = "Unregistered"; }

    $mode = "(Insert Mode)";
    if ( $texte->OverstrikeMode ) { $mode = "(Overstrike Mode)"; }

    ( $line, $colon1 ) = split( /\./, $texte->index( 'insert' ));
    ( $end, $colon2 ) = split( /\./, $texte->index( 'end' ));
    ( $top_visible, $bottom_visible ) = $texte->yview();
    
    $bottom_visible = int( $bottom_visible * $end );
    $percent = int( $bottom_visible*100/$end );

    return( $label->configure( -text => "--:** ".$file."\t\t".$mode."--L".
	    $line."--C".$colon1."--TL".$end."--(".$percent."%)"));
}


#---------------------------------------------------------------------------------------
sub UpdateIndicators2test {
    my ($texte) = @_;
    my ( $file, $mode,$line, $colon1,$end, $colon2,$top_visible, $bottom_visible, $percent );
    $file = $texte->FileName();
    $winMain::nom_fic = $texte->FileName();
    if ( defined( $file )) {
	if ( $file =~ /([^\/\\]+)$/ ) {
	    $file = $1;
	}
    }
    else { $file = "Unregistered"; }
    
    $mode = "(Insert Mode)";
    if ( $texte->OverstrikeMode ) { $mode = "(Overstrike Mode)"; }

    ( $line, $colon1 ) = split( /\./, $texte->index( 'insert' ));
    ( $end, $colon2 ) = split( /\./, $texte->index( 'end' ));
    ( $top_visible, $bottom_visible ) = $texte->yview();
    
    $bottom_visible = int( $bottom_visible * $end );
    $percent = int( $bottom_visible*100/$end );

    return( $winMain::label->configure( -text => "--:** ".$file."\t\t".$mode."--L".
	    $line."--C".$colon1."--TL".$end."--(".$percent."%)"));
}

#---------------------------------------------------------------------------------------
sub UpdateIndicators2 {

}

#------------------------------------------------------------------------
1;

